// AUTOGENERATED FILE. DO NOT MODIFY.

#include <stdlib.h>
#include <stdint.h>

#include "unpack17.h"



static void unpack_1_17bit_signed_0off(const uint8_t * input, double * output) {
	// Unpack 1 values into output
	// Values are 17-bit signed
	// Skip 0 bits, read 17 bits of data.
	// Input must be at least 3 bytes long

	int32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);
}

static void unpack_1_17bit_unsigned_0off(const uint8_t * input, double * output) {
	// Unpack 1 values into output
	// Values are 17-bit unsigned
	// Skip 0 bits, read 17 bits of data.
	// Input must be at least 3 bytes long

	uint32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);
}

static void unpack_1_17bit_signed_1off(const uint8_t * input, double * output) {
	// Unpack 1 values into output
	// Values are 17-bit signed
	// Skip 1 bits, read 17 bits of data.
	// Input must be at least 3 bytes long

	int32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);
}

static void unpack_1_17bit_unsigned_1off(const uint8_t * input, double * output) {
	// Unpack 1 values into output
	// Values are 17-bit unsigned
	// Skip 1 bits, read 17 bits of data.
	// Input must be at least 3 bytes long

	uint32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);
}

static void unpack_1_17bit_signed_2off(const uint8_t * input, double * output) {
	// Unpack 1 values into output
	// Values are 17-bit signed
	// Skip 2 bits, read 17 bits of data.
	// Input must be at least 3 bytes long

	int32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);
}

static void unpack_1_17bit_unsigned_2off(const uint8_t * input, double * output) {
	// Unpack 1 values into output
	// Values are 17-bit unsigned
	// Skip 2 bits, read 17 bits of data.
	// Input must be at least 3 bytes long

	uint32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);
}

static void unpack_1_17bit_signed_3off(const uint8_t * input, double * output) {
	// Unpack 1 values into output
	// Values are 17-bit signed
	// Skip 3 bits, read 17 bits of data.
	// Input must be at least 3 bytes long

	int32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);
}

static void unpack_1_17bit_unsigned_3off(const uint8_t * input, double * output) {
	// Unpack 1 values into output
	// Values are 17-bit unsigned
	// Skip 3 bits, read 17 bits of data.
	// Input must be at least 3 bytes long

	uint32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);
}

static void unpack_1_17bit_signed_4off(const uint8_t * input, double * output) {
	// Unpack 1 values into output
	// Values are 17-bit signed
	// Skip 4 bits, read 17 bits of data.
	// Input must be at least 3 bytes long

	int32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);
}

static void unpack_1_17bit_unsigned_4off(const uint8_t * input, double * output) {
	// Unpack 1 values into output
	// Values are 17-bit unsigned
	// Skip 4 bits, read 17 bits of data.
	// Input must be at least 3 bytes long

	uint32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);
}

static void unpack_1_17bit_signed_5off(const uint8_t * input, double * output) {
	// Unpack 1 values into output
	// Values are 17-bit signed
	// Skip 5 bits, read 17 bits of data.
	// Input must be at least 3 bytes long

	int32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);
}

static void unpack_1_17bit_unsigned_5off(const uint8_t * input, double * output) {
	// Unpack 1 values into output
	// Values are 17-bit unsigned
	// Skip 5 bits, read 17 bits of data.
	// Input must be at least 3 bytes long

	uint32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);
}

static void unpack_1_17bit_signed_6off(const uint8_t * input, double * output) {
	// Unpack 1 values into output
	// Values are 17-bit signed
	// Skip 6 bits, read 17 bits of data.
	// Input must be at least 3 bytes long

	int32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);
}

static void unpack_1_17bit_unsigned_6off(const uint8_t * input, double * output) {
	// Unpack 1 values into output
	// Values are 17-bit unsigned
	// Skip 6 bits, read 17 bits of data.
	// Input must be at least 3 bytes long

	uint32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);
}

static void unpack_1_17bit_signed_7off(const uint8_t * input, double * output) {
	// Unpack 1 values into output
	// Values are 17-bit signed
	// Skip 7 bits, read 17 bits of data.
	// Input must be at least 3 bytes long

	int32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);
}

static void unpack_1_17bit_unsigned_7off(const uint8_t * input, double * output) {
	// Unpack 1 values into output
	// Values are 17-bit unsigned
	// Skip 7 bits, read 17 bits of data.
	// Input must be at least 3 bytes long

	uint32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);
}

static void unpack_2_17bit_signed_0off(const uint8_t * input, double * output) {
	// Unpack 2 values into output
	// Values are 17-bit signed
	// Skip 0 bits, read 34 bits of data.
	// Input must be at least 5 bytes long

	int32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);
}

static void unpack_2_17bit_unsigned_0off(const uint8_t * input, double * output) {
	// Unpack 2 values into output
	// Values are 17-bit unsigned
	// Skip 0 bits, read 34 bits of data.
	// Input must be at least 5 bytes long

	uint32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);
}

static void unpack_2_17bit_signed_1off(const uint8_t * input, double * output) {
	// Unpack 2 values into output
	// Values are 17-bit signed
	// Skip 1 bits, read 34 bits of data.
	// Input must be at least 5 bytes long

	int32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);
}

static void unpack_2_17bit_unsigned_1off(const uint8_t * input, double * output) {
	// Unpack 2 values into output
	// Values are 17-bit unsigned
	// Skip 1 bits, read 34 bits of data.
	// Input must be at least 5 bytes long

	uint32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);
}

static void unpack_2_17bit_signed_2off(const uint8_t * input, double * output) {
	// Unpack 2 values into output
	// Values are 17-bit signed
	// Skip 2 bits, read 34 bits of data.
	// Input must be at least 5 bytes long

	int32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);
}

static void unpack_2_17bit_unsigned_2off(const uint8_t * input, double * output) {
	// Unpack 2 values into output
	// Values are 17-bit unsigned
	// Skip 2 bits, read 34 bits of data.
	// Input must be at least 5 bytes long

	uint32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);
}

static void unpack_2_17bit_signed_3off(const uint8_t * input, double * output) {
	// Unpack 2 values into output
	// Values are 17-bit signed
	// Skip 3 bits, read 34 bits of data.
	// Input must be at least 5 bytes long

	int32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);
}

static void unpack_2_17bit_unsigned_3off(const uint8_t * input, double * output) {
	// Unpack 2 values into output
	// Values are 17-bit unsigned
	// Skip 3 bits, read 34 bits of data.
	// Input must be at least 5 bytes long

	uint32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);
}

static void unpack_2_17bit_signed_4off(const uint8_t * input, double * output) {
	// Unpack 2 values into output
	// Values are 17-bit signed
	// Skip 4 bits, read 34 bits of data.
	// Input must be at least 5 bytes long

	int32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);
}

static void unpack_2_17bit_unsigned_4off(const uint8_t * input, double * output) {
	// Unpack 2 values into output
	// Values are 17-bit unsigned
	// Skip 4 bits, read 34 bits of data.
	// Input must be at least 5 bytes long

	uint32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);
}

static void unpack_2_17bit_signed_5off(const uint8_t * input, double * output) {
	// Unpack 2 values into output
	// Values are 17-bit signed
	// Skip 5 bits, read 34 bits of data.
	// Input must be at least 5 bytes long

	int32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);
}

static void unpack_2_17bit_unsigned_5off(const uint8_t * input, double * output) {
	// Unpack 2 values into output
	// Values are 17-bit unsigned
	// Skip 5 bits, read 34 bits of data.
	// Input must be at least 5 bytes long

	uint32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);
}

static void unpack_2_17bit_signed_6off(const uint8_t * input, double * output) {
	// Unpack 2 values into output
	// Values are 17-bit signed
	// Skip 6 bits, read 34 bits of data.
	// Input must be at least 5 bytes long

	int32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);
}

static void unpack_2_17bit_unsigned_6off(const uint8_t * input, double * output) {
	// Unpack 2 values into output
	// Values are 17-bit unsigned
	// Skip 6 bits, read 34 bits of data.
	// Input must be at least 5 bytes long

	uint32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);
}

static void unpack_2_17bit_signed_7off(const uint8_t * input, double * output) {
	// Unpack 2 values into output
	// Values are 17-bit signed
	// Skip 7 bits, read 34 bits of data.
	// Input must be at least 6 bytes long

	int32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);
}

static void unpack_2_17bit_unsigned_7off(const uint8_t * input, double * output) {
	// Unpack 2 values into output
	// Values are 17-bit unsigned
	// Skip 7 bits, read 34 bits of data.
	// Input must be at least 6 bytes long

	uint32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);
}

static void unpack_3_17bit_signed_0off(const uint8_t * input, double * output) {
	// Unpack 3 values into output
	// Values are 17-bit signed
	// Skip 0 bits, read 51 bits of data.
	// Input must be at least 7 bytes long

	int32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);
}

static void unpack_3_17bit_unsigned_0off(const uint8_t * input, double * output) {
	// Unpack 3 values into output
	// Values are 17-bit unsigned
	// Skip 0 bits, read 51 bits of data.
	// Input must be at least 7 bytes long

	uint32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);
}

static void unpack_3_17bit_signed_1off(const uint8_t * input, double * output) {
	// Unpack 3 values into output
	// Values are 17-bit signed
	// Skip 1 bits, read 51 bits of data.
	// Input must be at least 7 bytes long

	int32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);
}

static void unpack_3_17bit_unsigned_1off(const uint8_t * input, double * output) {
	// Unpack 3 values into output
	// Values are 17-bit unsigned
	// Skip 1 bits, read 51 bits of data.
	// Input must be at least 7 bytes long

	uint32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);
}

static void unpack_3_17bit_signed_2off(const uint8_t * input, double * output) {
	// Unpack 3 values into output
	// Values are 17-bit signed
	// Skip 2 bits, read 51 bits of data.
	// Input must be at least 7 bytes long

	int32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);
}

static void unpack_3_17bit_unsigned_2off(const uint8_t * input, double * output) {
	// Unpack 3 values into output
	// Values are 17-bit unsigned
	// Skip 2 bits, read 51 bits of data.
	// Input must be at least 7 bytes long

	uint32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);
}

static void unpack_3_17bit_signed_3off(const uint8_t * input, double * output) {
	// Unpack 3 values into output
	// Values are 17-bit signed
	// Skip 3 bits, read 51 bits of data.
	// Input must be at least 7 bytes long

	int32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);
}

static void unpack_3_17bit_unsigned_3off(const uint8_t * input, double * output) {
	// Unpack 3 values into output
	// Values are 17-bit unsigned
	// Skip 3 bits, read 51 bits of data.
	// Input must be at least 7 bytes long

	uint32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);
}

static void unpack_3_17bit_signed_4off(const uint8_t * input, double * output) {
	// Unpack 3 values into output
	// Values are 17-bit signed
	// Skip 4 bits, read 51 bits of data.
	// Input must be at least 7 bytes long

	int32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);
}

static void unpack_3_17bit_unsigned_4off(const uint8_t * input, double * output) {
	// Unpack 3 values into output
	// Values are 17-bit unsigned
	// Skip 4 bits, read 51 bits of data.
	// Input must be at least 7 bytes long

	uint32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);
}

static void unpack_3_17bit_signed_5off(const uint8_t * input, double * output) {
	// Unpack 3 values into output
	// Values are 17-bit signed
	// Skip 5 bits, read 51 bits of data.
	// Input must be at least 7 bytes long

	int32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);
}

static void unpack_3_17bit_unsigned_5off(const uint8_t * input, double * output) {
	// Unpack 3 values into output
	// Values are 17-bit unsigned
	// Skip 5 bits, read 51 bits of data.
	// Input must be at least 7 bytes long

	uint32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);
}

static void unpack_3_17bit_signed_6off(const uint8_t * input, double * output) {
	// Unpack 3 values into output
	// Values are 17-bit signed
	// Skip 6 bits, read 51 bits of data.
	// Input must be at least 8 bytes long

	int32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);
}

static void unpack_3_17bit_unsigned_6off(const uint8_t * input, double * output) {
	// Unpack 3 values into output
	// Values are 17-bit unsigned
	// Skip 6 bits, read 51 bits of data.
	// Input must be at least 8 bytes long

	uint32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);
}

static void unpack_3_17bit_signed_7off(const uint8_t * input, double * output) {
	// Unpack 3 values into output
	// Values are 17-bit signed
	// Skip 7 bits, read 51 bits of data.
	// Input must be at least 8 bytes long

	int32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);
}

static void unpack_3_17bit_unsigned_7off(const uint8_t * input, double * output) {
	// Unpack 3 values into output
	// Values are 17-bit unsigned
	// Skip 7 bits, read 51 bits of data.
	// Input must be at least 8 bytes long

	uint32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);
}

static void unpack_4_17bit_signed_0off(const uint8_t * input, double * output) {
	// Unpack 4 values into output
	// Values are 17-bit signed
	// Skip 0 bits, read 68 bits of data.
	// Input must be at least 9 bytes long

	int32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 51 to 67
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xf0) << 11);
	output[3] = (double)(value >> 15);
}

static void unpack_4_17bit_unsigned_0off(const uint8_t * input, double * output) {
	// Unpack 4 values into output
	// Values are 17-bit unsigned
	// Skip 0 bits, read 68 bits of data.
	// Input must be at least 9 bytes long

	uint32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 51 to 67
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xf0) << 11);
	output[3] = (double)(value >> 15);
}

static void unpack_4_17bit_signed_1off(const uint8_t * input, double * output) {
	// Unpack 4 values into output
	// Values are 17-bit signed
	// Skip 1 bits, read 68 bits of data.
	// Input must be at least 9 bytes long

	int32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 52 to 68
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf8) << 12);
	output[3] = (double)(value >> 15);
}

static void unpack_4_17bit_unsigned_1off(const uint8_t * input, double * output) {
	// Unpack 4 values into output
	// Values are 17-bit unsigned
	// Skip 1 bits, read 68 bits of data.
	// Input must be at least 9 bytes long

	uint32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 52 to 68
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf8) << 12);
	output[3] = (double)(value >> 15);
}

static void unpack_4_17bit_signed_2off(const uint8_t * input, double * output) {
	// Unpack 4 values into output
	// Values are 17-bit signed
	// Skip 2 bits, read 68 bits of data.
	// Input must be at least 9 bytes long

	int32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 53 to 69
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xfc) << 13);
	output[3] = (double)(value >> 15);
}

static void unpack_4_17bit_unsigned_2off(const uint8_t * input, double * output) {
	// Unpack 4 values into output
	// Values are 17-bit unsigned
	// Skip 2 bits, read 68 bits of data.
	// Input must be at least 9 bytes long

	uint32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 53 to 69
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xfc) << 13);
	output[3] = (double)(value >> 15);
}

static void unpack_4_17bit_signed_3off(const uint8_t * input, double * output) {
	// Unpack 4 values into output
	// Values are 17-bit signed
	// Skip 3 bits, read 68 bits of data.
	// Input must be at least 9 bytes long

	int32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 54 to 70
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfe) << 14);
	output[3] = (double)(value >> 15);
}

static void unpack_4_17bit_unsigned_3off(const uint8_t * input, double * output) {
	// Unpack 4 values into output
	// Values are 17-bit unsigned
	// Skip 3 bits, read 68 bits of data.
	// Input must be at least 9 bytes long

	uint32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 54 to 70
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfe) << 14);
	output[3] = (double)(value >> 15);
}

static void unpack_4_17bit_signed_4off(const uint8_t * input, double * output) {
	// Unpack 4 values into output
	// Values are 17-bit signed
	// Skip 4 bits, read 68 bits of data.
	// Input must be at least 9 bytes long

	int32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 55 to 71
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15);
	output[3] = (double)(value >> 15);
}

static void unpack_4_17bit_unsigned_4off(const uint8_t * input, double * output) {
	// Unpack 4 values into output
	// Values are 17-bit unsigned
	// Skip 4 bits, read 68 bits of data.
	// Input must be at least 9 bytes long

	uint32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 55 to 71
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15);
	output[3] = (double)(value >> 15);
}

static void unpack_4_17bit_signed_5off(const uint8_t * input, double * output) {
	// Unpack 4 values into output
	// Values are 17-bit signed
	// Skip 5 bits, read 68 bits of data.
	// Input must be at least 10 bytes long

	int32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 56 to 72
	value = ((uint32_t)input[7] << 24) |
			((uint32_t)input[8] << 16) |
			((uint32_t)(input[9] & 0x80) << 8);
	output[3] = (double)(value >> 15);
}

static void unpack_4_17bit_unsigned_5off(const uint8_t * input, double * output) {
	// Unpack 4 values into output
	// Values are 17-bit unsigned
	// Skip 5 bits, read 68 bits of data.
	// Input must be at least 10 bytes long

	uint32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 56 to 72
	value = ((uint32_t)input[7] << 24) |
			((uint32_t)input[8] << 16) |
			((uint32_t)(input[9] & 0x80) << 8);
	output[3] = (double)(value >> 15);
}

static void unpack_4_17bit_signed_6off(const uint8_t * input, double * output) {
	// Unpack 4 values into output
	// Values are 17-bit signed
	// Skip 6 bits, read 68 bits of data.
	// Input must be at least 10 bytes long

	int32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 57 to 73
	value = ((uint32_t)(input[7] & 0x7f) << 25) |
			((uint32_t)input[8] << 17) |
			((uint32_t)(input[9] & 0xc0) << 9);
	output[3] = (double)(value >> 15);
}

static void unpack_4_17bit_unsigned_6off(const uint8_t * input, double * output) {
	// Unpack 4 values into output
	// Values are 17-bit unsigned
	// Skip 6 bits, read 68 bits of data.
	// Input must be at least 10 bytes long

	uint32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 57 to 73
	value = ((uint32_t)(input[7] & 0x7f) << 25) |
			((uint32_t)input[8] << 17) |
			((uint32_t)(input[9] & 0xc0) << 9);
	output[3] = (double)(value >> 15);
}

static void unpack_4_17bit_signed_7off(const uint8_t * input, double * output) {
	// Unpack 4 values into output
	// Values are 17-bit signed
	// Skip 7 bits, read 68 bits of data.
	// Input must be at least 10 bytes long

	int32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 58 to 74
	value = ((uint32_t)(input[7] & 0x3f) << 26) |
			((uint32_t)input[8] << 18) |
			((uint32_t)(input[9] & 0xe0) << 10);
	output[3] = (double)(value >> 15);
}

static void unpack_4_17bit_unsigned_7off(const uint8_t * input, double * output) {
	// Unpack 4 values into output
	// Values are 17-bit unsigned
	// Skip 7 bits, read 68 bits of data.
	// Input must be at least 10 bytes long

	uint32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 58 to 74
	value = ((uint32_t)(input[7] & 0x3f) << 26) |
			((uint32_t)input[8] << 18) |
			((uint32_t)(input[9] & 0xe0) << 10);
	output[3] = (double)(value >> 15);
}

static void unpack_5_17bit_signed_0off(const uint8_t * input, double * output) {
	// Unpack 5 values into output
	// Values are 17-bit signed
	// Skip 0 bits, read 85 bits of data.
	// Input must be at least 11 bytes long

	int32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 51 to 67
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xf0) << 11);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 68 to 84
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf8) << 12);
	output[4] = (double)(value >> 15);
}

static void unpack_5_17bit_unsigned_0off(const uint8_t * input, double * output) {
	// Unpack 5 values into output
	// Values are 17-bit unsigned
	// Skip 0 bits, read 85 bits of data.
	// Input must be at least 11 bytes long

	uint32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 51 to 67
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xf0) << 11);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 68 to 84
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf8) << 12);
	output[4] = (double)(value >> 15);
}

static void unpack_5_17bit_signed_1off(const uint8_t * input, double * output) {
	// Unpack 5 values into output
	// Values are 17-bit signed
	// Skip 1 bits, read 85 bits of data.
	// Input must be at least 11 bytes long

	int32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 52 to 68
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf8) << 12);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 69 to 85
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xfc) << 13);
	output[4] = (double)(value >> 15);
}

static void unpack_5_17bit_unsigned_1off(const uint8_t * input, double * output) {
	// Unpack 5 values into output
	// Values are 17-bit unsigned
	// Skip 1 bits, read 85 bits of data.
	// Input must be at least 11 bytes long

	uint32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 52 to 68
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf8) << 12);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 69 to 85
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xfc) << 13);
	output[4] = (double)(value >> 15);
}

static void unpack_5_17bit_signed_2off(const uint8_t * input, double * output) {
	// Unpack 5 values into output
	// Values are 17-bit signed
	// Skip 2 bits, read 85 bits of data.
	// Input must be at least 11 bytes long

	int32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 53 to 69
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xfc) << 13);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 70 to 86
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfe) << 14);
	output[4] = (double)(value >> 15);
}

static void unpack_5_17bit_unsigned_2off(const uint8_t * input, double * output) {
	// Unpack 5 values into output
	// Values are 17-bit unsigned
	// Skip 2 bits, read 85 bits of data.
	// Input must be at least 11 bytes long

	uint32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 53 to 69
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xfc) << 13);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 70 to 86
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfe) << 14);
	output[4] = (double)(value >> 15);
}

static void unpack_5_17bit_signed_3off(const uint8_t * input, double * output) {
	// Unpack 5 values into output
	// Values are 17-bit signed
	// Skip 3 bits, read 85 bits of data.
	// Input must be at least 11 bytes long

	int32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 54 to 70
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfe) << 14);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 71 to 87
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)input[10] << 15);
	output[4] = (double)(value >> 15);
}

static void unpack_5_17bit_unsigned_3off(const uint8_t * input, double * output) {
	// Unpack 5 values into output
	// Values are 17-bit unsigned
	// Skip 3 bits, read 85 bits of data.
	// Input must be at least 11 bytes long

	uint32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 54 to 70
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfe) << 14);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 71 to 87
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)input[10] << 15);
	output[4] = (double)(value >> 15);
}

static void unpack_5_17bit_signed_4off(const uint8_t * input, double * output) {
	// Unpack 5 values into output
	// Values are 17-bit signed
	// Skip 4 bits, read 85 bits of data.
	// Input must be at least 12 bytes long

	int32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 55 to 71
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 72 to 88
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)(input[11] & 0x80) << 8);
	output[4] = (double)(value >> 15);
}

static void unpack_5_17bit_unsigned_4off(const uint8_t * input, double * output) {
	// Unpack 5 values into output
	// Values are 17-bit unsigned
	// Skip 4 bits, read 85 bits of data.
	// Input must be at least 12 bytes long

	uint32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 55 to 71
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 72 to 88
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)(input[11] & 0x80) << 8);
	output[4] = (double)(value >> 15);
}

static void unpack_5_17bit_signed_5off(const uint8_t * input, double * output) {
	// Unpack 5 values into output
	// Values are 17-bit signed
	// Skip 5 bits, read 85 bits of data.
	// Input must be at least 12 bytes long

	int32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 56 to 72
	value = ((uint32_t)input[7] << 24) |
			((uint32_t)input[8] << 16) |
			((uint32_t)(input[9] & 0x80) << 8);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 73 to 89
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)(input[11] & 0xc0) << 9);
	output[4] = (double)(value >> 15);
}

static void unpack_5_17bit_unsigned_5off(const uint8_t * input, double * output) {
	// Unpack 5 values into output
	// Values are 17-bit unsigned
	// Skip 5 bits, read 85 bits of data.
	// Input must be at least 12 bytes long

	uint32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 56 to 72
	value = ((uint32_t)input[7] << 24) |
			((uint32_t)input[8] << 16) |
			((uint32_t)(input[9] & 0x80) << 8);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 73 to 89
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)(input[11] & 0xc0) << 9);
	output[4] = (double)(value >> 15);
}

static void unpack_5_17bit_signed_6off(const uint8_t * input, double * output) {
	// Unpack 5 values into output
	// Values are 17-bit signed
	// Skip 6 bits, read 85 bits of data.
	// Input must be at least 12 bytes long

	int32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 57 to 73
	value = ((uint32_t)(input[7] & 0x7f) << 25) |
			((uint32_t)input[8] << 17) |
			((uint32_t)(input[9] & 0xc0) << 9);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 74 to 90
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)(input[11] & 0xe0) << 10);
	output[4] = (double)(value >> 15);
}

static void unpack_5_17bit_unsigned_6off(const uint8_t * input, double * output) {
	// Unpack 5 values into output
	// Values are 17-bit unsigned
	// Skip 6 bits, read 85 bits of data.
	// Input must be at least 12 bytes long

	uint32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 57 to 73
	value = ((uint32_t)(input[7] & 0x7f) << 25) |
			((uint32_t)input[8] << 17) |
			((uint32_t)(input[9] & 0xc0) << 9);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 74 to 90
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)(input[11] & 0xe0) << 10);
	output[4] = (double)(value >> 15);
}

static void unpack_5_17bit_signed_7off(const uint8_t * input, double * output) {
	// Unpack 5 values into output
	// Values are 17-bit signed
	// Skip 7 bits, read 85 bits of data.
	// Input must be at least 12 bytes long

	int32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 58 to 74
	value = ((uint32_t)(input[7] & 0x3f) << 26) |
			((uint32_t)input[8] << 18) |
			((uint32_t)(input[9] & 0xe0) << 10);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 75 to 91
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)(input[11] & 0xf0) << 11);
	output[4] = (double)(value >> 15);
}

static void unpack_5_17bit_unsigned_7off(const uint8_t * input, double * output) {
	// Unpack 5 values into output
	// Values are 17-bit unsigned
	// Skip 7 bits, read 85 bits of data.
	// Input must be at least 12 bytes long

	uint32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 58 to 74
	value = ((uint32_t)(input[7] & 0x3f) << 26) |
			((uint32_t)input[8] << 18) |
			((uint32_t)(input[9] & 0xe0) << 10);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 75 to 91
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)(input[11] & 0xf0) << 11);
	output[4] = (double)(value >> 15);
}

static void unpack_6_17bit_signed_0off(const uint8_t * input, double * output) {
	// Unpack 6 values into output
	// Values are 17-bit signed
	// Skip 0 bits, read 102 bits of data.
	// Input must be at least 13 bytes long

	int32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 51 to 67
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xf0) << 11);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 68 to 84
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf8) << 12);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 85 to 101
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xfc) << 13);
	output[5] = (double)(value >> 15);
}

static void unpack_6_17bit_unsigned_0off(const uint8_t * input, double * output) {
	// Unpack 6 values into output
	// Values are 17-bit unsigned
	// Skip 0 bits, read 102 bits of data.
	// Input must be at least 13 bytes long

	uint32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 51 to 67
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xf0) << 11);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 68 to 84
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf8) << 12);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 85 to 101
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xfc) << 13);
	output[5] = (double)(value >> 15);
}

static void unpack_6_17bit_signed_1off(const uint8_t * input, double * output) {
	// Unpack 6 values into output
	// Values are 17-bit signed
	// Skip 1 bits, read 102 bits of data.
	// Input must be at least 13 bytes long

	int32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 52 to 68
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf8) << 12);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 69 to 85
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xfc) << 13);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 86 to 102
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfe) << 14);
	output[5] = (double)(value >> 15);
}

static void unpack_6_17bit_unsigned_1off(const uint8_t * input, double * output) {
	// Unpack 6 values into output
	// Values are 17-bit unsigned
	// Skip 1 bits, read 102 bits of data.
	// Input must be at least 13 bytes long

	uint32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 52 to 68
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf8) << 12);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 69 to 85
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xfc) << 13);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 86 to 102
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfe) << 14);
	output[5] = (double)(value >> 15);
}

static void unpack_6_17bit_signed_2off(const uint8_t * input, double * output) {
	// Unpack 6 values into output
	// Values are 17-bit signed
	// Skip 2 bits, read 102 bits of data.
	// Input must be at least 13 bytes long

	int32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 53 to 69
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xfc) << 13);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 70 to 86
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfe) << 14);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 87 to 103
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15);
	output[5] = (double)(value >> 15);
}

static void unpack_6_17bit_unsigned_2off(const uint8_t * input, double * output) {
	// Unpack 6 values into output
	// Values are 17-bit unsigned
	// Skip 2 bits, read 102 bits of data.
	// Input must be at least 13 bytes long

	uint32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 53 to 69
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xfc) << 13);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 70 to 86
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfe) << 14);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 87 to 103
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15);
	output[5] = (double)(value >> 15);
}

static void unpack_6_17bit_signed_3off(const uint8_t * input, double * output) {
	// Unpack 6 values into output
	// Values are 17-bit signed
	// Skip 3 bits, read 102 bits of data.
	// Input must be at least 14 bytes long

	int32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 54 to 70
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfe) << 14);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 71 to 87
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)input[10] << 15);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 88 to 104
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0x80) << 8);
	output[5] = (double)(value >> 15);
}

static void unpack_6_17bit_unsigned_3off(const uint8_t * input, double * output) {
	// Unpack 6 values into output
	// Values are 17-bit unsigned
	// Skip 3 bits, read 102 bits of data.
	// Input must be at least 14 bytes long

	uint32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 54 to 70
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfe) << 14);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 71 to 87
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)input[10] << 15);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 88 to 104
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0x80) << 8);
	output[5] = (double)(value >> 15);
}

static void unpack_6_17bit_signed_4off(const uint8_t * input, double * output) {
	// Unpack 6 values into output
	// Values are 17-bit signed
	// Skip 4 bits, read 102 bits of data.
	// Input must be at least 14 bytes long

	int32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 55 to 71
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 72 to 88
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)(input[11] & 0x80) << 8);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 89 to 105
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xc0) << 9);
	output[5] = (double)(value >> 15);
}

static void unpack_6_17bit_unsigned_4off(const uint8_t * input, double * output) {
	// Unpack 6 values into output
	// Values are 17-bit unsigned
	// Skip 4 bits, read 102 bits of data.
	// Input must be at least 14 bytes long

	uint32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 55 to 71
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 72 to 88
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)(input[11] & 0x80) << 8);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 89 to 105
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xc0) << 9);
	output[5] = (double)(value >> 15);
}

static void unpack_6_17bit_signed_5off(const uint8_t * input, double * output) {
	// Unpack 6 values into output
	// Values are 17-bit signed
	// Skip 5 bits, read 102 bits of data.
	// Input must be at least 14 bytes long

	int32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 56 to 72
	value = ((uint32_t)input[7] << 24) |
			((uint32_t)input[8] << 16) |
			((uint32_t)(input[9] & 0x80) << 8);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 73 to 89
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)(input[11] & 0xc0) << 9);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 90 to 106
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xe0) << 10);
	output[5] = (double)(value >> 15);
}

static void unpack_6_17bit_unsigned_5off(const uint8_t * input, double * output) {
	// Unpack 6 values into output
	// Values are 17-bit unsigned
	// Skip 5 bits, read 102 bits of data.
	// Input must be at least 14 bytes long

	uint32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 56 to 72
	value = ((uint32_t)input[7] << 24) |
			((uint32_t)input[8] << 16) |
			((uint32_t)(input[9] & 0x80) << 8);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 73 to 89
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)(input[11] & 0xc0) << 9);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 90 to 106
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xe0) << 10);
	output[5] = (double)(value >> 15);
}

static void unpack_6_17bit_signed_6off(const uint8_t * input, double * output) {
	// Unpack 6 values into output
	// Values are 17-bit signed
	// Skip 6 bits, read 102 bits of data.
	// Input must be at least 14 bytes long

	int32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 57 to 73
	value = ((uint32_t)(input[7] & 0x7f) << 25) |
			((uint32_t)input[8] << 17) |
			((uint32_t)(input[9] & 0xc0) << 9);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 74 to 90
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)(input[11] & 0xe0) << 10);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 91 to 107
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)(input[13] & 0xf0) << 11);
	output[5] = (double)(value >> 15);
}

static void unpack_6_17bit_unsigned_6off(const uint8_t * input, double * output) {
	// Unpack 6 values into output
	// Values are 17-bit unsigned
	// Skip 6 bits, read 102 bits of data.
	// Input must be at least 14 bytes long

	uint32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 57 to 73
	value = ((uint32_t)(input[7] & 0x7f) << 25) |
			((uint32_t)input[8] << 17) |
			((uint32_t)(input[9] & 0xc0) << 9);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 74 to 90
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)(input[11] & 0xe0) << 10);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 91 to 107
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)(input[13] & 0xf0) << 11);
	output[5] = (double)(value >> 15);
}

static void unpack_6_17bit_signed_7off(const uint8_t * input, double * output) {
	// Unpack 6 values into output
	// Values are 17-bit signed
	// Skip 7 bits, read 102 bits of data.
	// Input must be at least 14 bytes long

	int32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 58 to 74
	value = ((uint32_t)(input[7] & 0x3f) << 26) |
			((uint32_t)input[8] << 18) |
			((uint32_t)(input[9] & 0xe0) << 10);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 75 to 91
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)(input[11] & 0xf0) << 11);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 92 to 108
	value = ((uint32_t)(input[11] & 0x0f) << 28) |
			((uint32_t)input[12] << 20) |
			((uint32_t)(input[13] & 0xf8) << 12);
	output[5] = (double)(value >> 15);
}

static void unpack_6_17bit_unsigned_7off(const uint8_t * input, double * output) {
	// Unpack 6 values into output
	// Values are 17-bit unsigned
	// Skip 7 bits, read 102 bits of data.
	// Input must be at least 14 bytes long

	uint32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 58 to 74
	value = ((uint32_t)(input[7] & 0x3f) << 26) |
			((uint32_t)input[8] << 18) |
			((uint32_t)(input[9] & 0xe0) << 10);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 75 to 91
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)(input[11] & 0xf0) << 11);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 92 to 108
	value = ((uint32_t)(input[11] & 0x0f) << 28) |
			((uint32_t)input[12] << 20) |
			((uint32_t)(input[13] & 0xf8) << 12);
	output[5] = (double)(value >> 15);
}

static void unpack_7_17bit_signed_0off(const uint8_t * input, double * output) {
	// Unpack 7 values into output
	// Values are 17-bit signed
	// Skip 0 bits, read 119 bits of data.
	// Input must be at least 15 bytes long

	int32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 51 to 67
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xf0) << 11);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 68 to 84
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf8) << 12);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 85 to 101
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xfc) << 13);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 102 to 118
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfe) << 14);
	output[6] = (double)(value >> 15);
}

static void unpack_7_17bit_unsigned_0off(const uint8_t * input, double * output) {
	// Unpack 7 values into output
	// Values are 17-bit unsigned
	// Skip 0 bits, read 119 bits of data.
	// Input must be at least 15 bytes long

	uint32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 51 to 67
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xf0) << 11);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 68 to 84
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf8) << 12);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 85 to 101
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xfc) << 13);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 102 to 118
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfe) << 14);
	output[6] = (double)(value >> 15);
}

static void unpack_7_17bit_signed_1off(const uint8_t * input, double * output) {
	// Unpack 7 values into output
	// Values are 17-bit signed
	// Skip 1 bits, read 119 bits of data.
	// Input must be at least 15 bytes long

	int32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 52 to 68
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf8) << 12);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 69 to 85
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xfc) << 13);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 86 to 102
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfe) << 14);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 103 to 119
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15);
	output[6] = (double)(value >> 15);
}

static void unpack_7_17bit_unsigned_1off(const uint8_t * input, double * output) {
	// Unpack 7 values into output
	// Values are 17-bit unsigned
	// Skip 1 bits, read 119 bits of data.
	// Input must be at least 15 bytes long

	uint32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 52 to 68
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf8) << 12);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 69 to 85
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xfc) << 13);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 86 to 102
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfe) << 14);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 103 to 119
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15);
	output[6] = (double)(value >> 15);
}

static void unpack_7_17bit_signed_2off(const uint8_t * input, double * output) {
	// Unpack 7 values into output
	// Values are 17-bit signed
	// Skip 2 bits, read 119 bits of data.
	// Input must be at least 16 bytes long

	int32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 53 to 69
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xfc) << 13);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 70 to 86
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfe) << 14);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 87 to 103
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 104 to 120
	value = ((uint32_t)input[13] << 24) |
			((uint32_t)input[14] << 16) |
			((uint32_t)(input[15] & 0x80) << 8);
	output[6] = (double)(value >> 15);
}

static void unpack_7_17bit_unsigned_2off(const uint8_t * input, double * output) {
	// Unpack 7 values into output
	// Values are 17-bit unsigned
	// Skip 2 bits, read 119 bits of data.
	// Input must be at least 16 bytes long

	uint32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 53 to 69
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xfc) << 13);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 70 to 86
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfe) << 14);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 87 to 103
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 104 to 120
	value = ((uint32_t)input[13] << 24) |
			((uint32_t)input[14] << 16) |
			((uint32_t)(input[15] & 0x80) << 8);
	output[6] = (double)(value >> 15);
}

static void unpack_7_17bit_signed_3off(const uint8_t * input, double * output) {
	// Unpack 7 values into output
	// Values are 17-bit signed
	// Skip 3 bits, read 119 bits of data.
	// Input must be at least 16 bytes long

	int32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 54 to 70
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfe) << 14);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 71 to 87
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)input[10] << 15);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 88 to 104
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0x80) << 8);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 105 to 121
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xc0) << 9);
	output[6] = (double)(value >> 15);
}

static void unpack_7_17bit_unsigned_3off(const uint8_t * input, double * output) {
	// Unpack 7 values into output
	// Values are 17-bit unsigned
	// Skip 3 bits, read 119 bits of data.
	// Input must be at least 16 bytes long

	uint32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 54 to 70
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfe) << 14);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 71 to 87
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)input[10] << 15);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 88 to 104
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0x80) << 8);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 105 to 121
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xc0) << 9);
	output[6] = (double)(value >> 15);
}

static void unpack_7_17bit_signed_4off(const uint8_t * input, double * output) {
	// Unpack 7 values into output
	// Values are 17-bit signed
	// Skip 4 bits, read 119 bits of data.
	// Input must be at least 16 bytes long

	int32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 55 to 71
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 72 to 88
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)(input[11] & 0x80) << 8);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 89 to 105
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xc0) << 9);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 106 to 122
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xe0) << 10);
	output[6] = (double)(value >> 15);
}

static void unpack_7_17bit_unsigned_4off(const uint8_t * input, double * output) {
	// Unpack 7 values into output
	// Values are 17-bit unsigned
	// Skip 4 bits, read 119 bits of data.
	// Input must be at least 16 bytes long

	uint32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 55 to 71
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 72 to 88
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)(input[11] & 0x80) << 8);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 89 to 105
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xc0) << 9);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 106 to 122
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xe0) << 10);
	output[6] = (double)(value >> 15);
}

static void unpack_7_17bit_signed_5off(const uint8_t * input, double * output) {
	// Unpack 7 values into output
	// Values are 17-bit signed
	// Skip 5 bits, read 119 bits of data.
	// Input must be at least 16 bytes long

	int32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 56 to 72
	value = ((uint32_t)input[7] << 24) |
			((uint32_t)input[8] << 16) |
			((uint32_t)(input[9] & 0x80) << 8);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 73 to 89
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)(input[11] & 0xc0) << 9);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 90 to 106
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xe0) << 10);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 107 to 123
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)(input[15] & 0xf0) << 11);
	output[6] = (double)(value >> 15);
}

static void unpack_7_17bit_unsigned_5off(const uint8_t * input, double * output) {
	// Unpack 7 values into output
	// Values are 17-bit unsigned
	// Skip 5 bits, read 119 bits of data.
	// Input must be at least 16 bytes long

	uint32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 56 to 72
	value = ((uint32_t)input[7] << 24) |
			((uint32_t)input[8] << 16) |
			((uint32_t)(input[9] & 0x80) << 8);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 73 to 89
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)(input[11] & 0xc0) << 9);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 90 to 106
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xe0) << 10);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 107 to 123
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)(input[15] & 0xf0) << 11);
	output[6] = (double)(value >> 15);
}

static void unpack_7_17bit_signed_6off(const uint8_t * input, double * output) {
	// Unpack 7 values into output
	// Values are 17-bit signed
	// Skip 6 bits, read 119 bits of data.
	// Input must be at least 16 bytes long

	int32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 57 to 73
	value = ((uint32_t)(input[7] & 0x7f) << 25) |
			((uint32_t)input[8] << 17) |
			((uint32_t)(input[9] & 0xc0) << 9);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 74 to 90
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)(input[11] & 0xe0) << 10);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 91 to 107
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)(input[13] & 0xf0) << 11);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 108 to 124
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)(input[15] & 0xf8) << 12);
	output[6] = (double)(value >> 15);
}

static void unpack_7_17bit_unsigned_6off(const uint8_t * input, double * output) {
	// Unpack 7 values into output
	// Values are 17-bit unsigned
	// Skip 6 bits, read 119 bits of data.
	// Input must be at least 16 bytes long

	uint32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 57 to 73
	value = ((uint32_t)(input[7] & 0x7f) << 25) |
			((uint32_t)input[8] << 17) |
			((uint32_t)(input[9] & 0xc0) << 9);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 74 to 90
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)(input[11] & 0xe0) << 10);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 91 to 107
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)(input[13] & 0xf0) << 11);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 108 to 124
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)(input[15] & 0xf8) << 12);
	output[6] = (double)(value >> 15);
}

static void unpack_7_17bit_signed_7off(const uint8_t * input, double * output) {
	// Unpack 7 values into output
	// Values are 17-bit signed
	// Skip 7 bits, read 119 bits of data.
	// Input must be at least 16 bytes long

	int32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 58 to 74
	value = ((uint32_t)(input[7] & 0x3f) << 26) |
			((uint32_t)input[8] << 18) |
			((uint32_t)(input[9] & 0xe0) << 10);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 75 to 91
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)(input[11] & 0xf0) << 11);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 92 to 108
	value = ((uint32_t)(input[11] & 0x0f) << 28) |
			((uint32_t)input[12] << 20) |
			((uint32_t)(input[13] & 0xf8) << 12);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 109 to 125
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0xfc) << 13);
	output[6] = (double)(value >> 15);
}

static void unpack_7_17bit_unsigned_7off(const uint8_t * input, double * output) {
	// Unpack 7 values into output
	// Values are 17-bit unsigned
	// Skip 7 bits, read 119 bits of data.
	// Input must be at least 16 bytes long

	uint32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 58 to 74
	value = ((uint32_t)(input[7] & 0x3f) << 26) |
			((uint32_t)input[8] << 18) |
			((uint32_t)(input[9] & 0xe0) << 10);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 75 to 91
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)(input[11] & 0xf0) << 11);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 92 to 108
	value = ((uint32_t)(input[11] & 0x0f) << 28) |
			((uint32_t)input[12] << 20) |
			((uint32_t)(input[13] & 0xf8) << 12);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 109 to 125
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0xfc) << 13);
	output[6] = (double)(value >> 15);
}

static void unpack_8_17bit_signed_0off(const uint8_t * input, double * output) {
	// Unpack 8 values into output
	// Values are 17-bit signed
	// Skip 0 bits, read 136 bits of data.
	// Input must be at least 17 bytes long

	int32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 51 to 67
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xf0) << 11);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 68 to 84
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf8) << 12);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 85 to 101
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xfc) << 13);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 102 to 118
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfe) << 14);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 119 to 135
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)input[16] << 15);
	output[7] = (double)(value >> 15);
}

static void unpack_8_17bit_unsigned_0off(const uint8_t * input, double * output) {
	// Unpack 8 values into output
	// Values are 17-bit unsigned
	// Skip 0 bits, read 136 bits of data.
	// Input must be at least 17 bytes long

	uint32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 51 to 67
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xf0) << 11);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 68 to 84
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf8) << 12);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 85 to 101
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xfc) << 13);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 102 to 118
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfe) << 14);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 119 to 135
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)input[16] << 15);
	output[7] = (double)(value >> 15);
}

static void unpack_8_17bit_signed_1off(const uint8_t * input, double * output) {
	// Unpack 8 values into output
	// Values are 17-bit signed
	// Skip 1 bits, read 136 bits of data.
	// Input must be at least 18 bytes long

	int32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 52 to 68
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf8) << 12);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 69 to 85
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xfc) << 13);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 86 to 102
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfe) << 14);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 103 to 119
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 120 to 136
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)(input[17] & 0x80) << 8);
	output[7] = (double)(value >> 15);
}

static void unpack_8_17bit_unsigned_1off(const uint8_t * input, double * output) {
	// Unpack 8 values into output
	// Values are 17-bit unsigned
	// Skip 1 bits, read 136 bits of data.
	// Input must be at least 18 bytes long

	uint32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 52 to 68
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf8) << 12);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 69 to 85
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xfc) << 13);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 86 to 102
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfe) << 14);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 103 to 119
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 120 to 136
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)(input[17] & 0x80) << 8);
	output[7] = (double)(value >> 15);
}

static void unpack_8_17bit_signed_2off(const uint8_t * input, double * output) {
	// Unpack 8 values into output
	// Values are 17-bit signed
	// Skip 2 bits, read 136 bits of data.
	// Input must be at least 18 bytes long

	int32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 53 to 69
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xfc) << 13);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 70 to 86
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfe) << 14);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 87 to 103
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 104 to 120
	value = ((uint32_t)input[13] << 24) |
			((uint32_t)input[14] << 16) |
			((uint32_t)(input[15] & 0x80) << 8);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 121 to 137
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)(input[17] & 0xc0) << 9);
	output[7] = (double)(value >> 15);
}

static void unpack_8_17bit_unsigned_2off(const uint8_t * input, double * output) {
	// Unpack 8 values into output
	// Values are 17-bit unsigned
	// Skip 2 bits, read 136 bits of data.
	// Input must be at least 18 bytes long

	uint32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 53 to 69
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xfc) << 13);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 70 to 86
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfe) << 14);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 87 to 103
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 104 to 120
	value = ((uint32_t)input[13] << 24) |
			((uint32_t)input[14] << 16) |
			((uint32_t)(input[15] & 0x80) << 8);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 121 to 137
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)(input[17] & 0xc0) << 9);
	output[7] = (double)(value >> 15);
}

static void unpack_8_17bit_signed_3off(const uint8_t * input, double * output) {
	// Unpack 8 values into output
	// Values are 17-bit signed
	// Skip 3 bits, read 136 bits of data.
	// Input must be at least 18 bytes long

	int32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 54 to 70
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfe) << 14);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 71 to 87
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)input[10] << 15);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 88 to 104
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0x80) << 8);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 105 to 121
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xc0) << 9);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 122 to 138
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)(input[17] & 0xe0) << 10);
	output[7] = (double)(value >> 15);
}

static void unpack_8_17bit_unsigned_3off(const uint8_t * input, double * output) {
	// Unpack 8 values into output
	// Values are 17-bit unsigned
	// Skip 3 bits, read 136 bits of data.
	// Input must be at least 18 bytes long

	uint32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 54 to 70
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfe) << 14);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 71 to 87
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)input[10] << 15);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 88 to 104
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0x80) << 8);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 105 to 121
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xc0) << 9);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 122 to 138
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)(input[17] & 0xe0) << 10);
	output[7] = (double)(value >> 15);
}

static void unpack_8_17bit_signed_4off(const uint8_t * input, double * output) {
	// Unpack 8 values into output
	// Values are 17-bit signed
	// Skip 4 bits, read 136 bits of data.
	// Input must be at least 18 bytes long

	int32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 55 to 71
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 72 to 88
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)(input[11] & 0x80) << 8);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 89 to 105
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xc0) << 9);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 106 to 122
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xe0) << 10);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 123 to 139
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)(input[17] & 0xf0) << 11);
	output[7] = (double)(value >> 15);
}

static void unpack_8_17bit_unsigned_4off(const uint8_t * input, double * output) {
	// Unpack 8 values into output
	// Values are 17-bit unsigned
	// Skip 4 bits, read 136 bits of data.
	// Input must be at least 18 bytes long

	uint32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 55 to 71
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 72 to 88
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)(input[11] & 0x80) << 8);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 89 to 105
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xc0) << 9);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 106 to 122
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xe0) << 10);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 123 to 139
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)(input[17] & 0xf0) << 11);
	output[7] = (double)(value >> 15);
}

static void unpack_8_17bit_signed_5off(const uint8_t * input, double * output) {
	// Unpack 8 values into output
	// Values are 17-bit signed
	// Skip 5 bits, read 136 bits of data.
	// Input must be at least 18 bytes long

	int32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 56 to 72
	value = ((uint32_t)input[7] << 24) |
			((uint32_t)input[8] << 16) |
			((uint32_t)(input[9] & 0x80) << 8);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 73 to 89
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)(input[11] & 0xc0) << 9);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 90 to 106
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xe0) << 10);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 107 to 123
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)(input[15] & 0xf0) << 11);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 124 to 140
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)(input[17] & 0xf8) << 12);
	output[7] = (double)(value >> 15);
}

static void unpack_8_17bit_unsigned_5off(const uint8_t * input, double * output) {
	// Unpack 8 values into output
	// Values are 17-bit unsigned
	// Skip 5 bits, read 136 bits of data.
	// Input must be at least 18 bytes long

	uint32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 56 to 72
	value = ((uint32_t)input[7] << 24) |
			((uint32_t)input[8] << 16) |
			((uint32_t)(input[9] & 0x80) << 8);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 73 to 89
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)(input[11] & 0xc0) << 9);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 90 to 106
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xe0) << 10);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 107 to 123
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)(input[15] & 0xf0) << 11);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 124 to 140
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)(input[17] & 0xf8) << 12);
	output[7] = (double)(value >> 15);
}

static void unpack_8_17bit_signed_6off(const uint8_t * input, double * output) {
	// Unpack 8 values into output
	// Values are 17-bit signed
	// Skip 6 bits, read 136 bits of data.
	// Input must be at least 18 bytes long

	int32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 57 to 73
	value = ((uint32_t)(input[7] & 0x7f) << 25) |
			((uint32_t)input[8] << 17) |
			((uint32_t)(input[9] & 0xc0) << 9);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 74 to 90
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)(input[11] & 0xe0) << 10);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 91 to 107
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)(input[13] & 0xf0) << 11);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 108 to 124
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)(input[15] & 0xf8) << 12);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 125 to 141
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0xfc) << 13);
	output[7] = (double)(value >> 15);
}

static void unpack_8_17bit_unsigned_6off(const uint8_t * input, double * output) {
	// Unpack 8 values into output
	// Values are 17-bit unsigned
	// Skip 6 bits, read 136 bits of data.
	// Input must be at least 18 bytes long

	uint32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 57 to 73
	value = ((uint32_t)(input[7] & 0x7f) << 25) |
			((uint32_t)input[8] << 17) |
			((uint32_t)(input[9] & 0xc0) << 9);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 74 to 90
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)(input[11] & 0xe0) << 10);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 91 to 107
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)(input[13] & 0xf0) << 11);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 108 to 124
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)(input[15] & 0xf8) << 12);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 125 to 141
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0xfc) << 13);
	output[7] = (double)(value >> 15);
}

static void unpack_8_17bit_signed_7off(const uint8_t * input, double * output) {
	// Unpack 8 values into output
	// Values are 17-bit signed
	// Skip 7 bits, read 136 bits of data.
	// Input must be at least 18 bytes long

	int32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 58 to 74
	value = ((uint32_t)(input[7] & 0x3f) << 26) |
			((uint32_t)input[8] << 18) |
			((uint32_t)(input[9] & 0xe0) << 10);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 75 to 91
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)(input[11] & 0xf0) << 11);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 92 to 108
	value = ((uint32_t)(input[11] & 0x0f) << 28) |
			((uint32_t)input[12] << 20) |
			((uint32_t)(input[13] & 0xf8) << 12);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 109 to 125
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0xfc) << 13);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 126 to 142
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xfe) << 14);
	output[7] = (double)(value >> 15);
}

static void unpack_8_17bit_unsigned_7off(const uint8_t * input, double * output) {
	// Unpack 8 values into output
	// Values are 17-bit unsigned
	// Skip 7 bits, read 136 bits of data.
	// Input must be at least 18 bytes long

	uint32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 58 to 74
	value = ((uint32_t)(input[7] & 0x3f) << 26) |
			((uint32_t)input[8] << 18) |
			((uint32_t)(input[9] & 0xe0) << 10);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 75 to 91
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)(input[11] & 0xf0) << 11);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 92 to 108
	value = ((uint32_t)(input[11] & 0x0f) << 28) |
			((uint32_t)input[12] << 20) |
			((uint32_t)(input[13] & 0xf8) << 12);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 109 to 125
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0xfc) << 13);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 126 to 142
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xfe) << 14);
	output[7] = (double)(value >> 15);
}

static void unpack_9_17bit_signed_0off(const uint8_t * input, double * output) {
	// Unpack 9 values into output
	// Values are 17-bit signed
	// Skip 0 bits, read 153 bits of data.
	// Input must be at least 20 bytes long

	int32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 51 to 67
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xf0) << 11);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 68 to 84
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf8) << 12);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 85 to 101
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xfc) << 13);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 102 to 118
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfe) << 14);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 119 to 135
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)input[16] << 15);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 136 to 152
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)input[18] << 16) |
			((uint32_t)(input[19] & 0x80) << 8);
	output[8] = (double)(value >> 15);
}

static void unpack_9_17bit_unsigned_0off(const uint8_t * input, double * output) {
	// Unpack 9 values into output
	// Values are 17-bit unsigned
	// Skip 0 bits, read 153 bits of data.
	// Input must be at least 20 bytes long

	uint32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 51 to 67
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xf0) << 11);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 68 to 84
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf8) << 12);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 85 to 101
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xfc) << 13);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 102 to 118
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfe) << 14);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 119 to 135
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)input[16] << 15);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 136 to 152
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)input[18] << 16) |
			((uint32_t)(input[19] & 0x80) << 8);
	output[8] = (double)(value >> 15);
}

static void unpack_9_17bit_signed_1off(const uint8_t * input, double * output) {
	// Unpack 9 values into output
	// Values are 17-bit signed
	// Skip 1 bits, read 153 bits of data.
	// Input must be at least 20 bytes long

	int32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 52 to 68
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf8) << 12);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 69 to 85
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xfc) << 13);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 86 to 102
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfe) << 14);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 103 to 119
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 120 to 136
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)(input[17] & 0x80) << 8);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 137 to 153
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)input[18] << 17) |
			((uint32_t)(input[19] & 0xc0) << 9);
	output[8] = (double)(value >> 15);
}

static void unpack_9_17bit_unsigned_1off(const uint8_t * input, double * output) {
	// Unpack 9 values into output
	// Values are 17-bit unsigned
	// Skip 1 bits, read 153 bits of data.
	// Input must be at least 20 bytes long

	uint32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 52 to 68
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf8) << 12);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 69 to 85
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xfc) << 13);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 86 to 102
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfe) << 14);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 103 to 119
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 120 to 136
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)(input[17] & 0x80) << 8);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 137 to 153
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)input[18] << 17) |
			((uint32_t)(input[19] & 0xc0) << 9);
	output[8] = (double)(value >> 15);
}

static void unpack_9_17bit_signed_2off(const uint8_t * input, double * output) {
	// Unpack 9 values into output
	// Values are 17-bit signed
	// Skip 2 bits, read 153 bits of data.
	// Input must be at least 20 bytes long

	int32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 53 to 69
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xfc) << 13);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 70 to 86
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfe) << 14);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 87 to 103
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 104 to 120
	value = ((uint32_t)input[13] << 24) |
			((uint32_t)input[14] << 16) |
			((uint32_t)(input[15] & 0x80) << 8);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 121 to 137
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)(input[17] & 0xc0) << 9);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 138 to 154
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)input[18] << 18) |
			((uint32_t)(input[19] & 0xe0) << 10);
	output[8] = (double)(value >> 15);
}

static void unpack_9_17bit_unsigned_2off(const uint8_t * input, double * output) {
	// Unpack 9 values into output
	// Values are 17-bit unsigned
	// Skip 2 bits, read 153 bits of data.
	// Input must be at least 20 bytes long

	uint32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 53 to 69
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xfc) << 13);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 70 to 86
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfe) << 14);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 87 to 103
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 104 to 120
	value = ((uint32_t)input[13] << 24) |
			((uint32_t)input[14] << 16) |
			((uint32_t)(input[15] & 0x80) << 8);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 121 to 137
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)(input[17] & 0xc0) << 9);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 138 to 154
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)input[18] << 18) |
			((uint32_t)(input[19] & 0xe0) << 10);
	output[8] = (double)(value >> 15);
}

static void unpack_9_17bit_signed_3off(const uint8_t * input, double * output) {
	// Unpack 9 values into output
	// Values are 17-bit signed
	// Skip 3 bits, read 153 bits of data.
	// Input must be at least 20 bytes long

	int32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 54 to 70
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfe) << 14);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 71 to 87
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)input[10] << 15);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 88 to 104
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0x80) << 8);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 105 to 121
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xc0) << 9);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 122 to 138
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)(input[17] & 0xe0) << 10);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 139 to 155
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)input[18] << 19) |
			((uint32_t)(input[19] & 0xf0) << 11);
	output[8] = (double)(value >> 15);
}

static void unpack_9_17bit_unsigned_3off(const uint8_t * input, double * output) {
	// Unpack 9 values into output
	// Values are 17-bit unsigned
	// Skip 3 bits, read 153 bits of data.
	// Input must be at least 20 bytes long

	uint32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 54 to 70
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfe) << 14);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 71 to 87
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)input[10] << 15);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 88 to 104
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0x80) << 8);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 105 to 121
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xc0) << 9);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 122 to 138
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)(input[17] & 0xe0) << 10);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 139 to 155
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)input[18] << 19) |
			((uint32_t)(input[19] & 0xf0) << 11);
	output[8] = (double)(value >> 15);
}

static void unpack_9_17bit_signed_4off(const uint8_t * input, double * output) {
	// Unpack 9 values into output
	// Values are 17-bit signed
	// Skip 4 bits, read 153 bits of data.
	// Input must be at least 20 bytes long

	int32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 55 to 71
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 72 to 88
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)(input[11] & 0x80) << 8);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 89 to 105
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xc0) << 9);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 106 to 122
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xe0) << 10);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 123 to 139
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)(input[17] & 0xf0) << 11);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 140 to 156
	value = ((uint32_t)(input[17] & 0x0f) << 28) |
			((uint32_t)input[18] << 20) |
			((uint32_t)(input[19] & 0xf8) << 12);
	output[8] = (double)(value >> 15);
}

static void unpack_9_17bit_unsigned_4off(const uint8_t * input, double * output) {
	// Unpack 9 values into output
	// Values are 17-bit unsigned
	// Skip 4 bits, read 153 bits of data.
	// Input must be at least 20 bytes long

	uint32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 55 to 71
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 72 to 88
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)(input[11] & 0x80) << 8);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 89 to 105
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xc0) << 9);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 106 to 122
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xe0) << 10);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 123 to 139
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)(input[17] & 0xf0) << 11);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 140 to 156
	value = ((uint32_t)(input[17] & 0x0f) << 28) |
			((uint32_t)input[18] << 20) |
			((uint32_t)(input[19] & 0xf8) << 12);
	output[8] = (double)(value >> 15);
}

static void unpack_9_17bit_signed_5off(const uint8_t * input, double * output) {
	// Unpack 9 values into output
	// Values are 17-bit signed
	// Skip 5 bits, read 153 bits of data.
	// Input must be at least 20 bytes long

	int32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 56 to 72
	value = ((uint32_t)input[7] << 24) |
			((uint32_t)input[8] << 16) |
			((uint32_t)(input[9] & 0x80) << 8);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 73 to 89
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)(input[11] & 0xc0) << 9);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 90 to 106
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xe0) << 10);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 107 to 123
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)(input[15] & 0xf0) << 11);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 124 to 140
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)(input[17] & 0xf8) << 12);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 141 to 157
	value = ((uint32_t)(input[17] & 0x07) << 29) |
			((uint32_t)input[18] << 21) |
			((uint32_t)(input[19] & 0xfc) << 13);
	output[8] = (double)(value >> 15);
}

static void unpack_9_17bit_unsigned_5off(const uint8_t * input, double * output) {
	// Unpack 9 values into output
	// Values are 17-bit unsigned
	// Skip 5 bits, read 153 bits of data.
	// Input must be at least 20 bytes long

	uint32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 56 to 72
	value = ((uint32_t)input[7] << 24) |
			((uint32_t)input[8] << 16) |
			((uint32_t)(input[9] & 0x80) << 8);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 73 to 89
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)(input[11] & 0xc0) << 9);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 90 to 106
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xe0) << 10);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 107 to 123
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)(input[15] & 0xf0) << 11);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 124 to 140
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)(input[17] & 0xf8) << 12);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 141 to 157
	value = ((uint32_t)(input[17] & 0x07) << 29) |
			((uint32_t)input[18] << 21) |
			((uint32_t)(input[19] & 0xfc) << 13);
	output[8] = (double)(value >> 15);
}

static void unpack_9_17bit_signed_6off(const uint8_t * input, double * output) {
	// Unpack 9 values into output
	// Values are 17-bit signed
	// Skip 6 bits, read 153 bits of data.
	// Input must be at least 20 bytes long

	int32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 57 to 73
	value = ((uint32_t)(input[7] & 0x7f) << 25) |
			((uint32_t)input[8] << 17) |
			((uint32_t)(input[9] & 0xc0) << 9);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 74 to 90
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)(input[11] & 0xe0) << 10);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 91 to 107
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)(input[13] & 0xf0) << 11);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 108 to 124
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)(input[15] & 0xf8) << 12);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 125 to 141
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0xfc) << 13);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 142 to 158
	value = ((uint32_t)(input[17] & 0x03) << 30) |
			((uint32_t)input[18] << 22) |
			((uint32_t)(input[19] & 0xfe) << 14);
	output[8] = (double)(value >> 15);
}

static void unpack_9_17bit_unsigned_6off(const uint8_t * input, double * output) {
	// Unpack 9 values into output
	// Values are 17-bit unsigned
	// Skip 6 bits, read 153 bits of data.
	// Input must be at least 20 bytes long

	uint32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 57 to 73
	value = ((uint32_t)(input[7] & 0x7f) << 25) |
			((uint32_t)input[8] << 17) |
			((uint32_t)(input[9] & 0xc0) << 9);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 74 to 90
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)(input[11] & 0xe0) << 10);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 91 to 107
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)(input[13] & 0xf0) << 11);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 108 to 124
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)(input[15] & 0xf8) << 12);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 125 to 141
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0xfc) << 13);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 142 to 158
	value = ((uint32_t)(input[17] & 0x03) << 30) |
			((uint32_t)input[18] << 22) |
			((uint32_t)(input[19] & 0xfe) << 14);
	output[8] = (double)(value >> 15);
}

static void unpack_9_17bit_signed_7off(const uint8_t * input, double * output) {
	// Unpack 9 values into output
	// Values are 17-bit signed
	// Skip 7 bits, read 153 bits of data.
	// Input must be at least 20 bytes long

	int32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 58 to 74
	value = ((uint32_t)(input[7] & 0x3f) << 26) |
			((uint32_t)input[8] << 18) |
			((uint32_t)(input[9] & 0xe0) << 10);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 75 to 91
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)(input[11] & 0xf0) << 11);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 92 to 108
	value = ((uint32_t)(input[11] & 0x0f) << 28) |
			((uint32_t)input[12] << 20) |
			((uint32_t)(input[13] & 0xf8) << 12);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 109 to 125
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0xfc) << 13);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 126 to 142
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xfe) << 14);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 143 to 159
	value = ((uint32_t)(input[17] & 0x01) << 31) |
			((uint32_t)input[18] << 23) |
			((uint32_t)input[19] << 15);
	output[8] = (double)(value >> 15);
}

static void unpack_9_17bit_unsigned_7off(const uint8_t * input, double * output) {
	// Unpack 9 values into output
	// Values are 17-bit unsigned
	// Skip 7 bits, read 153 bits of data.
	// Input must be at least 20 bytes long

	uint32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 58 to 74
	value = ((uint32_t)(input[7] & 0x3f) << 26) |
			((uint32_t)input[8] << 18) |
			((uint32_t)(input[9] & 0xe0) << 10);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 75 to 91
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)(input[11] & 0xf0) << 11);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 92 to 108
	value = ((uint32_t)(input[11] & 0x0f) << 28) |
			((uint32_t)input[12] << 20) |
			((uint32_t)(input[13] & 0xf8) << 12);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 109 to 125
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0xfc) << 13);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 126 to 142
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xfe) << 14);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 143 to 159
	value = ((uint32_t)(input[17] & 0x01) << 31) |
			((uint32_t)input[18] << 23) |
			((uint32_t)input[19] << 15);
	output[8] = (double)(value >> 15);
}

static void unpack_10_17bit_signed_0off(const uint8_t * input, double * output) {
	// Unpack 10 values into output
	// Values are 17-bit signed
	// Skip 0 bits, read 170 bits of data.
	// Input must be at least 22 bytes long

	int32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 51 to 67
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xf0) << 11);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 68 to 84
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf8) << 12);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 85 to 101
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xfc) << 13);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 102 to 118
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfe) << 14);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 119 to 135
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)input[16] << 15);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 136 to 152
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)input[18] << 16) |
			((uint32_t)(input[19] & 0x80) << 8);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 153 to 169
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xc0) << 9);
	output[9] = (double)(value >> 15);
}

static void unpack_10_17bit_unsigned_0off(const uint8_t * input, double * output) {
	// Unpack 10 values into output
	// Values are 17-bit unsigned
	// Skip 0 bits, read 170 bits of data.
	// Input must be at least 22 bytes long

	uint32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 51 to 67
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xf0) << 11);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 68 to 84
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf8) << 12);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 85 to 101
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xfc) << 13);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 102 to 118
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfe) << 14);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 119 to 135
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)input[16] << 15);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 136 to 152
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)input[18] << 16) |
			((uint32_t)(input[19] & 0x80) << 8);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 153 to 169
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xc0) << 9);
	output[9] = (double)(value >> 15);
}

static void unpack_10_17bit_signed_1off(const uint8_t * input, double * output) {
	// Unpack 10 values into output
	// Values are 17-bit signed
	// Skip 1 bits, read 170 bits of data.
	// Input must be at least 22 bytes long

	int32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 52 to 68
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf8) << 12);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 69 to 85
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xfc) << 13);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 86 to 102
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfe) << 14);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 103 to 119
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 120 to 136
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)(input[17] & 0x80) << 8);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 137 to 153
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)input[18] << 17) |
			((uint32_t)(input[19] & 0xc0) << 9);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 154 to 170
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xe0) << 10);
	output[9] = (double)(value >> 15);
}

static void unpack_10_17bit_unsigned_1off(const uint8_t * input, double * output) {
	// Unpack 10 values into output
	// Values are 17-bit unsigned
	// Skip 1 bits, read 170 bits of data.
	// Input must be at least 22 bytes long

	uint32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 52 to 68
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf8) << 12);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 69 to 85
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xfc) << 13);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 86 to 102
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfe) << 14);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 103 to 119
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 120 to 136
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)(input[17] & 0x80) << 8);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 137 to 153
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)input[18] << 17) |
			((uint32_t)(input[19] & 0xc0) << 9);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 154 to 170
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xe0) << 10);
	output[9] = (double)(value >> 15);
}

static void unpack_10_17bit_signed_2off(const uint8_t * input, double * output) {
	// Unpack 10 values into output
	// Values are 17-bit signed
	// Skip 2 bits, read 170 bits of data.
	// Input must be at least 22 bytes long

	int32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 53 to 69
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xfc) << 13);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 70 to 86
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfe) << 14);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 87 to 103
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 104 to 120
	value = ((uint32_t)input[13] << 24) |
			((uint32_t)input[14] << 16) |
			((uint32_t)(input[15] & 0x80) << 8);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 121 to 137
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)(input[17] & 0xc0) << 9);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 138 to 154
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)input[18] << 18) |
			((uint32_t)(input[19] & 0xe0) << 10);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 155 to 171
	value = ((uint32_t)(input[19] & 0x1f) << 27) |
			((uint32_t)input[20] << 19) |
			((uint32_t)(input[21] & 0xf0) << 11);
	output[9] = (double)(value >> 15);
}

static void unpack_10_17bit_unsigned_2off(const uint8_t * input, double * output) {
	// Unpack 10 values into output
	// Values are 17-bit unsigned
	// Skip 2 bits, read 170 bits of data.
	// Input must be at least 22 bytes long

	uint32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 53 to 69
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xfc) << 13);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 70 to 86
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfe) << 14);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 87 to 103
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 104 to 120
	value = ((uint32_t)input[13] << 24) |
			((uint32_t)input[14] << 16) |
			((uint32_t)(input[15] & 0x80) << 8);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 121 to 137
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)(input[17] & 0xc0) << 9);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 138 to 154
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)input[18] << 18) |
			((uint32_t)(input[19] & 0xe0) << 10);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 155 to 171
	value = ((uint32_t)(input[19] & 0x1f) << 27) |
			((uint32_t)input[20] << 19) |
			((uint32_t)(input[21] & 0xf0) << 11);
	output[9] = (double)(value >> 15);
}

static void unpack_10_17bit_signed_3off(const uint8_t * input, double * output) {
	// Unpack 10 values into output
	// Values are 17-bit signed
	// Skip 3 bits, read 170 bits of data.
	// Input must be at least 22 bytes long

	int32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 54 to 70
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfe) << 14);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 71 to 87
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)input[10] << 15);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 88 to 104
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0x80) << 8);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 105 to 121
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xc0) << 9);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 122 to 138
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)(input[17] & 0xe0) << 10);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 139 to 155
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)input[18] << 19) |
			((uint32_t)(input[19] & 0xf0) << 11);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 156 to 172
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20) |
			((uint32_t)(input[21] & 0xf8) << 12);
	output[9] = (double)(value >> 15);
}

static void unpack_10_17bit_unsigned_3off(const uint8_t * input, double * output) {
	// Unpack 10 values into output
	// Values are 17-bit unsigned
	// Skip 3 bits, read 170 bits of data.
	// Input must be at least 22 bytes long

	uint32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 54 to 70
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfe) << 14);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 71 to 87
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)input[10] << 15);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 88 to 104
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0x80) << 8);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 105 to 121
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xc0) << 9);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 122 to 138
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)(input[17] & 0xe0) << 10);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 139 to 155
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)input[18] << 19) |
			((uint32_t)(input[19] & 0xf0) << 11);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 156 to 172
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20) |
			((uint32_t)(input[21] & 0xf8) << 12);
	output[9] = (double)(value >> 15);
}

static void unpack_10_17bit_signed_4off(const uint8_t * input, double * output) {
	// Unpack 10 values into output
	// Values are 17-bit signed
	// Skip 4 bits, read 170 bits of data.
	// Input must be at least 22 bytes long

	int32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 55 to 71
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 72 to 88
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)(input[11] & 0x80) << 8);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 89 to 105
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xc0) << 9);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 106 to 122
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xe0) << 10);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 123 to 139
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)(input[17] & 0xf0) << 11);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 140 to 156
	value = ((uint32_t)(input[17] & 0x0f) << 28) |
			((uint32_t)input[18] << 20) |
			((uint32_t)(input[19] & 0xf8) << 12);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 157 to 173
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0xfc) << 13);
	output[9] = (double)(value >> 15);
}

static void unpack_10_17bit_unsigned_4off(const uint8_t * input, double * output) {
	// Unpack 10 values into output
	// Values are 17-bit unsigned
	// Skip 4 bits, read 170 bits of data.
	// Input must be at least 22 bytes long

	uint32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 55 to 71
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 72 to 88
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)(input[11] & 0x80) << 8);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 89 to 105
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xc0) << 9);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 106 to 122
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xe0) << 10);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 123 to 139
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)(input[17] & 0xf0) << 11);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 140 to 156
	value = ((uint32_t)(input[17] & 0x0f) << 28) |
			((uint32_t)input[18] << 20) |
			((uint32_t)(input[19] & 0xf8) << 12);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 157 to 173
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0xfc) << 13);
	output[9] = (double)(value >> 15);
}

static void unpack_10_17bit_signed_5off(const uint8_t * input, double * output) {
	// Unpack 10 values into output
	// Values are 17-bit signed
	// Skip 5 bits, read 170 bits of data.
	// Input must be at least 22 bytes long

	int32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 56 to 72
	value = ((uint32_t)input[7] << 24) |
			((uint32_t)input[8] << 16) |
			((uint32_t)(input[9] & 0x80) << 8);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 73 to 89
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)(input[11] & 0xc0) << 9);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 90 to 106
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xe0) << 10);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 107 to 123
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)(input[15] & 0xf0) << 11);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 124 to 140
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)(input[17] & 0xf8) << 12);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 141 to 157
	value = ((uint32_t)(input[17] & 0x07) << 29) |
			((uint32_t)input[18] << 21) |
			((uint32_t)(input[19] & 0xfc) << 13);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 158 to 174
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xfe) << 14);
	output[9] = (double)(value >> 15);
}

static void unpack_10_17bit_unsigned_5off(const uint8_t * input, double * output) {
	// Unpack 10 values into output
	// Values are 17-bit unsigned
	// Skip 5 bits, read 170 bits of data.
	// Input must be at least 22 bytes long

	uint32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 56 to 72
	value = ((uint32_t)input[7] << 24) |
			((uint32_t)input[8] << 16) |
			((uint32_t)(input[9] & 0x80) << 8);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 73 to 89
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)(input[11] & 0xc0) << 9);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 90 to 106
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xe0) << 10);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 107 to 123
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)(input[15] & 0xf0) << 11);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 124 to 140
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)(input[17] & 0xf8) << 12);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 141 to 157
	value = ((uint32_t)(input[17] & 0x07) << 29) |
			((uint32_t)input[18] << 21) |
			((uint32_t)(input[19] & 0xfc) << 13);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 158 to 174
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xfe) << 14);
	output[9] = (double)(value >> 15);
}

static void unpack_10_17bit_signed_6off(const uint8_t * input, double * output) {
	// Unpack 10 values into output
	// Values are 17-bit signed
	// Skip 6 bits, read 170 bits of data.
	// Input must be at least 22 bytes long

	int32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 57 to 73
	value = ((uint32_t)(input[7] & 0x7f) << 25) |
			((uint32_t)input[8] << 17) |
			((uint32_t)(input[9] & 0xc0) << 9);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 74 to 90
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)(input[11] & 0xe0) << 10);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 91 to 107
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)(input[13] & 0xf0) << 11);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 108 to 124
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)(input[15] & 0xf8) << 12);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 125 to 141
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0xfc) << 13);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 142 to 158
	value = ((uint32_t)(input[17] & 0x03) << 30) |
			((uint32_t)input[18] << 22) |
			((uint32_t)(input[19] & 0xfe) << 14);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 159 to 175
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)input[21] << 15);
	output[9] = (double)(value >> 15);
}

static void unpack_10_17bit_unsigned_6off(const uint8_t * input, double * output) {
	// Unpack 10 values into output
	// Values are 17-bit unsigned
	// Skip 6 bits, read 170 bits of data.
	// Input must be at least 22 bytes long

	uint32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 57 to 73
	value = ((uint32_t)(input[7] & 0x7f) << 25) |
			((uint32_t)input[8] << 17) |
			((uint32_t)(input[9] & 0xc0) << 9);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 74 to 90
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)(input[11] & 0xe0) << 10);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 91 to 107
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)(input[13] & 0xf0) << 11);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 108 to 124
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)(input[15] & 0xf8) << 12);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 125 to 141
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0xfc) << 13);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 142 to 158
	value = ((uint32_t)(input[17] & 0x03) << 30) |
			((uint32_t)input[18] << 22) |
			((uint32_t)(input[19] & 0xfe) << 14);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 159 to 175
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)input[21] << 15);
	output[9] = (double)(value >> 15);
}

static void unpack_10_17bit_signed_7off(const uint8_t * input, double * output) {
	// Unpack 10 values into output
	// Values are 17-bit signed
	// Skip 7 bits, read 170 bits of data.
	// Input must be at least 23 bytes long

	int32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 58 to 74
	value = ((uint32_t)(input[7] & 0x3f) << 26) |
			((uint32_t)input[8] << 18) |
			((uint32_t)(input[9] & 0xe0) << 10);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 75 to 91
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)(input[11] & 0xf0) << 11);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 92 to 108
	value = ((uint32_t)(input[11] & 0x0f) << 28) |
			((uint32_t)input[12] << 20) |
			((uint32_t)(input[13] & 0xf8) << 12);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 109 to 125
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0xfc) << 13);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 126 to 142
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xfe) << 14);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 143 to 159
	value = ((uint32_t)(input[17] & 0x01) << 31) |
			((uint32_t)input[18] << 23) |
			((uint32_t)input[19] << 15);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 160 to 176
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16) |
			((uint32_t)(input[22] & 0x80) << 8);
	output[9] = (double)(value >> 15);
}

static void unpack_10_17bit_unsigned_7off(const uint8_t * input, double * output) {
	// Unpack 10 values into output
	// Values are 17-bit unsigned
	// Skip 7 bits, read 170 bits of data.
	// Input must be at least 23 bytes long

	uint32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 58 to 74
	value = ((uint32_t)(input[7] & 0x3f) << 26) |
			((uint32_t)input[8] << 18) |
			((uint32_t)(input[9] & 0xe0) << 10);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 75 to 91
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)(input[11] & 0xf0) << 11);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 92 to 108
	value = ((uint32_t)(input[11] & 0x0f) << 28) |
			((uint32_t)input[12] << 20) |
			((uint32_t)(input[13] & 0xf8) << 12);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 109 to 125
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0xfc) << 13);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 126 to 142
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xfe) << 14);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 143 to 159
	value = ((uint32_t)(input[17] & 0x01) << 31) |
			((uint32_t)input[18] << 23) |
			((uint32_t)input[19] << 15);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 160 to 176
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16) |
			((uint32_t)(input[22] & 0x80) << 8);
	output[9] = (double)(value >> 15);
}

static void unpack_11_17bit_signed_0off(const uint8_t * input, double * output) {
	// Unpack 11 values into output
	// Values are 17-bit signed
	// Skip 0 bits, read 187 bits of data.
	// Input must be at least 24 bytes long

	int32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 51 to 67
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xf0) << 11);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 68 to 84
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf8) << 12);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 85 to 101
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xfc) << 13);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 102 to 118
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfe) << 14);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 119 to 135
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)input[16] << 15);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 136 to 152
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)input[18] << 16) |
			((uint32_t)(input[19] & 0x80) << 8);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 153 to 169
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xc0) << 9);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 170 to 186
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xe0) << 10);
	output[10] = (double)(value >> 15);
}

static void unpack_11_17bit_unsigned_0off(const uint8_t * input, double * output) {
	// Unpack 11 values into output
	// Values are 17-bit unsigned
	// Skip 0 bits, read 187 bits of data.
	// Input must be at least 24 bytes long

	uint32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 51 to 67
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xf0) << 11);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 68 to 84
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf8) << 12);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 85 to 101
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xfc) << 13);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 102 to 118
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfe) << 14);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 119 to 135
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)input[16] << 15);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 136 to 152
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)input[18] << 16) |
			((uint32_t)(input[19] & 0x80) << 8);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 153 to 169
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xc0) << 9);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 170 to 186
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xe0) << 10);
	output[10] = (double)(value >> 15);
}

static void unpack_11_17bit_signed_1off(const uint8_t * input, double * output) {
	// Unpack 11 values into output
	// Values are 17-bit signed
	// Skip 1 bits, read 187 bits of data.
	// Input must be at least 24 bytes long

	int32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 52 to 68
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf8) << 12);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 69 to 85
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xfc) << 13);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 86 to 102
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfe) << 14);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 103 to 119
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 120 to 136
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)(input[17] & 0x80) << 8);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 137 to 153
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)input[18] << 17) |
			((uint32_t)(input[19] & 0xc0) << 9);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 154 to 170
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xe0) << 10);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 171 to 187
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)(input[23] & 0xf0) << 11);
	output[10] = (double)(value >> 15);
}

static void unpack_11_17bit_unsigned_1off(const uint8_t * input, double * output) {
	// Unpack 11 values into output
	// Values are 17-bit unsigned
	// Skip 1 bits, read 187 bits of data.
	// Input must be at least 24 bytes long

	uint32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 52 to 68
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf8) << 12);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 69 to 85
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xfc) << 13);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 86 to 102
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfe) << 14);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 103 to 119
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 120 to 136
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)(input[17] & 0x80) << 8);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 137 to 153
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)input[18] << 17) |
			((uint32_t)(input[19] & 0xc0) << 9);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 154 to 170
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xe0) << 10);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 171 to 187
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)(input[23] & 0xf0) << 11);
	output[10] = (double)(value >> 15);
}

static void unpack_11_17bit_signed_2off(const uint8_t * input, double * output) {
	// Unpack 11 values into output
	// Values are 17-bit signed
	// Skip 2 bits, read 187 bits of data.
	// Input must be at least 24 bytes long

	int32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 53 to 69
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xfc) << 13);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 70 to 86
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfe) << 14);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 87 to 103
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 104 to 120
	value = ((uint32_t)input[13] << 24) |
			((uint32_t)input[14] << 16) |
			((uint32_t)(input[15] & 0x80) << 8);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 121 to 137
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)(input[17] & 0xc0) << 9);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 138 to 154
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)input[18] << 18) |
			((uint32_t)(input[19] & 0xe0) << 10);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 155 to 171
	value = ((uint32_t)(input[19] & 0x1f) << 27) |
			((uint32_t)input[20] << 19) |
			((uint32_t)(input[21] & 0xf0) << 11);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 172 to 188
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)(input[23] & 0xf8) << 12);
	output[10] = (double)(value >> 15);
}

static void unpack_11_17bit_unsigned_2off(const uint8_t * input, double * output) {
	// Unpack 11 values into output
	// Values are 17-bit unsigned
	// Skip 2 bits, read 187 bits of data.
	// Input must be at least 24 bytes long

	uint32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 53 to 69
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xfc) << 13);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 70 to 86
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfe) << 14);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 87 to 103
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 104 to 120
	value = ((uint32_t)input[13] << 24) |
			((uint32_t)input[14] << 16) |
			((uint32_t)(input[15] & 0x80) << 8);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 121 to 137
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)(input[17] & 0xc0) << 9);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 138 to 154
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)input[18] << 18) |
			((uint32_t)(input[19] & 0xe0) << 10);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 155 to 171
	value = ((uint32_t)(input[19] & 0x1f) << 27) |
			((uint32_t)input[20] << 19) |
			((uint32_t)(input[21] & 0xf0) << 11);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 172 to 188
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)(input[23] & 0xf8) << 12);
	output[10] = (double)(value >> 15);
}

static void unpack_11_17bit_signed_3off(const uint8_t * input, double * output) {
	// Unpack 11 values into output
	// Values are 17-bit signed
	// Skip 3 bits, read 187 bits of data.
	// Input must be at least 24 bytes long

	int32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 54 to 70
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfe) << 14);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 71 to 87
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)input[10] << 15);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 88 to 104
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0x80) << 8);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 105 to 121
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xc0) << 9);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 122 to 138
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)(input[17] & 0xe0) << 10);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 139 to 155
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)input[18] << 19) |
			((uint32_t)(input[19] & 0xf0) << 11);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 156 to 172
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20) |
			((uint32_t)(input[21] & 0xf8) << 12);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 173 to 189
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0xfc) << 13);
	output[10] = (double)(value >> 15);
}

static void unpack_11_17bit_unsigned_3off(const uint8_t * input, double * output) {
	// Unpack 11 values into output
	// Values are 17-bit unsigned
	// Skip 3 bits, read 187 bits of data.
	// Input must be at least 24 bytes long

	uint32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 54 to 70
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfe) << 14);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 71 to 87
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)input[10] << 15);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 88 to 104
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0x80) << 8);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 105 to 121
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xc0) << 9);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 122 to 138
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)(input[17] & 0xe0) << 10);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 139 to 155
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)input[18] << 19) |
			((uint32_t)(input[19] & 0xf0) << 11);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 156 to 172
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20) |
			((uint32_t)(input[21] & 0xf8) << 12);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 173 to 189
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0xfc) << 13);
	output[10] = (double)(value >> 15);
}

static void unpack_11_17bit_signed_4off(const uint8_t * input, double * output) {
	// Unpack 11 values into output
	// Values are 17-bit signed
	// Skip 4 bits, read 187 bits of data.
	// Input must be at least 24 bytes long

	int32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 55 to 71
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 72 to 88
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)(input[11] & 0x80) << 8);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 89 to 105
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xc0) << 9);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 106 to 122
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xe0) << 10);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 123 to 139
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)(input[17] & 0xf0) << 11);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 140 to 156
	value = ((uint32_t)(input[17] & 0x0f) << 28) |
			((uint32_t)input[18] << 20) |
			((uint32_t)(input[19] & 0xf8) << 12);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 157 to 173
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0xfc) << 13);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 174 to 190
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xfe) << 14);
	output[10] = (double)(value >> 15);
}

static void unpack_11_17bit_unsigned_4off(const uint8_t * input, double * output) {
	// Unpack 11 values into output
	// Values are 17-bit unsigned
	// Skip 4 bits, read 187 bits of data.
	// Input must be at least 24 bytes long

	uint32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 55 to 71
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 72 to 88
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)(input[11] & 0x80) << 8);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 89 to 105
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xc0) << 9);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 106 to 122
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xe0) << 10);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 123 to 139
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)(input[17] & 0xf0) << 11);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 140 to 156
	value = ((uint32_t)(input[17] & 0x0f) << 28) |
			((uint32_t)input[18] << 20) |
			((uint32_t)(input[19] & 0xf8) << 12);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 157 to 173
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0xfc) << 13);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 174 to 190
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xfe) << 14);
	output[10] = (double)(value >> 15);
}

static void unpack_11_17bit_signed_5off(const uint8_t * input, double * output) {
	// Unpack 11 values into output
	// Values are 17-bit signed
	// Skip 5 bits, read 187 bits of data.
	// Input must be at least 24 bytes long

	int32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 56 to 72
	value = ((uint32_t)input[7] << 24) |
			((uint32_t)input[8] << 16) |
			((uint32_t)(input[9] & 0x80) << 8);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 73 to 89
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)(input[11] & 0xc0) << 9);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 90 to 106
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xe0) << 10);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 107 to 123
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)(input[15] & 0xf0) << 11);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 124 to 140
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)(input[17] & 0xf8) << 12);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 141 to 157
	value = ((uint32_t)(input[17] & 0x07) << 29) |
			((uint32_t)input[18] << 21) |
			((uint32_t)(input[19] & 0xfc) << 13);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 158 to 174
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xfe) << 14);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 175 to 191
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15);
	output[10] = (double)(value >> 15);
}

static void unpack_11_17bit_unsigned_5off(const uint8_t * input, double * output) {
	// Unpack 11 values into output
	// Values are 17-bit unsigned
	// Skip 5 bits, read 187 bits of data.
	// Input must be at least 24 bytes long

	uint32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 56 to 72
	value = ((uint32_t)input[7] << 24) |
			((uint32_t)input[8] << 16) |
			((uint32_t)(input[9] & 0x80) << 8);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 73 to 89
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)(input[11] & 0xc0) << 9);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 90 to 106
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xe0) << 10);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 107 to 123
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)(input[15] & 0xf0) << 11);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 124 to 140
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)(input[17] & 0xf8) << 12);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 141 to 157
	value = ((uint32_t)(input[17] & 0x07) << 29) |
			((uint32_t)input[18] << 21) |
			((uint32_t)(input[19] & 0xfc) << 13);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 158 to 174
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xfe) << 14);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 175 to 191
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15);
	output[10] = (double)(value >> 15);
}

static void unpack_11_17bit_signed_6off(const uint8_t * input, double * output) {
	// Unpack 11 values into output
	// Values are 17-bit signed
	// Skip 6 bits, read 187 bits of data.
	// Input must be at least 25 bytes long

	int32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 57 to 73
	value = ((uint32_t)(input[7] & 0x7f) << 25) |
			((uint32_t)input[8] << 17) |
			((uint32_t)(input[9] & 0xc0) << 9);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 74 to 90
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)(input[11] & 0xe0) << 10);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 91 to 107
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)(input[13] & 0xf0) << 11);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 108 to 124
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)(input[15] & 0xf8) << 12);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 125 to 141
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0xfc) << 13);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 142 to 158
	value = ((uint32_t)(input[17] & 0x03) << 30) |
			((uint32_t)input[18] << 22) |
			((uint32_t)(input[19] & 0xfe) << 14);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 159 to 175
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)input[21] << 15);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 176 to 192
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16) |
			((uint32_t)(input[24] & 0x80) << 8);
	output[10] = (double)(value >> 15);
}

static void unpack_11_17bit_unsigned_6off(const uint8_t * input, double * output) {
	// Unpack 11 values into output
	// Values are 17-bit unsigned
	// Skip 6 bits, read 187 bits of data.
	// Input must be at least 25 bytes long

	uint32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 57 to 73
	value = ((uint32_t)(input[7] & 0x7f) << 25) |
			((uint32_t)input[8] << 17) |
			((uint32_t)(input[9] & 0xc0) << 9);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 74 to 90
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)(input[11] & 0xe0) << 10);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 91 to 107
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)(input[13] & 0xf0) << 11);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 108 to 124
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)(input[15] & 0xf8) << 12);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 125 to 141
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0xfc) << 13);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 142 to 158
	value = ((uint32_t)(input[17] & 0x03) << 30) |
			((uint32_t)input[18] << 22) |
			((uint32_t)(input[19] & 0xfe) << 14);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 159 to 175
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)input[21] << 15);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 176 to 192
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16) |
			((uint32_t)(input[24] & 0x80) << 8);
	output[10] = (double)(value >> 15);
}

static void unpack_11_17bit_signed_7off(const uint8_t * input, double * output) {
	// Unpack 11 values into output
	// Values are 17-bit signed
	// Skip 7 bits, read 187 bits of data.
	// Input must be at least 25 bytes long

	int32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 58 to 74
	value = ((uint32_t)(input[7] & 0x3f) << 26) |
			((uint32_t)input[8] << 18) |
			((uint32_t)(input[9] & 0xe0) << 10);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 75 to 91
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)(input[11] & 0xf0) << 11);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 92 to 108
	value = ((uint32_t)(input[11] & 0x0f) << 28) |
			((uint32_t)input[12] << 20) |
			((uint32_t)(input[13] & 0xf8) << 12);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 109 to 125
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0xfc) << 13);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 126 to 142
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xfe) << 14);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 143 to 159
	value = ((uint32_t)(input[17] & 0x01) << 31) |
			((uint32_t)input[18] << 23) |
			((uint32_t)input[19] << 15);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 160 to 176
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16) |
			((uint32_t)(input[22] & 0x80) << 8);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 177 to 193
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0xc0) << 9);
	output[10] = (double)(value >> 15);
}

static void unpack_11_17bit_unsigned_7off(const uint8_t * input, double * output) {
	// Unpack 11 values into output
	// Values are 17-bit unsigned
	// Skip 7 bits, read 187 bits of data.
	// Input must be at least 25 bytes long

	uint32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 58 to 74
	value = ((uint32_t)(input[7] & 0x3f) << 26) |
			((uint32_t)input[8] << 18) |
			((uint32_t)(input[9] & 0xe0) << 10);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 75 to 91
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)(input[11] & 0xf0) << 11);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 92 to 108
	value = ((uint32_t)(input[11] & 0x0f) << 28) |
			((uint32_t)input[12] << 20) |
			((uint32_t)(input[13] & 0xf8) << 12);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 109 to 125
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0xfc) << 13);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 126 to 142
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xfe) << 14);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 143 to 159
	value = ((uint32_t)(input[17] & 0x01) << 31) |
			((uint32_t)input[18] << 23) |
			((uint32_t)input[19] << 15);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 160 to 176
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16) |
			((uint32_t)(input[22] & 0x80) << 8);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 177 to 193
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0xc0) << 9);
	output[10] = (double)(value >> 15);
}

static void unpack_12_17bit_signed_0off(const uint8_t * input, double * output) {
	// Unpack 12 values into output
	// Values are 17-bit signed
	// Skip 0 bits, read 204 bits of data.
	// Input must be at least 26 bytes long

	int32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 51 to 67
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xf0) << 11);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 68 to 84
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf8) << 12);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 85 to 101
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xfc) << 13);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 102 to 118
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfe) << 14);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 119 to 135
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)input[16] << 15);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 136 to 152
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)input[18] << 16) |
			((uint32_t)(input[19] & 0x80) << 8);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 153 to 169
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xc0) << 9);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 170 to 186
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xe0) << 10);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 187 to 203
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)input[24] << 19) |
			((uint32_t)(input[25] & 0xf0) << 11);
	output[11] = (double)(value >> 15);
}

static void unpack_12_17bit_unsigned_0off(const uint8_t * input, double * output) {
	// Unpack 12 values into output
	// Values are 17-bit unsigned
	// Skip 0 bits, read 204 bits of data.
	// Input must be at least 26 bytes long

	uint32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 51 to 67
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xf0) << 11);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 68 to 84
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf8) << 12);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 85 to 101
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xfc) << 13);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 102 to 118
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfe) << 14);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 119 to 135
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)input[16] << 15);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 136 to 152
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)input[18] << 16) |
			((uint32_t)(input[19] & 0x80) << 8);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 153 to 169
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xc0) << 9);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 170 to 186
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xe0) << 10);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 187 to 203
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)input[24] << 19) |
			((uint32_t)(input[25] & 0xf0) << 11);
	output[11] = (double)(value >> 15);
}

static void unpack_12_17bit_signed_1off(const uint8_t * input, double * output) {
	// Unpack 12 values into output
	// Values are 17-bit signed
	// Skip 1 bits, read 204 bits of data.
	// Input must be at least 26 bytes long

	int32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 52 to 68
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf8) << 12);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 69 to 85
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xfc) << 13);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 86 to 102
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfe) << 14);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 103 to 119
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 120 to 136
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)(input[17] & 0x80) << 8);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 137 to 153
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)input[18] << 17) |
			((uint32_t)(input[19] & 0xc0) << 9);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 154 to 170
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xe0) << 10);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 171 to 187
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)(input[23] & 0xf0) << 11);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 188 to 204
	value = ((uint32_t)(input[23] & 0x0f) << 28) |
			((uint32_t)input[24] << 20) |
			((uint32_t)(input[25] & 0xf8) << 12);
	output[11] = (double)(value >> 15);
}

static void unpack_12_17bit_unsigned_1off(const uint8_t * input, double * output) {
	// Unpack 12 values into output
	// Values are 17-bit unsigned
	// Skip 1 bits, read 204 bits of data.
	// Input must be at least 26 bytes long

	uint32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 52 to 68
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf8) << 12);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 69 to 85
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xfc) << 13);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 86 to 102
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfe) << 14);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 103 to 119
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 120 to 136
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)(input[17] & 0x80) << 8);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 137 to 153
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)input[18] << 17) |
			((uint32_t)(input[19] & 0xc0) << 9);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 154 to 170
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xe0) << 10);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 171 to 187
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)(input[23] & 0xf0) << 11);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 188 to 204
	value = ((uint32_t)(input[23] & 0x0f) << 28) |
			((uint32_t)input[24] << 20) |
			((uint32_t)(input[25] & 0xf8) << 12);
	output[11] = (double)(value >> 15);
}

static void unpack_12_17bit_signed_2off(const uint8_t * input, double * output) {
	// Unpack 12 values into output
	// Values are 17-bit signed
	// Skip 2 bits, read 204 bits of data.
	// Input must be at least 26 bytes long

	int32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 53 to 69
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xfc) << 13);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 70 to 86
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfe) << 14);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 87 to 103
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 104 to 120
	value = ((uint32_t)input[13] << 24) |
			((uint32_t)input[14] << 16) |
			((uint32_t)(input[15] & 0x80) << 8);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 121 to 137
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)(input[17] & 0xc0) << 9);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 138 to 154
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)input[18] << 18) |
			((uint32_t)(input[19] & 0xe0) << 10);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 155 to 171
	value = ((uint32_t)(input[19] & 0x1f) << 27) |
			((uint32_t)input[20] << 19) |
			((uint32_t)(input[21] & 0xf0) << 11);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 172 to 188
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)(input[23] & 0xf8) << 12);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 189 to 205
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)(input[25] & 0xfc) << 13);
	output[11] = (double)(value >> 15);
}

static void unpack_12_17bit_unsigned_2off(const uint8_t * input, double * output) {
	// Unpack 12 values into output
	// Values are 17-bit unsigned
	// Skip 2 bits, read 204 bits of data.
	// Input must be at least 26 bytes long

	uint32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 53 to 69
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xfc) << 13);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 70 to 86
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfe) << 14);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 87 to 103
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 104 to 120
	value = ((uint32_t)input[13] << 24) |
			((uint32_t)input[14] << 16) |
			((uint32_t)(input[15] & 0x80) << 8);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 121 to 137
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)(input[17] & 0xc0) << 9);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 138 to 154
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)input[18] << 18) |
			((uint32_t)(input[19] & 0xe0) << 10);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 155 to 171
	value = ((uint32_t)(input[19] & 0x1f) << 27) |
			((uint32_t)input[20] << 19) |
			((uint32_t)(input[21] & 0xf0) << 11);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 172 to 188
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)(input[23] & 0xf8) << 12);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 189 to 205
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)(input[25] & 0xfc) << 13);
	output[11] = (double)(value >> 15);
}

static void unpack_12_17bit_signed_3off(const uint8_t * input, double * output) {
	// Unpack 12 values into output
	// Values are 17-bit signed
	// Skip 3 bits, read 204 bits of data.
	// Input must be at least 26 bytes long

	int32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 54 to 70
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfe) << 14);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 71 to 87
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)input[10] << 15);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 88 to 104
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0x80) << 8);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 105 to 121
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xc0) << 9);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 122 to 138
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)(input[17] & 0xe0) << 10);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 139 to 155
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)input[18] << 19) |
			((uint32_t)(input[19] & 0xf0) << 11);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 156 to 172
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20) |
			((uint32_t)(input[21] & 0xf8) << 12);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 173 to 189
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0xfc) << 13);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 190 to 206
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)(input[25] & 0xfe) << 14);
	output[11] = (double)(value >> 15);
}

static void unpack_12_17bit_unsigned_3off(const uint8_t * input, double * output) {
	// Unpack 12 values into output
	// Values are 17-bit unsigned
	// Skip 3 bits, read 204 bits of data.
	// Input must be at least 26 bytes long

	uint32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 54 to 70
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfe) << 14);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 71 to 87
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)input[10] << 15);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 88 to 104
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0x80) << 8);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 105 to 121
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xc0) << 9);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 122 to 138
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)(input[17] & 0xe0) << 10);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 139 to 155
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)input[18] << 19) |
			((uint32_t)(input[19] & 0xf0) << 11);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 156 to 172
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20) |
			((uint32_t)(input[21] & 0xf8) << 12);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 173 to 189
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0xfc) << 13);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 190 to 206
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)(input[25] & 0xfe) << 14);
	output[11] = (double)(value >> 15);
}

static void unpack_12_17bit_signed_4off(const uint8_t * input, double * output) {
	// Unpack 12 values into output
	// Values are 17-bit signed
	// Skip 4 bits, read 204 bits of data.
	// Input must be at least 26 bytes long

	int32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 55 to 71
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 72 to 88
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)(input[11] & 0x80) << 8);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 89 to 105
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xc0) << 9);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 106 to 122
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xe0) << 10);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 123 to 139
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)(input[17] & 0xf0) << 11);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 140 to 156
	value = ((uint32_t)(input[17] & 0x0f) << 28) |
			((uint32_t)input[18] << 20) |
			((uint32_t)(input[19] & 0xf8) << 12);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 157 to 173
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0xfc) << 13);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 174 to 190
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xfe) << 14);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 191 to 207
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15);
	output[11] = (double)(value >> 15);
}

static void unpack_12_17bit_unsigned_4off(const uint8_t * input, double * output) {
	// Unpack 12 values into output
	// Values are 17-bit unsigned
	// Skip 4 bits, read 204 bits of data.
	// Input must be at least 26 bytes long

	uint32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 55 to 71
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 72 to 88
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)(input[11] & 0x80) << 8);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 89 to 105
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xc0) << 9);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 106 to 122
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xe0) << 10);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 123 to 139
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)(input[17] & 0xf0) << 11);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 140 to 156
	value = ((uint32_t)(input[17] & 0x0f) << 28) |
			((uint32_t)input[18] << 20) |
			((uint32_t)(input[19] & 0xf8) << 12);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 157 to 173
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0xfc) << 13);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 174 to 190
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xfe) << 14);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 191 to 207
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15);
	output[11] = (double)(value >> 15);
}

static void unpack_12_17bit_signed_5off(const uint8_t * input, double * output) {
	// Unpack 12 values into output
	// Values are 17-bit signed
	// Skip 5 bits, read 204 bits of data.
	// Input must be at least 27 bytes long

	int32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 56 to 72
	value = ((uint32_t)input[7] << 24) |
			((uint32_t)input[8] << 16) |
			((uint32_t)(input[9] & 0x80) << 8);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 73 to 89
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)(input[11] & 0xc0) << 9);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 90 to 106
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xe0) << 10);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 107 to 123
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)(input[15] & 0xf0) << 11);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 124 to 140
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)(input[17] & 0xf8) << 12);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 141 to 157
	value = ((uint32_t)(input[17] & 0x07) << 29) |
			((uint32_t)input[18] << 21) |
			((uint32_t)(input[19] & 0xfc) << 13);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 158 to 174
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xfe) << 14);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 175 to 191
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 192 to 208
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0x80) << 8);
	output[11] = (double)(value >> 15);
}

static void unpack_12_17bit_unsigned_5off(const uint8_t * input, double * output) {
	// Unpack 12 values into output
	// Values are 17-bit unsigned
	// Skip 5 bits, read 204 bits of data.
	// Input must be at least 27 bytes long

	uint32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 56 to 72
	value = ((uint32_t)input[7] << 24) |
			((uint32_t)input[8] << 16) |
			((uint32_t)(input[9] & 0x80) << 8);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 73 to 89
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)(input[11] & 0xc0) << 9);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 90 to 106
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xe0) << 10);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 107 to 123
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)(input[15] & 0xf0) << 11);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 124 to 140
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)(input[17] & 0xf8) << 12);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 141 to 157
	value = ((uint32_t)(input[17] & 0x07) << 29) |
			((uint32_t)input[18] << 21) |
			((uint32_t)(input[19] & 0xfc) << 13);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 158 to 174
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xfe) << 14);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 175 to 191
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 192 to 208
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0x80) << 8);
	output[11] = (double)(value >> 15);
}

static void unpack_12_17bit_signed_6off(const uint8_t * input, double * output) {
	// Unpack 12 values into output
	// Values are 17-bit signed
	// Skip 6 bits, read 204 bits of data.
	// Input must be at least 27 bytes long

	int32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 57 to 73
	value = ((uint32_t)(input[7] & 0x7f) << 25) |
			((uint32_t)input[8] << 17) |
			((uint32_t)(input[9] & 0xc0) << 9);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 74 to 90
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)(input[11] & 0xe0) << 10);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 91 to 107
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)(input[13] & 0xf0) << 11);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 108 to 124
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)(input[15] & 0xf8) << 12);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 125 to 141
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0xfc) << 13);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 142 to 158
	value = ((uint32_t)(input[17] & 0x03) << 30) |
			((uint32_t)input[18] << 22) |
			((uint32_t)(input[19] & 0xfe) << 14);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 159 to 175
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)input[21] << 15);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 176 to 192
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16) |
			((uint32_t)(input[24] & 0x80) << 8);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 193 to 209
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xc0) << 9);
	output[11] = (double)(value >> 15);
}

static void unpack_12_17bit_unsigned_6off(const uint8_t * input, double * output) {
	// Unpack 12 values into output
	// Values are 17-bit unsigned
	// Skip 6 bits, read 204 bits of data.
	// Input must be at least 27 bytes long

	uint32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 57 to 73
	value = ((uint32_t)(input[7] & 0x7f) << 25) |
			((uint32_t)input[8] << 17) |
			((uint32_t)(input[9] & 0xc0) << 9);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 74 to 90
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)(input[11] & 0xe0) << 10);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 91 to 107
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)(input[13] & 0xf0) << 11);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 108 to 124
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)(input[15] & 0xf8) << 12);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 125 to 141
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0xfc) << 13);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 142 to 158
	value = ((uint32_t)(input[17] & 0x03) << 30) |
			((uint32_t)input[18] << 22) |
			((uint32_t)(input[19] & 0xfe) << 14);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 159 to 175
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)input[21] << 15);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 176 to 192
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16) |
			((uint32_t)(input[24] & 0x80) << 8);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 193 to 209
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xc0) << 9);
	output[11] = (double)(value >> 15);
}

static void unpack_12_17bit_signed_7off(const uint8_t * input, double * output) {
	// Unpack 12 values into output
	// Values are 17-bit signed
	// Skip 7 bits, read 204 bits of data.
	// Input must be at least 27 bytes long

	int32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 58 to 74
	value = ((uint32_t)(input[7] & 0x3f) << 26) |
			((uint32_t)input[8] << 18) |
			((uint32_t)(input[9] & 0xe0) << 10);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 75 to 91
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)(input[11] & 0xf0) << 11);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 92 to 108
	value = ((uint32_t)(input[11] & 0x0f) << 28) |
			((uint32_t)input[12] << 20) |
			((uint32_t)(input[13] & 0xf8) << 12);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 109 to 125
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0xfc) << 13);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 126 to 142
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xfe) << 14);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 143 to 159
	value = ((uint32_t)(input[17] & 0x01) << 31) |
			((uint32_t)input[18] << 23) |
			((uint32_t)input[19] << 15);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 160 to 176
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16) |
			((uint32_t)(input[22] & 0x80) << 8);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 177 to 193
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0xc0) << 9);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 194 to 210
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xe0) << 10);
	output[11] = (double)(value >> 15);
}

static void unpack_12_17bit_unsigned_7off(const uint8_t * input, double * output) {
	// Unpack 12 values into output
	// Values are 17-bit unsigned
	// Skip 7 bits, read 204 bits of data.
	// Input must be at least 27 bytes long

	uint32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 58 to 74
	value = ((uint32_t)(input[7] & 0x3f) << 26) |
			((uint32_t)input[8] << 18) |
			((uint32_t)(input[9] & 0xe0) << 10);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 75 to 91
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)(input[11] & 0xf0) << 11);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 92 to 108
	value = ((uint32_t)(input[11] & 0x0f) << 28) |
			((uint32_t)input[12] << 20) |
			((uint32_t)(input[13] & 0xf8) << 12);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 109 to 125
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0xfc) << 13);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 126 to 142
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xfe) << 14);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 143 to 159
	value = ((uint32_t)(input[17] & 0x01) << 31) |
			((uint32_t)input[18] << 23) |
			((uint32_t)input[19] << 15);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 160 to 176
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16) |
			((uint32_t)(input[22] & 0x80) << 8);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 177 to 193
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0xc0) << 9);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 194 to 210
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xe0) << 10);
	output[11] = (double)(value >> 15);
}

static void unpack_13_17bit_signed_0off(const uint8_t * input, double * output) {
	// Unpack 13 values into output
	// Values are 17-bit signed
	// Skip 0 bits, read 221 bits of data.
	// Input must be at least 28 bytes long

	int32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 51 to 67
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xf0) << 11);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 68 to 84
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf8) << 12);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 85 to 101
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xfc) << 13);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 102 to 118
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfe) << 14);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 119 to 135
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)input[16] << 15);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 136 to 152
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)input[18] << 16) |
			((uint32_t)(input[19] & 0x80) << 8);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 153 to 169
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xc0) << 9);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 170 to 186
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xe0) << 10);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 187 to 203
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)input[24] << 19) |
			((uint32_t)(input[25] & 0xf0) << 11);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 204 to 220
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20) |
			((uint32_t)(input[27] & 0xf8) << 12);
	output[12] = (double)(value >> 15);
}

static void unpack_13_17bit_unsigned_0off(const uint8_t * input, double * output) {
	// Unpack 13 values into output
	// Values are 17-bit unsigned
	// Skip 0 bits, read 221 bits of data.
	// Input must be at least 28 bytes long

	uint32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 51 to 67
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xf0) << 11);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 68 to 84
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf8) << 12);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 85 to 101
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xfc) << 13);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 102 to 118
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfe) << 14);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 119 to 135
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)input[16] << 15);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 136 to 152
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)input[18] << 16) |
			((uint32_t)(input[19] & 0x80) << 8);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 153 to 169
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xc0) << 9);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 170 to 186
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xe0) << 10);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 187 to 203
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)input[24] << 19) |
			((uint32_t)(input[25] & 0xf0) << 11);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 204 to 220
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20) |
			((uint32_t)(input[27] & 0xf8) << 12);
	output[12] = (double)(value >> 15);
}

static void unpack_13_17bit_signed_1off(const uint8_t * input, double * output) {
	// Unpack 13 values into output
	// Values are 17-bit signed
	// Skip 1 bits, read 221 bits of data.
	// Input must be at least 28 bytes long

	int32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 52 to 68
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf8) << 12);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 69 to 85
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xfc) << 13);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 86 to 102
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfe) << 14);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 103 to 119
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 120 to 136
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)(input[17] & 0x80) << 8);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 137 to 153
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)input[18] << 17) |
			((uint32_t)(input[19] & 0xc0) << 9);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 154 to 170
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xe0) << 10);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 171 to 187
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)(input[23] & 0xf0) << 11);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 188 to 204
	value = ((uint32_t)(input[23] & 0x0f) << 28) |
			((uint32_t)input[24] << 20) |
			((uint32_t)(input[25] & 0xf8) << 12);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 205 to 221
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0xfc) << 13);
	output[12] = (double)(value >> 15);
}

static void unpack_13_17bit_unsigned_1off(const uint8_t * input, double * output) {
	// Unpack 13 values into output
	// Values are 17-bit unsigned
	// Skip 1 bits, read 221 bits of data.
	// Input must be at least 28 bytes long

	uint32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 52 to 68
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf8) << 12);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 69 to 85
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xfc) << 13);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 86 to 102
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfe) << 14);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 103 to 119
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 120 to 136
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)(input[17] & 0x80) << 8);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 137 to 153
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)input[18] << 17) |
			((uint32_t)(input[19] & 0xc0) << 9);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 154 to 170
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xe0) << 10);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 171 to 187
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)(input[23] & 0xf0) << 11);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 188 to 204
	value = ((uint32_t)(input[23] & 0x0f) << 28) |
			((uint32_t)input[24] << 20) |
			((uint32_t)(input[25] & 0xf8) << 12);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 205 to 221
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0xfc) << 13);
	output[12] = (double)(value >> 15);
}

static void unpack_13_17bit_signed_2off(const uint8_t * input, double * output) {
	// Unpack 13 values into output
	// Values are 17-bit signed
	// Skip 2 bits, read 221 bits of data.
	// Input must be at least 28 bytes long

	int32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 53 to 69
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xfc) << 13);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 70 to 86
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfe) << 14);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 87 to 103
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 104 to 120
	value = ((uint32_t)input[13] << 24) |
			((uint32_t)input[14] << 16) |
			((uint32_t)(input[15] & 0x80) << 8);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 121 to 137
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)(input[17] & 0xc0) << 9);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 138 to 154
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)input[18] << 18) |
			((uint32_t)(input[19] & 0xe0) << 10);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 155 to 171
	value = ((uint32_t)(input[19] & 0x1f) << 27) |
			((uint32_t)input[20] << 19) |
			((uint32_t)(input[21] & 0xf0) << 11);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 172 to 188
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)(input[23] & 0xf8) << 12);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 189 to 205
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)(input[25] & 0xfc) << 13);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 206 to 222
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xfe) << 14);
	output[12] = (double)(value >> 15);
}

static void unpack_13_17bit_unsigned_2off(const uint8_t * input, double * output) {
	// Unpack 13 values into output
	// Values are 17-bit unsigned
	// Skip 2 bits, read 221 bits of data.
	// Input must be at least 28 bytes long

	uint32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 53 to 69
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xfc) << 13);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 70 to 86
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfe) << 14);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 87 to 103
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 104 to 120
	value = ((uint32_t)input[13] << 24) |
			((uint32_t)input[14] << 16) |
			((uint32_t)(input[15] & 0x80) << 8);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 121 to 137
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)(input[17] & 0xc0) << 9);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 138 to 154
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)input[18] << 18) |
			((uint32_t)(input[19] & 0xe0) << 10);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 155 to 171
	value = ((uint32_t)(input[19] & 0x1f) << 27) |
			((uint32_t)input[20] << 19) |
			((uint32_t)(input[21] & 0xf0) << 11);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 172 to 188
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)(input[23] & 0xf8) << 12);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 189 to 205
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)(input[25] & 0xfc) << 13);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 206 to 222
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xfe) << 14);
	output[12] = (double)(value >> 15);
}

static void unpack_13_17bit_signed_3off(const uint8_t * input, double * output) {
	// Unpack 13 values into output
	// Values are 17-bit signed
	// Skip 3 bits, read 221 bits of data.
	// Input must be at least 28 bytes long

	int32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 54 to 70
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfe) << 14);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 71 to 87
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)input[10] << 15);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 88 to 104
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0x80) << 8);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 105 to 121
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xc0) << 9);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 122 to 138
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)(input[17] & 0xe0) << 10);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 139 to 155
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)input[18] << 19) |
			((uint32_t)(input[19] & 0xf0) << 11);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 156 to 172
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20) |
			((uint32_t)(input[21] & 0xf8) << 12);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 173 to 189
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0xfc) << 13);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 190 to 206
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)(input[25] & 0xfe) << 14);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 207 to 223
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)input[27] << 15);
	output[12] = (double)(value >> 15);
}

static void unpack_13_17bit_unsigned_3off(const uint8_t * input, double * output) {
	// Unpack 13 values into output
	// Values are 17-bit unsigned
	// Skip 3 bits, read 221 bits of data.
	// Input must be at least 28 bytes long

	uint32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 54 to 70
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfe) << 14);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 71 to 87
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)input[10] << 15);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 88 to 104
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0x80) << 8);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 105 to 121
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xc0) << 9);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 122 to 138
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)(input[17] & 0xe0) << 10);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 139 to 155
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)input[18] << 19) |
			((uint32_t)(input[19] & 0xf0) << 11);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 156 to 172
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20) |
			((uint32_t)(input[21] & 0xf8) << 12);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 173 to 189
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0xfc) << 13);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 190 to 206
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)(input[25] & 0xfe) << 14);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 207 to 223
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)input[27] << 15);
	output[12] = (double)(value >> 15);
}

static void unpack_13_17bit_signed_4off(const uint8_t * input, double * output) {
	// Unpack 13 values into output
	// Values are 17-bit signed
	// Skip 4 bits, read 221 bits of data.
	// Input must be at least 29 bytes long

	int32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 55 to 71
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 72 to 88
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)(input[11] & 0x80) << 8);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 89 to 105
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xc0) << 9);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 106 to 122
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xe0) << 10);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 123 to 139
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)(input[17] & 0xf0) << 11);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 140 to 156
	value = ((uint32_t)(input[17] & 0x0f) << 28) |
			((uint32_t)input[18] << 20) |
			((uint32_t)(input[19] & 0xf8) << 12);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 157 to 173
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0xfc) << 13);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 174 to 190
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xfe) << 14);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 191 to 207
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 208 to 224
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16) |
			((uint32_t)(input[28] & 0x80) << 8);
	output[12] = (double)(value >> 15);
}

static void unpack_13_17bit_unsigned_4off(const uint8_t * input, double * output) {
	// Unpack 13 values into output
	// Values are 17-bit unsigned
	// Skip 4 bits, read 221 bits of data.
	// Input must be at least 29 bytes long

	uint32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 55 to 71
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 72 to 88
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)(input[11] & 0x80) << 8);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 89 to 105
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xc0) << 9);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 106 to 122
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xe0) << 10);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 123 to 139
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)(input[17] & 0xf0) << 11);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 140 to 156
	value = ((uint32_t)(input[17] & 0x0f) << 28) |
			((uint32_t)input[18] << 20) |
			((uint32_t)(input[19] & 0xf8) << 12);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 157 to 173
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0xfc) << 13);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 174 to 190
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xfe) << 14);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 191 to 207
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 208 to 224
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16) |
			((uint32_t)(input[28] & 0x80) << 8);
	output[12] = (double)(value >> 15);
}

static void unpack_13_17bit_signed_5off(const uint8_t * input, double * output) {
	// Unpack 13 values into output
	// Values are 17-bit signed
	// Skip 5 bits, read 221 bits of data.
	// Input must be at least 29 bytes long

	int32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 56 to 72
	value = ((uint32_t)input[7] << 24) |
			((uint32_t)input[8] << 16) |
			((uint32_t)(input[9] & 0x80) << 8);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 73 to 89
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)(input[11] & 0xc0) << 9);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 90 to 106
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xe0) << 10);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 107 to 123
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)(input[15] & 0xf0) << 11);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 124 to 140
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)(input[17] & 0xf8) << 12);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 141 to 157
	value = ((uint32_t)(input[17] & 0x07) << 29) |
			((uint32_t)input[18] << 21) |
			((uint32_t)(input[19] & 0xfc) << 13);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 158 to 174
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xfe) << 14);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 175 to 191
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 192 to 208
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0x80) << 8);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 209 to 225
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0xc0) << 9);
	output[12] = (double)(value >> 15);
}

static void unpack_13_17bit_unsigned_5off(const uint8_t * input, double * output) {
	// Unpack 13 values into output
	// Values are 17-bit unsigned
	// Skip 5 bits, read 221 bits of data.
	// Input must be at least 29 bytes long

	uint32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 56 to 72
	value = ((uint32_t)input[7] << 24) |
			((uint32_t)input[8] << 16) |
			((uint32_t)(input[9] & 0x80) << 8);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 73 to 89
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)(input[11] & 0xc0) << 9);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 90 to 106
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xe0) << 10);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 107 to 123
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)(input[15] & 0xf0) << 11);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 124 to 140
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)(input[17] & 0xf8) << 12);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 141 to 157
	value = ((uint32_t)(input[17] & 0x07) << 29) |
			((uint32_t)input[18] << 21) |
			((uint32_t)(input[19] & 0xfc) << 13);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 158 to 174
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xfe) << 14);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 175 to 191
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 192 to 208
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0x80) << 8);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 209 to 225
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0xc0) << 9);
	output[12] = (double)(value >> 15);
}

static void unpack_13_17bit_signed_6off(const uint8_t * input, double * output) {
	// Unpack 13 values into output
	// Values are 17-bit signed
	// Skip 6 bits, read 221 bits of data.
	// Input must be at least 29 bytes long

	int32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 57 to 73
	value = ((uint32_t)(input[7] & 0x7f) << 25) |
			((uint32_t)input[8] << 17) |
			((uint32_t)(input[9] & 0xc0) << 9);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 74 to 90
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)(input[11] & 0xe0) << 10);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 91 to 107
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)(input[13] & 0xf0) << 11);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 108 to 124
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)(input[15] & 0xf8) << 12);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 125 to 141
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0xfc) << 13);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 142 to 158
	value = ((uint32_t)(input[17] & 0x03) << 30) |
			((uint32_t)input[18] << 22) |
			((uint32_t)(input[19] & 0xfe) << 14);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 159 to 175
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)input[21] << 15);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 176 to 192
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16) |
			((uint32_t)(input[24] & 0x80) << 8);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 193 to 209
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xc0) << 9);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 210 to 226
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xe0) << 10);
	output[12] = (double)(value >> 15);
}

static void unpack_13_17bit_unsigned_6off(const uint8_t * input, double * output) {
	// Unpack 13 values into output
	// Values are 17-bit unsigned
	// Skip 6 bits, read 221 bits of data.
	// Input must be at least 29 bytes long

	uint32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 57 to 73
	value = ((uint32_t)(input[7] & 0x7f) << 25) |
			((uint32_t)input[8] << 17) |
			((uint32_t)(input[9] & 0xc0) << 9);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 74 to 90
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)(input[11] & 0xe0) << 10);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 91 to 107
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)(input[13] & 0xf0) << 11);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 108 to 124
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)(input[15] & 0xf8) << 12);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 125 to 141
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0xfc) << 13);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 142 to 158
	value = ((uint32_t)(input[17] & 0x03) << 30) |
			((uint32_t)input[18] << 22) |
			((uint32_t)(input[19] & 0xfe) << 14);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 159 to 175
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)input[21] << 15);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 176 to 192
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16) |
			((uint32_t)(input[24] & 0x80) << 8);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 193 to 209
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xc0) << 9);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 210 to 226
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xe0) << 10);
	output[12] = (double)(value >> 15);
}

static void unpack_13_17bit_signed_7off(const uint8_t * input, double * output) {
	// Unpack 13 values into output
	// Values are 17-bit signed
	// Skip 7 bits, read 221 bits of data.
	// Input must be at least 29 bytes long

	int32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 58 to 74
	value = ((uint32_t)(input[7] & 0x3f) << 26) |
			((uint32_t)input[8] << 18) |
			((uint32_t)(input[9] & 0xe0) << 10);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 75 to 91
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)(input[11] & 0xf0) << 11);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 92 to 108
	value = ((uint32_t)(input[11] & 0x0f) << 28) |
			((uint32_t)input[12] << 20) |
			((uint32_t)(input[13] & 0xf8) << 12);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 109 to 125
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0xfc) << 13);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 126 to 142
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xfe) << 14);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 143 to 159
	value = ((uint32_t)(input[17] & 0x01) << 31) |
			((uint32_t)input[18] << 23) |
			((uint32_t)input[19] << 15);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 160 to 176
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16) |
			((uint32_t)(input[22] & 0x80) << 8);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 177 to 193
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0xc0) << 9);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 194 to 210
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xe0) << 10);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 211 to 227
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xf0) << 11);
	output[12] = (double)(value >> 15);
}

static void unpack_13_17bit_unsigned_7off(const uint8_t * input, double * output) {
	// Unpack 13 values into output
	// Values are 17-bit unsigned
	// Skip 7 bits, read 221 bits of data.
	// Input must be at least 29 bytes long

	uint32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 58 to 74
	value = ((uint32_t)(input[7] & 0x3f) << 26) |
			((uint32_t)input[8] << 18) |
			((uint32_t)(input[9] & 0xe0) << 10);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 75 to 91
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)(input[11] & 0xf0) << 11);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 92 to 108
	value = ((uint32_t)(input[11] & 0x0f) << 28) |
			((uint32_t)input[12] << 20) |
			((uint32_t)(input[13] & 0xf8) << 12);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 109 to 125
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0xfc) << 13);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 126 to 142
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xfe) << 14);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 143 to 159
	value = ((uint32_t)(input[17] & 0x01) << 31) |
			((uint32_t)input[18] << 23) |
			((uint32_t)input[19] << 15);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 160 to 176
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16) |
			((uint32_t)(input[22] & 0x80) << 8);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 177 to 193
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0xc0) << 9);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 194 to 210
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xe0) << 10);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 211 to 227
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xf0) << 11);
	output[12] = (double)(value >> 15);
}

static void unpack_14_17bit_signed_0off(const uint8_t * input, double * output) {
	// Unpack 14 values into output
	// Values are 17-bit signed
	// Skip 0 bits, read 238 bits of data.
	// Input must be at least 30 bytes long

	int32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 51 to 67
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xf0) << 11);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 68 to 84
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf8) << 12);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 85 to 101
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xfc) << 13);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 102 to 118
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfe) << 14);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 119 to 135
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)input[16] << 15);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 136 to 152
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)input[18] << 16) |
			((uint32_t)(input[19] & 0x80) << 8);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 153 to 169
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xc0) << 9);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 170 to 186
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xe0) << 10);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 187 to 203
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)input[24] << 19) |
			((uint32_t)(input[25] & 0xf0) << 11);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 204 to 220
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20) |
			((uint32_t)(input[27] & 0xf8) << 12);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 221 to 237
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0xfc) << 13);
	output[13] = (double)(value >> 15);
}

static void unpack_14_17bit_unsigned_0off(const uint8_t * input, double * output) {
	// Unpack 14 values into output
	// Values are 17-bit unsigned
	// Skip 0 bits, read 238 bits of data.
	// Input must be at least 30 bytes long

	uint32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 51 to 67
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xf0) << 11);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 68 to 84
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf8) << 12);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 85 to 101
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xfc) << 13);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 102 to 118
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfe) << 14);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 119 to 135
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)input[16] << 15);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 136 to 152
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)input[18] << 16) |
			((uint32_t)(input[19] & 0x80) << 8);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 153 to 169
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xc0) << 9);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 170 to 186
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xe0) << 10);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 187 to 203
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)input[24] << 19) |
			((uint32_t)(input[25] & 0xf0) << 11);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 204 to 220
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20) |
			((uint32_t)(input[27] & 0xf8) << 12);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 221 to 237
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0xfc) << 13);
	output[13] = (double)(value >> 15);
}

static void unpack_14_17bit_signed_1off(const uint8_t * input, double * output) {
	// Unpack 14 values into output
	// Values are 17-bit signed
	// Skip 1 bits, read 238 bits of data.
	// Input must be at least 30 bytes long

	int32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 52 to 68
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf8) << 12);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 69 to 85
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xfc) << 13);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 86 to 102
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfe) << 14);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 103 to 119
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 120 to 136
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)(input[17] & 0x80) << 8);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 137 to 153
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)input[18] << 17) |
			((uint32_t)(input[19] & 0xc0) << 9);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 154 to 170
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xe0) << 10);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 171 to 187
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)(input[23] & 0xf0) << 11);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 188 to 204
	value = ((uint32_t)(input[23] & 0x0f) << 28) |
			((uint32_t)input[24] << 20) |
			((uint32_t)(input[25] & 0xf8) << 12);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 205 to 221
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0xfc) << 13);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 222 to 238
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xfe) << 14);
	output[13] = (double)(value >> 15);
}

static void unpack_14_17bit_unsigned_1off(const uint8_t * input, double * output) {
	// Unpack 14 values into output
	// Values are 17-bit unsigned
	// Skip 1 bits, read 238 bits of data.
	// Input must be at least 30 bytes long

	uint32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 52 to 68
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf8) << 12);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 69 to 85
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xfc) << 13);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 86 to 102
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfe) << 14);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 103 to 119
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 120 to 136
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)(input[17] & 0x80) << 8);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 137 to 153
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)input[18] << 17) |
			((uint32_t)(input[19] & 0xc0) << 9);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 154 to 170
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xe0) << 10);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 171 to 187
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)(input[23] & 0xf0) << 11);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 188 to 204
	value = ((uint32_t)(input[23] & 0x0f) << 28) |
			((uint32_t)input[24] << 20) |
			((uint32_t)(input[25] & 0xf8) << 12);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 205 to 221
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0xfc) << 13);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 222 to 238
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xfe) << 14);
	output[13] = (double)(value >> 15);
}

static void unpack_14_17bit_signed_2off(const uint8_t * input, double * output) {
	// Unpack 14 values into output
	// Values are 17-bit signed
	// Skip 2 bits, read 238 bits of data.
	// Input must be at least 30 bytes long

	int32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 53 to 69
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xfc) << 13);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 70 to 86
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfe) << 14);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 87 to 103
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 104 to 120
	value = ((uint32_t)input[13] << 24) |
			((uint32_t)input[14] << 16) |
			((uint32_t)(input[15] & 0x80) << 8);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 121 to 137
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)(input[17] & 0xc0) << 9);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 138 to 154
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)input[18] << 18) |
			((uint32_t)(input[19] & 0xe0) << 10);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 155 to 171
	value = ((uint32_t)(input[19] & 0x1f) << 27) |
			((uint32_t)input[20] << 19) |
			((uint32_t)(input[21] & 0xf0) << 11);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 172 to 188
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)(input[23] & 0xf8) << 12);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 189 to 205
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)(input[25] & 0xfc) << 13);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 206 to 222
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xfe) << 14);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 223 to 239
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15);
	output[13] = (double)(value >> 15);
}

static void unpack_14_17bit_unsigned_2off(const uint8_t * input, double * output) {
	// Unpack 14 values into output
	// Values are 17-bit unsigned
	// Skip 2 bits, read 238 bits of data.
	// Input must be at least 30 bytes long

	uint32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 53 to 69
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xfc) << 13);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 70 to 86
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfe) << 14);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 87 to 103
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 104 to 120
	value = ((uint32_t)input[13] << 24) |
			((uint32_t)input[14] << 16) |
			((uint32_t)(input[15] & 0x80) << 8);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 121 to 137
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)(input[17] & 0xc0) << 9);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 138 to 154
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)input[18] << 18) |
			((uint32_t)(input[19] & 0xe0) << 10);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 155 to 171
	value = ((uint32_t)(input[19] & 0x1f) << 27) |
			((uint32_t)input[20] << 19) |
			((uint32_t)(input[21] & 0xf0) << 11);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 172 to 188
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)(input[23] & 0xf8) << 12);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 189 to 205
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)(input[25] & 0xfc) << 13);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 206 to 222
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xfe) << 14);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 223 to 239
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15);
	output[13] = (double)(value >> 15);
}

static void unpack_14_17bit_signed_3off(const uint8_t * input, double * output) {
	// Unpack 14 values into output
	// Values are 17-bit signed
	// Skip 3 bits, read 238 bits of data.
	// Input must be at least 31 bytes long

	int32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 54 to 70
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfe) << 14);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 71 to 87
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)input[10] << 15);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 88 to 104
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0x80) << 8);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 105 to 121
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xc0) << 9);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 122 to 138
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)(input[17] & 0xe0) << 10);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 139 to 155
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)input[18] << 19) |
			((uint32_t)(input[19] & 0xf0) << 11);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 156 to 172
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20) |
			((uint32_t)(input[21] & 0xf8) << 12);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 173 to 189
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0xfc) << 13);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 190 to 206
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)(input[25] & 0xfe) << 14);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 207 to 223
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)input[27] << 15);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 224 to 240
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16) |
			((uint32_t)(input[30] & 0x80) << 8);
	output[13] = (double)(value >> 15);
}

static void unpack_14_17bit_unsigned_3off(const uint8_t * input, double * output) {
	// Unpack 14 values into output
	// Values are 17-bit unsigned
	// Skip 3 bits, read 238 bits of data.
	// Input must be at least 31 bytes long

	uint32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 54 to 70
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfe) << 14);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 71 to 87
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)input[10] << 15);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 88 to 104
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0x80) << 8);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 105 to 121
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xc0) << 9);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 122 to 138
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)(input[17] & 0xe0) << 10);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 139 to 155
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)input[18] << 19) |
			((uint32_t)(input[19] & 0xf0) << 11);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 156 to 172
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20) |
			((uint32_t)(input[21] & 0xf8) << 12);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 173 to 189
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0xfc) << 13);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 190 to 206
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)(input[25] & 0xfe) << 14);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 207 to 223
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)input[27] << 15);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 224 to 240
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16) |
			((uint32_t)(input[30] & 0x80) << 8);
	output[13] = (double)(value >> 15);
}

static void unpack_14_17bit_signed_4off(const uint8_t * input, double * output) {
	// Unpack 14 values into output
	// Values are 17-bit signed
	// Skip 4 bits, read 238 bits of data.
	// Input must be at least 31 bytes long

	int32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 55 to 71
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 72 to 88
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)(input[11] & 0x80) << 8);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 89 to 105
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xc0) << 9);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 106 to 122
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xe0) << 10);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 123 to 139
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)(input[17] & 0xf0) << 11);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 140 to 156
	value = ((uint32_t)(input[17] & 0x0f) << 28) |
			((uint32_t)input[18] << 20) |
			((uint32_t)(input[19] & 0xf8) << 12);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 157 to 173
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0xfc) << 13);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 174 to 190
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xfe) << 14);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 191 to 207
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 208 to 224
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16) |
			((uint32_t)(input[28] & 0x80) << 8);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 225 to 241
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0xc0) << 9);
	output[13] = (double)(value >> 15);
}

static void unpack_14_17bit_unsigned_4off(const uint8_t * input, double * output) {
	// Unpack 14 values into output
	// Values are 17-bit unsigned
	// Skip 4 bits, read 238 bits of data.
	// Input must be at least 31 bytes long

	uint32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 55 to 71
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 72 to 88
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)(input[11] & 0x80) << 8);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 89 to 105
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xc0) << 9);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 106 to 122
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xe0) << 10);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 123 to 139
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)(input[17] & 0xf0) << 11);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 140 to 156
	value = ((uint32_t)(input[17] & 0x0f) << 28) |
			((uint32_t)input[18] << 20) |
			((uint32_t)(input[19] & 0xf8) << 12);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 157 to 173
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0xfc) << 13);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 174 to 190
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xfe) << 14);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 191 to 207
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 208 to 224
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16) |
			((uint32_t)(input[28] & 0x80) << 8);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 225 to 241
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0xc0) << 9);
	output[13] = (double)(value >> 15);
}

static void unpack_14_17bit_signed_5off(const uint8_t * input, double * output) {
	// Unpack 14 values into output
	// Values are 17-bit signed
	// Skip 5 bits, read 238 bits of data.
	// Input must be at least 31 bytes long

	int32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 56 to 72
	value = ((uint32_t)input[7] << 24) |
			((uint32_t)input[8] << 16) |
			((uint32_t)(input[9] & 0x80) << 8);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 73 to 89
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)(input[11] & 0xc0) << 9);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 90 to 106
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xe0) << 10);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 107 to 123
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)(input[15] & 0xf0) << 11);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 124 to 140
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)(input[17] & 0xf8) << 12);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 141 to 157
	value = ((uint32_t)(input[17] & 0x07) << 29) |
			((uint32_t)input[18] << 21) |
			((uint32_t)(input[19] & 0xfc) << 13);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 158 to 174
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xfe) << 14);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 175 to 191
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 192 to 208
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0x80) << 8);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 209 to 225
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0xc0) << 9);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 226 to 242
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xe0) << 10);
	output[13] = (double)(value >> 15);
}

static void unpack_14_17bit_unsigned_5off(const uint8_t * input, double * output) {
	// Unpack 14 values into output
	// Values are 17-bit unsigned
	// Skip 5 bits, read 238 bits of data.
	// Input must be at least 31 bytes long

	uint32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 56 to 72
	value = ((uint32_t)input[7] << 24) |
			((uint32_t)input[8] << 16) |
			((uint32_t)(input[9] & 0x80) << 8);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 73 to 89
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)(input[11] & 0xc0) << 9);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 90 to 106
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xe0) << 10);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 107 to 123
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)(input[15] & 0xf0) << 11);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 124 to 140
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)(input[17] & 0xf8) << 12);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 141 to 157
	value = ((uint32_t)(input[17] & 0x07) << 29) |
			((uint32_t)input[18] << 21) |
			((uint32_t)(input[19] & 0xfc) << 13);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 158 to 174
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xfe) << 14);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 175 to 191
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 192 to 208
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0x80) << 8);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 209 to 225
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0xc0) << 9);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 226 to 242
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xe0) << 10);
	output[13] = (double)(value >> 15);
}

static void unpack_14_17bit_signed_6off(const uint8_t * input, double * output) {
	// Unpack 14 values into output
	// Values are 17-bit signed
	// Skip 6 bits, read 238 bits of data.
	// Input must be at least 31 bytes long

	int32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 57 to 73
	value = ((uint32_t)(input[7] & 0x7f) << 25) |
			((uint32_t)input[8] << 17) |
			((uint32_t)(input[9] & 0xc0) << 9);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 74 to 90
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)(input[11] & 0xe0) << 10);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 91 to 107
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)(input[13] & 0xf0) << 11);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 108 to 124
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)(input[15] & 0xf8) << 12);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 125 to 141
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0xfc) << 13);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 142 to 158
	value = ((uint32_t)(input[17] & 0x03) << 30) |
			((uint32_t)input[18] << 22) |
			((uint32_t)(input[19] & 0xfe) << 14);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 159 to 175
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)input[21] << 15);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 176 to 192
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16) |
			((uint32_t)(input[24] & 0x80) << 8);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 193 to 209
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xc0) << 9);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 210 to 226
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xe0) << 10);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 227 to 243
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xf0) << 11);
	output[13] = (double)(value >> 15);
}

static void unpack_14_17bit_unsigned_6off(const uint8_t * input, double * output) {
	// Unpack 14 values into output
	// Values are 17-bit unsigned
	// Skip 6 bits, read 238 bits of data.
	// Input must be at least 31 bytes long

	uint32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 57 to 73
	value = ((uint32_t)(input[7] & 0x7f) << 25) |
			((uint32_t)input[8] << 17) |
			((uint32_t)(input[9] & 0xc0) << 9);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 74 to 90
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)(input[11] & 0xe0) << 10);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 91 to 107
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)(input[13] & 0xf0) << 11);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 108 to 124
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)(input[15] & 0xf8) << 12);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 125 to 141
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0xfc) << 13);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 142 to 158
	value = ((uint32_t)(input[17] & 0x03) << 30) |
			((uint32_t)input[18] << 22) |
			((uint32_t)(input[19] & 0xfe) << 14);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 159 to 175
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)input[21] << 15);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 176 to 192
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16) |
			((uint32_t)(input[24] & 0x80) << 8);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 193 to 209
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xc0) << 9);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 210 to 226
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xe0) << 10);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 227 to 243
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xf0) << 11);
	output[13] = (double)(value >> 15);
}

static void unpack_14_17bit_signed_7off(const uint8_t * input, double * output) {
	// Unpack 14 values into output
	// Values are 17-bit signed
	// Skip 7 bits, read 238 bits of data.
	// Input must be at least 31 bytes long

	int32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 58 to 74
	value = ((uint32_t)(input[7] & 0x3f) << 26) |
			((uint32_t)input[8] << 18) |
			((uint32_t)(input[9] & 0xe0) << 10);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 75 to 91
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)(input[11] & 0xf0) << 11);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 92 to 108
	value = ((uint32_t)(input[11] & 0x0f) << 28) |
			((uint32_t)input[12] << 20) |
			((uint32_t)(input[13] & 0xf8) << 12);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 109 to 125
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0xfc) << 13);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 126 to 142
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xfe) << 14);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 143 to 159
	value = ((uint32_t)(input[17] & 0x01) << 31) |
			((uint32_t)input[18] << 23) |
			((uint32_t)input[19] << 15);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 160 to 176
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16) |
			((uint32_t)(input[22] & 0x80) << 8);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 177 to 193
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0xc0) << 9);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 194 to 210
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xe0) << 10);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 211 to 227
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xf0) << 11);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 228 to 244
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf8) << 12);
	output[13] = (double)(value >> 15);
}

static void unpack_14_17bit_unsigned_7off(const uint8_t * input, double * output) {
	// Unpack 14 values into output
	// Values are 17-bit unsigned
	// Skip 7 bits, read 238 bits of data.
	// Input must be at least 31 bytes long

	uint32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 58 to 74
	value = ((uint32_t)(input[7] & 0x3f) << 26) |
			((uint32_t)input[8] << 18) |
			((uint32_t)(input[9] & 0xe0) << 10);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 75 to 91
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)(input[11] & 0xf0) << 11);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 92 to 108
	value = ((uint32_t)(input[11] & 0x0f) << 28) |
			((uint32_t)input[12] << 20) |
			((uint32_t)(input[13] & 0xf8) << 12);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 109 to 125
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0xfc) << 13);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 126 to 142
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xfe) << 14);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 143 to 159
	value = ((uint32_t)(input[17] & 0x01) << 31) |
			((uint32_t)input[18] << 23) |
			((uint32_t)input[19] << 15);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 160 to 176
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16) |
			((uint32_t)(input[22] & 0x80) << 8);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 177 to 193
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0xc0) << 9);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 194 to 210
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xe0) << 10);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 211 to 227
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xf0) << 11);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 228 to 244
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf8) << 12);
	output[13] = (double)(value >> 15);
}

static void unpack_15_17bit_signed_0off(const uint8_t * input, double * output) {
	// Unpack 15 values into output
	// Values are 17-bit signed
	// Skip 0 bits, read 255 bits of data.
	// Input must be at least 32 bytes long

	int32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 51 to 67
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xf0) << 11);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 68 to 84
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf8) << 12);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 85 to 101
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xfc) << 13);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 102 to 118
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfe) << 14);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 119 to 135
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)input[16] << 15);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 136 to 152
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)input[18] << 16) |
			((uint32_t)(input[19] & 0x80) << 8);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 153 to 169
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xc0) << 9);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 170 to 186
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xe0) << 10);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 187 to 203
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)input[24] << 19) |
			((uint32_t)(input[25] & 0xf0) << 11);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 204 to 220
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20) |
			((uint32_t)(input[27] & 0xf8) << 12);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 221 to 237
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0xfc) << 13);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 238 to 254
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)(input[31] & 0xfe) << 14);
	output[14] = (double)(value >> 15);
}

static void unpack_15_17bit_unsigned_0off(const uint8_t * input, double * output) {
	// Unpack 15 values into output
	// Values are 17-bit unsigned
	// Skip 0 bits, read 255 bits of data.
	// Input must be at least 32 bytes long

	uint32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 51 to 67
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xf0) << 11);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 68 to 84
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf8) << 12);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 85 to 101
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xfc) << 13);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 102 to 118
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfe) << 14);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 119 to 135
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)input[16] << 15);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 136 to 152
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)input[18] << 16) |
			((uint32_t)(input[19] & 0x80) << 8);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 153 to 169
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xc0) << 9);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 170 to 186
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xe0) << 10);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 187 to 203
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)input[24] << 19) |
			((uint32_t)(input[25] & 0xf0) << 11);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 204 to 220
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20) |
			((uint32_t)(input[27] & 0xf8) << 12);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 221 to 237
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0xfc) << 13);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 238 to 254
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)(input[31] & 0xfe) << 14);
	output[14] = (double)(value >> 15);
}

static void unpack_15_17bit_signed_1off(const uint8_t * input, double * output) {
	// Unpack 15 values into output
	// Values are 17-bit signed
	// Skip 1 bits, read 255 bits of data.
	// Input must be at least 32 bytes long

	int32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 52 to 68
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf8) << 12);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 69 to 85
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xfc) << 13);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 86 to 102
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfe) << 14);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 103 to 119
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 120 to 136
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)(input[17] & 0x80) << 8);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 137 to 153
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)input[18] << 17) |
			((uint32_t)(input[19] & 0xc0) << 9);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 154 to 170
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xe0) << 10);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 171 to 187
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)(input[23] & 0xf0) << 11);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 188 to 204
	value = ((uint32_t)(input[23] & 0x0f) << 28) |
			((uint32_t)input[24] << 20) |
			((uint32_t)(input[25] & 0xf8) << 12);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 205 to 221
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0xfc) << 13);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 222 to 238
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xfe) << 14);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 239 to 255
	value = ((uint32_t)(input[29] & 0x01) << 31) |
			((uint32_t)input[30] << 23) |
			((uint32_t)input[31] << 15);
	output[14] = (double)(value >> 15);
}

static void unpack_15_17bit_unsigned_1off(const uint8_t * input, double * output) {
	// Unpack 15 values into output
	// Values are 17-bit unsigned
	// Skip 1 bits, read 255 bits of data.
	// Input must be at least 32 bytes long

	uint32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 52 to 68
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf8) << 12);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 69 to 85
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xfc) << 13);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 86 to 102
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfe) << 14);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 103 to 119
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 120 to 136
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)(input[17] & 0x80) << 8);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 137 to 153
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)input[18] << 17) |
			((uint32_t)(input[19] & 0xc0) << 9);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 154 to 170
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xe0) << 10);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 171 to 187
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)(input[23] & 0xf0) << 11);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 188 to 204
	value = ((uint32_t)(input[23] & 0x0f) << 28) |
			((uint32_t)input[24] << 20) |
			((uint32_t)(input[25] & 0xf8) << 12);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 205 to 221
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0xfc) << 13);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 222 to 238
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xfe) << 14);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 239 to 255
	value = ((uint32_t)(input[29] & 0x01) << 31) |
			((uint32_t)input[30] << 23) |
			((uint32_t)input[31] << 15);
	output[14] = (double)(value >> 15);
}

static void unpack_15_17bit_signed_2off(const uint8_t * input, double * output) {
	// Unpack 15 values into output
	// Values are 17-bit signed
	// Skip 2 bits, read 255 bits of data.
	// Input must be at least 33 bytes long

	int32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 53 to 69
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xfc) << 13);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 70 to 86
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfe) << 14);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 87 to 103
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 104 to 120
	value = ((uint32_t)input[13] << 24) |
			((uint32_t)input[14] << 16) |
			((uint32_t)(input[15] & 0x80) << 8);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 121 to 137
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)(input[17] & 0xc0) << 9);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 138 to 154
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)input[18] << 18) |
			((uint32_t)(input[19] & 0xe0) << 10);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 155 to 171
	value = ((uint32_t)(input[19] & 0x1f) << 27) |
			((uint32_t)input[20] << 19) |
			((uint32_t)(input[21] & 0xf0) << 11);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 172 to 188
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)(input[23] & 0xf8) << 12);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 189 to 205
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)(input[25] & 0xfc) << 13);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 206 to 222
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xfe) << 14);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 223 to 239
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 240 to 256
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)(input[32] & 0x80) << 8);
	output[14] = (double)(value >> 15);
}

static void unpack_15_17bit_unsigned_2off(const uint8_t * input, double * output) {
	// Unpack 15 values into output
	// Values are 17-bit unsigned
	// Skip 2 bits, read 255 bits of data.
	// Input must be at least 33 bytes long

	uint32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 53 to 69
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xfc) << 13);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 70 to 86
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfe) << 14);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 87 to 103
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 104 to 120
	value = ((uint32_t)input[13] << 24) |
			((uint32_t)input[14] << 16) |
			((uint32_t)(input[15] & 0x80) << 8);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 121 to 137
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)(input[17] & 0xc0) << 9);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 138 to 154
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)input[18] << 18) |
			((uint32_t)(input[19] & 0xe0) << 10);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 155 to 171
	value = ((uint32_t)(input[19] & 0x1f) << 27) |
			((uint32_t)input[20] << 19) |
			((uint32_t)(input[21] & 0xf0) << 11);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 172 to 188
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)(input[23] & 0xf8) << 12);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 189 to 205
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)(input[25] & 0xfc) << 13);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 206 to 222
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xfe) << 14);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 223 to 239
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 240 to 256
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)(input[32] & 0x80) << 8);
	output[14] = (double)(value >> 15);
}

static void unpack_15_17bit_signed_3off(const uint8_t * input, double * output) {
	// Unpack 15 values into output
	// Values are 17-bit signed
	// Skip 3 bits, read 255 bits of data.
	// Input must be at least 33 bytes long

	int32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 54 to 70
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfe) << 14);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 71 to 87
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)input[10] << 15);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 88 to 104
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0x80) << 8);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 105 to 121
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xc0) << 9);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 122 to 138
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)(input[17] & 0xe0) << 10);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 139 to 155
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)input[18] << 19) |
			((uint32_t)(input[19] & 0xf0) << 11);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 156 to 172
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20) |
			((uint32_t)(input[21] & 0xf8) << 12);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 173 to 189
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0xfc) << 13);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 190 to 206
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)(input[25] & 0xfe) << 14);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 207 to 223
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)input[27] << 15);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 224 to 240
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16) |
			((uint32_t)(input[30] & 0x80) << 8);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 241 to 257
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0xc0) << 9);
	output[14] = (double)(value >> 15);
}

static void unpack_15_17bit_unsigned_3off(const uint8_t * input, double * output) {
	// Unpack 15 values into output
	// Values are 17-bit unsigned
	// Skip 3 bits, read 255 bits of data.
	// Input must be at least 33 bytes long

	uint32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 54 to 70
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfe) << 14);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 71 to 87
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)input[10] << 15);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 88 to 104
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0x80) << 8);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 105 to 121
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xc0) << 9);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 122 to 138
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)(input[17] & 0xe0) << 10);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 139 to 155
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)input[18] << 19) |
			((uint32_t)(input[19] & 0xf0) << 11);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 156 to 172
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20) |
			((uint32_t)(input[21] & 0xf8) << 12);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 173 to 189
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0xfc) << 13);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 190 to 206
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)(input[25] & 0xfe) << 14);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 207 to 223
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)input[27] << 15);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 224 to 240
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16) |
			((uint32_t)(input[30] & 0x80) << 8);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 241 to 257
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0xc0) << 9);
	output[14] = (double)(value >> 15);
}

static void unpack_15_17bit_signed_4off(const uint8_t * input, double * output) {
	// Unpack 15 values into output
	// Values are 17-bit signed
	// Skip 4 bits, read 255 bits of data.
	// Input must be at least 33 bytes long

	int32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 55 to 71
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 72 to 88
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)(input[11] & 0x80) << 8);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 89 to 105
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xc0) << 9);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 106 to 122
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xe0) << 10);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 123 to 139
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)(input[17] & 0xf0) << 11);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 140 to 156
	value = ((uint32_t)(input[17] & 0x0f) << 28) |
			((uint32_t)input[18] << 20) |
			((uint32_t)(input[19] & 0xf8) << 12);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 157 to 173
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0xfc) << 13);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 174 to 190
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xfe) << 14);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 191 to 207
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 208 to 224
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16) |
			((uint32_t)(input[28] & 0x80) << 8);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 225 to 241
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0xc0) << 9);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 242 to 258
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xe0) << 10);
	output[14] = (double)(value >> 15);
}

static void unpack_15_17bit_unsigned_4off(const uint8_t * input, double * output) {
	// Unpack 15 values into output
	// Values are 17-bit unsigned
	// Skip 4 bits, read 255 bits of data.
	// Input must be at least 33 bytes long

	uint32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 55 to 71
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 72 to 88
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)(input[11] & 0x80) << 8);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 89 to 105
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xc0) << 9);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 106 to 122
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xe0) << 10);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 123 to 139
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)(input[17] & 0xf0) << 11);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 140 to 156
	value = ((uint32_t)(input[17] & 0x0f) << 28) |
			((uint32_t)input[18] << 20) |
			((uint32_t)(input[19] & 0xf8) << 12);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 157 to 173
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0xfc) << 13);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 174 to 190
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xfe) << 14);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 191 to 207
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 208 to 224
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16) |
			((uint32_t)(input[28] & 0x80) << 8);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 225 to 241
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0xc0) << 9);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 242 to 258
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xe0) << 10);
	output[14] = (double)(value >> 15);
}

static void unpack_15_17bit_signed_5off(const uint8_t * input, double * output) {
	// Unpack 15 values into output
	// Values are 17-bit signed
	// Skip 5 bits, read 255 bits of data.
	// Input must be at least 33 bytes long

	int32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 56 to 72
	value = ((uint32_t)input[7] << 24) |
			((uint32_t)input[8] << 16) |
			((uint32_t)(input[9] & 0x80) << 8);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 73 to 89
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)(input[11] & 0xc0) << 9);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 90 to 106
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xe0) << 10);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 107 to 123
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)(input[15] & 0xf0) << 11);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 124 to 140
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)(input[17] & 0xf8) << 12);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 141 to 157
	value = ((uint32_t)(input[17] & 0x07) << 29) |
			((uint32_t)input[18] << 21) |
			((uint32_t)(input[19] & 0xfc) << 13);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 158 to 174
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xfe) << 14);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 175 to 191
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 192 to 208
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0x80) << 8);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 209 to 225
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0xc0) << 9);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 226 to 242
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xe0) << 10);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 243 to 259
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xf0) << 11);
	output[14] = (double)(value >> 15);
}

static void unpack_15_17bit_unsigned_5off(const uint8_t * input, double * output) {
	// Unpack 15 values into output
	// Values are 17-bit unsigned
	// Skip 5 bits, read 255 bits of data.
	// Input must be at least 33 bytes long

	uint32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 56 to 72
	value = ((uint32_t)input[7] << 24) |
			((uint32_t)input[8] << 16) |
			((uint32_t)(input[9] & 0x80) << 8);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 73 to 89
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)(input[11] & 0xc0) << 9);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 90 to 106
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xe0) << 10);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 107 to 123
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)(input[15] & 0xf0) << 11);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 124 to 140
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)(input[17] & 0xf8) << 12);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 141 to 157
	value = ((uint32_t)(input[17] & 0x07) << 29) |
			((uint32_t)input[18] << 21) |
			((uint32_t)(input[19] & 0xfc) << 13);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 158 to 174
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xfe) << 14);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 175 to 191
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 192 to 208
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0x80) << 8);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 209 to 225
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0xc0) << 9);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 226 to 242
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xe0) << 10);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 243 to 259
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xf0) << 11);
	output[14] = (double)(value >> 15);
}

static void unpack_15_17bit_signed_6off(const uint8_t * input, double * output) {
	// Unpack 15 values into output
	// Values are 17-bit signed
	// Skip 6 bits, read 255 bits of data.
	// Input must be at least 33 bytes long

	int32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 57 to 73
	value = ((uint32_t)(input[7] & 0x7f) << 25) |
			((uint32_t)input[8] << 17) |
			((uint32_t)(input[9] & 0xc0) << 9);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 74 to 90
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)(input[11] & 0xe0) << 10);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 91 to 107
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)(input[13] & 0xf0) << 11);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 108 to 124
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)(input[15] & 0xf8) << 12);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 125 to 141
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0xfc) << 13);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 142 to 158
	value = ((uint32_t)(input[17] & 0x03) << 30) |
			((uint32_t)input[18] << 22) |
			((uint32_t)(input[19] & 0xfe) << 14);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 159 to 175
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)input[21] << 15);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 176 to 192
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16) |
			((uint32_t)(input[24] & 0x80) << 8);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 193 to 209
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xc0) << 9);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 210 to 226
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xe0) << 10);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 227 to 243
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xf0) << 11);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 244 to 260
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf8) << 12);
	output[14] = (double)(value >> 15);
}

static void unpack_15_17bit_unsigned_6off(const uint8_t * input, double * output) {
	// Unpack 15 values into output
	// Values are 17-bit unsigned
	// Skip 6 bits, read 255 bits of data.
	// Input must be at least 33 bytes long

	uint32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 57 to 73
	value = ((uint32_t)(input[7] & 0x7f) << 25) |
			((uint32_t)input[8] << 17) |
			((uint32_t)(input[9] & 0xc0) << 9);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 74 to 90
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)(input[11] & 0xe0) << 10);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 91 to 107
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)(input[13] & 0xf0) << 11);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 108 to 124
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)(input[15] & 0xf8) << 12);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 125 to 141
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0xfc) << 13);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 142 to 158
	value = ((uint32_t)(input[17] & 0x03) << 30) |
			((uint32_t)input[18] << 22) |
			((uint32_t)(input[19] & 0xfe) << 14);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 159 to 175
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)input[21] << 15);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 176 to 192
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16) |
			((uint32_t)(input[24] & 0x80) << 8);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 193 to 209
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xc0) << 9);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 210 to 226
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xe0) << 10);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 227 to 243
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xf0) << 11);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 244 to 260
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf8) << 12);
	output[14] = (double)(value >> 15);
}

static void unpack_15_17bit_signed_7off(const uint8_t * input, double * output) {
	// Unpack 15 values into output
	// Values are 17-bit signed
	// Skip 7 bits, read 255 bits of data.
	// Input must be at least 33 bytes long

	int32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 58 to 74
	value = ((uint32_t)(input[7] & 0x3f) << 26) |
			((uint32_t)input[8] << 18) |
			((uint32_t)(input[9] & 0xe0) << 10);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 75 to 91
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)(input[11] & 0xf0) << 11);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 92 to 108
	value = ((uint32_t)(input[11] & 0x0f) << 28) |
			((uint32_t)input[12] << 20) |
			((uint32_t)(input[13] & 0xf8) << 12);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 109 to 125
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0xfc) << 13);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 126 to 142
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xfe) << 14);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 143 to 159
	value = ((uint32_t)(input[17] & 0x01) << 31) |
			((uint32_t)input[18] << 23) |
			((uint32_t)input[19] << 15);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 160 to 176
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16) |
			((uint32_t)(input[22] & 0x80) << 8);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 177 to 193
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0xc0) << 9);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 194 to 210
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xe0) << 10);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 211 to 227
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xf0) << 11);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 228 to 244
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf8) << 12);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 245 to 261
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xfc) << 13);
	output[14] = (double)(value >> 15);
}

static void unpack_15_17bit_unsigned_7off(const uint8_t * input, double * output) {
	// Unpack 15 values into output
	// Values are 17-bit unsigned
	// Skip 7 bits, read 255 bits of data.
	// Input must be at least 33 bytes long

	uint32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 58 to 74
	value = ((uint32_t)(input[7] & 0x3f) << 26) |
			((uint32_t)input[8] << 18) |
			((uint32_t)(input[9] & 0xe0) << 10);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 75 to 91
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)(input[11] & 0xf0) << 11);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 92 to 108
	value = ((uint32_t)(input[11] & 0x0f) << 28) |
			((uint32_t)input[12] << 20) |
			((uint32_t)(input[13] & 0xf8) << 12);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 109 to 125
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0xfc) << 13);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 126 to 142
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xfe) << 14);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 143 to 159
	value = ((uint32_t)(input[17] & 0x01) << 31) |
			((uint32_t)input[18] << 23) |
			((uint32_t)input[19] << 15);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 160 to 176
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16) |
			((uint32_t)(input[22] & 0x80) << 8);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 177 to 193
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0xc0) << 9);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 194 to 210
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xe0) << 10);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 211 to 227
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xf0) << 11);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 228 to 244
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf8) << 12);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 245 to 261
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xfc) << 13);
	output[14] = (double)(value >> 15);
}

static void unpack_16_17bit_signed_0off(const uint8_t * input, double * output) {
	// Unpack 16 values into output
	// Values are 17-bit signed
	// Skip 0 bits, read 272 bits of data.
	// Input must be at least 34 bytes long

	int32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 51 to 67
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xf0) << 11);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 68 to 84
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf8) << 12);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 85 to 101
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xfc) << 13);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 102 to 118
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfe) << 14);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 119 to 135
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)input[16] << 15);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 136 to 152
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)input[18] << 16) |
			((uint32_t)(input[19] & 0x80) << 8);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 153 to 169
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xc0) << 9);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 170 to 186
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xe0) << 10);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 187 to 203
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)input[24] << 19) |
			((uint32_t)(input[25] & 0xf0) << 11);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 204 to 220
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20) |
			((uint32_t)(input[27] & 0xf8) << 12);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 221 to 237
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0xfc) << 13);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 238 to 254
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)(input[31] & 0xfe) << 14);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 255 to 271
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)input[33] << 15);
	output[15] = (double)(value >> 15);
}

static void unpack_16_17bit_unsigned_0off(const uint8_t * input, double * output) {
	// Unpack 16 values into output
	// Values are 17-bit unsigned
	// Skip 0 bits, read 272 bits of data.
	// Input must be at least 34 bytes long

	uint32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 51 to 67
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xf0) << 11);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 68 to 84
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf8) << 12);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 85 to 101
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xfc) << 13);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 102 to 118
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfe) << 14);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 119 to 135
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)input[16] << 15);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 136 to 152
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)input[18] << 16) |
			((uint32_t)(input[19] & 0x80) << 8);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 153 to 169
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xc0) << 9);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 170 to 186
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xe0) << 10);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 187 to 203
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)input[24] << 19) |
			((uint32_t)(input[25] & 0xf0) << 11);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 204 to 220
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20) |
			((uint32_t)(input[27] & 0xf8) << 12);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 221 to 237
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0xfc) << 13);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 238 to 254
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)(input[31] & 0xfe) << 14);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 255 to 271
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)input[33] << 15);
	output[15] = (double)(value >> 15);
}

static void unpack_16_17bit_signed_1off(const uint8_t * input, double * output) {
	// Unpack 16 values into output
	// Values are 17-bit signed
	// Skip 1 bits, read 272 bits of data.
	// Input must be at least 35 bytes long

	int32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 52 to 68
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf8) << 12);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 69 to 85
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xfc) << 13);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 86 to 102
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfe) << 14);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 103 to 119
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 120 to 136
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)(input[17] & 0x80) << 8);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 137 to 153
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)input[18] << 17) |
			((uint32_t)(input[19] & 0xc0) << 9);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 154 to 170
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xe0) << 10);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 171 to 187
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)(input[23] & 0xf0) << 11);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 188 to 204
	value = ((uint32_t)(input[23] & 0x0f) << 28) |
			((uint32_t)input[24] << 20) |
			((uint32_t)(input[25] & 0xf8) << 12);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 205 to 221
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0xfc) << 13);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 222 to 238
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xfe) << 14);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 239 to 255
	value = ((uint32_t)(input[29] & 0x01) << 31) |
			((uint32_t)input[30] << 23) |
			((uint32_t)input[31] << 15);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 256 to 272
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16) |
			((uint32_t)(input[34] & 0x80) << 8);
	output[15] = (double)(value >> 15);
}

static void unpack_16_17bit_unsigned_1off(const uint8_t * input, double * output) {
	// Unpack 16 values into output
	// Values are 17-bit unsigned
	// Skip 1 bits, read 272 bits of data.
	// Input must be at least 35 bytes long

	uint32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 52 to 68
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf8) << 12);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 69 to 85
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xfc) << 13);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 86 to 102
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfe) << 14);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 103 to 119
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 120 to 136
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)(input[17] & 0x80) << 8);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 137 to 153
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)input[18] << 17) |
			((uint32_t)(input[19] & 0xc0) << 9);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 154 to 170
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xe0) << 10);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 171 to 187
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)(input[23] & 0xf0) << 11);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 188 to 204
	value = ((uint32_t)(input[23] & 0x0f) << 28) |
			((uint32_t)input[24] << 20) |
			((uint32_t)(input[25] & 0xf8) << 12);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 205 to 221
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0xfc) << 13);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 222 to 238
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xfe) << 14);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 239 to 255
	value = ((uint32_t)(input[29] & 0x01) << 31) |
			((uint32_t)input[30] << 23) |
			((uint32_t)input[31] << 15);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 256 to 272
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16) |
			((uint32_t)(input[34] & 0x80) << 8);
	output[15] = (double)(value >> 15);
}

static void unpack_16_17bit_signed_2off(const uint8_t * input, double * output) {
	// Unpack 16 values into output
	// Values are 17-bit signed
	// Skip 2 bits, read 272 bits of data.
	// Input must be at least 35 bytes long

	int32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 53 to 69
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xfc) << 13);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 70 to 86
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfe) << 14);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 87 to 103
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 104 to 120
	value = ((uint32_t)input[13] << 24) |
			((uint32_t)input[14] << 16) |
			((uint32_t)(input[15] & 0x80) << 8);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 121 to 137
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)(input[17] & 0xc0) << 9);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 138 to 154
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)input[18] << 18) |
			((uint32_t)(input[19] & 0xe0) << 10);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 155 to 171
	value = ((uint32_t)(input[19] & 0x1f) << 27) |
			((uint32_t)input[20] << 19) |
			((uint32_t)(input[21] & 0xf0) << 11);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 172 to 188
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)(input[23] & 0xf8) << 12);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 189 to 205
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)(input[25] & 0xfc) << 13);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 206 to 222
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xfe) << 14);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 223 to 239
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 240 to 256
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)(input[32] & 0x80) << 8);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 257 to 273
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0xc0) << 9);
	output[15] = (double)(value >> 15);
}

static void unpack_16_17bit_unsigned_2off(const uint8_t * input, double * output) {
	// Unpack 16 values into output
	// Values are 17-bit unsigned
	// Skip 2 bits, read 272 bits of data.
	// Input must be at least 35 bytes long

	uint32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 53 to 69
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xfc) << 13);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 70 to 86
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfe) << 14);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 87 to 103
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 104 to 120
	value = ((uint32_t)input[13] << 24) |
			((uint32_t)input[14] << 16) |
			((uint32_t)(input[15] & 0x80) << 8);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 121 to 137
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)(input[17] & 0xc0) << 9);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 138 to 154
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)input[18] << 18) |
			((uint32_t)(input[19] & 0xe0) << 10);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 155 to 171
	value = ((uint32_t)(input[19] & 0x1f) << 27) |
			((uint32_t)input[20] << 19) |
			((uint32_t)(input[21] & 0xf0) << 11);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 172 to 188
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)(input[23] & 0xf8) << 12);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 189 to 205
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)(input[25] & 0xfc) << 13);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 206 to 222
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xfe) << 14);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 223 to 239
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 240 to 256
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)(input[32] & 0x80) << 8);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 257 to 273
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0xc0) << 9);
	output[15] = (double)(value >> 15);
}

static void unpack_16_17bit_signed_3off(const uint8_t * input, double * output) {
	// Unpack 16 values into output
	// Values are 17-bit signed
	// Skip 3 bits, read 272 bits of data.
	// Input must be at least 35 bytes long

	int32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 54 to 70
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfe) << 14);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 71 to 87
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)input[10] << 15);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 88 to 104
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0x80) << 8);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 105 to 121
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xc0) << 9);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 122 to 138
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)(input[17] & 0xe0) << 10);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 139 to 155
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)input[18] << 19) |
			((uint32_t)(input[19] & 0xf0) << 11);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 156 to 172
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20) |
			((uint32_t)(input[21] & 0xf8) << 12);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 173 to 189
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0xfc) << 13);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 190 to 206
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)(input[25] & 0xfe) << 14);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 207 to 223
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)input[27] << 15);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 224 to 240
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16) |
			((uint32_t)(input[30] & 0x80) << 8);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 241 to 257
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0xc0) << 9);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 258 to 274
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xe0) << 10);
	output[15] = (double)(value >> 15);
}

static void unpack_16_17bit_unsigned_3off(const uint8_t * input, double * output) {
	// Unpack 16 values into output
	// Values are 17-bit unsigned
	// Skip 3 bits, read 272 bits of data.
	// Input must be at least 35 bytes long

	uint32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 54 to 70
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfe) << 14);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 71 to 87
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)input[10] << 15);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 88 to 104
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0x80) << 8);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 105 to 121
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xc0) << 9);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 122 to 138
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)(input[17] & 0xe0) << 10);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 139 to 155
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)input[18] << 19) |
			((uint32_t)(input[19] & 0xf0) << 11);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 156 to 172
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20) |
			((uint32_t)(input[21] & 0xf8) << 12);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 173 to 189
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0xfc) << 13);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 190 to 206
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)(input[25] & 0xfe) << 14);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 207 to 223
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)input[27] << 15);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 224 to 240
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16) |
			((uint32_t)(input[30] & 0x80) << 8);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 241 to 257
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0xc0) << 9);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 258 to 274
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xe0) << 10);
	output[15] = (double)(value >> 15);
}

static void unpack_16_17bit_signed_4off(const uint8_t * input, double * output) {
	// Unpack 16 values into output
	// Values are 17-bit signed
	// Skip 4 bits, read 272 bits of data.
	// Input must be at least 35 bytes long

	int32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 55 to 71
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 72 to 88
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)(input[11] & 0x80) << 8);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 89 to 105
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xc0) << 9);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 106 to 122
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xe0) << 10);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 123 to 139
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)(input[17] & 0xf0) << 11);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 140 to 156
	value = ((uint32_t)(input[17] & 0x0f) << 28) |
			((uint32_t)input[18] << 20) |
			((uint32_t)(input[19] & 0xf8) << 12);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 157 to 173
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0xfc) << 13);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 174 to 190
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xfe) << 14);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 191 to 207
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 208 to 224
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16) |
			((uint32_t)(input[28] & 0x80) << 8);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 225 to 241
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0xc0) << 9);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 242 to 258
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xe0) << 10);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 259 to 275
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xf0) << 11);
	output[15] = (double)(value >> 15);
}

static void unpack_16_17bit_unsigned_4off(const uint8_t * input, double * output) {
	// Unpack 16 values into output
	// Values are 17-bit unsigned
	// Skip 4 bits, read 272 bits of data.
	// Input must be at least 35 bytes long

	uint32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 55 to 71
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 72 to 88
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)(input[11] & 0x80) << 8);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 89 to 105
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xc0) << 9);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 106 to 122
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xe0) << 10);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 123 to 139
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)(input[17] & 0xf0) << 11);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 140 to 156
	value = ((uint32_t)(input[17] & 0x0f) << 28) |
			((uint32_t)input[18] << 20) |
			((uint32_t)(input[19] & 0xf8) << 12);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 157 to 173
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0xfc) << 13);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 174 to 190
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xfe) << 14);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 191 to 207
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 208 to 224
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16) |
			((uint32_t)(input[28] & 0x80) << 8);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 225 to 241
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0xc0) << 9);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 242 to 258
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xe0) << 10);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 259 to 275
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xf0) << 11);
	output[15] = (double)(value >> 15);
}

static void unpack_16_17bit_signed_5off(const uint8_t * input, double * output) {
	// Unpack 16 values into output
	// Values are 17-bit signed
	// Skip 5 bits, read 272 bits of data.
	// Input must be at least 35 bytes long

	int32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 56 to 72
	value = ((uint32_t)input[7] << 24) |
			((uint32_t)input[8] << 16) |
			((uint32_t)(input[9] & 0x80) << 8);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 73 to 89
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)(input[11] & 0xc0) << 9);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 90 to 106
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xe0) << 10);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 107 to 123
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)(input[15] & 0xf0) << 11);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 124 to 140
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)(input[17] & 0xf8) << 12);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 141 to 157
	value = ((uint32_t)(input[17] & 0x07) << 29) |
			((uint32_t)input[18] << 21) |
			((uint32_t)(input[19] & 0xfc) << 13);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 158 to 174
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xfe) << 14);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 175 to 191
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 192 to 208
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0x80) << 8);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 209 to 225
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0xc0) << 9);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 226 to 242
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xe0) << 10);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 243 to 259
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xf0) << 11);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 260 to 276
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf8) << 12);
	output[15] = (double)(value >> 15);
}

static void unpack_16_17bit_unsigned_5off(const uint8_t * input, double * output) {
	// Unpack 16 values into output
	// Values are 17-bit unsigned
	// Skip 5 bits, read 272 bits of data.
	// Input must be at least 35 bytes long

	uint32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 56 to 72
	value = ((uint32_t)input[7] << 24) |
			((uint32_t)input[8] << 16) |
			((uint32_t)(input[9] & 0x80) << 8);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 73 to 89
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)(input[11] & 0xc0) << 9);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 90 to 106
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xe0) << 10);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 107 to 123
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)(input[15] & 0xf0) << 11);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 124 to 140
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)(input[17] & 0xf8) << 12);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 141 to 157
	value = ((uint32_t)(input[17] & 0x07) << 29) |
			((uint32_t)input[18] << 21) |
			((uint32_t)(input[19] & 0xfc) << 13);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 158 to 174
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xfe) << 14);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 175 to 191
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 192 to 208
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0x80) << 8);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 209 to 225
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0xc0) << 9);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 226 to 242
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xe0) << 10);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 243 to 259
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xf0) << 11);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 260 to 276
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf8) << 12);
	output[15] = (double)(value >> 15);
}

static void unpack_16_17bit_signed_6off(const uint8_t * input, double * output) {
	// Unpack 16 values into output
	// Values are 17-bit signed
	// Skip 6 bits, read 272 bits of data.
	// Input must be at least 35 bytes long

	int32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 57 to 73
	value = ((uint32_t)(input[7] & 0x7f) << 25) |
			((uint32_t)input[8] << 17) |
			((uint32_t)(input[9] & 0xc0) << 9);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 74 to 90
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)(input[11] & 0xe0) << 10);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 91 to 107
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)(input[13] & 0xf0) << 11);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 108 to 124
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)(input[15] & 0xf8) << 12);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 125 to 141
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0xfc) << 13);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 142 to 158
	value = ((uint32_t)(input[17] & 0x03) << 30) |
			((uint32_t)input[18] << 22) |
			((uint32_t)(input[19] & 0xfe) << 14);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 159 to 175
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)input[21] << 15);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 176 to 192
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16) |
			((uint32_t)(input[24] & 0x80) << 8);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 193 to 209
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xc0) << 9);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 210 to 226
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xe0) << 10);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 227 to 243
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xf0) << 11);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 244 to 260
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf8) << 12);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 261 to 277
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xfc) << 13);
	output[15] = (double)(value >> 15);
}

static void unpack_16_17bit_unsigned_6off(const uint8_t * input, double * output) {
	// Unpack 16 values into output
	// Values are 17-bit unsigned
	// Skip 6 bits, read 272 bits of data.
	// Input must be at least 35 bytes long

	uint32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 57 to 73
	value = ((uint32_t)(input[7] & 0x7f) << 25) |
			((uint32_t)input[8] << 17) |
			((uint32_t)(input[9] & 0xc0) << 9);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 74 to 90
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)(input[11] & 0xe0) << 10);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 91 to 107
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)(input[13] & 0xf0) << 11);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 108 to 124
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)(input[15] & 0xf8) << 12);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 125 to 141
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0xfc) << 13);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 142 to 158
	value = ((uint32_t)(input[17] & 0x03) << 30) |
			((uint32_t)input[18] << 22) |
			((uint32_t)(input[19] & 0xfe) << 14);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 159 to 175
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)input[21] << 15);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 176 to 192
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16) |
			((uint32_t)(input[24] & 0x80) << 8);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 193 to 209
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xc0) << 9);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 210 to 226
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xe0) << 10);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 227 to 243
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xf0) << 11);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 244 to 260
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf8) << 12);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 261 to 277
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xfc) << 13);
	output[15] = (double)(value >> 15);
}

static void unpack_16_17bit_signed_7off(const uint8_t * input, double * output) {
	// Unpack 16 values into output
	// Values are 17-bit signed
	// Skip 7 bits, read 272 bits of data.
	// Input must be at least 35 bytes long

	int32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 58 to 74
	value = ((uint32_t)(input[7] & 0x3f) << 26) |
			((uint32_t)input[8] << 18) |
			((uint32_t)(input[9] & 0xe0) << 10);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 75 to 91
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)(input[11] & 0xf0) << 11);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 92 to 108
	value = ((uint32_t)(input[11] & 0x0f) << 28) |
			((uint32_t)input[12] << 20) |
			((uint32_t)(input[13] & 0xf8) << 12);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 109 to 125
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0xfc) << 13);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 126 to 142
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xfe) << 14);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 143 to 159
	value = ((uint32_t)(input[17] & 0x01) << 31) |
			((uint32_t)input[18] << 23) |
			((uint32_t)input[19] << 15);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 160 to 176
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16) |
			((uint32_t)(input[22] & 0x80) << 8);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 177 to 193
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0xc0) << 9);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 194 to 210
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xe0) << 10);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 211 to 227
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xf0) << 11);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 228 to 244
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf8) << 12);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 245 to 261
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xfc) << 13);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 262 to 278
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfe) << 14);
	output[15] = (double)(value >> 15);
}

static void unpack_16_17bit_unsigned_7off(const uint8_t * input, double * output) {
	// Unpack 16 values into output
	// Values are 17-bit unsigned
	// Skip 7 bits, read 272 bits of data.
	// Input must be at least 35 bytes long

	uint32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 58 to 74
	value = ((uint32_t)(input[7] & 0x3f) << 26) |
			((uint32_t)input[8] << 18) |
			((uint32_t)(input[9] & 0xe0) << 10);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 75 to 91
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)(input[11] & 0xf0) << 11);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 92 to 108
	value = ((uint32_t)(input[11] & 0x0f) << 28) |
			((uint32_t)input[12] << 20) |
			((uint32_t)(input[13] & 0xf8) << 12);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 109 to 125
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0xfc) << 13);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 126 to 142
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xfe) << 14);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 143 to 159
	value = ((uint32_t)(input[17] & 0x01) << 31) |
			((uint32_t)input[18] << 23) |
			((uint32_t)input[19] << 15);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 160 to 176
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16) |
			((uint32_t)(input[22] & 0x80) << 8);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 177 to 193
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0xc0) << 9);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 194 to 210
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xe0) << 10);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 211 to 227
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xf0) << 11);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 228 to 244
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf8) << 12);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 245 to 261
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xfc) << 13);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 262 to 278
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfe) << 14);
	output[15] = (double)(value >> 15);
}

static void unpack_17_17bit_signed_0off(const uint8_t * input, double * output) {
	// Unpack 17 values into output
	// Values are 17-bit signed
	// Skip 0 bits, read 289 bits of data.
	// Input must be at least 37 bytes long

	int32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 51 to 67
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xf0) << 11);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 68 to 84
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf8) << 12);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 85 to 101
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xfc) << 13);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 102 to 118
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfe) << 14);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 119 to 135
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)input[16] << 15);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 136 to 152
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)input[18] << 16) |
			((uint32_t)(input[19] & 0x80) << 8);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 153 to 169
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xc0) << 9);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 170 to 186
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xe0) << 10);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 187 to 203
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)input[24] << 19) |
			((uint32_t)(input[25] & 0xf0) << 11);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 204 to 220
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20) |
			((uint32_t)(input[27] & 0xf8) << 12);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 221 to 237
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0xfc) << 13);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 238 to 254
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)(input[31] & 0xfe) << 14);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 255 to 271
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)input[33] << 15);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 272 to 288
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16) |
			((uint32_t)(input[36] & 0x80) << 8);
	output[16] = (double)(value >> 15);
}

static void unpack_17_17bit_unsigned_0off(const uint8_t * input, double * output) {
	// Unpack 17 values into output
	// Values are 17-bit unsigned
	// Skip 0 bits, read 289 bits of data.
	// Input must be at least 37 bytes long

	uint32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 51 to 67
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xf0) << 11);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 68 to 84
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf8) << 12);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 85 to 101
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xfc) << 13);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 102 to 118
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfe) << 14);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 119 to 135
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)input[16] << 15);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 136 to 152
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)input[18] << 16) |
			((uint32_t)(input[19] & 0x80) << 8);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 153 to 169
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xc0) << 9);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 170 to 186
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xe0) << 10);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 187 to 203
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)input[24] << 19) |
			((uint32_t)(input[25] & 0xf0) << 11);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 204 to 220
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20) |
			((uint32_t)(input[27] & 0xf8) << 12);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 221 to 237
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0xfc) << 13);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 238 to 254
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)(input[31] & 0xfe) << 14);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 255 to 271
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)input[33] << 15);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 272 to 288
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16) |
			((uint32_t)(input[36] & 0x80) << 8);
	output[16] = (double)(value >> 15);
}

static void unpack_17_17bit_signed_1off(const uint8_t * input, double * output) {
	// Unpack 17 values into output
	// Values are 17-bit signed
	// Skip 1 bits, read 289 bits of data.
	// Input must be at least 37 bytes long

	int32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 52 to 68
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf8) << 12);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 69 to 85
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xfc) << 13);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 86 to 102
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfe) << 14);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 103 to 119
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 120 to 136
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)(input[17] & 0x80) << 8);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 137 to 153
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)input[18] << 17) |
			((uint32_t)(input[19] & 0xc0) << 9);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 154 to 170
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xe0) << 10);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 171 to 187
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)(input[23] & 0xf0) << 11);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 188 to 204
	value = ((uint32_t)(input[23] & 0x0f) << 28) |
			((uint32_t)input[24] << 20) |
			((uint32_t)(input[25] & 0xf8) << 12);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 205 to 221
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0xfc) << 13);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 222 to 238
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xfe) << 14);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 239 to 255
	value = ((uint32_t)(input[29] & 0x01) << 31) |
			((uint32_t)input[30] << 23) |
			((uint32_t)input[31] << 15);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 256 to 272
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16) |
			((uint32_t)(input[34] & 0x80) << 8);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 273 to 289
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0xc0) << 9);
	output[16] = (double)(value >> 15);
}

static void unpack_17_17bit_unsigned_1off(const uint8_t * input, double * output) {
	// Unpack 17 values into output
	// Values are 17-bit unsigned
	// Skip 1 bits, read 289 bits of data.
	// Input must be at least 37 bytes long

	uint32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 52 to 68
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf8) << 12);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 69 to 85
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xfc) << 13);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 86 to 102
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfe) << 14);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 103 to 119
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 120 to 136
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)(input[17] & 0x80) << 8);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 137 to 153
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)input[18] << 17) |
			((uint32_t)(input[19] & 0xc0) << 9);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 154 to 170
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xe0) << 10);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 171 to 187
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)(input[23] & 0xf0) << 11);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 188 to 204
	value = ((uint32_t)(input[23] & 0x0f) << 28) |
			((uint32_t)input[24] << 20) |
			((uint32_t)(input[25] & 0xf8) << 12);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 205 to 221
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0xfc) << 13);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 222 to 238
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xfe) << 14);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 239 to 255
	value = ((uint32_t)(input[29] & 0x01) << 31) |
			((uint32_t)input[30] << 23) |
			((uint32_t)input[31] << 15);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 256 to 272
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16) |
			((uint32_t)(input[34] & 0x80) << 8);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 273 to 289
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0xc0) << 9);
	output[16] = (double)(value >> 15);
}

static void unpack_17_17bit_signed_2off(const uint8_t * input, double * output) {
	// Unpack 17 values into output
	// Values are 17-bit signed
	// Skip 2 bits, read 289 bits of data.
	// Input must be at least 37 bytes long

	int32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 53 to 69
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xfc) << 13);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 70 to 86
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfe) << 14);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 87 to 103
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 104 to 120
	value = ((uint32_t)input[13] << 24) |
			((uint32_t)input[14] << 16) |
			((uint32_t)(input[15] & 0x80) << 8);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 121 to 137
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)(input[17] & 0xc0) << 9);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 138 to 154
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)input[18] << 18) |
			((uint32_t)(input[19] & 0xe0) << 10);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 155 to 171
	value = ((uint32_t)(input[19] & 0x1f) << 27) |
			((uint32_t)input[20] << 19) |
			((uint32_t)(input[21] & 0xf0) << 11);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 172 to 188
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)(input[23] & 0xf8) << 12);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 189 to 205
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)(input[25] & 0xfc) << 13);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 206 to 222
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xfe) << 14);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 223 to 239
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 240 to 256
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)(input[32] & 0x80) << 8);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 257 to 273
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0xc0) << 9);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 274 to 290
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xe0) << 10);
	output[16] = (double)(value >> 15);
}

static void unpack_17_17bit_unsigned_2off(const uint8_t * input, double * output) {
	// Unpack 17 values into output
	// Values are 17-bit unsigned
	// Skip 2 bits, read 289 bits of data.
	// Input must be at least 37 bytes long

	uint32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 53 to 69
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xfc) << 13);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 70 to 86
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfe) << 14);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 87 to 103
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 104 to 120
	value = ((uint32_t)input[13] << 24) |
			((uint32_t)input[14] << 16) |
			((uint32_t)(input[15] & 0x80) << 8);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 121 to 137
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)(input[17] & 0xc0) << 9);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 138 to 154
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)input[18] << 18) |
			((uint32_t)(input[19] & 0xe0) << 10);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 155 to 171
	value = ((uint32_t)(input[19] & 0x1f) << 27) |
			((uint32_t)input[20] << 19) |
			((uint32_t)(input[21] & 0xf0) << 11);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 172 to 188
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)(input[23] & 0xf8) << 12);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 189 to 205
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)(input[25] & 0xfc) << 13);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 206 to 222
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xfe) << 14);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 223 to 239
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 240 to 256
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)(input[32] & 0x80) << 8);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 257 to 273
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0xc0) << 9);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 274 to 290
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xe0) << 10);
	output[16] = (double)(value >> 15);
}

static void unpack_17_17bit_signed_3off(const uint8_t * input, double * output) {
	// Unpack 17 values into output
	// Values are 17-bit signed
	// Skip 3 bits, read 289 bits of data.
	// Input must be at least 37 bytes long

	int32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 54 to 70
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfe) << 14);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 71 to 87
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)input[10] << 15);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 88 to 104
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0x80) << 8);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 105 to 121
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xc0) << 9);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 122 to 138
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)(input[17] & 0xe0) << 10);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 139 to 155
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)input[18] << 19) |
			((uint32_t)(input[19] & 0xf0) << 11);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 156 to 172
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20) |
			((uint32_t)(input[21] & 0xf8) << 12);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 173 to 189
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0xfc) << 13);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 190 to 206
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)(input[25] & 0xfe) << 14);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 207 to 223
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)input[27] << 15);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 224 to 240
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16) |
			((uint32_t)(input[30] & 0x80) << 8);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 241 to 257
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0xc0) << 9);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 258 to 274
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xe0) << 10);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 275 to 291
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xf0) << 11);
	output[16] = (double)(value >> 15);
}

static void unpack_17_17bit_unsigned_3off(const uint8_t * input, double * output) {
	// Unpack 17 values into output
	// Values are 17-bit unsigned
	// Skip 3 bits, read 289 bits of data.
	// Input must be at least 37 bytes long

	uint32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 54 to 70
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfe) << 14);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 71 to 87
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)input[10] << 15);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 88 to 104
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0x80) << 8);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 105 to 121
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xc0) << 9);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 122 to 138
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)(input[17] & 0xe0) << 10);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 139 to 155
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)input[18] << 19) |
			((uint32_t)(input[19] & 0xf0) << 11);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 156 to 172
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20) |
			((uint32_t)(input[21] & 0xf8) << 12);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 173 to 189
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0xfc) << 13);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 190 to 206
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)(input[25] & 0xfe) << 14);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 207 to 223
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)input[27] << 15);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 224 to 240
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16) |
			((uint32_t)(input[30] & 0x80) << 8);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 241 to 257
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0xc0) << 9);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 258 to 274
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xe0) << 10);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 275 to 291
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xf0) << 11);
	output[16] = (double)(value >> 15);
}

static void unpack_17_17bit_signed_4off(const uint8_t * input, double * output) {
	// Unpack 17 values into output
	// Values are 17-bit signed
	// Skip 4 bits, read 289 bits of data.
	// Input must be at least 37 bytes long

	int32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 55 to 71
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 72 to 88
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)(input[11] & 0x80) << 8);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 89 to 105
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xc0) << 9);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 106 to 122
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xe0) << 10);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 123 to 139
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)(input[17] & 0xf0) << 11);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 140 to 156
	value = ((uint32_t)(input[17] & 0x0f) << 28) |
			((uint32_t)input[18] << 20) |
			((uint32_t)(input[19] & 0xf8) << 12);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 157 to 173
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0xfc) << 13);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 174 to 190
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xfe) << 14);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 191 to 207
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 208 to 224
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16) |
			((uint32_t)(input[28] & 0x80) << 8);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 225 to 241
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0xc0) << 9);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 242 to 258
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xe0) << 10);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 259 to 275
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xf0) << 11);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 276 to 292
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf8) << 12);
	output[16] = (double)(value >> 15);
}

static void unpack_17_17bit_unsigned_4off(const uint8_t * input, double * output) {
	// Unpack 17 values into output
	// Values are 17-bit unsigned
	// Skip 4 bits, read 289 bits of data.
	// Input must be at least 37 bytes long

	uint32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 55 to 71
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 72 to 88
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)(input[11] & 0x80) << 8);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 89 to 105
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xc0) << 9);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 106 to 122
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xe0) << 10);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 123 to 139
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)(input[17] & 0xf0) << 11);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 140 to 156
	value = ((uint32_t)(input[17] & 0x0f) << 28) |
			((uint32_t)input[18] << 20) |
			((uint32_t)(input[19] & 0xf8) << 12);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 157 to 173
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0xfc) << 13);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 174 to 190
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xfe) << 14);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 191 to 207
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 208 to 224
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16) |
			((uint32_t)(input[28] & 0x80) << 8);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 225 to 241
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0xc0) << 9);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 242 to 258
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xe0) << 10);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 259 to 275
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xf0) << 11);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 276 to 292
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf8) << 12);
	output[16] = (double)(value >> 15);
}

static void unpack_17_17bit_signed_5off(const uint8_t * input, double * output) {
	// Unpack 17 values into output
	// Values are 17-bit signed
	// Skip 5 bits, read 289 bits of data.
	// Input must be at least 37 bytes long

	int32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 56 to 72
	value = ((uint32_t)input[7] << 24) |
			((uint32_t)input[8] << 16) |
			((uint32_t)(input[9] & 0x80) << 8);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 73 to 89
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)(input[11] & 0xc0) << 9);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 90 to 106
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xe0) << 10);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 107 to 123
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)(input[15] & 0xf0) << 11);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 124 to 140
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)(input[17] & 0xf8) << 12);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 141 to 157
	value = ((uint32_t)(input[17] & 0x07) << 29) |
			((uint32_t)input[18] << 21) |
			((uint32_t)(input[19] & 0xfc) << 13);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 158 to 174
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xfe) << 14);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 175 to 191
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 192 to 208
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0x80) << 8);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 209 to 225
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0xc0) << 9);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 226 to 242
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xe0) << 10);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 243 to 259
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xf0) << 11);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 260 to 276
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf8) << 12);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 277 to 293
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xfc) << 13);
	output[16] = (double)(value >> 15);
}

static void unpack_17_17bit_unsigned_5off(const uint8_t * input, double * output) {
	// Unpack 17 values into output
	// Values are 17-bit unsigned
	// Skip 5 bits, read 289 bits of data.
	// Input must be at least 37 bytes long

	uint32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 56 to 72
	value = ((uint32_t)input[7] << 24) |
			((uint32_t)input[8] << 16) |
			((uint32_t)(input[9] & 0x80) << 8);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 73 to 89
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)(input[11] & 0xc0) << 9);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 90 to 106
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xe0) << 10);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 107 to 123
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)(input[15] & 0xf0) << 11);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 124 to 140
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)(input[17] & 0xf8) << 12);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 141 to 157
	value = ((uint32_t)(input[17] & 0x07) << 29) |
			((uint32_t)input[18] << 21) |
			((uint32_t)(input[19] & 0xfc) << 13);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 158 to 174
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xfe) << 14);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 175 to 191
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 192 to 208
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0x80) << 8);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 209 to 225
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0xc0) << 9);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 226 to 242
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xe0) << 10);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 243 to 259
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xf0) << 11);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 260 to 276
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf8) << 12);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 277 to 293
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xfc) << 13);
	output[16] = (double)(value >> 15);
}

static void unpack_17_17bit_signed_6off(const uint8_t * input, double * output) {
	// Unpack 17 values into output
	// Values are 17-bit signed
	// Skip 6 bits, read 289 bits of data.
	// Input must be at least 37 bytes long

	int32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 57 to 73
	value = ((uint32_t)(input[7] & 0x7f) << 25) |
			((uint32_t)input[8] << 17) |
			((uint32_t)(input[9] & 0xc0) << 9);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 74 to 90
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)(input[11] & 0xe0) << 10);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 91 to 107
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)(input[13] & 0xf0) << 11);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 108 to 124
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)(input[15] & 0xf8) << 12);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 125 to 141
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0xfc) << 13);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 142 to 158
	value = ((uint32_t)(input[17] & 0x03) << 30) |
			((uint32_t)input[18] << 22) |
			((uint32_t)(input[19] & 0xfe) << 14);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 159 to 175
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)input[21] << 15);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 176 to 192
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16) |
			((uint32_t)(input[24] & 0x80) << 8);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 193 to 209
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xc0) << 9);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 210 to 226
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xe0) << 10);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 227 to 243
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xf0) << 11);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 244 to 260
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf8) << 12);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 261 to 277
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xfc) << 13);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 278 to 294
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfe) << 14);
	output[16] = (double)(value >> 15);
}

static void unpack_17_17bit_unsigned_6off(const uint8_t * input, double * output) {
	// Unpack 17 values into output
	// Values are 17-bit unsigned
	// Skip 6 bits, read 289 bits of data.
	// Input must be at least 37 bytes long

	uint32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 57 to 73
	value = ((uint32_t)(input[7] & 0x7f) << 25) |
			((uint32_t)input[8] << 17) |
			((uint32_t)(input[9] & 0xc0) << 9);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 74 to 90
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)(input[11] & 0xe0) << 10);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 91 to 107
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)(input[13] & 0xf0) << 11);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 108 to 124
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)(input[15] & 0xf8) << 12);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 125 to 141
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0xfc) << 13);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 142 to 158
	value = ((uint32_t)(input[17] & 0x03) << 30) |
			((uint32_t)input[18] << 22) |
			((uint32_t)(input[19] & 0xfe) << 14);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 159 to 175
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)input[21] << 15);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 176 to 192
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16) |
			((uint32_t)(input[24] & 0x80) << 8);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 193 to 209
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xc0) << 9);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 210 to 226
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xe0) << 10);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 227 to 243
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xf0) << 11);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 244 to 260
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf8) << 12);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 261 to 277
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xfc) << 13);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 278 to 294
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfe) << 14);
	output[16] = (double)(value >> 15);
}

static void unpack_17_17bit_signed_7off(const uint8_t * input, double * output) {
	// Unpack 17 values into output
	// Values are 17-bit signed
	// Skip 7 bits, read 289 bits of data.
	// Input must be at least 37 bytes long

	int32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 58 to 74
	value = ((uint32_t)(input[7] & 0x3f) << 26) |
			((uint32_t)input[8] << 18) |
			((uint32_t)(input[9] & 0xe0) << 10);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 75 to 91
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)(input[11] & 0xf0) << 11);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 92 to 108
	value = ((uint32_t)(input[11] & 0x0f) << 28) |
			((uint32_t)input[12] << 20) |
			((uint32_t)(input[13] & 0xf8) << 12);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 109 to 125
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0xfc) << 13);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 126 to 142
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xfe) << 14);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 143 to 159
	value = ((uint32_t)(input[17] & 0x01) << 31) |
			((uint32_t)input[18] << 23) |
			((uint32_t)input[19] << 15);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 160 to 176
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16) |
			((uint32_t)(input[22] & 0x80) << 8);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 177 to 193
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0xc0) << 9);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 194 to 210
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xe0) << 10);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 211 to 227
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xf0) << 11);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 228 to 244
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf8) << 12);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 245 to 261
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xfc) << 13);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 262 to 278
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfe) << 14);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 279 to 295
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)input[36] << 15);
	output[16] = (double)(value >> 15);
}

static void unpack_17_17bit_unsigned_7off(const uint8_t * input, double * output) {
	// Unpack 17 values into output
	// Values are 17-bit unsigned
	// Skip 7 bits, read 289 bits of data.
	// Input must be at least 37 bytes long

	uint32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 58 to 74
	value = ((uint32_t)(input[7] & 0x3f) << 26) |
			((uint32_t)input[8] << 18) |
			((uint32_t)(input[9] & 0xe0) << 10);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 75 to 91
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)(input[11] & 0xf0) << 11);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 92 to 108
	value = ((uint32_t)(input[11] & 0x0f) << 28) |
			((uint32_t)input[12] << 20) |
			((uint32_t)(input[13] & 0xf8) << 12);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 109 to 125
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0xfc) << 13);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 126 to 142
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xfe) << 14);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 143 to 159
	value = ((uint32_t)(input[17] & 0x01) << 31) |
			((uint32_t)input[18] << 23) |
			((uint32_t)input[19] << 15);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 160 to 176
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16) |
			((uint32_t)(input[22] & 0x80) << 8);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 177 to 193
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0xc0) << 9);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 194 to 210
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xe0) << 10);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 211 to 227
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xf0) << 11);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 228 to 244
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf8) << 12);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 245 to 261
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xfc) << 13);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 262 to 278
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfe) << 14);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 279 to 295
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)input[36] << 15);
	output[16] = (double)(value >> 15);
}

static void unpack_18_17bit_signed_0off(const uint8_t * input, double * output) {
	// Unpack 18 values into output
	// Values are 17-bit signed
	// Skip 0 bits, read 306 bits of data.
	// Input must be at least 39 bytes long

	int32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 51 to 67
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xf0) << 11);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 68 to 84
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf8) << 12);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 85 to 101
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xfc) << 13);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 102 to 118
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfe) << 14);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 119 to 135
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)input[16] << 15);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 136 to 152
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)input[18] << 16) |
			((uint32_t)(input[19] & 0x80) << 8);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 153 to 169
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xc0) << 9);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 170 to 186
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xe0) << 10);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 187 to 203
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)input[24] << 19) |
			((uint32_t)(input[25] & 0xf0) << 11);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 204 to 220
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20) |
			((uint32_t)(input[27] & 0xf8) << 12);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 221 to 237
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0xfc) << 13);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 238 to 254
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)(input[31] & 0xfe) << 14);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 255 to 271
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)input[33] << 15);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 272 to 288
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16) |
			((uint32_t)(input[36] & 0x80) << 8);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 289 to 305
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0xc0) << 9);
	output[17] = (double)(value >> 15);
}

static void unpack_18_17bit_unsigned_0off(const uint8_t * input, double * output) {
	// Unpack 18 values into output
	// Values are 17-bit unsigned
	// Skip 0 bits, read 306 bits of data.
	// Input must be at least 39 bytes long

	uint32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 51 to 67
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xf0) << 11);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 68 to 84
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf8) << 12);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 85 to 101
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xfc) << 13);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 102 to 118
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfe) << 14);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 119 to 135
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)input[16] << 15);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 136 to 152
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)input[18] << 16) |
			((uint32_t)(input[19] & 0x80) << 8);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 153 to 169
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xc0) << 9);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 170 to 186
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xe0) << 10);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 187 to 203
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)input[24] << 19) |
			((uint32_t)(input[25] & 0xf0) << 11);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 204 to 220
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20) |
			((uint32_t)(input[27] & 0xf8) << 12);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 221 to 237
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0xfc) << 13);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 238 to 254
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)(input[31] & 0xfe) << 14);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 255 to 271
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)input[33] << 15);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 272 to 288
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16) |
			((uint32_t)(input[36] & 0x80) << 8);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 289 to 305
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0xc0) << 9);
	output[17] = (double)(value >> 15);
}

static void unpack_18_17bit_signed_1off(const uint8_t * input, double * output) {
	// Unpack 18 values into output
	// Values are 17-bit signed
	// Skip 1 bits, read 306 bits of data.
	// Input must be at least 39 bytes long

	int32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 52 to 68
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf8) << 12);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 69 to 85
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xfc) << 13);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 86 to 102
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfe) << 14);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 103 to 119
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 120 to 136
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)(input[17] & 0x80) << 8);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 137 to 153
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)input[18] << 17) |
			((uint32_t)(input[19] & 0xc0) << 9);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 154 to 170
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xe0) << 10);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 171 to 187
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)(input[23] & 0xf0) << 11);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 188 to 204
	value = ((uint32_t)(input[23] & 0x0f) << 28) |
			((uint32_t)input[24] << 20) |
			((uint32_t)(input[25] & 0xf8) << 12);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 205 to 221
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0xfc) << 13);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 222 to 238
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xfe) << 14);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 239 to 255
	value = ((uint32_t)(input[29] & 0x01) << 31) |
			((uint32_t)input[30] << 23) |
			((uint32_t)input[31] << 15);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 256 to 272
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16) |
			((uint32_t)(input[34] & 0x80) << 8);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 273 to 289
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0xc0) << 9);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 290 to 306
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xe0) << 10);
	output[17] = (double)(value >> 15);
}

static void unpack_18_17bit_unsigned_1off(const uint8_t * input, double * output) {
	// Unpack 18 values into output
	// Values are 17-bit unsigned
	// Skip 1 bits, read 306 bits of data.
	// Input must be at least 39 bytes long

	uint32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 52 to 68
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf8) << 12);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 69 to 85
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xfc) << 13);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 86 to 102
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfe) << 14);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 103 to 119
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 120 to 136
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)(input[17] & 0x80) << 8);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 137 to 153
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)input[18] << 17) |
			((uint32_t)(input[19] & 0xc0) << 9);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 154 to 170
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xe0) << 10);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 171 to 187
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)(input[23] & 0xf0) << 11);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 188 to 204
	value = ((uint32_t)(input[23] & 0x0f) << 28) |
			((uint32_t)input[24] << 20) |
			((uint32_t)(input[25] & 0xf8) << 12);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 205 to 221
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0xfc) << 13);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 222 to 238
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xfe) << 14);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 239 to 255
	value = ((uint32_t)(input[29] & 0x01) << 31) |
			((uint32_t)input[30] << 23) |
			((uint32_t)input[31] << 15);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 256 to 272
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16) |
			((uint32_t)(input[34] & 0x80) << 8);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 273 to 289
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0xc0) << 9);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 290 to 306
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xe0) << 10);
	output[17] = (double)(value >> 15);
}

static void unpack_18_17bit_signed_2off(const uint8_t * input, double * output) {
	// Unpack 18 values into output
	// Values are 17-bit signed
	// Skip 2 bits, read 306 bits of data.
	// Input must be at least 39 bytes long

	int32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 53 to 69
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xfc) << 13);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 70 to 86
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfe) << 14);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 87 to 103
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 104 to 120
	value = ((uint32_t)input[13] << 24) |
			((uint32_t)input[14] << 16) |
			((uint32_t)(input[15] & 0x80) << 8);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 121 to 137
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)(input[17] & 0xc0) << 9);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 138 to 154
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)input[18] << 18) |
			((uint32_t)(input[19] & 0xe0) << 10);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 155 to 171
	value = ((uint32_t)(input[19] & 0x1f) << 27) |
			((uint32_t)input[20] << 19) |
			((uint32_t)(input[21] & 0xf0) << 11);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 172 to 188
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)(input[23] & 0xf8) << 12);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 189 to 205
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)(input[25] & 0xfc) << 13);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 206 to 222
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xfe) << 14);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 223 to 239
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 240 to 256
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)(input[32] & 0x80) << 8);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 257 to 273
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0xc0) << 9);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 274 to 290
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xe0) << 10);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 291 to 307
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xf0) << 11);
	output[17] = (double)(value >> 15);
}

static void unpack_18_17bit_unsigned_2off(const uint8_t * input, double * output) {
	// Unpack 18 values into output
	// Values are 17-bit unsigned
	// Skip 2 bits, read 306 bits of data.
	// Input must be at least 39 bytes long

	uint32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 53 to 69
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xfc) << 13);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 70 to 86
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfe) << 14);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 87 to 103
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 104 to 120
	value = ((uint32_t)input[13] << 24) |
			((uint32_t)input[14] << 16) |
			((uint32_t)(input[15] & 0x80) << 8);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 121 to 137
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)(input[17] & 0xc0) << 9);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 138 to 154
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)input[18] << 18) |
			((uint32_t)(input[19] & 0xe0) << 10);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 155 to 171
	value = ((uint32_t)(input[19] & 0x1f) << 27) |
			((uint32_t)input[20] << 19) |
			((uint32_t)(input[21] & 0xf0) << 11);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 172 to 188
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)(input[23] & 0xf8) << 12);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 189 to 205
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)(input[25] & 0xfc) << 13);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 206 to 222
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xfe) << 14);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 223 to 239
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 240 to 256
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)(input[32] & 0x80) << 8);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 257 to 273
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0xc0) << 9);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 274 to 290
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xe0) << 10);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 291 to 307
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xf0) << 11);
	output[17] = (double)(value >> 15);
}

static void unpack_18_17bit_signed_3off(const uint8_t * input, double * output) {
	// Unpack 18 values into output
	// Values are 17-bit signed
	// Skip 3 bits, read 306 bits of data.
	// Input must be at least 39 bytes long

	int32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 54 to 70
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfe) << 14);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 71 to 87
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)input[10] << 15);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 88 to 104
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0x80) << 8);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 105 to 121
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xc0) << 9);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 122 to 138
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)(input[17] & 0xe0) << 10);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 139 to 155
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)input[18] << 19) |
			((uint32_t)(input[19] & 0xf0) << 11);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 156 to 172
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20) |
			((uint32_t)(input[21] & 0xf8) << 12);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 173 to 189
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0xfc) << 13);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 190 to 206
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)(input[25] & 0xfe) << 14);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 207 to 223
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)input[27] << 15);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 224 to 240
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16) |
			((uint32_t)(input[30] & 0x80) << 8);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 241 to 257
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0xc0) << 9);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 258 to 274
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xe0) << 10);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 275 to 291
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xf0) << 11);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 292 to 308
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf8) << 12);
	output[17] = (double)(value >> 15);
}

static void unpack_18_17bit_unsigned_3off(const uint8_t * input, double * output) {
	// Unpack 18 values into output
	// Values are 17-bit unsigned
	// Skip 3 bits, read 306 bits of data.
	// Input must be at least 39 bytes long

	uint32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 54 to 70
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfe) << 14);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 71 to 87
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)input[10] << 15);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 88 to 104
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0x80) << 8);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 105 to 121
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xc0) << 9);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 122 to 138
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)(input[17] & 0xe0) << 10);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 139 to 155
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)input[18] << 19) |
			((uint32_t)(input[19] & 0xf0) << 11);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 156 to 172
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20) |
			((uint32_t)(input[21] & 0xf8) << 12);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 173 to 189
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0xfc) << 13);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 190 to 206
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)(input[25] & 0xfe) << 14);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 207 to 223
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)input[27] << 15);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 224 to 240
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16) |
			((uint32_t)(input[30] & 0x80) << 8);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 241 to 257
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0xc0) << 9);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 258 to 274
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xe0) << 10);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 275 to 291
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xf0) << 11);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 292 to 308
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf8) << 12);
	output[17] = (double)(value >> 15);
}

static void unpack_18_17bit_signed_4off(const uint8_t * input, double * output) {
	// Unpack 18 values into output
	// Values are 17-bit signed
	// Skip 4 bits, read 306 bits of data.
	// Input must be at least 39 bytes long

	int32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 55 to 71
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 72 to 88
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)(input[11] & 0x80) << 8);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 89 to 105
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xc0) << 9);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 106 to 122
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xe0) << 10);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 123 to 139
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)(input[17] & 0xf0) << 11);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 140 to 156
	value = ((uint32_t)(input[17] & 0x0f) << 28) |
			((uint32_t)input[18] << 20) |
			((uint32_t)(input[19] & 0xf8) << 12);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 157 to 173
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0xfc) << 13);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 174 to 190
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xfe) << 14);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 191 to 207
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 208 to 224
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16) |
			((uint32_t)(input[28] & 0x80) << 8);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 225 to 241
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0xc0) << 9);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 242 to 258
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xe0) << 10);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 259 to 275
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xf0) << 11);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 276 to 292
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf8) << 12);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 293 to 309
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xfc) << 13);
	output[17] = (double)(value >> 15);
}

static void unpack_18_17bit_unsigned_4off(const uint8_t * input, double * output) {
	// Unpack 18 values into output
	// Values are 17-bit unsigned
	// Skip 4 bits, read 306 bits of data.
	// Input must be at least 39 bytes long

	uint32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 55 to 71
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 72 to 88
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)(input[11] & 0x80) << 8);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 89 to 105
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xc0) << 9);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 106 to 122
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xe0) << 10);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 123 to 139
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)(input[17] & 0xf0) << 11);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 140 to 156
	value = ((uint32_t)(input[17] & 0x0f) << 28) |
			((uint32_t)input[18] << 20) |
			((uint32_t)(input[19] & 0xf8) << 12);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 157 to 173
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0xfc) << 13);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 174 to 190
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xfe) << 14);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 191 to 207
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 208 to 224
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16) |
			((uint32_t)(input[28] & 0x80) << 8);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 225 to 241
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0xc0) << 9);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 242 to 258
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xe0) << 10);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 259 to 275
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xf0) << 11);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 276 to 292
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf8) << 12);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 293 to 309
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xfc) << 13);
	output[17] = (double)(value >> 15);
}

static void unpack_18_17bit_signed_5off(const uint8_t * input, double * output) {
	// Unpack 18 values into output
	// Values are 17-bit signed
	// Skip 5 bits, read 306 bits of data.
	// Input must be at least 39 bytes long

	int32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 56 to 72
	value = ((uint32_t)input[7] << 24) |
			((uint32_t)input[8] << 16) |
			((uint32_t)(input[9] & 0x80) << 8);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 73 to 89
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)(input[11] & 0xc0) << 9);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 90 to 106
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xe0) << 10);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 107 to 123
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)(input[15] & 0xf0) << 11);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 124 to 140
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)(input[17] & 0xf8) << 12);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 141 to 157
	value = ((uint32_t)(input[17] & 0x07) << 29) |
			((uint32_t)input[18] << 21) |
			((uint32_t)(input[19] & 0xfc) << 13);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 158 to 174
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xfe) << 14);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 175 to 191
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 192 to 208
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0x80) << 8);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 209 to 225
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0xc0) << 9);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 226 to 242
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xe0) << 10);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 243 to 259
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xf0) << 11);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 260 to 276
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf8) << 12);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 277 to 293
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xfc) << 13);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 294 to 310
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfe) << 14);
	output[17] = (double)(value >> 15);
}

static void unpack_18_17bit_unsigned_5off(const uint8_t * input, double * output) {
	// Unpack 18 values into output
	// Values are 17-bit unsigned
	// Skip 5 bits, read 306 bits of data.
	// Input must be at least 39 bytes long

	uint32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 56 to 72
	value = ((uint32_t)input[7] << 24) |
			((uint32_t)input[8] << 16) |
			((uint32_t)(input[9] & 0x80) << 8);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 73 to 89
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)(input[11] & 0xc0) << 9);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 90 to 106
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xe0) << 10);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 107 to 123
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)(input[15] & 0xf0) << 11);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 124 to 140
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)(input[17] & 0xf8) << 12);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 141 to 157
	value = ((uint32_t)(input[17] & 0x07) << 29) |
			((uint32_t)input[18] << 21) |
			((uint32_t)(input[19] & 0xfc) << 13);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 158 to 174
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xfe) << 14);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 175 to 191
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 192 to 208
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0x80) << 8);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 209 to 225
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0xc0) << 9);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 226 to 242
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xe0) << 10);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 243 to 259
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xf0) << 11);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 260 to 276
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf8) << 12);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 277 to 293
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xfc) << 13);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 294 to 310
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfe) << 14);
	output[17] = (double)(value >> 15);
}

static void unpack_18_17bit_signed_6off(const uint8_t * input, double * output) {
	// Unpack 18 values into output
	// Values are 17-bit signed
	// Skip 6 bits, read 306 bits of data.
	// Input must be at least 39 bytes long

	int32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 57 to 73
	value = ((uint32_t)(input[7] & 0x7f) << 25) |
			((uint32_t)input[8] << 17) |
			((uint32_t)(input[9] & 0xc0) << 9);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 74 to 90
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)(input[11] & 0xe0) << 10);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 91 to 107
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)(input[13] & 0xf0) << 11);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 108 to 124
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)(input[15] & 0xf8) << 12);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 125 to 141
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0xfc) << 13);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 142 to 158
	value = ((uint32_t)(input[17] & 0x03) << 30) |
			((uint32_t)input[18] << 22) |
			((uint32_t)(input[19] & 0xfe) << 14);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 159 to 175
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)input[21] << 15);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 176 to 192
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16) |
			((uint32_t)(input[24] & 0x80) << 8);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 193 to 209
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xc0) << 9);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 210 to 226
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xe0) << 10);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 227 to 243
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xf0) << 11);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 244 to 260
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf8) << 12);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 261 to 277
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xfc) << 13);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 278 to 294
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfe) << 14);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 295 to 311
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15);
	output[17] = (double)(value >> 15);
}

static void unpack_18_17bit_unsigned_6off(const uint8_t * input, double * output) {
	// Unpack 18 values into output
	// Values are 17-bit unsigned
	// Skip 6 bits, read 306 bits of data.
	// Input must be at least 39 bytes long

	uint32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 57 to 73
	value = ((uint32_t)(input[7] & 0x7f) << 25) |
			((uint32_t)input[8] << 17) |
			((uint32_t)(input[9] & 0xc0) << 9);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 74 to 90
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)(input[11] & 0xe0) << 10);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 91 to 107
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)(input[13] & 0xf0) << 11);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 108 to 124
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)(input[15] & 0xf8) << 12);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 125 to 141
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0xfc) << 13);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 142 to 158
	value = ((uint32_t)(input[17] & 0x03) << 30) |
			((uint32_t)input[18] << 22) |
			((uint32_t)(input[19] & 0xfe) << 14);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 159 to 175
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)input[21] << 15);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 176 to 192
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16) |
			((uint32_t)(input[24] & 0x80) << 8);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 193 to 209
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xc0) << 9);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 210 to 226
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xe0) << 10);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 227 to 243
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xf0) << 11);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 244 to 260
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf8) << 12);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 261 to 277
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xfc) << 13);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 278 to 294
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfe) << 14);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 295 to 311
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15);
	output[17] = (double)(value >> 15);
}

static void unpack_18_17bit_signed_7off(const uint8_t * input, double * output) {
	// Unpack 18 values into output
	// Values are 17-bit signed
	// Skip 7 bits, read 306 bits of data.
	// Input must be at least 40 bytes long

	int32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 58 to 74
	value = ((uint32_t)(input[7] & 0x3f) << 26) |
			((uint32_t)input[8] << 18) |
			((uint32_t)(input[9] & 0xe0) << 10);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 75 to 91
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)(input[11] & 0xf0) << 11);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 92 to 108
	value = ((uint32_t)(input[11] & 0x0f) << 28) |
			((uint32_t)input[12] << 20) |
			((uint32_t)(input[13] & 0xf8) << 12);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 109 to 125
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0xfc) << 13);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 126 to 142
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xfe) << 14);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 143 to 159
	value = ((uint32_t)(input[17] & 0x01) << 31) |
			((uint32_t)input[18] << 23) |
			((uint32_t)input[19] << 15);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 160 to 176
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16) |
			((uint32_t)(input[22] & 0x80) << 8);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 177 to 193
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0xc0) << 9);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 194 to 210
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xe0) << 10);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 211 to 227
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xf0) << 11);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 228 to 244
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf8) << 12);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 245 to 261
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xfc) << 13);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 262 to 278
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfe) << 14);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 279 to 295
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)input[36] << 15);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 296 to 312
	value = ((uint32_t)input[37] << 24) |
			((uint32_t)input[38] << 16) |
			((uint32_t)(input[39] & 0x80) << 8);
	output[17] = (double)(value >> 15);
}

static void unpack_18_17bit_unsigned_7off(const uint8_t * input, double * output) {
	// Unpack 18 values into output
	// Values are 17-bit unsigned
	// Skip 7 bits, read 306 bits of data.
	// Input must be at least 40 bytes long

	uint32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 58 to 74
	value = ((uint32_t)(input[7] & 0x3f) << 26) |
			((uint32_t)input[8] << 18) |
			((uint32_t)(input[9] & 0xe0) << 10);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 75 to 91
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)(input[11] & 0xf0) << 11);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 92 to 108
	value = ((uint32_t)(input[11] & 0x0f) << 28) |
			((uint32_t)input[12] << 20) |
			((uint32_t)(input[13] & 0xf8) << 12);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 109 to 125
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0xfc) << 13);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 126 to 142
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xfe) << 14);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 143 to 159
	value = ((uint32_t)(input[17] & 0x01) << 31) |
			((uint32_t)input[18] << 23) |
			((uint32_t)input[19] << 15);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 160 to 176
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16) |
			((uint32_t)(input[22] & 0x80) << 8);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 177 to 193
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0xc0) << 9);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 194 to 210
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xe0) << 10);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 211 to 227
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xf0) << 11);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 228 to 244
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf8) << 12);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 245 to 261
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xfc) << 13);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 262 to 278
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfe) << 14);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 279 to 295
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)input[36] << 15);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 296 to 312
	value = ((uint32_t)input[37] << 24) |
			((uint32_t)input[38] << 16) |
			((uint32_t)(input[39] & 0x80) << 8);
	output[17] = (double)(value >> 15);
}

static void unpack_19_17bit_signed_0off(const uint8_t * input, double * output) {
	// Unpack 19 values into output
	// Values are 17-bit signed
	// Skip 0 bits, read 323 bits of data.
	// Input must be at least 41 bytes long

	int32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 51 to 67
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xf0) << 11);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 68 to 84
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf8) << 12);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 85 to 101
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xfc) << 13);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 102 to 118
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfe) << 14);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 119 to 135
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)input[16] << 15);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 136 to 152
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)input[18] << 16) |
			((uint32_t)(input[19] & 0x80) << 8);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 153 to 169
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xc0) << 9);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 170 to 186
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xe0) << 10);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 187 to 203
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)input[24] << 19) |
			((uint32_t)(input[25] & 0xf0) << 11);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 204 to 220
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20) |
			((uint32_t)(input[27] & 0xf8) << 12);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 221 to 237
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0xfc) << 13);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 238 to 254
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)(input[31] & 0xfe) << 14);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 255 to 271
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)input[33] << 15);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 272 to 288
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16) |
			((uint32_t)(input[36] & 0x80) << 8);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 289 to 305
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0xc0) << 9);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 306 to 322
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xe0) << 10);
	output[18] = (double)(value >> 15);
}

static void unpack_19_17bit_unsigned_0off(const uint8_t * input, double * output) {
	// Unpack 19 values into output
	// Values are 17-bit unsigned
	// Skip 0 bits, read 323 bits of data.
	// Input must be at least 41 bytes long

	uint32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 51 to 67
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xf0) << 11);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 68 to 84
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf8) << 12);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 85 to 101
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xfc) << 13);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 102 to 118
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfe) << 14);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 119 to 135
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)input[16] << 15);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 136 to 152
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)input[18] << 16) |
			((uint32_t)(input[19] & 0x80) << 8);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 153 to 169
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xc0) << 9);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 170 to 186
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xe0) << 10);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 187 to 203
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)input[24] << 19) |
			((uint32_t)(input[25] & 0xf0) << 11);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 204 to 220
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20) |
			((uint32_t)(input[27] & 0xf8) << 12);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 221 to 237
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0xfc) << 13);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 238 to 254
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)(input[31] & 0xfe) << 14);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 255 to 271
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)input[33] << 15);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 272 to 288
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16) |
			((uint32_t)(input[36] & 0x80) << 8);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 289 to 305
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0xc0) << 9);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 306 to 322
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xe0) << 10);
	output[18] = (double)(value >> 15);
}

static void unpack_19_17bit_signed_1off(const uint8_t * input, double * output) {
	// Unpack 19 values into output
	// Values are 17-bit signed
	// Skip 1 bits, read 323 bits of data.
	// Input must be at least 41 bytes long

	int32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 52 to 68
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf8) << 12);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 69 to 85
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xfc) << 13);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 86 to 102
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfe) << 14);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 103 to 119
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 120 to 136
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)(input[17] & 0x80) << 8);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 137 to 153
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)input[18] << 17) |
			((uint32_t)(input[19] & 0xc0) << 9);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 154 to 170
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xe0) << 10);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 171 to 187
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)(input[23] & 0xf0) << 11);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 188 to 204
	value = ((uint32_t)(input[23] & 0x0f) << 28) |
			((uint32_t)input[24] << 20) |
			((uint32_t)(input[25] & 0xf8) << 12);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 205 to 221
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0xfc) << 13);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 222 to 238
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xfe) << 14);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 239 to 255
	value = ((uint32_t)(input[29] & 0x01) << 31) |
			((uint32_t)input[30] << 23) |
			((uint32_t)input[31] << 15);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 256 to 272
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16) |
			((uint32_t)(input[34] & 0x80) << 8);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 273 to 289
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0xc0) << 9);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 290 to 306
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xe0) << 10);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 307 to 323
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xf0) << 11);
	output[18] = (double)(value >> 15);
}

static void unpack_19_17bit_unsigned_1off(const uint8_t * input, double * output) {
	// Unpack 19 values into output
	// Values are 17-bit unsigned
	// Skip 1 bits, read 323 bits of data.
	// Input must be at least 41 bytes long

	uint32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 52 to 68
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf8) << 12);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 69 to 85
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xfc) << 13);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 86 to 102
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfe) << 14);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 103 to 119
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 120 to 136
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)(input[17] & 0x80) << 8);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 137 to 153
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)input[18] << 17) |
			((uint32_t)(input[19] & 0xc0) << 9);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 154 to 170
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xe0) << 10);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 171 to 187
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)(input[23] & 0xf0) << 11);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 188 to 204
	value = ((uint32_t)(input[23] & 0x0f) << 28) |
			((uint32_t)input[24] << 20) |
			((uint32_t)(input[25] & 0xf8) << 12);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 205 to 221
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0xfc) << 13);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 222 to 238
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xfe) << 14);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 239 to 255
	value = ((uint32_t)(input[29] & 0x01) << 31) |
			((uint32_t)input[30] << 23) |
			((uint32_t)input[31] << 15);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 256 to 272
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16) |
			((uint32_t)(input[34] & 0x80) << 8);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 273 to 289
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0xc0) << 9);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 290 to 306
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xe0) << 10);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 307 to 323
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xf0) << 11);
	output[18] = (double)(value >> 15);
}

static void unpack_19_17bit_signed_2off(const uint8_t * input, double * output) {
	// Unpack 19 values into output
	// Values are 17-bit signed
	// Skip 2 bits, read 323 bits of data.
	// Input must be at least 41 bytes long

	int32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 53 to 69
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xfc) << 13);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 70 to 86
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfe) << 14);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 87 to 103
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 104 to 120
	value = ((uint32_t)input[13] << 24) |
			((uint32_t)input[14] << 16) |
			((uint32_t)(input[15] & 0x80) << 8);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 121 to 137
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)(input[17] & 0xc0) << 9);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 138 to 154
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)input[18] << 18) |
			((uint32_t)(input[19] & 0xe0) << 10);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 155 to 171
	value = ((uint32_t)(input[19] & 0x1f) << 27) |
			((uint32_t)input[20] << 19) |
			((uint32_t)(input[21] & 0xf0) << 11);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 172 to 188
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)(input[23] & 0xf8) << 12);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 189 to 205
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)(input[25] & 0xfc) << 13);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 206 to 222
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xfe) << 14);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 223 to 239
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 240 to 256
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)(input[32] & 0x80) << 8);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 257 to 273
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0xc0) << 9);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 274 to 290
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xe0) << 10);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 291 to 307
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xf0) << 11);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 308 to 324
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf8) << 12);
	output[18] = (double)(value >> 15);
}

static void unpack_19_17bit_unsigned_2off(const uint8_t * input, double * output) {
	// Unpack 19 values into output
	// Values are 17-bit unsigned
	// Skip 2 bits, read 323 bits of data.
	// Input must be at least 41 bytes long

	uint32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 53 to 69
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xfc) << 13);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 70 to 86
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfe) << 14);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 87 to 103
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 104 to 120
	value = ((uint32_t)input[13] << 24) |
			((uint32_t)input[14] << 16) |
			((uint32_t)(input[15] & 0x80) << 8);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 121 to 137
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)(input[17] & 0xc0) << 9);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 138 to 154
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)input[18] << 18) |
			((uint32_t)(input[19] & 0xe0) << 10);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 155 to 171
	value = ((uint32_t)(input[19] & 0x1f) << 27) |
			((uint32_t)input[20] << 19) |
			((uint32_t)(input[21] & 0xf0) << 11);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 172 to 188
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)(input[23] & 0xf8) << 12);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 189 to 205
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)(input[25] & 0xfc) << 13);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 206 to 222
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xfe) << 14);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 223 to 239
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 240 to 256
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)(input[32] & 0x80) << 8);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 257 to 273
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0xc0) << 9);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 274 to 290
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xe0) << 10);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 291 to 307
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xf0) << 11);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 308 to 324
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf8) << 12);
	output[18] = (double)(value >> 15);
}

static void unpack_19_17bit_signed_3off(const uint8_t * input, double * output) {
	// Unpack 19 values into output
	// Values are 17-bit signed
	// Skip 3 bits, read 323 bits of data.
	// Input must be at least 41 bytes long

	int32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 54 to 70
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfe) << 14);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 71 to 87
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)input[10] << 15);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 88 to 104
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0x80) << 8);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 105 to 121
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xc0) << 9);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 122 to 138
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)(input[17] & 0xe0) << 10);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 139 to 155
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)input[18] << 19) |
			((uint32_t)(input[19] & 0xf0) << 11);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 156 to 172
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20) |
			((uint32_t)(input[21] & 0xf8) << 12);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 173 to 189
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0xfc) << 13);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 190 to 206
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)(input[25] & 0xfe) << 14);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 207 to 223
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)input[27] << 15);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 224 to 240
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16) |
			((uint32_t)(input[30] & 0x80) << 8);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 241 to 257
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0xc0) << 9);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 258 to 274
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xe0) << 10);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 275 to 291
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xf0) << 11);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 292 to 308
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf8) << 12);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 309 to 325
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xfc) << 13);
	output[18] = (double)(value >> 15);
}

static void unpack_19_17bit_unsigned_3off(const uint8_t * input, double * output) {
	// Unpack 19 values into output
	// Values are 17-bit unsigned
	// Skip 3 bits, read 323 bits of data.
	// Input must be at least 41 bytes long

	uint32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 54 to 70
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfe) << 14);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 71 to 87
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)input[10] << 15);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 88 to 104
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0x80) << 8);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 105 to 121
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xc0) << 9);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 122 to 138
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)(input[17] & 0xe0) << 10);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 139 to 155
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)input[18] << 19) |
			((uint32_t)(input[19] & 0xf0) << 11);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 156 to 172
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20) |
			((uint32_t)(input[21] & 0xf8) << 12);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 173 to 189
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0xfc) << 13);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 190 to 206
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)(input[25] & 0xfe) << 14);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 207 to 223
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)input[27] << 15);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 224 to 240
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16) |
			((uint32_t)(input[30] & 0x80) << 8);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 241 to 257
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0xc0) << 9);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 258 to 274
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xe0) << 10);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 275 to 291
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xf0) << 11);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 292 to 308
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf8) << 12);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 309 to 325
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xfc) << 13);
	output[18] = (double)(value >> 15);
}

static void unpack_19_17bit_signed_4off(const uint8_t * input, double * output) {
	// Unpack 19 values into output
	// Values are 17-bit signed
	// Skip 4 bits, read 323 bits of data.
	// Input must be at least 41 bytes long

	int32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 55 to 71
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 72 to 88
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)(input[11] & 0x80) << 8);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 89 to 105
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xc0) << 9);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 106 to 122
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xe0) << 10);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 123 to 139
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)(input[17] & 0xf0) << 11);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 140 to 156
	value = ((uint32_t)(input[17] & 0x0f) << 28) |
			((uint32_t)input[18] << 20) |
			((uint32_t)(input[19] & 0xf8) << 12);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 157 to 173
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0xfc) << 13);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 174 to 190
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xfe) << 14);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 191 to 207
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 208 to 224
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16) |
			((uint32_t)(input[28] & 0x80) << 8);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 225 to 241
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0xc0) << 9);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 242 to 258
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xe0) << 10);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 259 to 275
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xf0) << 11);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 276 to 292
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf8) << 12);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 293 to 309
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xfc) << 13);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 310 to 326
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfe) << 14);
	output[18] = (double)(value >> 15);
}

static void unpack_19_17bit_unsigned_4off(const uint8_t * input, double * output) {
	// Unpack 19 values into output
	// Values are 17-bit unsigned
	// Skip 4 bits, read 323 bits of data.
	// Input must be at least 41 bytes long

	uint32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 55 to 71
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 72 to 88
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)(input[11] & 0x80) << 8);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 89 to 105
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xc0) << 9);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 106 to 122
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xe0) << 10);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 123 to 139
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)(input[17] & 0xf0) << 11);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 140 to 156
	value = ((uint32_t)(input[17] & 0x0f) << 28) |
			((uint32_t)input[18] << 20) |
			((uint32_t)(input[19] & 0xf8) << 12);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 157 to 173
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0xfc) << 13);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 174 to 190
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xfe) << 14);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 191 to 207
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 208 to 224
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16) |
			((uint32_t)(input[28] & 0x80) << 8);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 225 to 241
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0xc0) << 9);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 242 to 258
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xe0) << 10);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 259 to 275
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xf0) << 11);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 276 to 292
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf8) << 12);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 293 to 309
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xfc) << 13);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 310 to 326
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfe) << 14);
	output[18] = (double)(value >> 15);
}

static void unpack_19_17bit_signed_5off(const uint8_t * input, double * output) {
	// Unpack 19 values into output
	// Values are 17-bit signed
	// Skip 5 bits, read 323 bits of data.
	// Input must be at least 41 bytes long

	int32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 56 to 72
	value = ((uint32_t)input[7] << 24) |
			((uint32_t)input[8] << 16) |
			((uint32_t)(input[9] & 0x80) << 8);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 73 to 89
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)(input[11] & 0xc0) << 9);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 90 to 106
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xe0) << 10);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 107 to 123
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)(input[15] & 0xf0) << 11);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 124 to 140
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)(input[17] & 0xf8) << 12);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 141 to 157
	value = ((uint32_t)(input[17] & 0x07) << 29) |
			((uint32_t)input[18] << 21) |
			((uint32_t)(input[19] & 0xfc) << 13);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 158 to 174
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xfe) << 14);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 175 to 191
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 192 to 208
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0x80) << 8);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 209 to 225
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0xc0) << 9);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 226 to 242
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xe0) << 10);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 243 to 259
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xf0) << 11);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 260 to 276
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf8) << 12);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 277 to 293
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xfc) << 13);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 294 to 310
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfe) << 14);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 311 to 327
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)input[40] << 15);
	output[18] = (double)(value >> 15);
}

static void unpack_19_17bit_unsigned_5off(const uint8_t * input, double * output) {
	// Unpack 19 values into output
	// Values are 17-bit unsigned
	// Skip 5 bits, read 323 bits of data.
	// Input must be at least 41 bytes long

	uint32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 56 to 72
	value = ((uint32_t)input[7] << 24) |
			((uint32_t)input[8] << 16) |
			((uint32_t)(input[9] & 0x80) << 8);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 73 to 89
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)(input[11] & 0xc0) << 9);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 90 to 106
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xe0) << 10);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 107 to 123
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)(input[15] & 0xf0) << 11);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 124 to 140
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)(input[17] & 0xf8) << 12);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 141 to 157
	value = ((uint32_t)(input[17] & 0x07) << 29) |
			((uint32_t)input[18] << 21) |
			((uint32_t)(input[19] & 0xfc) << 13);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 158 to 174
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xfe) << 14);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 175 to 191
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 192 to 208
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0x80) << 8);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 209 to 225
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0xc0) << 9);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 226 to 242
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xe0) << 10);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 243 to 259
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xf0) << 11);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 260 to 276
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf8) << 12);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 277 to 293
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xfc) << 13);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 294 to 310
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfe) << 14);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 311 to 327
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)input[40] << 15);
	output[18] = (double)(value >> 15);
}

static void unpack_19_17bit_signed_6off(const uint8_t * input, double * output) {
	// Unpack 19 values into output
	// Values are 17-bit signed
	// Skip 6 bits, read 323 bits of data.
	// Input must be at least 42 bytes long

	int32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 57 to 73
	value = ((uint32_t)(input[7] & 0x7f) << 25) |
			((uint32_t)input[8] << 17) |
			((uint32_t)(input[9] & 0xc0) << 9);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 74 to 90
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)(input[11] & 0xe0) << 10);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 91 to 107
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)(input[13] & 0xf0) << 11);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 108 to 124
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)(input[15] & 0xf8) << 12);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 125 to 141
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0xfc) << 13);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 142 to 158
	value = ((uint32_t)(input[17] & 0x03) << 30) |
			((uint32_t)input[18] << 22) |
			((uint32_t)(input[19] & 0xfe) << 14);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 159 to 175
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)input[21] << 15);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 176 to 192
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16) |
			((uint32_t)(input[24] & 0x80) << 8);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 193 to 209
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xc0) << 9);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 210 to 226
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xe0) << 10);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 227 to 243
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xf0) << 11);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 244 to 260
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf8) << 12);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 261 to 277
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xfc) << 13);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 278 to 294
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfe) << 14);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 295 to 311
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 312 to 328
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)(input[41] & 0x80) << 8);
	output[18] = (double)(value >> 15);
}

static void unpack_19_17bit_unsigned_6off(const uint8_t * input, double * output) {
	// Unpack 19 values into output
	// Values are 17-bit unsigned
	// Skip 6 bits, read 323 bits of data.
	// Input must be at least 42 bytes long

	uint32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 57 to 73
	value = ((uint32_t)(input[7] & 0x7f) << 25) |
			((uint32_t)input[8] << 17) |
			((uint32_t)(input[9] & 0xc0) << 9);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 74 to 90
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)(input[11] & 0xe0) << 10);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 91 to 107
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)(input[13] & 0xf0) << 11);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 108 to 124
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)(input[15] & 0xf8) << 12);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 125 to 141
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0xfc) << 13);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 142 to 158
	value = ((uint32_t)(input[17] & 0x03) << 30) |
			((uint32_t)input[18] << 22) |
			((uint32_t)(input[19] & 0xfe) << 14);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 159 to 175
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)input[21] << 15);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 176 to 192
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16) |
			((uint32_t)(input[24] & 0x80) << 8);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 193 to 209
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xc0) << 9);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 210 to 226
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xe0) << 10);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 227 to 243
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xf0) << 11);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 244 to 260
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf8) << 12);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 261 to 277
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xfc) << 13);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 278 to 294
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfe) << 14);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 295 to 311
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 312 to 328
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)(input[41] & 0x80) << 8);
	output[18] = (double)(value >> 15);
}

static void unpack_19_17bit_signed_7off(const uint8_t * input, double * output) {
	// Unpack 19 values into output
	// Values are 17-bit signed
	// Skip 7 bits, read 323 bits of data.
	// Input must be at least 42 bytes long

	int32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 58 to 74
	value = ((uint32_t)(input[7] & 0x3f) << 26) |
			((uint32_t)input[8] << 18) |
			((uint32_t)(input[9] & 0xe0) << 10);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 75 to 91
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)(input[11] & 0xf0) << 11);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 92 to 108
	value = ((uint32_t)(input[11] & 0x0f) << 28) |
			((uint32_t)input[12] << 20) |
			((uint32_t)(input[13] & 0xf8) << 12);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 109 to 125
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0xfc) << 13);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 126 to 142
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xfe) << 14);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 143 to 159
	value = ((uint32_t)(input[17] & 0x01) << 31) |
			((uint32_t)input[18] << 23) |
			((uint32_t)input[19] << 15);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 160 to 176
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16) |
			((uint32_t)(input[22] & 0x80) << 8);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 177 to 193
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0xc0) << 9);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 194 to 210
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xe0) << 10);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 211 to 227
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xf0) << 11);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 228 to 244
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf8) << 12);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 245 to 261
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xfc) << 13);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 262 to 278
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfe) << 14);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 279 to 295
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)input[36] << 15);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 296 to 312
	value = ((uint32_t)input[37] << 24) |
			((uint32_t)input[38] << 16) |
			((uint32_t)(input[39] & 0x80) << 8);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 313 to 329
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)(input[41] & 0xc0) << 9);
	output[18] = (double)(value >> 15);
}

static void unpack_19_17bit_unsigned_7off(const uint8_t * input, double * output) {
	// Unpack 19 values into output
	// Values are 17-bit unsigned
	// Skip 7 bits, read 323 bits of data.
	// Input must be at least 42 bytes long

	uint32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 58 to 74
	value = ((uint32_t)(input[7] & 0x3f) << 26) |
			((uint32_t)input[8] << 18) |
			((uint32_t)(input[9] & 0xe0) << 10);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 75 to 91
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)(input[11] & 0xf0) << 11);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 92 to 108
	value = ((uint32_t)(input[11] & 0x0f) << 28) |
			((uint32_t)input[12] << 20) |
			((uint32_t)(input[13] & 0xf8) << 12);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 109 to 125
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0xfc) << 13);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 126 to 142
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xfe) << 14);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 143 to 159
	value = ((uint32_t)(input[17] & 0x01) << 31) |
			((uint32_t)input[18] << 23) |
			((uint32_t)input[19] << 15);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 160 to 176
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16) |
			((uint32_t)(input[22] & 0x80) << 8);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 177 to 193
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0xc0) << 9);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 194 to 210
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xe0) << 10);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 211 to 227
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xf0) << 11);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 228 to 244
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf8) << 12);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 245 to 261
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xfc) << 13);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 262 to 278
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfe) << 14);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 279 to 295
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)input[36] << 15);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 296 to 312
	value = ((uint32_t)input[37] << 24) |
			((uint32_t)input[38] << 16) |
			((uint32_t)(input[39] & 0x80) << 8);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 313 to 329
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)(input[41] & 0xc0) << 9);
	output[18] = (double)(value >> 15);
}

static void unpack_20_17bit_signed_0off(const uint8_t * input, double * output) {
	// Unpack 20 values into output
	// Values are 17-bit signed
	// Skip 0 bits, read 340 bits of data.
	// Input must be at least 43 bytes long

	int32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 51 to 67
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xf0) << 11);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 68 to 84
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf8) << 12);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 85 to 101
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xfc) << 13);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 102 to 118
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfe) << 14);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 119 to 135
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)input[16] << 15);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 136 to 152
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)input[18] << 16) |
			((uint32_t)(input[19] & 0x80) << 8);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 153 to 169
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xc0) << 9);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 170 to 186
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xe0) << 10);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 187 to 203
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)input[24] << 19) |
			((uint32_t)(input[25] & 0xf0) << 11);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 204 to 220
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20) |
			((uint32_t)(input[27] & 0xf8) << 12);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 221 to 237
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0xfc) << 13);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 238 to 254
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)(input[31] & 0xfe) << 14);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 255 to 271
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)input[33] << 15);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 272 to 288
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16) |
			((uint32_t)(input[36] & 0x80) << 8);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 289 to 305
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0xc0) << 9);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 306 to 322
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xe0) << 10);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 323 to 339
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xf0) << 11);
	output[19] = (double)(value >> 15);
}

static void unpack_20_17bit_unsigned_0off(const uint8_t * input, double * output) {
	// Unpack 20 values into output
	// Values are 17-bit unsigned
	// Skip 0 bits, read 340 bits of data.
	// Input must be at least 43 bytes long

	uint32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 51 to 67
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xf0) << 11);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 68 to 84
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf8) << 12);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 85 to 101
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xfc) << 13);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 102 to 118
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfe) << 14);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 119 to 135
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)input[16] << 15);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 136 to 152
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)input[18] << 16) |
			((uint32_t)(input[19] & 0x80) << 8);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 153 to 169
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xc0) << 9);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 170 to 186
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xe0) << 10);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 187 to 203
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)input[24] << 19) |
			((uint32_t)(input[25] & 0xf0) << 11);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 204 to 220
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20) |
			((uint32_t)(input[27] & 0xf8) << 12);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 221 to 237
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0xfc) << 13);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 238 to 254
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)(input[31] & 0xfe) << 14);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 255 to 271
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)input[33] << 15);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 272 to 288
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16) |
			((uint32_t)(input[36] & 0x80) << 8);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 289 to 305
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0xc0) << 9);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 306 to 322
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xe0) << 10);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 323 to 339
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xf0) << 11);
	output[19] = (double)(value >> 15);
}

static void unpack_20_17bit_signed_1off(const uint8_t * input, double * output) {
	// Unpack 20 values into output
	// Values are 17-bit signed
	// Skip 1 bits, read 340 bits of data.
	// Input must be at least 43 bytes long

	int32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 52 to 68
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf8) << 12);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 69 to 85
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xfc) << 13);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 86 to 102
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfe) << 14);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 103 to 119
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 120 to 136
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)(input[17] & 0x80) << 8);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 137 to 153
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)input[18] << 17) |
			((uint32_t)(input[19] & 0xc0) << 9);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 154 to 170
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xe0) << 10);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 171 to 187
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)(input[23] & 0xf0) << 11);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 188 to 204
	value = ((uint32_t)(input[23] & 0x0f) << 28) |
			((uint32_t)input[24] << 20) |
			((uint32_t)(input[25] & 0xf8) << 12);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 205 to 221
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0xfc) << 13);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 222 to 238
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xfe) << 14);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 239 to 255
	value = ((uint32_t)(input[29] & 0x01) << 31) |
			((uint32_t)input[30] << 23) |
			((uint32_t)input[31] << 15);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 256 to 272
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16) |
			((uint32_t)(input[34] & 0x80) << 8);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 273 to 289
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0xc0) << 9);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 290 to 306
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xe0) << 10);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 307 to 323
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xf0) << 11);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 324 to 340
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf8) << 12);
	output[19] = (double)(value >> 15);
}

static void unpack_20_17bit_unsigned_1off(const uint8_t * input, double * output) {
	// Unpack 20 values into output
	// Values are 17-bit unsigned
	// Skip 1 bits, read 340 bits of data.
	// Input must be at least 43 bytes long

	uint32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 52 to 68
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf8) << 12);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 69 to 85
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xfc) << 13);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 86 to 102
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfe) << 14);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 103 to 119
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 120 to 136
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)(input[17] & 0x80) << 8);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 137 to 153
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)input[18] << 17) |
			((uint32_t)(input[19] & 0xc0) << 9);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 154 to 170
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xe0) << 10);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 171 to 187
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)(input[23] & 0xf0) << 11);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 188 to 204
	value = ((uint32_t)(input[23] & 0x0f) << 28) |
			((uint32_t)input[24] << 20) |
			((uint32_t)(input[25] & 0xf8) << 12);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 205 to 221
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0xfc) << 13);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 222 to 238
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xfe) << 14);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 239 to 255
	value = ((uint32_t)(input[29] & 0x01) << 31) |
			((uint32_t)input[30] << 23) |
			((uint32_t)input[31] << 15);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 256 to 272
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16) |
			((uint32_t)(input[34] & 0x80) << 8);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 273 to 289
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0xc0) << 9);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 290 to 306
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xe0) << 10);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 307 to 323
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xf0) << 11);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 324 to 340
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf8) << 12);
	output[19] = (double)(value >> 15);
}

static void unpack_20_17bit_signed_2off(const uint8_t * input, double * output) {
	// Unpack 20 values into output
	// Values are 17-bit signed
	// Skip 2 bits, read 340 bits of data.
	// Input must be at least 43 bytes long

	int32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 53 to 69
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xfc) << 13);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 70 to 86
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfe) << 14);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 87 to 103
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 104 to 120
	value = ((uint32_t)input[13] << 24) |
			((uint32_t)input[14] << 16) |
			((uint32_t)(input[15] & 0x80) << 8);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 121 to 137
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)(input[17] & 0xc0) << 9);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 138 to 154
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)input[18] << 18) |
			((uint32_t)(input[19] & 0xe0) << 10);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 155 to 171
	value = ((uint32_t)(input[19] & 0x1f) << 27) |
			((uint32_t)input[20] << 19) |
			((uint32_t)(input[21] & 0xf0) << 11);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 172 to 188
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)(input[23] & 0xf8) << 12);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 189 to 205
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)(input[25] & 0xfc) << 13);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 206 to 222
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xfe) << 14);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 223 to 239
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 240 to 256
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)(input[32] & 0x80) << 8);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 257 to 273
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0xc0) << 9);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 274 to 290
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xe0) << 10);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 291 to 307
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xf0) << 11);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 308 to 324
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf8) << 12);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 325 to 341
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xfc) << 13);
	output[19] = (double)(value >> 15);
}

static void unpack_20_17bit_unsigned_2off(const uint8_t * input, double * output) {
	// Unpack 20 values into output
	// Values are 17-bit unsigned
	// Skip 2 bits, read 340 bits of data.
	// Input must be at least 43 bytes long

	uint32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 53 to 69
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xfc) << 13);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 70 to 86
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfe) << 14);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 87 to 103
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 104 to 120
	value = ((uint32_t)input[13] << 24) |
			((uint32_t)input[14] << 16) |
			((uint32_t)(input[15] & 0x80) << 8);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 121 to 137
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)(input[17] & 0xc0) << 9);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 138 to 154
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)input[18] << 18) |
			((uint32_t)(input[19] & 0xe0) << 10);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 155 to 171
	value = ((uint32_t)(input[19] & 0x1f) << 27) |
			((uint32_t)input[20] << 19) |
			((uint32_t)(input[21] & 0xf0) << 11);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 172 to 188
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)(input[23] & 0xf8) << 12);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 189 to 205
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)(input[25] & 0xfc) << 13);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 206 to 222
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xfe) << 14);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 223 to 239
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 240 to 256
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)(input[32] & 0x80) << 8);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 257 to 273
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0xc0) << 9);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 274 to 290
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xe0) << 10);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 291 to 307
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xf0) << 11);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 308 to 324
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf8) << 12);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 325 to 341
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xfc) << 13);
	output[19] = (double)(value >> 15);
}

static void unpack_20_17bit_signed_3off(const uint8_t * input, double * output) {
	// Unpack 20 values into output
	// Values are 17-bit signed
	// Skip 3 bits, read 340 bits of data.
	// Input must be at least 43 bytes long

	int32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 54 to 70
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfe) << 14);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 71 to 87
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)input[10] << 15);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 88 to 104
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0x80) << 8);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 105 to 121
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xc0) << 9);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 122 to 138
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)(input[17] & 0xe0) << 10);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 139 to 155
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)input[18] << 19) |
			((uint32_t)(input[19] & 0xf0) << 11);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 156 to 172
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20) |
			((uint32_t)(input[21] & 0xf8) << 12);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 173 to 189
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0xfc) << 13);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 190 to 206
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)(input[25] & 0xfe) << 14);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 207 to 223
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)input[27] << 15);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 224 to 240
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16) |
			((uint32_t)(input[30] & 0x80) << 8);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 241 to 257
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0xc0) << 9);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 258 to 274
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xe0) << 10);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 275 to 291
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xf0) << 11);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 292 to 308
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf8) << 12);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 309 to 325
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xfc) << 13);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 326 to 342
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfe) << 14);
	output[19] = (double)(value >> 15);
}

static void unpack_20_17bit_unsigned_3off(const uint8_t * input, double * output) {
	// Unpack 20 values into output
	// Values are 17-bit unsigned
	// Skip 3 bits, read 340 bits of data.
	// Input must be at least 43 bytes long

	uint32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 54 to 70
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfe) << 14);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 71 to 87
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)input[10] << 15);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 88 to 104
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0x80) << 8);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 105 to 121
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xc0) << 9);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 122 to 138
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)(input[17] & 0xe0) << 10);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 139 to 155
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)input[18] << 19) |
			((uint32_t)(input[19] & 0xf0) << 11);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 156 to 172
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20) |
			((uint32_t)(input[21] & 0xf8) << 12);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 173 to 189
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0xfc) << 13);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 190 to 206
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)(input[25] & 0xfe) << 14);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 207 to 223
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)input[27] << 15);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 224 to 240
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16) |
			((uint32_t)(input[30] & 0x80) << 8);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 241 to 257
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0xc0) << 9);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 258 to 274
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xe0) << 10);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 275 to 291
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xf0) << 11);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 292 to 308
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf8) << 12);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 309 to 325
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xfc) << 13);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 326 to 342
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfe) << 14);
	output[19] = (double)(value >> 15);
}

static void unpack_20_17bit_signed_4off(const uint8_t * input, double * output) {
	// Unpack 20 values into output
	// Values are 17-bit signed
	// Skip 4 bits, read 340 bits of data.
	// Input must be at least 43 bytes long

	int32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 55 to 71
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 72 to 88
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)(input[11] & 0x80) << 8);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 89 to 105
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xc0) << 9);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 106 to 122
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xe0) << 10);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 123 to 139
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)(input[17] & 0xf0) << 11);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 140 to 156
	value = ((uint32_t)(input[17] & 0x0f) << 28) |
			((uint32_t)input[18] << 20) |
			((uint32_t)(input[19] & 0xf8) << 12);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 157 to 173
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0xfc) << 13);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 174 to 190
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xfe) << 14);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 191 to 207
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 208 to 224
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16) |
			((uint32_t)(input[28] & 0x80) << 8);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 225 to 241
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0xc0) << 9);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 242 to 258
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xe0) << 10);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 259 to 275
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xf0) << 11);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 276 to 292
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf8) << 12);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 293 to 309
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xfc) << 13);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 310 to 326
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfe) << 14);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 327 to 343
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)input[42] << 15);
	output[19] = (double)(value >> 15);
}

static void unpack_20_17bit_unsigned_4off(const uint8_t * input, double * output) {
	// Unpack 20 values into output
	// Values are 17-bit unsigned
	// Skip 4 bits, read 340 bits of data.
	// Input must be at least 43 bytes long

	uint32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 55 to 71
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 72 to 88
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)(input[11] & 0x80) << 8);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 89 to 105
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xc0) << 9);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 106 to 122
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xe0) << 10);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 123 to 139
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)(input[17] & 0xf0) << 11);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 140 to 156
	value = ((uint32_t)(input[17] & 0x0f) << 28) |
			((uint32_t)input[18] << 20) |
			((uint32_t)(input[19] & 0xf8) << 12);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 157 to 173
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0xfc) << 13);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 174 to 190
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xfe) << 14);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 191 to 207
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 208 to 224
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16) |
			((uint32_t)(input[28] & 0x80) << 8);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 225 to 241
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0xc0) << 9);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 242 to 258
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xe0) << 10);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 259 to 275
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xf0) << 11);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 276 to 292
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf8) << 12);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 293 to 309
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xfc) << 13);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 310 to 326
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfe) << 14);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 327 to 343
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)input[42] << 15);
	output[19] = (double)(value >> 15);
}

static void unpack_20_17bit_signed_5off(const uint8_t * input, double * output) {
	// Unpack 20 values into output
	// Values are 17-bit signed
	// Skip 5 bits, read 340 bits of data.
	// Input must be at least 44 bytes long

	int32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 56 to 72
	value = ((uint32_t)input[7] << 24) |
			((uint32_t)input[8] << 16) |
			((uint32_t)(input[9] & 0x80) << 8);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 73 to 89
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)(input[11] & 0xc0) << 9);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 90 to 106
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xe0) << 10);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 107 to 123
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)(input[15] & 0xf0) << 11);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 124 to 140
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)(input[17] & 0xf8) << 12);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 141 to 157
	value = ((uint32_t)(input[17] & 0x07) << 29) |
			((uint32_t)input[18] << 21) |
			((uint32_t)(input[19] & 0xfc) << 13);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 158 to 174
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xfe) << 14);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 175 to 191
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 192 to 208
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0x80) << 8);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 209 to 225
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0xc0) << 9);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 226 to 242
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xe0) << 10);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 243 to 259
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xf0) << 11);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 260 to 276
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf8) << 12);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 277 to 293
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xfc) << 13);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 294 to 310
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfe) << 14);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 311 to 327
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)input[40] << 15);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 328 to 344
	value = ((uint32_t)input[41] << 24) |
			((uint32_t)input[42] << 16) |
			((uint32_t)(input[43] & 0x80) << 8);
	output[19] = (double)(value >> 15);
}

static void unpack_20_17bit_unsigned_5off(const uint8_t * input, double * output) {
	// Unpack 20 values into output
	// Values are 17-bit unsigned
	// Skip 5 bits, read 340 bits of data.
	// Input must be at least 44 bytes long

	uint32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 56 to 72
	value = ((uint32_t)input[7] << 24) |
			((uint32_t)input[8] << 16) |
			((uint32_t)(input[9] & 0x80) << 8);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 73 to 89
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)(input[11] & 0xc0) << 9);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 90 to 106
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xe0) << 10);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 107 to 123
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)(input[15] & 0xf0) << 11);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 124 to 140
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)(input[17] & 0xf8) << 12);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 141 to 157
	value = ((uint32_t)(input[17] & 0x07) << 29) |
			((uint32_t)input[18] << 21) |
			((uint32_t)(input[19] & 0xfc) << 13);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 158 to 174
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xfe) << 14);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 175 to 191
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 192 to 208
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0x80) << 8);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 209 to 225
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0xc0) << 9);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 226 to 242
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xe0) << 10);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 243 to 259
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xf0) << 11);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 260 to 276
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf8) << 12);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 277 to 293
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xfc) << 13);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 294 to 310
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfe) << 14);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 311 to 327
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)input[40] << 15);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 328 to 344
	value = ((uint32_t)input[41] << 24) |
			((uint32_t)input[42] << 16) |
			((uint32_t)(input[43] & 0x80) << 8);
	output[19] = (double)(value >> 15);
}

static void unpack_20_17bit_signed_6off(const uint8_t * input, double * output) {
	// Unpack 20 values into output
	// Values are 17-bit signed
	// Skip 6 bits, read 340 bits of data.
	// Input must be at least 44 bytes long

	int32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 57 to 73
	value = ((uint32_t)(input[7] & 0x7f) << 25) |
			((uint32_t)input[8] << 17) |
			((uint32_t)(input[9] & 0xc0) << 9);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 74 to 90
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)(input[11] & 0xe0) << 10);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 91 to 107
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)(input[13] & 0xf0) << 11);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 108 to 124
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)(input[15] & 0xf8) << 12);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 125 to 141
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0xfc) << 13);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 142 to 158
	value = ((uint32_t)(input[17] & 0x03) << 30) |
			((uint32_t)input[18] << 22) |
			((uint32_t)(input[19] & 0xfe) << 14);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 159 to 175
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)input[21] << 15);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 176 to 192
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16) |
			((uint32_t)(input[24] & 0x80) << 8);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 193 to 209
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xc0) << 9);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 210 to 226
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xe0) << 10);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 227 to 243
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xf0) << 11);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 244 to 260
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf8) << 12);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 261 to 277
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xfc) << 13);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 278 to 294
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfe) << 14);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 295 to 311
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 312 to 328
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)(input[41] & 0x80) << 8);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 329 to 345
	value = ((uint32_t)(input[41] & 0x7f) << 25) |
			((uint32_t)input[42] << 17) |
			((uint32_t)(input[43] & 0xc0) << 9);
	output[19] = (double)(value >> 15);
}

static void unpack_20_17bit_unsigned_6off(const uint8_t * input, double * output) {
	// Unpack 20 values into output
	// Values are 17-bit unsigned
	// Skip 6 bits, read 340 bits of data.
	// Input must be at least 44 bytes long

	uint32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 57 to 73
	value = ((uint32_t)(input[7] & 0x7f) << 25) |
			((uint32_t)input[8] << 17) |
			((uint32_t)(input[9] & 0xc0) << 9);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 74 to 90
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)(input[11] & 0xe0) << 10);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 91 to 107
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)(input[13] & 0xf0) << 11);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 108 to 124
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)(input[15] & 0xf8) << 12);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 125 to 141
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0xfc) << 13);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 142 to 158
	value = ((uint32_t)(input[17] & 0x03) << 30) |
			((uint32_t)input[18] << 22) |
			((uint32_t)(input[19] & 0xfe) << 14);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 159 to 175
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)input[21] << 15);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 176 to 192
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16) |
			((uint32_t)(input[24] & 0x80) << 8);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 193 to 209
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xc0) << 9);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 210 to 226
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xe0) << 10);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 227 to 243
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xf0) << 11);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 244 to 260
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf8) << 12);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 261 to 277
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xfc) << 13);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 278 to 294
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfe) << 14);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 295 to 311
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 312 to 328
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)(input[41] & 0x80) << 8);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 329 to 345
	value = ((uint32_t)(input[41] & 0x7f) << 25) |
			((uint32_t)input[42] << 17) |
			((uint32_t)(input[43] & 0xc0) << 9);
	output[19] = (double)(value >> 15);
}

static void unpack_20_17bit_signed_7off(const uint8_t * input, double * output) {
	// Unpack 20 values into output
	// Values are 17-bit signed
	// Skip 7 bits, read 340 bits of data.
	// Input must be at least 44 bytes long

	int32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 58 to 74
	value = ((uint32_t)(input[7] & 0x3f) << 26) |
			((uint32_t)input[8] << 18) |
			((uint32_t)(input[9] & 0xe0) << 10);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 75 to 91
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)(input[11] & 0xf0) << 11);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 92 to 108
	value = ((uint32_t)(input[11] & 0x0f) << 28) |
			((uint32_t)input[12] << 20) |
			((uint32_t)(input[13] & 0xf8) << 12);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 109 to 125
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0xfc) << 13);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 126 to 142
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xfe) << 14);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 143 to 159
	value = ((uint32_t)(input[17] & 0x01) << 31) |
			((uint32_t)input[18] << 23) |
			((uint32_t)input[19] << 15);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 160 to 176
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16) |
			((uint32_t)(input[22] & 0x80) << 8);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 177 to 193
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0xc0) << 9);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 194 to 210
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xe0) << 10);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 211 to 227
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xf0) << 11);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 228 to 244
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf8) << 12);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 245 to 261
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xfc) << 13);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 262 to 278
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfe) << 14);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 279 to 295
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)input[36] << 15);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 296 to 312
	value = ((uint32_t)input[37] << 24) |
			((uint32_t)input[38] << 16) |
			((uint32_t)(input[39] & 0x80) << 8);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 313 to 329
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)(input[41] & 0xc0) << 9);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 330 to 346
	value = ((uint32_t)(input[41] & 0x3f) << 26) |
			((uint32_t)input[42] << 18) |
			((uint32_t)(input[43] & 0xe0) << 10);
	output[19] = (double)(value >> 15);
}

static void unpack_20_17bit_unsigned_7off(const uint8_t * input, double * output) {
	// Unpack 20 values into output
	// Values are 17-bit unsigned
	// Skip 7 bits, read 340 bits of data.
	// Input must be at least 44 bytes long

	uint32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 58 to 74
	value = ((uint32_t)(input[7] & 0x3f) << 26) |
			((uint32_t)input[8] << 18) |
			((uint32_t)(input[9] & 0xe0) << 10);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 75 to 91
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)(input[11] & 0xf0) << 11);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 92 to 108
	value = ((uint32_t)(input[11] & 0x0f) << 28) |
			((uint32_t)input[12] << 20) |
			((uint32_t)(input[13] & 0xf8) << 12);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 109 to 125
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0xfc) << 13);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 126 to 142
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xfe) << 14);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 143 to 159
	value = ((uint32_t)(input[17] & 0x01) << 31) |
			((uint32_t)input[18] << 23) |
			((uint32_t)input[19] << 15);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 160 to 176
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16) |
			((uint32_t)(input[22] & 0x80) << 8);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 177 to 193
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0xc0) << 9);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 194 to 210
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xe0) << 10);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 211 to 227
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xf0) << 11);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 228 to 244
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf8) << 12);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 245 to 261
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xfc) << 13);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 262 to 278
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfe) << 14);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 279 to 295
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)input[36] << 15);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 296 to 312
	value = ((uint32_t)input[37] << 24) |
			((uint32_t)input[38] << 16) |
			((uint32_t)(input[39] & 0x80) << 8);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 313 to 329
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)(input[41] & 0xc0) << 9);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 330 to 346
	value = ((uint32_t)(input[41] & 0x3f) << 26) |
			((uint32_t)input[42] << 18) |
			((uint32_t)(input[43] & 0xe0) << 10);
	output[19] = (double)(value >> 15);
}

static void unpack_21_17bit_signed_0off(const uint8_t * input, double * output) {
	// Unpack 21 values into output
	// Values are 17-bit signed
	// Skip 0 bits, read 357 bits of data.
	// Input must be at least 45 bytes long

	int32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 51 to 67
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xf0) << 11);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 68 to 84
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf8) << 12);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 85 to 101
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xfc) << 13);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 102 to 118
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfe) << 14);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 119 to 135
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)input[16] << 15);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 136 to 152
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)input[18] << 16) |
			((uint32_t)(input[19] & 0x80) << 8);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 153 to 169
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xc0) << 9);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 170 to 186
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xe0) << 10);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 187 to 203
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)input[24] << 19) |
			((uint32_t)(input[25] & 0xf0) << 11);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 204 to 220
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20) |
			((uint32_t)(input[27] & 0xf8) << 12);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 221 to 237
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0xfc) << 13);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 238 to 254
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)(input[31] & 0xfe) << 14);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 255 to 271
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)input[33] << 15);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 272 to 288
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16) |
			((uint32_t)(input[36] & 0x80) << 8);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 289 to 305
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0xc0) << 9);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 306 to 322
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xe0) << 10);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 323 to 339
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xf0) << 11);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 340 to 356
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf8) << 12);
	output[20] = (double)(value >> 15);
}

static void unpack_21_17bit_unsigned_0off(const uint8_t * input, double * output) {
	// Unpack 21 values into output
	// Values are 17-bit unsigned
	// Skip 0 bits, read 357 bits of data.
	// Input must be at least 45 bytes long

	uint32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 51 to 67
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xf0) << 11);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 68 to 84
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf8) << 12);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 85 to 101
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xfc) << 13);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 102 to 118
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfe) << 14);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 119 to 135
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)input[16] << 15);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 136 to 152
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)input[18] << 16) |
			((uint32_t)(input[19] & 0x80) << 8);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 153 to 169
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xc0) << 9);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 170 to 186
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xe0) << 10);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 187 to 203
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)input[24] << 19) |
			((uint32_t)(input[25] & 0xf0) << 11);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 204 to 220
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20) |
			((uint32_t)(input[27] & 0xf8) << 12);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 221 to 237
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0xfc) << 13);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 238 to 254
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)(input[31] & 0xfe) << 14);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 255 to 271
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)input[33] << 15);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 272 to 288
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16) |
			((uint32_t)(input[36] & 0x80) << 8);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 289 to 305
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0xc0) << 9);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 306 to 322
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xe0) << 10);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 323 to 339
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xf0) << 11);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 340 to 356
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf8) << 12);
	output[20] = (double)(value >> 15);
}

static void unpack_21_17bit_signed_1off(const uint8_t * input, double * output) {
	// Unpack 21 values into output
	// Values are 17-bit signed
	// Skip 1 bits, read 357 bits of data.
	// Input must be at least 45 bytes long

	int32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 52 to 68
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf8) << 12);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 69 to 85
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xfc) << 13);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 86 to 102
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfe) << 14);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 103 to 119
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 120 to 136
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)(input[17] & 0x80) << 8);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 137 to 153
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)input[18] << 17) |
			((uint32_t)(input[19] & 0xc0) << 9);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 154 to 170
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xe0) << 10);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 171 to 187
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)(input[23] & 0xf0) << 11);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 188 to 204
	value = ((uint32_t)(input[23] & 0x0f) << 28) |
			((uint32_t)input[24] << 20) |
			((uint32_t)(input[25] & 0xf8) << 12);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 205 to 221
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0xfc) << 13);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 222 to 238
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xfe) << 14);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 239 to 255
	value = ((uint32_t)(input[29] & 0x01) << 31) |
			((uint32_t)input[30] << 23) |
			((uint32_t)input[31] << 15);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 256 to 272
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16) |
			((uint32_t)(input[34] & 0x80) << 8);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 273 to 289
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0xc0) << 9);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 290 to 306
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xe0) << 10);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 307 to 323
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xf0) << 11);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 324 to 340
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf8) << 12);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 341 to 357
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xfc) << 13);
	output[20] = (double)(value >> 15);
}

static void unpack_21_17bit_unsigned_1off(const uint8_t * input, double * output) {
	// Unpack 21 values into output
	// Values are 17-bit unsigned
	// Skip 1 bits, read 357 bits of data.
	// Input must be at least 45 bytes long

	uint32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 52 to 68
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf8) << 12);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 69 to 85
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xfc) << 13);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 86 to 102
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfe) << 14);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 103 to 119
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 120 to 136
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)(input[17] & 0x80) << 8);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 137 to 153
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)input[18] << 17) |
			((uint32_t)(input[19] & 0xc0) << 9);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 154 to 170
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xe0) << 10);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 171 to 187
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)(input[23] & 0xf0) << 11);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 188 to 204
	value = ((uint32_t)(input[23] & 0x0f) << 28) |
			((uint32_t)input[24] << 20) |
			((uint32_t)(input[25] & 0xf8) << 12);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 205 to 221
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0xfc) << 13);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 222 to 238
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xfe) << 14);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 239 to 255
	value = ((uint32_t)(input[29] & 0x01) << 31) |
			((uint32_t)input[30] << 23) |
			((uint32_t)input[31] << 15);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 256 to 272
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16) |
			((uint32_t)(input[34] & 0x80) << 8);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 273 to 289
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0xc0) << 9);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 290 to 306
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xe0) << 10);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 307 to 323
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xf0) << 11);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 324 to 340
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf8) << 12);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 341 to 357
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xfc) << 13);
	output[20] = (double)(value >> 15);
}

static void unpack_21_17bit_signed_2off(const uint8_t * input, double * output) {
	// Unpack 21 values into output
	// Values are 17-bit signed
	// Skip 2 bits, read 357 bits of data.
	// Input must be at least 45 bytes long

	int32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 53 to 69
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xfc) << 13);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 70 to 86
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfe) << 14);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 87 to 103
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 104 to 120
	value = ((uint32_t)input[13] << 24) |
			((uint32_t)input[14] << 16) |
			((uint32_t)(input[15] & 0x80) << 8);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 121 to 137
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)(input[17] & 0xc0) << 9);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 138 to 154
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)input[18] << 18) |
			((uint32_t)(input[19] & 0xe0) << 10);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 155 to 171
	value = ((uint32_t)(input[19] & 0x1f) << 27) |
			((uint32_t)input[20] << 19) |
			((uint32_t)(input[21] & 0xf0) << 11);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 172 to 188
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)(input[23] & 0xf8) << 12);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 189 to 205
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)(input[25] & 0xfc) << 13);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 206 to 222
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xfe) << 14);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 223 to 239
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 240 to 256
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)(input[32] & 0x80) << 8);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 257 to 273
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0xc0) << 9);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 274 to 290
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xe0) << 10);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 291 to 307
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xf0) << 11);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 308 to 324
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf8) << 12);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 325 to 341
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xfc) << 13);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 342 to 358
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfe) << 14);
	output[20] = (double)(value >> 15);
}

static void unpack_21_17bit_unsigned_2off(const uint8_t * input, double * output) {
	// Unpack 21 values into output
	// Values are 17-bit unsigned
	// Skip 2 bits, read 357 bits of data.
	// Input must be at least 45 bytes long

	uint32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 53 to 69
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xfc) << 13);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 70 to 86
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfe) << 14);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 87 to 103
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 104 to 120
	value = ((uint32_t)input[13] << 24) |
			((uint32_t)input[14] << 16) |
			((uint32_t)(input[15] & 0x80) << 8);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 121 to 137
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)(input[17] & 0xc0) << 9);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 138 to 154
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)input[18] << 18) |
			((uint32_t)(input[19] & 0xe0) << 10);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 155 to 171
	value = ((uint32_t)(input[19] & 0x1f) << 27) |
			((uint32_t)input[20] << 19) |
			((uint32_t)(input[21] & 0xf0) << 11);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 172 to 188
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)(input[23] & 0xf8) << 12);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 189 to 205
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)(input[25] & 0xfc) << 13);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 206 to 222
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xfe) << 14);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 223 to 239
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 240 to 256
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)(input[32] & 0x80) << 8);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 257 to 273
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0xc0) << 9);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 274 to 290
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xe0) << 10);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 291 to 307
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xf0) << 11);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 308 to 324
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf8) << 12);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 325 to 341
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xfc) << 13);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 342 to 358
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfe) << 14);
	output[20] = (double)(value >> 15);
}

static void unpack_21_17bit_signed_3off(const uint8_t * input, double * output) {
	// Unpack 21 values into output
	// Values are 17-bit signed
	// Skip 3 bits, read 357 bits of data.
	// Input must be at least 45 bytes long

	int32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 54 to 70
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfe) << 14);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 71 to 87
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)input[10] << 15);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 88 to 104
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0x80) << 8);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 105 to 121
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xc0) << 9);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 122 to 138
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)(input[17] & 0xe0) << 10);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 139 to 155
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)input[18] << 19) |
			((uint32_t)(input[19] & 0xf0) << 11);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 156 to 172
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20) |
			((uint32_t)(input[21] & 0xf8) << 12);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 173 to 189
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0xfc) << 13);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 190 to 206
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)(input[25] & 0xfe) << 14);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 207 to 223
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)input[27] << 15);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 224 to 240
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16) |
			((uint32_t)(input[30] & 0x80) << 8);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 241 to 257
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0xc0) << 9);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 258 to 274
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xe0) << 10);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 275 to 291
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xf0) << 11);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 292 to 308
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf8) << 12);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 309 to 325
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xfc) << 13);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 326 to 342
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfe) << 14);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 343 to 359
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15);
	output[20] = (double)(value >> 15);
}

static void unpack_21_17bit_unsigned_3off(const uint8_t * input, double * output) {
	// Unpack 21 values into output
	// Values are 17-bit unsigned
	// Skip 3 bits, read 357 bits of data.
	// Input must be at least 45 bytes long

	uint32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 54 to 70
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfe) << 14);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 71 to 87
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)input[10] << 15);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 88 to 104
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0x80) << 8);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 105 to 121
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xc0) << 9);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 122 to 138
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)(input[17] & 0xe0) << 10);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 139 to 155
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)input[18] << 19) |
			((uint32_t)(input[19] & 0xf0) << 11);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 156 to 172
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20) |
			((uint32_t)(input[21] & 0xf8) << 12);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 173 to 189
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0xfc) << 13);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 190 to 206
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)(input[25] & 0xfe) << 14);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 207 to 223
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)input[27] << 15);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 224 to 240
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16) |
			((uint32_t)(input[30] & 0x80) << 8);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 241 to 257
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0xc0) << 9);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 258 to 274
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xe0) << 10);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 275 to 291
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xf0) << 11);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 292 to 308
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf8) << 12);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 309 to 325
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xfc) << 13);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 326 to 342
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfe) << 14);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 343 to 359
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15);
	output[20] = (double)(value >> 15);
}

static void unpack_21_17bit_signed_4off(const uint8_t * input, double * output) {
	// Unpack 21 values into output
	// Values are 17-bit signed
	// Skip 4 bits, read 357 bits of data.
	// Input must be at least 46 bytes long

	int32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 55 to 71
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 72 to 88
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)(input[11] & 0x80) << 8);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 89 to 105
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xc0) << 9);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 106 to 122
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xe0) << 10);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 123 to 139
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)(input[17] & 0xf0) << 11);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 140 to 156
	value = ((uint32_t)(input[17] & 0x0f) << 28) |
			((uint32_t)input[18] << 20) |
			((uint32_t)(input[19] & 0xf8) << 12);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 157 to 173
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0xfc) << 13);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 174 to 190
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xfe) << 14);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 191 to 207
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 208 to 224
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16) |
			((uint32_t)(input[28] & 0x80) << 8);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 225 to 241
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0xc0) << 9);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 242 to 258
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xe0) << 10);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 259 to 275
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xf0) << 11);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 276 to 292
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf8) << 12);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 293 to 309
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xfc) << 13);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 310 to 326
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfe) << 14);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 327 to 343
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)input[42] << 15);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 344 to 360
	value = ((uint32_t)input[43] << 24) |
			((uint32_t)input[44] << 16) |
			((uint32_t)(input[45] & 0x80) << 8);
	output[20] = (double)(value >> 15);
}

static void unpack_21_17bit_unsigned_4off(const uint8_t * input, double * output) {
	// Unpack 21 values into output
	// Values are 17-bit unsigned
	// Skip 4 bits, read 357 bits of data.
	// Input must be at least 46 bytes long

	uint32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 55 to 71
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 72 to 88
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)(input[11] & 0x80) << 8);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 89 to 105
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xc0) << 9);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 106 to 122
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xe0) << 10);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 123 to 139
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)(input[17] & 0xf0) << 11);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 140 to 156
	value = ((uint32_t)(input[17] & 0x0f) << 28) |
			((uint32_t)input[18] << 20) |
			((uint32_t)(input[19] & 0xf8) << 12);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 157 to 173
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0xfc) << 13);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 174 to 190
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xfe) << 14);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 191 to 207
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 208 to 224
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16) |
			((uint32_t)(input[28] & 0x80) << 8);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 225 to 241
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0xc0) << 9);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 242 to 258
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xe0) << 10);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 259 to 275
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xf0) << 11);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 276 to 292
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf8) << 12);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 293 to 309
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xfc) << 13);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 310 to 326
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfe) << 14);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 327 to 343
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)input[42] << 15);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 344 to 360
	value = ((uint32_t)input[43] << 24) |
			((uint32_t)input[44] << 16) |
			((uint32_t)(input[45] & 0x80) << 8);
	output[20] = (double)(value >> 15);
}

static void unpack_21_17bit_signed_5off(const uint8_t * input, double * output) {
	// Unpack 21 values into output
	// Values are 17-bit signed
	// Skip 5 bits, read 357 bits of data.
	// Input must be at least 46 bytes long

	int32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 56 to 72
	value = ((uint32_t)input[7] << 24) |
			((uint32_t)input[8] << 16) |
			((uint32_t)(input[9] & 0x80) << 8);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 73 to 89
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)(input[11] & 0xc0) << 9);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 90 to 106
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xe0) << 10);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 107 to 123
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)(input[15] & 0xf0) << 11);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 124 to 140
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)(input[17] & 0xf8) << 12);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 141 to 157
	value = ((uint32_t)(input[17] & 0x07) << 29) |
			((uint32_t)input[18] << 21) |
			((uint32_t)(input[19] & 0xfc) << 13);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 158 to 174
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xfe) << 14);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 175 to 191
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 192 to 208
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0x80) << 8);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 209 to 225
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0xc0) << 9);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 226 to 242
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xe0) << 10);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 243 to 259
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xf0) << 11);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 260 to 276
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf8) << 12);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 277 to 293
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xfc) << 13);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 294 to 310
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfe) << 14);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 311 to 327
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)input[40] << 15);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 328 to 344
	value = ((uint32_t)input[41] << 24) |
			((uint32_t)input[42] << 16) |
			((uint32_t)(input[43] & 0x80) << 8);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 345 to 361
	value = ((uint32_t)(input[43] & 0x7f) << 25) |
			((uint32_t)input[44] << 17) |
			((uint32_t)(input[45] & 0xc0) << 9);
	output[20] = (double)(value >> 15);
}

static void unpack_21_17bit_unsigned_5off(const uint8_t * input, double * output) {
	// Unpack 21 values into output
	// Values are 17-bit unsigned
	// Skip 5 bits, read 357 bits of data.
	// Input must be at least 46 bytes long

	uint32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 56 to 72
	value = ((uint32_t)input[7] << 24) |
			((uint32_t)input[8] << 16) |
			((uint32_t)(input[9] & 0x80) << 8);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 73 to 89
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)(input[11] & 0xc0) << 9);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 90 to 106
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xe0) << 10);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 107 to 123
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)(input[15] & 0xf0) << 11);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 124 to 140
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)(input[17] & 0xf8) << 12);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 141 to 157
	value = ((uint32_t)(input[17] & 0x07) << 29) |
			((uint32_t)input[18] << 21) |
			((uint32_t)(input[19] & 0xfc) << 13);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 158 to 174
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xfe) << 14);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 175 to 191
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 192 to 208
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0x80) << 8);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 209 to 225
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0xc0) << 9);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 226 to 242
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xe0) << 10);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 243 to 259
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xf0) << 11);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 260 to 276
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf8) << 12);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 277 to 293
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xfc) << 13);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 294 to 310
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfe) << 14);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 311 to 327
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)input[40] << 15);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 328 to 344
	value = ((uint32_t)input[41] << 24) |
			((uint32_t)input[42] << 16) |
			((uint32_t)(input[43] & 0x80) << 8);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 345 to 361
	value = ((uint32_t)(input[43] & 0x7f) << 25) |
			((uint32_t)input[44] << 17) |
			((uint32_t)(input[45] & 0xc0) << 9);
	output[20] = (double)(value >> 15);
}

static void unpack_21_17bit_signed_6off(const uint8_t * input, double * output) {
	// Unpack 21 values into output
	// Values are 17-bit signed
	// Skip 6 bits, read 357 bits of data.
	// Input must be at least 46 bytes long

	int32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 57 to 73
	value = ((uint32_t)(input[7] & 0x7f) << 25) |
			((uint32_t)input[8] << 17) |
			((uint32_t)(input[9] & 0xc0) << 9);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 74 to 90
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)(input[11] & 0xe0) << 10);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 91 to 107
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)(input[13] & 0xf0) << 11);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 108 to 124
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)(input[15] & 0xf8) << 12);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 125 to 141
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0xfc) << 13);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 142 to 158
	value = ((uint32_t)(input[17] & 0x03) << 30) |
			((uint32_t)input[18] << 22) |
			((uint32_t)(input[19] & 0xfe) << 14);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 159 to 175
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)input[21] << 15);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 176 to 192
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16) |
			((uint32_t)(input[24] & 0x80) << 8);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 193 to 209
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xc0) << 9);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 210 to 226
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xe0) << 10);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 227 to 243
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xf0) << 11);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 244 to 260
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf8) << 12);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 261 to 277
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xfc) << 13);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 278 to 294
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfe) << 14);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 295 to 311
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 312 to 328
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)(input[41] & 0x80) << 8);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 329 to 345
	value = ((uint32_t)(input[41] & 0x7f) << 25) |
			((uint32_t)input[42] << 17) |
			((uint32_t)(input[43] & 0xc0) << 9);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 346 to 362
	value = ((uint32_t)(input[43] & 0x3f) << 26) |
			((uint32_t)input[44] << 18) |
			((uint32_t)(input[45] & 0xe0) << 10);
	output[20] = (double)(value >> 15);
}

static void unpack_21_17bit_unsigned_6off(const uint8_t * input, double * output) {
	// Unpack 21 values into output
	// Values are 17-bit unsigned
	// Skip 6 bits, read 357 bits of data.
	// Input must be at least 46 bytes long

	uint32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 57 to 73
	value = ((uint32_t)(input[7] & 0x7f) << 25) |
			((uint32_t)input[8] << 17) |
			((uint32_t)(input[9] & 0xc0) << 9);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 74 to 90
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)(input[11] & 0xe0) << 10);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 91 to 107
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)(input[13] & 0xf0) << 11);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 108 to 124
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)(input[15] & 0xf8) << 12);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 125 to 141
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0xfc) << 13);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 142 to 158
	value = ((uint32_t)(input[17] & 0x03) << 30) |
			((uint32_t)input[18] << 22) |
			((uint32_t)(input[19] & 0xfe) << 14);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 159 to 175
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)input[21] << 15);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 176 to 192
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16) |
			((uint32_t)(input[24] & 0x80) << 8);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 193 to 209
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xc0) << 9);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 210 to 226
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xe0) << 10);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 227 to 243
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xf0) << 11);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 244 to 260
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf8) << 12);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 261 to 277
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xfc) << 13);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 278 to 294
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfe) << 14);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 295 to 311
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 312 to 328
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)(input[41] & 0x80) << 8);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 329 to 345
	value = ((uint32_t)(input[41] & 0x7f) << 25) |
			((uint32_t)input[42] << 17) |
			((uint32_t)(input[43] & 0xc0) << 9);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 346 to 362
	value = ((uint32_t)(input[43] & 0x3f) << 26) |
			((uint32_t)input[44] << 18) |
			((uint32_t)(input[45] & 0xe0) << 10);
	output[20] = (double)(value >> 15);
}

static void unpack_21_17bit_signed_7off(const uint8_t * input, double * output) {
	// Unpack 21 values into output
	// Values are 17-bit signed
	// Skip 7 bits, read 357 bits of data.
	// Input must be at least 46 bytes long

	int32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 58 to 74
	value = ((uint32_t)(input[7] & 0x3f) << 26) |
			((uint32_t)input[8] << 18) |
			((uint32_t)(input[9] & 0xe0) << 10);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 75 to 91
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)(input[11] & 0xf0) << 11);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 92 to 108
	value = ((uint32_t)(input[11] & 0x0f) << 28) |
			((uint32_t)input[12] << 20) |
			((uint32_t)(input[13] & 0xf8) << 12);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 109 to 125
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0xfc) << 13);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 126 to 142
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xfe) << 14);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 143 to 159
	value = ((uint32_t)(input[17] & 0x01) << 31) |
			((uint32_t)input[18] << 23) |
			((uint32_t)input[19] << 15);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 160 to 176
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16) |
			((uint32_t)(input[22] & 0x80) << 8);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 177 to 193
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0xc0) << 9);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 194 to 210
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xe0) << 10);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 211 to 227
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xf0) << 11);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 228 to 244
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf8) << 12);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 245 to 261
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xfc) << 13);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 262 to 278
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfe) << 14);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 279 to 295
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)input[36] << 15);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 296 to 312
	value = ((uint32_t)input[37] << 24) |
			((uint32_t)input[38] << 16) |
			((uint32_t)(input[39] & 0x80) << 8);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 313 to 329
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)(input[41] & 0xc0) << 9);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 330 to 346
	value = ((uint32_t)(input[41] & 0x3f) << 26) |
			((uint32_t)input[42] << 18) |
			((uint32_t)(input[43] & 0xe0) << 10);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 347 to 363
	value = ((uint32_t)(input[43] & 0x1f) << 27) |
			((uint32_t)input[44] << 19) |
			((uint32_t)(input[45] & 0xf0) << 11);
	output[20] = (double)(value >> 15);
}

static void unpack_21_17bit_unsigned_7off(const uint8_t * input, double * output) {
	// Unpack 21 values into output
	// Values are 17-bit unsigned
	// Skip 7 bits, read 357 bits of data.
	// Input must be at least 46 bytes long

	uint32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 58 to 74
	value = ((uint32_t)(input[7] & 0x3f) << 26) |
			((uint32_t)input[8] << 18) |
			((uint32_t)(input[9] & 0xe0) << 10);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 75 to 91
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)(input[11] & 0xf0) << 11);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 92 to 108
	value = ((uint32_t)(input[11] & 0x0f) << 28) |
			((uint32_t)input[12] << 20) |
			((uint32_t)(input[13] & 0xf8) << 12);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 109 to 125
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0xfc) << 13);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 126 to 142
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xfe) << 14);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 143 to 159
	value = ((uint32_t)(input[17] & 0x01) << 31) |
			((uint32_t)input[18] << 23) |
			((uint32_t)input[19] << 15);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 160 to 176
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16) |
			((uint32_t)(input[22] & 0x80) << 8);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 177 to 193
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0xc0) << 9);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 194 to 210
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xe0) << 10);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 211 to 227
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xf0) << 11);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 228 to 244
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf8) << 12);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 245 to 261
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xfc) << 13);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 262 to 278
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfe) << 14);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 279 to 295
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)input[36] << 15);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 296 to 312
	value = ((uint32_t)input[37] << 24) |
			((uint32_t)input[38] << 16) |
			((uint32_t)(input[39] & 0x80) << 8);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 313 to 329
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)(input[41] & 0xc0) << 9);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 330 to 346
	value = ((uint32_t)(input[41] & 0x3f) << 26) |
			((uint32_t)input[42] << 18) |
			((uint32_t)(input[43] & 0xe0) << 10);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 347 to 363
	value = ((uint32_t)(input[43] & 0x1f) << 27) |
			((uint32_t)input[44] << 19) |
			((uint32_t)(input[45] & 0xf0) << 11);
	output[20] = (double)(value >> 15);
}

static void unpack_22_17bit_signed_0off(const uint8_t * input, double * output) {
	// Unpack 22 values into output
	// Values are 17-bit signed
	// Skip 0 bits, read 374 bits of data.
	// Input must be at least 47 bytes long

	int32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 51 to 67
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xf0) << 11);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 68 to 84
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf8) << 12);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 85 to 101
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xfc) << 13);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 102 to 118
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfe) << 14);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 119 to 135
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)input[16] << 15);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 136 to 152
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)input[18] << 16) |
			((uint32_t)(input[19] & 0x80) << 8);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 153 to 169
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xc0) << 9);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 170 to 186
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xe0) << 10);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 187 to 203
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)input[24] << 19) |
			((uint32_t)(input[25] & 0xf0) << 11);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 204 to 220
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20) |
			((uint32_t)(input[27] & 0xf8) << 12);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 221 to 237
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0xfc) << 13);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 238 to 254
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)(input[31] & 0xfe) << 14);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 255 to 271
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)input[33] << 15);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 272 to 288
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16) |
			((uint32_t)(input[36] & 0x80) << 8);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 289 to 305
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0xc0) << 9);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 306 to 322
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xe0) << 10);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 323 to 339
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xf0) << 11);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 340 to 356
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf8) << 12);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 357 to 373
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xfc) << 13);
	output[21] = (double)(value >> 15);
}

static void unpack_22_17bit_unsigned_0off(const uint8_t * input, double * output) {
	// Unpack 22 values into output
	// Values are 17-bit unsigned
	// Skip 0 bits, read 374 bits of data.
	// Input must be at least 47 bytes long

	uint32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 51 to 67
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xf0) << 11);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 68 to 84
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf8) << 12);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 85 to 101
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xfc) << 13);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 102 to 118
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfe) << 14);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 119 to 135
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)input[16] << 15);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 136 to 152
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)input[18] << 16) |
			((uint32_t)(input[19] & 0x80) << 8);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 153 to 169
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xc0) << 9);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 170 to 186
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xe0) << 10);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 187 to 203
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)input[24] << 19) |
			((uint32_t)(input[25] & 0xf0) << 11);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 204 to 220
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20) |
			((uint32_t)(input[27] & 0xf8) << 12);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 221 to 237
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0xfc) << 13);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 238 to 254
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)(input[31] & 0xfe) << 14);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 255 to 271
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)input[33] << 15);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 272 to 288
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16) |
			((uint32_t)(input[36] & 0x80) << 8);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 289 to 305
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0xc0) << 9);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 306 to 322
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xe0) << 10);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 323 to 339
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xf0) << 11);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 340 to 356
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf8) << 12);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 357 to 373
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xfc) << 13);
	output[21] = (double)(value >> 15);
}

static void unpack_22_17bit_signed_1off(const uint8_t * input, double * output) {
	// Unpack 22 values into output
	// Values are 17-bit signed
	// Skip 1 bits, read 374 bits of data.
	// Input must be at least 47 bytes long

	int32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 52 to 68
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf8) << 12);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 69 to 85
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xfc) << 13);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 86 to 102
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfe) << 14);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 103 to 119
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 120 to 136
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)(input[17] & 0x80) << 8);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 137 to 153
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)input[18] << 17) |
			((uint32_t)(input[19] & 0xc0) << 9);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 154 to 170
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xe0) << 10);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 171 to 187
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)(input[23] & 0xf0) << 11);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 188 to 204
	value = ((uint32_t)(input[23] & 0x0f) << 28) |
			((uint32_t)input[24] << 20) |
			((uint32_t)(input[25] & 0xf8) << 12);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 205 to 221
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0xfc) << 13);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 222 to 238
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xfe) << 14);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 239 to 255
	value = ((uint32_t)(input[29] & 0x01) << 31) |
			((uint32_t)input[30] << 23) |
			((uint32_t)input[31] << 15);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 256 to 272
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16) |
			((uint32_t)(input[34] & 0x80) << 8);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 273 to 289
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0xc0) << 9);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 290 to 306
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xe0) << 10);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 307 to 323
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xf0) << 11);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 324 to 340
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf8) << 12);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 341 to 357
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xfc) << 13);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 358 to 374
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfe) << 14);
	output[21] = (double)(value >> 15);
}

static void unpack_22_17bit_unsigned_1off(const uint8_t * input, double * output) {
	// Unpack 22 values into output
	// Values are 17-bit unsigned
	// Skip 1 bits, read 374 bits of data.
	// Input must be at least 47 bytes long

	uint32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 52 to 68
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf8) << 12);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 69 to 85
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xfc) << 13);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 86 to 102
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfe) << 14);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 103 to 119
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 120 to 136
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)(input[17] & 0x80) << 8);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 137 to 153
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)input[18] << 17) |
			((uint32_t)(input[19] & 0xc0) << 9);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 154 to 170
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xe0) << 10);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 171 to 187
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)(input[23] & 0xf0) << 11);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 188 to 204
	value = ((uint32_t)(input[23] & 0x0f) << 28) |
			((uint32_t)input[24] << 20) |
			((uint32_t)(input[25] & 0xf8) << 12);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 205 to 221
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0xfc) << 13);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 222 to 238
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xfe) << 14);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 239 to 255
	value = ((uint32_t)(input[29] & 0x01) << 31) |
			((uint32_t)input[30] << 23) |
			((uint32_t)input[31] << 15);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 256 to 272
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16) |
			((uint32_t)(input[34] & 0x80) << 8);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 273 to 289
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0xc0) << 9);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 290 to 306
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xe0) << 10);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 307 to 323
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xf0) << 11);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 324 to 340
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf8) << 12);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 341 to 357
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xfc) << 13);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 358 to 374
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfe) << 14);
	output[21] = (double)(value >> 15);
}

static void unpack_22_17bit_signed_2off(const uint8_t * input, double * output) {
	// Unpack 22 values into output
	// Values are 17-bit signed
	// Skip 2 bits, read 374 bits of data.
	// Input must be at least 47 bytes long

	int32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 53 to 69
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xfc) << 13);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 70 to 86
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfe) << 14);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 87 to 103
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 104 to 120
	value = ((uint32_t)input[13] << 24) |
			((uint32_t)input[14] << 16) |
			((uint32_t)(input[15] & 0x80) << 8);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 121 to 137
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)(input[17] & 0xc0) << 9);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 138 to 154
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)input[18] << 18) |
			((uint32_t)(input[19] & 0xe0) << 10);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 155 to 171
	value = ((uint32_t)(input[19] & 0x1f) << 27) |
			((uint32_t)input[20] << 19) |
			((uint32_t)(input[21] & 0xf0) << 11);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 172 to 188
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)(input[23] & 0xf8) << 12);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 189 to 205
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)(input[25] & 0xfc) << 13);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 206 to 222
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xfe) << 14);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 223 to 239
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 240 to 256
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)(input[32] & 0x80) << 8);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 257 to 273
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0xc0) << 9);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 274 to 290
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xe0) << 10);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 291 to 307
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xf0) << 11);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 308 to 324
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf8) << 12);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 325 to 341
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xfc) << 13);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 342 to 358
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfe) << 14);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 359 to 375
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)input[46] << 15);
	output[21] = (double)(value >> 15);
}

static void unpack_22_17bit_unsigned_2off(const uint8_t * input, double * output) {
	// Unpack 22 values into output
	// Values are 17-bit unsigned
	// Skip 2 bits, read 374 bits of data.
	// Input must be at least 47 bytes long

	uint32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 53 to 69
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xfc) << 13);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 70 to 86
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfe) << 14);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 87 to 103
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 104 to 120
	value = ((uint32_t)input[13] << 24) |
			((uint32_t)input[14] << 16) |
			((uint32_t)(input[15] & 0x80) << 8);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 121 to 137
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)(input[17] & 0xc0) << 9);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 138 to 154
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)input[18] << 18) |
			((uint32_t)(input[19] & 0xe0) << 10);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 155 to 171
	value = ((uint32_t)(input[19] & 0x1f) << 27) |
			((uint32_t)input[20] << 19) |
			((uint32_t)(input[21] & 0xf0) << 11);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 172 to 188
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)(input[23] & 0xf8) << 12);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 189 to 205
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)(input[25] & 0xfc) << 13);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 206 to 222
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xfe) << 14);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 223 to 239
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 240 to 256
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)(input[32] & 0x80) << 8);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 257 to 273
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0xc0) << 9);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 274 to 290
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xe0) << 10);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 291 to 307
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xf0) << 11);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 308 to 324
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf8) << 12);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 325 to 341
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xfc) << 13);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 342 to 358
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfe) << 14);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 359 to 375
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)input[46] << 15);
	output[21] = (double)(value >> 15);
}

static void unpack_22_17bit_signed_3off(const uint8_t * input, double * output) {
	// Unpack 22 values into output
	// Values are 17-bit signed
	// Skip 3 bits, read 374 bits of data.
	// Input must be at least 48 bytes long

	int32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 54 to 70
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfe) << 14);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 71 to 87
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)input[10] << 15);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 88 to 104
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0x80) << 8);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 105 to 121
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xc0) << 9);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 122 to 138
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)(input[17] & 0xe0) << 10);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 139 to 155
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)input[18] << 19) |
			((uint32_t)(input[19] & 0xf0) << 11);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 156 to 172
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20) |
			((uint32_t)(input[21] & 0xf8) << 12);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 173 to 189
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0xfc) << 13);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 190 to 206
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)(input[25] & 0xfe) << 14);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 207 to 223
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)input[27] << 15);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 224 to 240
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16) |
			((uint32_t)(input[30] & 0x80) << 8);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 241 to 257
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0xc0) << 9);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 258 to 274
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xe0) << 10);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 275 to 291
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xf0) << 11);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 292 to 308
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf8) << 12);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 309 to 325
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xfc) << 13);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 326 to 342
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfe) << 14);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 343 to 359
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 360 to 376
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)(input[47] & 0x80) << 8);
	output[21] = (double)(value >> 15);
}

static void unpack_22_17bit_unsigned_3off(const uint8_t * input, double * output) {
	// Unpack 22 values into output
	// Values are 17-bit unsigned
	// Skip 3 bits, read 374 bits of data.
	// Input must be at least 48 bytes long

	uint32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 54 to 70
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfe) << 14);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 71 to 87
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)input[10] << 15);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 88 to 104
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0x80) << 8);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 105 to 121
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xc0) << 9);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 122 to 138
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)(input[17] & 0xe0) << 10);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 139 to 155
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)input[18] << 19) |
			((uint32_t)(input[19] & 0xf0) << 11);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 156 to 172
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20) |
			((uint32_t)(input[21] & 0xf8) << 12);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 173 to 189
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0xfc) << 13);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 190 to 206
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)(input[25] & 0xfe) << 14);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 207 to 223
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)input[27] << 15);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 224 to 240
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16) |
			((uint32_t)(input[30] & 0x80) << 8);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 241 to 257
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0xc0) << 9);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 258 to 274
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xe0) << 10);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 275 to 291
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xf0) << 11);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 292 to 308
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf8) << 12);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 309 to 325
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xfc) << 13);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 326 to 342
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfe) << 14);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 343 to 359
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 360 to 376
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)(input[47] & 0x80) << 8);
	output[21] = (double)(value >> 15);
}

static void unpack_22_17bit_signed_4off(const uint8_t * input, double * output) {
	// Unpack 22 values into output
	// Values are 17-bit signed
	// Skip 4 bits, read 374 bits of data.
	// Input must be at least 48 bytes long

	int32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 55 to 71
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 72 to 88
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)(input[11] & 0x80) << 8);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 89 to 105
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xc0) << 9);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 106 to 122
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xe0) << 10);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 123 to 139
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)(input[17] & 0xf0) << 11);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 140 to 156
	value = ((uint32_t)(input[17] & 0x0f) << 28) |
			((uint32_t)input[18] << 20) |
			((uint32_t)(input[19] & 0xf8) << 12);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 157 to 173
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0xfc) << 13);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 174 to 190
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xfe) << 14);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 191 to 207
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 208 to 224
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16) |
			((uint32_t)(input[28] & 0x80) << 8);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 225 to 241
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0xc0) << 9);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 242 to 258
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xe0) << 10);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 259 to 275
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xf0) << 11);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 276 to 292
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf8) << 12);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 293 to 309
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xfc) << 13);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 310 to 326
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfe) << 14);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 327 to 343
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)input[42] << 15);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 344 to 360
	value = ((uint32_t)input[43] << 24) |
			((uint32_t)input[44] << 16) |
			((uint32_t)(input[45] & 0x80) << 8);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 361 to 377
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)(input[47] & 0xc0) << 9);
	output[21] = (double)(value >> 15);
}

static void unpack_22_17bit_unsigned_4off(const uint8_t * input, double * output) {
	// Unpack 22 values into output
	// Values are 17-bit unsigned
	// Skip 4 bits, read 374 bits of data.
	// Input must be at least 48 bytes long

	uint32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 55 to 71
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 72 to 88
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)(input[11] & 0x80) << 8);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 89 to 105
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xc0) << 9);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 106 to 122
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xe0) << 10);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 123 to 139
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)(input[17] & 0xf0) << 11);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 140 to 156
	value = ((uint32_t)(input[17] & 0x0f) << 28) |
			((uint32_t)input[18] << 20) |
			((uint32_t)(input[19] & 0xf8) << 12);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 157 to 173
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0xfc) << 13);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 174 to 190
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xfe) << 14);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 191 to 207
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 208 to 224
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16) |
			((uint32_t)(input[28] & 0x80) << 8);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 225 to 241
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0xc0) << 9);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 242 to 258
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xe0) << 10);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 259 to 275
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xf0) << 11);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 276 to 292
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf8) << 12);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 293 to 309
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xfc) << 13);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 310 to 326
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfe) << 14);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 327 to 343
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)input[42] << 15);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 344 to 360
	value = ((uint32_t)input[43] << 24) |
			((uint32_t)input[44] << 16) |
			((uint32_t)(input[45] & 0x80) << 8);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 361 to 377
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)(input[47] & 0xc0) << 9);
	output[21] = (double)(value >> 15);
}

static void unpack_22_17bit_signed_5off(const uint8_t * input, double * output) {
	// Unpack 22 values into output
	// Values are 17-bit signed
	// Skip 5 bits, read 374 bits of data.
	// Input must be at least 48 bytes long

	int32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 56 to 72
	value = ((uint32_t)input[7] << 24) |
			((uint32_t)input[8] << 16) |
			((uint32_t)(input[9] & 0x80) << 8);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 73 to 89
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)(input[11] & 0xc0) << 9);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 90 to 106
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xe0) << 10);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 107 to 123
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)(input[15] & 0xf0) << 11);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 124 to 140
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)(input[17] & 0xf8) << 12);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 141 to 157
	value = ((uint32_t)(input[17] & 0x07) << 29) |
			((uint32_t)input[18] << 21) |
			((uint32_t)(input[19] & 0xfc) << 13);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 158 to 174
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xfe) << 14);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 175 to 191
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 192 to 208
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0x80) << 8);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 209 to 225
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0xc0) << 9);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 226 to 242
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xe0) << 10);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 243 to 259
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xf0) << 11);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 260 to 276
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf8) << 12);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 277 to 293
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xfc) << 13);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 294 to 310
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfe) << 14);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 311 to 327
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)input[40] << 15);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 328 to 344
	value = ((uint32_t)input[41] << 24) |
			((uint32_t)input[42] << 16) |
			((uint32_t)(input[43] & 0x80) << 8);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 345 to 361
	value = ((uint32_t)(input[43] & 0x7f) << 25) |
			((uint32_t)input[44] << 17) |
			((uint32_t)(input[45] & 0xc0) << 9);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 362 to 378
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)(input[47] & 0xe0) << 10);
	output[21] = (double)(value >> 15);
}

static void unpack_22_17bit_unsigned_5off(const uint8_t * input, double * output) {
	// Unpack 22 values into output
	// Values are 17-bit unsigned
	// Skip 5 bits, read 374 bits of data.
	// Input must be at least 48 bytes long

	uint32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 56 to 72
	value = ((uint32_t)input[7] << 24) |
			((uint32_t)input[8] << 16) |
			((uint32_t)(input[9] & 0x80) << 8);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 73 to 89
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)(input[11] & 0xc0) << 9);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 90 to 106
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xe0) << 10);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 107 to 123
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)(input[15] & 0xf0) << 11);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 124 to 140
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)(input[17] & 0xf8) << 12);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 141 to 157
	value = ((uint32_t)(input[17] & 0x07) << 29) |
			((uint32_t)input[18] << 21) |
			((uint32_t)(input[19] & 0xfc) << 13);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 158 to 174
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xfe) << 14);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 175 to 191
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 192 to 208
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0x80) << 8);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 209 to 225
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0xc0) << 9);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 226 to 242
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xe0) << 10);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 243 to 259
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xf0) << 11);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 260 to 276
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf8) << 12);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 277 to 293
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xfc) << 13);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 294 to 310
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfe) << 14);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 311 to 327
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)input[40] << 15);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 328 to 344
	value = ((uint32_t)input[41] << 24) |
			((uint32_t)input[42] << 16) |
			((uint32_t)(input[43] & 0x80) << 8);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 345 to 361
	value = ((uint32_t)(input[43] & 0x7f) << 25) |
			((uint32_t)input[44] << 17) |
			((uint32_t)(input[45] & 0xc0) << 9);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 362 to 378
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)(input[47] & 0xe0) << 10);
	output[21] = (double)(value >> 15);
}

static void unpack_22_17bit_signed_6off(const uint8_t * input, double * output) {
	// Unpack 22 values into output
	// Values are 17-bit signed
	// Skip 6 bits, read 374 bits of data.
	// Input must be at least 48 bytes long

	int32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 57 to 73
	value = ((uint32_t)(input[7] & 0x7f) << 25) |
			((uint32_t)input[8] << 17) |
			((uint32_t)(input[9] & 0xc0) << 9);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 74 to 90
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)(input[11] & 0xe0) << 10);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 91 to 107
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)(input[13] & 0xf0) << 11);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 108 to 124
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)(input[15] & 0xf8) << 12);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 125 to 141
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0xfc) << 13);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 142 to 158
	value = ((uint32_t)(input[17] & 0x03) << 30) |
			((uint32_t)input[18] << 22) |
			((uint32_t)(input[19] & 0xfe) << 14);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 159 to 175
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)input[21] << 15);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 176 to 192
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16) |
			((uint32_t)(input[24] & 0x80) << 8);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 193 to 209
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xc0) << 9);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 210 to 226
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xe0) << 10);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 227 to 243
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xf0) << 11);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 244 to 260
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf8) << 12);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 261 to 277
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xfc) << 13);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 278 to 294
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfe) << 14);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 295 to 311
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 312 to 328
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)(input[41] & 0x80) << 8);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 329 to 345
	value = ((uint32_t)(input[41] & 0x7f) << 25) |
			((uint32_t)input[42] << 17) |
			((uint32_t)(input[43] & 0xc0) << 9);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 346 to 362
	value = ((uint32_t)(input[43] & 0x3f) << 26) |
			((uint32_t)input[44] << 18) |
			((uint32_t)(input[45] & 0xe0) << 10);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 363 to 379
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)(input[47] & 0xf0) << 11);
	output[21] = (double)(value >> 15);
}

static void unpack_22_17bit_unsigned_6off(const uint8_t * input, double * output) {
	// Unpack 22 values into output
	// Values are 17-bit unsigned
	// Skip 6 bits, read 374 bits of data.
	// Input must be at least 48 bytes long

	uint32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 57 to 73
	value = ((uint32_t)(input[7] & 0x7f) << 25) |
			((uint32_t)input[8] << 17) |
			((uint32_t)(input[9] & 0xc0) << 9);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 74 to 90
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)(input[11] & 0xe0) << 10);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 91 to 107
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)(input[13] & 0xf0) << 11);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 108 to 124
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)(input[15] & 0xf8) << 12);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 125 to 141
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0xfc) << 13);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 142 to 158
	value = ((uint32_t)(input[17] & 0x03) << 30) |
			((uint32_t)input[18] << 22) |
			((uint32_t)(input[19] & 0xfe) << 14);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 159 to 175
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)input[21] << 15);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 176 to 192
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16) |
			((uint32_t)(input[24] & 0x80) << 8);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 193 to 209
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xc0) << 9);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 210 to 226
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xe0) << 10);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 227 to 243
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xf0) << 11);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 244 to 260
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf8) << 12);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 261 to 277
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xfc) << 13);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 278 to 294
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfe) << 14);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 295 to 311
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 312 to 328
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)(input[41] & 0x80) << 8);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 329 to 345
	value = ((uint32_t)(input[41] & 0x7f) << 25) |
			((uint32_t)input[42] << 17) |
			((uint32_t)(input[43] & 0xc0) << 9);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 346 to 362
	value = ((uint32_t)(input[43] & 0x3f) << 26) |
			((uint32_t)input[44] << 18) |
			((uint32_t)(input[45] & 0xe0) << 10);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 363 to 379
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)(input[47] & 0xf0) << 11);
	output[21] = (double)(value >> 15);
}

static void unpack_22_17bit_signed_7off(const uint8_t * input, double * output) {
	// Unpack 22 values into output
	// Values are 17-bit signed
	// Skip 7 bits, read 374 bits of data.
	// Input must be at least 48 bytes long

	int32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 58 to 74
	value = ((uint32_t)(input[7] & 0x3f) << 26) |
			((uint32_t)input[8] << 18) |
			((uint32_t)(input[9] & 0xe0) << 10);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 75 to 91
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)(input[11] & 0xf0) << 11);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 92 to 108
	value = ((uint32_t)(input[11] & 0x0f) << 28) |
			((uint32_t)input[12] << 20) |
			((uint32_t)(input[13] & 0xf8) << 12);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 109 to 125
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0xfc) << 13);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 126 to 142
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xfe) << 14);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 143 to 159
	value = ((uint32_t)(input[17] & 0x01) << 31) |
			((uint32_t)input[18] << 23) |
			((uint32_t)input[19] << 15);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 160 to 176
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16) |
			((uint32_t)(input[22] & 0x80) << 8);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 177 to 193
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0xc0) << 9);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 194 to 210
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xe0) << 10);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 211 to 227
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xf0) << 11);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 228 to 244
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf8) << 12);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 245 to 261
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xfc) << 13);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 262 to 278
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfe) << 14);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 279 to 295
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)input[36] << 15);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 296 to 312
	value = ((uint32_t)input[37] << 24) |
			((uint32_t)input[38] << 16) |
			((uint32_t)(input[39] & 0x80) << 8);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 313 to 329
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)(input[41] & 0xc0) << 9);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 330 to 346
	value = ((uint32_t)(input[41] & 0x3f) << 26) |
			((uint32_t)input[42] << 18) |
			((uint32_t)(input[43] & 0xe0) << 10);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 347 to 363
	value = ((uint32_t)(input[43] & 0x1f) << 27) |
			((uint32_t)input[44] << 19) |
			((uint32_t)(input[45] & 0xf0) << 11);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 364 to 380
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)(input[47] & 0xf8) << 12);
	output[21] = (double)(value >> 15);
}

static void unpack_22_17bit_unsigned_7off(const uint8_t * input, double * output) {
	// Unpack 22 values into output
	// Values are 17-bit unsigned
	// Skip 7 bits, read 374 bits of data.
	// Input must be at least 48 bytes long

	uint32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 58 to 74
	value = ((uint32_t)(input[7] & 0x3f) << 26) |
			((uint32_t)input[8] << 18) |
			((uint32_t)(input[9] & 0xe0) << 10);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 75 to 91
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)(input[11] & 0xf0) << 11);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 92 to 108
	value = ((uint32_t)(input[11] & 0x0f) << 28) |
			((uint32_t)input[12] << 20) |
			((uint32_t)(input[13] & 0xf8) << 12);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 109 to 125
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0xfc) << 13);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 126 to 142
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xfe) << 14);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 143 to 159
	value = ((uint32_t)(input[17] & 0x01) << 31) |
			((uint32_t)input[18] << 23) |
			((uint32_t)input[19] << 15);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 160 to 176
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16) |
			((uint32_t)(input[22] & 0x80) << 8);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 177 to 193
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0xc0) << 9);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 194 to 210
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xe0) << 10);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 211 to 227
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xf0) << 11);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 228 to 244
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf8) << 12);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 245 to 261
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xfc) << 13);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 262 to 278
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfe) << 14);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 279 to 295
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)input[36] << 15);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 296 to 312
	value = ((uint32_t)input[37] << 24) |
			((uint32_t)input[38] << 16) |
			((uint32_t)(input[39] & 0x80) << 8);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 313 to 329
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)(input[41] & 0xc0) << 9);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 330 to 346
	value = ((uint32_t)(input[41] & 0x3f) << 26) |
			((uint32_t)input[42] << 18) |
			((uint32_t)(input[43] & 0xe0) << 10);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 347 to 363
	value = ((uint32_t)(input[43] & 0x1f) << 27) |
			((uint32_t)input[44] << 19) |
			((uint32_t)(input[45] & 0xf0) << 11);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 364 to 380
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)(input[47] & 0xf8) << 12);
	output[21] = (double)(value >> 15);
}

static void unpack_23_17bit_signed_0off(const uint8_t * input, double * output) {
	// Unpack 23 values into output
	// Values are 17-bit signed
	// Skip 0 bits, read 391 bits of data.
	// Input must be at least 49 bytes long

	int32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 51 to 67
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xf0) << 11);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 68 to 84
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf8) << 12);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 85 to 101
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xfc) << 13);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 102 to 118
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfe) << 14);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 119 to 135
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)input[16] << 15);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 136 to 152
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)input[18] << 16) |
			((uint32_t)(input[19] & 0x80) << 8);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 153 to 169
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xc0) << 9);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 170 to 186
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xe0) << 10);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 187 to 203
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)input[24] << 19) |
			((uint32_t)(input[25] & 0xf0) << 11);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 204 to 220
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20) |
			((uint32_t)(input[27] & 0xf8) << 12);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 221 to 237
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0xfc) << 13);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 238 to 254
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)(input[31] & 0xfe) << 14);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 255 to 271
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)input[33] << 15);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 272 to 288
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16) |
			((uint32_t)(input[36] & 0x80) << 8);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 289 to 305
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0xc0) << 9);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 306 to 322
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xe0) << 10);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 323 to 339
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xf0) << 11);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 340 to 356
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf8) << 12);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 357 to 373
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xfc) << 13);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 374 to 390
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfe) << 14);
	output[22] = (double)(value >> 15);
}

static void unpack_23_17bit_unsigned_0off(const uint8_t * input, double * output) {
	// Unpack 23 values into output
	// Values are 17-bit unsigned
	// Skip 0 bits, read 391 bits of data.
	// Input must be at least 49 bytes long

	uint32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 51 to 67
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xf0) << 11);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 68 to 84
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf8) << 12);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 85 to 101
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xfc) << 13);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 102 to 118
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfe) << 14);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 119 to 135
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)input[16] << 15);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 136 to 152
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)input[18] << 16) |
			((uint32_t)(input[19] & 0x80) << 8);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 153 to 169
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xc0) << 9);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 170 to 186
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xe0) << 10);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 187 to 203
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)input[24] << 19) |
			((uint32_t)(input[25] & 0xf0) << 11);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 204 to 220
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20) |
			((uint32_t)(input[27] & 0xf8) << 12);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 221 to 237
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0xfc) << 13);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 238 to 254
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)(input[31] & 0xfe) << 14);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 255 to 271
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)input[33] << 15);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 272 to 288
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16) |
			((uint32_t)(input[36] & 0x80) << 8);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 289 to 305
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0xc0) << 9);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 306 to 322
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xe0) << 10);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 323 to 339
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xf0) << 11);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 340 to 356
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf8) << 12);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 357 to 373
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xfc) << 13);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 374 to 390
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfe) << 14);
	output[22] = (double)(value >> 15);
}

static void unpack_23_17bit_signed_1off(const uint8_t * input, double * output) {
	// Unpack 23 values into output
	// Values are 17-bit signed
	// Skip 1 bits, read 391 bits of data.
	// Input must be at least 49 bytes long

	int32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 52 to 68
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf8) << 12);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 69 to 85
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xfc) << 13);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 86 to 102
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfe) << 14);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 103 to 119
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 120 to 136
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)(input[17] & 0x80) << 8);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 137 to 153
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)input[18] << 17) |
			((uint32_t)(input[19] & 0xc0) << 9);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 154 to 170
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xe0) << 10);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 171 to 187
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)(input[23] & 0xf0) << 11);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 188 to 204
	value = ((uint32_t)(input[23] & 0x0f) << 28) |
			((uint32_t)input[24] << 20) |
			((uint32_t)(input[25] & 0xf8) << 12);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 205 to 221
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0xfc) << 13);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 222 to 238
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xfe) << 14);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 239 to 255
	value = ((uint32_t)(input[29] & 0x01) << 31) |
			((uint32_t)input[30] << 23) |
			((uint32_t)input[31] << 15);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 256 to 272
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16) |
			((uint32_t)(input[34] & 0x80) << 8);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 273 to 289
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0xc0) << 9);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 290 to 306
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xe0) << 10);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 307 to 323
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xf0) << 11);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 324 to 340
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf8) << 12);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 341 to 357
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xfc) << 13);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 358 to 374
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfe) << 14);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 375 to 391
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)input[48] << 15);
	output[22] = (double)(value >> 15);
}

static void unpack_23_17bit_unsigned_1off(const uint8_t * input, double * output) {
	// Unpack 23 values into output
	// Values are 17-bit unsigned
	// Skip 1 bits, read 391 bits of data.
	// Input must be at least 49 bytes long

	uint32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 52 to 68
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf8) << 12);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 69 to 85
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xfc) << 13);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 86 to 102
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfe) << 14);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 103 to 119
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 120 to 136
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)(input[17] & 0x80) << 8);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 137 to 153
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)input[18] << 17) |
			((uint32_t)(input[19] & 0xc0) << 9);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 154 to 170
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xe0) << 10);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 171 to 187
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)(input[23] & 0xf0) << 11);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 188 to 204
	value = ((uint32_t)(input[23] & 0x0f) << 28) |
			((uint32_t)input[24] << 20) |
			((uint32_t)(input[25] & 0xf8) << 12);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 205 to 221
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0xfc) << 13);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 222 to 238
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xfe) << 14);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 239 to 255
	value = ((uint32_t)(input[29] & 0x01) << 31) |
			((uint32_t)input[30] << 23) |
			((uint32_t)input[31] << 15);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 256 to 272
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16) |
			((uint32_t)(input[34] & 0x80) << 8);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 273 to 289
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0xc0) << 9);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 290 to 306
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xe0) << 10);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 307 to 323
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xf0) << 11);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 324 to 340
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf8) << 12);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 341 to 357
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xfc) << 13);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 358 to 374
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfe) << 14);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 375 to 391
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)input[48] << 15);
	output[22] = (double)(value >> 15);
}

static void unpack_23_17bit_signed_2off(const uint8_t * input, double * output) {
	// Unpack 23 values into output
	// Values are 17-bit signed
	// Skip 2 bits, read 391 bits of data.
	// Input must be at least 50 bytes long

	int32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 53 to 69
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xfc) << 13);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 70 to 86
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfe) << 14);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 87 to 103
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 104 to 120
	value = ((uint32_t)input[13] << 24) |
			((uint32_t)input[14] << 16) |
			((uint32_t)(input[15] & 0x80) << 8);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 121 to 137
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)(input[17] & 0xc0) << 9);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 138 to 154
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)input[18] << 18) |
			((uint32_t)(input[19] & 0xe0) << 10);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 155 to 171
	value = ((uint32_t)(input[19] & 0x1f) << 27) |
			((uint32_t)input[20] << 19) |
			((uint32_t)(input[21] & 0xf0) << 11);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 172 to 188
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)(input[23] & 0xf8) << 12);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 189 to 205
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)(input[25] & 0xfc) << 13);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 206 to 222
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xfe) << 14);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 223 to 239
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 240 to 256
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)(input[32] & 0x80) << 8);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 257 to 273
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0xc0) << 9);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 274 to 290
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xe0) << 10);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 291 to 307
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xf0) << 11);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 308 to 324
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf8) << 12);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 325 to 341
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xfc) << 13);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 342 to 358
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfe) << 14);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 359 to 375
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)input[46] << 15);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 376 to 392
	value = ((uint32_t)input[47] << 24) |
			((uint32_t)input[48] << 16) |
			((uint32_t)(input[49] & 0x80) << 8);
	output[22] = (double)(value >> 15);
}

static void unpack_23_17bit_unsigned_2off(const uint8_t * input, double * output) {
	// Unpack 23 values into output
	// Values are 17-bit unsigned
	// Skip 2 bits, read 391 bits of data.
	// Input must be at least 50 bytes long

	uint32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 53 to 69
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xfc) << 13);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 70 to 86
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfe) << 14);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 87 to 103
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 104 to 120
	value = ((uint32_t)input[13] << 24) |
			((uint32_t)input[14] << 16) |
			((uint32_t)(input[15] & 0x80) << 8);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 121 to 137
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)(input[17] & 0xc0) << 9);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 138 to 154
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)input[18] << 18) |
			((uint32_t)(input[19] & 0xe0) << 10);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 155 to 171
	value = ((uint32_t)(input[19] & 0x1f) << 27) |
			((uint32_t)input[20] << 19) |
			((uint32_t)(input[21] & 0xf0) << 11);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 172 to 188
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)(input[23] & 0xf8) << 12);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 189 to 205
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)(input[25] & 0xfc) << 13);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 206 to 222
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xfe) << 14);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 223 to 239
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 240 to 256
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)(input[32] & 0x80) << 8);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 257 to 273
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0xc0) << 9);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 274 to 290
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xe0) << 10);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 291 to 307
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xf0) << 11);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 308 to 324
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf8) << 12);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 325 to 341
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xfc) << 13);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 342 to 358
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfe) << 14);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 359 to 375
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)input[46] << 15);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 376 to 392
	value = ((uint32_t)input[47] << 24) |
			((uint32_t)input[48] << 16) |
			((uint32_t)(input[49] & 0x80) << 8);
	output[22] = (double)(value >> 15);
}

static void unpack_23_17bit_signed_3off(const uint8_t * input, double * output) {
	// Unpack 23 values into output
	// Values are 17-bit signed
	// Skip 3 bits, read 391 bits of data.
	// Input must be at least 50 bytes long

	int32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 54 to 70
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfe) << 14);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 71 to 87
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)input[10] << 15);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 88 to 104
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0x80) << 8);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 105 to 121
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xc0) << 9);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 122 to 138
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)(input[17] & 0xe0) << 10);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 139 to 155
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)input[18] << 19) |
			((uint32_t)(input[19] & 0xf0) << 11);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 156 to 172
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20) |
			((uint32_t)(input[21] & 0xf8) << 12);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 173 to 189
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0xfc) << 13);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 190 to 206
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)(input[25] & 0xfe) << 14);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 207 to 223
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)input[27] << 15);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 224 to 240
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16) |
			((uint32_t)(input[30] & 0x80) << 8);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 241 to 257
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0xc0) << 9);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 258 to 274
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xe0) << 10);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 275 to 291
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xf0) << 11);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 292 to 308
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf8) << 12);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 309 to 325
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xfc) << 13);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 326 to 342
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfe) << 14);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 343 to 359
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 360 to 376
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)(input[47] & 0x80) << 8);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 377 to 393
	value = ((uint32_t)(input[47] & 0x7f) << 25) |
			((uint32_t)input[48] << 17) |
			((uint32_t)(input[49] & 0xc0) << 9);
	output[22] = (double)(value >> 15);
}

static void unpack_23_17bit_unsigned_3off(const uint8_t * input, double * output) {
	// Unpack 23 values into output
	// Values are 17-bit unsigned
	// Skip 3 bits, read 391 bits of data.
	// Input must be at least 50 bytes long

	uint32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 54 to 70
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfe) << 14);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 71 to 87
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)input[10] << 15);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 88 to 104
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0x80) << 8);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 105 to 121
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xc0) << 9);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 122 to 138
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)(input[17] & 0xe0) << 10);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 139 to 155
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)input[18] << 19) |
			((uint32_t)(input[19] & 0xf0) << 11);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 156 to 172
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20) |
			((uint32_t)(input[21] & 0xf8) << 12);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 173 to 189
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0xfc) << 13);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 190 to 206
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)(input[25] & 0xfe) << 14);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 207 to 223
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)input[27] << 15);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 224 to 240
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16) |
			((uint32_t)(input[30] & 0x80) << 8);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 241 to 257
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0xc0) << 9);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 258 to 274
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xe0) << 10);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 275 to 291
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xf0) << 11);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 292 to 308
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf8) << 12);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 309 to 325
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xfc) << 13);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 326 to 342
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfe) << 14);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 343 to 359
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 360 to 376
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)(input[47] & 0x80) << 8);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 377 to 393
	value = ((uint32_t)(input[47] & 0x7f) << 25) |
			((uint32_t)input[48] << 17) |
			((uint32_t)(input[49] & 0xc0) << 9);
	output[22] = (double)(value >> 15);
}

static void unpack_23_17bit_signed_4off(const uint8_t * input, double * output) {
	// Unpack 23 values into output
	// Values are 17-bit signed
	// Skip 4 bits, read 391 bits of data.
	// Input must be at least 50 bytes long

	int32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 55 to 71
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 72 to 88
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)(input[11] & 0x80) << 8);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 89 to 105
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xc0) << 9);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 106 to 122
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xe0) << 10);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 123 to 139
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)(input[17] & 0xf0) << 11);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 140 to 156
	value = ((uint32_t)(input[17] & 0x0f) << 28) |
			((uint32_t)input[18] << 20) |
			((uint32_t)(input[19] & 0xf8) << 12);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 157 to 173
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0xfc) << 13);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 174 to 190
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xfe) << 14);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 191 to 207
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 208 to 224
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16) |
			((uint32_t)(input[28] & 0x80) << 8);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 225 to 241
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0xc0) << 9);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 242 to 258
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xe0) << 10);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 259 to 275
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xf0) << 11);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 276 to 292
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf8) << 12);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 293 to 309
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xfc) << 13);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 310 to 326
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfe) << 14);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 327 to 343
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)input[42] << 15);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 344 to 360
	value = ((uint32_t)input[43] << 24) |
			((uint32_t)input[44] << 16) |
			((uint32_t)(input[45] & 0x80) << 8);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 361 to 377
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)(input[47] & 0xc0) << 9);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 378 to 394
	value = ((uint32_t)(input[47] & 0x3f) << 26) |
			((uint32_t)input[48] << 18) |
			((uint32_t)(input[49] & 0xe0) << 10);
	output[22] = (double)(value >> 15);
}

static void unpack_23_17bit_unsigned_4off(const uint8_t * input, double * output) {
	// Unpack 23 values into output
	// Values are 17-bit unsigned
	// Skip 4 bits, read 391 bits of data.
	// Input must be at least 50 bytes long

	uint32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 55 to 71
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 72 to 88
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)(input[11] & 0x80) << 8);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 89 to 105
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xc0) << 9);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 106 to 122
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xe0) << 10);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 123 to 139
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)(input[17] & 0xf0) << 11);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 140 to 156
	value = ((uint32_t)(input[17] & 0x0f) << 28) |
			((uint32_t)input[18] << 20) |
			((uint32_t)(input[19] & 0xf8) << 12);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 157 to 173
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0xfc) << 13);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 174 to 190
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xfe) << 14);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 191 to 207
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 208 to 224
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16) |
			((uint32_t)(input[28] & 0x80) << 8);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 225 to 241
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0xc0) << 9);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 242 to 258
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xe0) << 10);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 259 to 275
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xf0) << 11);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 276 to 292
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf8) << 12);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 293 to 309
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xfc) << 13);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 310 to 326
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfe) << 14);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 327 to 343
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)input[42] << 15);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 344 to 360
	value = ((uint32_t)input[43] << 24) |
			((uint32_t)input[44] << 16) |
			((uint32_t)(input[45] & 0x80) << 8);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 361 to 377
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)(input[47] & 0xc0) << 9);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 378 to 394
	value = ((uint32_t)(input[47] & 0x3f) << 26) |
			((uint32_t)input[48] << 18) |
			((uint32_t)(input[49] & 0xe0) << 10);
	output[22] = (double)(value >> 15);
}

static void unpack_23_17bit_signed_5off(const uint8_t * input, double * output) {
	// Unpack 23 values into output
	// Values are 17-bit signed
	// Skip 5 bits, read 391 bits of data.
	// Input must be at least 50 bytes long

	int32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 56 to 72
	value = ((uint32_t)input[7] << 24) |
			((uint32_t)input[8] << 16) |
			((uint32_t)(input[9] & 0x80) << 8);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 73 to 89
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)(input[11] & 0xc0) << 9);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 90 to 106
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xe0) << 10);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 107 to 123
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)(input[15] & 0xf0) << 11);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 124 to 140
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)(input[17] & 0xf8) << 12);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 141 to 157
	value = ((uint32_t)(input[17] & 0x07) << 29) |
			((uint32_t)input[18] << 21) |
			((uint32_t)(input[19] & 0xfc) << 13);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 158 to 174
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xfe) << 14);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 175 to 191
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 192 to 208
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0x80) << 8);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 209 to 225
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0xc0) << 9);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 226 to 242
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xe0) << 10);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 243 to 259
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xf0) << 11);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 260 to 276
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf8) << 12);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 277 to 293
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xfc) << 13);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 294 to 310
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfe) << 14);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 311 to 327
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)input[40] << 15);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 328 to 344
	value = ((uint32_t)input[41] << 24) |
			((uint32_t)input[42] << 16) |
			((uint32_t)(input[43] & 0x80) << 8);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 345 to 361
	value = ((uint32_t)(input[43] & 0x7f) << 25) |
			((uint32_t)input[44] << 17) |
			((uint32_t)(input[45] & 0xc0) << 9);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 362 to 378
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)(input[47] & 0xe0) << 10);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 379 to 395
	value = ((uint32_t)(input[47] & 0x1f) << 27) |
			((uint32_t)input[48] << 19) |
			((uint32_t)(input[49] & 0xf0) << 11);
	output[22] = (double)(value >> 15);
}

static void unpack_23_17bit_unsigned_5off(const uint8_t * input, double * output) {
	// Unpack 23 values into output
	// Values are 17-bit unsigned
	// Skip 5 bits, read 391 bits of data.
	// Input must be at least 50 bytes long

	uint32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 56 to 72
	value = ((uint32_t)input[7] << 24) |
			((uint32_t)input[8] << 16) |
			((uint32_t)(input[9] & 0x80) << 8);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 73 to 89
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)(input[11] & 0xc0) << 9);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 90 to 106
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xe0) << 10);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 107 to 123
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)(input[15] & 0xf0) << 11);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 124 to 140
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)(input[17] & 0xf8) << 12);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 141 to 157
	value = ((uint32_t)(input[17] & 0x07) << 29) |
			((uint32_t)input[18] << 21) |
			((uint32_t)(input[19] & 0xfc) << 13);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 158 to 174
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xfe) << 14);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 175 to 191
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 192 to 208
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0x80) << 8);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 209 to 225
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0xc0) << 9);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 226 to 242
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xe0) << 10);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 243 to 259
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xf0) << 11);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 260 to 276
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf8) << 12);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 277 to 293
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xfc) << 13);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 294 to 310
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfe) << 14);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 311 to 327
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)input[40] << 15);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 328 to 344
	value = ((uint32_t)input[41] << 24) |
			((uint32_t)input[42] << 16) |
			((uint32_t)(input[43] & 0x80) << 8);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 345 to 361
	value = ((uint32_t)(input[43] & 0x7f) << 25) |
			((uint32_t)input[44] << 17) |
			((uint32_t)(input[45] & 0xc0) << 9);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 362 to 378
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)(input[47] & 0xe0) << 10);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 379 to 395
	value = ((uint32_t)(input[47] & 0x1f) << 27) |
			((uint32_t)input[48] << 19) |
			((uint32_t)(input[49] & 0xf0) << 11);
	output[22] = (double)(value >> 15);
}

static void unpack_23_17bit_signed_6off(const uint8_t * input, double * output) {
	// Unpack 23 values into output
	// Values are 17-bit signed
	// Skip 6 bits, read 391 bits of data.
	// Input must be at least 50 bytes long

	int32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 57 to 73
	value = ((uint32_t)(input[7] & 0x7f) << 25) |
			((uint32_t)input[8] << 17) |
			((uint32_t)(input[9] & 0xc0) << 9);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 74 to 90
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)(input[11] & 0xe0) << 10);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 91 to 107
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)(input[13] & 0xf0) << 11);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 108 to 124
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)(input[15] & 0xf8) << 12);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 125 to 141
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0xfc) << 13);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 142 to 158
	value = ((uint32_t)(input[17] & 0x03) << 30) |
			((uint32_t)input[18] << 22) |
			((uint32_t)(input[19] & 0xfe) << 14);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 159 to 175
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)input[21] << 15);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 176 to 192
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16) |
			((uint32_t)(input[24] & 0x80) << 8);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 193 to 209
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xc0) << 9);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 210 to 226
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xe0) << 10);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 227 to 243
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xf0) << 11);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 244 to 260
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf8) << 12);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 261 to 277
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xfc) << 13);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 278 to 294
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfe) << 14);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 295 to 311
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 312 to 328
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)(input[41] & 0x80) << 8);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 329 to 345
	value = ((uint32_t)(input[41] & 0x7f) << 25) |
			((uint32_t)input[42] << 17) |
			((uint32_t)(input[43] & 0xc0) << 9);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 346 to 362
	value = ((uint32_t)(input[43] & 0x3f) << 26) |
			((uint32_t)input[44] << 18) |
			((uint32_t)(input[45] & 0xe0) << 10);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 363 to 379
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)(input[47] & 0xf0) << 11);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 380 to 396
	value = ((uint32_t)(input[47] & 0x0f) << 28) |
			((uint32_t)input[48] << 20) |
			((uint32_t)(input[49] & 0xf8) << 12);
	output[22] = (double)(value >> 15);
}

static void unpack_23_17bit_unsigned_6off(const uint8_t * input, double * output) {
	// Unpack 23 values into output
	// Values are 17-bit unsigned
	// Skip 6 bits, read 391 bits of data.
	// Input must be at least 50 bytes long

	uint32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 57 to 73
	value = ((uint32_t)(input[7] & 0x7f) << 25) |
			((uint32_t)input[8] << 17) |
			((uint32_t)(input[9] & 0xc0) << 9);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 74 to 90
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)(input[11] & 0xe0) << 10);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 91 to 107
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)(input[13] & 0xf0) << 11);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 108 to 124
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)(input[15] & 0xf8) << 12);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 125 to 141
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0xfc) << 13);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 142 to 158
	value = ((uint32_t)(input[17] & 0x03) << 30) |
			((uint32_t)input[18] << 22) |
			((uint32_t)(input[19] & 0xfe) << 14);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 159 to 175
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)input[21] << 15);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 176 to 192
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16) |
			((uint32_t)(input[24] & 0x80) << 8);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 193 to 209
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xc0) << 9);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 210 to 226
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xe0) << 10);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 227 to 243
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xf0) << 11);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 244 to 260
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf8) << 12);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 261 to 277
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xfc) << 13);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 278 to 294
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfe) << 14);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 295 to 311
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 312 to 328
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)(input[41] & 0x80) << 8);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 329 to 345
	value = ((uint32_t)(input[41] & 0x7f) << 25) |
			((uint32_t)input[42] << 17) |
			((uint32_t)(input[43] & 0xc0) << 9);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 346 to 362
	value = ((uint32_t)(input[43] & 0x3f) << 26) |
			((uint32_t)input[44] << 18) |
			((uint32_t)(input[45] & 0xe0) << 10);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 363 to 379
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)(input[47] & 0xf0) << 11);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 380 to 396
	value = ((uint32_t)(input[47] & 0x0f) << 28) |
			((uint32_t)input[48] << 20) |
			((uint32_t)(input[49] & 0xf8) << 12);
	output[22] = (double)(value >> 15);
}

static void unpack_23_17bit_signed_7off(const uint8_t * input, double * output) {
	// Unpack 23 values into output
	// Values are 17-bit signed
	// Skip 7 bits, read 391 bits of data.
	// Input must be at least 50 bytes long

	int32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 58 to 74
	value = ((uint32_t)(input[7] & 0x3f) << 26) |
			((uint32_t)input[8] << 18) |
			((uint32_t)(input[9] & 0xe0) << 10);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 75 to 91
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)(input[11] & 0xf0) << 11);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 92 to 108
	value = ((uint32_t)(input[11] & 0x0f) << 28) |
			((uint32_t)input[12] << 20) |
			((uint32_t)(input[13] & 0xf8) << 12);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 109 to 125
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0xfc) << 13);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 126 to 142
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xfe) << 14);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 143 to 159
	value = ((uint32_t)(input[17] & 0x01) << 31) |
			((uint32_t)input[18] << 23) |
			((uint32_t)input[19] << 15);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 160 to 176
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16) |
			((uint32_t)(input[22] & 0x80) << 8);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 177 to 193
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0xc0) << 9);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 194 to 210
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xe0) << 10);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 211 to 227
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xf0) << 11);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 228 to 244
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf8) << 12);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 245 to 261
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xfc) << 13);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 262 to 278
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfe) << 14);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 279 to 295
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)input[36] << 15);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 296 to 312
	value = ((uint32_t)input[37] << 24) |
			((uint32_t)input[38] << 16) |
			((uint32_t)(input[39] & 0x80) << 8);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 313 to 329
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)(input[41] & 0xc0) << 9);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 330 to 346
	value = ((uint32_t)(input[41] & 0x3f) << 26) |
			((uint32_t)input[42] << 18) |
			((uint32_t)(input[43] & 0xe0) << 10);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 347 to 363
	value = ((uint32_t)(input[43] & 0x1f) << 27) |
			((uint32_t)input[44] << 19) |
			((uint32_t)(input[45] & 0xf0) << 11);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 364 to 380
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)(input[47] & 0xf8) << 12);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 381 to 397
	value = ((uint32_t)(input[47] & 0x07) << 29) |
			((uint32_t)input[48] << 21) |
			((uint32_t)(input[49] & 0xfc) << 13);
	output[22] = (double)(value >> 15);
}

static void unpack_23_17bit_unsigned_7off(const uint8_t * input, double * output) {
	// Unpack 23 values into output
	// Values are 17-bit unsigned
	// Skip 7 bits, read 391 bits of data.
	// Input must be at least 50 bytes long

	uint32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 58 to 74
	value = ((uint32_t)(input[7] & 0x3f) << 26) |
			((uint32_t)input[8] << 18) |
			((uint32_t)(input[9] & 0xe0) << 10);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 75 to 91
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)(input[11] & 0xf0) << 11);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 92 to 108
	value = ((uint32_t)(input[11] & 0x0f) << 28) |
			((uint32_t)input[12] << 20) |
			((uint32_t)(input[13] & 0xf8) << 12);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 109 to 125
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0xfc) << 13);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 126 to 142
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xfe) << 14);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 143 to 159
	value = ((uint32_t)(input[17] & 0x01) << 31) |
			((uint32_t)input[18] << 23) |
			((uint32_t)input[19] << 15);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 160 to 176
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16) |
			((uint32_t)(input[22] & 0x80) << 8);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 177 to 193
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0xc0) << 9);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 194 to 210
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xe0) << 10);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 211 to 227
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xf0) << 11);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 228 to 244
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf8) << 12);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 245 to 261
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xfc) << 13);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 262 to 278
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfe) << 14);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 279 to 295
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)input[36] << 15);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 296 to 312
	value = ((uint32_t)input[37] << 24) |
			((uint32_t)input[38] << 16) |
			((uint32_t)(input[39] & 0x80) << 8);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 313 to 329
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)(input[41] & 0xc0) << 9);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 330 to 346
	value = ((uint32_t)(input[41] & 0x3f) << 26) |
			((uint32_t)input[42] << 18) |
			((uint32_t)(input[43] & 0xe0) << 10);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 347 to 363
	value = ((uint32_t)(input[43] & 0x1f) << 27) |
			((uint32_t)input[44] << 19) |
			((uint32_t)(input[45] & 0xf0) << 11);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 364 to 380
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)(input[47] & 0xf8) << 12);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 381 to 397
	value = ((uint32_t)(input[47] & 0x07) << 29) |
			((uint32_t)input[48] << 21) |
			((uint32_t)(input[49] & 0xfc) << 13);
	output[22] = (double)(value >> 15);
}

static void unpack_24_17bit_signed_0off(const uint8_t * input, double * output) {
	// Unpack 24 values into output
	// Values are 17-bit signed
	// Skip 0 bits, read 408 bits of data.
	// Input must be at least 51 bytes long

	int32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 51 to 67
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xf0) << 11);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 68 to 84
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf8) << 12);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 85 to 101
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xfc) << 13);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 102 to 118
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfe) << 14);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 119 to 135
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)input[16] << 15);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 136 to 152
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)input[18] << 16) |
			((uint32_t)(input[19] & 0x80) << 8);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 153 to 169
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xc0) << 9);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 170 to 186
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xe0) << 10);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 187 to 203
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)input[24] << 19) |
			((uint32_t)(input[25] & 0xf0) << 11);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 204 to 220
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20) |
			((uint32_t)(input[27] & 0xf8) << 12);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 221 to 237
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0xfc) << 13);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 238 to 254
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)(input[31] & 0xfe) << 14);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 255 to 271
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)input[33] << 15);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 272 to 288
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16) |
			((uint32_t)(input[36] & 0x80) << 8);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 289 to 305
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0xc0) << 9);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 306 to 322
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xe0) << 10);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 323 to 339
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xf0) << 11);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 340 to 356
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf8) << 12);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 357 to 373
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xfc) << 13);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 374 to 390
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfe) << 14);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 391 to 407
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15);
	output[23] = (double)(value >> 15);
}

static void unpack_24_17bit_unsigned_0off(const uint8_t * input, double * output) {
	// Unpack 24 values into output
	// Values are 17-bit unsigned
	// Skip 0 bits, read 408 bits of data.
	// Input must be at least 51 bytes long

	uint32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 51 to 67
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xf0) << 11);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 68 to 84
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf8) << 12);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 85 to 101
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xfc) << 13);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 102 to 118
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfe) << 14);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 119 to 135
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)input[16] << 15);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 136 to 152
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)input[18] << 16) |
			((uint32_t)(input[19] & 0x80) << 8);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 153 to 169
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xc0) << 9);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 170 to 186
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xe0) << 10);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 187 to 203
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)input[24] << 19) |
			((uint32_t)(input[25] & 0xf0) << 11);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 204 to 220
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20) |
			((uint32_t)(input[27] & 0xf8) << 12);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 221 to 237
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0xfc) << 13);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 238 to 254
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)(input[31] & 0xfe) << 14);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 255 to 271
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)input[33] << 15);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 272 to 288
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16) |
			((uint32_t)(input[36] & 0x80) << 8);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 289 to 305
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0xc0) << 9);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 306 to 322
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xe0) << 10);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 323 to 339
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xf0) << 11);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 340 to 356
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf8) << 12);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 357 to 373
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xfc) << 13);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 374 to 390
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfe) << 14);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 391 to 407
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15);
	output[23] = (double)(value >> 15);
}

static void unpack_24_17bit_signed_1off(const uint8_t * input, double * output) {
	// Unpack 24 values into output
	// Values are 17-bit signed
	// Skip 1 bits, read 408 bits of data.
	// Input must be at least 52 bytes long

	int32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 52 to 68
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf8) << 12);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 69 to 85
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xfc) << 13);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 86 to 102
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfe) << 14);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 103 to 119
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 120 to 136
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)(input[17] & 0x80) << 8);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 137 to 153
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)input[18] << 17) |
			((uint32_t)(input[19] & 0xc0) << 9);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 154 to 170
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xe0) << 10);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 171 to 187
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)(input[23] & 0xf0) << 11);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 188 to 204
	value = ((uint32_t)(input[23] & 0x0f) << 28) |
			((uint32_t)input[24] << 20) |
			((uint32_t)(input[25] & 0xf8) << 12);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 205 to 221
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0xfc) << 13);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 222 to 238
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xfe) << 14);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 239 to 255
	value = ((uint32_t)(input[29] & 0x01) << 31) |
			((uint32_t)input[30] << 23) |
			((uint32_t)input[31] << 15);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 256 to 272
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16) |
			((uint32_t)(input[34] & 0x80) << 8);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 273 to 289
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0xc0) << 9);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 290 to 306
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xe0) << 10);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 307 to 323
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xf0) << 11);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 324 to 340
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf8) << 12);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 341 to 357
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xfc) << 13);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 358 to 374
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfe) << 14);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 375 to 391
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)input[48] << 15);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 392 to 408
	value = ((uint32_t)input[49] << 24) |
			((uint32_t)input[50] << 16) |
			((uint32_t)(input[51] & 0x80) << 8);
	output[23] = (double)(value >> 15);
}

static void unpack_24_17bit_unsigned_1off(const uint8_t * input, double * output) {
	// Unpack 24 values into output
	// Values are 17-bit unsigned
	// Skip 1 bits, read 408 bits of data.
	// Input must be at least 52 bytes long

	uint32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 52 to 68
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf8) << 12);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 69 to 85
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xfc) << 13);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 86 to 102
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfe) << 14);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 103 to 119
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 120 to 136
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)(input[17] & 0x80) << 8);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 137 to 153
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)input[18] << 17) |
			((uint32_t)(input[19] & 0xc0) << 9);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 154 to 170
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xe0) << 10);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 171 to 187
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)(input[23] & 0xf0) << 11);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 188 to 204
	value = ((uint32_t)(input[23] & 0x0f) << 28) |
			((uint32_t)input[24] << 20) |
			((uint32_t)(input[25] & 0xf8) << 12);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 205 to 221
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0xfc) << 13);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 222 to 238
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xfe) << 14);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 239 to 255
	value = ((uint32_t)(input[29] & 0x01) << 31) |
			((uint32_t)input[30] << 23) |
			((uint32_t)input[31] << 15);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 256 to 272
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16) |
			((uint32_t)(input[34] & 0x80) << 8);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 273 to 289
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0xc0) << 9);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 290 to 306
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xe0) << 10);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 307 to 323
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xf0) << 11);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 324 to 340
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf8) << 12);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 341 to 357
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xfc) << 13);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 358 to 374
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfe) << 14);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 375 to 391
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)input[48] << 15);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 392 to 408
	value = ((uint32_t)input[49] << 24) |
			((uint32_t)input[50] << 16) |
			((uint32_t)(input[51] & 0x80) << 8);
	output[23] = (double)(value >> 15);
}

static void unpack_24_17bit_signed_2off(const uint8_t * input, double * output) {
	// Unpack 24 values into output
	// Values are 17-bit signed
	// Skip 2 bits, read 408 bits of data.
	// Input must be at least 52 bytes long

	int32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 53 to 69
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xfc) << 13);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 70 to 86
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfe) << 14);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 87 to 103
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 104 to 120
	value = ((uint32_t)input[13] << 24) |
			((uint32_t)input[14] << 16) |
			((uint32_t)(input[15] & 0x80) << 8);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 121 to 137
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)(input[17] & 0xc0) << 9);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 138 to 154
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)input[18] << 18) |
			((uint32_t)(input[19] & 0xe0) << 10);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 155 to 171
	value = ((uint32_t)(input[19] & 0x1f) << 27) |
			((uint32_t)input[20] << 19) |
			((uint32_t)(input[21] & 0xf0) << 11);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 172 to 188
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)(input[23] & 0xf8) << 12);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 189 to 205
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)(input[25] & 0xfc) << 13);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 206 to 222
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xfe) << 14);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 223 to 239
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 240 to 256
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)(input[32] & 0x80) << 8);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 257 to 273
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0xc0) << 9);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 274 to 290
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xe0) << 10);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 291 to 307
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xf0) << 11);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 308 to 324
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf8) << 12);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 325 to 341
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xfc) << 13);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 342 to 358
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfe) << 14);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 359 to 375
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)input[46] << 15);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 376 to 392
	value = ((uint32_t)input[47] << 24) |
			((uint32_t)input[48] << 16) |
			((uint32_t)(input[49] & 0x80) << 8);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 393 to 409
	value = ((uint32_t)(input[49] & 0x7f) << 25) |
			((uint32_t)input[50] << 17) |
			((uint32_t)(input[51] & 0xc0) << 9);
	output[23] = (double)(value >> 15);
}

static void unpack_24_17bit_unsigned_2off(const uint8_t * input, double * output) {
	// Unpack 24 values into output
	// Values are 17-bit unsigned
	// Skip 2 bits, read 408 bits of data.
	// Input must be at least 52 bytes long

	uint32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 53 to 69
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xfc) << 13);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 70 to 86
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfe) << 14);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 87 to 103
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 104 to 120
	value = ((uint32_t)input[13] << 24) |
			((uint32_t)input[14] << 16) |
			((uint32_t)(input[15] & 0x80) << 8);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 121 to 137
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)(input[17] & 0xc0) << 9);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 138 to 154
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)input[18] << 18) |
			((uint32_t)(input[19] & 0xe0) << 10);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 155 to 171
	value = ((uint32_t)(input[19] & 0x1f) << 27) |
			((uint32_t)input[20] << 19) |
			((uint32_t)(input[21] & 0xf0) << 11);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 172 to 188
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)(input[23] & 0xf8) << 12);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 189 to 205
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)(input[25] & 0xfc) << 13);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 206 to 222
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xfe) << 14);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 223 to 239
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 240 to 256
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)(input[32] & 0x80) << 8);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 257 to 273
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0xc0) << 9);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 274 to 290
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xe0) << 10);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 291 to 307
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xf0) << 11);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 308 to 324
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf8) << 12);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 325 to 341
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xfc) << 13);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 342 to 358
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfe) << 14);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 359 to 375
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)input[46] << 15);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 376 to 392
	value = ((uint32_t)input[47] << 24) |
			((uint32_t)input[48] << 16) |
			((uint32_t)(input[49] & 0x80) << 8);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 393 to 409
	value = ((uint32_t)(input[49] & 0x7f) << 25) |
			((uint32_t)input[50] << 17) |
			((uint32_t)(input[51] & 0xc0) << 9);
	output[23] = (double)(value >> 15);
}

static void unpack_24_17bit_signed_3off(const uint8_t * input, double * output) {
	// Unpack 24 values into output
	// Values are 17-bit signed
	// Skip 3 bits, read 408 bits of data.
	// Input must be at least 52 bytes long

	int32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 54 to 70
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfe) << 14);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 71 to 87
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)input[10] << 15);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 88 to 104
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0x80) << 8);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 105 to 121
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xc0) << 9);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 122 to 138
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)(input[17] & 0xe0) << 10);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 139 to 155
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)input[18] << 19) |
			((uint32_t)(input[19] & 0xf0) << 11);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 156 to 172
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20) |
			((uint32_t)(input[21] & 0xf8) << 12);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 173 to 189
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0xfc) << 13);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 190 to 206
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)(input[25] & 0xfe) << 14);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 207 to 223
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)input[27] << 15);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 224 to 240
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16) |
			((uint32_t)(input[30] & 0x80) << 8);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 241 to 257
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0xc0) << 9);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 258 to 274
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xe0) << 10);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 275 to 291
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xf0) << 11);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 292 to 308
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf8) << 12);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 309 to 325
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xfc) << 13);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 326 to 342
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfe) << 14);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 343 to 359
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 360 to 376
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)(input[47] & 0x80) << 8);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 377 to 393
	value = ((uint32_t)(input[47] & 0x7f) << 25) |
			((uint32_t)input[48] << 17) |
			((uint32_t)(input[49] & 0xc0) << 9);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 394 to 410
	value = ((uint32_t)(input[49] & 0x3f) << 26) |
			((uint32_t)input[50] << 18) |
			((uint32_t)(input[51] & 0xe0) << 10);
	output[23] = (double)(value >> 15);
}

static void unpack_24_17bit_unsigned_3off(const uint8_t * input, double * output) {
	// Unpack 24 values into output
	// Values are 17-bit unsigned
	// Skip 3 bits, read 408 bits of data.
	// Input must be at least 52 bytes long

	uint32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 54 to 70
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfe) << 14);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 71 to 87
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)input[10] << 15);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 88 to 104
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0x80) << 8);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 105 to 121
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xc0) << 9);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 122 to 138
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)(input[17] & 0xe0) << 10);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 139 to 155
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)input[18] << 19) |
			((uint32_t)(input[19] & 0xf0) << 11);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 156 to 172
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20) |
			((uint32_t)(input[21] & 0xf8) << 12);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 173 to 189
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0xfc) << 13);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 190 to 206
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)(input[25] & 0xfe) << 14);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 207 to 223
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)input[27] << 15);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 224 to 240
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16) |
			((uint32_t)(input[30] & 0x80) << 8);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 241 to 257
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0xc0) << 9);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 258 to 274
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xe0) << 10);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 275 to 291
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xf0) << 11);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 292 to 308
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf8) << 12);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 309 to 325
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xfc) << 13);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 326 to 342
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfe) << 14);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 343 to 359
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 360 to 376
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)(input[47] & 0x80) << 8);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 377 to 393
	value = ((uint32_t)(input[47] & 0x7f) << 25) |
			((uint32_t)input[48] << 17) |
			((uint32_t)(input[49] & 0xc0) << 9);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 394 to 410
	value = ((uint32_t)(input[49] & 0x3f) << 26) |
			((uint32_t)input[50] << 18) |
			((uint32_t)(input[51] & 0xe0) << 10);
	output[23] = (double)(value >> 15);
}

static void unpack_24_17bit_signed_4off(const uint8_t * input, double * output) {
	// Unpack 24 values into output
	// Values are 17-bit signed
	// Skip 4 bits, read 408 bits of data.
	// Input must be at least 52 bytes long

	int32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 55 to 71
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 72 to 88
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)(input[11] & 0x80) << 8);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 89 to 105
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xc0) << 9);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 106 to 122
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xe0) << 10);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 123 to 139
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)(input[17] & 0xf0) << 11);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 140 to 156
	value = ((uint32_t)(input[17] & 0x0f) << 28) |
			((uint32_t)input[18] << 20) |
			((uint32_t)(input[19] & 0xf8) << 12);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 157 to 173
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0xfc) << 13);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 174 to 190
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xfe) << 14);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 191 to 207
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 208 to 224
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16) |
			((uint32_t)(input[28] & 0x80) << 8);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 225 to 241
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0xc0) << 9);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 242 to 258
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xe0) << 10);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 259 to 275
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xf0) << 11);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 276 to 292
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf8) << 12);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 293 to 309
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xfc) << 13);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 310 to 326
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfe) << 14);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 327 to 343
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)input[42] << 15);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 344 to 360
	value = ((uint32_t)input[43] << 24) |
			((uint32_t)input[44] << 16) |
			((uint32_t)(input[45] & 0x80) << 8);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 361 to 377
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)(input[47] & 0xc0) << 9);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 378 to 394
	value = ((uint32_t)(input[47] & 0x3f) << 26) |
			((uint32_t)input[48] << 18) |
			((uint32_t)(input[49] & 0xe0) << 10);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 395 to 411
	value = ((uint32_t)(input[49] & 0x1f) << 27) |
			((uint32_t)input[50] << 19) |
			((uint32_t)(input[51] & 0xf0) << 11);
	output[23] = (double)(value >> 15);
}

static void unpack_24_17bit_unsigned_4off(const uint8_t * input, double * output) {
	// Unpack 24 values into output
	// Values are 17-bit unsigned
	// Skip 4 bits, read 408 bits of data.
	// Input must be at least 52 bytes long

	uint32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 55 to 71
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 72 to 88
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)(input[11] & 0x80) << 8);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 89 to 105
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xc0) << 9);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 106 to 122
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xe0) << 10);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 123 to 139
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)(input[17] & 0xf0) << 11);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 140 to 156
	value = ((uint32_t)(input[17] & 0x0f) << 28) |
			((uint32_t)input[18] << 20) |
			((uint32_t)(input[19] & 0xf8) << 12);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 157 to 173
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0xfc) << 13);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 174 to 190
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xfe) << 14);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 191 to 207
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 208 to 224
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16) |
			((uint32_t)(input[28] & 0x80) << 8);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 225 to 241
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0xc0) << 9);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 242 to 258
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xe0) << 10);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 259 to 275
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xf0) << 11);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 276 to 292
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf8) << 12);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 293 to 309
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xfc) << 13);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 310 to 326
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfe) << 14);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 327 to 343
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)input[42] << 15);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 344 to 360
	value = ((uint32_t)input[43] << 24) |
			((uint32_t)input[44] << 16) |
			((uint32_t)(input[45] & 0x80) << 8);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 361 to 377
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)(input[47] & 0xc0) << 9);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 378 to 394
	value = ((uint32_t)(input[47] & 0x3f) << 26) |
			((uint32_t)input[48] << 18) |
			((uint32_t)(input[49] & 0xe0) << 10);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 395 to 411
	value = ((uint32_t)(input[49] & 0x1f) << 27) |
			((uint32_t)input[50] << 19) |
			((uint32_t)(input[51] & 0xf0) << 11);
	output[23] = (double)(value >> 15);
}

static void unpack_24_17bit_signed_5off(const uint8_t * input, double * output) {
	// Unpack 24 values into output
	// Values are 17-bit signed
	// Skip 5 bits, read 408 bits of data.
	// Input must be at least 52 bytes long

	int32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 56 to 72
	value = ((uint32_t)input[7] << 24) |
			((uint32_t)input[8] << 16) |
			((uint32_t)(input[9] & 0x80) << 8);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 73 to 89
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)(input[11] & 0xc0) << 9);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 90 to 106
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xe0) << 10);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 107 to 123
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)(input[15] & 0xf0) << 11);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 124 to 140
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)(input[17] & 0xf8) << 12);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 141 to 157
	value = ((uint32_t)(input[17] & 0x07) << 29) |
			((uint32_t)input[18] << 21) |
			((uint32_t)(input[19] & 0xfc) << 13);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 158 to 174
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xfe) << 14);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 175 to 191
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 192 to 208
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0x80) << 8);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 209 to 225
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0xc0) << 9);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 226 to 242
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xe0) << 10);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 243 to 259
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xf0) << 11);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 260 to 276
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf8) << 12);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 277 to 293
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xfc) << 13);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 294 to 310
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfe) << 14);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 311 to 327
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)input[40] << 15);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 328 to 344
	value = ((uint32_t)input[41] << 24) |
			((uint32_t)input[42] << 16) |
			((uint32_t)(input[43] & 0x80) << 8);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 345 to 361
	value = ((uint32_t)(input[43] & 0x7f) << 25) |
			((uint32_t)input[44] << 17) |
			((uint32_t)(input[45] & 0xc0) << 9);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 362 to 378
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)(input[47] & 0xe0) << 10);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 379 to 395
	value = ((uint32_t)(input[47] & 0x1f) << 27) |
			((uint32_t)input[48] << 19) |
			((uint32_t)(input[49] & 0xf0) << 11);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 396 to 412
	value = ((uint32_t)(input[49] & 0x0f) << 28) |
			((uint32_t)input[50] << 20) |
			((uint32_t)(input[51] & 0xf8) << 12);
	output[23] = (double)(value >> 15);
}

static void unpack_24_17bit_unsigned_5off(const uint8_t * input, double * output) {
	// Unpack 24 values into output
	// Values are 17-bit unsigned
	// Skip 5 bits, read 408 bits of data.
	// Input must be at least 52 bytes long

	uint32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 56 to 72
	value = ((uint32_t)input[7] << 24) |
			((uint32_t)input[8] << 16) |
			((uint32_t)(input[9] & 0x80) << 8);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 73 to 89
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)(input[11] & 0xc0) << 9);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 90 to 106
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xe0) << 10);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 107 to 123
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)(input[15] & 0xf0) << 11);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 124 to 140
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)(input[17] & 0xf8) << 12);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 141 to 157
	value = ((uint32_t)(input[17] & 0x07) << 29) |
			((uint32_t)input[18] << 21) |
			((uint32_t)(input[19] & 0xfc) << 13);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 158 to 174
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xfe) << 14);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 175 to 191
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 192 to 208
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0x80) << 8);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 209 to 225
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0xc0) << 9);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 226 to 242
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xe0) << 10);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 243 to 259
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xf0) << 11);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 260 to 276
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf8) << 12);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 277 to 293
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xfc) << 13);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 294 to 310
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfe) << 14);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 311 to 327
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)input[40] << 15);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 328 to 344
	value = ((uint32_t)input[41] << 24) |
			((uint32_t)input[42] << 16) |
			((uint32_t)(input[43] & 0x80) << 8);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 345 to 361
	value = ((uint32_t)(input[43] & 0x7f) << 25) |
			((uint32_t)input[44] << 17) |
			((uint32_t)(input[45] & 0xc0) << 9);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 362 to 378
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)(input[47] & 0xe0) << 10);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 379 to 395
	value = ((uint32_t)(input[47] & 0x1f) << 27) |
			((uint32_t)input[48] << 19) |
			((uint32_t)(input[49] & 0xf0) << 11);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 396 to 412
	value = ((uint32_t)(input[49] & 0x0f) << 28) |
			((uint32_t)input[50] << 20) |
			((uint32_t)(input[51] & 0xf8) << 12);
	output[23] = (double)(value >> 15);
}

static void unpack_24_17bit_signed_6off(const uint8_t * input, double * output) {
	// Unpack 24 values into output
	// Values are 17-bit signed
	// Skip 6 bits, read 408 bits of data.
	// Input must be at least 52 bytes long

	int32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 57 to 73
	value = ((uint32_t)(input[7] & 0x7f) << 25) |
			((uint32_t)input[8] << 17) |
			((uint32_t)(input[9] & 0xc0) << 9);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 74 to 90
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)(input[11] & 0xe0) << 10);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 91 to 107
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)(input[13] & 0xf0) << 11);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 108 to 124
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)(input[15] & 0xf8) << 12);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 125 to 141
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0xfc) << 13);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 142 to 158
	value = ((uint32_t)(input[17] & 0x03) << 30) |
			((uint32_t)input[18] << 22) |
			((uint32_t)(input[19] & 0xfe) << 14);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 159 to 175
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)input[21] << 15);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 176 to 192
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16) |
			((uint32_t)(input[24] & 0x80) << 8);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 193 to 209
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xc0) << 9);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 210 to 226
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xe0) << 10);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 227 to 243
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xf0) << 11);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 244 to 260
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf8) << 12);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 261 to 277
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xfc) << 13);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 278 to 294
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfe) << 14);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 295 to 311
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 312 to 328
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)(input[41] & 0x80) << 8);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 329 to 345
	value = ((uint32_t)(input[41] & 0x7f) << 25) |
			((uint32_t)input[42] << 17) |
			((uint32_t)(input[43] & 0xc0) << 9);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 346 to 362
	value = ((uint32_t)(input[43] & 0x3f) << 26) |
			((uint32_t)input[44] << 18) |
			((uint32_t)(input[45] & 0xe0) << 10);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 363 to 379
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)(input[47] & 0xf0) << 11);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 380 to 396
	value = ((uint32_t)(input[47] & 0x0f) << 28) |
			((uint32_t)input[48] << 20) |
			((uint32_t)(input[49] & 0xf8) << 12);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 397 to 413
	value = ((uint32_t)(input[49] & 0x07) << 29) |
			((uint32_t)input[50] << 21) |
			((uint32_t)(input[51] & 0xfc) << 13);
	output[23] = (double)(value >> 15);
}

static void unpack_24_17bit_unsigned_6off(const uint8_t * input, double * output) {
	// Unpack 24 values into output
	// Values are 17-bit unsigned
	// Skip 6 bits, read 408 bits of data.
	// Input must be at least 52 bytes long

	uint32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 57 to 73
	value = ((uint32_t)(input[7] & 0x7f) << 25) |
			((uint32_t)input[8] << 17) |
			((uint32_t)(input[9] & 0xc0) << 9);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 74 to 90
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)(input[11] & 0xe0) << 10);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 91 to 107
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)(input[13] & 0xf0) << 11);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 108 to 124
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)(input[15] & 0xf8) << 12);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 125 to 141
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0xfc) << 13);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 142 to 158
	value = ((uint32_t)(input[17] & 0x03) << 30) |
			((uint32_t)input[18] << 22) |
			((uint32_t)(input[19] & 0xfe) << 14);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 159 to 175
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)input[21] << 15);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 176 to 192
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16) |
			((uint32_t)(input[24] & 0x80) << 8);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 193 to 209
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xc0) << 9);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 210 to 226
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xe0) << 10);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 227 to 243
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xf0) << 11);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 244 to 260
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf8) << 12);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 261 to 277
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xfc) << 13);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 278 to 294
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfe) << 14);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 295 to 311
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 312 to 328
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)(input[41] & 0x80) << 8);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 329 to 345
	value = ((uint32_t)(input[41] & 0x7f) << 25) |
			((uint32_t)input[42] << 17) |
			((uint32_t)(input[43] & 0xc0) << 9);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 346 to 362
	value = ((uint32_t)(input[43] & 0x3f) << 26) |
			((uint32_t)input[44] << 18) |
			((uint32_t)(input[45] & 0xe0) << 10);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 363 to 379
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)(input[47] & 0xf0) << 11);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 380 to 396
	value = ((uint32_t)(input[47] & 0x0f) << 28) |
			((uint32_t)input[48] << 20) |
			((uint32_t)(input[49] & 0xf8) << 12);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 397 to 413
	value = ((uint32_t)(input[49] & 0x07) << 29) |
			((uint32_t)input[50] << 21) |
			((uint32_t)(input[51] & 0xfc) << 13);
	output[23] = (double)(value >> 15);
}

static void unpack_24_17bit_signed_7off(const uint8_t * input, double * output) {
	// Unpack 24 values into output
	// Values are 17-bit signed
	// Skip 7 bits, read 408 bits of data.
	// Input must be at least 52 bytes long

	int32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 58 to 74
	value = ((uint32_t)(input[7] & 0x3f) << 26) |
			((uint32_t)input[8] << 18) |
			((uint32_t)(input[9] & 0xe0) << 10);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 75 to 91
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)(input[11] & 0xf0) << 11);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 92 to 108
	value = ((uint32_t)(input[11] & 0x0f) << 28) |
			((uint32_t)input[12] << 20) |
			((uint32_t)(input[13] & 0xf8) << 12);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 109 to 125
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0xfc) << 13);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 126 to 142
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xfe) << 14);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 143 to 159
	value = ((uint32_t)(input[17] & 0x01) << 31) |
			((uint32_t)input[18] << 23) |
			((uint32_t)input[19] << 15);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 160 to 176
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16) |
			((uint32_t)(input[22] & 0x80) << 8);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 177 to 193
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0xc0) << 9);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 194 to 210
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xe0) << 10);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 211 to 227
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xf0) << 11);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 228 to 244
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf8) << 12);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 245 to 261
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xfc) << 13);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 262 to 278
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfe) << 14);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 279 to 295
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)input[36] << 15);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 296 to 312
	value = ((uint32_t)input[37] << 24) |
			((uint32_t)input[38] << 16) |
			((uint32_t)(input[39] & 0x80) << 8);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 313 to 329
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)(input[41] & 0xc0) << 9);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 330 to 346
	value = ((uint32_t)(input[41] & 0x3f) << 26) |
			((uint32_t)input[42] << 18) |
			((uint32_t)(input[43] & 0xe0) << 10);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 347 to 363
	value = ((uint32_t)(input[43] & 0x1f) << 27) |
			((uint32_t)input[44] << 19) |
			((uint32_t)(input[45] & 0xf0) << 11);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 364 to 380
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)(input[47] & 0xf8) << 12);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 381 to 397
	value = ((uint32_t)(input[47] & 0x07) << 29) |
			((uint32_t)input[48] << 21) |
			((uint32_t)(input[49] & 0xfc) << 13);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 398 to 414
	value = ((uint32_t)(input[49] & 0x03) << 30) |
			((uint32_t)input[50] << 22) |
			((uint32_t)(input[51] & 0xfe) << 14);
	output[23] = (double)(value >> 15);
}

static void unpack_24_17bit_unsigned_7off(const uint8_t * input, double * output) {
	// Unpack 24 values into output
	// Values are 17-bit unsigned
	// Skip 7 bits, read 408 bits of data.
	// Input must be at least 52 bytes long

	uint32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 58 to 74
	value = ((uint32_t)(input[7] & 0x3f) << 26) |
			((uint32_t)input[8] << 18) |
			((uint32_t)(input[9] & 0xe0) << 10);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 75 to 91
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)(input[11] & 0xf0) << 11);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 92 to 108
	value = ((uint32_t)(input[11] & 0x0f) << 28) |
			((uint32_t)input[12] << 20) |
			((uint32_t)(input[13] & 0xf8) << 12);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 109 to 125
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0xfc) << 13);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 126 to 142
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xfe) << 14);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 143 to 159
	value = ((uint32_t)(input[17] & 0x01) << 31) |
			((uint32_t)input[18] << 23) |
			((uint32_t)input[19] << 15);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 160 to 176
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16) |
			((uint32_t)(input[22] & 0x80) << 8);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 177 to 193
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0xc0) << 9);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 194 to 210
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xe0) << 10);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 211 to 227
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xf0) << 11);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 228 to 244
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf8) << 12);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 245 to 261
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xfc) << 13);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 262 to 278
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfe) << 14);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 279 to 295
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)input[36] << 15);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 296 to 312
	value = ((uint32_t)input[37] << 24) |
			((uint32_t)input[38] << 16) |
			((uint32_t)(input[39] & 0x80) << 8);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 313 to 329
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)(input[41] & 0xc0) << 9);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 330 to 346
	value = ((uint32_t)(input[41] & 0x3f) << 26) |
			((uint32_t)input[42] << 18) |
			((uint32_t)(input[43] & 0xe0) << 10);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 347 to 363
	value = ((uint32_t)(input[43] & 0x1f) << 27) |
			((uint32_t)input[44] << 19) |
			((uint32_t)(input[45] & 0xf0) << 11);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 364 to 380
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)(input[47] & 0xf8) << 12);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 381 to 397
	value = ((uint32_t)(input[47] & 0x07) << 29) |
			((uint32_t)input[48] << 21) |
			((uint32_t)(input[49] & 0xfc) << 13);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 398 to 414
	value = ((uint32_t)(input[49] & 0x03) << 30) |
			((uint32_t)input[50] << 22) |
			((uint32_t)(input[51] & 0xfe) << 14);
	output[23] = (double)(value >> 15);
}

static void unpack_25_17bit_signed_0off(const uint8_t * input, double * output) {
	// Unpack 25 values into output
	// Values are 17-bit signed
	// Skip 0 bits, read 425 bits of data.
	// Input must be at least 54 bytes long

	int32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 51 to 67
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xf0) << 11);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 68 to 84
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf8) << 12);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 85 to 101
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xfc) << 13);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 102 to 118
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfe) << 14);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 119 to 135
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)input[16] << 15);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 136 to 152
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)input[18] << 16) |
			((uint32_t)(input[19] & 0x80) << 8);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 153 to 169
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xc0) << 9);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 170 to 186
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xe0) << 10);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 187 to 203
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)input[24] << 19) |
			((uint32_t)(input[25] & 0xf0) << 11);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 204 to 220
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20) |
			((uint32_t)(input[27] & 0xf8) << 12);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 221 to 237
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0xfc) << 13);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 238 to 254
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)(input[31] & 0xfe) << 14);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 255 to 271
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)input[33] << 15);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 272 to 288
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16) |
			((uint32_t)(input[36] & 0x80) << 8);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 289 to 305
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0xc0) << 9);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 306 to 322
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xe0) << 10);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 323 to 339
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xf0) << 11);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 340 to 356
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf8) << 12);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 357 to 373
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xfc) << 13);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 374 to 390
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfe) << 14);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 391 to 407
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 408 to 424
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)(input[53] & 0x80) << 8);
	output[24] = (double)(value >> 15);
}

static void unpack_25_17bit_unsigned_0off(const uint8_t * input, double * output) {
	// Unpack 25 values into output
	// Values are 17-bit unsigned
	// Skip 0 bits, read 425 bits of data.
	// Input must be at least 54 bytes long

	uint32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 51 to 67
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xf0) << 11);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 68 to 84
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf8) << 12);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 85 to 101
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xfc) << 13);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 102 to 118
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfe) << 14);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 119 to 135
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)input[16] << 15);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 136 to 152
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)input[18] << 16) |
			((uint32_t)(input[19] & 0x80) << 8);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 153 to 169
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xc0) << 9);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 170 to 186
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xe0) << 10);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 187 to 203
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)input[24] << 19) |
			((uint32_t)(input[25] & 0xf0) << 11);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 204 to 220
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20) |
			((uint32_t)(input[27] & 0xf8) << 12);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 221 to 237
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0xfc) << 13);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 238 to 254
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)(input[31] & 0xfe) << 14);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 255 to 271
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)input[33] << 15);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 272 to 288
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16) |
			((uint32_t)(input[36] & 0x80) << 8);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 289 to 305
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0xc0) << 9);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 306 to 322
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xe0) << 10);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 323 to 339
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xf0) << 11);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 340 to 356
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf8) << 12);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 357 to 373
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xfc) << 13);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 374 to 390
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfe) << 14);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 391 to 407
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 408 to 424
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)(input[53] & 0x80) << 8);
	output[24] = (double)(value >> 15);
}

static void unpack_25_17bit_signed_1off(const uint8_t * input, double * output) {
	// Unpack 25 values into output
	// Values are 17-bit signed
	// Skip 1 bits, read 425 bits of data.
	// Input must be at least 54 bytes long

	int32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 52 to 68
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf8) << 12);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 69 to 85
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xfc) << 13);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 86 to 102
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfe) << 14);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 103 to 119
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 120 to 136
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)(input[17] & 0x80) << 8);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 137 to 153
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)input[18] << 17) |
			((uint32_t)(input[19] & 0xc0) << 9);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 154 to 170
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xe0) << 10);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 171 to 187
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)(input[23] & 0xf0) << 11);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 188 to 204
	value = ((uint32_t)(input[23] & 0x0f) << 28) |
			((uint32_t)input[24] << 20) |
			((uint32_t)(input[25] & 0xf8) << 12);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 205 to 221
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0xfc) << 13);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 222 to 238
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xfe) << 14);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 239 to 255
	value = ((uint32_t)(input[29] & 0x01) << 31) |
			((uint32_t)input[30] << 23) |
			((uint32_t)input[31] << 15);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 256 to 272
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16) |
			((uint32_t)(input[34] & 0x80) << 8);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 273 to 289
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0xc0) << 9);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 290 to 306
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xe0) << 10);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 307 to 323
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xf0) << 11);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 324 to 340
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf8) << 12);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 341 to 357
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xfc) << 13);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 358 to 374
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfe) << 14);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 375 to 391
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)input[48] << 15);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 392 to 408
	value = ((uint32_t)input[49] << 24) |
			((uint32_t)input[50] << 16) |
			((uint32_t)(input[51] & 0x80) << 8);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 409 to 425
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)(input[53] & 0xc0) << 9);
	output[24] = (double)(value >> 15);
}

static void unpack_25_17bit_unsigned_1off(const uint8_t * input, double * output) {
	// Unpack 25 values into output
	// Values are 17-bit unsigned
	// Skip 1 bits, read 425 bits of data.
	// Input must be at least 54 bytes long

	uint32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 52 to 68
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf8) << 12);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 69 to 85
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xfc) << 13);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 86 to 102
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfe) << 14);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 103 to 119
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 120 to 136
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)(input[17] & 0x80) << 8);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 137 to 153
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)input[18] << 17) |
			((uint32_t)(input[19] & 0xc0) << 9);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 154 to 170
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xe0) << 10);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 171 to 187
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)(input[23] & 0xf0) << 11);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 188 to 204
	value = ((uint32_t)(input[23] & 0x0f) << 28) |
			((uint32_t)input[24] << 20) |
			((uint32_t)(input[25] & 0xf8) << 12);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 205 to 221
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0xfc) << 13);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 222 to 238
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xfe) << 14);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 239 to 255
	value = ((uint32_t)(input[29] & 0x01) << 31) |
			((uint32_t)input[30] << 23) |
			((uint32_t)input[31] << 15);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 256 to 272
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16) |
			((uint32_t)(input[34] & 0x80) << 8);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 273 to 289
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0xc0) << 9);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 290 to 306
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xe0) << 10);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 307 to 323
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xf0) << 11);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 324 to 340
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf8) << 12);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 341 to 357
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xfc) << 13);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 358 to 374
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfe) << 14);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 375 to 391
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)input[48] << 15);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 392 to 408
	value = ((uint32_t)input[49] << 24) |
			((uint32_t)input[50] << 16) |
			((uint32_t)(input[51] & 0x80) << 8);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 409 to 425
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)(input[53] & 0xc0) << 9);
	output[24] = (double)(value >> 15);
}

static void unpack_25_17bit_signed_2off(const uint8_t * input, double * output) {
	// Unpack 25 values into output
	// Values are 17-bit signed
	// Skip 2 bits, read 425 bits of data.
	// Input must be at least 54 bytes long

	int32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 53 to 69
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xfc) << 13);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 70 to 86
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfe) << 14);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 87 to 103
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 104 to 120
	value = ((uint32_t)input[13] << 24) |
			((uint32_t)input[14] << 16) |
			((uint32_t)(input[15] & 0x80) << 8);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 121 to 137
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)(input[17] & 0xc0) << 9);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 138 to 154
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)input[18] << 18) |
			((uint32_t)(input[19] & 0xe0) << 10);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 155 to 171
	value = ((uint32_t)(input[19] & 0x1f) << 27) |
			((uint32_t)input[20] << 19) |
			((uint32_t)(input[21] & 0xf0) << 11);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 172 to 188
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)(input[23] & 0xf8) << 12);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 189 to 205
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)(input[25] & 0xfc) << 13);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 206 to 222
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xfe) << 14);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 223 to 239
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 240 to 256
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)(input[32] & 0x80) << 8);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 257 to 273
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0xc0) << 9);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 274 to 290
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xe0) << 10);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 291 to 307
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xf0) << 11);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 308 to 324
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf8) << 12);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 325 to 341
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xfc) << 13);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 342 to 358
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfe) << 14);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 359 to 375
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)input[46] << 15);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 376 to 392
	value = ((uint32_t)input[47] << 24) |
			((uint32_t)input[48] << 16) |
			((uint32_t)(input[49] & 0x80) << 8);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 393 to 409
	value = ((uint32_t)(input[49] & 0x7f) << 25) |
			((uint32_t)input[50] << 17) |
			((uint32_t)(input[51] & 0xc0) << 9);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 410 to 426
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)(input[53] & 0xe0) << 10);
	output[24] = (double)(value >> 15);
}

static void unpack_25_17bit_unsigned_2off(const uint8_t * input, double * output) {
	// Unpack 25 values into output
	// Values are 17-bit unsigned
	// Skip 2 bits, read 425 bits of data.
	// Input must be at least 54 bytes long

	uint32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 53 to 69
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xfc) << 13);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 70 to 86
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfe) << 14);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 87 to 103
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 104 to 120
	value = ((uint32_t)input[13] << 24) |
			((uint32_t)input[14] << 16) |
			((uint32_t)(input[15] & 0x80) << 8);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 121 to 137
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)(input[17] & 0xc0) << 9);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 138 to 154
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)input[18] << 18) |
			((uint32_t)(input[19] & 0xe0) << 10);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 155 to 171
	value = ((uint32_t)(input[19] & 0x1f) << 27) |
			((uint32_t)input[20] << 19) |
			((uint32_t)(input[21] & 0xf0) << 11);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 172 to 188
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)(input[23] & 0xf8) << 12);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 189 to 205
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)(input[25] & 0xfc) << 13);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 206 to 222
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xfe) << 14);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 223 to 239
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 240 to 256
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)(input[32] & 0x80) << 8);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 257 to 273
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0xc0) << 9);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 274 to 290
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xe0) << 10);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 291 to 307
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xf0) << 11);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 308 to 324
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf8) << 12);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 325 to 341
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xfc) << 13);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 342 to 358
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfe) << 14);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 359 to 375
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)input[46] << 15);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 376 to 392
	value = ((uint32_t)input[47] << 24) |
			((uint32_t)input[48] << 16) |
			((uint32_t)(input[49] & 0x80) << 8);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 393 to 409
	value = ((uint32_t)(input[49] & 0x7f) << 25) |
			((uint32_t)input[50] << 17) |
			((uint32_t)(input[51] & 0xc0) << 9);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 410 to 426
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)(input[53] & 0xe0) << 10);
	output[24] = (double)(value >> 15);
}

static void unpack_25_17bit_signed_3off(const uint8_t * input, double * output) {
	// Unpack 25 values into output
	// Values are 17-bit signed
	// Skip 3 bits, read 425 bits of data.
	// Input must be at least 54 bytes long

	int32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 54 to 70
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfe) << 14);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 71 to 87
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)input[10] << 15);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 88 to 104
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0x80) << 8);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 105 to 121
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xc0) << 9);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 122 to 138
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)(input[17] & 0xe0) << 10);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 139 to 155
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)input[18] << 19) |
			((uint32_t)(input[19] & 0xf0) << 11);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 156 to 172
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20) |
			((uint32_t)(input[21] & 0xf8) << 12);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 173 to 189
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0xfc) << 13);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 190 to 206
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)(input[25] & 0xfe) << 14);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 207 to 223
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)input[27] << 15);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 224 to 240
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16) |
			((uint32_t)(input[30] & 0x80) << 8);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 241 to 257
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0xc0) << 9);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 258 to 274
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xe0) << 10);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 275 to 291
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xf0) << 11);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 292 to 308
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf8) << 12);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 309 to 325
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xfc) << 13);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 326 to 342
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfe) << 14);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 343 to 359
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 360 to 376
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)(input[47] & 0x80) << 8);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 377 to 393
	value = ((uint32_t)(input[47] & 0x7f) << 25) |
			((uint32_t)input[48] << 17) |
			((uint32_t)(input[49] & 0xc0) << 9);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 394 to 410
	value = ((uint32_t)(input[49] & 0x3f) << 26) |
			((uint32_t)input[50] << 18) |
			((uint32_t)(input[51] & 0xe0) << 10);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 411 to 427
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)(input[53] & 0xf0) << 11);
	output[24] = (double)(value >> 15);
}

static void unpack_25_17bit_unsigned_3off(const uint8_t * input, double * output) {
	// Unpack 25 values into output
	// Values are 17-bit unsigned
	// Skip 3 bits, read 425 bits of data.
	// Input must be at least 54 bytes long

	uint32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 54 to 70
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfe) << 14);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 71 to 87
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)input[10] << 15);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 88 to 104
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0x80) << 8);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 105 to 121
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xc0) << 9);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 122 to 138
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)(input[17] & 0xe0) << 10);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 139 to 155
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)input[18] << 19) |
			((uint32_t)(input[19] & 0xf0) << 11);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 156 to 172
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20) |
			((uint32_t)(input[21] & 0xf8) << 12);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 173 to 189
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0xfc) << 13);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 190 to 206
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)(input[25] & 0xfe) << 14);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 207 to 223
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)input[27] << 15);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 224 to 240
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16) |
			((uint32_t)(input[30] & 0x80) << 8);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 241 to 257
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0xc0) << 9);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 258 to 274
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xe0) << 10);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 275 to 291
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xf0) << 11);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 292 to 308
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf8) << 12);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 309 to 325
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xfc) << 13);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 326 to 342
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfe) << 14);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 343 to 359
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 360 to 376
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)(input[47] & 0x80) << 8);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 377 to 393
	value = ((uint32_t)(input[47] & 0x7f) << 25) |
			((uint32_t)input[48] << 17) |
			((uint32_t)(input[49] & 0xc0) << 9);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 394 to 410
	value = ((uint32_t)(input[49] & 0x3f) << 26) |
			((uint32_t)input[50] << 18) |
			((uint32_t)(input[51] & 0xe0) << 10);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 411 to 427
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)(input[53] & 0xf0) << 11);
	output[24] = (double)(value >> 15);
}

static void unpack_25_17bit_signed_4off(const uint8_t * input, double * output) {
	// Unpack 25 values into output
	// Values are 17-bit signed
	// Skip 4 bits, read 425 bits of data.
	// Input must be at least 54 bytes long

	int32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 55 to 71
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 72 to 88
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)(input[11] & 0x80) << 8);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 89 to 105
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xc0) << 9);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 106 to 122
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xe0) << 10);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 123 to 139
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)(input[17] & 0xf0) << 11);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 140 to 156
	value = ((uint32_t)(input[17] & 0x0f) << 28) |
			((uint32_t)input[18] << 20) |
			((uint32_t)(input[19] & 0xf8) << 12);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 157 to 173
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0xfc) << 13);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 174 to 190
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xfe) << 14);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 191 to 207
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 208 to 224
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16) |
			((uint32_t)(input[28] & 0x80) << 8);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 225 to 241
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0xc0) << 9);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 242 to 258
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xe0) << 10);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 259 to 275
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xf0) << 11);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 276 to 292
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf8) << 12);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 293 to 309
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xfc) << 13);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 310 to 326
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfe) << 14);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 327 to 343
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)input[42] << 15);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 344 to 360
	value = ((uint32_t)input[43] << 24) |
			((uint32_t)input[44] << 16) |
			((uint32_t)(input[45] & 0x80) << 8);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 361 to 377
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)(input[47] & 0xc0) << 9);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 378 to 394
	value = ((uint32_t)(input[47] & 0x3f) << 26) |
			((uint32_t)input[48] << 18) |
			((uint32_t)(input[49] & 0xe0) << 10);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 395 to 411
	value = ((uint32_t)(input[49] & 0x1f) << 27) |
			((uint32_t)input[50] << 19) |
			((uint32_t)(input[51] & 0xf0) << 11);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 412 to 428
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)(input[53] & 0xf8) << 12);
	output[24] = (double)(value >> 15);
}

static void unpack_25_17bit_unsigned_4off(const uint8_t * input, double * output) {
	// Unpack 25 values into output
	// Values are 17-bit unsigned
	// Skip 4 bits, read 425 bits of data.
	// Input must be at least 54 bytes long

	uint32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 55 to 71
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 72 to 88
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)(input[11] & 0x80) << 8);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 89 to 105
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xc0) << 9);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 106 to 122
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xe0) << 10);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 123 to 139
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)(input[17] & 0xf0) << 11);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 140 to 156
	value = ((uint32_t)(input[17] & 0x0f) << 28) |
			((uint32_t)input[18] << 20) |
			((uint32_t)(input[19] & 0xf8) << 12);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 157 to 173
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0xfc) << 13);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 174 to 190
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xfe) << 14);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 191 to 207
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 208 to 224
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16) |
			((uint32_t)(input[28] & 0x80) << 8);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 225 to 241
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0xc0) << 9);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 242 to 258
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xe0) << 10);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 259 to 275
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xf0) << 11);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 276 to 292
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf8) << 12);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 293 to 309
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xfc) << 13);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 310 to 326
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfe) << 14);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 327 to 343
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)input[42] << 15);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 344 to 360
	value = ((uint32_t)input[43] << 24) |
			((uint32_t)input[44] << 16) |
			((uint32_t)(input[45] & 0x80) << 8);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 361 to 377
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)(input[47] & 0xc0) << 9);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 378 to 394
	value = ((uint32_t)(input[47] & 0x3f) << 26) |
			((uint32_t)input[48] << 18) |
			((uint32_t)(input[49] & 0xe0) << 10);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 395 to 411
	value = ((uint32_t)(input[49] & 0x1f) << 27) |
			((uint32_t)input[50] << 19) |
			((uint32_t)(input[51] & 0xf0) << 11);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 412 to 428
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)(input[53] & 0xf8) << 12);
	output[24] = (double)(value >> 15);
}

static void unpack_25_17bit_signed_5off(const uint8_t * input, double * output) {
	// Unpack 25 values into output
	// Values are 17-bit signed
	// Skip 5 bits, read 425 bits of data.
	// Input must be at least 54 bytes long

	int32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 56 to 72
	value = ((uint32_t)input[7] << 24) |
			((uint32_t)input[8] << 16) |
			((uint32_t)(input[9] & 0x80) << 8);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 73 to 89
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)(input[11] & 0xc0) << 9);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 90 to 106
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xe0) << 10);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 107 to 123
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)(input[15] & 0xf0) << 11);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 124 to 140
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)(input[17] & 0xf8) << 12);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 141 to 157
	value = ((uint32_t)(input[17] & 0x07) << 29) |
			((uint32_t)input[18] << 21) |
			((uint32_t)(input[19] & 0xfc) << 13);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 158 to 174
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xfe) << 14);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 175 to 191
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 192 to 208
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0x80) << 8);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 209 to 225
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0xc0) << 9);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 226 to 242
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xe0) << 10);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 243 to 259
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xf0) << 11);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 260 to 276
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf8) << 12);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 277 to 293
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xfc) << 13);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 294 to 310
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfe) << 14);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 311 to 327
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)input[40] << 15);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 328 to 344
	value = ((uint32_t)input[41] << 24) |
			((uint32_t)input[42] << 16) |
			((uint32_t)(input[43] & 0x80) << 8);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 345 to 361
	value = ((uint32_t)(input[43] & 0x7f) << 25) |
			((uint32_t)input[44] << 17) |
			((uint32_t)(input[45] & 0xc0) << 9);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 362 to 378
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)(input[47] & 0xe0) << 10);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 379 to 395
	value = ((uint32_t)(input[47] & 0x1f) << 27) |
			((uint32_t)input[48] << 19) |
			((uint32_t)(input[49] & 0xf0) << 11);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 396 to 412
	value = ((uint32_t)(input[49] & 0x0f) << 28) |
			((uint32_t)input[50] << 20) |
			((uint32_t)(input[51] & 0xf8) << 12);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 413 to 429
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)(input[53] & 0xfc) << 13);
	output[24] = (double)(value >> 15);
}

static void unpack_25_17bit_unsigned_5off(const uint8_t * input, double * output) {
	// Unpack 25 values into output
	// Values are 17-bit unsigned
	// Skip 5 bits, read 425 bits of data.
	// Input must be at least 54 bytes long

	uint32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 56 to 72
	value = ((uint32_t)input[7] << 24) |
			((uint32_t)input[8] << 16) |
			((uint32_t)(input[9] & 0x80) << 8);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 73 to 89
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)(input[11] & 0xc0) << 9);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 90 to 106
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xe0) << 10);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 107 to 123
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)(input[15] & 0xf0) << 11);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 124 to 140
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)(input[17] & 0xf8) << 12);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 141 to 157
	value = ((uint32_t)(input[17] & 0x07) << 29) |
			((uint32_t)input[18] << 21) |
			((uint32_t)(input[19] & 0xfc) << 13);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 158 to 174
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xfe) << 14);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 175 to 191
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 192 to 208
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0x80) << 8);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 209 to 225
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0xc0) << 9);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 226 to 242
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xe0) << 10);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 243 to 259
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xf0) << 11);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 260 to 276
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf8) << 12);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 277 to 293
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xfc) << 13);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 294 to 310
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfe) << 14);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 311 to 327
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)input[40] << 15);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 328 to 344
	value = ((uint32_t)input[41] << 24) |
			((uint32_t)input[42] << 16) |
			((uint32_t)(input[43] & 0x80) << 8);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 345 to 361
	value = ((uint32_t)(input[43] & 0x7f) << 25) |
			((uint32_t)input[44] << 17) |
			((uint32_t)(input[45] & 0xc0) << 9);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 362 to 378
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)(input[47] & 0xe0) << 10);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 379 to 395
	value = ((uint32_t)(input[47] & 0x1f) << 27) |
			((uint32_t)input[48] << 19) |
			((uint32_t)(input[49] & 0xf0) << 11);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 396 to 412
	value = ((uint32_t)(input[49] & 0x0f) << 28) |
			((uint32_t)input[50] << 20) |
			((uint32_t)(input[51] & 0xf8) << 12);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 413 to 429
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)(input[53] & 0xfc) << 13);
	output[24] = (double)(value >> 15);
}

static void unpack_25_17bit_signed_6off(const uint8_t * input, double * output) {
	// Unpack 25 values into output
	// Values are 17-bit signed
	// Skip 6 bits, read 425 bits of data.
	// Input must be at least 54 bytes long

	int32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 57 to 73
	value = ((uint32_t)(input[7] & 0x7f) << 25) |
			((uint32_t)input[8] << 17) |
			((uint32_t)(input[9] & 0xc0) << 9);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 74 to 90
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)(input[11] & 0xe0) << 10);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 91 to 107
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)(input[13] & 0xf0) << 11);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 108 to 124
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)(input[15] & 0xf8) << 12);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 125 to 141
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0xfc) << 13);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 142 to 158
	value = ((uint32_t)(input[17] & 0x03) << 30) |
			((uint32_t)input[18] << 22) |
			((uint32_t)(input[19] & 0xfe) << 14);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 159 to 175
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)input[21] << 15);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 176 to 192
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16) |
			((uint32_t)(input[24] & 0x80) << 8);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 193 to 209
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xc0) << 9);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 210 to 226
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xe0) << 10);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 227 to 243
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xf0) << 11);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 244 to 260
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf8) << 12);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 261 to 277
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xfc) << 13);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 278 to 294
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfe) << 14);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 295 to 311
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 312 to 328
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)(input[41] & 0x80) << 8);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 329 to 345
	value = ((uint32_t)(input[41] & 0x7f) << 25) |
			((uint32_t)input[42] << 17) |
			((uint32_t)(input[43] & 0xc0) << 9);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 346 to 362
	value = ((uint32_t)(input[43] & 0x3f) << 26) |
			((uint32_t)input[44] << 18) |
			((uint32_t)(input[45] & 0xe0) << 10);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 363 to 379
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)(input[47] & 0xf0) << 11);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 380 to 396
	value = ((uint32_t)(input[47] & 0x0f) << 28) |
			((uint32_t)input[48] << 20) |
			((uint32_t)(input[49] & 0xf8) << 12);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 397 to 413
	value = ((uint32_t)(input[49] & 0x07) << 29) |
			((uint32_t)input[50] << 21) |
			((uint32_t)(input[51] & 0xfc) << 13);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 414 to 430
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)(input[53] & 0xfe) << 14);
	output[24] = (double)(value >> 15);
}

static void unpack_25_17bit_unsigned_6off(const uint8_t * input, double * output) {
	// Unpack 25 values into output
	// Values are 17-bit unsigned
	// Skip 6 bits, read 425 bits of data.
	// Input must be at least 54 bytes long

	uint32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 57 to 73
	value = ((uint32_t)(input[7] & 0x7f) << 25) |
			((uint32_t)input[8] << 17) |
			((uint32_t)(input[9] & 0xc0) << 9);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 74 to 90
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)(input[11] & 0xe0) << 10);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 91 to 107
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)(input[13] & 0xf0) << 11);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 108 to 124
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)(input[15] & 0xf8) << 12);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 125 to 141
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0xfc) << 13);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 142 to 158
	value = ((uint32_t)(input[17] & 0x03) << 30) |
			((uint32_t)input[18] << 22) |
			((uint32_t)(input[19] & 0xfe) << 14);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 159 to 175
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)input[21] << 15);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 176 to 192
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16) |
			((uint32_t)(input[24] & 0x80) << 8);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 193 to 209
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xc0) << 9);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 210 to 226
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xe0) << 10);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 227 to 243
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xf0) << 11);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 244 to 260
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf8) << 12);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 261 to 277
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xfc) << 13);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 278 to 294
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfe) << 14);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 295 to 311
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 312 to 328
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)(input[41] & 0x80) << 8);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 329 to 345
	value = ((uint32_t)(input[41] & 0x7f) << 25) |
			((uint32_t)input[42] << 17) |
			((uint32_t)(input[43] & 0xc0) << 9);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 346 to 362
	value = ((uint32_t)(input[43] & 0x3f) << 26) |
			((uint32_t)input[44] << 18) |
			((uint32_t)(input[45] & 0xe0) << 10);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 363 to 379
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)(input[47] & 0xf0) << 11);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 380 to 396
	value = ((uint32_t)(input[47] & 0x0f) << 28) |
			((uint32_t)input[48] << 20) |
			((uint32_t)(input[49] & 0xf8) << 12);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 397 to 413
	value = ((uint32_t)(input[49] & 0x07) << 29) |
			((uint32_t)input[50] << 21) |
			((uint32_t)(input[51] & 0xfc) << 13);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 414 to 430
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)(input[53] & 0xfe) << 14);
	output[24] = (double)(value >> 15);
}

static void unpack_25_17bit_signed_7off(const uint8_t * input, double * output) {
	// Unpack 25 values into output
	// Values are 17-bit signed
	// Skip 7 bits, read 425 bits of data.
	// Input must be at least 54 bytes long

	int32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 58 to 74
	value = ((uint32_t)(input[7] & 0x3f) << 26) |
			((uint32_t)input[8] << 18) |
			((uint32_t)(input[9] & 0xe0) << 10);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 75 to 91
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)(input[11] & 0xf0) << 11);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 92 to 108
	value = ((uint32_t)(input[11] & 0x0f) << 28) |
			((uint32_t)input[12] << 20) |
			((uint32_t)(input[13] & 0xf8) << 12);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 109 to 125
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0xfc) << 13);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 126 to 142
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xfe) << 14);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 143 to 159
	value = ((uint32_t)(input[17] & 0x01) << 31) |
			((uint32_t)input[18] << 23) |
			((uint32_t)input[19] << 15);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 160 to 176
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16) |
			((uint32_t)(input[22] & 0x80) << 8);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 177 to 193
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0xc0) << 9);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 194 to 210
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xe0) << 10);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 211 to 227
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xf0) << 11);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 228 to 244
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf8) << 12);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 245 to 261
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xfc) << 13);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 262 to 278
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfe) << 14);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 279 to 295
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)input[36] << 15);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 296 to 312
	value = ((uint32_t)input[37] << 24) |
			((uint32_t)input[38] << 16) |
			((uint32_t)(input[39] & 0x80) << 8);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 313 to 329
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)(input[41] & 0xc0) << 9);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 330 to 346
	value = ((uint32_t)(input[41] & 0x3f) << 26) |
			((uint32_t)input[42] << 18) |
			((uint32_t)(input[43] & 0xe0) << 10);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 347 to 363
	value = ((uint32_t)(input[43] & 0x1f) << 27) |
			((uint32_t)input[44] << 19) |
			((uint32_t)(input[45] & 0xf0) << 11);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 364 to 380
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)(input[47] & 0xf8) << 12);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 381 to 397
	value = ((uint32_t)(input[47] & 0x07) << 29) |
			((uint32_t)input[48] << 21) |
			((uint32_t)(input[49] & 0xfc) << 13);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 398 to 414
	value = ((uint32_t)(input[49] & 0x03) << 30) |
			((uint32_t)input[50] << 22) |
			((uint32_t)(input[51] & 0xfe) << 14);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 415 to 431
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15);
	output[24] = (double)(value >> 15);
}

static void unpack_25_17bit_unsigned_7off(const uint8_t * input, double * output) {
	// Unpack 25 values into output
	// Values are 17-bit unsigned
	// Skip 7 bits, read 425 bits of data.
	// Input must be at least 54 bytes long

	uint32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 58 to 74
	value = ((uint32_t)(input[7] & 0x3f) << 26) |
			((uint32_t)input[8] << 18) |
			((uint32_t)(input[9] & 0xe0) << 10);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 75 to 91
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)(input[11] & 0xf0) << 11);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 92 to 108
	value = ((uint32_t)(input[11] & 0x0f) << 28) |
			((uint32_t)input[12] << 20) |
			((uint32_t)(input[13] & 0xf8) << 12);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 109 to 125
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0xfc) << 13);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 126 to 142
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xfe) << 14);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 143 to 159
	value = ((uint32_t)(input[17] & 0x01) << 31) |
			((uint32_t)input[18] << 23) |
			((uint32_t)input[19] << 15);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 160 to 176
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16) |
			((uint32_t)(input[22] & 0x80) << 8);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 177 to 193
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0xc0) << 9);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 194 to 210
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xe0) << 10);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 211 to 227
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xf0) << 11);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 228 to 244
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf8) << 12);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 245 to 261
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xfc) << 13);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 262 to 278
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfe) << 14);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 279 to 295
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)input[36] << 15);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 296 to 312
	value = ((uint32_t)input[37] << 24) |
			((uint32_t)input[38] << 16) |
			((uint32_t)(input[39] & 0x80) << 8);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 313 to 329
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)(input[41] & 0xc0) << 9);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 330 to 346
	value = ((uint32_t)(input[41] & 0x3f) << 26) |
			((uint32_t)input[42] << 18) |
			((uint32_t)(input[43] & 0xe0) << 10);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 347 to 363
	value = ((uint32_t)(input[43] & 0x1f) << 27) |
			((uint32_t)input[44] << 19) |
			((uint32_t)(input[45] & 0xf0) << 11);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 364 to 380
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)(input[47] & 0xf8) << 12);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 381 to 397
	value = ((uint32_t)(input[47] & 0x07) << 29) |
			((uint32_t)input[48] << 21) |
			((uint32_t)(input[49] & 0xfc) << 13);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 398 to 414
	value = ((uint32_t)(input[49] & 0x03) << 30) |
			((uint32_t)input[50] << 22) |
			((uint32_t)(input[51] & 0xfe) << 14);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 415 to 431
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15);
	output[24] = (double)(value >> 15);
}

static void unpack_26_17bit_signed_0off(const uint8_t * input, double * output) {
	// Unpack 26 values into output
	// Values are 17-bit signed
	// Skip 0 bits, read 442 bits of data.
	// Input must be at least 56 bytes long

	int32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 51 to 67
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xf0) << 11);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 68 to 84
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf8) << 12);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 85 to 101
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xfc) << 13);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 102 to 118
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfe) << 14);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 119 to 135
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)input[16] << 15);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 136 to 152
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)input[18] << 16) |
			((uint32_t)(input[19] & 0x80) << 8);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 153 to 169
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xc0) << 9);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 170 to 186
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xe0) << 10);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 187 to 203
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)input[24] << 19) |
			((uint32_t)(input[25] & 0xf0) << 11);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 204 to 220
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20) |
			((uint32_t)(input[27] & 0xf8) << 12);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 221 to 237
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0xfc) << 13);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 238 to 254
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)(input[31] & 0xfe) << 14);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 255 to 271
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)input[33] << 15);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 272 to 288
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16) |
			((uint32_t)(input[36] & 0x80) << 8);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 289 to 305
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0xc0) << 9);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 306 to 322
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xe0) << 10);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 323 to 339
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xf0) << 11);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 340 to 356
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf8) << 12);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 357 to 373
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xfc) << 13);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 374 to 390
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfe) << 14);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 391 to 407
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 408 to 424
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)(input[53] & 0x80) << 8);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 425 to 441
	value = ((uint32_t)(input[53] & 0x7f) << 25) |
			((uint32_t)input[54] << 17) |
			((uint32_t)(input[55] & 0xc0) << 9);
	output[25] = (double)(value >> 15);
}

static void unpack_26_17bit_unsigned_0off(const uint8_t * input, double * output) {
	// Unpack 26 values into output
	// Values are 17-bit unsigned
	// Skip 0 bits, read 442 bits of data.
	// Input must be at least 56 bytes long

	uint32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 51 to 67
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xf0) << 11);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 68 to 84
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf8) << 12);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 85 to 101
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xfc) << 13);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 102 to 118
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfe) << 14);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 119 to 135
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)input[16] << 15);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 136 to 152
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)input[18] << 16) |
			((uint32_t)(input[19] & 0x80) << 8);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 153 to 169
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xc0) << 9);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 170 to 186
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xe0) << 10);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 187 to 203
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)input[24] << 19) |
			((uint32_t)(input[25] & 0xf0) << 11);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 204 to 220
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20) |
			((uint32_t)(input[27] & 0xf8) << 12);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 221 to 237
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0xfc) << 13);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 238 to 254
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)(input[31] & 0xfe) << 14);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 255 to 271
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)input[33] << 15);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 272 to 288
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16) |
			((uint32_t)(input[36] & 0x80) << 8);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 289 to 305
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0xc0) << 9);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 306 to 322
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xe0) << 10);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 323 to 339
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xf0) << 11);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 340 to 356
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf8) << 12);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 357 to 373
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xfc) << 13);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 374 to 390
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfe) << 14);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 391 to 407
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 408 to 424
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)(input[53] & 0x80) << 8);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 425 to 441
	value = ((uint32_t)(input[53] & 0x7f) << 25) |
			((uint32_t)input[54] << 17) |
			((uint32_t)(input[55] & 0xc0) << 9);
	output[25] = (double)(value >> 15);
}

static void unpack_26_17bit_signed_1off(const uint8_t * input, double * output) {
	// Unpack 26 values into output
	// Values are 17-bit signed
	// Skip 1 bits, read 442 bits of data.
	// Input must be at least 56 bytes long

	int32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 52 to 68
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf8) << 12);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 69 to 85
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xfc) << 13);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 86 to 102
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfe) << 14);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 103 to 119
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 120 to 136
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)(input[17] & 0x80) << 8);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 137 to 153
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)input[18] << 17) |
			((uint32_t)(input[19] & 0xc0) << 9);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 154 to 170
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xe0) << 10);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 171 to 187
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)(input[23] & 0xf0) << 11);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 188 to 204
	value = ((uint32_t)(input[23] & 0x0f) << 28) |
			((uint32_t)input[24] << 20) |
			((uint32_t)(input[25] & 0xf8) << 12);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 205 to 221
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0xfc) << 13);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 222 to 238
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xfe) << 14);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 239 to 255
	value = ((uint32_t)(input[29] & 0x01) << 31) |
			((uint32_t)input[30] << 23) |
			((uint32_t)input[31] << 15);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 256 to 272
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16) |
			((uint32_t)(input[34] & 0x80) << 8);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 273 to 289
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0xc0) << 9);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 290 to 306
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xe0) << 10);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 307 to 323
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xf0) << 11);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 324 to 340
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf8) << 12);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 341 to 357
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xfc) << 13);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 358 to 374
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfe) << 14);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 375 to 391
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)input[48] << 15);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 392 to 408
	value = ((uint32_t)input[49] << 24) |
			((uint32_t)input[50] << 16) |
			((uint32_t)(input[51] & 0x80) << 8);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 409 to 425
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)(input[53] & 0xc0) << 9);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 426 to 442
	value = ((uint32_t)(input[53] & 0x3f) << 26) |
			((uint32_t)input[54] << 18) |
			((uint32_t)(input[55] & 0xe0) << 10);
	output[25] = (double)(value >> 15);
}

static void unpack_26_17bit_unsigned_1off(const uint8_t * input, double * output) {
	// Unpack 26 values into output
	// Values are 17-bit unsigned
	// Skip 1 bits, read 442 bits of data.
	// Input must be at least 56 bytes long

	uint32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 52 to 68
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf8) << 12);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 69 to 85
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xfc) << 13);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 86 to 102
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfe) << 14);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 103 to 119
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 120 to 136
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)(input[17] & 0x80) << 8);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 137 to 153
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)input[18] << 17) |
			((uint32_t)(input[19] & 0xc0) << 9);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 154 to 170
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xe0) << 10);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 171 to 187
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)(input[23] & 0xf0) << 11);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 188 to 204
	value = ((uint32_t)(input[23] & 0x0f) << 28) |
			((uint32_t)input[24] << 20) |
			((uint32_t)(input[25] & 0xf8) << 12);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 205 to 221
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0xfc) << 13);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 222 to 238
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xfe) << 14);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 239 to 255
	value = ((uint32_t)(input[29] & 0x01) << 31) |
			((uint32_t)input[30] << 23) |
			((uint32_t)input[31] << 15);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 256 to 272
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16) |
			((uint32_t)(input[34] & 0x80) << 8);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 273 to 289
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0xc0) << 9);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 290 to 306
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xe0) << 10);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 307 to 323
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xf0) << 11);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 324 to 340
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf8) << 12);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 341 to 357
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xfc) << 13);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 358 to 374
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfe) << 14);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 375 to 391
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)input[48] << 15);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 392 to 408
	value = ((uint32_t)input[49] << 24) |
			((uint32_t)input[50] << 16) |
			((uint32_t)(input[51] & 0x80) << 8);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 409 to 425
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)(input[53] & 0xc0) << 9);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 426 to 442
	value = ((uint32_t)(input[53] & 0x3f) << 26) |
			((uint32_t)input[54] << 18) |
			((uint32_t)(input[55] & 0xe0) << 10);
	output[25] = (double)(value >> 15);
}

static void unpack_26_17bit_signed_2off(const uint8_t * input, double * output) {
	// Unpack 26 values into output
	// Values are 17-bit signed
	// Skip 2 bits, read 442 bits of data.
	// Input must be at least 56 bytes long

	int32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 53 to 69
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xfc) << 13);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 70 to 86
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfe) << 14);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 87 to 103
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 104 to 120
	value = ((uint32_t)input[13] << 24) |
			((uint32_t)input[14] << 16) |
			((uint32_t)(input[15] & 0x80) << 8);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 121 to 137
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)(input[17] & 0xc0) << 9);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 138 to 154
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)input[18] << 18) |
			((uint32_t)(input[19] & 0xe0) << 10);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 155 to 171
	value = ((uint32_t)(input[19] & 0x1f) << 27) |
			((uint32_t)input[20] << 19) |
			((uint32_t)(input[21] & 0xf0) << 11);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 172 to 188
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)(input[23] & 0xf8) << 12);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 189 to 205
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)(input[25] & 0xfc) << 13);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 206 to 222
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xfe) << 14);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 223 to 239
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 240 to 256
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)(input[32] & 0x80) << 8);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 257 to 273
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0xc0) << 9);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 274 to 290
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xe0) << 10);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 291 to 307
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xf0) << 11);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 308 to 324
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf8) << 12);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 325 to 341
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xfc) << 13);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 342 to 358
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfe) << 14);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 359 to 375
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)input[46] << 15);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 376 to 392
	value = ((uint32_t)input[47] << 24) |
			((uint32_t)input[48] << 16) |
			((uint32_t)(input[49] & 0x80) << 8);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 393 to 409
	value = ((uint32_t)(input[49] & 0x7f) << 25) |
			((uint32_t)input[50] << 17) |
			((uint32_t)(input[51] & 0xc0) << 9);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 410 to 426
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)(input[53] & 0xe0) << 10);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 427 to 443
	value = ((uint32_t)(input[53] & 0x1f) << 27) |
			((uint32_t)input[54] << 19) |
			((uint32_t)(input[55] & 0xf0) << 11);
	output[25] = (double)(value >> 15);
}

static void unpack_26_17bit_unsigned_2off(const uint8_t * input, double * output) {
	// Unpack 26 values into output
	// Values are 17-bit unsigned
	// Skip 2 bits, read 442 bits of data.
	// Input must be at least 56 bytes long

	uint32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 53 to 69
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xfc) << 13);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 70 to 86
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfe) << 14);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 87 to 103
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 104 to 120
	value = ((uint32_t)input[13] << 24) |
			((uint32_t)input[14] << 16) |
			((uint32_t)(input[15] & 0x80) << 8);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 121 to 137
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)(input[17] & 0xc0) << 9);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 138 to 154
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)input[18] << 18) |
			((uint32_t)(input[19] & 0xe0) << 10);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 155 to 171
	value = ((uint32_t)(input[19] & 0x1f) << 27) |
			((uint32_t)input[20] << 19) |
			((uint32_t)(input[21] & 0xf0) << 11);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 172 to 188
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)(input[23] & 0xf8) << 12);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 189 to 205
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)(input[25] & 0xfc) << 13);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 206 to 222
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xfe) << 14);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 223 to 239
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 240 to 256
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)(input[32] & 0x80) << 8);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 257 to 273
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0xc0) << 9);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 274 to 290
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xe0) << 10);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 291 to 307
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xf0) << 11);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 308 to 324
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf8) << 12);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 325 to 341
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xfc) << 13);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 342 to 358
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfe) << 14);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 359 to 375
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)input[46] << 15);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 376 to 392
	value = ((uint32_t)input[47] << 24) |
			((uint32_t)input[48] << 16) |
			((uint32_t)(input[49] & 0x80) << 8);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 393 to 409
	value = ((uint32_t)(input[49] & 0x7f) << 25) |
			((uint32_t)input[50] << 17) |
			((uint32_t)(input[51] & 0xc0) << 9);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 410 to 426
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)(input[53] & 0xe0) << 10);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 427 to 443
	value = ((uint32_t)(input[53] & 0x1f) << 27) |
			((uint32_t)input[54] << 19) |
			((uint32_t)(input[55] & 0xf0) << 11);
	output[25] = (double)(value >> 15);
}

static void unpack_26_17bit_signed_3off(const uint8_t * input, double * output) {
	// Unpack 26 values into output
	// Values are 17-bit signed
	// Skip 3 bits, read 442 bits of data.
	// Input must be at least 56 bytes long

	int32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 54 to 70
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfe) << 14);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 71 to 87
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)input[10] << 15);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 88 to 104
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0x80) << 8);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 105 to 121
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xc0) << 9);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 122 to 138
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)(input[17] & 0xe0) << 10);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 139 to 155
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)input[18] << 19) |
			((uint32_t)(input[19] & 0xf0) << 11);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 156 to 172
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20) |
			((uint32_t)(input[21] & 0xf8) << 12);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 173 to 189
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0xfc) << 13);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 190 to 206
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)(input[25] & 0xfe) << 14);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 207 to 223
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)input[27] << 15);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 224 to 240
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16) |
			((uint32_t)(input[30] & 0x80) << 8);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 241 to 257
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0xc0) << 9);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 258 to 274
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xe0) << 10);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 275 to 291
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xf0) << 11);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 292 to 308
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf8) << 12);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 309 to 325
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xfc) << 13);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 326 to 342
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfe) << 14);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 343 to 359
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 360 to 376
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)(input[47] & 0x80) << 8);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 377 to 393
	value = ((uint32_t)(input[47] & 0x7f) << 25) |
			((uint32_t)input[48] << 17) |
			((uint32_t)(input[49] & 0xc0) << 9);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 394 to 410
	value = ((uint32_t)(input[49] & 0x3f) << 26) |
			((uint32_t)input[50] << 18) |
			((uint32_t)(input[51] & 0xe0) << 10);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 411 to 427
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)(input[53] & 0xf0) << 11);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 428 to 444
	value = ((uint32_t)(input[53] & 0x0f) << 28) |
			((uint32_t)input[54] << 20) |
			((uint32_t)(input[55] & 0xf8) << 12);
	output[25] = (double)(value >> 15);
}

static void unpack_26_17bit_unsigned_3off(const uint8_t * input, double * output) {
	// Unpack 26 values into output
	// Values are 17-bit unsigned
	// Skip 3 bits, read 442 bits of data.
	// Input must be at least 56 bytes long

	uint32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 54 to 70
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfe) << 14);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 71 to 87
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)input[10] << 15);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 88 to 104
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0x80) << 8);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 105 to 121
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xc0) << 9);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 122 to 138
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)(input[17] & 0xe0) << 10);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 139 to 155
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)input[18] << 19) |
			((uint32_t)(input[19] & 0xf0) << 11);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 156 to 172
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20) |
			((uint32_t)(input[21] & 0xf8) << 12);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 173 to 189
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0xfc) << 13);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 190 to 206
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)(input[25] & 0xfe) << 14);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 207 to 223
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)input[27] << 15);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 224 to 240
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16) |
			((uint32_t)(input[30] & 0x80) << 8);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 241 to 257
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0xc0) << 9);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 258 to 274
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xe0) << 10);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 275 to 291
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xf0) << 11);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 292 to 308
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf8) << 12);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 309 to 325
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xfc) << 13);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 326 to 342
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfe) << 14);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 343 to 359
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 360 to 376
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)(input[47] & 0x80) << 8);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 377 to 393
	value = ((uint32_t)(input[47] & 0x7f) << 25) |
			((uint32_t)input[48] << 17) |
			((uint32_t)(input[49] & 0xc0) << 9);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 394 to 410
	value = ((uint32_t)(input[49] & 0x3f) << 26) |
			((uint32_t)input[50] << 18) |
			((uint32_t)(input[51] & 0xe0) << 10);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 411 to 427
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)(input[53] & 0xf0) << 11);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 428 to 444
	value = ((uint32_t)(input[53] & 0x0f) << 28) |
			((uint32_t)input[54] << 20) |
			((uint32_t)(input[55] & 0xf8) << 12);
	output[25] = (double)(value >> 15);
}

static void unpack_26_17bit_signed_4off(const uint8_t * input, double * output) {
	// Unpack 26 values into output
	// Values are 17-bit signed
	// Skip 4 bits, read 442 bits of data.
	// Input must be at least 56 bytes long

	int32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 55 to 71
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 72 to 88
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)(input[11] & 0x80) << 8);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 89 to 105
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xc0) << 9);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 106 to 122
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xe0) << 10);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 123 to 139
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)(input[17] & 0xf0) << 11);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 140 to 156
	value = ((uint32_t)(input[17] & 0x0f) << 28) |
			((uint32_t)input[18] << 20) |
			((uint32_t)(input[19] & 0xf8) << 12);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 157 to 173
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0xfc) << 13);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 174 to 190
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xfe) << 14);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 191 to 207
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 208 to 224
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16) |
			((uint32_t)(input[28] & 0x80) << 8);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 225 to 241
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0xc0) << 9);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 242 to 258
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xe0) << 10);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 259 to 275
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xf0) << 11);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 276 to 292
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf8) << 12);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 293 to 309
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xfc) << 13);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 310 to 326
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfe) << 14);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 327 to 343
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)input[42] << 15);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 344 to 360
	value = ((uint32_t)input[43] << 24) |
			((uint32_t)input[44] << 16) |
			((uint32_t)(input[45] & 0x80) << 8);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 361 to 377
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)(input[47] & 0xc0) << 9);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 378 to 394
	value = ((uint32_t)(input[47] & 0x3f) << 26) |
			((uint32_t)input[48] << 18) |
			((uint32_t)(input[49] & 0xe0) << 10);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 395 to 411
	value = ((uint32_t)(input[49] & 0x1f) << 27) |
			((uint32_t)input[50] << 19) |
			((uint32_t)(input[51] & 0xf0) << 11);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 412 to 428
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)(input[53] & 0xf8) << 12);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 429 to 445
	value = ((uint32_t)(input[53] & 0x07) << 29) |
			((uint32_t)input[54] << 21) |
			((uint32_t)(input[55] & 0xfc) << 13);
	output[25] = (double)(value >> 15);
}

static void unpack_26_17bit_unsigned_4off(const uint8_t * input, double * output) {
	// Unpack 26 values into output
	// Values are 17-bit unsigned
	// Skip 4 bits, read 442 bits of data.
	// Input must be at least 56 bytes long

	uint32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 55 to 71
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 72 to 88
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)(input[11] & 0x80) << 8);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 89 to 105
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xc0) << 9);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 106 to 122
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xe0) << 10);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 123 to 139
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)(input[17] & 0xf0) << 11);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 140 to 156
	value = ((uint32_t)(input[17] & 0x0f) << 28) |
			((uint32_t)input[18] << 20) |
			((uint32_t)(input[19] & 0xf8) << 12);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 157 to 173
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0xfc) << 13);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 174 to 190
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xfe) << 14);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 191 to 207
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 208 to 224
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16) |
			((uint32_t)(input[28] & 0x80) << 8);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 225 to 241
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0xc0) << 9);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 242 to 258
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xe0) << 10);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 259 to 275
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xf0) << 11);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 276 to 292
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf8) << 12);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 293 to 309
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xfc) << 13);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 310 to 326
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfe) << 14);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 327 to 343
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)input[42] << 15);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 344 to 360
	value = ((uint32_t)input[43] << 24) |
			((uint32_t)input[44] << 16) |
			((uint32_t)(input[45] & 0x80) << 8);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 361 to 377
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)(input[47] & 0xc0) << 9);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 378 to 394
	value = ((uint32_t)(input[47] & 0x3f) << 26) |
			((uint32_t)input[48] << 18) |
			((uint32_t)(input[49] & 0xe0) << 10);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 395 to 411
	value = ((uint32_t)(input[49] & 0x1f) << 27) |
			((uint32_t)input[50] << 19) |
			((uint32_t)(input[51] & 0xf0) << 11);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 412 to 428
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)(input[53] & 0xf8) << 12);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 429 to 445
	value = ((uint32_t)(input[53] & 0x07) << 29) |
			((uint32_t)input[54] << 21) |
			((uint32_t)(input[55] & 0xfc) << 13);
	output[25] = (double)(value >> 15);
}

static void unpack_26_17bit_signed_5off(const uint8_t * input, double * output) {
	// Unpack 26 values into output
	// Values are 17-bit signed
	// Skip 5 bits, read 442 bits of data.
	// Input must be at least 56 bytes long

	int32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 56 to 72
	value = ((uint32_t)input[7] << 24) |
			((uint32_t)input[8] << 16) |
			((uint32_t)(input[9] & 0x80) << 8);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 73 to 89
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)(input[11] & 0xc0) << 9);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 90 to 106
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xe0) << 10);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 107 to 123
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)(input[15] & 0xf0) << 11);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 124 to 140
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)(input[17] & 0xf8) << 12);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 141 to 157
	value = ((uint32_t)(input[17] & 0x07) << 29) |
			((uint32_t)input[18] << 21) |
			((uint32_t)(input[19] & 0xfc) << 13);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 158 to 174
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xfe) << 14);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 175 to 191
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 192 to 208
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0x80) << 8);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 209 to 225
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0xc0) << 9);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 226 to 242
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xe0) << 10);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 243 to 259
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xf0) << 11);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 260 to 276
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf8) << 12);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 277 to 293
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xfc) << 13);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 294 to 310
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfe) << 14);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 311 to 327
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)input[40] << 15);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 328 to 344
	value = ((uint32_t)input[41] << 24) |
			((uint32_t)input[42] << 16) |
			((uint32_t)(input[43] & 0x80) << 8);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 345 to 361
	value = ((uint32_t)(input[43] & 0x7f) << 25) |
			((uint32_t)input[44] << 17) |
			((uint32_t)(input[45] & 0xc0) << 9);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 362 to 378
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)(input[47] & 0xe0) << 10);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 379 to 395
	value = ((uint32_t)(input[47] & 0x1f) << 27) |
			((uint32_t)input[48] << 19) |
			((uint32_t)(input[49] & 0xf0) << 11);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 396 to 412
	value = ((uint32_t)(input[49] & 0x0f) << 28) |
			((uint32_t)input[50] << 20) |
			((uint32_t)(input[51] & 0xf8) << 12);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 413 to 429
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)(input[53] & 0xfc) << 13);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 430 to 446
	value = ((uint32_t)(input[53] & 0x03) << 30) |
			((uint32_t)input[54] << 22) |
			((uint32_t)(input[55] & 0xfe) << 14);
	output[25] = (double)(value >> 15);
}

static void unpack_26_17bit_unsigned_5off(const uint8_t * input, double * output) {
	// Unpack 26 values into output
	// Values are 17-bit unsigned
	// Skip 5 bits, read 442 bits of data.
	// Input must be at least 56 bytes long

	uint32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 56 to 72
	value = ((uint32_t)input[7] << 24) |
			((uint32_t)input[8] << 16) |
			((uint32_t)(input[9] & 0x80) << 8);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 73 to 89
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)(input[11] & 0xc0) << 9);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 90 to 106
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xe0) << 10);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 107 to 123
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)(input[15] & 0xf0) << 11);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 124 to 140
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)(input[17] & 0xf8) << 12);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 141 to 157
	value = ((uint32_t)(input[17] & 0x07) << 29) |
			((uint32_t)input[18] << 21) |
			((uint32_t)(input[19] & 0xfc) << 13);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 158 to 174
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xfe) << 14);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 175 to 191
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 192 to 208
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0x80) << 8);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 209 to 225
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0xc0) << 9);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 226 to 242
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xe0) << 10);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 243 to 259
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xf0) << 11);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 260 to 276
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf8) << 12);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 277 to 293
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xfc) << 13);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 294 to 310
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfe) << 14);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 311 to 327
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)input[40] << 15);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 328 to 344
	value = ((uint32_t)input[41] << 24) |
			((uint32_t)input[42] << 16) |
			((uint32_t)(input[43] & 0x80) << 8);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 345 to 361
	value = ((uint32_t)(input[43] & 0x7f) << 25) |
			((uint32_t)input[44] << 17) |
			((uint32_t)(input[45] & 0xc0) << 9);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 362 to 378
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)(input[47] & 0xe0) << 10);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 379 to 395
	value = ((uint32_t)(input[47] & 0x1f) << 27) |
			((uint32_t)input[48] << 19) |
			((uint32_t)(input[49] & 0xf0) << 11);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 396 to 412
	value = ((uint32_t)(input[49] & 0x0f) << 28) |
			((uint32_t)input[50] << 20) |
			((uint32_t)(input[51] & 0xf8) << 12);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 413 to 429
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)(input[53] & 0xfc) << 13);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 430 to 446
	value = ((uint32_t)(input[53] & 0x03) << 30) |
			((uint32_t)input[54] << 22) |
			((uint32_t)(input[55] & 0xfe) << 14);
	output[25] = (double)(value >> 15);
}

static void unpack_26_17bit_signed_6off(const uint8_t * input, double * output) {
	// Unpack 26 values into output
	// Values are 17-bit signed
	// Skip 6 bits, read 442 bits of data.
	// Input must be at least 56 bytes long

	int32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 57 to 73
	value = ((uint32_t)(input[7] & 0x7f) << 25) |
			((uint32_t)input[8] << 17) |
			((uint32_t)(input[9] & 0xc0) << 9);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 74 to 90
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)(input[11] & 0xe0) << 10);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 91 to 107
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)(input[13] & 0xf0) << 11);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 108 to 124
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)(input[15] & 0xf8) << 12);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 125 to 141
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0xfc) << 13);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 142 to 158
	value = ((uint32_t)(input[17] & 0x03) << 30) |
			((uint32_t)input[18] << 22) |
			((uint32_t)(input[19] & 0xfe) << 14);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 159 to 175
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)input[21] << 15);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 176 to 192
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16) |
			((uint32_t)(input[24] & 0x80) << 8);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 193 to 209
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xc0) << 9);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 210 to 226
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xe0) << 10);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 227 to 243
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xf0) << 11);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 244 to 260
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf8) << 12);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 261 to 277
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xfc) << 13);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 278 to 294
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfe) << 14);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 295 to 311
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 312 to 328
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)(input[41] & 0x80) << 8);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 329 to 345
	value = ((uint32_t)(input[41] & 0x7f) << 25) |
			((uint32_t)input[42] << 17) |
			((uint32_t)(input[43] & 0xc0) << 9);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 346 to 362
	value = ((uint32_t)(input[43] & 0x3f) << 26) |
			((uint32_t)input[44] << 18) |
			((uint32_t)(input[45] & 0xe0) << 10);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 363 to 379
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)(input[47] & 0xf0) << 11);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 380 to 396
	value = ((uint32_t)(input[47] & 0x0f) << 28) |
			((uint32_t)input[48] << 20) |
			((uint32_t)(input[49] & 0xf8) << 12);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 397 to 413
	value = ((uint32_t)(input[49] & 0x07) << 29) |
			((uint32_t)input[50] << 21) |
			((uint32_t)(input[51] & 0xfc) << 13);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 414 to 430
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)(input[53] & 0xfe) << 14);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 431 to 447
	value = ((uint32_t)(input[53] & 0x01) << 31) |
			((uint32_t)input[54] << 23) |
			((uint32_t)input[55] << 15);
	output[25] = (double)(value >> 15);
}

static void unpack_26_17bit_unsigned_6off(const uint8_t * input, double * output) {
	// Unpack 26 values into output
	// Values are 17-bit unsigned
	// Skip 6 bits, read 442 bits of data.
	// Input must be at least 56 bytes long

	uint32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 57 to 73
	value = ((uint32_t)(input[7] & 0x7f) << 25) |
			((uint32_t)input[8] << 17) |
			((uint32_t)(input[9] & 0xc0) << 9);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 74 to 90
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)(input[11] & 0xe0) << 10);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 91 to 107
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)(input[13] & 0xf0) << 11);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 108 to 124
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)(input[15] & 0xf8) << 12);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 125 to 141
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0xfc) << 13);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 142 to 158
	value = ((uint32_t)(input[17] & 0x03) << 30) |
			((uint32_t)input[18] << 22) |
			((uint32_t)(input[19] & 0xfe) << 14);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 159 to 175
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)input[21] << 15);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 176 to 192
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16) |
			((uint32_t)(input[24] & 0x80) << 8);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 193 to 209
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xc0) << 9);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 210 to 226
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xe0) << 10);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 227 to 243
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xf0) << 11);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 244 to 260
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf8) << 12);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 261 to 277
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xfc) << 13);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 278 to 294
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfe) << 14);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 295 to 311
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 312 to 328
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)(input[41] & 0x80) << 8);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 329 to 345
	value = ((uint32_t)(input[41] & 0x7f) << 25) |
			((uint32_t)input[42] << 17) |
			((uint32_t)(input[43] & 0xc0) << 9);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 346 to 362
	value = ((uint32_t)(input[43] & 0x3f) << 26) |
			((uint32_t)input[44] << 18) |
			((uint32_t)(input[45] & 0xe0) << 10);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 363 to 379
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)(input[47] & 0xf0) << 11);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 380 to 396
	value = ((uint32_t)(input[47] & 0x0f) << 28) |
			((uint32_t)input[48] << 20) |
			((uint32_t)(input[49] & 0xf8) << 12);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 397 to 413
	value = ((uint32_t)(input[49] & 0x07) << 29) |
			((uint32_t)input[50] << 21) |
			((uint32_t)(input[51] & 0xfc) << 13);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 414 to 430
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)(input[53] & 0xfe) << 14);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 431 to 447
	value = ((uint32_t)(input[53] & 0x01) << 31) |
			((uint32_t)input[54] << 23) |
			((uint32_t)input[55] << 15);
	output[25] = (double)(value >> 15);
}

static void unpack_26_17bit_signed_7off(const uint8_t * input, double * output) {
	// Unpack 26 values into output
	// Values are 17-bit signed
	// Skip 7 bits, read 442 bits of data.
	// Input must be at least 57 bytes long

	int32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 58 to 74
	value = ((uint32_t)(input[7] & 0x3f) << 26) |
			((uint32_t)input[8] << 18) |
			((uint32_t)(input[9] & 0xe0) << 10);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 75 to 91
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)(input[11] & 0xf0) << 11);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 92 to 108
	value = ((uint32_t)(input[11] & 0x0f) << 28) |
			((uint32_t)input[12] << 20) |
			((uint32_t)(input[13] & 0xf8) << 12);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 109 to 125
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0xfc) << 13);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 126 to 142
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xfe) << 14);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 143 to 159
	value = ((uint32_t)(input[17] & 0x01) << 31) |
			((uint32_t)input[18] << 23) |
			((uint32_t)input[19] << 15);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 160 to 176
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16) |
			((uint32_t)(input[22] & 0x80) << 8);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 177 to 193
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0xc0) << 9);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 194 to 210
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xe0) << 10);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 211 to 227
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xf0) << 11);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 228 to 244
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf8) << 12);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 245 to 261
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xfc) << 13);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 262 to 278
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfe) << 14);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 279 to 295
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)input[36] << 15);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 296 to 312
	value = ((uint32_t)input[37] << 24) |
			((uint32_t)input[38] << 16) |
			((uint32_t)(input[39] & 0x80) << 8);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 313 to 329
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)(input[41] & 0xc0) << 9);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 330 to 346
	value = ((uint32_t)(input[41] & 0x3f) << 26) |
			((uint32_t)input[42] << 18) |
			((uint32_t)(input[43] & 0xe0) << 10);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 347 to 363
	value = ((uint32_t)(input[43] & 0x1f) << 27) |
			((uint32_t)input[44] << 19) |
			((uint32_t)(input[45] & 0xf0) << 11);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 364 to 380
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)(input[47] & 0xf8) << 12);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 381 to 397
	value = ((uint32_t)(input[47] & 0x07) << 29) |
			((uint32_t)input[48] << 21) |
			((uint32_t)(input[49] & 0xfc) << 13);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 398 to 414
	value = ((uint32_t)(input[49] & 0x03) << 30) |
			((uint32_t)input[50] << 22) |
			((uint32_t)(input[51] & 0xfe) << 14);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 415 to 431
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 432 to 448
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)(input[56] & 0x80) << 8);
	output[25] = (double)(value >> 15);
}

static void unpack_26_17bit_unsigned_7off(const uint8_t * input, double * output) {
	// Unpack 26 values into output
	// Values are 17-bit unsigned
	// Skip 7 bits, read 442 bits of data.
	// Input must be at least 57 bytes long

	uint32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 58 to 74
	value = ((uint32_t)(input[7] & 0x3f) << 26) |
			((uint32_t)input[8] << 18) |
			((uint32_t)(input[9] & 0xe0) << 10);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 75 to 91
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)(input[11] & 0xf0) << 11);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 92 to 108
	value = ((uint32_t)(input[11] & 0x0f) << 28) |
			((uint32_t)input[12] << 20) |
			((uint32_t)(input[13] & 0xf8) << 12);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 109 to 125
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0xfc) << 13);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 126 to 142
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xfe) << 14);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 143 to 159
	value = ((uint32_t)(input[17] & 0x01) << 31) |
			((uint32_t)input[18] << 23) |
			((uint32_t)input[19] << 15);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 160 to 176
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16) |
			((uint32_t)(input[22] & 0x80) << 8);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 177 to 193
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0xc0) << 9);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 194 to 210
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xe0) << 10);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 211 to 227
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xf0) << 11);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 228 to 244
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf8) << 12);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 245 to 261
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xfc) << 13);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 262 to 278
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfe) << 14);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 279 to 295
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)input[36] << 15);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 296 to 312
	value = ((uint32_t)input[37] << 24) |
			((uint32_t)input[38] << 16) |
			((uint32_t)(input[39] & 0x80) << 8);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 313 to 329
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)(input[41] & 0xc0) << 9);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 330 to 346
	value = ((uint32_t)(input[41] & 0x3f) << 26) |
			((uint32_t)input[42] << 18) |
			((uint32_t)(input[43] & 0xe0) << 10);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 347 to 363
	value = ((uint32_t)(input[43] & 0x1f) << 27) |
			((uint32_t)input[44] << 19) |
			((uint32_t)(input[45] & 0xf0) << 11);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 364 to 380
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)(input[47] & 0xf8) << 12);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 381 to 397
	value = ((uint32_t)(input[47] & 0x07) << 29) |
			((uint32_t)input[48] << 21) |
			((uint32_t)(input[49] & 0xfc) << 13);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 398 to 414
	value = ((uint32_t)(input[49] & 0x03) << 30) |
			((uint32_t)input[50] << 22) |
			((uint32_t)(input[51] & 0xfe) << 14);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 415 to 431
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 432 to 448
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)(input[56] & 0x80) << 8);
	output[25] = (double)(value >> 15);
}

static void unpack_27_17bit_signed_0off(const uint8_t * input, double * output) {
	// Unpack 27 values into output
	// Values are 17-bit signed
	// Skip 0 bits, read 459 bits of data.
	// Input must be at least 58 bytes long

	int32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 51 to 67
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xf0) << 11);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 68 to 84
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf8) << 12);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 85 to 101
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xfc) << 13);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 102 to 118
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfe) << 14);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 119 to 135
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)input[16] << 15);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 136 to 152
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)input[18] << 16) |
			((uint32_t)(input[19] & 0x80) << 8);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 153 to 169
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xc0) << 9);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 170 to 186
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xe0) << 10);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 187 to 203
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)input[24] << 19) |
			((uint32_t)(input[25] & 0xf0) << 11);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 204 to 220
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20) |
			((uint32_t)(input[27] & 0xf8) << 12);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 221 to 237
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0xfc) << 13);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 238 to 254
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)(input[31] & 0xfe) << 14);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 255 to 271
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)input[33] << 15);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 272 to 288
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16) |
			((uint32_t)(input[36] & 0x80) << 8);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 289 to 305
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0xc0) << 9);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 306 to 322
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xe0) << 10);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 323 to 339
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xf0) << 11);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 340 to 356
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf8) << 12);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 357 to 373
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xfc) << 13);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 374 to 390
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfe) << 14);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 391 to 407
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 408 to 424
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)(input[53] & 0x80) << 8);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 425 to 441
	value = ((uint32_t)(input[53] & 0x7f) << 25) |
			((uint32_t)input[54] << 17) |
			((uint32_t)(input[55] & 0xc0) << 9);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 442 to 458
	value = ((uint32_t)(input[55] & 0x3f) << 26) |
			((uint32_t)input[56] << 18) |
			((uint32_t)(input[57] & 0xe0) << 10);
	output[26] = (double)(value >> 15);
}

static void unpack_27_17bit_unsigned_0off(const uint8_t * input, double * output) {
	// Unpack 27 values into output
	// Values are 17-bit unsigned
	// Skip 0 bits, read 459 bits of data.
	// Input must be at least 58 bytes long

	uint32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 51 to 67
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xf0) << 11);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 68 to 84
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf8) << 12);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 85 to 101
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xfc) << 13);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 102 to 118
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfe) << 14);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 119 to 135
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)input[16] << 15);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 136 to 152
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)input[18] << 16) |
			((uint32_t)(input[19] & 0x80) << 8);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 153 to 169
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xc0) << 9);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 170 to 186
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xe0) << 10);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 187 to 203
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)input[24] << 19) |
			((uint32_t)(input[25] & 0xf0) << 11);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 204 to 220
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20) |
			((uint32_t)(input[27] & 0xf8) << 12);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 221 to 237
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0xfc) << 13);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 238 to 254
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)(input[31] & 0xfe) << 14);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 255 to 271
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)input[33] << 15);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 272 to 288
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16) |
			((uint32_t)(input[36] & 0x80) << 8);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 289 to 305
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0xc0) << 9);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 306 to 322
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xe0) << 10);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 323 to 339
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xf0) << 11);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 340 to 356
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf8) << 12);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 357 to 373
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xfc) << 13);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 374 to 390
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfe) << 14);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 391 to 407
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 408 to 424
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)(input[53] & 0x80) << 8);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 425 to 441
	value = ((uint32_t)(input[53] & 0x7f) << 25) |
			((uint32_t)input[54] << 17) |
			((uint32_t)(input[55] & 0xc0) << 9);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 442 to 458
	value = ((uint32_t)(input[55] & 0x3f) << 26) |
			((uint32_t)input[56] << 18) |
			((uint32_t)(input[57] & 0xe0) << 10);
	output[26] = (double)(value >> 15);
}

static void unpack_27_17bit_signed_1off(const uint8_t * input, double * output) {
	// Unpack 27 values into output
	// Values are 17-bit signed
	// Skip 1 bits, read 459 bits of data.
	// Input must be at least 58 bytes long

	int32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 52 to 68
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf8) << 12);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 69 to 85
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xfc) << 13);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 86 to 102
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfe) << 14);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 103 to 119
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 120 to 136
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)(input[17] & 0x80) << 8);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 137 to 153
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)input[18] << 17) |
			((uint32_t)(input[19] & 0xc0) << 9);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 154 to 170
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xe0) << 10);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 171 to 187
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)(input[23] & 0xf0) << 11);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 188 to 204
	value = ((uint32_t)(input[23] & 0x0f) << 28) |
			((uint32_t)input[24] << 20) |
			((uint32_t)(input[25] & 0xf8) << 12);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 205 to 221
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0xfc) << 13);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 222 to 238
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xfe) << 14);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 239 to 255
	value = ((uint32_t)(input[29] & 0x01) << 31) |
			((uint32_t)input[30] << 23) |
			((uint32_t)input[31] << 15);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 256 to 272
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16) |
			((uint32_t)(input[34] & 0x80) << 8);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 273 to 289
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0xc0) << 9);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 290 to 306
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xe0) << 10);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 307 to 323
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xf0) << 11);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 324 to 340
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf8) << 12);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 341 to 357
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xfc) << 13);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 358 to 374
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfe) << 14);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 375 to 391
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)input[48] << 15);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 392 to 408
	value = ((uint32_t)input[49] << 24) |
			((uint32_t)input[50] << 16) |
			((uint32_t)(input[51] & 0x80) << 8);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 409 to 425
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)(input[53] & 0xc0) << 9);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 426 to 442
	value = ((uint32_t)(input[53] & 0x3f) << 26) |
			((uint32_t)input[54] << 18) |
			((uint32_t)(input[55] & 0xe0) << 10);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 443 to 459
	value = ((uint32_t)(input[55] & 0x1f) << 27) |
			((uint32_t)input[56] << 19) |
			((uint32_t)(input[57] & 0xf0) << 11);
	output[26] = (double)(value >> 15);
}

static void unpack_27_17bit_unsigned_1off(const uint8_t * input, double * output) {
	// Unpack 27 values into output
	// Values are 17-bit unsigned
	// Skip 1 bits, read 459 bits of data.
	// Input must be at least 58 bytes long

	uint32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 52 to 68
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf8) << 12);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 69 to 85
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xfc) << 13);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 86 to 102
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfe) << 14);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 103 to 119
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 120 to 136
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)(input[17] & 0x80) << 8);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 137 to 153
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)input[18] << 17) |
			((uint32_t)(input[19] & 0xc0) << 9);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 154 to 170
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xe0) << 10);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 171 to 187
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)(input[23] & 0xf0) << 11);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 188 to 204
	value = ((uint32_t)(input[23] & 0x0f) << 28) |
			((uint32_t)input[24] << 20) |
			((uint32_t)(input[25] & 0xf8) << 12);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 205 to 221
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0xfc) << 13);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 222 to 238
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xfe) << 14);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 239 to 255
	value = ((uint32_t)(input[29] & 0x01) << 31) |
			((uint32_t)input[30] << 23) |
			((uint32_t)input[31] << 15);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 256 to 272
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16) |
			((uint32_t)(input[34] & 0x80) << 8);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 273 to 289
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0xc0) << 9);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 290 to 306
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xe0) << 10);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 307 to 323
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xf0) << 11);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 324 to 340
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf8) << 12);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 341 to 357
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xfc) << 13);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 358 to 374
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfe) << 14);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 375 to 391
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)input[48] << 15);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 392 to 408
	value = ((uint32_t)input[49] << 24) |
			((uint32_t)input[50] << 16) |
			((uint32_t)(input[51] & 0x80) << 8);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 409 to 425
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)(input[53] & 0xc0) << 9);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 426 to 442
	value = ((uint32_t)(input[53] & 0x3f) << 26) |
			((uint32_t)input[54] << 18) |
			((uint32_t)(input[55] & 0xe0) << 10);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 443 to 459
	value = ((uint32_t)(input[55] & 0x1f) << 27) |
			((uint32_t)input[56] << 19) |
			((uint32_t)(input[57] & 0xf0) << 11);
	output[26] = (double)(value >> 15);
}

static void unpack_27_17bit_signed_2off(const uint8_t * input, double * output) {
	// Unpack 27 values into output
	// Values are 17-bit signed
	// Skip 2 bits, read 459 bits of data.
	// Input must be at least 58 bytes long

	int32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 53 to 69
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xfc) << 13);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 70 to 86
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfe) << 14);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 87 to 103
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 104 to 120
	value = ((uint32_t)input[13] << 24) |
			((uint32_t)input[14] << 16) |
			((uint32_t)(input[15] & 0x80) << 8);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 121 to 137
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)(input[17] & 0xc0) << 9);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 138 to 154
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)input[18] << 18) |
			((uint32_t)(input[19] & 0xe0) << 10);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 155 to 171
	value = ((uint32_t)(input[19] & 0x1f) << 27) |
			((uint32_t)input[20] << 19) |
			((uint32_t)(input[21] & 0xf0) << 11);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 172 to 188
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)(input[23] & 0xf8) << 12);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 189 to 205
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)(input[25] & 0xfc) << 13);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 206 to 222
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xfe) << 14);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 223 to 239
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 240 to 256
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)(input[32] & 0x80) << 8);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 257 to 273
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0xc0) << 9);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 274 to 290
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xe0) << 10);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 291 to 307
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xf0) << 11);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 308 to 324
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf8) << 12);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 325 to 341
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xfc) << 13);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 342 to 358
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfe) << 14);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 359 to 375
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)input[46] << 15);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 376 to 392
	value = ((uint32_t)input[47] << 24) |
			((uint32_t)input[48] << 16) |
			((uint32_t)(input[49] & 0x80) << 8);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 393 to 409
	value = ((uint32_t)(input[49] & 0x7f) << 25) |
			((uint32_t)input[50] << 17) |
			((uint32_t)(input[51] & 0xc0) << 9);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 410 to 426
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)(input[53] & 0xe0) << 10);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 427 to 443
	value = ((uint32_t)(input[53] & 0x1f) << 27) |
			((uint32_t)input[54] << 19) |
			((uint32_t)(input[55] & 0xf0) << 11);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 444 to 460
	value = ((uint32_t)(input[55] & 0x0f) << 28) |
			((uint32_t)input[56] << 20) |
			((uint32_t)(input[57] & 0xf8) << 12);
	output[26] = (double)(value >> 15);
}

static void unpack_27_17bit_unsigned_2off(const uint8_t * input, double * output) {
	// Unpack 27 values into output
	// Values are 17-bit unsigned
	// Skip 2 bits, read 459 bits of data.
	// Input must be at least 58 bytes long

	uint32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 53 to 69
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xfc) << 13);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 70 to 86
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfe) << 14);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 87 to 103
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 104 to 120
	value = ((uint32_t)input[13] << 24) |
			((uint32_t)input[14] << 16) |
			((uint32_t)(input[15] & 0x80) << 8);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 121 to 137
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)(input[17] & 0xc0) << 9);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 138 to 154
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)input[18] << 18) |
			((uint32_t)(input[19] & 0xe0) << 10);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 155 to 171
	value = ((uint32_t)(input[19] & 0x1f) << 27) |
			((uint32_t)input[20] << 19) |
			((uint32_t)(input[21] & 0xf0) << 11);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 172 to 188
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)(input[23] & 0xf8) << 12);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 189 to 205
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)(input[25] & 0xfc) << 13);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 206 to 222
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xfe) << 14);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 223 to 239
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 240 to 256
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)(input[32] & 0x80) << 8);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 257 to 273
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0xc0) << 9);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 274 to 290
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xe0) << 10);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 291 to 307
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xf0) << 11);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 308 to 324
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf8) << 12);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 325 to 341
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xfc) << 13);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 342 to 358
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfe) << 14);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 359 to 375
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)input[46] << 15);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 376 to 392
	value = ((uint32_t)input[47] << 24) |
			((uint32_t)input[48] << 16) |
			((uint32_t)(input[49] & 0x80) << 8);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 393 to 409
	value = ((uint32_t)(input[49] & 0x7f) << 25) |
			((uint32_t)input[50] << 17) |
			((uint32_t)(input[51] & 0xc0) << 9);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 410 to 426
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)(input[53] & 0xe0) << 10);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 427 to 443
	value = ((uint32_t)(input[53] & 0x1f) << 27) |
			((uint32_t)input[54] << 19) |
			((uint32_t)(input[55] & 0xf0) << 11);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 444 to 460
	value = ((uint32_t)(input[55] & 0x0f) << 28) |
			((uint32_t)input[56] << 20) |
			((uint32_t)(input[57] & 0xf8) << 12);
	output[26] = (double)(value >> 15);
}

static void unpack_27_17bit_signed_3off(const uint8_t * input, double * output) {
	// Unpack 27 values into output
	// Values are 17-bit signed
	// Skip 3 bits, read 459 bits of data.
	// Input must be at least 58 bytes long

	int32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 54 to 70
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfe) << 14);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 71 to 87
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)input[10] << 15);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 88 to 104
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0x80) << 8);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 105 to 121
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xc0) << 9);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 122 to 138
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)(input[17] & 0xe0) << 10);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 139 to 155
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)input[18] << 19) |
			((uint32_t)(input[19] & 0xf0) << 11);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 156 to 172
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20) |
			((uint32_t)(input[21] & 0xf8) << 12);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 173 to 189
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0xfc) << 13);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 190 to 206
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)(input[25] & 0xfe) << 14);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 207 to 223
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)input[27] << 15);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 224 to 240
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16) |
			((uint32_t)(input[30] & 0x80) << 8);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 241 to 257
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0xc0) << 9);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 258 to 274
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xe0) << 10);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 275 to 291
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xf0) << 11);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 292 to 308
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf8) << 12);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 309 to 325
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xfc) << 13);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 326 to 342
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfe) << 14);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 343 to 359
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 360 to 376
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)(input[47] & 0x80) << 8);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 377 to 393
	value = ((uint32_t)(input[47] & 0x7f) << 25) |
			((uint32_t)input[48] << 17) |
			((uint32_t)(input[49] & 0xc0) << 9);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 394 to 410
	value = ((uint32_t)(input[49] & 0x3f) << 26) |
			((uint32_t)input[50] << 18) |
			((uint32_t)(input[51] & 0xe0) << 10);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 411 to 427
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)(input[53] & 0xf0) << 11);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 428 to 444
	value = ((uint32_t)(input[53] & 0x0f) << 28) |
			((uint32_t)input[54] << 20) |
			((uint32_t)(input[55] & 0xf8) << 12);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 445 to 461
	value = ((uint32_t)(input[55] & 0x07) << 29) |
			((uint32_t)input[56] << 21) |
			((uint32_t)(input[57] & 0xfc) << 13);
	output[26] = (double)(value >> 15);
}

static void unpack_27_17bit_unsigned_3off(const uint8_t * input, double * output) {
	// Unpack 27 values into output
	// Values are 17-bit unsigned
	// Skip 3 bits, read 459 bits of data.
	// Input must be at least 58 bytes long

	uint32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 54 to 70
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfe) << 14);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 71 to 87
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)input[10] << 15);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 88 to 104
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0x80) << 8);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 105 to 121
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xc0) << 9);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 122 to 138
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)(input[17] & 0xe0) << 10);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 139 to 155
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)input[18] << 19) |
			((uint32_t)(input[19] & 0xf0) << 11);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 156 to 172
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20) |
			((uint32_t)(input[21] & 0xf8) << 12);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 173 to 189
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0xfc) << 13);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 190 to 206
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)(input[25] & 0xfe) << 14);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 207 to 223
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)input[27] << 15);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 224 to 240
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16) |
			((uint32_t)(input[30] & 0x80) << 8);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 241 to 257
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0xc0) << 9);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 258 to 274
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xe0) << 10);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 275 to 291
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xf0) << 11);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 292 to 308
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf8) << 12);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 309 to 325
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xfc) << 13);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 326 to 342
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfe) << 14);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 343 to 359
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 360 to 376
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)(input[47] & 0x80) << 8);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 377 to 393
	value = ((uint32_t)(input[47] & 0x7f) << 25) |
			((uint32_t)input[48] << 17) |
			((uint32_t)(input[49] & 0xc0) << 9);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 394 to 410
	value = ((uint32_t)(input[49] & 0x3f) << 26) |
			((uint32_t)input[50] << 18) |
			((uint32_t)(input[51] & 0xe0) << 10);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 411 to 427
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)(input[53] & 0xf0) << 11);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 428 to 444
	value = ((uint32_t)(input[53] & 0x0f) << 28) |
			((uint32_t)input[54] << 20) |
			((uint32_t)(input[55] & 0xf8) << 12);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 445 to 461
	value = ((uint32_t)(input[55] & 0x07) << 29) |
			((uint32_t)input[56] << 21) |
			((uint32_t)(input[57] & 0xfc) << 13);
	output[26] = (double)(value >> 15);
}

static void unpack_27_17bit_signed_4off(const uint8_t * input, double * output) {
	// Unpack 27 values into output
	// Values are 17-bit signed
	// Skip 4 bits, read 459 bits of data.
	// Input must be at least 58 bytes long

	int32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 55 to 71
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 72 to 88
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)(input[11] & 0x80) << 8);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 89 to 105
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xc0) << 9);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 106 to 122
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xe0) << 10);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 123 to 139
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)(input[17] & 0xf0) << 11);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 140 to 156
	value = ((uint32_t)(input[17] & 0x0f) << 28) |
			((uint32_t)input[18] << 20) |
			((uint32_t)(input[19] & 0xf8) << 12);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 157 to 173
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0xfc) << 13);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 174 to 190
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xfe) << 14);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 191 to 207
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 208 to 224
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16) |
			((uint32_t)(input[28] & 0x80) << 8);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 225 to 241
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0xc0) << 9);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 242 to 258
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xe0) << 10);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 259 to 275
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xf0) << 11);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 276 to 292
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf8) << 12);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 293 to 309
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xfc) << 13);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 310 to 326
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfe) << 14);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 327 to 343
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)input[42] << 15);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 344 to 360
	value = ((uint32_t)input[43] << 24) |
			((uint32_t)input[44] << 16) |
			((uint32_t)(input[45] & 0x80) << 8);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 361 to 377
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)(input[47] & 0xc0) << 9);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 378 to 394
	value = ((uint32_t)(input[47] & 0x3f) << 26) |
			((uint32_t)input[48] << 18) |
			((uint32_t)(input[49] & 0xe0) << 10);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 395 to 411
	value = ((uint32_t)(input[49] & 0x1f) << 27) |
			((uint32_t)input[50] << 19) |
			((uint32_t)(input[51] & 0xf0) << 11);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 412 to 428
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)(input[53] & 0xf8) << 12);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 429 to 445
	value = ((uint32_t)(input[53] & 0x07) << 29) |
			((uint32_t)input[54] << 21) |
			((uint32_t)(input[55] & 0xfc) << 13);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 446 to 462
	value = ((uint32_t)(input[55] & 0x03) << 30) |
			((uint32_t)input[56] << 22) |
			((uint32_t)(input[57] & 0xfe) << 14);
	output[26] = (double)(value >> 15);
}

static void unpack_27_17bit_unsigned_4off(const uint8_t * input, double * output) {
	// Unpack 27 values into output
	// Values are 17-bit unsigned
	// Skip 4 bits, read 459 bits of data.
	// Input must be at least 58 bytes long

	uint32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 55 to 71
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 72 to 88
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)(input[11] & 0x80) << 8);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 89 to 105
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xc0) << 9);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 106 to 122
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xe0) << 10);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 123 to 139
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)(input[17] & 0xf0) << 11);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 140 to 156
	value = ((uint32_t)(input[17] & 0x0f) << 28) |
			((uint32_t)input[18] << 20) |
			((uint32_t)(input[19] & 0xf8) << 12);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 157 to 173
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0xfc) << 13);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 174 to 190
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xfe) << 14);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 191 to 207
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 208 to 224
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16) |
			((uint32_t)(input[28] & 0x80) << 8);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 225 to 241
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0xc0) << 9);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 242 to 258
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xe0) << 10);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 259 to 275
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xf0) << 11);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 276 to 292
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf8) << 12);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 293 to 309
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xfc) << 13);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 310 to 326
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfe) << 14);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 327 to 343
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)input[42] << 15);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 344 to 360
	value = ((uint32_t)input[43] << 24) |
			((uint32_t)input[44] << 16) |
			((uint32_t)(input[45] & 0x80) << 8);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 361 to 377
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)(input[47] & 0xc0) << 9);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 378 to 394
	value = ((uint32_t)(input[47] & 0x3f) << 26) |
			((uint32_t)input[48] << 18) |
			((uint32_t)(input[49] & 0xe0) << 10);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 395 to 411
	value = ((uint32_t)(input[49] & 0x1f) << 27) |
			((uint32_t)input[50] << 19) |
			((uint32_t)(input[51] & 0xf0) << 11);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 412 to 428
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)(input[53] & 0xf8) << 12);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 429 to 445
	value = ((uint32_t)(input[53] & 0x07) << 29) |
			((uint32_t)input[54] << 21) |
			((uint32_t)(input[55] & 0xfc) << 13);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 446 to 462
	value = ((uint32_t)(input[55] & 0x03) << 30) |
			((uint32_t)input[56] << 22) |
			((uint32_t)(input[57] & 0xfe) << 14);
	output[26] = (double)(value >> 15);
}

static void unpack_27_17bit_signed_5off(const uint8_t * input, double * output) {
	// Unpack 27 values into output
	// Values are 17-bit signed
	// Skip 5 bits, read 459 bits of data.
	// Input must be at least 58 bytes long

	int32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 56 to 72
	value = ((uint32_t)input[7] << 24) |
			((uint32_t)input[8] << 16) |
			((uint32_t)(input[9] & 0x80) << 8);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 73 to 89
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)(input[11] & 0xc0) << 9);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 90 to 106
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xe0) << 10);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 107 to 123
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)(input[15] & 0xf0) << 11);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 124 to 140
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)(input[17] & 0xf8) << 12);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 141 to 157
	value = ((uint32_t)(input[17] & 0x07) << 29) |
			((uint32_t)input[18] << 21) |
			((uint32_t)(input[19] & 0xfc) << 13);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 158 to 174
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xfe) << 14);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 175 to 191
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 192 to 208
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0x80) << 8);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 209 to 225
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0xc0) << 9);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 226 to 242
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xe0) << 10);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 243 to 259
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xf0) << 11);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 260 to 276
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf8) << 12);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 277 to 293
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xfc) << 13);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 294 to 310
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfe) << 14);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 311 to 327
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)input[40] << 15);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 328 to 344
	value = ((uint32_t)input[41] << 24) |
			((uint32_t)input[42] << 16) |
			((uint32_t)(input[43] & 0x80) << 8);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 345 to 361
	value = ((uint32_t)(input[43] & 0x7f) << 25) |
			((uint32_t)input[44] << 17) |
			((uint32_t)(input[45] & 0xc0) << 9);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 362 to 378
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)(input[47] & 0xe0) << 10);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 379 to 395
	value = ((uint32_t)(input[47] & 0x1f) << 27) |
			((uint32_t)input[48] << 19) |
			((uint32_t)(input[49] & 0xf0) << 11);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 396 to 412
	value = ((uint32_t)(input[49] & 0x0f) << 28) |
			((uint32_t)input[50] << 20) |
			((uint32_t)(input[51] & 0xf8) << 12);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 413 to 429
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)(input[53] & 0xfc) << 13);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 430 to 446
	value = ((uint32_t)(input[53] & 0x03) << 30) |
			((uint32_t)input[54] << 22) |
			((uint32_t)(input[55] & 0xfe) << 14);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 447 to 463
	value = ((uint32_t)(input[55] & 0x01) << 31) |
			((uint32_t)input[56] << 23) |
			((uint32_t)input[57] << 15);
	output[26] = (double)(value >> 15);
}

static void unpack_27_17bit_unsigned_5off(const uint8_t * input, double * output) {
	// Unpack 27 values into output
	// Values are 17-bit unsigned
	// Skip 5 bits, read 459 bits of data.
	// Input must be at least 58 bytes long

	uint32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 56 to 72
	value = ((uint32_t)input[7] << 24) |
			((uint32_t)input[8] << 16) |
			((uint32_t)(input[9] & 0x80) << 8);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 73 to 89
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)(input[11] & 0xc0) << 9);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 90 to 106
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xe0) << 10);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 107 to 123
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)(input[15] & 0xf0) << 11);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 124 to 140
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)(input[17] & 0xf8) << 12);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 141 to 157
	value = ((uint32_t)(input[17] & 0x07) << 29) |
			((uint32_t)input[18] << 21) |
			((uint32_t)(input[19] & 0xfc) << 13);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 158 to 174
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xfe) << 14);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 175 to 191
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 192 to 208
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0x80) << 8);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 209 to 225
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0xc0) << 9);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 226 to 242
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xe0) << 10);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 243 to 259
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xf0) << 11);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 260 to 276
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf8) << 12);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 277 to 293
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xfc) << 13);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 294 to 310
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfe) << 14);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 311 to 327
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)input[40] << 15);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 328 to 344
	value = ((uint32_t)input[41] << 24) |
			((uint32_t)input[42] << 16) |
			((uint32_t)(input[43] & 0x80) << 8);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 345 to 361
	value = ((uint32_t)(input[43] & 0x7f) << 25) |
			((uint32_t)input[44] << 17) |
			((uint32_t)(input[45] & 0xc0) << 9);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 362 to 378
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)(input[47] & 0xe0) << 10);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 379 to 395
	value = ((uint32_t)(input[47] & 0x1f) << 27) |
			((uint32_t)input[48] << 19) |
			((uint32_t)(input[49] & 0xf0) << 11);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 396 to 412
	value = ((uint32_t)(input[49] & 0x0f) << 28) |
			((uint32_t)input[50] << 20) |
			((uint32_t)(input[51] & 0xf8) << 12);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 413 to 429
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)(input[53] & 0xfc) << 13);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 430 to 446
	value = ((uint32_t)(input[53] & 0x03) << 30) |
			((uint32_t)input[54] << 22) |
			((uint32_t)(input[55] & 0xfe) << 14);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 447 to 463
	value = ((uint32_t)(input[55] & 0x01) << 31) |
			((uint32_t)input[56] << 23) |
			((uint32_t)input[57] << 15);
	output[26] = (double)(value >> 15);
}

static void unpack_27_17bit_signed_6off(const uint8_t * input, double * output) {
	// Unpack 27 values into output
	// Values are 17-bit signed
	// Skip 6 bits, read 459 bits of data.
	// Input must be at least 59 bytes long

	int32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 57 to 73
	value = ((uint32_t)(input[7] & 0x7f) << 25) |
			((uint32_t)input[8] << 17) |
			((uint32_t)(input[9] & 0xc0) << 9);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 74 to 90
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)(input[11] & 0xe0) << 10);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 91 to 107
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)(input[13] & 0xf0) << 11);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 108 to 124
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)(input[15] & 0xf8) << 12);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 125 to 141
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0xfc) << 13);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 142 to 158
	value = ((uint32_t)(input[17] & 0x03) << 30) |
			((uint32_t)input[18] << 22) |
			((uint32_t)(input[19] & 0xfe) << 14);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 159 to 175
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)input[21] << 15);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 176 to 192
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16) |
			((uint32_t)(input[24] & 0x80) << 8);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 193 to 209
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xc0) << 9);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 210 to 226
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xe0) << 10);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 227 to 243
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xf0) << 11);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 244 to 260
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf8) << 12);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 261 to 277
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xfc) << 13);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 278 to 294
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfe) << 14);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 295 to 311
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 312 to 328
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)(input[41] & 0x80) << 8);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 329 to 345
	value = ((uint32_t)(input[41] & 0x7f) << 25) |
			((uint32_t)input[42] << 17) |
			((uint32_t)(input[43] & 0xc0) << 9);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 346 to 362
	value = ((uint32_t)(input[43] & 0x3f) << 26) |
			((uint32_t)input[44] << 18) |
			((uint32_t)(input[45] & 0xe0) << 10);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 363 to 379
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)(input[47] & 0xf0) << 11);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 380 to 396
	value = ((uint32_t)(input[47] & 0x0f) << 28) |
			((uint32_t)input[48] << 20) |
			((uint32_t)(input[49] & 0xf8) << 12);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 397 to 413
	value = ((uint32_t)(input[49] & 0x07) << 29) |
			((uint32_t)input[50] << 21) |
			((uint32_t)(input[51] & 0xfc) << 13);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 414 to 430
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)(input[53] & 0xfe) << 14);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 431 to 447
	value = ((uint32_t)(input[53] & 0x01) << 31) |
			((uint32_t)input[54] << 23) |
			((uint32_t)input[55] << 15);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 448 to 464
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16) |
			((uint32_t)(input[58] & 0x80) << 8);
	output[26] = (double)(value >> 15);
}

static void unpack_27_17bit_unsigned_6off(const uint8_t * input, double * output) {
	// Unpack 27 values into output
	// Values are 17-bit unsigned
	// Skip 6 bits, read 459 bits of data.
	// Input must be at least 59 bytes long

	uint32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 57 to 73
	value = ((uint32_t)(input[7] & 0x7f) << 25) |
			((uint32_t)input[8] << 17) |
			((uint32_t)(input[9] & 0xc0) << 9);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 74 to 90
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)(input[11] & 0xe0) << 10);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 91 to 107
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)(input[13] & 0xf0) << 11);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 108 to 124
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)(input[15] & 0xf8) << 12);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 125 to 141
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0xfc) << 13);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 142 to 158
	value = ((uint32_t)(input[17] & 0x03) << 30) |
			((uint32_t)input[18] << 22) |
			((uint32_t)(input[19] & 0xfe) << 14);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 159 to 175
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)input[21] << 15);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 176 to 192
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16) |
			((uint32_t)(input[24] & 0x80) << 8);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 193 to 209
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xc0) << 9);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 210 to 226
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xe0) << 10);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 227 to 243
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xf0) << 11);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 244 to 260
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf8) << 12);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 261 to 277
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xfc) << 13);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 278 to 294
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfe) << 14);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 295 to 311
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 312 to 328
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)(input[41] & 0x80) << 8);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 329 to 345
	value = ((uint32_t)(input[41] & 0x7f) << 25) |
			((uint32_t)input[42] << 17) |
			((uint32_t)(input[43] & 0xc0) << 9);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 346 to 362
	value = ((uint32_t)(input[43] & 0x3f) << 26) |
			((uint32_t)input[44] << 18) |
			((uint32_t)(input[45] & 0xe0) << 10);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 363 to 379
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)(input[47] & 0xf0) << 11);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 380 to 396
	value = ((uint32_t)(input[47] & 0x0f) << 28) |
			((uint32_t)input[48] << 20) |
			((uint32_t)(input[49] & 0xf8) << 12);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 397 to 413
	value = ((uint32_t)(input[49] & 0x07) << 29) |
			((uint32_t)input[50] << 21) |
			((uint32_t)(input[51] & 0xfc) << 13);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 414 to 430
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)(input[53] & 0xfe) << 14);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 431 to 447
	value = ((uint32_t)(input[53] & 0x01) << 31) |
			((uint32_t)input[54] << 23) |
			((uint32_t)input[55] << 15);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 448 to 464
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16) |
			((uint32_t)(input[58] & 0x80) << 8);
	output[26] = (double)(value >> 15);
}

static void unpack_27_17bit_signed_7off(const uint8_t * input, double * output) {
	// Unpack 27 values into output
	// Values are 17-bit signed
	// Skip 7 bits, read 459 bits of data.
	// Input must be at least 59 bytes long

	int32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 58 to 74
	value = ((uint32_t)(input[7] & 0x3f) << 26) |
			((uint32_t)input[8] << 18) |
			((uint32_t)(input[9] & 0xe0) << 10);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 75 to 91
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)(input[11] & 0xf0) << 11);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 92 to 108
	value = ((uint32_t)(input[11] & 0x0f) << 28) |
			((uint32_t)input[12] << 20) |
			((uint32_t)(input[13] & 0xf8) << 12);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 109 to 125
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0xfc) << 13);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 126 to 142
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xfe) << 14);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 143 to 159
	value = ((uint32_t)(input[17] & 0x01) << 31) |
			((uint32_t)input[18] << 23) |
			((uint32_t)input[19] << 15);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 160 to 176
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16) |
			((uint32_t)(input[22] & 0x80) << 8);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 177 to 193
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0xc0) << 9);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 194 to 210
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xe0) << 10);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 211 to 227
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xf0) << 11);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 228 to 244
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf8) << 12);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 245 to 261
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xfc) << 13);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 262 to 278
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfe) << 14);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 279 to 295
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)input[36] << 15);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 296 to 312
	value = ((uint32_t)input[37] << 24) |
			((uint32_t)input[38] << 16) |
			((uint32_t)(input[39] & 0x80) << 8);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 313 to 329
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)(input[41] & 0xc0) << 9);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 330 to 346
	value = ((uint32_t)(input[41] & 0x3f) << 26) |
			((uint32_t)input[42] << 18) |
			((uint32_t)(input[43] & 0xe0) << 10);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 347 to 363
	value = ((uint32_t)(input[43] & 0x1f) << 27) |
			((uint32_t)input[44] << 19) |
			((uint32_t)(input[45] & 0xf0) << 11);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 364 to 380
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)(input[47] & 0xf8) << 12);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 381 to 397
	value = ((uint32_t)(input[47] & 0x07) << 29) |
			((uint32_t)input[48] << 21) |
			((uint32_t)(input[49] & 0xfc) << 13);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 398 to 414
	value = ((uint32_t)(input[49] & 0x03) << 30) |
			((uint32_t)input[50] << 22) |
			((uint32_t)(input[51] & 0xfe) << 14);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 415 to 431
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 432 to 448
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)(input[56] & 0x80) << 8);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 449 to 465
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0xc0) << 9);
	output[26] = (double)(value >> 15);
}

static void unpack_27_17bit_unsigned_7off(const uint8_t * input, double * output) {
	// Unpack 27 values into output
	// Values are 17-bit unsigned
	// Skip 7 bits, read 459 bits of data.
	// Input must be at least 59 bytes long

	uint32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 58 to 74
	value = ((uint32_t)(input[7] & 0x3f) << 26) |
			((uint32_t)input[8] << 18) |
			((uint32_t)(input[9] & 0xe0) << 10);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 75 to 91
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)(input[11] & 0xf0) << 11);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 92 to 108
	value = ((uint32_t)(input[11] & 0x0f) << 28) |
			((uint32_t)input[12] << 20) |
			((uint32_t)(input[13] & 0xf8) << 12);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 109 to 125
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0xfc) << 13);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 126 to 142
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xfe) << 14);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 143 to 159
	value = ((uint32_t)(input[17] & 0x01) << 31) |
			((uint32_t)input[18] << 23) |
			((uint32_t)input[19] << 15);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 160 to 176
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16) |
			((uint32_t)(input[22] & 0x80) << 8);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 177 to 193
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0xc0) << 9);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 194 to 210
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xe0) << 10);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 211 to 227
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xf0) << 11);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 228 to 244
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf8) << 12);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 245 to 261
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xfc) << 13);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 262 to 278
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfe) << 14);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 279 to 295
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)input[36] << 15);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 296 to 312
	value = ((uint32_t)input[37] << 24) |
			((uint32_t)input[38] << 16) |
			((uint32_t)(input[39] & 0x80) << 8);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 313 to 329
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)(input[41] & 0xc0) << 9);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 330 to 346
	value = ((uint32_t)(input[41] & 0x3f) << 26) |
			((uint32_t)input[42] << 18) |
			((uint32_t)(input[43] & 0xe0) << 10);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 347 to 363
	value = ((uint32_t)(input[43] & 0x1f) << 27) |
			((uint32_t)input[44] << 19) |
			((uint32_t)(input[45] & 0xf0) << 11);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 364 to 380
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)(input[47] & 0xf8) << 12);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 381 to 397
	value = ((uint32_t)(input[47] & 0x07) << 29) |
			((uint32_t)input[48] << 21) |
			((uint32_t)(input[49] & 0xfc) << 13);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 398 to 414
	value = ((uint32_t)(input[49] & 0x03) << 30) |
			((uint32_t)input[50] << 22) |
			((uint32_t)(input[51] & 0xfe) << 14);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 415 to 431
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 432 to 448
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)(input[56] & 0x80) << 8);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 449 to 465
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0xc0) << 9);
	output[26] = (double)(value >> 15);
}

static void unpack_28_17bit_signed_0off(const uint8_t * input, double * output) {
	// Unpack 28 values into output
	// Values are 17-bit signed
	// Skip 0 bits, read 476 bits of data.
	// Input must be at least 60 bytes long

	int32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 51 to 67
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xf0) << 11);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 68 to 84
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf8) << 12);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 85 to 101
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xfc) << 13);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 102 to 118
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfe) << 14);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 119 to 135
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)input[16] << 15);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 136 to 152
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)input[18] << 16) |
			((uint32_t)(input[19] & 0x80) << 8);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 153 to 169
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xc0) << 9);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 170 to 186
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xe0) << 10);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 187 to 203
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)input[24] << 19) |
			((uint32_t)(input[25] & 0xf0) << 11);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 204 to 220
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20) |
			((uint32_t)(input[27] & 0xf8) << 12);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 221 to 237
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0xfc) << 13);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 238 to 254
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)(input[31] & 0xfe) << 14);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 255 to 271
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)input[33] << 15);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 272 to 288
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16) |
			((uint32_t)(input[36] & 0x80) << 8);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 289 to 305
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0xc0) << 9);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 306 to 322
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xe0) << 10);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 323 to 339
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xf0) << 11);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 340 to 356
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf8) << 12);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 357 to 373
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xfc) << 13);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 374 to 390
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfe) << 14);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 391 to 407
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 408 to 424
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)(input[53] & 0x80) << 8);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 425 to 441
	value = ((uint32_t)(input[53] & 0x7f) << 25) |
			((uint32_t)input[54] << 17) |
			((uint32_t)(input[55] & 0xc0) << 9);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 442 to 458
	value = ((uint32_t)(input[55] & 0x3f) << 26) |
			((uint32_t)input[56] << 18) |
			((uint32_t)(input[57] & 0xe0) << 10);
	output[26] = (double)(value >> 15);

	// read output[27]: from bit 459 to 475
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)input[58] << 19) |
			((uint32_t)(input[59] & 0xf0) << 11);
	output[27] = (double)(value >> 15);
}

static void unpack_28_17bit_unsigned_0off(const uint8_t * input, double * output) {
	// Unpack 28 values into output
	// Values are 17-bit unsigned
	// Skip 0 bits, read 476 bits of data.
	// Input must be at least 60 bytes long

	uint32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 51 to 67
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xf0) << 11);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 68 to 84
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf8) << 12);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 85 to 101
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xfc) << 13);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 102 to 118
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfe) << 14);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 119 to 135
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)input[16] << 15);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 136 to 152
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)input[18] << 16) |
			((uint32_t)(input[19] & 0x80) << 8);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 153 to 169
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xc0) << 9);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 170 to 186
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xe0) << 10);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 187 to 203
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)input[24] << 19) |
			((uint32_t)(input[25] & 0xf0) << 11);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 204 to 220
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20) |
			((uint32_t)(input[27] & 0xf8) << 12);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 221 to 237
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0xfc) << 13);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 238 to 254
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)(input[31] & 0xfe) << 14);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 255 to 271
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)input[33] << 15);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 272 to 288
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16) |
			((uint32_t)(input[36] & 0x80) << 8);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 289 to 305
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0xc0) << 9);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 306 to 322
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xe0) << 10);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 323 to 339
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xf0) << 11);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 340 to 356
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf8) << 12);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 357 to 373
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xfc) << 13);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 374 to 390
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfe) << 14);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 391 to 407
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 408 to 424
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)(input[53] & 0x80) << 8);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 425 to 441
	value = ((uint32_t)(input[53] & 0x7f) << 25) |
			((uint32_t)input[54] << 17) |
			((uint32_t)(input[55] & 0xc0) << 9);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 442 to 458
	value = ((uint32_t)(input[55] & 0x3f) << 26) |
			((uint32_t)input[56] << 18) |
			((uint32_t)(input[57] & 0xe0) << 10);
	output[26] = (double)(value >> 15);

	// read output[27]: from bit 459 to 475
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)input[58] << 19) |
			((uint32_t)(input[59] & 0xf0) << 11);
	output[27] = (double)(value >> 15);
}

static void unpack_28_17bit_signed_1off(const uint8_t * input, double * output) {
	// Unpack 28 values into output
	// Values are 17-bit signed
	// Skip 1 bits, read 476 bits of data.
	// Input must be at least 60 bytes long

	int32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 52 to 68
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf8) << 12);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 69 to 85
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xfc) << 13);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 86 to 102
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfe) << 14);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 103 to 119
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 120 to 136
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)(input[17] & 0x80) << 8);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 137 to 153
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)input[18] << 17) |
			((uint32_t)(input[19] & 0xc0) << 9);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 154 to 170
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xe0) << 10);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 171 to 187
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)(input[23] & 0xf0) << 11);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 188 to 204
	value = ((uint32_t)(input[23] & 0x0f) << 28) |
			((uint32_t)input[24] << 20) |
			((uint32_t)(input[25] & 0xf8) << 12);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 205 to 221
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0xfc) << 13);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 222 to 238
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xfe) << 14);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 239 to 255
	value = ((uint32_t)(input[29] & 0x01) << 31) |
			((uint32_t)input[30] << 23) |
			((uint32_t)input[31] << 15);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 256 to 272
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16) |
			((uint32_t)(input[34] & 0x80) << 8);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 273 to 289
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0xc0) << 9);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 290 to 306
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xe0) << 10);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 307 to 323
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xf0) << 11);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 324 to 340
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf8) << 12);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 341 to 357
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xfc) << 13);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 358 to 374
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfe) << 14);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 375 to 391
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)input[48] << 15);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 392 to 408
	value = ((uint32_t)input[49] << 24) |
			((uint32_t)input[50] << 16) |
			((uint32_t)(input[51] & 0x80) << 8);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 409 to 425
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)(input[53] & 0xc0) << 9);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 426 to 442
	value = ((uint32_t)(input[53] & 0x3f) << 26) |
			((uint32_t)input[54] << 18) |
			((uint32_t)(input[55] & 0xe0) << 10);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 443 to 459
	value = ((uint32_t)(input[55] & 0x1f) << 27) |
			((uint32_t)input[56] << 19) |
			((uint32_t)(input[57] & 0xf0) << 11);
	output[26] = (double)(value >> 15);

	// read output[27]: from bit 460 to 476
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20) |
			((uint32_t)(input[59] & 0xf8) << 12);
	output[27] = (double)(value >> 15);
}

static void unpack_28_17bit_unsigned_1off(const uint8_t * input, double * output) {
	// Unpack 28 values into output
	// Values are 17-bit unsigned
	// Skip 1 bits, read 476 bits of data.
	// Input must be at least 60 bytes long

	uint32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 52 to 68
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf8) << 12);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 69 to 85
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xfc) << 13);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 86 to 102
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfe) << 14);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 103 to 119
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 120 to 136
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)(input[17] & 0x80) << 8);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 137 to 153
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)input[18] << 17) |
			((uint32_t)(input[19] & 0xc0) << 9);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 154 to 170
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xe0) << 10);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 171 to 187
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)(input[23] & 0xf0) << 11);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 188 to 204
	value = ((uint32_t)(input[23] & 0x0f) << 28) |
			((uint32_t)input[24] << 20) |
			((uint32_t)(input[25] & 0xf8) << 12);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 205 to 221
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0xfc) << 13);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 222 to 238
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xfe) << 14);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 239 to 255
	value = ((uint32_t)(input[29] & 0x01) << 31) |
			((uint32_t)input[30] << 23) |
			((uint32_t)input[31] << 15);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 256 to 272
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16) |
			((uint32_t)(input[34] & 0x80) << 8);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 273 to 289
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0xc0) << 9);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 290 to 306
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xe0) << 10);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 307 to 323
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xf0) << 11);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 324 to 340
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf8) << 12);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 341 to 357
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xfc) << 13);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 358 to 374
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfe) << 14);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 375 to 391
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)input[48] << 15);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 392 to 408
	value = ((uint32_t)input[49] << 24) |
			((uint32_t)input[50] << 16) |
			((uint32_t)(input[51] & 0x80) << 8);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 409 to 425
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)(input[53] & 0xc0) << 9);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 426 to 442
	value = ((uint32_t)(input[53] & 0x3f) << 26) |
			((uint32_t)input[54] << 18) |
			((uint32_t)(input[55] & 0xe0) << 10);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 443 to 459
	value = ((uint32_t)(input[55] & 0x1f) << 27) |
			((uint32_t)input[56] << 19) |
			((uint32_t)(input[57] & 0xf0) << 11);
	output[26] = (double)(value >> 15);

	// read output[27]: from bit 460 to 476
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20) |
			((uint32_t)(input[59] & 0xf8) << 12);
	output[27] = (double)(value >> 15);
}

static void unpack_28_17bit_signed_2off(const uint8_t * input, double * output) {
	// Unpack 28 values into output
	// Values are 17-bit signed
	// Skip 2 bits, read 476 bits of data.
	// Input must be at least 60 bytes long

	int32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 53 to 69
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xfc) << 13);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 70 to 86
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfe) << 14);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 87 to 103
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 104 to 120
	value = ((uint32_t)input[13] << 24) |
			((uint32_t)input[14] << 16) |
			((uint32_t)(input[15] & 0x80) << 8);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 121 to 137
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)(input[17] & 0xc0) << 9);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 138 to 154
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)input[18] << 18) |
			((uint32_t)(input[19] & 0xe0) << 10);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 155 to 171
	value = ((uint32_t)(input[19] & 0x1f) << 27) |
			((uint32_t)input[20] << 19) |
			((uint32_t)(input[21] & 0xf0) << 11);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 172 to 188
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)(input[23] & 0xf8) << 12);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 189 to 205
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)(input[25] & 0xfc) << 13);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 206 to 222
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xfe) << 14);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 223 to 239
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 240 to 256
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)(input[32] & 0x80) << 8);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 257 to 273
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0xc0) << 9);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 274 to 290
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xe0) << 10);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 291 to 307
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xf0) << 11);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 308 to 324
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf8) << 12);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 325 to 341
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xfc) << 13);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 342 to 358
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfe) << 14);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 359 to 375
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)input[46] << 15);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 376 to 392
	value = ((uint32_t)input[47] << 24) |
			((uint32_t)input[48] << 16) |
			((uint32_t)(input[49] & 0x80) << 8);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 393 to 409
	value = ((uint32_t)(input[49] & 0x7f) << 25) |
			((uint32_t)input[50] << 17) |
			((uint32_t)(input[51] & 0xc0) << 9);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 410 to 426
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)(input[53] & 0xe0) << 10);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 427 to 443
	value = ((uint32_t)(input[53] & 0x1f) << 27) |
			((uint32_t)input[54] << 19) |
			((uint32_t)(input[55] & 0xf0) << 11);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 444 to 460
	value = ((uint32_t)(input[55] & 0x0f) << 28) |
			((uint32_t)input[56] << 20) |
			((uint32_t)(input[57] & 0xf8) << 12);
	output[26] = (double)(value >> 15);

	// read output[27]: from bit 461 to 477
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)(input[59] & 0xfc) << 13);
	output[27] = (double)(value >> 15);
}

static void unpack_28_17bit_unsigned_2off(const uint8_t * input, double * output) {
	// Unpack 28 values into output
	// Values are 17-bit unsigned
	// Skip 2 bits, read 476 bits of data.
	// Input must be at least 60 bytes long

	uint32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 53 to 69
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xfc) << 13);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 70 to 86
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfe) << 14);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 87 to 103
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 104 to 120
	value = ((uint32_t)input[13] << 24) |
			((uint32_t)input[14] << 16) |
			((uint32_t)(input[15] & 0x80) << 8);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 121 to 137
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)(input[17] & 0xc0) << 9);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 138 to 154
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)input[18] << 18) |
			((uint32_t)(input[19] & 0xe0) << 10);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 155 to 171
	value = ((uint32_t)(input[19] & 0x1f) << 27) |
			((uint32_t)input[20] << 19) |
			((uint32_t)(input[21] & 0xf0) << 11);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 172 to 188
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)(input[23] & 0xf8) << 12);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 189 to 205
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)(input[25] & 0xfc) << 13);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 206 to 222
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xfe) << 14);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 223 to 239
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 240 to 256
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)(input[32] & 0x80) << 8);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 257 to 273
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0xc0) << 9);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 274 to 290
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xe0) << 10);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 291 to 307
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xf0) << 11);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 308 to 324
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf8) << 12);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 325 to 341
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xfc) << 13);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 342 to 358
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfe) << 14);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 359 to 375
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)input[46] << 15);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 376 to 392
	value = ((uint32_t)input[47] << 24) |
			((uint32_t)input[48] << 16) |
			((uint32_t)(input[49] & 0x80) << 8);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 393 to 409
	value = ((uint32_t)(input[49] & 0x7f) << 25) |
			((uint32_t)input[50] << 17) |
			((uint32_t)(input[51] & 0xc0) << 9);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 410 to 426
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)(input[53] & 0xe0) << 10);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 427 to 443
	value = ((uint32_t)(input[53] & 0x1f) << 27) |
			((uint32_t)input[54] << 19) |
			((uint32_t)(input[55] & 0xf0) << 11);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 444 to 460
	value = ((uint32_t)(input[55] & 0x0f) << 28) |
			((uint32_t)input[56] << 20) |
			((uint32_t)(input[57] & 0xf8) << 12);
	output[26] = (double)(value >> 15);

	// read output[27]: from bit 461 to 477
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)(input[59] & 0xfc) << 13);
	output[27] = (double)(value >> 15);
}

static void unpack_28_17bit_signed_3off(const uint8_t * input, double * output) {
	// Unpack 28 values into output
	// Values are 17-bit signed
	// Skip 3 bits, read 476 bits of data.
	// Input must be at least 60 bytes long

	int32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 54 to 70
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfe) << 14);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 71 to 87
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)input[10] << 15);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 88 to 104
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0x80) << 8);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 105 to 121
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xc0) << 9);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 122 to 138
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)(input[17] & 0xe0) << 10);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 139 to 155
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)input[18] << 19) |
			((uint32_t)(input[19] & 0xf0) << 11);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 156 to 172
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20) |
			((uint32_t)(input[21] & 0xf8) << 12);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 173 to 189
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0xfc) << 13);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 190 to 206
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)(input[25] & 0xfe) << 14);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 207 to 223
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)input[27] << 15);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 224 to 240
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16) |
			((uint32_t)(input[30] & 0x80) << 8);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 241 to 257
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0xc0) << 9);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 258 to 274
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xe0) << 10);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 275 to 291
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xf0) << 11);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 292 to 308
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf8) << 12);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 309 to 325
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xfc) << 13);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 326 to 342
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfe) << 14);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 343 to 359
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 360 to 376
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)(input[47] & 0x80) << 8);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 377 to 393
	value = ((uint32_t)(input[47] & 0x7f) << 25) |
			((uint32_t)input[48] << 17) |
			((uint32_t)(input[49] & 0xc0) << 9);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 394 to 410
	value = ((uint32_t)(input[49] & 0x3f) << 26) |
			((uint32_t)input[50] << 18) |
			((uint32_t)(input[51] & 0xe0) << 10);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 411 to 427
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)(input[53] & 0xf0) << 11);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 428 to 444
	value = ((uint32_t)(input[53] & 0x0f) << 28) |
			((uint32_t)input[54] << 20) |
			((uint32_t)(input[55] & 0xf8) << 12);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 445 to 461
	value = ((uint32_t)(input[55] & 0x07) << 29) |
			((uint32_t)input[56] << 21) |
			((uint32_t)(input[57] & 0xfc) << 13);
	output[26] = (double)(value >> 15);

	// read output[27]: from bit 462 to 478
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)(input[59] & 0xfe) << 14);
	output[27] = (double)(value >> 15);
}

static void unpack_28_17bit_unsigned_3off(const uint8_t * input, double * output) {
	// Unpack 28 values into output
	// Values are 17-bit unsigned
	// Skip 3 bits, read 476 bits of data.
	// Input must be at least 60 bytes long

	uint32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 54 to 70
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfe) << 14);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 71 to 87
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)input[10] << 15);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 88 to 104
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0x80) << 8);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 105 to 121
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xc0) << 9);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 122 to 138
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)(input[17] & 0xe0) << 10);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 139 to 155
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)input[18] << 19) |
			((uint32_t)(input[19] & 0xf0) << 11);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 156 to 172
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20) |
			((uint32_t)(input[21] & 0xf8) << 12);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 173 to 189
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0xfc) << 13);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 190 to 206
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)(input[25] & 0xfe) << 14);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 207 to 223
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)input[27] << 15);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 224 to 240
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16) |
			((uint32_t)(input[30] & 0x80) << 8);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 241 to 257
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0xc0) << 9);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 258 to 274
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xe0) << 10);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 275 to 291
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xf0) << 11);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 292 to 308
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf8) << 12);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 309 to 325
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xfc) << 13);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 326 to 342
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfe) << 14);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 343 to 359
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 360 to 376
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)(input[47] & 0x80) << 8);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 377 to 393
	value = ((uint32_t)(input[47] & 0x7f) << 25) |
			((uint32_t)input[48] << 17) |
			((uint32_t)(input[49] & 0xc0) << 9);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 394 to 410
	value = ((uint32_t)(input[49] & 0x3f) << 26) |
			((uint32_t)input[50] << 18) |
			((uint32_t)(input[51] & 0xe0) << 10);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 411 to 427
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)(input[53] & 0xf0) << 11);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 428 to 444
	value = ((uint32_t)(input[53] & 0x0f) << 28) |
			((uint32_t)input[54] << 20) |
			((uint32_t)(input[55] & 0xf8) << 12);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 445 to 461
	value = ((uint32_t)(input[55] & 0x07) << 29) |
			((uint32_t)input[56] << 21) |
			((uint32_t)(input[57] & 0xfc) << 13);
	output[26] = (double)(value >> 15);

	// read output[27]: from bit 462 to 478
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)(input[59] & 0xfe) << 14);
	output[27] = (double)(value >> 15);
}

static void unpack_28_17bit_signed_4off(const uint8_t * input, double * output) {
	// Unpack 28 values into output
	// Values are 17-bit signed
	// Skip 4 bits, read 476 bits of data.
	// Input must be at least 60 bytes long

	int32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 55 to 71
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 72 to 88
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)(input[11] & 0x80) << 8);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 89 to 105
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xc0) << 9);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 106 to 122
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xe0) << 10);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 123 to 139
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)(input[17] & 0xf0) << 11);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 140 to 156
	value = ((uint32_t)(input[17] & 0x0f) << 28) |
			((uint32_t)input[18] << 20) |
			((uint32_t)(input[19] & 0xf8) << 12);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 157 to 173
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0xfc) << 13);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 174 to 190
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xfe) << 14);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 191 to 207
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 208 to 224
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16) |
			((uint32_t)(input[28] & 0x80) << 8);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 225 to 241
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0xc0) << 9);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 242 to 258
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xe0) << 10);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 259 to 275
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xf0) << 11);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 276 to 292
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf8) << 12);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 293 to 309
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xfc) << 13);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 310 to 326
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfe) << 14);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 327 to 343
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)input[42] << 15);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 344 to 360
	value = ((uint32_t)input[43] << 24) |
			((uint32_t)input[44] << 16) |
			((uint32_t)(input[45] & 0x80) << 8);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 361 to 377
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)(input[47] & 0xc0) << 9);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 378 to 394
	value = ((uint32_t)(input[47] & 0x3f) << 26) |
			((uint32_t)input[48] << 18) |
			((uint32_t)(input[49] & 0xe0) << 10);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 395 to 411
	value = ((uint32_t)(input[49] & 0x1f) << 27) |
			((uint32_t)input[50] << 19) |
			((uint32_t)(input[51] & 0xf0) << 11);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 412 to 428
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)(input[53] & 0xf8) << 12);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 429 to 445
	value = ((uint32_t)(input[53] & 0x07) << 29) |
			((uint32_t)input[54] << 21) |
			((uint32_t)(input[55] & 0xfc) << 13);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 446 to 462
	value = ((uint32_t)(input[55] & 0x03) << 30) |
			((uint32_t)input[56] << 22) |
			((uint32_t)(input[57] & 0xfe) << 14);
	output[26] = (double)(value >> 15);

	// read output[27]: from bit 463 to 479
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15);
	output[27] = (double)(value >> 15);
}

static void unpack_28_17bit_unsigned_4off(const uint8_t * input, double * output) {
	// Unpack 28 values into output
	// Values are 17-bit unsigned
	// Skip 4 bits, read 476 bits of data.
	// Input must be at least 60 bytes long

	uint32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 55 to 71
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 72 to 88
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)(input[11] & 0x80) << 8);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 89 to 105
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xc0) << 9);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 106 to 122
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xe0) << 10);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 123 to 139
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)(input[17] & 0xf0) << 11);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 140 to 156
	value = ((uint32_t)(input[17] & 0x0f) << 28) |
			((uint32_t)input[18] << 20) |
			((uint32_t)(input[19] & 0xf8) << 12);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 157 to 173
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0xfc) << 13);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 174 to 190
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xfe) << 14);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 191 to 207
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 208 to 224
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16) |
			((uint32_t)(input[28] & 0x80) << 8);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 225 to 241
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0xc0) << 9);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 242 to 258
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xe0) << 10);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 259 to 275
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xf0) << 11);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 276 to 292
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf8) << 12);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 293 to 309
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xfc) << 13);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 310 to 326
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfe) << 14);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 327 to 343
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)input[42] << 15);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 344 to 360
	value = ((uint32_t)input[43] << 24) |
			((uint32_t)input[44] << 16) |
			((uint32_t)(input[45] & 0x80) << 8);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 361 to 377
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)(input[47] & 0xc0) << 9);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 378 to 394
	value = ((uint32_t)(input[47] & 0x3f) << 26) |
			((uint32_t)input[48] << 18) |
			((uint32_t)(input[49] & 0xe0) << 10);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 395 to 411
	value = ((uint32_t)(input[49] & 0x1f) << 27) |
			((uint32_t)input[50] << 19) |
			((uint32_t)(input[51] & 0xf0) << 11);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 412 to 428
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)(input[53] & 0xf8) << 12);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 429 to 445
	value = ((uint32_t)(input[53] & 0x07) << 29) |
			((uint32_t)input[54] << 21) |
			((uint32_t)(input[55] & 0xfc) << 13);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 446 to 462
	value = ((uint32_t)(input[55] & 0x03) << 30) |
			((uint32_t)input[56] << 22) |
			((uint32_t)(input[57] & 0xfe) << 14);
	output[26] = (double)(value >> 15);

	// read output[27]: from bit 463 to 479
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15);
	output[27] = (double)(value >> 15);
}

static void unpack_28_17bit_signed_5off(const uint8_t * input, double * output) {
	// Unpack 28 values into output
	// Values are 17-bit signed
	// Skip 5 bits, read 476 bits of data.
	// Input must be at least 61 bytes long

	int32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 56 to 72
	value = ((uint32_t)input[7] << 24) |
			((uint32_t)input[8] << 16) |
			((uint32_t)(input[9] & 0x80) << 8);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 73 to 89
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)(input[11] & 0xc0) << 9);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 90 to 106
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xe0) << 10);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 107 to 123
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)(input[15] & 0xf0) << 11);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 124 to 140
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)(input[17] & 0xf8) << 12);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 141 to 157
	value = ((uint32_t)(input[17] & 0x07) << 29) |
			((uint32_t)input[18] << 21) |
			((uint32_t)(input[19] & 0xfc) << 13);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 158 to 174
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xfe) << 14);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 175 to 191
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 192 to 208
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0x80) << 8);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 209 to 225
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0xc0) << 9);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 226 to 242
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xe0) << 10);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 243 to 259
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xf0) << 11);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 260 to 276
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf8) << 12);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 277 to 293
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xfc) << 13);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 294 to 310
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfe) << 14);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 311 to 327
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)input[40] << 15);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 328 to 344
	value = ((uint32_t)input[41] << 24) |
			((uint32_t)input[42] << 16) |
			((uint32_t)(input[43] & 0x80) << 8);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 345 to 361
	value = ((uint32_t)(input[43] & 0x7f) << 25) |
			((uint32_t)input[44] << 17) |
			((uint32_t)(input[45] & 0xc0) << 9);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 362 to 378
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)(input[47] & 0xe0) << 10);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 379 to 395
	value = ((uint32_t)(input[47] & 0x1f) << 27) |
			((uint32_t)input[48] << 19) |
			((uint32_t)(input[49] & 0xf0) << 11);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 396 to 412
	value = ((uint32_t)(input[49] & 0x0f) << 28) |
			((uint32_t)input[50] << 20) |
			((uint32_t)(input[51] & 0xf8) << 12);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 413 to 429
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)(input[53] & 0xfc) << 13);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 430 to 446
	value = ((uint32_t)(input[53] & 0x03) << 30) |
			((uint32_t)input[54] << 22) |
			((uint32_t)(input[55] & 0xfe) << 14);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 447 to 463
	value = ((uint32_t)(input[55] & 0x01) << 31) |
			((uint32_t)input[56] << 23) |
			((uint32_t)input[57] << 15);
	output[26] = (double)(value >> 15);

	// read output[27]: from bit 464 to 480
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16) |
			((uint32_t)(input[60] & 0x80) << 8);
	output[27] = (double)(value >> 15);
}

static void unpack_28_17bit_unsigned_5off(const uint8_t * input, double * output) {
	// Unpack 28 values into output
	// Values are 17-bit unsigned
	// Skip 5 bits, read 476 bits of data.
	// Input must be at least 61 bytes long

	uint32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 56 to 72
	value = ((uint32_t)input[7] << 24) |
			((uint32_t)input[8] << 16) |
			((uint32_t)(input[9] & 0x80) << 8);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 73 to 89
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)(input[11] & 0xc0) << 9);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 90 to 106
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xe0) << 10);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 107 to 123
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)(input[15] & 0xf0) << 11);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 124 to 140
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)(input[17] & 0xf8) << 12);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 141 to 157
	value = ((uint32_t)(input[17] & 0x07) << 29) |
			((uint32_t)input[18] << 21) |
			((uint32_t)(input[19] & 0xfc) << 13);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 158 to 174
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xfe) << 14);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 175 to 191
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 192 to 208
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0x80) << 8);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 209 to 225
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0xc0) << 9);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 226 to 242
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xe0) << 10);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 243 to 259
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xf0) << 11);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 260 to 276
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf8) << 12);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 277 to 293
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xfc) << 13);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 294 to 310
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfe) << 14);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 311 to 327
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)input[40] << 15);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 328 to 344
	value = ((uint32_t)input[41] << 24) |
			((uint32_t)input[42] << 16) |
			((uint32_t)(input[43] & 0x80) << 8);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 345 to 361
	value = ((uint32_t)(input[43] & 0x7f) << 25) |
			((uint32_t)input[44] << 17) |
			((uint32_t)(input[45] & 0xc0) << 9);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 362 to 378
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)(input[47] & 0xe0) << 10);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 379 to 395
	value = ((uint32_t)(input[47] & 0x1f) << 27) |
			((uint32_t)input[48] << 19) |
			((uint32_t)(input[49] & 0xf0) << 11);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 396 to 412
	value = ((uint32_t)(input[49] & 0x0f) << 28) |
			((uint32_t)input[50] << 20) |
			((uint32_t)(input[51] & 0xf8) << 12);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 413 to 429
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)(input[53] & 0xfc) << 13);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 430 to 446
	value = ((uint32_t)(input[53] & 0x03) << 30) |
			((uint32_t)input[54] << 22) |
			((uint32_t)(input[55] & 0xfe) << 14);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 447 to 463
	value = ((uint32_t)(input[55] & 0x01) << 31) |
			((uint32_t)input[56] << 23) |
			((uint32_t)input[57] << 15);
	output[26] = (double)(value >> 15);

	// read output[27]: from bit 464 to 480
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16) |
			((uint32_t)(input[60] & 0x80) << 8);
	output[27] = (double)(value >> 15);
}

static void unpack_28_17bit_signed_6off(const uint8_t * input, double * output) {
	// Unpack 28 values into output
	// Values are 17-bit signed
	// Skip 6 bits, read 476 bits of data.
	// Input must be at least 61 bytes long

	int32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 57 to 73
	value = ((uint32_t)(input[7] & 0x7f) << 25) |
			((uint32_t)input[8] << 17) |
			((uint32_t)(input[9] & 0xc0) << 9);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 74 to 90
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)(input[11] & 0xe0) << 10);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 91 to 107
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)(input[13] & 0xf0) << 11);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 108 to 124
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)(input[15] & 0xf8) << 12);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 125 to 141
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0xfc) << 13);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 142 to 158
	value = ((uint32_t)(input[17] & 0x03) << 30) |
			((uint32_t)input[18] << 22) |
			((uint32_t)(input[19] & 0xfe) << 14);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 159 to 175
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)input[21] << 15);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 176 to 192
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16) |
			((uint32_t)(input[24] & 0x80) << 8);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 193 to 209
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xc0) << 9);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 210 to 226
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xe0) << 10);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 227 to 243
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xf0) << 11);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 244 to 260
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf8) << 12);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 261 to 277
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xfc) << 13);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 278 to 294
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfe) << 14);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 295 to 311
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 312 to 328
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)(input[41] & 0x80) << 8);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 329 to 345
	value = ((uint32_t)(input[41] & 0x7f) << 25) |
			((uint32_t)input[42] << 17) |
			((uint32_t)(input[43] & 0xc0) << 9);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 346 to 362
	value = ((uint32_t)(input[43] & 0x3f) << 26) |
			((uint32_t)input[44] << 18) |
			((uint32_t)(input[45] & 0xe0) << 10);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 363 to 379
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)(input[47] & 0xf0) << 11);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 380 to 396
	value = ((uint32_t)(input[47] & 0x0f) << 28) |
			((uint32_t)input[48] << 20) |
			((uint32_t)(input[49] & 0xf8) << 12);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 397 to 413
	value = ((uint32_t)(input[49] & 0x07) << 29) |
			((uint32_t)input[50] << 21) |
			((uint32_t)(input[51] & 0xfc) << 13);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 414 to 430
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)(input[53] & 0xfe) << 14);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 431 to 447
	value = ((uint32_t)(input[53] & 0x01) << 31) |
			((uint32_t)input[54] << 23) |
			((uint32_t)input[55] << 15);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 448 to 464
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16) |
			((uint32_t)(input[58] & 0x80) << 8);
	output[26] = (double)(value >> 15);

	// read output[27]: from bit 465 to 481
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0xc0) << 9);
	output[27] = (double)(value >> 15);
}

static void unpack_28_17bit_unsigned_6off(const uint8_t * input, double * output) {
	// Unpack 28 values into output
	// Values are 17-bit unsigned
	// Skip 6 bits, read 476 bits of data.
	// Input must be at least 61 bytes long

	uint32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 57 to 73
	value = ((uint32_t)(input[7] & 0x7f) << 25) |
			((uint32_t)input[8] << 17) |
			((uint32_t)(input[9] & 0xc0) << 9);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 74 to 90
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)(input[11] & 0xe0) << 10);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 91 to 107
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)(input[13] & 0xf0) << 11);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 108 to 124
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)(input[15] & 0xf8) << 12);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 125 to 141
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0xfc) << 13);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 142 to 158
	value = ((uint32_t)(input[17] & 0x03) << 30) |
			((uint32_t)input[18] << 22) |
			((uint32_t)(input[19] & 0xfe) << 14);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 159 to 175
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)input[21] << 15);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 176 to 192
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16) |
			((uint32_t)(input[24] & 0x80) << 8);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 193 to 209
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xc0) << 9);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 210 to 226
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xe0) << 10);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 227 to 243
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xf0) << 11);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 244 to 260
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf8) << 12);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 261 to 277
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xfc) << 13);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 278 to 294
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfe) << 14);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 295 to 311
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 312 to 328
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)(input[41] & 0x80) << 8);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 329 to 345
	value = ((uint32_t)(input[41] & 0x7f) << 25) |
			((uint32_t)input[42] << 17) |
			((uint32_t)(input[43] & 0xc0) << 9);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 346 to 362
	value = ((uint32_t)(input[43] & 0x3f) << 26) |
			((uint32_t)input[44] << 18) |
			((uint32_t)(input[45] & 0xe0) << 10);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 363 to 379
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)(input[47] & 0xf0) << 11);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 380 to 396
	value = ((uint32_t)(input[47] & 0x0f) << 28) |
			((uint32_t)input[48] << 20) |
			((uint32_t)(input[49] & 0xf8) << 12);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 397 to 413
	value = ((uint32_t)(input[49] & 0x07) << 29) |
			((uint32_t)input[50] << 21) |
			((uint32_t)(input[51] & 0xfc) << 13);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 414 to 430
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)(input[53] & 0xfe) << 14);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 431 to 447
	value = ((uint32_t)(input[53] & 0x01) << 31) |
			((uint32_t)input[54] << 23) |
			((uint32_t)input[55] << 15);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 448 to 464
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16) |
			((uint32_t)(input[58] & 0x80) << 8);
	output[26] = (double)(value >> 15);

	// read output[27]: from bit 465 to 481
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0xc0) << 9);
	output[27] = (double)(value >> 15);
}

static void unpack_28_17bit_signed_7off(const uint8_t * input, double * output) {
	// Unpack 28 values into output
	// Values are 17-bit signed
	// Skip 7 bits, read 476 bits of data.
	// Input must be at least 61 bytes long

	int32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 58 to 74
	value = ((uint32_t)(input[7] & 0x3f) << 26) |
			((uint32_t)input[8] << 18) |
			((uint32_t)(input[9] & 0xe0) << 10);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 75 to 91
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)(input[11] & 0xf0) << 11);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 92 to 108
	value = ((uint32_t)(input[11] & 0x0f) << 28) |
			((uint32_t)input[12] << 20) |
			((uint32_t)(input[13] & 0xf8) << 12);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 109 to 125
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0xfc) << 13);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 126 to 142
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xfe) << 14);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 143 to 159
	value = ((uint32_t)(input[17] & 0x01) << 31) |
			((uint32_t)input[18] << 23) |
			((uint32_t)input[19] << 15);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 160 to 176
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16) |
			((uint32_t)(input[22] & 0x80) << 8);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 177 to 193
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0xc0) << 9);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 194 to 210
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xe0) << 10);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 211 to 227
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xf0) << 11);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 228 to 244
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf8) << 12);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 245 to 261
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xfc) << 13);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 262 to 278
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfe) << 14);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 279 to 295
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)input[36] << 15);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 296 to 312
	value = ((uint32_t)input[37] << 24) |
			((uint32_t)input[38] << 16) |
			((uint32_t)(input[39] & 0x80) << 8);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 313 to 329
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)(input[41] & 0xc0) << 9);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 330 to 346
	value = ((uint32_t)(input[41] & 0x3f) << 26) |
			((uint32_t)input[42] << 18) |
			((uint32_t)(input[43] & 0xe0) << 10);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 347 to 363
	value = ((uint32_t)(input[43] & 0x1f) << 27) |
			((uint32_t)input[44] << 19) |
			((uint32_t)(input[45] & 0xf0) << 11);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 364 to 380
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)(input[47] & 0xf8) << 12);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 381 to 397
	value = ((uint32_t)(input[47] & 0x07) << 29) |
			((uint32_t)input[48] << 21) |
			((uint32_t)(input[49] & 0xfc) << 13);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 398 to 414
	value = ((uint32_t)(input[49] & 0x03) << 30) |
			((uint32_t)input[50] << 22) |
			((uint32_t)(input[51] & 0xfe) << 14);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 415 to 431
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 432 to 448
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)(input[56] & 0x80) << 8);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 449 to 465
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0xc0) << 9);
	output[26] = (double)(value >> 15);

	// read output[27]: from bit 466 to 482
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xe0) << 10);
	output[27] = (double)(value >> 15);
}

static void unpack_28_17bit_unsigned_7off(const uint8_t * input, double * output) {
	// Unpack 28 values into output
	// Values are 17-bit unsigned
	// Skip 7 bits, read 476 bits of data.
	// Input must be at least 61 bytes long

	uint32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 58 to 74
	value = ((uint32_t)(input[7] & 0x3f) << 26) |
			((uint32_t)input[8] << 18) |
			((uint32_t)(input[9] & 0xe0) << 10);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 75 to 91
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)(input[11] & 0xf0) << 11);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 92 to 108
	value = ((uint32_t)(input[11] & 0x0f) << 28) |
			((uint32_t)input[12] << 20) |
			((uint32_t)(input[13] & 0xf8) << 12);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 109 to 125
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0xfc) << 13);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 126 to 142
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xfe) << 14);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 143 to 159
	value = ((uint32_t)(input[17] & 0x01) << 31) |
			((uint32_t)input[18] << 23) |
			((uint32_t)input[19] << 15);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 160 to 176
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16) |
			((uint32_t)(input[22] & 0x80) << 8);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 177 to 193
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0xc0) << 9);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 194 to 210
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xe0) << 10);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 211 to 227
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xf0) << 11);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 228 to 244
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf8) << 12);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 245 to 261
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xfc) << 13);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 262 to 278
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfe) << 14);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 279 to 295
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)input[36] << 15);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 296 to 312
	value = ((uint32_t)input[37] << 24) |
			((uint32_t)input[38] << 16) |
			((uint32_t)(input[39] & 0x80) << 8);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 313 to 329
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)(input[41] & 0xc0) << 9);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 330 to 346
	value = ((uint32_t)(input[41] & 0x3f) << 26) |
			((uint32_t)input[42] << 18) |
			((uint32_t)(input[43] & 0xe0) << 10);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 347 to 363
	value = ((uint32_t)(input[43] & 0x1f) << 27) |
			((uint32_t)input[44] << 19) |
			((uint32_t)(input[45] & 0xf0) << 11);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 364 to 380
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)(input[47] & 0xf8) << 12);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 381 to 397
	value = ((uint32_t)(input[47] & 0x07) << 29) |
			((uint32_t)input[48] << 21) |
			((uint32_t)(input[49] & 0xfc) << 13);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 398 to 414
	value = ((uint32_t)(input[49] & 0x03) << 30) |
			((uint32_t)input[50] << 22) |
			((uint32_t)(input[51] & 0xfe) << 14);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 415 to 431
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 432 to 448
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)(input[56] & 0x80) << 8);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 449 to 465
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0xc0) << 9);
	output[26] = (double)(value >> 15);

	// read output[27]: from bit 466 to 482
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xe0) << 10);
	output[27] = (double)(value >> 15);
}

static void unpack_29_17bit_signed_0off(const uint8_t * input, double * output) {
	// Unpack 29 values into output
	// Values are 17-bit signed
	// Skip 0 bits, read 493 bits of data.
	// Input must be at least 62 bytes long

	int32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 51 to 67
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xf0) << 11);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 68 to 84
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf8) << 12);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 85 to 101
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xfc) << 13);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 102 to 118
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfe) << 14);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 119 to 135
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)input[16] << 15);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 136 to 152
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)input[18] << 16) |
			((uint32_t)(input[19] & 0x80) << 8);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 153 to 169
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xc0) << 9);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 170 to 186
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xe0) << 10);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 187 to 203
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)input[24] << 19) |
			((uint32_t)(input[25] & 0xf0) << 11);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 204 to 220
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20) |
			((uint32_t)(input[27] & 0xf8) << 12);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 221 to 237
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0xfc) << 13);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 238 to 254
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)(input[31] & 0xfe) << 14);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 255 to 271
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)input[33] << 15);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 272 to 288
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16) |
			((uint32_t)(input[36] & 0x80) << 8);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 289 to 305
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0xc0) << 9);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 306 to 322
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xe0) << 10);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 323 to 339
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xf0) << 11);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 340 to 356
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf8) << 12);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 357 to 373
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xfc) << 13);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 374 to 390
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfe) << 14);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 391 to 407
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 408 to 424
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)(input[53] & 0x80) << 8);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 425 to 441
	value = ((uint32_t)(input[53] & 0x7f) << 25) |
			((uint32_t)input[54] << 17) |
			((uint32_t)(input[55] & 0xc0) << 9);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 442 to 458
	value = ((uint32_t)(input[55] & 0x3f) << 26) |
			((uint32_t)input[56] << 18) |
			((uint32_t)(input[57] & 0xe0) << 10);
	output[26] = (double)(value >> 15);

	// read output[27]: from bit 459 to 475
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)input[58] << 19) |
			((uint32_t)(input[59] & 0xf0) << 11);
	output[27] = (double)(value >> 15);

	// read output[28]: from bit 476 to 492
	value = ((uint32_t)(input[59] & 0x0f) << 28) |
			((uint32_t)input[60] << 20) |
			((uint32_t)(input[61] & 0xf8) << 12);
	output[28] = (double)(value >> 15);
}

static void unpack_29_17bit_unsigned_0off(const uint8_t * input, double * output) {
	// Unpack 29 values into output
	// Values are 17-bit unsigned
	// Skip 0 bits, read 493 bits of data.
	// Input must be at least 62 bytes long

	uint32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 51 to 67
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xf0) << 11);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 68 to 84
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf8) << 12);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 85 to 101
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xfc) << 13);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 102 to 118
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfe) << 14);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 119 to 135
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)input[16] << 15);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 136 to 152
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)input[18] << 16) |
			((uint32_t)(input[19] & 0x80) << 8);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 153 to 169
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xc0) << 9);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 170 to 186
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xe0) << 10);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 187 to 203
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)input[24] << 19) |
			((uint32_t)(input[25] & 0xf0) << 11);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 204 to 220
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20) |
			((uint32_t)(input[27] & 0xf8) << 12);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 221 to 237
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0xfc) << 13);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 238 to 254
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)(input[31] & 0xfe) << 14);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 255 to 271
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)input[33] << 15);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 272 to 288
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16) |
			((uint32_t)(input[36] & 0x80) << 8);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 289 to 305
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0xc0) << 9);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 306 to 322
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xe0) << 10);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 323 to 339
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xf0) << 11);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 340 to 356
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf8) << 12);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 357 to 373
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xfc) << 13);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 374 to 390
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfe) << 14);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 391 to 407
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 408 to 424
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)(input[53] & 0x80) << 8);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 425 to 441
	value = ((uint32_t)(input[53] & 0x7f) << 25) |
			((uint32_t)input[54] << 17) |
			((uint32_t)(input[55] & 0xc0) << 9);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 442 to 458
	value = ((uint32_t)(input[55] & 0x3f) << 26) |
			((uint32_t)input[56] << 18) |
			((uint32_t)(input[57] & 0xe0) << 10);
	output[26] = (double)(value >> 15);

	// read output[27]: from bit 459 to 475
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)input[58] << 19) |
			((uint32_t)(input[59] & 0xf0) << 11);
	output[27] = (double)(value >> 15);

	// read output[28]: from bit 476 to 492
	value = ((uint32_t)(input[59] & 0x0f) << 28) |
			((uint32_t)input[60] << 20) |
			((uint32_t)(input[61] & 0xf8) << 12);
	output[28] = (double)(value >> 15);
}

static void unpack_29_17bit_signed_1off(const uint8_t * input, double * output) {
	// Unpack 29 values into output
	// Values are 17-bit signed
	// Skip 1 bits, read 493 bits of data.
	// Input must be at least 62 bytes long

	int32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 52 to 68
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf8) << 12);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 69 to 85
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xfc) << 13);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 86 to 102
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfe) << 14);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 103 to 119
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 120 to 136
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)(input[17] & 0x80) << 8);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 137 to 153
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)input[18] << 17) |
			((uint32_t)(input[19] & 0xc0) << 9);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 154 to 170
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xe0) << 10);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 171 to 187
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)(input[23] & 0xf0) << 11);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 188 to 204
	value = ((uint32_t)(input[23] & 0x0f) << 28) |
			((uint32_t)input[24] << 20) |
			((uint32_t)(input[25] & 0xf8) << 12);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 205 to 221
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0xfc) << 13);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 222 to 238
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xfe) << 14);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 239 to 255
	value = ((uint32_t)(input[29] & 0x01) << 31) |
			((uint32_t)input[30] << 23) |
			((uint32_t)input[31] << 15);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 256 to 272
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16) |
			((uint32_t)(input[34] & 0x80) << 8);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 273 to 289
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0xc0) << 9);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 290 to 306
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xe0) << 10);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 307 to 323
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xf0) << 11);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 324 to 340
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf8) << 12);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 341 to 357
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xfc) << 13);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 358 to 374
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfe) << 14);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 375 to 391
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)input[48] << 15);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 392 to 408
	value = ((uint32_t)input[49] << 24) |
			((uint32_t)input[50] << 16) |
			((uint32_t)(input[51] & 0x80) << 8);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 409 to 425
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)(input[53] & 0xc0) << 9);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 426 to 442
	value = ((uint32_t)(input[53] & 0x3f) << 26) |
			((uint32_t)input[54] << 18) |
			((uint32_t)(input[55] & 0xe0) << 10);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 443 to 459
	value = ((uint32_t)(input[55] & 0x1f) << 27) |
			((uint32_t)input[56] << 19) |
			((uint32_t)(input[57] & 0xf0) << 11);
	output[26] = (double)(value >> 15);

	// read output[27]: from bit 460 to 476
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20) |
			((uint32_t)(input[59] & 0xf8) << 12);
	output[27] = (double)(value >> 15);

	// read output[28]: from bit 477 to 493
	value = ((uint32_t)(input[59] & 0x07) << 29) |
			((uint32_t)input[60] << 21) |
			((uint32_t)(input[61] & 0xfc) << 13);
	output[28] = (double)(value >> 15);
}

static void unpack_29_17bit_unsigned_1off(const uint8_t * input, double * output) {
	// Unpack 29 values into output
	// Values are 17-bit unsigned
	// Skip 1 bits, read 493 bits of data.
	// Input must be at least 62 bytes long

	uint32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 52 to 68
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf8) << 12);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 69 to 85
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xfc) << 13);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 86 to 102
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfe) << 14);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 103 to 119
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 120 to 136
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)(input[17] & 0x80) << 8);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 137 to 153
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)input[18] << 17) |
			((uint32_t)(input[19] & 0xc0) << 9);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 154 to 170
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xe0) << 10);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 171 to 187
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)(input[23] & 0xf0) << 11);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 188 to 204
	value = ((uint32_t)(input[23] & 0x0f) << 28) |
			((uint32_t)input[24] << 20) |
			((uint32_t)(input[25] & 0xf8) << 12);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 205 to 221
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0xfc) << 13);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 222 to 238
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xfe) << 14);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 239 to 255
	value = ((uint32_t)(input[29] & 0x01) << 31) |
			((uint32_t)input[30] << 23) |
			((uint32_t)input[31] << 15);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 256 to 272
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16) |
			((uint32_t)(input[34] & 0x80) << 8);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 273 to 289
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0xc0) << 9);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 290 to 306
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xe0) << 10);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 307 to 323
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xf0) << 11);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 324 to 340
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf8) << 12);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 341 to 357
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xfc) << 13);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 358 to 374
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfe) << 14);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 375 to 391
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)input[48] << 15);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 392 to 408
	value = ((uint32_t)input[49] << 24) |
			((uint32_t)input[50] << 16) |
			((uint32_t)(input[51] & 0x80) << 8);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 409 to 425
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)(input[53] & 0xc0) << 9);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 426 to 442
	value = ((uint32_t)(input[53] & 0x3f) << 26) |
			((uint32_t)input[54] << 18) |
			((uint32_t)(input[55] & 0xe0) << 10);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 443 to 459
	value = ((uint32_t)(input[55] & 0x1f) << 27) |
			((uint32_t)input[56] << 19) |
			((uint32_t)(input[57] & 0xf0) << 11);
	output[26] = (double)(value >> 15);

	// read output[27]: from bit 460 to 476
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20) |
			((uint32_t)(input[59] & 0xf8) << 12);
	output[27] = (double)(value >> 15);

	// read output[28]: from bit 477 to 493
	value = ((uint32_t)(input[59] & 0x07) << 29) |
			((uint32_t)input[60] << 21) |
			((uint32_t)(input[61] & 0xfc) << 13);
	output[28] = (double)(value >> 15);
}

static void unpack_29_17bit_signed_2off(const uint8_t * input, double * output) {
	// Unpack 29 values into output
	// Values are 17-bit signed
	// Skip 2 bits, read 493 bits of data.
	// Input must be at least 62 bytes long

	int32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 53 to 69
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xfc) << 13);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 70 to 86
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfe) << 14);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 87 to 103
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 104 to 120
	value = ((uint32_t)input[13] << 24) |
			((uint32_t)input[14] << 16) |
			((uint32_t)(input[15] & 0x80) << 8);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 121 to 137
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)(input[17] & 0xc0) << 9);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 138 to 154
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)input[18] << 18) |
			((uint32_t)(input[19] & 0xe0) << 10);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 155 to 171
	value = ((uint32_t)(input[19] & 0x1f) << 27) |
			((uint32_t)input[20] << 19) |
			((uint32_t)(input[21] & 0xf0) << 11);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 172 to 188
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)(input[23] & 0xf8) << 12);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 189 to 205
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)(input[25] & 0xfc) << 13);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 206 to 222
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xfe) << 14);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 223 to 239
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 240 to 256
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)(input[32] & 0x80) << 8);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 257 to 273
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0xc0) << 9);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 274 to 290
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xe0) << 10);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 291 to 307
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xf0) << 11);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 308 to 324
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf8) << 12);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 325 to 341
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xfc) << 13);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 342 to 358
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfe) << 14);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 359 to 375
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)input[46] << 15);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 376 to 392
	value = ((uint32_t)input[47] << 24) |
			((uint32_t)input[48] << 16) |
			((uint32_t)(input[49] & 0x80) << 8);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 393 to 409
	value = ((uint32_t)(input[49] & 0x7f) << 25) |
			((uint32_t)input[50] << 17) |
			((uint32_t)(input[51] & 0xc0) << 9);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 410 to 426
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)(input[53] & 0xe0) << 10);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 427 to 443
	value = ((uint32_t)(input[53] & 0x1f) << 27) |
			((uint32_t)input[54] << 19) |
			((uint32_t)(input[55] & 0xf0) << 11);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 444 to 460
	value = ((uint32_t)(input[55] & 0x0f) << 28) |
			((uint32_t)input[56] << 20) |
			((uint32_t)(input[57] & 0xf8) << 12);
	output[26] = (double)(value >> 15);

	// read output[27]: from bit 461 to 477
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)(input[59] & 0xfc) << 13);
	output[27] = (double)(value >> 15);

	// read output[28]: from bit 478 to 494
	value = ((uint32_t)(input[59] & 0x03) << 30) |
			((uint32_t)input[60] << 22) |
			((uint32_t)(input[61] & 0xfe) << 14);
	output[28] = (double)(value >> 15);
}

static void unpack_29_17bit_unsigned_2off(const uint8_t * input, double * output) {
	// Unpack 29 values into output
	// Values are 17-bit unsigned
	// Skip 2 bits, read 493 bits of data.
	// Input must be at least 62 bytes long

	uint32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 53 to 69
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xfc) << 13);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 70 to 86
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfe) << 14);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 87 to 103
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 104 to 120
	value = ((uint32_t)input[13] << 24) |
			((uint32_t)input[14] << 16) |
			((uint32_t)(input[15] & 0x80) << 8);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 121 to 137
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)(input[17] & 0xc0) << 9);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 138 to 154
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)input[18] << 18) |
			((uint32_t)(input[19] & 0xe0) << 10);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 155 to 171
	value = ((uint32_t)(input[19] & 0x1f) << 27) |
			((uint32_t)input[20] << 19) |
			((uint32_t)(input[21] & 0xf0) << 11);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 172 to 188
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)(input[23] & 0xf8) << 12);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 189 to 205
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)(input[25] & 0xfc) << 13);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 206 to 222
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xfe) << 14);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 223 to 239
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 240 to 256
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)(input[32] & 0x80) << 8);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 257 to 273
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0xc0) << 9);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 274 to 290
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xe0) << 10);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 291 to 307
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xf0) << 11);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 308 to 324
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf8) << 12);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 325 to 341
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xfc) << 13);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 342 to 358
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfe) << 14);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 359 to 375
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)input[46] << 15);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 376 to 392
	value = ((uint32_t)input[47] << 24) |
			((uint32_t)input[48] << 16) |
			((uint32_t)(input[49] & 0x80) << 8);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 393 to 409
	value = ((uint32_t)(input[49] & 0x7f) << 25) |
			((uint32_t)input[50] << 17) |
			((uint32_t)(input[51] & 0xc0) << 9);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 410 to 426
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)(input[53] & 0xe0) << 10);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 427 to 443
	value = ((uint32_t)(input[53] & 0x1f) << 27) |
			((uint32_t)input[54] << 19) |
			((uint32_t)(input[55] & 0xf0) << 11);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 444 to 460
	value = ((uint32_t)(input[55] & 0x0f) << 28) |
			((uint32_t)input[56] << 20) |
			((uint32_t)(input[57] & 0xf8) << 12);
	output[26] = (double)(value >> 15);

	// read output[27]: from bit 461 to 477
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)(input[59] & 0xfc) << 13);
	output[27] = (double)(value >> 15);

	// read output[28]: from bit 478 to 494
	value = ((uint32_t)(input[59] & 0x03) << 30) |
			((uint32_t)input[60] << 22) |
			((uint32_t)(input[61] & 0xfe) << 14);
	output[28] = (double)(value >> 15);
}

static void unpack_29_17bit_signed_3off(const uint8_t * input, double * output) {
	// Unpack 29 values into output
	// Values are 17-bit signed
	// Skip 3 bits, read 493 bits of data.
	// Input must be at least 62 bytes long

	int32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 54 to 70
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfe) << 14);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 71 to 87
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)input[10] << 15);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 88 to 104
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0x80) << 8);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 105 to 121
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xc0) << 9);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 122 to 138
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)(input[17] & 0xe0) << 10);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 139 to 155
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)input[18] << 19) |
			((uint32_t)(input[19] & 0xf0) << 11);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 156 to 172
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20) |
			((uint32_t)(input[21] & 0xf8) << 12);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 173 to 189
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0xfc) << 13);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 190 to 206
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)(input[25] & 0xfe) << 14);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 207 to 223
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)input[27] << 15);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 224 to 240
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16) |
			((uint32_t)(input[30] & 0x80) << 8);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 241 to 257
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0xc0) << 9);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 258 to 274
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xe0) << 10);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 275 to 291
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xf0) << 11);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 292 to 308
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf8) << 12);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 309 to 325
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xfc) << 13);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 326 to 342
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfe) << 14);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 343 to 359
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 360 to 376
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)(input[47] & 0x80) << 8);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 377 to 393
	value = ((uint32_t)(input[47] & 0x7f) << 25) |
			((uint32_t)input[48] << 17) |
			((uint32_t)(input[49] & 0xc0) << 9);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 394 to 410
	value = ((uint32_t)(input[49] & 0x3f) << 26) |
			((uint32_t)input[50] << 18) |
			((uint32_t)(input[51] & 0xe0) << 10);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 411 to 427
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)(input[53] & 0xf0) << 11);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 428 to 444
	value = ((uint32_t)(input[53] & 0x0f) << 28) |
			((uint32_t)input[54] << 20) |
			((uint32_t)(input[55] & 0xf8) << 12);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 445 to 461
	value = ((uint32_t)(input[55] & 0x07) << 29) |
			((uint32_t)input[56] << 21) |
			((uint32_t)(input[57] & 0xfc) << 13);
	output[26] = (double)(value >> 15);

	// read output[27]: from bit 462 to 478
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)(input[59] & 0xfe) << 14);
	output[27] = (double)(value >> 15);

	// read output[28]: from bit 479 to 495
	value = ((uint32_t)(input[59] & 0x01) << 31) |
			((uint32_t)input[60] << 23) |
			((uint32_t)input[61] << 15);
	output[28] = (double)(value >> 15);
}

static void unpack_29_17bit_unsigned_3off(const uint8_t * input, double * output) {
	// Unpack 29 values into output
	// Values are 17-bit unsigned
	// Skip 3 bits, read 493 bits of data.
	// Input must be at least 62 bytes long

	uint32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 54 to 70
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfe) << 14);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 71 to 87
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)input[10] << 15);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 88 to 104
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0x80) << 8);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 105 to 121
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xc0) << 9);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 122 to 138
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)(input[17] & 0xe0) << 10);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 139 to 155
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)input[18] << 19) |
			((uint32_t)(input[19] & 0xf0) << 11);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 156 to 172
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20) |
			((uint32_t)(input[21] & 0xf8) << 12);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 173 to 189
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0xfc) << 13);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 190 to 206
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)(input[25] & 0xfe) << 14);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 207 to 223
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)input[27] << 15);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 224 to 240
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16) |
			((uint32_t)(input[30] & 0x80) << 8);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 241 to 257
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0xc0) << 9);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 258 to 274
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xe0) << 10);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 275 to 291
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xf0) << 11);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 292 to 308
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf8) << 12);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 309 to 325
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xfc) << 13);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 326 to 342
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfe) << 14);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 343 to 359
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 360 to 376
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)(input[47] & 0x80) << 8);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 377 to 393
	value = ((uint32_t)(input[47] & 0x7f) << 25) |
			((uint32_t)input[48] << 17) |
			((uint32_t)(input[49] & 0xc0) << 9);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 394 to 410
	value = ((uint32_t)(input[49] & 0x3f) << 26) |
			((uint32_t)input[50] << 18) |
			((uint32_t)(input[51] & 0xe0) << 10);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 411 to 427
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)(input[53] & 0xf0) << 11);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 428 to 444
	value = ((uint32_t)(input[53] & 0x0f) << 28) |
			((uint32_t)input[54] << 20) |
			((uint32_t)(input[55] & 0xf8) << 12);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 445 to 461
	value = ((uint32_t)(input[55] & 0x07) << 29) |
			((uint32_t)input[56] << 21) |
			((uint32_t)(input[57] & 0xfc) << 13);
	output[26] = (double)(value >> 15);

	// read output[27]: from bit 462 to 478
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)(input[59] & 0xfe) << 14);
	output[27] = (double)(value >> 15);

	// read output[28]: from bit 479 to 495
	value = ((uint32_t)(input[59] & 0x01) << 31) |
			((uint32_t)input[60] << 23) |
			((uint32_t)input[61] << 15);
	output[28] = (double)(value >> 15);
}

static void unpack_29_17bit_signed_4off(const uint8_t * input, double * output) {
	// Unpack 29 values into output
	// Values are 17-bit signed
	// Skip 4 bits, read 493 bits of data.
	// Input must be at least 63 bytes long

	int32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 55 to 71
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 72 to 88
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)(input[11] & 0x80) << 8);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 89 to 105
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xc0) << 9);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 106 to 122
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xe0) << 10);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 123 to 139
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)(input[17] & 0xf0) << 11);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 140 to 156
	value = ((uint32_t)(input[17] & 0x0f) << 28) |
			((uint32_t)input[18] << 20) |
			((uint32_t)(input[19] & 0xf8) << 12);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 157 to 173
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0xfc) << 13);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 174 to 190
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xfe) << 14);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 191 to 207
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 208 to 224
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16) |
			((uint32_t)(input[28] & 0x80) << 8);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 225 to 241
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0xc0) << 9);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 242 to 258
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xe0) << 10);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 259 to 275
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xf0) << 11);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 276 to 292
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf8) << 12);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 293 to 309
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xfc) << 13);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 310 to 326
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfe) << 14);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 327 to 343
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)input[42] << 15);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 344 to 360
	value = ((uint32_t)input[43] << 24) |
			((uint32_t)input[44] << 16) |
			((uint32_t)(input[45] & 0x80) << 8);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 361 to 377
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)(input[47] & 0xc0) << 9);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 378 to 394
	value = ((uint32_t)(input[47] & 0x3f) << 26) |
			((uint32_t)input[48] << 18) |
			((uint32_t)(input[49] & 0xe0) << 10);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 395 to 411
	value = ((uint32_t)(input[49] & 0x1f) << 27) |
			((uint32_t)input[50] << 19) |
			((uint32_t)(input[51] & 0xf0) << 11);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 412 to 428
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)(input[53] & 0xf8) << 12);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 429 to 445
	value = ((uint32_t)(input[53] & 0x07) << 29) |
			((uint32_t)input[54] << 21) |
			((uint32_t)(input[55] & 0xfc) << 13);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 446 to 462
	value = ((uint32_t)(input[55] & 0x03) << 30) |
			((uint32_t)input[56] << 22) |
			((uint32_t)(input[57] & 0xfe) << 14);
	output[26] = (double)(value >> 15);

	// read output[27]: from bit 463 to 479
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15);
	output[27] = (double)(value >> 15);

	// read output[28]: from bit 480 to 496
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16) |
			((uint32_t)(input[62] & 0x80) << 8);
	output[28] = (double)(value >> 15);
}

static void unpack_29_17bit_unsigned_4off(const uint8_t * input, double * output) {
	// Unpack 29 values into output
	// Values are 17-bit unsigned
	// Skip 4 bits, read 493 bits of data.
	// Input must be at least 63 bytes long

	uint32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 55 to 71
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 72 to 88
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)(input[11] & 0x80) << 8);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 89 to 105
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xc0) << 9);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 106 to 122
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xe0) << 10);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 123 to 139
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)(input[17] & 0xf0) << 11);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 140 to 156
	value = ((uint32_t)(input[17] & 0x0f) << 28) |
			((uint32_t)input[18] << 20) |
			((uint32_t)(input[19] & 0xf8) << 12);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 157 to 173
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0xfc) << 13);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 174 to 190
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xfe) << 14);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 191 to 207
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 208 to 224
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16) |
			((uint32_t)(input[28] & 0x80) << 8);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 225 to 241
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0xc0) << 9);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 242 to 258
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xe0) << 10);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 259 to 275
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xf0) << 11);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 276 to 292
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf8) << 12);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 293 to 309
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xfc) << 13);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 310 to 326
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfe) << 14);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 327 to 343
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)input[42] << 15);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 344 to 360
	value = ((uint32_t)input[43] << 24) |
			((uint32_t)input[44] << 16) |
			((uint32_t)(input[45] & 0x80) << 8);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 361 to 377
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)(input[47] & 0xc0) << 9);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 378 to 394
	value = ((uint32_t)(input[47] & 0x3f) << 26) |
			((uint32_t)input[48] << 18) |
			((uint32_t)(input[49] & 0xe0) << 10);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 395 to 411
	value = ((uint32_t)(input[49] & 0x1f) << 27) |
			((uint32_t)input[50] << 19) |
			((uint32_t)(input[51] & 0xf0) << 11);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 412 to 428
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)(input[53] & 0xf8) << 12);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 429 to 445
	value = ((uint32_t)(input[53] & 0x07) << 29) |
			((uint32_t)input[54] << 21) |
			((uint32_t)(input[55] & 0xfc) << 13);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 446 to 462
	value = ((uint32_t)(input[55] & 0x03) << 30) |
			((uint32_t)input[56] << 22) |
			((uint32_t)(input[57] & 0xfe) << 14);
	output[26] = (double)(value >> 15);

	// read output[27]: from bit 463 to 479
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15);
	output[27] = (double)(value >> 15);

	// read output[28]: from bit 480 to 496
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16) |
			((uint32_t)(input[62] & 0x80) << 8);
	output[28] = (double)(value >> 15);
}

static void unpack_29_17bit_signed_5off(const uint8_t * input, double * output) {
	// Unpack 29 values into output
	// Values are 17-bit signed
	// Skip 5 bits, read 493 bits of data.
	// Input must be at least 63 bytes long

	int32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 56 to 72
	value = ((uint32_t)input[7] << 24) |
			((uint32_t)input[8] << 16) |
			((uint32_t)(input[9] & 0x80) << 8);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 73 to 89
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)(input[11] & 0xc0) << 9);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 90 to 106
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xe0) << 10);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 107 to 123
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)(input[15] & 0xf0) << 11);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 124 to 140
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)(input[17] & 0xf8) << 12);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 141 to 157
	value = ((uint32_t)(input[17] & 0x07) << 29) |
			((uint32_t)input[18] << 21) |
			((uint32_t)(input[19] & 0xfc) << 13);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 158 to 174
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xfe) << 14);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 175 to 191
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 192 to 208
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0x80) << 8);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 209 to 225
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0xc0) << 9);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 226 to 242
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xe0) << 10);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 243 to 259
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xf0) << 11);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 260 to 276
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf8) << 12);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 277 to 293
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xfc) << 13);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 294 to 310
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfe) << 14);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 311 to 327
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)input[40] << 15);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 328 to 344
	value = ((uint32_t)input[41] << 24) |
			((uint32_t)input[42] << 16) |
			((uint32_t)(input[43] & 0x80) << 8);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 345 to 361
	value = ((uint32_t)(input[43] & 0x7f) << 25) |
			((uint32_t)input[44] << 17) |
			((uint32_t)(input[45] & 0xc0) << 9);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 362 to 378
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)(input[47] & 0xe0) << 10);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 379 to 395
	value = ((uint32_t)(input[47] & 0x1f) << 27) |
			((uint32_t)input[48] << 19) |
			((uint32_t)(input[49] & 0xf0) << 11);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 396 to 412
	value = ((uint32_t)(input[49] & 0x0f) << 28) |
			((uint32_t)input[50] << 20) |
			((uint32_t)(input[51] & 0xf8) << 12);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 413 to 429
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)(input[53] & 0xfc) << 13);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 430 to 446
	value = ((uint32_t)(input[53] & 0x03) << 30) |
			((uint32_t)input[54] << 22) |
			((uint32_t)(input[55] & 0xfe) << 14);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 447 to 463
	value = ((uint32_t)(input[55] & 0x01) << 31) |
			((uint32_t)input[56] << 23) |
			((uint32_t)input[57] << 15);
	output[26] = (double)(value >> 15);

	// read output[27]: from bit 464 to 480
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16) |
			((uint32_t)(input[60] & 0x80) << 8);
	output[27] = (double)(value >> 15);

	// read output[28]: from bit 481 to 497
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0xc0) << 9);
	output[28] = (double)(value >> 15);
}

static void unpack_29_17bit_unsigned_5off(const uint8_t * input, double * output) {
	// Unpack 29 values into output
	// Values are 17-bit unsigned
	// Skip 5 bits, read 493 bits of data.
	// Input must be at least 63 bytes long

	uint32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 56 to 72
	value = ((uint32_t)input[7] << 24) |
			((uint32_t)input[8] << 16) |
			((uint32_t)(input[9] & 0x80) << 8);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 73 to 89
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)(input[11] & 0xc0) << 9);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 90 to 106
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xe0) << 10);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 107 to 123
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)(input[15] & 0xf0) << 11);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 124 to 140
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)(input[17] & 0xf8) << 12);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 141 to 157
	value = ((uint32_t)(input[17] & 0x07) << 29) |
			((uint32_t)input[18] << 21) |
			((uint32_t)(input[19] & 0xfc) << 13);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 158 to 174
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xfe) << 14);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 175 to 191
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 192 to 208
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0x80) << 8);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 209 to 225
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0xc0) << 9);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 226 to 242
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xe0) << 10);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 243 to 259
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xf0) << 11);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 260 to 276
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf8) << 12);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 277 to 293
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xfc) << 13);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 294 to 310
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfe) << 14);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 311 to 327
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)input[40] << 15);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 328 to 344
	value = ((uint32_t)input[41] << 24) |
			((uint32_t)input[42] << 16) |
			((uint32_t)(input[43] & 0x80) << 8);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 345 to 361
	value = ((uint32_t)(input[43] & 0x7f) << 25) |
			((uint32_t)input[44] << 17) |
			((uint32_t)(input[45] & 0xc0) << 9);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 362 to 378
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)(input[47] & 0xe0) << 10);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 379 to 395
	value = ((uint32_t)(input[47] & 0x1f) << 27) |
			((uint32_t)input[48] << 19) |
			((uint32_t)(input[49] & 0xf0) << 11);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 396 to 412
	value = ((uint32_t)(input[49] & 0x0f) << 28) |
			((uint32_t)input[50] << 20) |
			((uint32_t)(input[51] & 0xf8) << 12);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 413 to 429
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)(input[53] & 0xfc) << 13);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 430 to 446
	value = ((uint32_t)(input[53] & 0x03) << 30) |
			((uint32_t)input[54] << 22) |
			((uint32_t)(input[55] & 0xfe) << 14);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 447 to 463
	value = ((uint32_t)(input[55] & 0x01) << 31) |
			((uint32_t)input[56] << 23) |
			((uint32_t)input[57] << 15);
	output[26] = (double)(value >> 15);

	// read output[27]: from bit 464 to 480
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16) |
			((uint32_t)(input[60] & 0x80) << 8);
	output[27] = (double)(value >> 15);

	// read output[28]: from bit 481 to 497
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0xc0) << 9);
	output[28] = (double)(value >> 15);
}

static void unpack_29_17bit_signed_6off(const uint8_t * input, double * output) {
	// Unpack 29 values into output
	// Values are 17-bit signed
	// Skip 6 bits, read 493 bits of data.
	// Input must be at least 63 bytes long

	int32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 57 to 73
	value = ((uint32_t)(input[7] & 0x7f) << 25) |
			((uint32_t)input[8] << 17) |
			((uint32_t)(input[9] & 0xc0) << 9);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 74 to 90
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)(input[11] & 0xe0) << 10);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 91 to 107
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)(input[13] & 0xf0) << 11);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 108 to 124
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)(input[15] & 0xf8) << 12);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 125 to 141
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0xfc) << 13);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 142 to 158
	value = ((uint32_t)(input[17] & 0x03) << 30) |
			((uint32_t)input[18] << 22) |
			((uint32_t)(input[19] & 0xfe) << 14);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 159 to 175
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)input[21] << 15);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 176 to 192
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16) |
			((uint32_t)(input[24] & 0x80) << 8);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 193 to 209
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xc0) << 9);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 210 to 226
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xe0) << 10);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 227 to 243
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xf0) << 11);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 244 to 260
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf8) << 12);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 261 to 277
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xfc) << 13);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 278 to 294
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfe) << 14);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 295 to 311
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 312 to 328
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)(input[41] & 0x80) << 8);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 329 to 345
	value = ((uint32_t)(input[41] & 0x7f) << 25) |
			((uint32_t)input[42] << 17) |
			((uint32_t)(input[43] & 0xc0) << 9);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 346 to 362
	value = ((uint32_t)(input[43] & 0x3f) << 26) |
			((uint32_t)input[44] << 18) |
			((uint32_t)(input[45] & 0xe0) << 10);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 363 to 379
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)(input[47] & 0xf0) << 11);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 380 to 396
	value = ((uint32_t)(input[47] & 0x0f) << 28) |
			((uint32_t)input[48] << 20) |
			((uint32_t)(input[49] & 0xf8) << 12);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 397 to 413
	value = ((uint32_t)(input[49] & 0x07) << 29) |
			((uint32_t)input[50] << 21) |
			((uint32_t)(input[51] & 0xfc) << 13);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 414 to 430
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)(input[53] & 0xfe) << 14);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 431 to 447
	value = ((uint32_t)(input[53] & 0x01) << 31) |
			((uint32_t)input[54] << 23) |
			((uint32_t)input[55] << 15);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 448 to 464
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16) |
			((uint32_t)(input[58] & 0x80) << 8);
	output[26] = (double)(value >> 15);

	// read output[27]: from bit 465 to 481
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0xc0) << 9);
	output[27] = (double)(value >> 15);

	// read output[28]: from bit 482 to 498
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xe0) << 10);
	output[28] = (double)(value >> 15);
}

static void unpack_29_17bit_unsigned_6off(const uint8_t * input, double * output) {
	// Unpack 29 values into output
	// Values are 17-bit unsigned
	// Skip 6 bits, read 493 bits of data.
	// Input must be at least 63 bytes long

	uint32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 57 to 73
	value = ((uint32_t)(input[7] & 0x7f) << 25) |
			((uint32_t)input[8] << 17) |
			((uint32_t)(input[9] & 0xc0) << 9);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 74 to 90
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)(input[11] & 0xe0) << 10);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 91 to 107
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)(input[13] & 0xf0) << 11);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 108 to 124
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)(input[15] & 0xf8) << 12);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 125 to 141
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0xfc) << 13);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 142 to 158
	value = ((uint32_t)(input[17] & 0x03) << 30) |
			((uint32_t)input[18] << 22) |
			((uint32_t)(input[19] & 0xfe) << 14);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 159 to 175
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)input[21] << 15);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 176 to 192
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16) |
			((uint32_t)(input[24] & 0x80) << 8);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 193 to 209
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xc0) << 9);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 210 to 226
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xe0) << 10);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 227 to 243
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xf0) << 11);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 244 to 260
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf8) << 12);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 261 to 277
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xfc) << 13);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 278 to 294
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfe) << 14);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 295 to 311
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 312 to 328
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)(input[41] & 0x80) << 8);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 329 to 345
	value = ((uint32_t)(input[41] & 0x7f) << 25) |
			((uint32_t)input[42] << 17) |
			((uint32_t)(input[43] & 0xc0) << 9);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 346 to 362
	value = ((uint32_t)(input[43] & 0x3f) << 26) |
			((uint32_t)input[44] << 18) |
			((uint32_t)(input[45] & 0xe0) << 10);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 363 to 379
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)(input[47] & 0xf0) << 11);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 380 to 396
	value = ((uint32_t)(input[47] & 0x0f) << 28) |
			((uint32_t)input[48] << 20) |
			((uint32_t)(input[49] & 0xf8) << 12);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 397 to 413
	value = ((uint32_t)(input[49] & 0x07) << 29) |
			((uint32_t)input[50] << 21) |
			((uint32_t)(input[51] & 0xfc) << 13);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 414 to 430
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)(input[53] & 0xfe) << 14);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 431 to 447
	value = ((uint32_t)(input[53] & 0x01) << 31) |
			((uint32_t)input[54] << 23) |
			((uint32_t)input[55] << 15);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 448 to 464
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16) |
			((uint32_t)(input[58] & 0x80) << 8);
	output[26] = (double)(value >> 15);

	// read output[27]: from bit 465 to 481
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0xc0) << 9);
	output[27] = (double)(value >> 15);

	// read output[28]: from bit 482 to 498
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xe0) << 10);
	output[28] = (double)(value >> 15);
}

static void unpack_29_17bit_signed_7off(const uint8_t * input, double * output) {
	// Unpack 29 values into output
	// Values are 17-bit signed
	// Skip 7 bits, read 493 bits of data.
	// Input must be at least 63 bytes long

	int32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 58 to 74
	value = ((uint32_t)(input[7] & 0x3f) << 26) |
			((uint32_t)input[8] << 18) |
			((uint32_t)(input[9] & 0xe0) << 10);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 75 to 91
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)(input[11] & 0xf0) << 11);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 92 to 108
	value = ((uint32_t)(input[11] & 0x0f) << 28) |
			((uint32_t)input[12] << 20) |
			((uint32_t)(input[13] & 0xf8) << 12);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 109 to 125
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0xfc) << 13);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 126 to 142
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xfe) << 14);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 143 to 159
	value = ((uint32_t)(input[17] & 0x01) << 31) |
			((uint32_t)input[18] << 23) |
			((uint32_t)input[19] << 15);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 160 to 176
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16) |
			((uint32_t)(input[22] & 0x80) << 8);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 177 to 193
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0xc0) << 9);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 194 to 210
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xe0) << 10);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 211 to 227
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xf0) << 11);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 228 to 244
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf8) << 12);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 245 to 261
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xfc) << 13);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 262 to 278
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfe) << 14);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 279 to 295
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)input[36] << 15);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 296 to 312
	value = ((uint32_t)input[37] << 24) |
			((uint32_t)input[38] << 16) |
			((uint32_t)(input[39] & 0x80) << 8);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 313 to 329
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)(input[41] & 0xc0) << 9);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 330 to 346
	value = ((uint32_t)(input[41] & 0x3f) << 26) |
			((uint32_t)input[42] << 18) |
			((uint32_t)(input[43] & 0xe0) << 10);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 347 to 363
	value = ((uint32_t)(input[43] & 0x1f) << 27) |
			((uint32_t)input[44] << 19) |
			((uint32_t)(input[45] & 0xf0) << 11);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 364 to 380
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)(input[47] & 0xf8) << 12);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 381 to 397
	value = ((uint32_t)(input[47] & 0x07) << 29) |
			((uint32_t)input[48] << 21) |
			((uint32_t)(input[49] & 0xfc) << 13);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 398 to 414
	value = ((uint32_t)(input[49] & 0x03) << 30) |
			((uint32_t)input[50] << 22) |
			((uint32_t)(input[51] & 0xfe) << 14);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 415 to 431
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 432 to 448
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)(input[56] & 0x80) << 8);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 449 to 465
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0xc0) << 9);
	output[26] = (double)(value >> 15);

	// read output[27]: from bit 466 to 482
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xe0) << 10);
	output[27] = (double)(value >> 15);

	// read output[28]: from bit 483 to 499
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xf0) << 11);
	output[28] = (double)(value >> 15);
}

static void unpack_29_17bit_unsigned_7off(const uint8_t * input, double * output) {
	// Unpack 29 values into output
	// Values are 17-bit unsigned
	// Skip 7 bits, read 493 bits of data.
	// Input must be at least 63 bytes long

	uint32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 58 to 74
	value = ((uint32_t)(input[7] & 0x3f) << 26) |
			((uint32_t)input[8] << 18) |
			((uint32_t)(input[9] & 0xe0) << 10);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 75 to 91
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)(input[11] & 0xf0) << 11);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 92 to 108
	value = ((uint32_t)(input[11] & 0x0f) << 28) |
			((uint32_t)input[12] << 20) |
			((uint32_t)(input[13] & 0xf8) << 12);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 109 to 125
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0xfc) << 13);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 126 to 142
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xfe) << 14);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 143 to 159
	value = ((uint32_t)(input[17] & 0x01) << 31) |
			((uint32_t)input[18] << 23) |
			((uint32_t)input[19] << 15);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 160 to 176
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16) |
			((uint32_t)(input[22] & 0x80) << 8);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 177 to 193
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0xc0) << 9);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 194 to 210
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xe0) << 10);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 211 to 227
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xf0) << 11);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 228 to 244
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf8) << 12);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 245 to 261
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xfc) << 13);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 262 to 278
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfe) << 14);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 279 to 295
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)input[36] << 15);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 296 to 312
	value = ((uint32_t)input[37] << 24) |
			((uint32_t)input[38] << 16) |
			((uint32_t)(input[39] & 0x80) << 8);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 313 to 329
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)(input[41] & 0xc0) << 9);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 330 to 346
	value = ((uint32_t)(input[41] & 0x3f) << 26) |
			((uint32_t)input[42] << 18) |
			((uint32_t)(input[43] & 0xe0) << 10);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 347 to 363
	value = ((uint32_t)(input[43] & 0x1f) << 27) |
			((uint32_t)input[44] << 19) |
			((uint32_t)(input[45] & 0xf0) << 11);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 364 to 380
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)(input[47] & 0xf8) << 12);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 381 to 397
	value = ((uint32_t)(input[47] & 0x07) << 29) |
			((uint32_t)input[48] << 21) |
			((uint32_t)(input[49] & 0xfc) << 13);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 398 to 414
	value = ((uint32_t)(input[49] & 0x03) << 30) |
			((uint32_t)input[50] << 22) |
			((uint32_t)(input[51] & 0xfe) << 14);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 415 to 431
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 432 to 448
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)(input[56] & 0x80) << 8);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 449 to 465
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0xc0) << 9);
	output[26] = (double)(value >> 15);

	// read output[27]: from bit 466 to 482
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xe0) << 10);
	output[27] = (double)(value >> 15);

	// read output[28]: from bit 483 to 499
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xf0) << 11);
	output[28] = (double)(value >> 15);
}

static void unpack_30_17bit_signed_0off(const uint8_t * input, double * output) {
	// Unpack 30 values into output
	// Values are 17-bit signed
	// Skip 0 bits, read 510 bits of data.
	// Input must be at least 64 bytes long

	int32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 51 to 67
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xf0) << 11);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 68 to 84
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf8) << 12);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 85 to 101
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xfc) << 13);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 102 to 118
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfe) << 14);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 119 to 135
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)input[16] << 15);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 136 to 152
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)input[18] << 16) |
			((uint32_t)(input[19] & 0x80) << 8);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 153 to 169
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xc0) << 9);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 170 to 186
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xe0) << 10);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 187 to 203
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)input[24] << 19) |
			((uint32_t)(input[25] & 0xf0) << 11);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 204 to 220
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20) |
			((uint32_t)(input[27] & 0xf8) << 12);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 221 to 237
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0xfc) << 13);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 238 to 254
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)(input[31] & 0xfe) << 14);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 255 to 271
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)input[33] << 15);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 272 to 288
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16) |
			((uint32_t)(input[36] & 0x80) << 8);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 289 to 305
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0xc0) << 9);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 306 to 322
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xe0) << 10);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 323 to 339
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xf0) << 11);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 340 to 356
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf8) << 12);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 357 to 373
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xfc) << 13);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 374 to 390
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfe) << 14);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 391 to 407
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 408 to 424
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)(input[53] & 0x80) << 8);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 425 to 441
	value = ((uint32_t)(input[53] & 0x7f) << 25) |
			((uint32_t)input[54] << 17) |
			((uint32_t)(input[55] & 0xc0) << 9);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 442 to 458
	value = ((uint32_t)(input[55] & 0x3f) << 26) |
			((uint32_t)input[56] << 18) |
			((uint32_t)(input[57] & 0xe0) << 10);
	output[26] = (double)(value >> 15);

	// read output[27]: from bit 459 to 475
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)input[58] << 19) |
			((uint32_t)(input[59] & 0xf0) << 11);
	output[27] = (double)(value >> 15);

	// read output[28]: from bit 476 to 492
	value = ((uint32_t)(input[59] & 0x0f) << 28) |
			((uint32_t)input[60] << 20) |
			((uint32_t)(input[61] & 0xf8) << 12);
	output[28] = (double)(value >> 15);

	// read output[29]: from bit 493 to 509
	value = ((uint32_t)(input[61] & 0x07) << 29) |
			((uint32_t)input[62] << 21) |
			((uint32_t)(input[63] & 0xfc) << 13);
	output[29] = (double)(value >> 15);
}

static void unpack_30_17bit_unsigned_0off(const uint8_t * input, double * output) {
	// Unpack 30 values into output
	// Values are 17-bit unsigned
	// Skip 0 bits, read 510 bits of data.
	// Input must be at least 64 bytes long

	uint32_t value;

	// read output[0]: from bit 0 to 16
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0x80) << 8);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 17 to 33
	value = ((uint32_t)(input[2] & 0x7f) << 25) |
			((uint32_t)input[3] << 17) |
			((uint32_t)(input[4] & 0xc0) << 9);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 34 to 50
	value = ((uint32_t)(input[4] & 0x3f) << 26) |
			((uint32_t)input[5] << 18) |
			((uint32_t)(input[6] & 0xe0) << 10);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 51 to 67
	value = ((uint32_t)(input[6] & 0x1f) << 27) |
			((uint32_t)input[7] << 19) |
			((uint32_t)(input[8] & 0xf0) << 11);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 68 to 84
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)(input[10] & 0xf8) << 12);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 85 to 101
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)(input[12] & 0xfc) << 13);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 102 to 118
	value = ((uint32_t)(input[12] & 0x03) << 30) |
			((uint32_t)input[13] << 22) |
			((uint32_t)(input[14] & 0xfe) << 14);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 119 to 135
	value = ((uint32_t)(input[14] & 0x01) << 31) |
			((uint32_t)input[15] << 23) |
			((uint32_t)input[16] << 15);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 136 to 152
	value = ((uint32_t)input[17] << 24) |
			((uint32_t)input[18] << 16) |
			((uint32_t)(input[19] & 0x80) << 8);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 153 to 169
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xc0) << 9);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 170 to 186
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xe0) << 10);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 187 to 203
	value = ((uint32_t)(input[23] & 0x1f) << 27) |
			((uint32_t)input[24] << 19) |
			((uint32_t)(input[25] & 0xf0) << 11);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 204 to 220
	value = ((uint32_t)(input[25] & 0x0f) << 28) |
			((uint32_t)input[26] << 20) |
			((uint32_t)(input[27] & 0xf8) << 12);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 221 to 237
	value = ((uint32_t)(input[27] & 0x07) << 29) |
			((uint32_t)input[28] << 21) |
			((uint32_t)(input[29] & 0xfc) << 13);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 238 to 254
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)(input[31] & 0xfe) << 14);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 255 to 271
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)input[33] << 15);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 272 to 288
	value = ((uint32_t)input[34] << 24) |
			((uint32_t)input[35] << 16) |
			((uint32_t)(input[36] & 0x80) << 8);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 289 to 305
	value = ((uint32_t)(input[36] & 0x7f) << 25) |
			((uint32_t)input[37] << 17) |
			((uint32_t)(input[38] & 0xc0) << 9);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 306 to 322
	value = ((uint32_t)(input[38] & 0x3f) << 26) |
			((uint32_t)input[39] << 18) |
			((uint32_t)(input[40] & 0xe0) << 10);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 323 to 339
	value = ((uint32_t)(input[40] & 0x1f) << 27) |
			((uint32_t)input[41] << 19) |
			((uint32_t)(input[42] & 0xf0) << 11);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 340 to 356
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)(input[44] & 0xf8) << 12);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 357 to 373
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)(input[46] & 0xfc) << 13);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 374 to 390
	value = ((uint32_t)(input[46] & 0x03) << 30) |
			((uint32_t)input[47] << 22) |
			((uint32_t)(input[48] & 0xfe) << 14);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 391 to 407
	value = ((uint32_t)(input[48] & 0x01) << 31) |
			((uint32_t)input[49] << 23) |
			((uint32_t)input[50] << 15);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 408 to 424
	value = ((uint32_t)input[51] << 24) |
			((uint32_t)input[52] << 16) |
			((uint32_t)(input[53] & 0x80) << 8);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 425 to 441
	value = ((uint32_t)(input[53] & 0x7f) << 25) |
			((uint32_t)input[54] << 17) |
			((uint32_t)(input[55] & 0xc0) << 9);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 442 to 458
	value = ((uint32_t)(input[55] & 0x3f) << 26) |
			((uint32_t)input[56] << 18) |
			((uint32_t)(input[57] & 0xe0) << 10);
	output[26] = (double)(value >> 15);

	// read output[27]: from bit 459 to 475
	value = ((uint32_t)(input[57] & 0x1f) << 27) |
			((uint32_t)input[58] << 19) |
			((uint32_t)(input[59] & 0xf0) << 11);
	output[27] = (double)(value >> 15);

	// read output[28]: from bit 476 to 492
	value = ((uint32_t)(input[59] & 0x0f) << 28) |
			((uint32_t)input[60] << 20) |
			((uint32_t)(input[61] & 0xf8) << 12);
	output[28] = (double)(value >> 15);

	// read output[29]: from bit 493 to 509
	value = ((uint32_t)(input[61] & 0x07) << 29) |
			((uint32_t)input[62] << 21) |
			((uint32_t)(input[63] & 0xfc) << 13);
	output[29] = (double)(value >> 15);
}

static void unpack_30_17bit_signed_1off(const uint8_t * input, double * output) {
	// Unpack 30 values into output
	// Values are 17-bit signed
	// Skip 1 bits, read 510 bits of data.
	// Input must be at least 64 bytes long

	int32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 52 to 68
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf8) << 12);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 69 to 85
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xfc) << 13);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 86 to 102
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfe) << 14);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 103 to 119
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 120 to 136
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)(input[17] & 0x80) << 8);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 137 to 153
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)input[18] << 17) |
			((uint32_t)(input[19] & 0xc0) << 9);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 154 to 170
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xe0) << 10);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 171 to 187
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)(input[23] & 0xf0) << 11);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 188 to 204
	value = ((uint32_t)(input[23] & 0x0f) << 28) |
			((uint32_t)input[24] << 20) |
			((uint32_t)(input[25] & 0xf8) << 12);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 205 to 221
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0xfc) << 13);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 222 to 238
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xfe) << 14);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 239 to 255
	value = ((uint32_t)(input[29] & 0x01) << 31) |
			((uint32_t)input[30] << 23) |
			((uint32_t)input[31] << 15);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 256 to 272
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16) |
			((uint32_t)(input[34] & 0x80) << 8);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 273 to 289
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0xc0) << 9);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 290 to 306
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xe0) << 10);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 307 to 323
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xf0) << 11);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 324 to 340
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf8) << 12);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 341 to 357
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xfc) << 13);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 358 to 374
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfe) << 14);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 375 to 391
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)input[48] << 15);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 392 to 408
	value = ((uint32_t)input[49] << 24) |
			((uint32_t)input[50] << 16) |
			((uint32_t)(input[51] & 0x80) << 8);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 409 to 425
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)(input[53] & 0xc0) << 9);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 426 to 442
	value = ((uint32_t)(input[53] & 0x3f) << 26) |
			((uint32_t)input[54] << 18) |
			((uint32_t)(input[55] & 0xe0) << 10);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 443 to 459
	value = ((uint32_t)(input[55] & 0x1f) << 27) |
			((uint32_t)input[56] << 19) |
			((uint32_t)(input[57] & 0xf0) << 11);
	output[26] = (double)(value >> 15);

	// read output[27]: from bit 460 to 476
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20) |
			((uint32_t)(input[59] & 0xf8) << 12);
	output[27] = (double)(value >> 15);

	// read output[28]: from bit 477 to 493
	value = ((uint32_t)(input[59] & 0x07) << 29) |
			((uint32_t)input[60] << 21) |
			((uint32_t)(input[61] & 0xfc) << 13);
	output[28] = (double)(value >> 15);

	// read output[29]: from bit 494 to 510
	value = ((uint32_t)(input[61] & 0x03) << 30) |
			((uint32_t)input[62] << 22) |
			((uint32_t)(input[63] & 0xfe) << 14);
	output[29] = (double)(value >> 15);
}

static void unpack_30_17bit_unsigned_1off(const uint8_t * input, double * output) {
	// Unpack 30 values into output
	// Values are 17-bit unsigned
	// Skip 1 bits, read 510 bits of data.
	// Input must be at least 64 bytes long

	uint32_t value;

	// read output[0]: from bit 1 to 17
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xc0) << 9);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 18 to 34
	value = ((uint32_t)(input[2] & 0x3f) << 26) |
			((uint32_t)input[3] << 18) |
			((uint32_t)(input[4] & 0xe0) << 10);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 35 to 51
	value = ((uint32_t)(input[4] & 0x1f) << 27) |
			((uint32_t)input[5] << 19) |
			((uint32_t)(input[6] & 0xf0) << 11);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 52 to 68
	value = ((uint32_t)(input[6] & 0x0f) << 28) |
			((uint32_t)input[7] << 20) |
			((uint32_t)(input[8] & 0xf8) << 12);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 69 to 85
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)(input[10] & 0xfc) << 13);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 86 to 102
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)(input[12] & 0xfe) << 14);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 103 to 119
	value = ((uint32_t)(input[12] & 0x01) << 31) |
			((uint32_t)input[13] << 23) |
			((uint32_t)input[14] << 15);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 120 to 136
	value = ((uint32_t)input[15] << 24) |
			((uint32_t)input[16] << 16) |
			((uint32_t)(input[17] & 0x80) << 8);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 137 to 153
	value = ((uint32_t)(input[17] & 0x7f) << 25) |
			((uint32_t)input[18] << 17) |
			((uint32_t)(input[19] & 0xc0) << 9);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 154 to 170
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xe0) << 10);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 171 to 187
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)(input[23] & 0xf0) << 11);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 188 to 204
	value = ((uint32_t)(input[23] & 0x0f) << 28) |
			((uint32_t)input[24] << 20) |
			((uint32_t)(input[25] & 0xf8) << 12);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 205 to 221
	value = ((uint32_t)(input[25] & 0x07) << 29) |
			((uint32_t)input[26] << 21) |
			((uint32_t)(input[27] & 0xfc) << 13);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 222 to 238
	value = ((uint32_t)(input[27] & 0x03) << 30) |
			((uint32_t)input[28] << 22) |
			((uint32_t)(input[29] & 0xfe) << 14);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 239 to 255
	value = ((uint32_t)(input[29] & 0x01) << 31) |
			((uint32_t)input[30] << 23) |
			((uint32_t)input[31] << 15);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 256 to 272
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16) |
			((uint32_t)(input[34] & 0x80) << 8);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 273 to 289
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0xc0) << 9);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 290 to 306
	value = ((uint32_t)(input[36] & 0x3f) << 26) |
			((uint32_t)input[37] << 18) |
			((uint32_t)(input[38] & 0xe0) << 10);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 307 to 323
	value = ((uint32_t)(input[38] & 0x1f) << 27) |
			((uint32_t)input[39] << 19) |
			((uint32_t)(input[40] & 0xf0) << 11);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 324 to 340
	value = ((uint32_t)(input[40] & 0x0f) << 28) |
			((uint32_t)input[41] << 20) |
			((uint32_t)(input[42] & 0xf8) << 12);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 341 to 357
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)(input[44] & 0xfc) << 13);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 358 to 374
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)(input[46] & 0xfe) << 14);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 375 to 391
	value = ((uint32_t)(input[46] & 0x01) << 31) |
			((uint32_t)input[47] << 23) |
			((uint32_t)input[48] << 15);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 392 to 408
	value = ((uint32_t)input[49] << 24) |
			((uint32_t)input[50] << 16) |
			((uint32_t)(input[51] & 0x80) << 8);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 409 to 425
	value = ((uint32_t)(input[51] & 0x7f) << 25) |
			((uint32_t)input[52] << 17) |
			((uint32_t)(input[53] & 0xc0) << 9);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 426 to 442
	value = ((uint32_t)(input[53] & 0x3f) << 26) |
			((uint32_t)input[54] << 18) |
			((uint32_t)(input[55] & 0xe0) << 10);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 443 to 459
	value = ((uint32_t)(input[55] & 0x1f) << 27) |
			((uint32_t)input[56] << 19) |
			((uint32_t)(input[57] & 0xf0) << 11);
	output[26] = (double)(value >> 15);

	// read output[27]: from bit 460 to 476
	value = ((uint32_t)(input[57] & 0x0f) << 28) |
			((uint32_t)input[58] << 20) |
			((uint32_t)(input[59] & 0xf8) << 12);
	output[27] = (double)(value >> 15);

	// read output[28]: from bit 477 to 493
	value = ((uint32_t)(input[59] & 0x07) << 29) |
			((uint32_t)input[60] << 21) |
			((uint32_t)(input[61] & 0xfc) << 13);
	output[28] = (double)(value >> 15);

	// read output[29]: from bit 494 to 510
	value = ((uint32_t)(input[61] & 0x03) << 30) |
			((uint32_t)input[62] << 22) |
			((uint32_t)(input[63] & 0xfe) << 14);
	output[29] = (double)(value >> 15);
}

static void unpack_30_17bit_signed_2off(const uint8_t * input, double * output) {
	// Unpack 30 values into output
	// Values are 17-bit signed
	// Skip 2 bits, read 510 bits of data.
	// Input must be at least 64 bytes long

	int32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 53 to 69
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xfc) << 13);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 70 to 86
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfe) << 14);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 87 to 103
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 104 to 120
	value = ((uint32_t)input[13] << 24) |
			((uint32_t)input[14] << 16) |
			((uint32_t)(input[15] & 0x80) << 8);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 121 to 137
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)(input[17] & 0xc0) << 9);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 138 to 154
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)input[18] << 18) |
			((uint32_t)(input[19] & 0xe0) << 10);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 155 to 171
	value = ((uint32_t)(input[19] & 0x1f) << 27) |
			((uint32_t)input[20] << 19) |
			((uint32_t)(input[21] & 0xf0) << 11);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 172 to 188
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)(input[23] & 0xf8) << 12);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 189 to 205
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)(input[25] & 0xfc) << 13);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 206 to 222
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xfe) << 14);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 223 to 239
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 240 to 256
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)(input[32] & 0x80) << 8);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 257 to 273
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0xc0) << 9);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 274 to 290
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xe0) << 10);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 291 to 307
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xf0) << 11);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 308 to 324
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf8) << 12);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 325 to 341
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xfc) << 13);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 342 to 358
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfe) << 14);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 359 to 375
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)input[46] << 15);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 376 to 392
	value = ((uint32_t)input[47] << 24) |
			((uint32_t)input[48] << 16) |
			((uint32_t)(input[49] & 0x80) << 8);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 393 to 409
	value = ((uint32_t)(input[49] & 0x7f) << 25) |
			((uint32_t)input[50] << 17) |
			((uint32_t)(input[51] & 0xc0) << 9);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 410 to 426
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)(input[53] & 0xe0) << 10);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 427 to 443
	value = ((uint32_t)(input[53] & 0x1f) << 27) |
			((uint32_t)input[54] << 19) |
			((uint32_t)(input[55] & 0xf0) << 11);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 444 to 460
	value = ((uint32_t)(input[55] & 0x0f) << 28) |
			((uint32_t)input[56] << 20) |
			((uint32_t)(input[57] & 0xf8) << 12);
	output[26] = (double)(value >> 15);

	// read output[27]: from bit 461 to 477
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)(input[59] & 0xfc) << 13);
	output[27] = (double)(value >> 15);

	// read output[28]: from bit 478 to 494
	value = ((uint32_t)(input[59] & 0x03) << 30) |
			((uint32_t)input[60] << 22) |
			((uint32_t)(input[61] & 0xfe) << 14);
	output[28] = (double)(value >> 15);

	// read output[29]: from bit 495 to 511
	value = ((uint32_t)(input[61] & 0x01) << 31) |
			((uint32_t)input[62] << 23) |
			((uint32_t)input[63] << 15);
	output[29] = (double)(value >> 15);
}

static void unpack_30_17bit_unsigned_2off(const uint8_t * input, double * output) {
	// Unpack 30 values into output
	// Values are 17-bit unsigned
	// Skip 2 bits, read 510 bits of data.
	// Input must be at least 64 bytes long

	uint32_t value;

	// read output[0]: from bit 2 to 18
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xe0) << 10);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 19 to 35
	value = ((uint32_t)(input[2] & 0x1f) << 27) |
			((uint32_t)input[3] << 19) |
			((uint32_t)(input[4] & 0xf0) << 11);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 36 to 52
	value = ((uint32_t)(input[4] & 0x0f) << 28) |
			((uint32_t)input[5] << 20) |
			((uint32_t)(input[6] & 0xf8) << 12);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 53 to 69
	value = ((uint32_t)(input[6] & 0x07) << 29) |
			((uint32_t)input[7] << 21) |
			((uint32_t)(input[8] & 0xfc) << 13);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 70 to 86
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)(input[10] & 0xfe) << 14);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 87 to 103
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 104 to 120
	value = ((uint32_t)input[13] << 24) |
			((uint32_t)input[14] << 16) |
			((uint32_t)(input[15] & 0x80) << 8);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 121 to 137
	value = ((uint32_t)(input[15] & 0x7f) << 25) |
			((uint32_t)input[16] << 17) |
			((uint32_t)(input[17] & 0xc0) << 9);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 138 to 154
	value = ((uint32_t)(input[17] & 0x3f) << 26) |
			((uint32_t)input[18] << 18) |
			((uint32_t)(input[19] & 0xe0) << 10);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 155 to 171
	value = ((uint32_t)(input[19] & 0x1f) << 27) |
			((uint32_t)input[20] << 19) |
			((uint32_t)(input[21] & 0xf0) << 11);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 172 to 188
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)(input[23] & 0xf8) << 12);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 189 to 205
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)(input[25] & 0xfc) << 13);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 206 to 222
	value = ((uint32_t)(input[25] & 0x03) << 30) |
			((uint32_t)input[26] << 22) |
			((uint32_t)(input[27] & 0xfe) << 14);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 223 to 239
	value = ((uint32_t)(input[27] & 0x01) << 31) |
			((uint32_t)input[28] << 23) |
			((uint32_t)input[29] << 15);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 240 to 256
	value = ((uint32_t)input[30] << 24) |
			((uint32_t)input[31] << 16) |
			((uint32_t)(input[32] & 0x80) << 8);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 257 to 273
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0xc0) << 9);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 274 to 290
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xe0) << 10);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 291 to 307
	value = ((uint32_t)(input[36] & 0x1f) << 27) |
			((uint32_t)input[37] << 19) |
			((uint32_t)(input[38] & 0xf0) << 11);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 308 to 324
	value = ((uint32_t)(input[38] & 0x0f) << 28) |
			((uint32_t)input[39] << 20) |
			((uint32_t)(input[40] & 0xf8) << 12);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 325 to 341
	value = ((uint32_t)(input[40] & 0x07) << 29) |
			((uint32_t)input[41] << 21) |
			((uint32_t)(input[42] & 0xfc) << 13);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 342 to 358
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)(input[44] & 0xfe) << 14);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 359 to 375
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)input[46] << 15);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 376 to 392
	value = ((uint32_t)input[47] << 24) |
			((uint32_t)input[48] << 16) |
			((uint32_t)(input[49] & 0x80) << 8);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 393 to 409
	value = ((uint32_t)(input[49] & 0x7f) << 25) |
			((uint32_t)input[50] << 17) |
			((uint32_t)(input[51] & 0xc0) << 9);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 410 to 426
	value = ((uint32_t)(input[51] & 0x3f) << 26) |
			((uint32_t)input[52] << 18) |
			((uint32_t)(input[53] & 0xe0) << 10);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 427 to 443
	value = ((uint32_t)(input[53] & 0x1f) << 27) |
			((uint32_t)input[54] << 19) |
			((uint32_t)(input[55] & 0xf0) << 11);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 444 to 460
	value = ((uint32_t)(input[55] & 0x0f) << 28) |
			((uint32_t)input[56] << 20) |
			((uint32_t)(input[57] & 0xf8) << 12);
	output[26] = (double)(value >> 15);

	// read output[27]: from bit 461 to 477
	value = ((uint32_t)(input[57] & 0x07) << 29) |
			((uint32_t)input[58] << 21) |
			((uint32_t)(input[59] & 0xfc) << 13);
	output[27] = (double)(value >> 15);

	// read output[28]: from bit 478 to 494
	value = ((uint32_t)(input[59] & 0x03) << 30) |
			((uint32_t)input[60] << 22) |
			((uint32_t)(input[61] & 0xfe) << 14);
	output[28] = (double)(value >> 15);

	// read output[29]: from bit 495 to 511
	value = ((uint32_t)(input[61] & 0x01) << 31) |
			((uint32_t)input[62] << 23) |
			((uint32_t)input[63] << 15);
	output[29] = (double)(value >> 15);
}

static void unpack_30_17bit_signed_3off(const uint8_t * input, double * output) {
	// Unpack 30 values into output
	// Values are 17-bit signed
	// Skip 3 bits, read 510 bits of data.
	// Input must be at least 65 bytes long

	int32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 54 to 70
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfe) << 14);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 71 to 87
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)input[10] << 15);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 88 to 104
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0x80) << 8);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 105 to 121
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xc0) << 9);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 122 to 138
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)(input[17] & 0xe0) << 10);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 139 to 155
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)input[18] << 19) |
			((uint32_t)(input[19] & 0xf0) << 11);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 156 to 172
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20) |
			((uint32_t)(input[21] & 0xf8) << 12);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 173 to 189
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0xfc) << 13);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 190 to 206
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)(input[25] & 0xfe) << 14);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 207 to 223
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)input[27] << 15);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 224 to 240
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16) |
			((uint32_t)(input[30] & 0x80) << 8);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 241 to 257
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0xc0) << 9);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 258 to 274
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xe0) << 10);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 275 to 291
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xf0) << 11);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 292 to 308
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf8) << 12);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 309 to 325
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xfc) << 13);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 326 to 342
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfe) << 14);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 343 to 359
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 360 to 376
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)(input[47] & 0x80) << 8);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 377 to 393
	value = ((uint32_t)(input[47] & 0x7f) << 25) |
			((uint32_t)input[48] << 17) |
			((uint32_t)(input[49] & 0xc0) << 9);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 394 to 410
	value = ((uint32_t)(input[49] & 0x3f) << 26) |
			((uint32_t)input[50] << 18) |
			((uint32_t)(input[51] & 0xe0) << 10);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 411 to 427
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)(input[53] & 0xf0) << 11);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 428 to 444
	value = ((uint32_t)(input[53] & 0x0f) << 28) |
			((uint32_t)input[54] << 20) |
			((uint32_t)(input[55] & 0xf8) << 12);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 445 to 461
	value = ((uint32_t)(input[55] & 0x07) << 29) |
			((uint32_t)input[56] << 21) |
			((uint32_t)(input[57] & 0xfc) << 13);
	output[26] = (double)(value >> 15);

	// read output[27]: from bit 462 to 478
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)(input[59] & 0xfe) << 14);
	output[27] = (double)(value >> 15);

	// read output[28]: from bit 479 to 495
	value = ((uint32_t)(input[59] & 0x01) << 31) |
			((uint32_t)input[60] << 23) |
			((uint32_t)input[61] << 15);
	output[28] = (double)(value >> 15);

	// read output[29]: from bit 496 to 512
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16) |
			((uint32_t)(input[64] & 0x80) << 8);
	output[29] = (double)(value >> 15);
}

static void unpack_30_17bit_unsigned_3off(const uint8_t * input, double * output) {
	// Unpack 30 values into output
	// Values are 17-bit unsigned
	// Skip 3 bits, read 510 bits of data.
	// Input must be at least 65 bytes long

	uint32_t value;

	// read output[0]: from bit 3 to 19
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)(input[2] & 0xf0) << 11);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 20 to 36
	value = ((uint32_t)(input[2] & 0x0f) << 28) |
			((uint32_t)input[3] << 20) |
			((uint32_t)(input[4] & 0xf8) << 12);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 37 to 53
	value = ((uint32_t)(input[4] & 0x07) << 29) |
			((uint32_t)input[5] << 21) |
			((uint32_t)(input[6] & 0xfc) << 13);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 54 to 70
	value = ((uint32_t)(input[6] & 0x03) << 30) |
			((uint32_t)input[7] << 22) |
			((uint32_t)(input[8] & 0xfe) << 14);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 71 to 87
	value = ((uint32_t)(input[8] & 0x01) << 31) |
			((uint32_t)input[9] << 23) |
			((uint32_t)input[10] << 15);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 88 to 104
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0x80) << 8);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 105 to 121
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xc0) << 9);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 122 to 138
	value = ((uint32_t)(input[15] & 0x3f) << 26) |
			((uint32_t)input[16] << 18) |
			((uint32_t)(input[17] & 0xe0) << 10);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 139 to 155
	value = ((uint32_t)(input[17] & 0x1f) << 27) |
			((uint32_t)input[18] << 19) |
			((uint32_t)(input[19] & 0xf0) << 11);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 156 to 172
	value = ((uint32_t)(input[19] & 0x0f) << 28) |
			((uint32_t)input[20] << 20) |
			((uint32_t)(input[21] & 0xf8) << 12);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 173 to 189
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)(input[23] & 0xfc) << 13);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 190 to 206
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)(input[25] & 0xfe) << 14);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 207 to 223
	value = ((uint32_t)(input[25] & 0x01) << 31) |
			((uint32_t)input[26] << 23) |
			((uint32_t)input[27] << 15);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 224 to 240
	value = ((uint32_t)input[28] << 24) |
			((uint32_t)input[29] << 16) |
			((uint32_t)(input[30] & 0x80) << 8);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 241 to 257
	value = ((uint32_t)(input[30] & 0x7f) << 25) |
			((uint32_t)input[31] << 17) |
			((uint32_t)(input[32] & 0xc0) << 9);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 258 to 274
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xe0) << 10);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 275 to 291
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)(input[36] & 0xf0) << 11);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 292 to 308
	value = ((uint32_t)(input[36] & 0x0f) << 28) |
			((uint32_t)input[37] << 20) |
			((uint32_t)(input[38] & 0xf8) << 12);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 309 to 325
	value = ((uint32_t)(input[38] & 0x07) << 29) |
			((uint32_t)input[39] << 21) |
			((uint32_t)(input[40] & 0xfc) << 13);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 326 to 342
	value = ((uint32_t)(input[40] & 0x03) << 30) |
			((uint32_t)input[41] << 22) |
			((uint32_t)(input[42] & 0xfe) << 14);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 343 to 359
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 360 to 376
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)(input[47] & 0x80) << 8);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 377 to 393
	value = ((uint32_t)(input[47] & 0x7f) << 25) |
			((uint32_t)input[48] << 17) |
			((uint32_t)(input[49] & 0xc0) << 9);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 394 to 410
	value = ((uint32_t)(input[49] & 0x3f) << 26) |
			((uint32_t)input[50] << 18) |
			((uint32_t)(input[51] & 0xe0) << 10);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 411 to 427
	value = ((uint32_t)(input[51] & 0x1f) << 27) |
			((uint32_t)input[52] << 19) |
			((uint32_t)(input[53] & 0xf0) << 11);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 428 to 444
	value = ((uint32_t)(input[53] & 0x0f) << 28) |
			((uint32_t)input[54] << 20) |
			((uint32_t)(input[55] & 0xf8) << 12);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 445 to 461
	value = ((uint32_t)(input[55] & 0x07) << 29) |
			((uint32_t)input[56] << 21) |
			((uint32_t)(input[57] & 0xfc) << 13);
	output[26] = (double)(value >> 15);

	// read output[27]: from bit 462 to 478
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)(input[59] & 0xfe) << 14);
	output[27] = (double)(value >> 15);

	// read output[28]: from bit 479 to 495
	value = ((uint32_t)(input[59] & 0x01) << 31) |
			((uint32_t)input[60] << 23) |
			((uint32_t)input[61] << 15);
	output[28] = (double)(value >> 15);

	// read output[29]: from bit 496 to 512
	value = ((uint32_t)input[62] << 24) |
			((uint32_t)input[63] << 16) |
			((uint32_t)(input[64] & 0x80) << 8);
	output[29] = (double)(value >> 15);
}

static void unpack_30_17bit_signed_4off(const uint8_t * input, double * output) {
	// Unpack 30 values into output
	// Values are 17-bit signed
	// Skip 4 bits, read 510 bits of data.
	// Input must be at least 65 bytes long

	int32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 55 to 71
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 72 to 88
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)(input[11] & 0x80) << 8);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 89 to 105
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xc0) << 9);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 106 to 122
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xe0) << 10);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 123 to 139
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)(input[17] & 0xf0) << 11);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 140 to 156
	value = ((uint32_t)(input[17] & 0x0f) << 28) |
			((uint32_t)input[18] << 20) |
			((uint32_t)(input[19] & 0xf8) << 12);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 157 to 173
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0xfc) << 13);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 174 to 190
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xfe) << 14);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 191 to 207
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 208 to 224
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16) |
			((uint32_t)(input[28] & 0x80) << 8);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 225 to 241
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0xc0) << 9);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 242 to 258
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xe0) << 10);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 259 to 275
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xf0) << 11);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 276 to 292
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf8) << 12);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 293 to 309
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xfc) << 13);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 310 to 326
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfe) << 14);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 327 to 343
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)input[42] << 15);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 344 to 360
	value = ((uint32_t)input[43] << 24) |
			((uint32_t)input[44] << 16) |
			((uint32_t)(input[45] & 0x80) << 8);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 361 to 377
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)(input[47] & 0xc0) << 9);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 378 to 394
	value = ((uint32_t)(input[47] & 0x3f) << 26) |
			((uint32_t)input[48] << 18) |
			((uint32_t)(input[49] & 0xe0) << 10);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 395 to 411
	value = ((uint32_t)(input[49] & 0x1f) << 27) |
			((uint32_t)input[50] << 19) |
			((uint32_t)(input[51] & 0xf0) << 11);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 412 to 428
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)(input[53] & 0xf8) << 12);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 429 to 445
	value = ((uint32_t)(input[53] & 0x07) << 29) |
			((uint32_t)input[54] << 21) |
			((uint32_t)(input[55] & 0xfc) << 13);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 446 to 462
	value = ((uint32_t)(input[55] & 0x03) << 30) |
			((uint32_t)input[56] << 22) |
			((uint32_t)(input[57] & 0xfe) << 14);
	output[26] = (double)(value >> 15);

	// read output[27]: from bit 463 to 479
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15);
	output[27] = (double)(value >> 15);

	// read output[28]: from bit 480 to 496
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16) |
			((uint32_t)(input[62] & 0x80) << 8);
	output[28] = (double)(value >> 15);

	// read output[29]: from bit 497 to 513
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0xc0) << 9);
	output[29] = (double)(value >> 15);
}

static void unpack_30_17bit_unsigned_4off(const uint8_t * input, double * output) {
	// Unpack 30 values into output
	// Values are 17-bit unsigned
	// Skip 4 bits, read 510 bits of data.
	// Input must be at least 65 bytes long

	uint32_t value;

	// read output[0]: from bit 4 to 20
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)(input[2] & 0xf8) << 12);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 21 to 37
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)(input[4] & 0xfc) << 13);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 38 to 54
	value = ((uint32_t)(input[4] & 0x03) << 30) |
			((uint32_t)input[5] << 22) |
			((uint32_t)(input[6] & 0xfe) << 14);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 55 to 71
	value = ((uint32_t)(input[6] & 0x01) << 31) |
			((uint32_t)input[7] << 23) |
			((uint32_t)input[8] << 15);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 72 to 88
	value = ((uint32_t)input[9] << 24) |
			((uint32_t)input[10] << 16) |
			((uint32_t)(input[11] & 0x80) << 8);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 89 to 105
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xc0) << 9);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 106 to 122
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xe0) << 10);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 123 to 139
	value = ((uint32_t)(input[15] & 0x1f) << 27) |
			((uint32_t)input[16] << 19) |
			((uint32_t)(input[17] & 0xf0) << 11);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 140 to 156
	value = ((uint32_t)(input[17] & 0x0f) << 28) |
			((uint32_t)input[18] << 20) |
			((uint32_t)(input[19] & 0xf8) << 12);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 157 to 173
	value = ((uint32_t)(input[19] & 0x07) << 29) |
			((uint32_t)input[20] << 21) |
			((uint32_t)(input[21] & 0xfc) << 13);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 174 to 190
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)(input[23] & 0xfe) << 14);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 191 to 207
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 208 to 224
	value = ((uint32_t)input[26] << 24) |
			((uint32_t)input[27] << 16) |
			((uint32_t)(input[28] & 0x80) << 8);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 225 to 241
	value = ((uint32_t)(input[28] & 0x7f) << 25) |
			((uint32_t)input[29] << 17) |
			((uint32_t)(input[30] & 0xc0) << 9);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 242 to 258
	value = ((uint32_t)(input[30] & 0x3f) << 26) |
			((uint32_t)input[31] << 18) |
			((uint32_t)(input[32] & 0xe0) << 10);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 259 to 275
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)(input[34] & 0xf0) << 11);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 276 to 292
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)(input[36] & 0xf8) << 12);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 293 to 309
	value = ((uint32_t)(input[36] & 0x07) << 29) |
			((uint32_t)input[37] << 21) |
			((uint32_t)(input[38] & 0xfc) << 13);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 310 to 326
	value = ((uint32_t)(input[38] & 0x03) << 30) |
			((uint32_t)input[39] << 22) |
			((uint32_t)(input[40] & 0xfe) << 14);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 327 to 343
	value = ((uint32_t)(input[40] & 0x01) << 31) |
			((uint32_t)input[41] << 23) |
			((uint32_t)input[42] << 15);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 344 to 360
	value = ((uint32_t)input[43] << 24) |
			((uint32_t)input[44] << 16) |
			((uint32_t)(input[45] & 0x80) << 8);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 361 to 377
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)(input[47] & 0xc0) << 9);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 378 to 394
	value = ((uint32_t)(input[47] & 0x3f) << 26) |
			((uint32_t)input[48] << 18) |
			((uint32_t)(input[49] & 0xe0) << 10);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 395 to 411
	value = ((uint32_t)(input[49] & 0x1f) << 27) |
			((uint32_t)input[50] << 19) |
			((uint32_t)(input[51] & 0xf0) << 11);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 412 to 428
	value = ((uint32_t)(input[51] & 0x0f) << 28) |
			((uint32_t)input[52] << 20) |
			((uint32_t)(input[53] & 0xf8) << 12);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 429 to 445
	value = ((uint32_t)(input[53] & 0x07) << 29) |
			((uint32_t)input[54] << 21) |
			((uint32_t)(input[55] & 0xfc) << 13);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 446 to 462
	value = ((uint32_t)(input[55] & 0x03) << 30) |
			((uint32_t)input[56] << 22) |
			((uint32_t)(input[57] & 0xfe) << 14);
	output[26] = (double)(value >> 15);

	// read output[27]: from bit 463 to 479
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15);
	output[27] = (double)(value >> 15);

	// read output[28]: from bit 480 to 496
	value = ((uint32_t)input[60] << 24) |
			((uint32_t)input[61] << 16) |
			((uint32_t)(input[62] & 0x80) << 8);
	output[28] = (double)(value >> 15);

	// read output[29]: from bit 497 to 513
	value = ((uint32_t)(input[62] & 0x7f) << 25) |
			((uint32_t)input[63] << 17) |
			((uint32_t)(input[64] & 0xc0) << 9);
	output[29] = (double)(value >> 15);
}

static void unpack_30_17bit_signed_5off(const uint8_t * input, double * output) {
	// Unpack 30 values into output
	// Values are 17-bit signed
	// Skip 5 bits, read 510 bits of data.
	// Input must be at least 65 bytes long

	int32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 56 to 72
	value = ((uint32_t)input[7] << 24) |
			((uint32_t)input[8] << 16) |
			((uint32_t)(input[9] & 0x80) << 8);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 73 to 89
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)(input[11] & 0xc0) << 9);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 90 to 106
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xe0) << 10);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 107 to 123
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)(input[15] & 0xf0) << 11);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 124 to 140
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)(input[17] & 0xf8) << 12);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 141 to 157
	value = ((uint32_t)(input[17] & 0x07) << 29) |
			((uint32_t)input[18] << 21) |
			((uint32_t)(input[19] & 0xfc) << 13);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 158 to 174
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xfe) << 14);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 175 to 191
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 192 to 208
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0x80) << 8);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 209 to 225
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0xc0) << 9);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 226 to 242
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xe0) << 10);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 243 to 259
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xf0) << 11);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 260 to 276
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf8) << 12);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 277 to 293
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xfc) << 13);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 294 to 310
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfe) << 14);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 311 to 327
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)input[40] << 15);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 328 to 344
	value = ((uint32_t)input[41] << 24) |
			((uint32_t)input[42] << 16) |
			((uint32_t)(input[43] & 0x80) << 8);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 345 to 361
	value = ((uint32_t)(input[43] & 0x7f) << 25) |
			((uint32_t)input[44] << 17) |
			((uint32_t)(input[45] & 0xc0) << 9);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 362 to 378
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)(input[47] & 0xe0) << 10);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 379 to 395
	value = ((uint32_t)(input[47] & 0x1f) << 27) |
			((uint32_t)input[48] << 19) |
			((uint32_t)(input[49] & 0xf0) << 11);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 396 to 412
	value = ((uint32_t)(input[49] & 0x0f) << 28) |
			((uint32_t)input[50] << 20) |
			((uint32_t)(input[51] & 0xf8) << 12);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 413 to 429
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)(input[53] & 0xfc) << 13);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 430 to 446
	value = ((uint32_t)(input[53] & 0x03) << 30) |
			((uint32_t)input[54] << 22) |
			((uint32_t)(input[55] & 0xfe) << 14);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 447 to 463
	value = ((uint32_t)(input[55] & 0x01) << 31) |
			((uint32_t)input[56] << 23) |
			((uint32_t)input[57] << 15);
	output[26] = (double)(value >> 15);

	// read output[27]: from bit 464 to 480
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16) |
			((uint32_t)(input[60] & 0x80) << 8);
	output[27] = (double)(value >> 15);

	// read output[28]: from bit 481 to 497
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0xc0) << 9);
	output[28] = (double)(value >> 15);

	// read output[29]: from bit 498 to 514
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xe0) << 10);
	output[29] = (double)(value >> 15);
}

static void unpack_30_17bit_unsigned_5off(const uint8_t * input, double * output) {
	// Unpack 30 values into output
	// Values are 17-bit unsigned
	// Skip 5 bits, read 510 bits of data.
	// Input must be at least 65 bytes long

	uint32_t value;

	// read output[0]: from bit 5 to 21
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)(input[2] & 0xfc) << 13);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 22 to 38
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)(input[4] & 0xfe) << 14);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 39 to 55
	value = ((uint32_t)(input[4] & 0x01) << 31) |
			((uint32_t)input[5] << 23) |
			((uint32_t)input[6] << 15);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 56 to 72
	value = ((uint32_t)input[7] << 24) |
			((uint32_t)input[8] << 16) |
			((uint32_t)(input[9] & 0x80) << 8);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 73 to 89
	value = ((uint32_t)(input[9] & 0x7f) << 25) |
			((uint32_t)input[10] << 17) |
			((uint32_t)(input[11] & 0xc0) << 9);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 90 to 106
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xe0) << 10);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 107 to 123
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)(input[15] & 0xf0) << 11);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 124 to 140
	value = ((uint32_t)(input[15] & 0x0f) << 28) |
			((uint32_t)input[16] << 20) |
			((uint32_t)(input[17] & 0xf8) << 12);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 141 to 157
	value = ((uint32_t)(input[17] & 0x07) << 29) |
			((uint32_t)input[18] << 21) |
			((uint32_t)(input[19] & 0xfc) << 13);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 158 to 174
	value = ((uint32_t)(input[19] & 0x03) << 30) |
			((uint32_t)input[20] << 22) |
			((uint32_t)(input[21] & 0xfe) << 14);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 175 to 191
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 192 to 208
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0x80) << 8);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 209 to 225
	value = ((uint32_t)(input[26] & 0x7f) << 25) |
			((uint32_t)input[27] << 17) |
			((uint32_t)(input[28] & 0xc0) << 9);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 226 to 242
	value = ((uint32_t)(input[28] & 0x3f) << 26) |
			((uint32_t)input[29] << 18) |
			((uint32_t)(input[30] & 0xe0) << 10);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 243 to 259
	value = ((uint32_t)(input[30] & 0x1f) << 27) |
			((uint32_t)input[31] << 19) |
			((uint32_t)(input[32] & 0xf0) << 11);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 260 to 276
	value = ((uint32_t)(input[32] & 0x0f) << 28) |
			((uint32_t)input[33] << 20) |
			((uint32_t)(input[34] & 0xf8) << 12);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 277 to 293
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)(input[36] & 0xfc) << 13);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 294 to 310
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)(input[38] & 0xfe) << 14);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 311 to 327
	value = ((uint32_t)(input[38] & 0x01) << 31) |
			((uint32_t)input[39] << 23) |
			((uint32_t)input[40] << 15);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 328 to 344
	value = ((uint32_t)input[41] << 24) |
			((uint32_t)input[42] << 16) |
			((uint32_t)(input[43] & 0x80) << 8);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 345 to 361
	value = ((uint32_t)(input[43] & 0x7f) << 25) |
			((uint32_t)input[44] << 17) |
			((uint32_t)(input[45] & 0xc0) << 9);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 362 to 378
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)(input[47] & 0xe0) << 10);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 379 to 395
	value = ((uint32_t)(input[47] & 0x1f) << 27) |
			((uint32_t)input[48] << 19) |
			((uint32_t)(input[49] & 0xf0) << 11);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 396 to 412
	value = ((uint32_t)(input[49] & 0x0f) << 28) |
			((uint32_t)input[50] << 20) |
			((uint32_t)(input[51] & 0xf8) << 12);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 413 to 429
	value = ((uint32_t)(input[51] & 0x07) << 29) |
			((uint32_t)input[52] << 21) |
			((uint32_t)(input[53] & 0xfc) << 13);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 430 to 446
	value = ((uint32_t)(input[53] & 0x03) << 30) |
			((uint32_t)input[54] << 22) |
			((uint32_t)(input[55] & 0xfe) << 14);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 447 to 463
	value = ((uint32_t)(input[55] & 0x01) << 31) |
			((uint32_t)input[56] << 23) |
			((uint32_t)input[57] << 15);
	output[26] = (double)(value >> 15);

	// read output[27]: from bit 464 to 480
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16) |
			((uint32_t)(input[60] & 0x80) << 8);
	output[27] = (double)(value >> 15);

	// read output[28]: from bit 481 to 497
	value = ((uint32_t)(input[60] & 0x7f) << 25) |
			((uint32_t)input[61] << 17) |
			((uint32_t)(input[62] & 0xc0) << 9);
	output[28] = (double)(value >> 15);

	// read output[29]: from bit 498 to 514
	value = ((uint32_t)(input[62] & 0x3f) << 26) |
			((uint32_t)input[63] << 18) |
			((uint32_t)(input[64] & 0xe0) << 10);
	output[29] = (double)(value >> 15);
}

static void unpack_30_17bit_signed_6off(const uint8_t * input, double * output) {
	// Unpack 30 values into output
	// Values are 17-bit signed
	// Skip 6 bits, read 510 bits of data.
	// Input must be at least 65 bytes long

	int32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 57 to 73
	value = ((uint32_t)(input[7] & 0x7f) << 25) |
			((uint32_t)input[8] << 17) |
			((uint32_t)(input[9] & 0xc0) << 9);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 74 to 90
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)(input[11] & 0xe0) << 10);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 91 to 107
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)(input[13] & 0xf0) << 11);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 108 to 124
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)(input[15] & 0xf8) << 12);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 125 to 141
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0xfc) << 13);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 142 to 158
	value = ((uint32_t)(input[17] & 0x03) << 30) |
			((uint32_t)input[18] << 22) |
			((uint32_t)(input[19] & 0xfe) << 14);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 159 to 175
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)input[21] << 15);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 176 to 192
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16) |
			((uint32_t)(input[24] & 0x80) << 8);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 193 to 209
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xc0) << 9);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 210 to 226
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xe0) << 10);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 227 to 243
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xf0) << 11);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 244 to 260
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf8) << 12);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 261 to 277
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xfc) << 13);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 278 to 294
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfe) << 14);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 295 to 311
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 312 to 328
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)(input[41] & 0x80) << 8);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 329 to 345
	value = ((uint32_t)(input[41] & 0x7f) << 25) |
			((uint32_t)input[42] << 17) |
			((uint32_t)(input[43] & 0xc0) << 9);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 346 to 362
	value = ((uint32_t)(input[43] & 0x3f) << 26) |
			((uint32_t)input[44] << 18) |
			((uint32_t)(input[45] & 0xe0) << 10);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 363 to 379
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)(input[47] & 0xf0) << 11);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 380 to 396
	value = ((uint32_t)(input[47] & 0x0f) << 28) |
			((uint32_t)input[48] << 20) |
			((uint32_t)(input[49] & 0xf8) << 12);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 397 to 413
	value = ((uint32_t)(input[49] & 0x07) << 29) |
			((uint32_t)input[50] << 21) |
			((uint32_t)(input[51] & 0xfc) << 13);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 414 to 430
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)(input[53] & 0xfe) << 14);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 431 to 447
	value = ((uint32_t)(input[53] & 0x01) << 31) |
			((uint32_t)input[54] << 23) |
			((uint32_t)input[55] << 15);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 448 to 464
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16) |
			((uint32_t)(input[58] & 0x80) << 8);
	output[26] = (double)(value >> 15);

	// read output[27]: from bit 465 to 481
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0xc0) << 9);
	output[27] = (double)(value >> 15);

	// read output[28]: from bit 482 to 498
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xe0) << 10);
	output[28] = (double)(value >> 15);

	// read output[29]: from bit 499 to 515
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xf0) << 11);
	output[29] = (double)(value >> 15);
}

static void unpack_30_17bit_unsigned_6off(const uint8_t * input, double * output) {
	// Unpack 30 values into output
	// Values are 17-bit unsigned
	// Skip 6 bits, read 510 bits of data.
	// Input must be at least 65 bytes long

	uint32_t value;

	// read output[0]: from bit 6 to 22
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)(input[2] & 0xfe) << 14);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 23 to 39
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 40 to 56
	value = ((uint32_t)input[5] << 24) |
			((uint32_t)input[6] << 16) |
			((uint32_t)(input[7] & 0x80) << 8);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 57 to 73
	value = ((uint32_t)(input[7] & 0x7f) << 25) |
			((uint32_t)input[8] << 17) |
			((uint32_t)(input[9] & 0xc0) << 9);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 74 to 90
	value = ((uint32_t)(input[9] & 0x3f) << 26) |
			((uint32_t)input[10] << 18) |
			((uint32_t)(input[11] & 0xe0) << 10);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 91 to 107
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)(input[13] & 0xf0) << 11);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 108 to 124
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)(input[15] & 0xf8) << 12);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 125 to 141
	value = ((uint32_t)(input[15] & 0x07) << 29) |
			((uint32_t)input[16] << 21) |
			((uint32_t)(input[17] & 0xfc) << 13);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 142 to 158
	value = ((uint32_t)(input[17] & 0x03) << 30) |
			((uint32_t)input[18] << 22) |
			((uint32_t)(input[19] & 0xfe) << 14);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 159 to 175
	value = ((uint32_t)(input[19] & 0x01) << 31) |
			((uint32_t)input[20] << 23) |
			((uint32_t)input[21] << 15);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 176 to 192
	value = ((uint32_t)input[22] << 24) |
			((uint32_t)input[23] << 16) |
			((uint32_t)(input[24] & 0x80) << 8);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 193 to 209
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xc0) << 9);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 210 to 226
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xe0) << 10);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 227 to 243
	value = ((uint32_t)(input[28] & 0x1f) << 27) |
			((uint32_t)input[29] << 19) |
			((uint32_t)(input[30] & 0xf0) << 11);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 244 to 260
	value = ((uint32_t)(input[30] & 0x0f) << 28) |
			((uint32_t)input[31] << 20) |
			((uint32_t)(input[32] & 0xf8) << 12);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 261 to 277
	value = ((uint32_t)(input[32] & 0x07) << 29) |
			((uint32_t)input[33] << 21) |
			((uint32_t)(input[34] & 0xfc) << 13);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 278 to 294
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)(input[36] & 0xfe) << 14);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 295 to 311
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 312 to 328
	value = ((uint32_t)input[39] << 24) |
			((uint32_t)input[40] << 16) |
			((uint32_t)(input[41] & 0x80) << 8);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 329 to 345
	value = ((uint32_t)(input[41] & 0x7f) << 25) |
			((uint32_t)input[42] << 17) |
			((uint32_t)(input[43] & 0xc0) << 9);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 346 to 362
	value = ((uint32_t)(input[43] & 0x3f) << 26) |
			((uint32_t)input[44] << 18) |
			((uint32_t)(input[45] & 0xe0) << 10);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 363 to 379
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)(input[47] & 0xf0) << 11);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 380 to 396
	value = ((uint32_t)(input[47] & 0x0f) << 28) |
			((uint32_t)input[48] << 20) |
			((uint32_t)(input[49] & 0xf8) << 12);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 397 to 413
	value = ((uint32_t)(input[49] & 0x07) << 29) |
			((uint32_t)input[50] << 21) |
			((uint32_t)(input[51] & 0xfc) << 13);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 414 to 430
	value = ((uint32_t)(input[51] & 0x03) << 30) |
			((uint32_t)input[52] << 22) |
			((uint32_t)(input[53] & 0xfe) << 14);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 431 to 447
	value = ((uint32_t)(input[53] & 0x01) << 31) |
			((uint32_t)input[54] << 23) |
			((uint32_t)input[55] << 15);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 448 to 464
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16) |
			((uint32_t)(input[58] & 0x80) << 8);
	output[26] = (double)(value >> 15);

	// read output[27]: from bit 465 to 481
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0xc0) << 9);
	output[27] = (double)(value >> 15);

	// read output[28]: from bit 482 to 498
	value = ((uint32_t)(input[60] & 0x3f) << 26) |
			((uint32_t)input[61] << 18) |
			((uint32_t)(input[62] & 0xe0) << 10);
	output[28] = (double)(value >> 15);

	// read output[29]: from bit 499 to 515
	value = ((uint32_t)(input[62] & 0x1f) << 27) |
			((uint32_t)input[63] << 19) |
			((uint32_t)(input[64] & 0xf0) << 11);
	output[29] = (double)(value >> 15);
}

static void unpack_30_17bit_signed_7off(const uint8_t * input, double * output) {
	// Unpack 30 values into output
	// Values are 17-bit signed
	// Skip 7 bits, read 510 bits of data.
	// Input must be at least 65 bytes long

	int32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 58 to 74
	value = ((uint32_t)(input[7] & 0x3f) << 26) |
			((uint32_t)input[8] << 18) |
			((uint32_t)(input[9] & 0xe0) << 10);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 75 to 91
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)(input[11] & 0xf0) << 11);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 92 to 108
	value = ((uint32_t)(input[11] & 0x0f) << 28) |
			((uint32_t)input[12] << 20) |
			((uint32_t)(input[13] & 0xf8) << 12);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 109 to 125
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0xfc) << 13);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 126 to 142
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xfe) << 14);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 143 to 159
	value = ((uint32_t)(input[17] & 0x01) << 31) |
			((uint32_t)input[18] << 23) |
			((uint32_t)input[19] << 15);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 160 to 176
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16) |
			((uint32_t)(input[22] & 0x80) << 8);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 177 to 193
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0xc0) << 9);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 194 to 210
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xe0) << 10);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 211 to 227
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xf0) << 11);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 228 to 244
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf8) << 12);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 245 to 261
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xfc) << 13);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 262 to 278
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfe) << 14);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 279 to 295
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)input[36] << 15);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 296 to 312
	value = ((uint32_t)input[37] << 24) |
			((uint32_t)input[38] << 16) |
			((uint32_t)(input[39] & 0x80) << 8);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 313 to 329
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)(input[41] & 0xc0) << 9);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 330 to 346
	value = ((uint32_t)(input[41] & 0x3f) << 26) |
			((uint32_t)input[42] << 18) |
			((uint32_t)(input[43] & 0xe0) << 10);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 347 to 363
	value = ((uint32_t)(input[43] & 0x1f) << 27) |
			((uint32_t)input[44] << 19) |
			((uint32_t)(input[45] & 0xf0) << 11);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 364 to 380
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)(input[47] & 0xf8) << 12);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 381 to 397
	value = ((uint32_t)(input[47] & 0x07) << 29) |
			((uint32_t)input[48] << 21) |
			((uint32_t)(input[49] & 0xfc) << 13);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 398 to 414
	value = ((uint32_t)(input[49] & 0x03) << 30) |
			((uint32_t)input[50] << 22) |
			((uint32_t)(input[51] & 0xfe) << 14);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 415 to 431
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 432 to 448
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)(input[56] & 0x80) << 8);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 449 to 465
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0xc0) << 9);
	output[26] = (double)(value >> 15);

	// read output[27]: from bit 466 to 482
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xe0) << 10);
	output[27] = (double)(value >> 15);

	// read output[28]: from bit 483 to 499
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xf0) << 11);
	output[28] = (double)(value >> 15);

	// read output[29]: from bit 500 to 516
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf8) << 12);
	output[29] = (double)(value >> 15);
}

static void unpack_30_17bit_unsigned_7off(const uint8_t * input, double * output) {
	// Unpack 30 values into output
	// Values are 17-bit unsigned
	// Skip 7 bits, read 510 bits of data.
	// Input must be at least 65 bytes long

	uint32_t value;

	// read output[0]: from bit 7 to 23
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15);
	output[0] = (double)(value >> 15);

	// read output[1]: from bit 24 to 40
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0x80) << 8);
	output[1] = (double)(value >> 15);

	// read output[2]: from bit 41 to 57
	value = ((uint32_t)(input[5] & 0x7f) << 25) |
			((uint32_t)input[6] << 17) |
			((uint32_t)(input[7] & 0xc0) << 9);
	output[2] = (double)(value >> 15);

	// read output[3]: from bit 58 to 74
	value = ((uint32_t)(input[7] & 0x3f) << 26) |
			((uint32_t)input[8] << 18) |
			((uint32_t)(input[9] & 0xe0) << 10);
	output[3] = (double)(value >> 15);

	// read output[4]: from bit 75 to 91
	value = ((uint32_t)(input[9] & 0x1f) << 27) |
			((uint32_t)input[10] << 19) |
			((uint32_t)(input[11] & 0xf0) << 11);
	output[4] = (double)(value >> 15);

	// read output[5]: from bit 92 to 108
	value = ((uint32_t)(input[11] & 0x0f) << 28) |
			((uint32_t)input[12] << 20) |
			((uint32_t)(input[13] & 0xf8) << 12);
	output[5] = (double)(value >> 15);

	// read output[6]: from bit 109 to 125
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)(input[15] & 0xfc) << 13);
	output[6] = (double)(value >> 15);

	// read output[7]: from bit 126 to 142
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)(input[17] & 0xfe) << 14);
	output[7] = (double)(value >> 15);

	// read output[8]: from bit 143 to 159
	value = ((uint32_t)(input[17] & 0x01) << 31) |
			((uint32_t)input[18] << 23) |
			((uint32_t)input[19] << 15);
	output[8] = (double)(value >> 15);

	// read output[9]: from bit 160 to 176
	value = ((uint32_t)input[20] << 24) |
			((uint32_t)input[21] << 16) |
			((uint32_t)(input[22] & 0x80) << 8);
	output[9] = (double)(value >> 15);

	// read output[10]: from bit 177 to 193
	value = ((uint32_t)(input[22] & 0x7f) << 25) |
			((uint32_t)input[23] << 17) |
			((uint32_t)(input[24] & 0xc0) << 9);
	output[10] = (double)(value >> 15);

	// read output[11]: from bit 194 to 210
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xe0) << 10);
	output[11] = (double)(value >> 15);

	// read output[12]: from bit 211 to 227
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)(input[28] & 0xf0) << 11);
	output[12] = (double)(value >> 15);

	// read output[13]: from bit 228 to 244
	value = ((uint32_t)(input[28] & 0x0f) << 28) |
			((uint32_t)input[29] << 20) |
			((uint32_t)(input[30] & 0xf8) << 12);
	output[13] = (double)(value >> 15);

	// read output[14]: from bit 245 to 261
	value = ((uint32_t)(input[30] & 0x07) << 29) |
			((uint32_t)input[31] << 21) |
			((uint32_t)(input[32] & 0xfc) << 13);
	output[14] = (double)(value >> 15);

	// read output[15]: from bit 262 to 278
	value = ((uint32_t)(input[32] & 0x03) << 30) |
			((uint32_t)input[33] << 22) |
			((uint32_t)(input[34] & 0xfe) << 14);
	output[15] = (double)(value >> 15);

	// read output[16]: from bit 279 to 295
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)input[36] << 15);
	output[16] = (double)(value >> 15);

	// read output[17]: from bit 296 to 312
	value = ((uint32_t)input[37] << 24) |
			((uint32_t)input[38] << 16) |
			((uint32_t)(input[39] & 0x80) << 8);
	output[17] = (double)(value >> 15);

	// read output[18]: from bit 313 to 329
	value = ((uint32_t)(input[39] & 0x7f) << 25) |
			((uint32_t)input[40] << 17) |
			((uint32_t)(input[41] & 0xc0) << 9);
	output[18] = (double)(value >> 15);

	// read output[19]: from bit 330 to 346
	value = ((uint32_t)(input[41] & 0x3f) << 26) |
			((uint32_t)input[42] << 18) |
			((uint32_t)(input[43] & 0xe0) << 10);
	output[19] = (double)(value >> 15);

	// read output[20]: from bit 347 to 363
	value = ((uint32_t)(input[43] & 0x1f) << 27) |
			((uint32_t)input[44] << 19) |
			((uint32_t)(input[45] & 0xf0) << 11);
	output[20] = (double)(value >> 15);

	// read output[21]: from bit 364 to 380
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)(input[47] & 0xf8) << 12);
	output[21] = (double)(value >> 15);

	// read output[22]: from bit 381 to 397
	value = ((uint32_t)(input[47] & 0x07) << 29) |
			((uint32_t)input[48] << 21) |
			((uint32_t)(input[49] & 0xfc) << 13);
	output[22] = (double)(value >> 15);

	// read output[23]: from bit 398 to 414
	value = ((uint32_t)(input[49] & 0x03) << 30) |
			((uint32_t)input[50] << 22) |
			((uint32_t)(input[51] & 0xfe) << 14);
	output[23] = (double)(value >> 15);

	// read output[24]: from bit 415 to 431
	value = ((uint32_t)(input[51] & 0x01) << 31) |
			((uint32_t)input[52] << 23) |
			((uint32_t)input[53] << 15);
	output[24] = (double)(value >> 15);

	// read output[25]: from bit 432 to 448
	value = ((uint32_t)input[54] << 24) |
			((uint32_t)input[55] << 16) |
			((uint32_t)(input[56] & 0x80) << 8);
	output[25] = (double)(value >> 15);

	// read output[26]: from bit 449 to 465
	value = ((uint32_t)(input[56] & 0x7f) << 25) |
			((uint32_t)input[57] << 17) |
			((uint32_t)(input[58] & 0xc0) << 9);
	output[26] = (double)(value >> 15);

	// read output[27]: from bit 466 to 482
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xe0) << 10);
	output[27] = (double)(value >> 15);

	// read output[28]: from bit 483 to 499
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)(input[62] & 0xf0) << 11);
	output[28] = (double)(value >> 15);

	// read output[29]: from bit 500 to 516
	value = ((uint32_t)(input[62] & 0x0f) << 28) |
			((uint32_t)input[63] << 20) |
			((uint32_t)(input[64] & 0xf8) << 12);
	output[29] = (double)(value >> 15);
}


unpack_func_t unpack_17bit[UNPACK_17BIT_MAX_COUNT][8][2] = {
	{
		{
			unpack_1_17bit_unsigned_0off,
			unpack_1_17bit_signed_0off,
		},
		{
			unpack_1_17bit_unsigned_1off,
			unpack_1_17bit_signed_1off,
		},
		{
			unpack_1_17bit_unsigned_2off,
			unpack_1_17bit_signed_2off,
		},
		{
			unpack_1_17bit_unsigned_3off,
			unpack_1_17bit_signed_3off,
		},
		{
			unpack_1_17bit_unsigned_4off,
			unpack_1_17bit_signed_4off,
		},
		{
			unpack_1_17bit_unsigned_5off,
			unpack_1_17bit_signed_5off,
		},
		{
			unpack_1_17bit_unsigned_6off,
			unpack_1_17bit_signed_6off,
		},
		{
			unpack_1_17bit_unsigned_7off,
			unpack_1_17bit_signed_7off,
		},
	},
	{
		{
			unpack_2_17bit_unsigned_0off,
			unpack_2_17bit_signed_0off,
		},
		{
			unpack_2_17bit_unsigned_1off,
			unpack_2_17bit_signed_1off,
		},
		{
			unpack_2_17bit_unsigned_2off,
			unpack_2_17bit_signed_2off,
		},
		{
			unpack_2_17bit_unsigned_3off,
			unpack_2_17bit_signed_3off,
		},
		{
			unpack_2_17bit_unsigned_4off,
			unpack_2_17bit_signed_4off,
		},
		{
			unpack_2_17bit_unsigned_5off,
			unpack_2_17bit_signed_5off,
		},
		{
			unpack_2_17bit_unsigned_6off,
			unpack_2_17bit_signed_6off,
		},
		{
			unpack_2_17bit_unsigned_7off,
			unpack_2_17bit_signed_7off,
		},
	},
	{
		{
			unpack_3_17bit_unsigned_0off,
			unpack_3_17bit_signed_0off,
		},
		{
			unpack_3_17bit_unsigned_1off,
			unpack_3_17bit_signed_1off,
		},
		{
			unpack_3_17bit_unsigned_2off,
			unpack_3_17bit_signed_2off,
		},
		{
			unpack_3_17bit_unsigned_3off,
			unpack_3_17bit_signed_3off,
		},
		{
			unpack_3_17bit_unsigned_4off,
			unpack_3_17bit_signed_4off,
		},
		{
			unpack_3_17bit_unsigned_5off,
			unpack_3_17bit_signed_5off,
		},
		{
			unpack_3_17bit_unsigned_6off,
			unpack_3_17bit_signed_6off,
		},
		{
			unpack_3_17bit_unsigned_7off,
			unpack_3_17bit_signed_7off,
		},
	},
	{
		{
			unpack_4_17bit_unsigned_0off,
			unpack_4_17bit_signed_0off,
		},
		{
			unpack_4_17bit_unsigned_1off,
			unpack_4_17bit_signed_1off,
		},
		{
			unpack_4_17bit_unsigned_2off,
			unpack_4_17bit_signed_2off,
		},
		{
			unpack_4_17bit_unsigned_3off,
			unpack_4_17bit_signed_3off,
		},
		{
			unpack_4_17bit_unsigned_4off,
			unpack_4_17bit_signed_4off,
		},
		{
			unpack_4_17bit_unsigned_5off,
			unpack_4_17bit_signed_5off,
		},
		{
			unpack_4_17bit_unsigned_6off,
			unpack_4_17bit_signed_6off,
		},
		{
			unpack_4_17bit_unsigned_7off,
			unpack_4_17bit_signed_7off,
		},
	},
	{
		{
			unpack_5_17bit_unsigned_0off,
			unpack_5_17bit_signed_0off,
		},
		{
			unpack_5_17bit_unsigned_1off,
			unpack_5_17bit_signed_1off,
		},
		{
			unpack_5_17bit_unsigned_2off,
			unpack_5_17bit_signed_2off,
		},
		{
			unpack_5_17bit_unsigned_3off,
			unpack_5_17bit_signed_3off,
		},
		{
			unpack_5_17bit_unsigned_4off,
			unpack_5_17bit_signed_4off,
		},
		{
			unpack_5_17bit_unsigned_5off,
			unpack_5_17bit_signed_5off,
		},
		{
			unpack_5_17bit_unsigned_6off,
			unpack_5_17bit_signed_6off,
		},
		{
			unpack_5_17bit_unsigned_7off,
			unpack_5_17bit_signed_7off,
		},
	},
	{
		{
			unpack_6_17bit_unsigned_0off,
			unpack_6_17bit_signed_0off,
		},
		{
			unpack_6_17bit_unsigned_1off,
			unpack_6_17bit_signed_1off,
		},
		{
			unpack_6_17bit_unsigned_2off,
			unpack_6_17bit_signed_2off,
		},
		{
			unpack_6_17bit_unsigned_3off,
			unpack_6_17bit_signed_3off,
		},
		{
			unpack_6_17bit_unsigned_4off,
			unpack_6_17bit_signed_4off,
		},
		{
			unpack_6_17bit_unsigned_5off,
			unpack_6_17bit_signed_5off,
		},
		{
			unpack_6_17bit_unsigned_6off,
			unpack_6_17bit_signed_6off,
		},
		{
			unpack_6_17bit_unsigned_7off,
			unpack_6_17bit_signed_7off,
		},
	},
	{
		{
			unpack_7_17bit_unsigned_0off,
			unpack_7_17bit_signed_0off,
		},
		{
			unpack_7_17bit_unsigned_1off,
			unpack_7_17bit_signed_1off,
		},
		{
			unpack_7_17bit_unsigned_2off,
			unpack_7_17bit_signed_2off,
		},
		{
			unpack_7_17bit_unsigned_3off,
			unpack_7_17bit_signed_3off,
		},
		{
			unpack_7_17bit_unsigned_4off,
			unpack_7_17bit_signed_4off,
		},
		{
			unpack_7_17bit_unsigned_5off,
			unpack_7_17bit_signed_5off,
		},
		{
			unpack_7_17bit_unsigned_6off,
			unpack_7_17bit_signed_6off,
		},
		{
			unpack_7_17bit_unsigned_7off,
			unpack_7_17bit_signed_7off,
		},
	},
	{
		{
			unpack_8_17bit_unsigned_0off,
			unpack_8_17bit_signed_0off,
		},
		{
			unpack_8_17bit_unsigned_1off,
			unpack_8_17bit_signed_1off,
		},
		{
			unpack_8_17bit_unsigned_2off,
			unpack_8_17bit_signed_2off,
		},
		{
			unpack_8_17bit_unsigned_3off,
			unpack_8_17bit_signed_3off,
		},
		{
			unpack_8_17bit_unsigned_4off,
			unpack_8_17bit_signed_4off,
		},
		{
			unpack_8_17bit_unsigned_5off,
			unpack_8_17bit_signed_5off,
		},
		{
			unpack_8_17bit_unsigned_6off,
			unpack_8_17bit_signed_6off,
		},
		{
			unpack_8_17bit_unsigned_7off,
			unpack_8_17bit_signed_7off,
		},
	},
	{
		{
			unpack_9_17bit_unsigned_0off,
			unpack_9_17bit_signed_0off,
		},
		{
			unpack_9_17bit_unsigned_1off,
			unpack_9_17bit_signed_1off,
		},
		{
			unpack_9_17bit_unsigned_2off,
			unpack_9_17bit_signed_2off,
		},
		{
			unpack_9_17bit_unsigned_3off,
			unpack_9_17bit_signed_3off,
		},
		{
			unpack_9_17bit_unsigned_4off,
			unpack_9_17bit_signed_4off,
		},
		{
			unpack_9_17bit_unsigned_5off,
			unpack_9_17bit_signed_5off,
		},
		{
			unpack_9_17bit_unsigned_6off,
			unpack_9_17bit_signed_6off,
		},
		{
			unpack_9_17bit_unsigned_7off,
			unpack_9_17bit_signed_7off,
		},
	},
	{
		{
			unpack_10_17bit_unsigned_0off,
			unpack_10_17bit_signed_0off,
		},
		{
			unpack_10_17bit_unsigned_1off,
			unpack_10_17bit_signed_1off,
		},
		{
			unpack_10_17bit_unsigned_2off,
			unpack_10_17bit_signed_2off,
		},
		{
			unpack_10_17bit_unsigned_3off,
			unpack_10_17bit_signed_3off,
		},
		{
			unpack_10_17bit_unsigned_4off,
			unpack_10_17bit_signed_4off,
		},
		{
			unpack_10_17bit_unsigned_5off,
			unpack_10_17bit_signed_5off,
		},
		{
			unpack_10_17bit_unsigned_6off,
			unpack_10_17bit_signed_6off,
		},
		{
			unpack_10_17bit_unsigned_7off,
			unpack_10_17bit_signed_7off,
		},
	},
	{
		{
			unpack_11_17bit_unsigned_0off,
			unpack_11_17bit_signed_0off,
		},
		{
			unpack_11_17bit_unsigned_1off,
			unpack_11_17bit_signed_1off,
		},
		{
			unpack_11_17bit_unsigned_2off,
			unpack_11_17bit_signed_2off,
		},
		{
			unpack_11_17bit_unsigned_3off,
			unpack_11_17bit_signed_3off,
		},
		{
			unpack_11_17bit_unsigned_4off,
			unpack_11_17bit_signed_4off,
		},
		{
			unpack_11_17bit_unsigned_5off,
			unpack_11_17bit_signed_5off,
		},
		{
			unpack_11_17bit_unsigned_6off,
			unpack_11_17bit_signed_6off,
		},
		{
			unpack_11_17bit_unsigned_7off,
			unpack_11_17bit_signed_7off,
		},
	},
	{
		{
			unpack_12_17bit_unsigned_0off,
			unpack_12_17bit_signed_0off,
		},
		{
			unpack_12_17bit_unsigned_1off,
			unpack_12_17bit_signed_1off,
		},
		{
			unpack_12_17bit_unsigned_2off,
			unpack_12_17bit_signed_2off,
		},
		{
			unpack_12_17bit_unsigned_3off,
			unpack_12_17bit_signed_3off,
		},
		{
			unpack_12_17bit_unsigned_4off,
			unpack_12_17bit_signed_4off,
		},
		{
			unpack_12_17bit_unsigned_5off,
			unpack_12_17bit_signed_5off,
		},
		{
			unpack_12_17bit_unsigned_6off,
			unpack_12_17bit_signed_6off,
		},
		{
			unpack_12_17bit_unsigned_7off,
			unpack_12_17bit_signed_7off,
		},
	},
	{
		{
			unpack_13_17bit_unsigned_0off,
			unpack_13_17bit_signed_0off,
		},
		{
			unpack_13_17bit_unsigned_1off,
			unpack_13_17bit_signed_1off,
		},
		{
			unpack_13_17bit_unsigned_2off,
			unpack_13_17bit_signed_2off,
		},
		{
			unpack_13_17bit_unsigned_3off,
			unpack_13_17bit_signed_3off,
		},
		{
			unpack_13_17bit_unsigned_4off,
			unpack_13_17bit_signed_4off,
		},
		{
			unpack_13_17bit_unsigned_5off,
			unpack_13_17bit_signed_5off,
		},
		{
			unpack_13_17bit_unsigned_6off,
			unpack_13_17bit_signed_6off,
		},
		{
			unpack_13_17bit_unsigned_7off,
			unpack_13_17bit_signed_7off,
		},
	},
	{
		{
			unpack_14_17bit_unsigned_0off,
			unpack_14_17bit_signed_0off,
		},
		{
			unpack_14_17bit_unsigned_1off,
			unpack_14_17bit_signed_1off,
		},
		{
			unpack_14_17bit_unsigned_2off,
			unpack_14_17bit_signed_2off,
		},
		{
			unpack_14_17bit_unsigned_3off,
			unpack_14_17bit_signed_3off,
		},
		{
			unpack_14_17bit_unsigned_4off,
			unpack_14_17bit_signed_4off,
		},
		{
			unpack_14_17bit_unsigned_5off,
			unpack_14_17bit_signed_5off,
		},
		{
			unpack_14_17bit_unsigned_6off,
			unpack_14_17bit_signed_6off,
		},
		{
			unpack_14_17bit_unsigned_7off,
			unpack_14_17bit_signed_7off,
		},
	},
	{
		{
			unpack_15_17bit_unsigned_0off,
			unpack_15_17bit_signed_0off,
		},
		{
			unpack_15_17bit_unsigned_1off,
			unpack_15_17bit_signed_1off,
		},
		{
			unpack_15_17bit_unsigned_2off,
			unpack_15_17bit_signed_2off,
		},
		{
			unpack_15_17bit_unsigned_3off,
			unpack_15_17bit_signed_3off,
		},
		{
			unpack_15_17bit_unsigned_4off,
			unpack_15_17bit_signed_4off,
		},
		{
			unpack_15_17bit_unsigned_5off,
			unpack_15_17bit_signed_5off,
		},
		{
			unpack_15_17bit_unsigned_6off,
			unpack_15_17bit_signed_6off,
		},
		{
			unpack_15_17bit_unsigned_7off,
			unpack_15_17bit_signed_7off,
		},
	},
	{
		{
			unpack_16_17bit_unsigned_0off,
			unpack_16_17bit_signed_0off,
		},
		{
			unpack_16_17bit_unsigned_1off,
			unpack_16_17bit_signed_1off,
		},
		{
			unpack_16_17bit_unsigned_2off,
			unpack_16_17bit_signed_2off,
		},
		{
			unpack_16_17bit_unsigned_3off,
			unpack_16_17bit_signed_3off,
		},
		{
			unpack_16_17bit_unsigned_4off,
			unpack_16_17bit_signed_4off,
		},
		{
			unpack_16_17bit_unsigned_5off,
			unpack_16_17bit_signed_5off,
		},
		{
			unpack_16_17bit_unsigned_6off,
			unpack_16_17bit_signed_6off,
		},
		{
			unpack_16_17bit_unsigned_7off,
			unpack_16_17bit_signed_7off,
		},
	},
	{
		{
			unpack_17_17bit_unsigned_0off,
			unpack_17_17bit_signed_0off,
		},
		{
			unpack_17_17bit_unsigned_1off,
			unpack_17_17bit_signed_1off,
		},
		{
			unpack_17_17bit_unsigned_2off,
			unpack_17_17bit_signed_2off,
		},
		{
			unpack_17_17bit_unsigned_3off,
			unpack_17_17bit_signed_3off,
		},
		{
			unpack_17_17bit_unsigned_4off,
			unpack_17_17bit_signed_4off,
		},
		{
			unpack_17_17bit_unsigned_5off,
			unpack_17_17bit_signed_5off,
		},
		{
			unpack_17_17bit_unsigned_6off,
			unpack_17_17bit_signed_6off,
		},
		{
			unpack_17_17bit_unsigned_7off,
			unpack_17_17bit_signed_7off,
		},
	},
	{
		{
			unpack_18_17bit_unsigned_0off,
			unpack_18_17bit_signed_0off,
		},
		{
			unpack_18_17bit_unsigned_1off,
			unpack_18_17bit_signed_1off,
		},
		{
			unpack_18_17bit_unsigned_2off,
			unpack_18_17bit_signed_2off,
		},
		{
			unpack_18_17bit_unsigned_3off,
			unpack_18_17bit_signed_3off,
		},
		{
			unpack_18_17bit_unsigned_4off,
			unpack_18_17bit_signed_4off,
		},
		{
			unpack_18_17bit_unsigned_5off,
			unpack_18_17bit_signed_5off,
		},
		{
			unpack_18_17bit_unsigned_6off,
			unpack_18_17bit_signed_6off,
		},
		{
			unpack_18_17bit_unsigned_7off,
			unpack_18_17bit_signed_7off,
		},
	},
	{
		{
			unpack_19_17bit_unsigned_0off,
			unpack_19_17bit_signed_0off,
		},
		{
			unpack_19_17bit_unsigned_1off,
			unpack_19_17bit_signed_1off,
		},
		{
			unpack_19_17bit_unsigned_2off,
			unpack_19_17bit_signed_2off,
		},
		{
			unpack_19_17bit_unsigned_3off,
			unpack_19_17bit_signed_3off,
		},
		{
			unpack_19_17bit_unsigned_4off,
			unpack_19_17bit_signed_4off,
		},
		{
			unpack_19_17bit_unsigned_5off,
			unpack_19_17bit_signed_5off,
		},
		{
			unpack_19_17bit_unsigned_6off,
			unpack_19_17bit_signed_6off,
		},
		{
			unpack_19_17bit_unsigned_7off,
			unpack_19_17bit_signed_7off,
		},
	},
	{
		{
			unpack_20_17bit_unsigned_0off,
			unpack_20_17bit_signed_0off,
		},
		{
			unpack_20_17bit_unsigned_1off,
			unpack_20_17bit_signed_1off,
		},
		{
			unpack_20_17bit_unsigned_2off,
			unpack_20_17bit_signed_2off,
		},
		{
			unpack_20_17bit_unsigned_3off,
			unpack_20_17bit_signed_3off,
		},
		{
			unpack_20_17bit_unsigned_4off,
			unpack_20_17bit_signed_4off,
		},
		{
			unpack_20_17bit_unsigned_5off,
			unpack_20_17bit_signed_5off,
		},
		{
			unpack_20_17bit_unsigned_6off,
			unpack_20_17bit_signed_6off,
		},
		{
			unpack_20_17bit_unsigned_7off,
			unpack_20_17bit_signed_7off,
		},
	},
	{
		{
			unpack_21_17bit_unsigned_0off,
			unpack_21_17bit_signed_0off,
		},
		{
			unpack_21_17bit_unsigned_1off,
			unpack_21_17bit_signed_1off,
		},
		{
			unpack_21_17bit_unsigned_2off,
			unpack_21_17bit_signed_2off,
		},
		{
			unpack_21_17bit_unsigned_3off,
			unpack_21_17bit_signed_3off,
		},
		{
			unpack_21_17bit_unsigned_4off,
			unpack_21_17bit_signed_4off,
		},
		{
			unpack_21_17bit_unsigned_5off,
			unpack_21_17bit_signed_5off,
		},
		{
			unpack_21_17bit_unsigned_6off,
			unpack_21_17bit_signed_6off,
		},
		{
			unpack_21_17bit_unsigned_7off,
			unpack_21_17bit_signed_7off,
		},
	},
	{
		{
			unpack_22_17bit_unsigned_0off,
			unpack_22_17bit_signed_0off,
		},
		{
			unpack_22_17bit_unsigned_1off,
			unpack_22_17bit_signed_1off,
		},
		{
			unpack_22_17bit_unsigned_2off,
			unpack_22_17bit_signed_2off,
		},
		{
			unpack_22_17bit_unsigned_3off,
			unpack_22_17bit_signed_3off,
		},
		{
			unpack_22_17bit_unsigned_4off,
			unpack_22_17bit_signed_4off,
		},
		{
			unpack_22_17bit_unsigned_5off,
			unpack_22_17bit_signed_5off,
		},
		{
			unpack_22_17bit_unsigned_6off,
			unpack_22_17bit_signed_6off,
		},
		{
			unpack_22_17bit_unsigned_7off,
			unpack_22_17bit_signed_7off,
		},
	},
	{
		{
			unpack_23_17bit_unsigned_0off,
			unpack_23_17bit_signed_0off,
		},
		{
			unpack_23_17bit_unsigned_1off,
			unpack_23_17bit_signed_1off,
		},
		{
			unpack_23_17bit_unsigned_2off,
			unpack_23_17bit_signed_2off,
		},
		{
			unpack_23_17bit_unsigned_3off,
			unpack_23_17bit_signed_3off,
		},
		{
			unpack_23_17bit_unsigned_4off,
			unpack_23_17bit_signed_4off,
		},
		{
			unpack_23_17bit_unsigned_5off,
			unpack_23_17bit_signed_5off,
		},
		{
			unpack_23_17bit_unsigned_6off,
			unpack_23_17bit_signed_6off,
		},
		{
			unpack_23_17bit_unsigned_7off,
			unpack_23_17bit_signed_7off,
		},
	},
	{
		{
			unpack_24_17bit_unsigned_0off,
			unpack_24_17bit_signed_0off,
		},
		{
			unpack_24_17bit_unsigned_1off,
			unpack_24_17bit_signed_1off,
		},
		{
			unpack_24_17bit_unsigned_2off,
			unpack_24_17bit_signed_2off,
		},
		{
			unpack_24_17bit_unsigned_3off,
			unpack_24_17bit_signed_3off,
		},
		{
			unpack_24_17bit_unsigned_4off,
			unpack_24_17bit_signed_4off,
		},
		{
			unpack_24_17bit_unsigned_5off,
			unpack_24_17bit_signed_5off,
		},
		{
			unpack_24_17bit_unsigned_6off,
			unpack_24_17bit_signed_6off,
		},
		{
			unpack_24_17bit_unsigned_7off,
			unpack_24_17bit_signed_7off,
		},
	},
	{
		{
			unpack_25_17bit_unsigned_0off,
			unpack_25_17bit_signed_0off,
		},
		{
			unpack_25_17bit_unsigned_1off,
			unpack_25_17bit_signed_1off,
		},
		{
			unpack_25_17bit_unsigned_2off,
			unpack_25_17bit_signed_2off,
		},
		{
			unpack_25_17bit_unsigned_3off,
			unpack_25_17bit_signed_3off,
		},
		{
			unpack_25_17bit_unsigned_4off,
			unpack_25_17bit_signed_4off,
		},
		{
			unpack_25_17bit_unsigned_5off,
			unpack_25_17bit_signed_5off,
		},
		{
			unpack_25_17bit_unsigned_6off,
			unpack_25_17bit_signed_6off,
		},
		{
			unpack_25_17bit_unsigned_7off,
			unpack_25_17bit_signed_7off,
		},
	},
	{
		{
			unpack_26_17bit_unsigned_0off,
			unpack_26_17bit_signed_0off,
		},
		{
			unpack_26_17bit_unsigned_1off,
			unpack_26_17bit_signed_1off,
		},
		{
			unpack_26_17bit_unsigned_2off,
			unpack_26_17bit_signed_2off,
		},
		{
			unpack_26_17bit_unsigned_3off,
			unpack_26_17bit_signed_3off,
		},
		{
			unpack_26_17bit_unsigned_4off,
			unpack_26_17bit_signed_4off,
		},
		{
			unpack_26_17bit_unsigned_5off,
			unpack_26_17bit_signed_5off,
		},
		{
			unpack_26_17bit_unsigned_6off,
			unpack_26_17bit_signed_6off,
		},
		{
			unpack_26_17bit_unsigned_7off,
			unpack_26_17bit_signed_7off,
		},
	},
	{
		{
			unpack_27_17bit_unsigned_0off,
			unpack_27_17bit_signed_0off,
		},
		{
			unpack_27_17bit_unsigned_1off,
			unpack_27_17bit_signed_1off,
		},
		{
			unpack_27_17bit_unsigned_2off,
			unpack_27_17bit_signed_2off,
		},
		{
			unpack_27_17bit_unsigned_3off,
			unpack_27_17bit_signed_3off,
		},
		{
			unpack_27_17bit_unsigned_4off,
			unpack_27_17bit_signed_4off,
		},
		{
			unpack_27_17bit_unsigned_5off,
			unpack_27_17bit_signed_5off,
		},
		{
			unpack_27_17bit_unsigned_6off,
			unpack_27_17bit_signed_6off,
		},
		{
			unpack_27_17bit_unsigned_7off,
			unpack_27_17bit_signed_7off,
		},
	},
	{
		{
			unpack_28_17bit_unsigned_0off,
			unpack_28_17bit_signed_0off,
		},
		{
			unpack_28_17bit_unsigned_1off,
			unpack_28_17bit_signed_1off,
		},
		{
			unpack_28_17bit_unsigned_2off,
			unpack_28_17bit_signed_2off,
		},
		{
			unpack_28_17bit_unsigned_3off,
			unpack_28_17bit_signed_3off,
		},
		{
			unpack_28_17bit_unsigned_4off,
			unpack_28_17bit_signed_4off,
		},
		{
			unpack_28_17bit_unsigned_5off,
			unpack_28_17bit_signed_5off,
		},
		{
			unpack_28_17bit_unsigned_6off,
			unpack_28_17bit_signed_6off,
		},
		{
			unpack_28_17bit_unsigned_7off,
			unpack_28_17bit_signed_7off,
		},
	},
	{
		{
			unpack_29_17bit_unsigned_0off,
			unpack_29_17bit_signed_0off,
		},
		{
			unpack_29_17bit_unsigned_1off,
			unpack_29_17bit_signed_1off,
		},
		{
			unpack_29_17bit_unsigned_2off,
			unpack_29_17bit_signed_2off,
		},
		{
			unpack_29_17bit_unsigned_3off,
			unpack_29_17bit_signed_3off,
		},
		{
			unpack_29_17bit_unsigned_4off,
			unpack_29_17bit_signed_4off,
		},
		{
			unpack_29_17bit_unsigned_5off,
			unpack_29_17bit_signed_5off,
		},
		{
			unpack_29_17bit_unsigned_6off,
			unpack_29_17bit_signed_6off,
		},
		{
			unpack_29_17bit_unsigned_7off,
			unpack_29_17bit_signed_7off,
		},
	},
	{
		{
			unpack_30_17bit_unsigned_0off,
			unpack_30_17bit_signed_0off,
		},
		{
			unpack_30_17bit_unsigned_1off,
			unpack_30_17bit_signed_1off,
		},
		{
			unpack_30_17bit_unsigned_2off,
			unpack_30_17bit_signed_2off,
		},
		{
			unpack_30_17bit_unsigned_3off,
			unpack_30_17bit_signed_3off,
		},
		{
			unpack_30_17bit_unsigned_4off,
			unpack_30_17bit_signed_4off,
		},
		{
			unpack_30_17bit_unsigned_5off,
			unpack_30_17bit_signed_5off,
		},
		{
			unpack_30_17bit_unsigned_6off,
			unpack_30_17bit_signed_6off,
		},
		{
			unpack_30_17bit_unsigned_7off,
			unpack_30_17bit_signed_7off,
		},
	},
};
