// AUTOGENERATED FILE. DO NOT MODIFY.

#include <stdlib.h>
#include <stdint.h>

#include "unpack21.h"



static void unpack_1_21bit_signed_0off(const uint8_t * input, double * output) {
	// Unpack 1 values into output
	// Values are 21-bit signed
	// Skip 0 bits, read 21 bits of data.
	// Input must be at least 3 bytes long

	int32_t value;

	// read output[0]: from bit 0 to 20
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0xf8) << 8);
	output[0] = (double)(value >> 11);
}

static void unpack_1_21bit_unsigned_0off(const uint8_t * input, double * output) {
	// Unpack 1 values into output
	// Values are 21-bit unsigned
	// Skip 0 bits, read 21 bits of data.
	// Input must be at least 3 bytes long

	uint32_t value;

	// read output[0]: from bit 0 to 20
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0xf8) << 8);
	output[0] = (double)(value >> 11);
}

static void unpack_1_21bit_signed_1off(const uint8_t * input, double * output) {
	// Unpack 1 values into output
	// Values are 21-bit signed
	// Skip 1 bits, read 21 bits of data.
	// Input must be at least 3 bytes long

	int32_t value;

	// read output[0]: from bit 1 to 21
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xfc) << 9);
	output[0] = (double)(value >> 11);
}

static void unpack_1_21bit_unsigned_1off(const uint8_t * input, double * output) {
	// Unpack 1 values into output
	// Values are 21-bit unsigned
	// Skip 1 bits, read 21 bits of data.
	// Input must be at least 3 bytes long

	uint32_t value;

	// read output[0]: from bit 1 to 21
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xfc) << 9);
	output[0] = (double)(value >> 11);
}

static void unpack_1_21bit_signed_2off(const uint8_t * input, double * output) {
	// Unpack 1 values into output
	// Values are 21-bit signed
	// Skip 2 bits, read 21 bits of data.
	// Input must be at least 3 bytes long

	int32_t value;

	// read output[0]: from bit 2 to 22
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xfe) << 10);
	output[0] = (double)(value >> 11);
}

static void unpack_1_21bit_unsigned_2off(const uint8_t * input, double * output) {
	// Unpack 1 values into output
	// Values are 21-bit unsigned
	// Skip 2 bits, read 21 bits of data.
	// Input must be at least 3 bytes long

	uint32_t value;

	// read output[0]: from bit 2 to 22
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xfe) << 10);
	output[0] = (double)(value >> 11);
}

static void unpack_1_21bit_signed_3off(const uint8_t * input, double * output) {
	// Unpack 1 values into output
	// Values are 21-bit signed
	// Skip 3 bits, read 21 bits of data.
	// Input must be at least 3 bytes long

	int32_t value;

	// read output[0]: from bit 3 to 23
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11);
	output[0] = (double)(value >> 11);
}

static void unpack_1_21bit_unsigned_3off(const uint8_t * input, double * output) {
	// Unpack 1 values into output
	// Values are 21-bit unsigned
	// Skip 3 bits, read 21 bits of data.
	// Input must be at least 3 bytes long

	uint32_t value;

	// read output[0]: from bit 3 to 23
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11);
	output[0] = (double)(value >> 11);
}

static void unpack_1_21bit_signed_4off(const uint8_t * input, double * output) {
	// Unpack 1 values into output
	// Values are 21-bit signed
	// Skip 4 bits, read 21 bits of data.
	// Input must be at least 4 bytes long

	int32_t value;

	// read output[0]: from bit 4 to 24
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0x80) << 4);
	output[0] = (double)(value >> 11);
}

static void unpack_1_21bit_unsigned_4off(const uint8_t * input, double * output) {
	// Unpack 1 values into output
	// Values are 21-bit unsigned
	// Skip 4 bits, read 21 bits of data.
	// Input must be at least 4 bytes long

	uint32_t value;

	// read output[0]: from bit 4 to 24
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0x80) << 4);
	output[0] = (double)(value >> 11);
}

static void unpack_1_21bit_signed_5off(const uint8_t * input, double * output) {
	// Unpack 1 values into output
	// Values are 21-bit signed
	// Skip 5 bits, read 21 bits of data.
	// Input must be at least 4 bytes long

	int32_t value;

	// read output[0]: from bit 5 to 25
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xc0) << 5);
	output[0] = (double)(value >> 11);
}

static void unpack_1_21bit_unsigned_5off(const uint8_t * input, double * output) {
	// Unpack 1 values into output
	// Values are 21-bit unsigned
	// Skip 5 bits, read 21 bits of data.
	// Input must be at least 4 bytes long

	uint32_t value;

	// read output[0]: from bit 5 to 25
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xc0) << 5);
	output[0] = (double)(value >> 11);
}

static void unpack_1_21bit_signed_6off(const uint8_t * input, double * output) {
	// Unpack 1 values into output
	// Values are 21-bit signed
	// Skip 6 bits, read 21 bits of data.
	// Input must be at least 4 bytes long

	int32_t value;

	// read output[0]: from bit 6 to 26
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xe0) << 6);
	output[0] = (double)(value >> 11);
}

static void unpack_1_21bit_unsigned_6off(const uint8_t * input, double * output) {
	// Unpack 1 values into output
	// Values are 21-bit unsigned
	// Skip 6 bits, read 21 bits of data.
	// Input must be at least 4 bytes long

	uint32_t value;

	// read output[0]: from bit 6 to 26
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xe0) << 6);
	output[0] = (double)(value >> 11);
}

static void unpack_1_21bit_signed_7off(const uint8_t * input, double * output) {
	// Unpack 1 values into output
	// Values are 21-bit signed
	// Skip 7 bits, read 21 bits of data.
	// Input must be at least 4 bytes long

	int32_t value;

	// read output[0]: from bit 7 to 27
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xf0) << 7);
	output[0] = (double)(value >> 11);
}

static void unpack_1_21bit_unsigned_7off(const uint8_t * input, double * output) {
	// Unpack 1 values into output
	// Values are 21-bit unsigned
	// Skip 7 bits, read 21 bits of data.
	// Input must be at least 4 bytes long

	uint32_t value;

	// read output[0]: from bit 7 to 27
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xf0) << 7);
	output[0] = (double)(value >> 11);
}

static void unpack_2_21bit_signed_0off(const uint8_t * input, double * output) {
	// Unpack 2 values into output
	// Values are 21-bit signed
	// Skip 0 bits, read 42 bits of data.
	// Input must be at least 6 bytes long

	int32_t value;

	// read output[0]: from bit 0 to 20
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0xf8) << 8);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 21 to 41
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)input[4] << 13) |
			((uint32_t)(input[5] & 0xc0) << 5);
	output[1] = (double)(value >> 11);
}

static void unpack_2_21bit_unsigned_0off(const uint8_t * input, double * output) {
	// Unpack 2 values into output
	// Values are 21-bit unsigned
	// Skip 0 bits, read 42 bits of data.
	// Input must be at least 6 bytes long

	uint32_t value;

	// read output[0]: from bit 0 to 20
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0xf8) << 8);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 21 to 41
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)input[4] << 13) |
			((uint32_t)(input[5] & 0xc0) << 5);
	output[1] = (double)(value >> 11);
}

static void unpack_2_21bit_signed_1off(const uint8_t * input, double * output) {
	// Unpack 2 values into output
	// Values are 21-bit signed
	// Skip 1 bits, read 42 bits of data.
	// Input must be at least 6 bytes long

	int32_t value;

	// read output[0]: from bit 1 to 21
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xfc) << 9);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 22 to 42
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)input[4] << 14) |
			((uint32_t)(input[5] & 0xe0) << 6);
	output[1] = (double)(value >> 11);
}

static void unpack_2_21bit_unsigned_1off(const uint8_t * input, double * output) {
	// Unpack 2 values into output
	// Values are 21-bit unsigned
	// Skip 1 bits, read 42 bits of data.
	// Input must be at least 6 bytes long

	uint32_t value;

	// read output[0]: from bit 1 to 21
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xfc) << 9);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 22 to 42
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)input[4] << 14) |
			((uint32_t)(input[5] & 0xe0) << 6);
	output[1] = (double)(value >> 11);
}

static void unpack_2_21bit_signed_2off(const uint8_t * input, double * output) {
	// Unpack 2 values into output
	// Values are 21-bit signed
	// Skip 2 bits, read 42 bits of data.
	// Input must be at least 6 bytes long

	int32_t value;

	// read output[0]: from bit 2 to 22
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xfe) << 10);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 23 to 43
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15) |
			((uint32_t)(input[5] & 0xf0) << 7);
	output[1] = (double)(value >> 11);
}

static void unpack_2_21bit_unsigned_2off(const uint8_t * input, double * output) {
	// Unpack 2 values into output
	// Values are 21-bit unsigned
	// Skip 2 bits, read 42 bits of data.
	// Input must be at least 6 bytes long

	uint32_t value;

	// read output[0]: from bit 2 to 22
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xfe) << 10);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 23 to 43
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15) |
			((uint32_t)(input[5] & 0xf0) << 7);
	output[1] = (double)(value >> 11);
}

static void unpack_2_21bit_signed_3off(const uint8_t * input, double * output) {
	// Unpack 2 values into output
	// Values are 21-bit signed
	// Skip 3 bits, read 42 bits of data.
	// Input must be at least 6 bytes long

	int32_t value;

	// read output[0]: from bit 3 to 23
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 24 to 44
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0xf8) << 8);
	output[1] = (double)(value >> 11);
}

static void unpack_2_21bit_unsigned_3off(const uint8_t * input, double * output) {
	// Unpack 2 values into output
	// Values are 21-bit unsigned
	// Skip 3 bits, read 42 bits of data.
	// Input must be at least 6 bytes long

	uint32_t value;

	// read output[0]: from bit 3 to 23
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 24 to 44
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0xf8) << 8);
	output[1] = (double)(value >> 11);
}

static void unpack_2_21bit_signed_4off(const uint8_t * input, double * output) {
	// Unpack 2 values into output
	// Values are 21-bit signed
	// Skip 4 bits, read 42 bits of data.
	// Input must be at least 6 bytes long

	int32_t value;

	// read output[0]: from bit 4 to 24
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0x80) << 4);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 25 to 45
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)(input[5] & 0xfc) << 9);
	output[1] = (double)(value >> 11);
}

static void unpack_2_21bit_unsigned_4off(const uint8_t * input, double * output) {
	// Unpack 2 values into output
	// Values are 21-bit unsigned
	// Skip 4 bits, read 42 bits of data.
	// Input must be at least 6 bytes long

	uint32_t value;

	// read output[0]: from bit 4 to 24
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0x80) << 4);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 25 to 45
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)(input[5] & 0xfc) << 9);
	output[1] = (double)(value >> 11);
}

static void unpack_2_21bit_signed_5off(const uint8_t * input, double * output) {
	// Unpack 2 values into output
	// Values are 21-bit signed
	// Skip 5 bits, read 42 bits of data.
	// Input must be at least 6 bytes long

	int32_t value;

	// read output[0]: from bit 5 to 25
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xc0) << 5);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 26 to 46
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)(input[5] & 0xfe) << 10);
	output[1] = (double)(value >> 11);
}

static void unpack_2_21bit_unsigned_5off(const uint8_t * input, double * output) {
	// Unpack 2 values into output
	// Values are 21-bit unsigned
	// Skip 5 bits, read 42 bits of data.
	// Input must be at least 6 bytes long

	uint32_t value;

	// read output[0]: from bit 5 to 25
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xc0) << 5);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 26 to 46
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)(input[5] & 0xfe) << 10);
	output[1] = (double)(value >> 11);
}

static void unpack_2_21bit_signed_6off(const uint8_t * input, double * output) {
	// Unpack 2 values into output
	// Values are 21-bit signed
	// Skip 6 bits, read 42 bits of data.
	// Input must be at least 6 bytes long

	int32_t value;

	// read output[0]: from bit 6 to 26
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xe0) << 6);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 27 to 47
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11);
	output[1] = (double)(value >> 11);
}

static void unpack_2_21bit_unsigned_6off(const uint8_t * input, double * output) {
	// Unpack 2 values into output
	// Values are 21-bit unsigned
	// Skip 6 bits, read 42 bits of data.
	// Input must be at least 6 bytes long

	uint32_t value;

	// read output[0]: from bit 6 to 26
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xe0) << 6);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 27 to 47
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11);
	output[1] = (double)(value >> 11);
}

static void unpack_2_21bit_signed_7off(const uint8_t * input, double * output) {
	// Unpack 2 values into output
	// Values are 21-bit signed
	// Skip 7 bits, read 42 bits of data.
	// Input must be at least 7 bytes long

	int32_t value;

	// read output[0]: from bit 7 to 27
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xf0) << 7);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 28 to 48
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0x80) << 4);
	output[1] = (double)(value >> 11);
}

static void unpack_2_21bit_unsigned_7off(const uint8_t * input, double * output) {
	// Unpack 2 values into output
	// Values are 21-bit unsigned
	// Skip 7 bits, read 42 bits of data.
	// Input must be at least 7 bytes long

	uint32_t value;

	// read output[0]: from bit 7 to 27
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xf0) << 7);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 28 to 48
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0x80) << 4);
	output[1] = (double)(value >> 11);
}

static void unpack_3_21bit_signed_0off(const uint8_t * input, double * output) {
	// Unpack 3 values into output
	// Values are 21-bit signed
	// Skip 0 bits, read 63 bits of data.
	// Input must be at least 8 bytes long

	int32_t value;

	// read output[0]: from bit 0 to 20
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0xf8) << 8);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 21 to 41
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)input[4] << 13) |
			((uint32_t)(input[5] & 0xc0) << 5);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 42 to 62
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)input[6] << 18) |
			((uint32_t)(input[7] & 0xfe) << 10);
	output[2] = (double)(value >> 11);
}

static void unpack_3_21bit_unsigned_0off(const uint8_t * input, double * output) {
	// Unpack 3 values into output
	// Values are 21-bit unsigned
	// Skip 0 bits, read 63 bits of data.
	// Input must be at least 8 bytes long

	uint32_t value;

	// read output[0]: from bit 0 to 20
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0xf8) << 8);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 21 to 41
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)input[4] << 13) |
			((uint32_t)(input[5] & 0xc0) << 5);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 42 to 62
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)input[6] << 18) |
			((uint32_t)(input[7] & 0xfe) << 10);
	output[2] = (double)(value >> 11);
}

static void unpack_3_21bit_signed_1off(const uint8_t * input, double * output) {
	// Unpack 3 values into output
	// Values are 21-bit signed
	// Skip 1 bits, read 63 bits of data.
	// Input must be at least 8 bytes long

	int32_t value;

	// read output[0]: from bit 1 to 21
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xfc) << 9);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 22 to 42
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)input[4] << 14) |
			((uint32_t)(input[5] & 0xe0) << 6);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 43 to 63
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)input[6] << 19) |
			((uint32_t)input[7] << 11);
	output[2] = (double)(value >> 11);
}

static void unpack_3_21bit_unsigned_1off(const uint8_t * input, double * output) {
	// Unpack 3 values into output
	// Values are 21-bit unsigned
	// Skip 1 bits, read 63 bits of data.
	// Input must be at least 8 bytes long

	uint32_t value;

	// read output[0]: from bit 1 to 21
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xfc) << 9);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 22 to 42
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)input[4] << 14) |
			((uint32_t)(input[5] & 0xe0) << 6);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 43 to 63
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)input[6] << 19) |
			((uint32_t)input[7] << 11);
	output[2] = (double)(value >> 11);
}

static void unpack_3_21bit_signed_2off(const uint8_t * input, double * output) {
	// Unpack 3 values into output
	// Values are 21-bit signed
	// Skip 2 bits, read 63 bits of data.
	// Input must be at least 9 bytes long

	int32_t value;

	// read output[0]: from bit 2 to 22
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xfe) << 10);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 23 to 43
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15) |
			((uint32_t)(input[5] & 0xf0) << 7);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 44 to 64
	value = ((uint32_t)(input[5] & 0x0f) << 28) |
			((uint32_t)input[6] << 20) |
			((uint32_t)input[7] << 12) |
			((uint32_t)(input[8] & 0x80) << 4);
	output[2] = (double)(value >> 11);
}

static void unpack_3_21bit_unsigned_2off(const uint8_t * input, double * output) {
	// Unpack 3 values into output
	// Values are 21-bit unsigned
	// Skip 2 bits, read 63 bits of data.
	// Input must be at least 9 bytes long

	uint32_t value;

	// read output[0]: from bit 2 to 22
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xfe) << 10);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 23 to 43
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15) |
			((uint32_t)(input[5] & 0xf0) << 7);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 44 to 64
	value = ((uint32_t)(input[5] & 0x0f) << 28) |
			((uint32_t)input[6] << 20) |
			((uint32_t)input[7] << 12) |
			((uint32_t)(input[8] & 0x80) << 4);
	output[2] = (double)(value >> 11);
}

static void unpack_3_21bit_signed_3off(const uint8_t * input, double * output) {
	// Unpack 3 values into output
	// Values are 21-bit signed
	// Skip 3 bits, read 63 bits of data.
	// Input must be at least 9 bytes long

	int32_t value;

	// read output[0]: from bit 3 to 23
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 24 to 44
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0xf8) << 8);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 45 to 65
	value = ((uint32_t)(input[5] & 0x07) << 29) |
			((uint32_t)input[6] << 21) |
			((uint32_t)input[7] << 13) |
			((uint32_t)(input[8] & 0xc0) << 5);
	output[2] = (double)(value >> 11);
}

static void unpack_3_21bit_unsigned_3off(const uint8_t * input, double * output) {
	// Unpack 3 values into output
	// Values are 21-bit unsigned
	// Skip 3 bits, read 63 bits of data.
	// Input must be at least 9 bytes long

	uint32_t value;

	// read output[0]: from bit 3 to 23
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 24 to 44
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0xf8) << 8);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 45 to 65
	value = ((uint32_t)(input[5] & 0x07) << 29) |
			((uint32_t)input[6] << 21) |
			((uint32_t)input[7] << 13) |
			((uint32_t)(input[8] & 0xc0) << 5);
	output[2] = (double)(value >> 11);
}

static void unpack_3_21bit_signed_4off(const uint8_t * input, double * output) {
	// Unpack 3 values into output
	// Values are 21-bit signed
	// Skip 4 bits, read 63 bits of data.
	// Input must be at least 9 bytes long

	int32_t value;

	// read output[0]: from bit 4 to 24
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0x80) << 4);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 25 to 45
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)(input[5] & 0xfc) << 9);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 46 to 66
	value = ((uint32_t)(input[5] & 0x03) << 30) |
			((uint32_t)input[6] << 22) |
			((uint32_t)input[7] << 14) |
			((uint32_t)(input[8] & 0xe0) << 6);
	output[2] = (double)(value >> 11);
}

static void unpack_3_21bit_unsigned_4off(const uint8_t * input, double * output) {
	// Unpack 3 values into output
	// Values are 21-bit unsigned
	// Skip 4 bits, read 63 bits of data.
	// Input must be at least 9 bytes long

	uint32_t value;

	// read output[0]: from bit 4 to 24
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0x80) << 4);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 25 to 45
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)(input[5] & 0xfc) << 9);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 46 to 66
	value = ((uint32_t)(input[5] & 0x03) << 30) |
			((uint32_t)input[6] << 22) |
			((uint32_t)input[7] << 14) |
			((uint32_t)(input[8] & 0xe0) << 6);
	output[2] = (double)(value >> 11);
}

static void unpack_3_21bit_signed_5off(const uint8_t * input, double * output) {
	// Unpack 3 values into output
	// Values are 21-bit signed
	// Skip 5 bits, read 63 bits of data.
	// Input must be at least 9 bytes long

	int32_t value;

	// read output[0]: from bit 5 to 25
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xc0) << 5);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 26 to 46
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)(input[5] & 0xfe) << 10);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 47 to 67
	value = ((uint32_t)(input[5] & 0x01) << 31) |
			((uint32_t)input[6] << 23) |
			((uint32_t)input[7] << 15) |
			((uint32_t)(input[8] & 0xf0) << 7);
	output[2] = (double)(value >> 11);
}

static void unpack_3_21bit_unsigned_5off(const uint8_t * input, double * output) {
	// Unpack 3 values into output
	// Values are 21-bit unsigned
	// Skip 5 bits, read 63 bits of data.
	// Input must be at least 9 bytes long

	uint32_t value;

	// read output[0]: from bit 5 to 25
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xc0) << 5);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 26 to 46
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)(input[5] & 0xfe) << 10);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 47 to 67
	value = ((uint32_t)(input[5] & 0x01) << 31) |
			((uint32_t)input[6] << 23) |
			((uint32_t)input[7] << 15) |
			((uint32_t)(input[8] & 0xf0) << 7);
	output[2] = (double)(value >> 11);
}

static void unpack_3_21bit_signed_6off(const uint8_t * input, double * output) {
	// Unpack 3 values into output
	// Values are 21-bit signed
	// Skip 6 bits, read 63 bits of data.
	// Input must be at least 9 bytes long

	int32_t value;

	// read output[0]: from bit 6 to 26
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xe0) << 6);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 27 to 47
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 48 to 68
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)(input[8] & 0xf8) << 8);
	output[2] = (double)(value >> 11);
}

static void unpack_3_21bit_unsigned_6off(const uint8_t * input, double * output) {
	// Unpack 3 values into output
	// Values are 21-bit unsigned
	// Skip 6 bits, read 63 bits of data.
	// Input must be at least 9 bytes long

	uint32_t value;

	// read output[0]: from bit 6 to 26
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xe0) << 6);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 27 to 47
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 48 to 68
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)(input[8] & 0xf8) << 8);
	output[2] = (double)(value >> 11);
}

static void unpack_3_21bit_signed_7off(const uint8_t * input, double * output) {
	// Unpack 3 values into output
	// Values are 21-bit signed
	// Skip 7 bits, read 63 bits of data.
	// Input must be at least 9 bytes long

	int32_t value;

	// read output[0]: from bit 7 to 27
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xf0) << 7);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 28 to 48
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0x80) << 4);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 49 to 69
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0xfc) << 9);
	output[2] = (double)(value >> 11);
}

static void unpack_3_21bit_unsigned_7off(const uint8_t * input, double * output) {
	// Unpack 3 values into output
	// Values are 21-bit unsigned
	// Skip 7 bits, read 63 bits of data.
	// Input must be at least 9 bytes long

	uint32_t value;

	// read output[0]: from bit 7 to 27
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xf0) << 7);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 28 to 48
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0x80) << 4);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 49 to 69
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0xfc) << 9);
	output[2] = (double)(value >> 11);
}

static void unpack_4_21bit_signed_0off(const uint8_t * input, double * output) {
	// Unpack 4 values into output
	// Values are 21-bit signed
	// Skip 0 bits, read 84 bits of data.
	// Input must be at least 11 bytes long

	int32_t value;

	// read output[0]: from bit 0 to 20
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0xf8) << 8);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 21 to 41
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)input[4] << 13) |
			((uint32_t)(input[5] & 0xc0) << 5);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 42 to 62
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)input[6] << 18) |
			((uint32_t)(input[7] & 0xfe) << 10);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 63 to 83
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)input[9] << 15) |
			((uint32_t)(input[10] & 0xf0) << 7);
	output[3] = (double)(value >> 11);
}

static void unpack_4_21bit_unsigned_0off(const uint8_t * input, double * output) {
	// Unpack 4 values into output
	// Values are 21-bit unsigned
	// Skip 0 bits, read 84 bits of data.
	// Input must be at least 11 bytes long

	uint32_t value;

	// read output[0]: from bit 0 to 20
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0xf8) << 8);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 21 to 41
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)input[4] << 13) |
			((uint32_t)(input[5] & 0xc0) << 5);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 42 to 62
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)input[6] << 18) |
			((uint32_t)(input[7] & 0xfe) << 10);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 63 to 83
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)input[9] << 15) |
			((uint32_t)(input[10] & 0xf0) << 7);
	output[3] = (double)(value >> 11);
}

static void unpack_4_21bit_signed_1off(const uint8_t * input, double * output) {
	// Unpack 4 values into output
	// Values are 21-bit signed
	// Skip 1 bits, read 84 bits of data.
	// Input must be at least 11 bytes long

	int32_t value;

	// read output[0]: from bit 1 to 21
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xfc) << 9);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 22 to 42
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)input[4] << 14) |
			((uint32_t)(input[5] & 0xe0) << 6);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 43 to 63
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)input[6] << 19) |
			((uint32_t)input[7] << 11);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 64 to 84
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16) |
			((uint32_t)(input[10] & 0xf8) << 8);
	output[3] = (double)(value >> 11);
}

static void unpack_4_21bit_unsigned_1off(const uint8_t * input, double * output) {
	// Unpack 4 values into output
	// Values are 21-bit unsigned
	// Skip 1 bits, read 84 bits of data.
	// Input must be at least 11 bytes long

	uint32_t value;

	// read output[0]: from bit 1 to 21
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xfc) << 9);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 22 to 42
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)input[4] << 14) |
			((uint32_t)(input[5] & 0xe0) << 6);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 43 to 63
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)input[6] << 19) |
			((uint32_t)input[7] << 11);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 64 to 84
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16) |
			((uint32_t)(input[10] & 0xf8) << 8);
	output[3] = (double)(value >> 11);
}

static void unpack_4_21bit_signed_2off(const uint8_t * input, double * output) {
	// Unpack 4 values into output
	// Values are 21-bit signed
	// Skip 2 bits, read 84 bits of data.
	// Input must be at least 11 bytes long

	int32_t value;

	// read output[0]: from bit 2 to 22
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xfe) << 10);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 23 to 43
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15) |
			((uint32_t)(input[5] & 0xf0) << 7);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 44 to 64
	value = ((uint32_t)(input[5] & 0x0f) << 28) |
			((uint32_t)input[6] << 20) |
			((uint32_t)input[7] << 12) |
			((uint32_t)(input[8] & 0x80) << 4);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 65 to 85
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0xfc) << 9);
	output[3] = (double)(value >> 11);
}

static void unpack_4_21bit_unsigned_2off(const uint8_t * input, double * output) {
	// Unpack 4 values into output
	// Values are 21-bit unsigned
	// Skip 2 bits, read 84 bits of data.
	// Input must be at least 11 bytes long

	uint32_t value;

	// read output[0]: from bit 2 to 22
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xfe) << 10);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 23 to 43
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15) |
			((uint32_t)(input[5] & 0xf0) << 7);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 44 to 64
	value = ((uint32_t)(input[5] & 0x0f) << 28) |
			((uint32_t)input[6] << 20) |
			((uint32_t)input[7] << 12) |
			((uint32_t)(input[8] & 0x80) << 4);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 65 to 85
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0xfc) << 9);
	output[3] = (double)(value >> 11);
}

static void unpack_4_21bit_signed_3off(const uint8_t * input, double * output) {
	// Unpack 4 values into output
	// Values are 21-bit signed
	// Skip 3 bits, read 84 bits of data.
	// Input must be at least 11 bytes long

	int32_t value;

	// read output[0]: from bit 3 to 23
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 24 to 44
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0xf8) << 8);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 45 to 65
	value = ((uint32_t)(input[5] & 0x07) << 29) |
			((uint32_t)input[6] << 21) |
			((uint32_t)input[7] << 13) |
			((uint32_t)(input[8] & 0xc0) << 5);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 66 to 86
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xfe) << 10);
	output[3] = (double)(value >> 11);
}

static void unpack_4_21bit_unsigned_3off(const uint8_t * input, double * output) {
	// Unpack 4 values into output
	// Values are 21-bit unsigned
	// Skip 3 bits, read 84 bits of data.
	// Input must be at least 11 bytes long

	uint32_t value;

	// read output[0]: from bit 3 to 23
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 24 to 44
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0xf8) << 8);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 45 to 65
	value = ((uint32_t)(input[5] & 0x07) << 29) |
			((uint32_t)input[6] << 21) |
			((uint32_t)input[7] << 13) |
			((uint32_t)(input[8] & 0xc0) << 5);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 66 to 86
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xfe) << 10);
	output[3] = (double)(value >> 11);
}

static void unpack_4_21bit_signed_4off(const uint8_t * input, double * output) {
	// Unpack 4 values into output
	// Values are 21-bit signed
	// Skip 4 bits, read 84 bits of data.
	// Input must be at least 11 bytes long

	int32_t value;

	// read output[0]: from bit 4 to 24
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0x80) << 4);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 25 to 45
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)(input[5] & 0xfc) << 9);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 46 to 66
	value = ((uint32_t)(input[5] & 0x03) << 30) |
			((uint32_t)input[6] << 22) |
			((uint32_t)input[7] << 14) |
			((uint32_t)(input[8] & 0xe0) << 6);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 67 to 87
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)input[10] << 11);
	output[3] = (double)(value >> 11);
}

static void unpack_4_21bit_unsigned_4off(const uint8_t * input, double * output) {
	// Unpack 4 values into output
	// Values are 21-bit unsigned
	// Skip 4 bits, read 84 bits of data.
	// Input must be at least 11 bytes long

	uint32_t value;

	// read output[0]: from bit 4 to 24
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0x80) << 4);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 25 to 45
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)(input[5] & 0xfc) << 9);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 46 to 66
	value = ((uint32_t)(input[5] & 0x03) << 30) |
			((uint32_t)input[6] << 22) |
			((uint32_t)input[7] << 14) |
			((uint32_t)(input[8] & 0xe0) << 6);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 67 to 87
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)input[10] << 11);
	output[3] = (double)(value >> 11);
}

static void unpack_4_21bit_signed_5off(const uint8_t * input, double * output) {
	// Unpack 4 values into output
	// Values are 21-bit signed
	// Skip 5 bits, read 84 bits of data.
	// Input must be at least 12 bytes long

	int32_t value;

	// read output[0]: from bit 5 to 25
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xc0) << 5);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 26 to 46
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)(input[5] & 0xfe) << 10);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 47 to 67
	value = ((uint32_t)(input[5] & 0x01) << 31) |
			((uint32_t)input[6] << 23) |
			((uint32_t)input[7] << 15) |
			((uint32_t)(input[8] & 0xf0) << 7);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 68 to 88
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)input[10] << 12) |
			((uint32_t)(input[11] & 0x80) << 4);
	output[3] = (double)(value >> 11);
}

static void unpack_4_21bit_unsigned_5off(const uint8_t * input, double * output) {
	// Unpack 4 values into output
	// Values are 21-bit unsigned
	// Skip 5 bits, read 84 bits of data.
	// Input must be at least 12 bytes long

	uint32_t value;

	// read output[0]: from bit 5 to 25
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xc0) << 5);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 26 to 46
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)(input[5] & 0xfe) << 10);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 47 to 67
	value = ((uint32_t)(input[5] & 0x01) << 31) |
			((uint32_t)input[6] << 23) |
			((uint32_t)input[7] << 15) |
			((uint32_t)(input[8] & 0xf0) << 7);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 68 to 88
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)input[10] << 12) |
			((uint32_t)(input[11] & 0x80) << 4);
	output[3] = (double)(value >> 11);
}

static void unpack_4_21bit_signed_6off(const uint8_t * input, double * output) {
	// Unpack 4 values into output
	// Values are 21-bit signed
	// Skip 6 bits, read 84 bits of data.
	// Input must be at least 12 bytes long

	int32_t value;

	// read output[0]: from bit 6 to 26
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xe0) << 6);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 27 to 47
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 48 to 68
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)(input[8] & 0xf8) << 8);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 69 to 89
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)input[10] << 13) |
			((uint32_t)(input[11] & 0xc0) << 5);
	output[3] = (double)(value >> 11);
}

static void unpack_4_21bit_unsigned_6off(const uint8_t * input, double * output) {
	// Unpack 4 values into output
	// Values are 21-bit unsigned
	// Skip 6 bits, read 84 bits of data.
	// Input must be at least 12 bytes long

	uint32_t value;

	// read output[0]: from bit 6 to 26
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xe0) << 6);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 27 to 47
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 48 to 68
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)(input[8] & 0xf8) << 8);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 69 to 89
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)input[10] << 13) |
			((uint32_t)(input[11] & 0xc0) << 5);
	output[3] = (double)(value >> 11);
}

static void unpack_4_21bit_signed_7off(const uint8_t * input, double * output) {
	// Unpack 4 values into output
	// Values are 21-bit signed
	// Skip 7 bits, read 84 bits of data.
	// Input must be at least 12 bytes long

	int32_t value;

	// read output[0]: from bit 7 to 27
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xf0) << 7);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 28 to 48
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0x80) << 4);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 49 to 69
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0xfc) << 9);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 70 to 90
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)input[10] << 14) |
			((uint32_t)(input[11] & 0xe0) << 6);
	output[3] = (double)(value >> 11);
}

static void unpack_4_21bit_unsigned_7off(const uint8_t * input, double * output) {
	// Unpack 4 values into output
	// Values are 21-bit unsigned
	// Skip 7 bits, read 84 bits of data.
	// Input must be at least 12 bytes long

	uint32_t value;

	// read output[0]: from bit 7 to 27
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xf0) << 7);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 28 to 48
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0x80) << 4);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 49 to 69
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0xfc) << 9);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 70 to 90
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)input[10] << 14) |
			((uint32_t)(input[11] & 0xe0) << 6);
	output[3] = (double)(value >> 11);
}

static void unpack_5_21bit_signed_0off(const uint8_t * input, double * output) {
	// Unpack 5 values into output
	// Values are 21-bit signed
	// Skip 0 bits, read 105 bits of data.
	// Input must be at least 14 bytes long

	int32_t value;

	// read output[0]: from bit 0 to 20
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0xf8) << 8);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 21 to 41
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)input[4] << 13) |
			((uint32_t)(input[5] & 0xc0) << 5);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 42 to 62
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)input[6] << 18) |
			((uint32_t)(input[7] & 0xfe) << 10);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 63 to 83
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)input[9] << 15) |
			((uint32_t)(input[10] & 0xf0) << 7);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 84 to 104
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)input[12] << 12) |
			((uint32_t)(input[13] & 0x80) << 4);
	output[4] = (double)(value >> 11);
}

static void unpack_5_21bit_unsigned_0off(const uint8_t * input, double * output) {
	// Unpack 5 values into output
	// Values are 21-bit unsigned
	// Skip 0 bits, read 105 bits of data.
	// Input must be at least 14 bytes long

	uint32_t value;

	// read output[0]: from bit 0 to 20
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0xf8) << 8);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 21 to 41
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)input[4] << 13) |
			((uint32_t)(input[5] & 0xc0) << 5);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 42 to 62
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)input[6] << 18) |
			((uint32_t)(input[7] & 0xfe) << 10);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 63 to 83
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)input[9] << 15) |
			((uint32_t)(input[10] & 0xf0) << 7);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 84 to 104
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)input[12] << 12) |
			((uint32_t)(input[13] & 0x80) << 4);
	output[4] = (double)(value >> 11);
}

static void unpack_5_21bit_signed_1off(const uint8_t * input, double * output) {
	// Unpack 5 values into output
	// Values are 21-bit signed
	// Skip 1 bits, read 105 bits of data.
	// Input must be at least 14 bytes long

	int32_t value;

	// read output[0]: from bit 1 to 21
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xfc) << 9);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 22 to 42
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)input[4] << 14) |
			((uint32_t)(input[5] & 0xe0) << 6);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 43 to 63
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)input[6] << 19) |
			((uint32_t)input[7] << 11);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 64 to 84
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16) |
			((uint32_t)(input[10] & 0xf8) << 8);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 85 to 105
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)input[12] << 13) |
			((uint32_t)(input[13] & 0xc0) << 5);
	output[4] = (double)(value >> 11);
}

static void unpack_5_21bit_unsigned_1off(const uint8_t * input, double * output) {
	// Unpack 5 values into output
	// Values are 21-bit unsigned
	// Skip 1 bits, read 105 bits of data.
	// Input must be at least 14 bytes long

	uint32_t value;

	// read output[0]: from bit 1 to 21
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xfc) << 9);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 22 to 42
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)input[4] << 14) |
			((uint32_t)(input[5] & 0xe0) << 6);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 43 to 63
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)input[6] << 19) |
			((uint32_t)input[7] << 11);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 64 to 84
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16) |
			((uint32_t)(input[10] & 0xf8) << 8);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 85 to 105
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)input[12] << 13) |
			((uint32_t)(input[13] & 0xc0) << 5);
	output[4] = (double)(value >> 11);
}

static void unpack_5_21bit_signed_2off(const uint8_t * input, double * output) {
	// Unpack 5 values into output
	// Values are 21-bit signed
	// Skip 2 bits, read 105 bits of data.
	// Input must be at least 14 bytes long

	int32_t value;

	// read output[0]: from bit 2 to 22
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xfe) << 10);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 23 to 43
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15) |
			((uint32_t)(input[5] & 0xf0) << 7);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 44 to 64
	value = ((uint32_t)(input[5] & 0x0f) << 28) |
			((uint32_t)input[6] << 20) |
			((uint32_t)input[7] << 12) |
			((uint32_t)(input[8] & 0x80) << 4);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 65 to 85
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0xfc) << 9);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 86 to 106
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)input[12] << 14) |
			((uint32_t)(input[13] & 0xe0) << 6);
	output[4] = (double)(value >> 11);
}

static void unpack_5_21bit_unsigned_2off(const uint8_t * input, double * output) {
	// Unpack 5 values into output
	// Values are 21-bit unsigned
	// Skip 2 bits, read 105 bits of data.
	// Input must be at least 14 bytes long

	uint32_t value;

	// read output[0]: from bit 2 to 22
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xfe) << 10);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 23 to 43
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15) |
			((uint32_t)(input[5] & 0xf0) << 7);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 44 to 64
	value = ((uint32_t)(input[5] & 0x0f) << 28) |
			((uint32_t)input[6] << 20) |
			((uint32_t)input[7] << 12) |
			((uint32_t)(input[8] & 0x80) << 4);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 65 to 85
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0xfc) << 9);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 86 to 106
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)input[12] << 14) |
			((uint32_t)(input[13] & 0xe0) << 6);
	output[4] = (double)(value >> 11);
}

static void unpack_5_21bit_signed_3off(const uint8_t * input, double * output) {
	// Unpack 5 values into output
	// Values are 21-bit signed
	// Skip 3 bits, read 105 bits of data.
	// Input must be at least 14 bytes long

	int32_t value;

	// read output[0]: from bit 3 to 23
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 24 to 44
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0xf8) << 8);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 45 to 65
	value = ((uint32_t)(input[5] & 0x07) << 29) |
			((uint32_t)input[6] << 21) |
			((uint32_t)input[7] << 13) |
			((uint32_t)(input[8] & 0xc0) << 5);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 66 to 86
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xfe) << 10);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 87 to 107
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15) |
			((uint32_t)(input[13] & 0xf0) << 7);
	output[4] = (double)(value >> 11);
}

static void unpack_5_21bit_unsigned_3off(const uint8_t * input, double * output) {
	// Unpack 5 values into output
	// Values are 21-bit unsigned
	// Skip 3 bits, read 105 bits of data.
	// Input must be at least 14 bytes long

	uint32_t value;

	// read output[0]: from bit 3 to 23
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 24 to 44
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0xf8) << 8);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 45 to 65
	value = ((uint32_t)(input[5] & 0x07) << 29) |
			((uint32_t)input[6] << 21) |
			((uint32_t)input[7] << 13) |
			((uint32_t)(input[8] & 0xc0) << 5);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 66 to 86
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xfe) << 10);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 87 to 107
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15) |
			((uint32_t)(input[13] & 0xf0) << 7);
	output[4] = (double)(value >> 11);
}

static void unpack_5_21bit_signed_4off(const uint8_t * input, double * output) {
	// Unpack 5 values into output
	// Values are 21-bit signed
	// Skip 4 bits, read 105 bits of data.
	// Input must be at least 14 bytes long

	int32_t value;

	// read output[0]: from bit 4 to 24
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0x80) << 4);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 25 to 45
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)(input[5] & 0xfc) << 9);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 46 to 66
	value = ((uint32_t)(input[5] & 0x03) << 30) |
			((uint32_t)input[6] << 22) |
			((uint32_t)input[7] << 14) |
			((uint32_t)(input[8] & 0xe0) << 6);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 67 to 87
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)input[10] << 11);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 88 to 108
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0xf8) << 8);
	output[4] = (double)(value >> 11);
}

static void unpack_5_21bit_unsigned_4off(const uint8_t * input, double * output) {
	// Unpack 5 values into output
	// Values are 21-bit unsigned
	// Skip 4 bits, read 105 bits of data.
	// Input must be at least 14 bytes long

	uint32_t value;

	// read output[0]: from bit 4 to 24
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0x80) << 4);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 25 to 45
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)(input[5] & 0xfc) << 9);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 46 to 66
	value = ((uint32_t)(input[5] & 0x03) << 30) |
			((uint32_t)input[6] << 22) |
			((uint32_t)input[7] << 14) |
			((uint32_t)(input[8] & 0xe0) << 6);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 67 to 87
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)input[10] << 11);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 88 to 108
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0xf8) << 8);
	output[4] = (double)(value >> 11);
}

static void unpack_5_21bit_signed_5off(const uint8_t * input, double * output) {
	// Unpack 5 values into output
	// Values are 21-bit signed
	// Skip 5 bits, read 105 bits of data.
	// Input must be at least 14 bytes long

	int32_t value;

	// read output[0]: from bit 5 to 25
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xc0) << 5);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 26 to 46
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)(input[5] & 0xfe) << 10);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 47 to 67
	value = ((uint32_t)(input[5] & 0x01) << 31) |
			((uint32_t)input[6] << 23) |
			((uint32_t)input[7] << 15) |
			((uint32_t)(input[8] & 0xf0) << 7);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 68 to 88
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)input[10] << 12) |
			((uint32_t)(input[11] & 0x80) << 4);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 89 to 109
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xfc) << 9);
	output[4] = (double)(value >> 11);
}

static void unpack_5_21bit_unsigned_5off(const uint8_t * input, double * output) {
	// Unpack 5 values into output
	// Values are 21-bit unsigned
	// Skip 5 bits, read 105 bits of data.
	// Input must be at least 14 bytes long

	uint32_t value;

	// read output[0]: from bit 5 to 25
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xc0) << 5);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 26 to 46
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)(input[5] & 0xfe) << 10);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 47 to 67
	value = ((uint32_t)(input[5] & 0x01) << 31) |
			((uint32_t)input[6] << 23) |
			((uint32_t)input[7] << 15) |
			((uint32_t)(input[8] & 0xf0) << 7);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 68 to 88
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)input[10] << 12) |
			((uint32_t)(input[11] & 0x80) << 4);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 89 to 109
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xfc) << 9);
	output[4] = (double)(value >> 11);
}

static void unpack_5_21bit_signed_6off(const uint8_t * input, double * output) {
	// Unpack 5 values into output
	// Values are 21-bit signed
	// Skip 6 bits, read 105 bits of data.
	// Input must be at least 14 bytes long

	int32_t value;

	// read output[0]: from bit 6 to 26
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xe0) << 6);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 27 to 47
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 48 to 68
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)(input[8] & 0xf8) << 8);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 69 to 89
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)input[10] << 13) |
			((uint32_t)(input[11] & 0xc0) << 5);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 90 to 110
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xfe) << 10);
	output[4] = (double)(value >> 11);
}

static void unpack_5_21bit_unsigned_6off(const uint8_t * input, double * output) {
	// Unpack 5 values into output
	// Values are 21-bit unsigned
	// Skip 6 bits, read 105 bits of data.
	// Input must be at least 14 bytes long

	uint32_t value;

	// read output[0]: from bit 6 to 26
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xe0) << 6);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 27 to 47
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 48 to 68
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)(input[8] & 0xf8) << 8);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 69 to 89
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)input[10] << 13) |
			((uint32_t)(input[11] & 0xc0) << 5);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 90 to 110
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xfe) << 10);
	output[4] = (double)(value >> 11);
}

static void unpack_5_21bit_signed_7off(const uint8_t * input, double * output) {
	// Unpack 5 values into output
	// Values are 21-bit signed
	// Skip 7 bits, read 105 bits of data.
	// Input must be at least 14 bytes long

	int32_t value;

	// read output[0]: from bit 7 to 27
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xf0) << 7);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 28 to 48
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0x80) << 4);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 49 to 69
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0xfc) << 9);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 70 to 90
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)input[10] << 14) |
			((uint32_t)(input[11] & 0xe0) << 6);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 91 to 111
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)input[13] << 11);
	output[4] = (double)(value >> 11);
}

static void unpack_5_21bit_unsigned_7off(const uint8_t * input, double * output) {
	// Unpack 5 values into output
	// Values are 21-bit unsigned
	// Skip 7 bits, read 105 bits of data.
	// Input must be at least 14 bytes long

	uint32_t value;

	// read output[0]: from bit 7 to 27
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xf0) << 7);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 28 to 48
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0x80) << 4);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 49 to 69
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0xfc) << 9);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 70 to 90
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)input[10] << 14) |
			((uint32_t)(input[11] & 0xe0) << 6);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 91 to 111
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)input[13] << 11);
	output[4] = (double)(value >> 11);
}

static void unpack_6_21bit_signed_0off(const uint8_t * input, double * output) {
	// Unpack 6 values into output
	// Values are 21-bit signed
	// Skip 0 bits, read 126 bits of data.
	// Input must be at least 16 bytes long

	int32_t value;

	// read output[0]: from bit 0 to 20
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0xf8) << 8);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 21 to 41
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)input[4] << 13) |
			((uint32_t)(input[5] & 0xc0) << 5);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 42 to 62
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)input[6] << 18) |
			((uint32_t)(input[7] & 0xfe) << 10);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 63 to 83
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)input[9] << 15) |
			((uint32_t)(input[10] & 0xf0) << 7);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 84 to 104
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)input[12] << 12) |
			((uint32_t)(input[13] & 0x80) << 4);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 105 to 125
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xfc) << 9);
	output[5] = (double)(value >> 11);
}

static void unpack_6_21bit_unsigned_0off(const uint8_t * input, double * output) {
	// Unpack 6 values into output
	// Values are 21-bit unsigned
	// Skip 0 bits, read 126 bits of data.
	// Input must be at least 16 bytes long

	uint32_t value;

	// read output[0]: from bit 0 to 20
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0xf8) << 8);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 21 to 41
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)input[4] << 13) |
			((uint32_t)(input[5] & 0xc0) << 5);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 42 to 62
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)input[6] << 18) |
			((uint32_t)(input[7] & 0xfe) << 10);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 63 to 83
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)input[9] << 15) |
			((uint32_t)(input[10] & 0xf0) << 7);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 84 to 104
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)input[12] << 12) |
			((uint32_t)(input[13] & 0x80) << 4);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 105 to 125
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xfc) << 9);
	output[5] = (double)(value >> 11);
}

static void unpack_6_21bit_signed_1off(const uint8_t * input, double * output) {
	// Unpack 6 values into output
	// Values are 21-bit signed
	// Skip 1 bits, read 126 bits of data.
	// Input must be at least 16 bytes long

	int32_t value;

	// read output[0]: from bit 1 to 21
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xfc) << 9);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 22 to 42
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)input[4] << 14) |
			((uint32_t)(input[5] & 0xe0) << 6);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 43 to 63
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)input[6] << 19) |
			((uint32_t)input[7] << 11);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 64 to 84
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16) |
			((uint32_t)(input[10] & 0xf8) << 8);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 85 to 105
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)input[12] << 13) |
			((uint32_t)(input[13] & 0xc0) << 5);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 106 to 126
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xfe) << 10);
	output[5] = (double)(value >> 11);
}

static void unpack_6_21bit_unsigned_1off(const uint8_t * input, double * output) {
	// Unpack 6 values into output
	// Values are 21-bit unsigned
	// Skip 1 bits, read 126 bits of data.
	// Input must be at least 16 bytes long

	uint32_t value;

	// read output[0]: from bit 1 to 21
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xfc) << 9);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 22 to 42
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)input[4] << 14) |
			((uint32_t)(input[5] & 0xe0) << 6);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 43 to 63
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)input[6] << 19) |
			((uint32_t)input[7] << 11);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 64 to 84
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16) |
			((uint32_t)(input[10] & 0xf8) << 8);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 85 to 105
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)input[12] << 13) |
			((uint32_t)(input[13] & 0xc0) << 5);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 106 to 126
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xfe) << 10);
	output[5] = (double)(value >> 11);
}

static void unpack_6_21bit_signed_2off(const uint8_t * input, double * output) {
	// Unpack 6 values into output
	// Values are 21-bit signed
	// Skip 2 bits, read 126 bits of data.
	// Input must be at least 16 bytes long

	int32_t value;

	// read output[0]: from bit 2 to 22
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xfe) << 10);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 23 to 43
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15) |
			((uint32_t)(input[5] & 0xf0) << 7);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 44 to 64
	value = ((uint32_t)(input[5] & 0x0f) << 28) |
			((uint32_t)input[6] << 20) |
			((uint32_t)input[7] << 12) |
			((uint32_t)(input[8] & 0x80) << 4);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 65 to 85
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0xfc) << 9);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 86 to 106
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)input[12] << 14) |
			((uint32_t)(input[13] & 0xe0) << 6);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 107 to 127
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)input[15] << 11);
	output[5] = (double)(value >> 11);
}

static void unpack_6_21bit_unsigned_2off(const uint8_t * input, double * output) {
	// Unpack 6 values into output
	// Values are 21-bit unsigned
	// Skip 2 bits, read 126 bits of data.
	// Input must be at least 16 bytes long

	uint32_t value;

	// read output[0]: from bit 2 to 22
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xfe) << 10);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 23 to 43
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15) |
			((uint32_t)(input[5] & 0xf0) << 7);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 44 to 64
	value = ((uint32_t)(input[5] & 0x0f) << 28) |
			((uint32_t)input[6] << 20) |
			((uint32_t)input[7] << 12) |
			((uint32_t)(input[8] & 0x80) << 4);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 65 to 85
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0xfc) << 9);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 86 to 106
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)input[12] << 14) |
			((uint32_t)(input[13] & 0xe0) << 6);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 107 to 127
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)input[15] << 11);
	output[5] = (double)(value >> 11);
}

static void unpack_6_21bit_signed_3off(const uint8_t * input, double * output) {
	// Unpack 6 values into output
	// Values are 21-bit signed
	// Skip 3 bits, read 126 bits of data.
	// Input must be at least 17 bytes long

	int32_t value;

	// read output[0]: from bit 3 to 23
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 24 to 44
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0xf8) << 8);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 45 to 65
	value = ((uint32_t)(input[5] & 0x07) << 29) |
			((uint32_t)input[6] << 21) |
			((uint32_t)input[7] << 13) |
			((uint32_t)(input[8] & 0xc0) << 5);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 66 to 86
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xfe) << 10);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 87 to 107
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15) |
			((uint32_t)(input[13] & 0xf0) << 7);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 108 to 128
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)input[15] << 12) |
			((uint32_t)(input[16] & 0x80) << 4);
	output[5] = (double)(value >> 11);
}

static void unpack_6_21bit_unsigned_3off(const uint8_t * input, double * output) {
	// Unpack 6 values into output
	// Values are 21-bit unsigned
	// Skip 3 bits, read 126 bits of data.
	// Input must be at least 17 bytes long

	uint32_t value;

	// read output[0]: from bit 3 to 23
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 24 to 44
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0xf8) << 8);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 45 to 65
	value = ((uint32_t)(input[5] & 0x07) << 29) |
			((uint32_t)input[6] << 21) |
			((uint32_t)input[7] << 13) |
			((uint32_t)(input[8] & 0xc0) << 5);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 66 to 86
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xfe) << 10);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 87 to 107
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15) |
			((uint32_t)(input[13] & 0xf0) << 7);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 108 to 128
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)input[15] << 12) |
			((uint32_t)(input[16] & 0x80) << 4);
	output[5] = (double)(value >> 11);
}

static void unpack_6_21bit_signed_4off(const uint8_t * input, double * output) {
	// Unpack 6 values into output
	// Values are 21-bit signed
	// Skip 4 bits, read 126 bits of data.
	// Input must be at least 17 bytes long

	int32_t value;

	// read output[0]: from bit 4 to 24
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0x80) << 4);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 25 to 45
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)(input[5] & 0xfc) << 9);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 46 to 66
	value = ((uint32_t)(input[5] & 0x03) << 30) |
			((uint32_t)input[6] << 22) |
			((uint32_t)input[7] << 14) |
			((uint32_t)(input[8] & 0xe0) << 6);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 67 to 87
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)input[10] << 11);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 88 to 108
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0xf8) << 8);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 109 to 129
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)input[15] << 13) |
			((uint32_t)(input[16] & 0xc0) << 5);
	output[5] = (double)(value >> 11);
}

static void unpack_6_21bit_unsigned_4off(const uint8_t * input, double * output) {
	// Unpack 6 values into output
	// Values are 21-bit unsigned
	// Skip 4 bits, read 126 bits of data.
	// Input must be at least 17 bytes long

	uint32_t value;

	// read output[0]: from bit 4 to 24
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0x80) << 4);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 25 to 45
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)(input[5] & 0xfc) << 9);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 46 to 66
	value = ((uint32_t)(input[5] & 0x03) << 30) |
			((uint32_t)input[6] << 22) |
			((uint32_t)input[7] << 14) |
			((uint32_t)(input[8] & 0xe0) << 6);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 67 to 87
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)input[10] << 11);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 88 to 108
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0xf8) << 8);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 109 to 129
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)input[15] << 13) |
			((uint32_t)(input[16] & 0xc0) << 5);
	output[5] = (double)(value >> 11);
}

static void unpack_6_21bit_signed_5off(const uint8_t * input, double * output) {
	// Unpack 6 values into output
	// Values are 21-bit signed
	// Skip 5 bits, read 126 bits of data.
	// Input must be at least 17 bytes long

	int32_t value;

	// read output[0]: from bit 5 to 25
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xc0) << 5);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 26 to 46
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)(input[5] & 0xfe) << 10);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 47 to 67
	value = ((uint32_t)(input[5] & 0x01) << 31) |
			((uint32_t)input[6] << 23) |
			((uint32_t)input[7] << 15) |
			((uint32_t)(input[8] & 0xf0) << 7);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 68 to 88
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)input[10] << 12) |
			((uint32_t)(input[11] & 0x80) << 4);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 89 to 109
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xfc) << 9);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 110 to 130
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)input[15] << 14) |
			((uint32_t)(input[16] & 0xe0) << 6);
	output[5] = (double)(value >> 11);
}

static void unpack_6_21bit_unsigned_5off(const uint8_t * input, double * output) {
	// Unpack 6 values into output
	// Values are 21-bit unsigned
	// Skip 5 bits, read 126 bits of data.
	// Input must be at least 17 bytes long

	uint32_t value;

	// read output[0]: from bit 5 to 25
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xc0) << 5);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 26 to 46
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)(input[5] & 0xfe) << 10);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 47 to 67
	value = ((uint32_t)(input[5] & 0x01) << 31) |
			((uint32_t)input[6] << 23) |
			((uint32_t)input[7] << 15) |
			((uint32_t)(input[8] & 0xf0) << 7);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 68 to 88
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)input[10] << 12) |
			((uint32_t)(input[11] & 0x80) << 4);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 89 to 109
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xfc) << 9);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 110 to 130
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)input[15] << 14) |
			((uint32_t)(input[16] & 0xe0) << 6);
	output[5] = (double)(value >> 11);
}

static void unpack_6_21bit_signed_6off(const uint8_t * input, double * output) {
	// Unpack 6 values into output
	// Values are 21-bit signed
	// Skip 6 bits, read 126 bits of data.
	// Input must be at least 17 bytes long

	int32_t value;

	// read output[0]: from bit 6 to 26
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xe0) << 6);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 27 to 47
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 48 to 68
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)(input[8] & 0xf8) << 8);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 69 to 89
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)input[10] << 13) |
			((uint32_t)(input[11] & 0xc0) << 5);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 90 to 110
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xfe) << 10);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 111 to 131
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)input[15] << 15) |
			((uint32_t)(input[16] & 0xf0) << 7);
	output[5] = (double)(value >> 11);
}

static void unpack_6_21bit_unsigned_6off(const uint8_t * input, double * output) {
	// Unpack 6 values into output
	// Values are 21-bit unsigned
	// Skip 6 bits, read 126 bits of data.
	// Input must be at least 17 bytes long

	uint32_t value;

	// read output[0]: from bit 6 to 26
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xe0) << 6);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 27 to 47
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 48 to 68
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)(input[8] & 0xf8) << 8);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 69 to 89
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)input[10] << 13) |
			((uint32_t)(input[11] & 0xc0) << 5);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 90 to 110
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xfe) << 10);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 111 to 131
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)input[15] << 15) |
			((uint32_t)(input[16] & 0xf0) << 7);
	output[5] = (double)(value >> 11);
}

static void unpack_6_21bit_signed_7off(const uint8_t * input, double * output) {
	// Unpack 6 values into output
	// Values are 21-bit signed
	// Skip 7 bits, read 126 bits of data.
	// Input must be at least 17 bytes long

	int32_t value;

	// read output[0]: from bit 7 to 27
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xf0) << 7);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 28 to 48
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0x80) << 4);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 49 to 69
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0xfc) << 9);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 70 to 90
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)input[10] << 14) |
			((uint32_t)(input[11] & 0xe0) << 6);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 91 to 111
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)input[13] << 11);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 112 to 132
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16) |
			((uint32_t)(input[16] & 0xf8) << 8);
	output[5] = (double)(value >> 11);
}

static void unpack_6_21bit_unsigned_7off(const uint8_t * input, double * output) {
	// Unpack 6 values into output
	// Values are 21-bit unsigned
	// Skip 7 bits, read 126 bits of data.
	// Input must be at least 17 bytes long

	uint32_t value;

	// read output[0]: from bit 7 to 27
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xf0) << 7);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 28 to 48
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0x80) << 4);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 49 to 69
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0xfc) << 9);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 70 to 90
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)input[10] << 14) |
			((uint32_t)(input[11] & 0xe0) << 6);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 91 to 111
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)input[13] << 11);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 112 to 132
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16) |
			((uint32_t)(input[16] & 0xf8) << 8);
	output[5] = (double)(value >> 11);
}

static void unpack_7_21bit_signed_0off(const uint8_t * input, double * output) {
	// Unpack 7 values into output
	// Values are 21-bit signed
	// Skip 0 bits, read 147 bits of data.
	// Input must be at least 19 bytes long

	int32_t value;

	// read output[0]: from bit 0 to 20
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0xf8) << 8);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 21 to 41
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)input[4] << 13) |
			((uint32_t)(input[5] & 0xc0) << 5);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 42 to 62
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)input[6] << 18) |
			((uint32_t)(input[7] & 0xfe) << 10);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 63 to 83
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)input[9] << 15) |
			((uint32_t)(input[10] & 0xf0) << 7);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 84 to 104
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)input[12] << 12) |
			((uint32_t)(input[13] & 0x80) << 4);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 105 to 125
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xfc) << 9);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 126 to 146
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xe0) << 6);
	output[6] = (double)(value >> 11);
}

static void unpack_7_21bit_unsigned_0off(const uint8_t * input, double * output) {
	// Unpack 7 values into output
	// Values are 21-bit unsigned
	// Skip 0 bits, read 147 bits of data.
	// Input must be at least 19 bytes long

	uint32_t value;

	// read output[0]: from bit 0 to 20
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0xf8) << 8);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 21 to 41
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)input[4] << 13) |
			((uint32_t)(input[5] & 0xc0) << 5);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 42 to 62
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)input[6] << 18) |
			((uint32_t)(input[7] & 0xfe) << 10);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 63 to 83
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)input[9] << 15) |
			((uint32_t)(input[10] & 0xf0) << 7);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 84 to 104
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)input[12] << 12) |
			((uint32_t)(input[13] & 0x80) << 4);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 105 to 125
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xfc) << 9);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 126 to 146
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xe0) << 6);
	output[6] = (double)(value >> 11);
}

static void unpack_7_21bit_signed_1off(const uint8_t * input, double * output) {
	// Unpack 7 values into output
	// Values are 21-bit signed
	// Skip 1 bits, read 147 bits of data.
	// Input must be at least 19 bytes long

	int32_t value;

	// read output[0]: from bit 1 to 21
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xfc) << 9);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 22 to 42
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)input[4] << 14) |
			((uint32_t)(input[5] & 0xe0) << 6);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 43 to 63
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)input[6] << 19) |
			((uint32_t)input[7] << 11);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 64 to 84
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16) |
			((uint32_t)(input[10] & 0xf8) << 8);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 85 to 105
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)input[12] << 13) |
			((uint32_t)(input[13] & 0xc0) << 5);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 106 to 126
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xfe) << 10);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 127 to 147
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xf0) << 7);
	output[6] = (double)(value >> 11);
}

static void unpack_7_21bit_unsigned_1off(const uint8_t * input, double * output) {
	// Unpack 7 values into output
	// Values are 21-bit unsigned
	// Skip 1 bits, read 147 bits of data.
	// Input must be at least 19 bytes long

	uint32_t value;

	// read output[0]: from bit 1 to 21
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xfc) << 9);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 22 to 42
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)input[4] << 14) |
			((uint32_t)(input[5] & 0xe0) << 6);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 43 to 63
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)input[6] << 19) |
			((uint32_t)input[7] << 11);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 64 to 84
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16) |
			((uint32_t)(input[10] & 0xf8) << 8);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 85 to 105
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)input[12] << 13) |
			((uint32_t)(input[13] & 0xc0) << 5);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 106 to 126
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xfe) << 10);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 127 to 147
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xf0) << 7);
	output[6] = (double)(value >> 11);
}

static void unpack_7_21bit_signed_2off(const uint8_t * input, double * output) {
	// Unpack 7 values into output
	// Values are 21-bit signed
	// Skip 2 bits, read 147 bits of data.
	// Input must be at least 19 bytes long

	int32_t value;

	// read output[0]: from bit 2 to 22
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xfe) << 10);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 23 to 43
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15) |
			((uint32_t)(input[5] & 0xf0) << 7);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 44 to 64
	value = ((uint32_t)(input[5] & 0x0f) << 28) |
			((uint32_t)input[6] << 20) |
			((uint32_t)input[7] << 12) |
			((uint32_t)(input[8] & 0x80) << 4);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 65 to 85
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0xfc) << 9);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 86 to 106
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)input[12] << 14) |
			((uint32_t)(input[13] & 0xe0) << 6);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 107 to 127
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)input[15] << 11);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 128 to 148
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16) |
			((uint32_t)(input[18] & 0xf8) << 8);
	output[6] = (double)(value >> 11);
}

static void unpack_7_21bit_unsigned_2off(const uint8_t * input, double * output) {
	// Unpack 7 values into output
	// Values are 21-bit unsigned
	// Skip 2 bits, read 147 bits of data.
	// Input must be at least 19 bytes long

	uint32_t value;

	// read output[0]: from bit 2 to 22
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xfe) << 10);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 23 to 43
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15) |
			((uint32_t)(input[5] & 0xf0) << 7);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 44 to 64
	value = ((uint32_t)(input[5] & 0x0f) << 28) |
			((uint32_t)input[6] << 20) |
			((uint32_t)input[7] << 12) |
			((uint32_t)(input[8] & 0x80) << 4);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 65 to 85
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0xfc) << 9);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 86 to 106
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)input[12] << 14) |
			((uint32_t)(input[13] & 0xe0) << 6);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 107 to 127
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)input[15] << 11);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 128 to 148
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16) |
			((uint32_t)(input[18] & 0xf8) << 8);
	output[6] = (double)(value >> 11);
}

static void unpack_7_21bit_signed_3off(const uint8_t * input, double * output) {
	// Unpack 7 values into output
	// Values are 21-bit signed
	// Skip 3 bits, read 147 bits of data.
	// Input must be at least 19 bytes long

	int32_t value;

	// read output[0]: from bit 3 to 23
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 24 to 44
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0xf8) << 8);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 45 to 65
	value = ((uint32_t)(input[5] & 0x07) << 29) |
			((uint32_t)input[6] << 21) |
			((uint32_t)input[7] << 13) |
			((uint32_t)(input[8] & 0xc0) << 5);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 66 to 86
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xfe) << 10);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 87 to 107
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15) |
			((uint32_t)(input[13] & 0xf0) << 7);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 108 to 128
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)input[15] << 12) |
			((uint32_t)(input[16] & 0x80) << 4);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 129 to 149
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0xfc) << 9);
	output[6] = (double)(value >> 11);
}

static void unpack_7_21bit_unsigned_3off(const uint8_t * input, double * output) {
	// Unpack 7 values into output
	// Values are 21-bit unsigned
	// Skip 3 bits, read 147 bits of data.
	// Input must be at least 19 bytes long

	uint32_t value;

	// read output[0]: from bit 3 to 23
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 24 to 44
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0xf8) << 8);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 45 to 65
	value = ((uint32_t)(input[5] & 0x07) << 29) |
			((uint32_t)input[6] << 21) |
			((uint32_t)input[7] << 13) |
			((uint32_t)(input[8] & 0xc0) << 5);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 66 to 86
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xfe) << 10);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 87 to 107
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15) |
			((uint32_t)(input[13] & 0xf0) << 7);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 108 to 128
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)input[15] << 12) |
			((uint32_t)(input[16] & 0x80) << 4);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 129 to 149
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0xfc) << 9);
	output[6] = (double)(value >> 11);
}

static void unpack_7_21bit_signed_4off(const uint8_t * input, double * output) {
	// Unpack 7 values into output
	// Values are 21-bit signed
	// Skip 4 bits, read 147 bits of data.
	// Input must be at least 19 bytes long

	int32_t value;

	// read output[0]: from bit 4 to 24
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0x80) << 4);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 25 to 45
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)(input[5] & 0xfc) << 9);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 46 to 66
	value = ((uint32_t)(input[5] & 0x03) << 30) |
			((uint32_t)input[6] << 22) |
			((uint32_t)input[7] << 14) |
			((uint32_t)(input[8] & 0xe0) << 6);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 67 to 87
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)input[10] << 11);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 88 to 108
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0xf8) << 8);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 109 to 129
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)input[15] << 13) |
			((uint32_t)(input[16] & 0xc0) << 5);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 130 to 150
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xfe) << 10);
	output[6] = (double)(value >> 11);
}

static void unpack_7_21bit_unsigned_4off(const uint8_t * input, double * output) {
	// Unpack 7 values into output
	// Values are 21-bit unsigned
	// Skip 4 bits, read 147 bits of data.
	// Input must be at least 19 bytes long

	uint32_t value;

	// read output[0]: from bit 4 to 24
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0x80) << 4);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 25 to 45
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)(input[5] & 0xfc) << 9);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 46 to 66
	value = ((uint32_t)(input[5] & 0x03) << 30) |
			((uint32_t)input[6] << 22) |
			((uint32_t)input[7] << 14) |
			((uint32_t)(input[8] & 0xe0) << 6);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 67 to 87
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)input[10] << 11);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 88 to 108
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0xf8) << 8);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 109 to 129
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)input[15] << 13) |
			((uint32_t)(input[16] & 0xc0) << 5);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 130 to 150
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xfe) << 10);
	output[6] = (double)(value >> 11);
}

static void unpack_7_21bit_signed_5off(const uint8_t * input, double * output) {
	// Unpack 7 values into output
	// Values are 21-bit signed
	// Skip 5 bits, read 147 bits of data.
	// Input must be at least 19 bytes long

	int32_t value;

	// read output[0]: from bit 5 to 25
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xc0) << 5);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 26 to 46
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)(input[5] & 0xfe) << 10);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 47 to 67
	value = ((uint32_t)(input[5] & 0x01) << 31) |
			((uint32_t)input[6] << 23) |
			((uint32_t)input[7] << 15) |
			((uint32_t)(input[8] & 0xf0) << 7);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 68 to 88
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)input[10] << 12) |
			((uint32_t)(input[11] & 0x80) << 4);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 89 to 109
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xfc) << 9);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 110 to 130
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)input[15] << 14) |
			((uint32_t)(input[16] & 0xe0) << 6);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 131 to 151
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)input[18] << 11);
	output[6] = (double)(value >> 11);
}

static void unpack_7_21bit_unsigned_5off(const uint8_t * input, double * output) {
	// Unpack 7 values into output
	// Values are 21-bit unsigned
	// Skip 5 bits, read 147 bits of data.
	// Input must be at least 19 bytes long

	uint32_t value;

	// read output[0]: from bit 5 to 25
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xc0) << 5);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 26 to 46
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)(input[5] & 0xfe) << 10);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 47 to 67
	value = ((uint32_t)(input[5] & 0x01) << 31) |
			((uint32_t)input[6] << 23) |
			((uint32_t)input[7] << 15) |
			((uint32_t)(input[8] & 0xf0) << 7);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 68 to 88
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)input[10] << 12) |
			((uint32_t)(input[11] & 0x80) << 4);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 89 to 109
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xfc) << 9);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 110 to 130
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)input[15] << 14) |
			((uint32_t)(input[16] & 0xe0) << 6);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 131 to 151
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)input[18] << 11);
	output[6] = (double)(value >> 11);
}

static void unpack_7_21bit_signed_6off(const uint8_t * input, double * output) {
	// Unpack 7 values into output
	// Values are 21-bit signed
	// Skip 6 bits, read 147 bits of data.
	// Input must be at least 20 bytes long

	int32_t value;

	// read output[0]: from bit 6 to 26
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xe0) << 6);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 27 to 47
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 48 to 68
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)(input[8] & 0xf8) << 8);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 69 to 89
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)input[10] << 13) |
			((uint32_t)(input[11] & 0xc0) << 5);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 90 to 110
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xfe) << 10);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 111 to 131
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)input[15] << 15) |
			((uint32_t)(input[16] & 0xf0) << 7);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 132 to 152
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)input[18] << 12) |
			((uint32_t)(input[19] & 0x80) << 4);
	output[6] = (double)(value >> 11);
}

static void unpack_7_21bit_unsigned_6off(const uint8_t * input, double * output) {
	// Unpack 7 values into output
	// Values are 21-bit unsigned
	// Skip 6 bits, read 147 bits of data.
	// Input must be at least 20 bytes long

	uint32_t value;

	// read output[0]: from bit 6 to 26
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xe0) << 6);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 27 to 47
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 48 to 68
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)(input[8] & 0xf8) << 8);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 69 to 89
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)input[10] << 13) |
			((uint32_t)(input[11] & 0xc0) << 5);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 90 to 110
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xfe) << 10);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 111 to 131
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)input[15] << 15) |
			((uint32_t)(input[16] & 0xf0) << 7);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 132 to 152
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)input[18] << 12) |
			((uint32_t)(input[19] & 0x80) << 4);
	output[6] = (double)(value >> 11);
}

static void unpack_7_21bit_signed_7off(const uint8_t * input, double * output) {
	// Unpack 7 values into output
	// Values are 21-bit signed
	// Skip 7 bits, read 147 bits of data.
	// Input must be at least 20 bytes long

	int32_t value;

	// read output[0]: from bit 7 to 27
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xf0) << 7);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 28 to 48
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0x80) << 4);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 49 to 69
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0xfc) << 9);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 70 to 90
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)input[10] << 14) |
			((uint32_t)(input[11] & 0xe0) << 6);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 91 to 111
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)input[13] << 11);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 112 to 132
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16) |
			((uint32_t)(input[16] & 0xf8) << 8);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 133 to 153
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)input[18] << 13) |
			((uint32_t)(input[19] & 0xc0) << 5);
	output[6] = (double)(value >> 11);
}

static void unpack_7_21bit_unsigned_7off(const uint8_t * input, double * output) {
	// Unpack 7 values into output
	// Values are 21-bit unsigned
	// Skip 7 bits, read 147 bits of data.
	// Input must be at least 20 bytes long

	uint32_t value;

	// read output[0]: from bit 7 to 27
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xf0) << 7);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 28 to 48
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0x80) << 4);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 49 to 69
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0xfc) << 9);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 70 to 90
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)input[10] << 14) |
			((uint32_t)(input[11] & 0xe0) << 6);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 91 to 111
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)input[13] << 11);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 112 to 132
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16) |
			((uint32_t)(input[16] & 0xf8) << 8);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 133 to 153
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)input[18] << 13) |
			((uint32_t)(input[19] & 0xc0) << 5);
	output[6] = (double)(value >> 11);
}

static void unpack_8_21bit_signed_0off(const uint8_t * input, double * output) {
	// Unpack 8 values into output
	// Values are 21-bit signed
	// Skip 0 bits, read 168 bits of data.
	// Input must be at least 21 bytes long

	int32_t value;

	// read output[0]: from bit 0 to 20
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0xf8) << 8);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 21 to 41
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)input[4] << 13) |
			((uint32_t)(input[5] & 0xc0) << 5);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 42 to 62
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)input[6] << 18) |
			((uint32_t)(input[7] & 0xfe) << 10);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 63 to 83
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)input[9] << 15) |
			((uint32_t)(input[10] & 0xf0) << 7);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 84 to 104
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)input[12] << 12) |
			((uint32_t)(input[13] & 0x80) << 4);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 105 to 125
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xfc) << 9);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 126 to 146
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xe0) << 6);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 147 to 167
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11);
	output[7] = (double)(value >> 11);
}

static void unpack_8_21bit_unsigned_0off(const uint8_t * input, double * output) {
	// Unpack 8 values into output
	// Values are 21-bit unsigned
	// Skip 0 bits, read 168 bits of data.
	// Input must be at least 21 bytes long

	uint32_t value;

	// read output[0]: from bit 0 to 20
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0xf8) << 8);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 21 to 41
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)input[4] << 13) |
			((uint32_t)(input[5] & 0xc0) << 5);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 42 to 62
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)input[6] << 18) |
			((uint32_t)(input[7] & 0xfe) << 10);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 63 to 83
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)input[9] << 15) |
			((uint32_t)(input[10] & 0xf0) << 7);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 84 to 104
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)input[12] << 12) |
			((uint32_t)(input[13] & 0x80) << 4);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 105 to 125
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xfc) << 9);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 126 to 146
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xe0) << 6);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 147 to 167
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11);
	output[7] = (double)(value >> 11);
}

static void unpack_8_21bit_signed_1off(const uint8_t * input, double * output) {
	// Unpack 8 values into output
	// Values are 21-bit signed
	// Skip 1 bits, read 168 bits of data.
	// Input must be at least 22 bytes long

	int32_t value;

	// read output[0]: from bit 1 to 21
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xfc) << 9);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 22 to 42
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)input[4] << 14) |
			((uint32_t)(input[5] & 0xe0) << 6);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 43 to 63
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)input[6] << 19) |
			((uint32_t)input[7] << 11);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 64 to 84
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16) |
			((uint32_t)(input[10] & 0xf8) << 8);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 85 to 105
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)input[12] << 13) |
			((uint32_t)(input[13] & 0xc0) << 5);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 106 to 126
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xfe) << 10);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 127 to 147
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xf0) << 7);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 148 to 168
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0x80) << 4);
	output[7] = (double)(value >> 11);
}

static void unpack_8_21bit_unsigned_1off(const uint8_t * input, double * output) {
	// Unpack 8 values into output
	// Values are 21-bit unsigned
	// Skip 1 bits, read 168 bits of data.
	// Input must be at least 22 bytes long

	uint32_t value;

	// read output[0]: from bit 1 to 21
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xfc) << 9);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 22 to 42
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)input[4] << 14) |
			((uint32_t)(input[5] & 0xe0) << 6);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 43 to 63
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)input[6] << 19) |
			((uint32_t)input[7] << 11);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 64 to 84
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16) |
			((uint32_t)(input[10] & 0xf8) << 8);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 85 to 105
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)input[12] << 13) |
			((uint32_t)(input[13] & 0xc0) << 5);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 106 to 126
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xfe) << 10);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 127 to 147
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xf0) << 7);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 148 to 168
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0x80) << 4);
	output[7] = (double)(value >> 11);
}

static void unpack_8_21bit_signed_2off(const uint8_t * input, double * output) {
	// Unpack 8 values into output
	// Values are 21-bit signed
	// Skip 2 bits, read 168 bits of data.
	// Input must be at least 22 bytes long

	int32_t value;

	// read output[0]: from bit 2 to 22
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xfe) << 10);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 23 to 43
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15) |
			((uint32_t)(input[5] & 0xf0) << 7);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 44 to 64
	value = ((uint32_t)(input[5] & 0x0f) << 28) |
			((uint32_t)input[6] << 20) |
			((uint32_t)input[7] << 12) |
			((uint32_t)(input[8] & 0x80) << 4);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 65 to 85
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0xfc) << 9);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 86 to 106
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)input[12] << 14) |
			((uint32_t)(input[13] & 0xe0) << 6);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 107 to 127
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)input[15] << 11);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 128 to 148
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16) |
			((uint32_t)(input[18] & 0xf8) << 8);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 149 to 169
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xc0) << 5);
	output[7] = (double)(value >> 11);
}

static void unpack_8_21bit_unsigned_2off(const uint8_t * input, double * output) {
	// Unpack 8 values into output
	// Values are 21-bit unsigned
	// Skip 2 bits, read 168 bits of data.
	// Input must be at least 22 bytes long

	uint32_t value;

	// read output[0]: from bit 2 to 22
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xfe) << 10);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 23 to 43
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15) |
			((uint32_t)(input[5] & 0xf0) << 7);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 44 to 64
	value = ((uint32_t)(input[5] & 0x0f) << 28) |
			((uint32_t)input[6] << 20) |
			((uint32_t)input[7] << 12) |
			((uint32_t)(input[8] & 0x80) << 4);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 65 to 85
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0xfc) << 9);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 86 to 106
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)input[12] << 14) |
			((uint32_t)(input[13] & 0xe0) << 6);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 107 to 127
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)input[15] << 11);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 128 to 148
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16) |
			((uint32_t)(input[18] & 0xf8) << 8);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 149 to 169
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xc0) << 5);
	output[7] = (double)(value >> 11);
}

static void unpack_8_21bit_signed_3off(const uint8_t * input, double * output) {
	// Unpack 8 values into output
	// Values are 21-bit signed
	// Skip 3 bits, read 168 bits of data.
	// Input must be at least 22 bytes long

	int32_t value;

	// read output[0]: from bit 3 to 23
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 24 to 44
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0xf8) << 8);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 45 to 65
	value = ((uint32_t)(input[5] & 0x07) << 29) |
			((uint32_t)input[6] << 21) |
			((uint32_t)input[7] << 13) |
			((uint32_t)(input[8] & 0xc0) << 5);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 66 to 86
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xfe) << 10);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 87 to 107
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15) |
			((uint32_t)(input[13] & 0xf0) << 7);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 108 to 128
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)input[15] << 12) |
			((uint32_t)(input[16] & 0x80) << 4);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 129 to 149
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0xfc) << 9);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 150 to 170
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xe0) << 6);
	output[7] = (double)(value >> 11);
}

static void unpack_8_21bit_unsigned_3off(const uint8_t * input, double * output) {
	// Unpack 8 values into output
	// Values are 21-bit unsigned
	// Skip 3 bits, read 168 bits of data.
	// Input must be at least 22 bytes long

	uint32_t value;

	// read output[0]: from bit 3 to 23
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 24 to 44
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0xf8) << 8);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 45 to 65
	value = ((uint32_t)(input[5] & 0x07) << 29) |
			((uint32_t)input[6] << 21) |
			((uint32_t)input[7] << 13) |
			((uint32_t)(input[8] & 0xc0) << 5);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 66 to 86
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xfe) << 10);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 87 to 107
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15) |
			((uint32_t)(input[13] & 0xf0) << 7);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 108 to 128
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)input[15] << 12) |
			((uint32_t)(input[16] & 0x80) << 4);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 129 to 149
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0xfc) << 9);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 150 to 170
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xe0) << 6);
	output[7] = (double)(value >> 11);
}

static void unpack_8_21bit_signed_4off(const uint8_t * input, double * output) {
	// Unpack 8 values into output
	// Values are 21-bit signed
	// Skip 4 bits, read 168 bits of data.
	// Input must be at least 22 bytes long

	int32_t value;

	// read output[0]: from bit 4 to 24
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0x80) << 4);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 25 to 45
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)(input[5] & 0xfc) << 9);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 46 to 66
	value = ((uint32_t)(input[5] & 0x03) << 30) |
			((uint32_t)input[6] << 22) |
			((uint32_t)input[7] << 14) |
			((uint32_t)(input[8] & 0xe0) << 6);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 67 to 87
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)input[10] << 11);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 88 to 108
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0xf8) << 8);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 109 to 129
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)input[15] << 13) |
			((uint32_t)(input[16] & 0xc0) << 5);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 130 to 150
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xfe) << 10);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 151 to 171
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xf0) << 7);
	output[7] = (double)(value >> 11);
}

static void unpack_8_21bit_unsigned_4off(const uint8_t * input, double * output) {
	// Unpack 8 values into output
	// Values are 21-bit unsigned
	// Skip 4 bits, read 168 bits of data.
	// Input must be at least 22 bytes long

	uint32_t value;

	// read output[0]: from bit 4 to 24
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0x80) << 4);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 25 to 45
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)(input[5] & 0xfc) << 9);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 46 to 66
	value = ((uint32_t)(input[5] & 0x03) << 30) |
			((uint32_t)input[6] << 22) |
			((uint32_t)input[7] << 14) |
			((uint32_t)(input[8] & 0xe0) << 6);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 67 to 87
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)input[10] << 11);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 88 to 108
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0xf8) << 8);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 109 to 129
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)input[15] << 13) |
			((uint32_t)(input[16] & 0xc0) << 5);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 130 to 150
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xfe) << 10);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 151 to 171
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xf0) << 7);
	output[7] = (double)(value >> 11);
}

static void unpack_8_21bit_signed_5off(const uint8_t * input, double * output) {
	// Unpack 8 values into output
	// Values are 21-bit signed
	// Skip 5 bits, read 168 bits of data.
	// Input must be at least 22 bytes long

	int32_t value;

	// read output[0]: from bit 5 to 25
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xc0) << 5);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 26 to 46
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)(input[5] & 0xfe) << 10);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 47 to 67
	value = ((uint32_t)(input[5] & 0x01) << 31) |
			((uint32_t)input[6] << 23) |
			((uint32_t)input[7] << 15) |
			((uint32_t)(input[8] & 0xf0) << 7);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 68 to 88
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)input[10] << 12) |
			((uint32_t)(input[11] & 0x80) << 4);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 89 to 109
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xfc) << 9);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 110 to 130
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)input[15] << 14) |
			((uint32_t)(input[16] & 0xe0) << 6);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 131 to 151
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)input[18] << 11);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 152 to 172
	value = ((uint32_t)input[19] << 24) |
			((uint32_t)input[20] << 16) |
			((uint32_t)(input[21] & 0xf8) << 8);
	output[7] = (double)(value >> 11);
}

static void unpack_8_21bit_unsigned_5off(const uint8_t * input, double * output) {
	// Unpack 8 values into output
	// Values are 21-bit unsigned
	// Skip 5 bits, read 168 bits of data.
	// Input must be at least 22 bytes long

	uint32_t value;

	// read output[0]: from bit 5 to 25
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xc0) << 5);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 26 to 46
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)(input[5] & 0xfe) << 10);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 47 to 67
	value = ((uint32_t)(input[5] & 0x01) << 31) |
			((uint32_t)input[6] << 23) |
			((uint32_t)input[7] << 15) |
			((uint32_t)(input[8] & 0xf0) << 7);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 68 to 88
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)input[10] << 12) |
			((uint32_t)(input[11] & 0x80) << 4);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 89 to 109
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xfc) << 9);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 110 to 130
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)input[15] << 14) |
			((uint32_t)(input[16] & 0xe0) << 6);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 131 to 151
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)input[18] << 11);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 152 to 172
	value = ((uint32_t)input[19] << 24) |
			((uint32_t)input[20] << 16) |
			((uint32_t)(input[21] & 0xf8) << 8);
	output[7] = (double)(value >> 11);
}

static void unpack_8_21bit_signed_6off(const uint8_t * input, double * output) {
	// Unpack 8 values into output
	// Values are 21-bit signed
	// Skip 6 bits, read 168 bits of data.
	// Input must be at least 22 bytes long

	int32_t value;

	// read output[0]: from bit 6 to 26
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xe0) << 6);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 27 to 47
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 48 to 68
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)(input[8] & 0xf8) << 8);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 69 to 89
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)input[10] << 13) |
			((uint32_t)(input[11] & 0xc0) << 5);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 90 to 110
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xfe) << 10);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 111 to 131
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)input[15] << 15) |
			((uint32_t)(input[16] & 0xf0) << 7);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 132 to 152
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)input[18] << 12) |
			((uint32_t)(input[19] & 0x80) << 4);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 153 to 173
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xfc) << 9);
	output[7] = (double)(value >> 11);
}

static void unpack_8_21bit_unsigned_6off(const uint8_t * input, double * output) {
	// Unpack 8 values into output
	// Values are 21-bit unsigned
	// Skip 6 bits, read 168 bits of data.
	// Input must be at least 22 bytes long

	uint32_t value;

	// read output[0]: from bit 6 to 26
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xe0) << 6);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 27 to 47
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 48 to 68
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)(input[8] & 0xf8) << 8);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 69 to 89
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)input[10] << 13) |
			((uint32_t)(input[11] & 0xc0) << 5);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 90 to 110
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xfe) << 10);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 111 to 131
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)input[15] << 15) |
			((uint32_t)(input[16] & 0xf0) << 7);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 132 to 152
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)input[18] << 12) |
			((uint32_t)(input[19] & 0x80) << 4);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 153 to 173
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xfc) << 9);
	output[7] = (double)(value >> 11);
}

static void unpack_8_21bit_signed_7off(const uint8_t * input, double * output) {
	// Unpack 8 values into output
	// Values are 21-bit signed
	// Skip 7 bits, read 168 bits of data.
	// Input must be at least 22 bytes long

	int32_t value;

	// read output[0]: from bit 7 to 27
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xf0) << 7);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 28 to 48
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0x80) << 4);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 49 to 69
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0xfc) << 9);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 70 to 90
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)input[10] << 14) |
			((uint32_t)(input[11] & 0xe0) << 6);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 91 to 111
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)input[13] << 11);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 112 to 132
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16) |
			((uint32_t)(input[16] & 0xf8) << 8);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 133 to 153
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)input[18] << 13) |
			((uint32_t)(input[19] & 0xc0) << 5);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 154 to 174
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xfe) << 10);
	output[7] = (double)(value >> 11);
}

static void unpack_8_21bit_unsigned_7off(const uint8_t * input, double * output) {
	// Unpack 8 values into output
	// Values are 21-bit unsigned
	// Skip 7 bits, read 168 bits of data.
	// Input must be at least 22 bytes long

	uint32_t value;

	// read output[0]: from bit 7 to 27
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xf0) << 7);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 28 to 48
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0x80) << 4);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 49 to 69
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0xfc) << 9);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 70 to 90
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)input[10] << 14) |
			((uint32_t)(input[11] & 0xe0) << 6);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 91 to 111
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)input[13] << 11);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 112 to 132
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16) |
			((uint32_t)(input[16] & 0xf8) << 8);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 133 to 153
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)input[18] << 13) |
			((uint32_t)(input[19] & 0xc0) << 5);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 154 to 174
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xfe) << 10);
	output[7] = (double)(value >> 11);
}

static void unpack_9_21bit_signed_0off(const uint8_t * input, double * output) {
	// Unpack 9 values into output
	// Values are 21-bit signed
	// Skip 0 bits, read 189 bits of data.
	// Input must be at least 24 bytes long

	int32_t value;

	// read output[0]: from bit 0 to 20
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0xf8) << 8);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 21 to 41
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)input[4] << 13) |
			((uint32_t)(input[5] & 0xc0) << 5);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 42 to 62
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)input[6] << 18) |
			((uint32_t)(input[7] & 0xfe) << 10);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 63 to 83
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)input[9] << 15) |
			((uint32_t)(input[10] & 0xf0) << 7);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 84 to 104
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)input[12] << 12) |
			((uint32_t)(input[13] & 0x80) << 4);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 105 to 125
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xfc) << 9);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 126 to 146
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xe0) << 6);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 147 to 167
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 168 to 188
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)(input[23] & 0xf8) << 8);
	output[8] = (double)(value >> 11);
}

static void unpack_9_21bit_unsigned_0off(const uint8_t * input, double * output) {
	// Unpack 9 values into output
	// Values are 21-bit unsigned
	// Skip 0 bits, read 189 bits of data.
	// Input must be at least 24 bytes long

	uint32_t value;

	// read output[0]: from bit 0 to 20
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0xf8) << 8);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 21 to 41
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)input[4] << 13) |
			((uint32_t)(input[5] & 0xc0) << 5);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 42 to 62
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)input[6] << 18) |
			((uint32_t)(input[7] & 0xfe) << 10);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 63 to 83
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)input[9] << 15) |
			((uint32_t)(input[10] & 0xf0) << 7);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 84 to 104
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)input[12] << 12) |
			((uint32_t)(input[13] & 0x80) << 4);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 105 to 125
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xfc) << 9);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 126 to 146
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xe0) << 6);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 147 to 167
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 168 to 188
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)(input[23] & 0xf8) << 8);
	output[8] = (double)(value >> 11);
}

static void unpack_9_21bit_signed_1off(const uint8_t * input, double * output) {
	// Unpack 9 values into output
	// Values are 21-bit signed
	// Skip 1 bits, read 189 bits of data.
	// Input must be at least 24 bytes long

	int32_t value;

	// read output[0]: from bit 1 to 21
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xfc) << 9);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 22 to 42
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)input[4] << 14) |
			((uint32_t)(input[5] & 0xe0) << 6);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 43 to 63
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)input[6] << 19) |
			((uint32_t)input[7] << 11);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 64 to 84
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16) |
			((uint32_t)(input[10] & 0xf8) << 8);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 85 to 105
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)input[12] << 13) |
			((uint32_t)(input[13] & 0xc0) << 5);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 106 to 126
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xfe) << 10);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 127 to 147
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xf0) << 7);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 148 to 168
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0x80) << 4);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 169 to 189
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)(input[23] & 0xfc) << 9);
	output[8] = (double)(value >> 11);
}

static void unpack_9_21bit_unsigned_1off(const uint8_t * input, double * output) {
	// Unpack 9 values into output
	// Values are 21-bit unsigned
	// Skip 1 bits, read 189 bits of data.
	// Input must be at least 24 bytes long

	uint32_t value;

	// read output[0]: from bit 1 to 21
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xfc) << 9);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 22 to 42
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)input[4] << 14) |
			((uint32_t)(input[5] & 0xe0) << 6);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 43 to 63
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)input[6] << 19) |
			((uint32_t)input[7] << 11);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 64 to 84
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16) |
			((uint32_t)(input[10] & 0xf8) << 8);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 85 to 105
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)input[12] << 13) |
			((uint32_t)(input[13] & 0xc0) << 5);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 106 to 126
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xfe) << 10);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 127 to 147
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xf0) << 7);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 148 to 168
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0x80) << 4);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 169 to 189
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)(input[23] & 0xfc) << 9);
	output[8] = (double)(value >> 11);
}

static void unpack_9_21bit_signed_2off(const uint8_t * input, double * output) {
	// Unpack 9 values into output
	// Values are 21-bit signed
	// Skip 2 bits, read 189 bits of data.
	// Input must be at least 24 bytes long

	int32_t value;

	// read output[0]: from bit 2 to 22
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xfe) << 10);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 23 to 43
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15) |
			((uint32_t)(input[5] & 0xf0) << 7);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 44 to 64
	value = ((uint32_t)(input[5] & 0x0f) << 28) |
			((uint32_t)input[6] << 20) |
			((uint32_t)input[7] << 12) |
			((uint32_t)(input[8] & 0x80) << 4);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 65 to 85
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0xfc) << 9);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 86 to 106
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)input[12] << 14) |
			((uint32_t)(input[13] & 0xe0) << 6);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 107 to 127
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)input[15] << 11);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 128 to 148
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16) |
			((uint32_t)(input[18] & 0xf8) << 8);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 149 to 169
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xc0) << 5);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 170 to 190
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xfe) << 10);
	output[8] = (double)(value >> 11);
}

static void unpack_9_21bit_unsigned_2off(const uint8_t * input, double * output) {
	// Unpack 9 values into output
	// Values are 21-bit unsigned
	// Skip 2 bits, read 189 bits of data.
	// Input must be at least 24 bytes long

	uint32_t value;

	// read output[0]: from bit 2 to 22
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xfe) << 10);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 23 to 43
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15) |
			((uint32_t)(input[5] & 0xf0) << 7);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 44 to 64
	value = ((uint32_t)(input[5] & 0x0f) << 28) |
			((uint32_t)input[6] << 20) |
			((uint32_t)input[7] << 12) |
			((uint32_t)(input[8] & 0x80) << 4);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 65 to 85
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0xfc) << 9);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 86 to 106
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)input[12] << 14) |
			((uint32_t)(input[13] & 0xe0) << 6);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 107 to 127
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)input[15] << 11);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 128 to 148
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16) |
			((uint32_t)(input[18] & 0xf8) << 8);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 149 to 169
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xc0) << 5);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 170 to 190
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xfe) << 10);
	output[8] = (double)(value >> 11);
}

static void unpack_9_21bit_signed_3off(const uint8_t * input, double * output) {
	// Unpack 9 values into output
	// Values are 21-bit signed
	// Skip 3 bits, read 189 bits of data.
	// Input must be at least 24 bytes long

	int32_t value;

	// read output[0]: from bit 3 to 23
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 24 to 44
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0xf8) << 8);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 45 to 65
	value = ((uint32_t)(input[5] & 0x07) << 29) |
			((uint32_t)input[6] << 21) |
			((uint32_t)input[7] << 13) |
			((uint32_t)(input[8] & 0xc0) << 5);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 66 to 86
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xfe) << 10);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 87 to 107
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15) |
			((uint32_t)(input[13] & 0xf0) << 7);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 108 to 128
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)input[15] << 12) |
			((uint32_t)(input[16] & 0x80) << 4);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 129 to 149
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0xfc) << 9);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 150 to 170
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xe0) << 6);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 171 to 191
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11);
	output[8] = (double)(value >> 11);
}

static void unpack_9_21bit_unsigned_3off(const uint8_t * input, double * output) {
	// Unpack 9 values into output
	// Values are 21-bit unsigned
	// Skip 3 bits, read 189 bits of data.
	// Input must be at least 24 bytes long

	uint32_t value;

	// read output[0]: from bit 3 to 23
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 24 to 44
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0xf8) << 8);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 45 to 65
	value = ((uint32_t)(input[5] & 0x07) << 29) |
			((uint32_t)input[6] << 21) |
			((uint32_t)input[7] << 13) |
			((uint32_t)(input[8] & 0xc0) << 5);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 66 to 86
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xfe) << 10);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 87 to 107
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15) |
			((uint32_t)(input[13] & 0xf0) << 7);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 108 to 128
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)input[15] << 12) |
			((uint32_t)(input[16] & 0x80) << 4);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 129 to 149
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0xfc) << 9);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 150 to 170
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xe0) << 6);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 171 to 191
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11);
	output[8] = (double)(value >> 11);
}

static void unpack_9_21bit_signed_4off(const uint8_t * input, double * output) {
	// Unpack 9 values into output
	// Values are 21-bit signed
	// Skip 4 bits, read 189 bits of data.
	// Input must be at least 25 bytes long

	int32_t value;

	// read output[0]: from bit 4 to 24
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0x80) << 4);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 25 to 45
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)(input[5] & 0xfc) << 9);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 46 to 66
	value = ((uint32_t)(input[5] & 0x03) << 30) |
			((uint32_t)input[6] << 22) |
			((uint32_t)input[7] << 14) |
			((uint32_t)(input[8] & 0xe0) << 6);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 67 to 87
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)input[10] << 11);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 88 to 108
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0xf8) << 8);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 109 to 129
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)input[15] << 13) |
			((uint32_t)(input[16] & 0xc0) << 5);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 130 to 150
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xfe) << 10);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 151 to 171
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xf0) << 7);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 172 to 192
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0x80) << 4);
	output[8] = (double)(value >> 11);
}

static void unpack_9_21bit_unsigned_4off(const uint8_t * input, double * output) {
	// Unpack 9 values into output
	// Values are 21-bit unsigned
	// Skip 4 bits, read 189 bits of data.
	// Input must be at least 25 bytes long

	uint32_t value;

	// read output[0]: from bit 4 to 24
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0x80) << 4);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 25 to 45
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)(input[5] & 0xfc) << 9);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 46 to 66
	value = ((uint32_t)(input[5] & 0x03) << 30) |
			((uint32_t)input[6] << 22) |
			((uint32_t)input[7] << 14) |
			((uint32_t)(input[8] & 0xe0) << 6);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 67 to 87
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)input[10] << 11);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 88 to 108
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0xf8) << 8);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 109 to 129
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)input[15] << 13) |
			((uint32_t)(input[16] & 0xc0) << 5);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 130 to 150
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xfe) << 10);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 151 to 171
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xf0) << 7);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 172 to 192
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0x80) << 4);
	output[8] = (double)(value >> 11);
}

static void unpack_9_21bit_signed_5off(const uint8_t * input, double * output) {
	// Unpack 9 values into output
	// Values are 21-bit signed
	// Skip 5 bits, read 189 bits of data.
	// Input must be at least 25 bytes long

	int32_t value;

	// read output[0]: from bit 5 to 25
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xc0) << 5);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 26 to 46
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)(input[5] & 0xfe) << 10);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 47 to 67
	value = ((uint32_t)(input[5] & 0x01) << 31) |
			((uint32_t)input[6] << 23) |
			((uint32_t)input[7] << 15) |
			((uint32_t)(input[8] & 0xf0) << 7);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 68 to 88
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)input[10] << 12) |
			((uint32_t)(input[11] & 0x80) << 4);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 89 to 109
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xfc) << 9);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 110 to 130
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)input[15] << 14) |
			((uint32_t)(input[16] & 0xe0) << 6);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 131 to 151
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)input[18] << 11);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 152 to 172
	value = ((uint32_t)input[19] << 24) |
			((uint32_t)input[20] << 16) |
			((uint32_t)(input[21] & 0xf8) << 8);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 173 to 193
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xc0) << 5);
	output[8] = (double)(value >> 11);
}

static void unpack_9_21bit_unsigned_5off(const uint8_t * input, double * output) {
	// Unpack 9 values into output
	// Values are 21-bit unsigned
	// Skip 5 bits, read 189 bits of data.
	// Input must be at least 25 bytes long

	uint32_t value;

	// read output[0]: from bit 5 to 25
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xc0) << 5);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 26 to 46
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)(input[5] & 0xfe) << 10);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 47 to 67
	value = ((uint32_t)(input[5] & 0x01) << 31) |
			((uint32_t)input[6] << 23) |
			((uint32_t)input[7] << 15) |
			((uint32_t)(input[8] & 0xf0) << 7);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 68 to 88
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)input[10] << 12) |
			((uint32_t)(input[11] & 0x80) << 4);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 89 to 109
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xfc) << 9);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 110 to 130
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)input[15] << 14) |
			((uint32_t)(input[16] & 0xe0) << 6);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 131 to 151
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)input[18] << 11);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 152 to 172
	value = ((uint32_t)input[19] << 24) |
			((uint32_t)input[20] << 16) |
			((uint32_t)(input[21] & 0xf8) << 8);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 173 to 193
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xc0) << 5);
	output[8] = (double)(value >> 11);
}

static void unpack_9_21bit_signed_6off(const uint8_t * input, double * output) {
	// Unpack 9 values into output
	// Values are 21-bit signed
	// Skip 6 bits, read 189 bits of data.
	// Input must be at least 25 bytes long

	int32_t value;

	// read output[0]: from bit 6 to 26
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xe0) << 6);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 27 to 47
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 48 to 68
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)(input[8] & 0xf8) << 8);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 69 to 89
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)input[10] << 13) |
			((uint32_t)(input[11] & 0xc0) << 5);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 90 to 110
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xfe) << 10);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 111 to 131
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)input[15] << 15) |
			((uint32_t)(input[16] & 0xf0) << 7);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 132 to 152
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)input[18] << 12) |
			((uint32_t)(input[19] & 0x80) << 4);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 153 to 173
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xfc) << 9);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 174 to 194
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xe0) << 6);
	output[8] = (double)(value >> 11);
}

static void unpack_9_21bit_unsigned_6off(const uint8_t * input, double * output) {
	// Unpack 9 values into output
	// Values are 21-bit unsigned
	// Skip 6 bits, read 189 bits of data.
	// Input must be at least 25 bytes long

	uint32_t value;

	// read output[0]: from bit 6 to 26
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xe0) << 6);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 27 to 47
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 48 to 68
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)(input[8] & 0xf8) << 8);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 69 to 89
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)input[10] << 13) |
			((uint32_t)(input[11] & 0xc0) << 5);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 90 to 110
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xfe) << 10);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 111 to 131
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)input[15] << 15) |
			((uint32_t)(input[16] & 0xf0) << 7);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 132 to 152
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)input[18] << 12) |
			((uint32_t)(input[19] & 0x80) << 4);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 153 to 173
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xfc) << 9);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 174 to 194
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xe0) << 6);
	output[8] = (double)(value >> 11);
}

static void unpack_9_21bit_signed_7off(const uint8_t * input, double * output) {
	// Unpack 9 values into output
	// Values are 21-bit signed
	// Skip 7 bits, read 189 bits of data.
	// Input must be at least 25 bytes long

	int32_t value;

	// read output[0]: from bit 7 to 27
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xf0) << 7);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 28 to 48
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0x80) << 4);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 49 to 69
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0xfc) << 9);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 70 to 90
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)input[10] << 14) |
			((uint32_t)(input[11] & 0xe0) << 6);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 91 to 111
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)input[13] << 11);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 112 to 132
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16) |
			((uint32_t)(input[16] & 0xf8) << 8);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 133 to 153
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)input[18] << 13) |
			((uint32_t)(input[19] & 0xc0) << 5);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 154 to 174
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xfe) << 10);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 175 to 195
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xf0) << 7);
	output[8] = (double)(value >> 11);
}

static void unpack_9_21bit_unsigned_7off(const uint8_t * input, double * output) {
	// Unpack 9 values into output
	// Values are 21-bit unsigned
	// Skip 7 bits, read 189 bits of data.
	// Input must be at least 25 bytes long

	uint32_t value;

	// read output[0]: from bit 7 to 27
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xf0) << 7);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 28 to 48
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0x80) << 4);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 49 to 69
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0xfc) << 9);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 70 to 90
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)input[10] << 14) |
			((uint32_t)(input[11] & 0xe0) << 6);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 91 to 111
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)input[13] << 11);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 112 to 132
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16) |
			((uint32_t)(input[16] & 0xf8) << 8);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 133 to 153
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)input[18] << 13) |
			((uint32_t)(input[19] & 0xc0) << 5);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 154 to 174
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xfe) << 10);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 175 to 195
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xf0) << 7);
	output[8] = (double)(value >> 11);
}

static void unpack_10_21bit_signed_0off(const uint8_t * input, double * output) {
	// Unpack 10 values into output
	// Values are 21-bit signed
	// Skip 0 bits, read 210 bits of data.
	// Input must be at least 27 bytes long

	int32_t value;

	// read output[0]: from bit 0 to 20
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0xf8) << 8);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 21 to 41
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)input[4] << 13) |
			((uint32_t)(input[5] & 0xc0) << 5);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 42 to 62
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)input[6] << 18) |
			((uint32_t)(input[7] & 0xfe) << 10);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 63 to 83
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)input[9] << 15) |
			((uint32_t)(input[10] & 0xf0) << 7);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 84 to 104
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)input[12] << 12) |
			((uint32_t)(input[13] & 0x80) << 4);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 105 to 125
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xfc) << 9);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 126 to 146
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xe0) << 6);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 147 to 167
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 168 to 188
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)(input[23] & 0xf8) << 8);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 189 to 209
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)input[25] << 13) |
			((uint32_t)(input[26] & 0xc0) << 5);
	output[9] = (double)(value >> 11);
}

static void unpack_10_21bit_unsigned_0off(const uint8_t * input, double * output) {
	// Unpack 10 values into output
	// Values are 21-bit unsigned
	// Skip 0 bits, read 210 bits of data.
	// Input must be at least 27 bytes long

	uint32_t value;

	// read output[0]: from bit 0 to 20
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0xf8) << 8);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 21 to 41
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)input[4] << 13) |
			((uint32_t)(input[5] & 0xc0) << 5);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 42 to 62
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)input[6] << 18) |
			((uint32_t)(input[7] & 0xfe) << 10);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 63 to 83
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)input[9] << 15) |
			((uint32_t)(input[10] & 0xf0) << 7);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 84 to 104
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)input[12] << 12) |
			((uint32_t)(input[13] & 0x80) << 4);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 105 to 125
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xfc) << 9);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 126 to 146
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xe0) << 6);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 147 to 167
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 168 to 188
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)(input[23] & 0xf8) << 8);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 189 to 209
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)input[25] << 13) |
			((uint32_t)(input[26] & 0xc0) << 5);
	output[9] = (double)(value >> 11);
}

static void unpack_10_21bit_signed_1off(const uint8_t * input, double * output) {
	// Unpack 10 values into output
	// Values are 21-bit signed
	// Skip 1 bits, read 210 bits of data.
	// Input must be at least 27 bytes long

	int32_t value;

	// read output[0]: from bit 1 to 21
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xfc) << 9);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 22 to 42
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)input[4] << 14) |
			((uint32_t)(input[5] & 0xe0) << 6);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 43 to 63
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)input[6] << 19) |
			((uint32_t)input[7] << 11);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 64 to 84
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16) |
			((uint32_t)(input[10] & 0xf8) << 8);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 85 to 105
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)input[12] << 13) |
			((uint32_t)(input[13] & 0xc0) << 5);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 106 to 126
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xfe) << 10);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 127 to 147
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xf0) << 7);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 148 to 168
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0x80) << 4);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 169 to 189
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)(input[23] & 0xfc) << 9);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 190 to 210
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)input[25] << 14) |
			((uint32_t)(input[26] & 0xe0) << 6);
	output[9] = (double)(value >> 11);
}

static void unpack_10_21bit_unsigned_1off(const uint8_t * input, double * output) {
	// Unpack 10 values into output
	// Values are 21-bit unsigned
	// Skip 1 bits, read 210 bits of data.
	// Input must be at least 27 bytes long

	uint32_t value;

	// read output[0]: from bit 1 to 21
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xfc) << 9);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 22 to 42
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)input[4] << 14) |
			((uint32_t)(input[5] & 0xe0) << 6);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 43 to 63
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)input[6] << 19) |
			((uint32_t)input[7] << 11);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 64 to 84
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16) |
			((uint32_t)(input[10] & 0xf8) << 8);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 85 to 105
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)input[12] << 13) |
			((uint32_t)(input[13] & 0xc0) << 5);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 106 to 126
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xfe) << 10);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 127 to 147
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xf0) << 7);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 148 to 168
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0x80) << 4);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 169 to 189
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)(input[23] & 0xfc) << 9);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 190 to 210
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)input[25] << 14) |
			((uint32_t)(input[26] & 0xe0) << 6);
	output[9] = (double)(value >> 11);
}

static void unpack_10_21bit_signed_2off(const uint8_t * input, double * output) {
	// Unpack 10 values into output
	// Values are 21-bit signed
	// Skip 2 bits, read 210 bits of data.
	// Input must be at least 27 bytes long

	int32_t value;

	// read output[0]: from bit 2 to 22
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xfe) << 10);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 23 to 43
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15) |
			((uint32_t)(input[5] & 0xf0) << 7);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 44 to 64
	value = ((uint32_t)(input[5] & 0x0f) << 28) |
			((uint32_t)input[6] << 20) |
			((uint32_t)input[7] << 12) |
			((uint32_t)(input[8] & 0x80) << 4);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 65 to 85
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0xfc) << 9);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 86 to 106
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)input[12] << 14) |
			((uint32_t)(input[13] & 0xe0) << 6);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 107 to 127
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)input[15] << 11);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 128 to 148
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16) |
			((uint32_t)(input[18] & 0xf8) << 8);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 149 to 169
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xc0) << 5);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 170 to 190
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xfe) << 10);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 191 to 211
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15) |
			((uint32_t)(input[26] & 0xf0) << 7);
	output[9] = (double)(value >> 11);
}

static void unpack_10_21bit_unsigned_2off(const uint8_t * input, double * output) {
	// Unpack 10 values into output
	// Values are 21-bit unsigned
	// Skip 2 bits, read 210 bits of data.
	// Input must be at least 27 bytes long

	uint32_t value;

	// read output[0]: from bit 2 to 22
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xfe) << 10);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 23 to 43
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15) |
			((uint32_t)(input[5] & 0xf0) << 7);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 44 to 64
	value = ((uint32_t)(input[5] & 0x0f) << 28) |
			((uint32_t)input[6] << 20) |
			((uint32_t)input[7] << 12) |
			((uint32_t)(input[8] & 0x80) << 4);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 65 to 85
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0xfc) << 9);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 86 to 106
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)input[12] << 14) |
			((uint32_t)(input[13] & 0xe0) << 6);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 107 to 127
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)input[15] << 11);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 128 to 148
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16) |
			((uint32_t)(input[18] & 0xf8) << 8);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 149 to 169
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xc0) << 5);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 170 to 190
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xfe) << 10);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 191 to 211
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15) |
			((uint32_t)(input[26] & 0xf0) << 7);
	output[9] = (double)(value >> 11);
}

static void unpack_10_21bit_signed_3off(const uint8_t * input, double * output) {
	// Unpack 10 values into output
	// Values are 21-bit signed
	// Skip 3 bits, read 210 bits of data.
	// Input must be at least 27 bytes long

	int32_t value;

	// read output[0]: from bit 3 to 23
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 24 to 44
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0xf8) << 8);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 45 to 65
	value = ((uint32_t)(input[5] & 0x07) << 29) |
			((uint32_t)input[6] << 21) |
			((uint32_t)input[7] << 13) |
			((uint32_t)(input[8] & 0xc0) << 5);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 66 to 86
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xfe) << 10);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 87 to 107
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15) |
			((uint32_t)(input[13] & 0xf0) << 7);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 108 to 128
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)input[15] << 12) |
			((uint32_t)(input[16] & 0x80) << 4);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 129 to 149
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0xfc) << 9);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 150 to 170
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xe0) << 6);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 171 to 191
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 192 to 212
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0xf8) << 8);
	output[9] = (double)(value >> 11);
}

static void unpack_10_21bit_unsigned_3off(const uint8_t * input, double * output) {
	// Unpack 10 values into output
	// Values are 21-bit unsigned
	// Skip 3 bits, read 210 bits of data.
	// Input must be at least 27 bytes long

	uint32_t value;

	// read output[0]: from bit 3 to 23
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 24 to 44
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0xf8) << 8);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 45 to 65
	value = ((uint32_t)(input[5] & 0x07) << 29) |
			((uint32_t)input[6] << 21) |
			((uint32_t)input[7] << 13) |
			((uint32_t)(input[8] & 0xc0) << 5);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 66 to 86
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xfe) << 10);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 87 to 107
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15) |
			((uint32_t)(input[13] & 0xf0) << 7);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 108 to 128
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)input[15] << 12) |
			((uint32_t)(input[16] & 0x80) << 4);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 129 to 149
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0xfc) << 9);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 150 to 170
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xe0) << 6);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 171 to 191
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 192 to 212
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0xf8) << 8);
	output[9] = (double)(value >> 11);
}

static void unpack_10_21bit_signed_4off(const uint8_t * input, double * output) {
	// Unpack 10 values into output
	// Values are 21-bit signed
	// Skip 4 bits, read 210 bits of data.
	// Input must be at least 27 bytes long

	int32_t value;

	// read output[0]: from bit 4 to 24
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0x80) << 4);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 25 to 45
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)(input[5] & 0xfc) << 9);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 46 to 66
	value = ((uint32_t)(input[5] & 0x03) << 30) |
			((uint32_t)input[6] << 22) |
			((uint32_t)input[7] << 14) |
			((uint32_t)(input[8] & 0xe0) << 6);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 67 to 87
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)input[10] << 11);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 88 to 108
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0xf8) << 8);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 109 to 129
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)input[15] << 13) |
			((uint32_t)(input[16] & 0xc0) << 5);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 130 to 150
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xfe) << 10);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 151 to 171
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xf0) << 7);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 172 to 192
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0x80) << 4);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 193 to 213
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xfc) << 9);
	output[9] = (double)(value >> 11);
}

static void unpack_10_21bit_unsigned_4off(const uint8_t * input, double * output) {
	// Unpack 10 values into output
	// Values are 21-bit unsigned
	// Skip 4 bits, read 210 bits of data.
	// Input must be at least 27 bytes long

	uint32_t value;

	// read output[0]: from bit 4 to 24
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0x80) << 4);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 25 to 45
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)(input[5] & 0xfc) << 9);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 46 to 66
	value = ((uint32_t)(input[5] & 0x03) << 30) |
			((uint32_t)input[6] << 22) |
			((uint32_t)input[7] << 14) |
			((uint32_t)(input[8] & 0xe0) << 6);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 67 to 87
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)input[10] << 11);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 88 to 108
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0xf8) << 8);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 109 to 129
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)input[15] << 13) |
			((uint32_t)(input[16] & 0xc0) << 5);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 130 to 150
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xfe) << 10);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 151 to 171
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xf0) << 7);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 172 to 192
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0x80) << 4);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 193 to 213
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xfc) << 9);
	output[9] = (double)(value >> 11);
}

static void unpack_10_21bit_signed_5off(const uint8_t * input, double * output) {
	// Unpack 10 values into output
	// Values are 21-bit signed
	// Skip 5 bits, read 210 bits of data.
	// Input must be at least 27 bytes long

	int32_t value;

	// read output[0]: from bit 5 to 25
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xc0) << 5);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 26 to 46
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)(input[5] & 0xfe) << 10);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 47 to 67
	value = ((uint32_t)(input[5] & 0x01) << 31) |
			((uint32_t)input[6] << 23) |
			((uint32_t)input[7] << 15) |
			((uint32_t)(input[8] & 0xf0) << 7);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 68 to 88
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)input[10] << 12) |
			((uint32_t)(input[11] & 0x80) << 4);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 89 to 109
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xfc) << 9);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 110 to 130
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)input[15] << 14) |
			((uint32_t)(input[16] & 0xe0) << 6);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 131 to 151
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)input[18] << 11);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 152 to 172
	value = ((uint32_t)input[19] << 24) |
			((uint32_t)input[20] << 16) |
			((uint32_t)(input[21] & 0xf8) << 8);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 173 to 193
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xc0) << 5);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 194 to 214
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xfe) << 10);
	output[9] = (double)(value >> 11);
}

static void unpack_10_21bit_unsigned_5off(const uint8_t * input, double * output) {
	// Unpack 10 values into output
	// Values are 21-bit unsigned
	// Skip 5 bits, read 210 bits of data.
	// Input must be at least 27 bytes long

	uint32_t value;

	// read output[0]: from bit 5 to 25
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xc0) << 5);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 26 to 46
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)(input[5] & 0xfe) << 10);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 47 to 67
	value = ((uint32_t)(input[5] & 0x01) << 31) |
			((uint32_t)input[6] << 23) |
			((uint32_t)input[7] << 15) |
			((uint32_t)(input[8] & 0xf0) << 7);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 68 to 88
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)input[10] << 12) |
			((uint32_t)(input[11] & 0x80) << 4);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 89 to 109
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xfc) << 9);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 110 to 130
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)input[15] << 14) |
			((uint32_t)(input[16] & 0xe0) << 6);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 131 to 151
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)input[18] << 11);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 152 to 172
	value = ((uint32_t)input[19] << 24) |
			((uint32_t)input[20] << 16) |
			((uint32_t)(input[21] & 0xf8) << 8);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 173 to 193
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xc0) << 5);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 194 to 214
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xfe) << 10);
	output[9] = (double)(value >> 11);
}

static void unpack_10_21bit_signed_6off(const uint8_t * input, double * output) {
	// Unpack 10 values into output
	// Values are 21-bit signed
	// Skip 6 bits, read 210 bits of data.
	// Input must be at least 27 bytes long

	int32_t value;

	// read output[0]: from bit 6 to 26
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xe0) << 6);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 27 to 47
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 48 to 68
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)(input[8] & 0xf8) << 8);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 69 to 89
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)input[10] << 13) |
			((uint32_t)(input[11] & 0xc0) << 5);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 90 to 110
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xfe) << 10);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 111 to 131
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)input[15] << 15) |
			((uint32_t)(input[16] & 0xf0) << 7);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 132 to 152
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)input[18] << 12) |
			((uint32_t)(input[19] & 0x80) << 4);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 153 to 173
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xfc) << 9);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 174 to 194
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xe0) << 6);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 195 to 215
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11);
	output[9] = (double)(value >> 11);
}

static void unpack_10_21bit_unsigned_6off(const uint8_t * input, double * output) {
	// Unpack 10 values into output
	// Values are 21-bit unsigned
	// Skip 6 bits, read 210 bits of data.
	// Input must be at least 27 bytes long

	uint32_t value;

	// read output[0]: from bit 6 to 26
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xe0) << 6);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 27 to 47
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 48 to 68
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)(input[8] & 0xf8) << 8);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 69 to 89
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)input[10] << 13) |
			((uint32_t)(input[11] & 0xc0) << 5);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 90 to 110
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xfe) << 10);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 111 to 131
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)input[15] << 15) |
			((uint32_t)(input[16] & 0xf0) << 7);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 132 to 152
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)input[18] << 12) |
			((uint32_t)(input[19] & 0x80) << 4);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 153 to 173
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xfc) << 9);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 174 to 194
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xe0) << 6);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 195 to 215
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11);
	output[9] = (double)(value >> 11);
}

static void unpack_10_21bit_signed_7off(const uint8_t * input, double * output) {
	// Unpack 10 values into output
	// Values are 21-bit signed
	// Skip 7 bits, read 210 bits of data.
	// Input must be at least 28 bytes long

	int32_t value;

	// read output[0]: from bit 7 to 27
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xf0) << 7);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 28 to 48
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0x80) << 4);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 49 to 69
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0xfc) << 9);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 70 to 90
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)input[10] << 14) |
			((uint32_t)(input[11] & 0xe0) << 6);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 91 to 111
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)input[13] << 11);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 112 to 132
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16) |
			((uint32_t)(input[16] & 0xf8) << 8);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 133 to 153
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)input[18] << 13) |
			((uint32_t)(input[19] & 0xc0) << 5);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 154 to 174
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xfe) << 10);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 175 to 195
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xf0) << 7);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 196 to 216
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0x80) << 4);
	output[9] = (double)(value >> 11);
}

static void unpack_10_21bit_unsigned_7off(const uint8_t * input, double * output) {
	// Unpack 10 values into output
	// Values are 21-bit unsigned
	// Skip 7 bits, read 210 bits of data.
	// Input must be at least 28 bytes long

	uint32_t value;

	// read output[0]: from bit 7 to 27
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xf0) << 7);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 28 to 48
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0x80) << 4);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 49 to 69
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0xfc) << 9);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 70 to 90
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)input[10] << 14) |
			((uint32_t)(input[11] & 0xe0) << 6);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 91 to 111
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)input[13] << 11);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 112 to 132
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16) |
			((uint32_t)(input[16] & 0xf8) << 8);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 133 to 153
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)input[18] << 13) |
			((uint32_t)(input[19] & 0xc0) << 5);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 154 to 174
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xfe) << 10);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 175 to 195
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xf0) << 7);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 196 to 216
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0x80) << 4);
	output[9] = (double)(value >> 11);
}

static void unpack_11_21bit_signed_0off(const uint8_t * input, double * output) {
	// Unpack 11 values into output
	// Values are 21-bit signed
	// Skip 0 bits, read 231 bits of data.
	// Input must be at least 29 bytes long

	int32_t value;

	// read output[0]: from bit 0 to 20
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0xf8) << 8);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 21 to 41
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)input[4] << 13) |
			((uint32_t)(input[5] & 0xc0) << 5);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 42 to 62
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)input[6] << 18) |
			((uint32_t)(input[7] & 0xfe) << 10);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 63 to 83
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)input[9] << 15) |
			((uint32_t)(input[10] & 0xf0) << 7);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 84 to 104
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)input[12] << 12) |
			((uint32_t)(input[13] & 0x80) << 4);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 105 to 125
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xfc) << 9);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 126 to 146
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xe0) << 6);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 147 to 167
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 168 to 188
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)(input[23] & 0xf8) << 8);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 189 to 209
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)input[25] << 13) |
			((uint32_t)(input[26] & 0xc0) << 5);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 210 to 230
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xfe) << 10);
	output[10] = (double)(value >> 11);
}

static void unpack_11_21bit_unsigned_0off(const uint8_t * input, double * output) {
	// Unpack 11 values into output
	// Values are 21-bit unsigned
	// Skip 0 bits, read 231 bits of data.
	// Input must be at least 29 bytes long

	uint32_t value;

	// read output[0]: from bit 0 to 20
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0xf8) << 8);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 21 to 41
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)input[4] << 13) |
			((uint32_t)(input[5] & 0xc0) << 5);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 42 to 62
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)input[6] << 18) |
			((uint32_t)(input[7] & 0xfe) << 10);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 63 to 83
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)input[9] << 15) |
			((uint32_t)(input[10] & 0xf0) << 7);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 84 to 104
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)input[12] << 12) |
			((uint32_t)(input[13] & 0x80) << 4);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 105 to 125
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xfc) << 9);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 126 to 146
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xe0) << 6);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 147 to 167
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 168 to 188
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)(input[23] & 0xf8) << 8);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 189 to 209
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)input[25] << 13) |
			((uint32_t)(input[26] & 0xc0) << 5);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 210 to 230
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xfe) << 10);
	output[10] = (double)(value >> 11);
}

static void unpack_11_21bit_signed_1off(const uint8_t * input, double * output) {
	// Unpack 11 values into output
	// Values are 21-bit signed
	// Skip 1 bits, read 231 bits of data.
	// Input must be at least 29 bytes long

	int32_t value;

	// read output[0]: from bit 1 to 21
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xfc) << 9);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 22 to 42
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)input[4] << 14) |
			((uint32_t)(input[5] & 0xe0) << 6);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 43 to 63
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)input[6] << 19) |
			((uint32_t)input[7] << 11);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 64 to 84
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16) |
			((uint32_t)(input[10] & 0xf8) << 8);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 85 to 105
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)input[12] << 13) |
			((uint32_t)(input[13] & 0xc0) << 5);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 106 to 126
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xfe) << 10);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 127 to 147
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xf0) << 7);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 148 to 168
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0x80) << 4);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 169 to 189
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)(input[23] & 0xfc) << 9);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 190 to 210
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)input[25] << 14) |
			((uint32_t)(input[26] & 0xe0) << 6);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 211 to 231
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)input[28] << 11);
	output[10] = (double)(value >> 11);
}

static void unpack_11_21bit_unsigned_1off(const uint8_t * input, double * output) {
	// Unpack 11 values into output
	// Values are 21-bit unsigned
	// Skip 1 bits, read 231 bits of data.
	// Input must be at least 29 bytes long

	uint32_t value;

	// read output[0]: from bit 1 to 21
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xfc) << 9);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 22 to 42
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)input[4] << 14) |
			((uint32_t)(input[5] & 0xe0) << 6);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 43 to 63
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)input[6] << 19) |
			((uint32_t)input[7] << 11);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 64 to 84
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16) |
			((uint32_t)(input[10] & 0xf8) << 8);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 85 to 105
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)input[12] << 13) |
			((uint32_t)(input[13] & 0xc0) << 5);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 106 to 126
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xfe) << 10);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 127 to 147
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xf0) << 7);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 148 to 168
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0x80) << 4);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 169 to 189
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)(input[23] & 0xfc) << 9);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 190 to 210
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)input[25] << 14) |
			((uint32_t)(input[26] & 0xe0) << 6);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 211 to 231
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)input[28] << 11);
	output[10] = (double)(value >> 11);
}

static void unpack_11_21bit_signed_2off(const uint8_t * input, double * output) {
	// Unpack 11 values into output
	// Values are 21-bit signed
	// Skip 2 bits, read 231 bits of data.
	// Input must be at least 30 bytes long

	int32_t value;

	// read output[0]: from bit 2 to 22
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xfe) << 10);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 23 to 43
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15) |
			((uint32_t)(input[5] & 0xf0) << 7);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 44 to 64
	value = ((uint32_t)(input[5] & 0x0f) << 28) |
			((uint32_t)input[6] << 20) |
			((uint32_t)input[7] << 12) |
			((uint32_t)(input[8] & 0x80) << 4);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 65 to 85
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0xfc) << 9);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 86 to 106
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)input[12] << 14) |
			((uint32_t)(input[13] & 0xe0) << 6);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 107 to 127
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)input[15] << 11);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 128 to 148
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16) |
			((uint32_t)(input[18] & 0xf8) << 8);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 149 to 169
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xc0) << 5);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 170 to 190
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xfe) << 10);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 191 to 211
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15) |
			((uint32_t)(input[26] & 0xf0) << 7);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 212 to 232
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)input[28] << 12) |
			((uint32_t)(input[29] & 0x80) << 4);
	output[10] = (double)(value >> 11);
}

static void unpack_11_21bit_unsigned_2off(const uint8_t * input, double * output) {
	// Unpack 11 values into output
	// Values are 21-bit unsigned
	// Skip 2 bits, read 231 bits of data.
	// Input must be at least 30 bytes long

	uint32_t value;

	// read output[0]: from bit 2 to 22
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xfe) << 10);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 23 to 43
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15) |
			((uint32_t)(input[5] & 0xf0) << 7);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 44 to 64
	value = ((uint32_t)(input[5] & 0x0f) << 28) |
			((uint32_t)input[6] << 20) |
			((uint32_t)input[7] << 12) |
			((uint32_t)(input[8] & 0x80) << 4);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 65 to 85
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0xfc) << 9);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 86 to 106
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)input[12] << 14) |
			((uint32_t)(input[13] & 0xe0) << 6);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 107 to 127
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)input[15] << 11);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 128 to 148
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16) |
			((uint32_t)(input[18] & 0xf8) << 8);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 149 to 169
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xc0) << 5);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 170 to 190
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xfe) << 10);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 191 to 211
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15) |
			((uint32_t)(input[26] & 0xf0) << 7);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 212 to 232
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)input[28] << 12) |
			((uint32_t)(input[29] & 0x80) << 4);
	output[10] = (double)(value >> 11);
}

static void unpack_11_21bit_signed_3off(const uint8_t * input, double * output) {
	// Unpack 11 values into output
	// Values are 21-bit signed
	// Skip 3 bits, read 231 bits of data.
	// Input must be at least 30 bytes long

	int32_t value;

	// read output[0]: from bit 3 to 23
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 24 to 44
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0xf8) << 8);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 45 to 65
	value = ((uint32_t)(input[5] & 0x07) << 29) |
			((uint32_t)input[6] << 21) |
			((uint32_t)input[7] << 13) |
			((uint32_t)(input[8] & 0xc0) << 5);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 66 to 86
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xfe) << 10);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 87 to 107
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15) |
			((uint32_t)(input[13] & 0xf0) << 7);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 108 to 128
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)input[15] << 12) |
			((uint32_t)(input[16] & 0x80) << 4);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 129 to 149
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0xfc) << 9);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 150 to 170
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xe0) << 6);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 171 to 191
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 192 to 212
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0xf8) << 8);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 213 to 233
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)input[28] << 13) |
			((uint32_t)(input[29] & 0xc0) << 5);
	output[10] = (double)(value >> 11);
}

static void unpack_11_21bit_unsigned_3off(const uint8_t * input, double * output) {
	// Unpack 11 values into output
	// Values are 21-bit unsigned
	// Skip 3 bits, read 231 bits of data.
	// Input must be at least 30 bytes long

	uint32_t value;

	// read output[0]: from bit 3 to 23
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 24 to 44
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0xf8) << 8);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 45 to 65
	value = ((uint32_t)(input[5] & 0x07) << 29) |
			((uint32_t)input[6] << 21) |
			((uint32_t)input[7] << 13) |
			((uint32_t)(input[8] & 0xc0) << 5);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 66 to 86
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xfe) << 10);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 87 to 107
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15) |
			((uint32_t)(input[13] & 0xf0) << 7);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 108 to 128
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)input[15] << 12) |
			((uint32_t)(input[16] & 0x80) << 4);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 129 to 149
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0xfc) << 9);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 150 to 170
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xe0) << 6);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 171 to 191
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 192 to 212
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0xf8) << 8);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 213 to 233
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)input[28] << 13) |
			((uint32_t)(input[29] & 0xc0) << 5);
	output[10] = (double)(value >> 11);
}

static void unpack_11_21bit_signed_4off(const uint8_t * input, double * output) {
	// Unpack 11 values into output
	// Values are 21-bit signed
	// Skip 4 bits, read 231 bits of data.
	// Input must be at least 30 bytes long

	int32_t value;

	// read output[0]: from bit 4 to 24
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0x80) << 4);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 25 to 45
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)(input[5] & 0xfc) << 9);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 46 to 66
	value = ((uint32_t)(input[5] & 0x03) << 30) |
			((uint32_t)input[6] << 22) |
			((uint32_t)input[7] << 14) |
			((uint32_t)(input[8] & 0xe0) << 6);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 67 to 87
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)input[10] << 11);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 88 to 108
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0xf8) << 8);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 109 to 129
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)input[15] << 13) |
			((uint32_t)(input[16] & 0xc0) << 5);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 130 to 150
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xfe) << 10);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 151 to 171
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xf0) << 7);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 172 to 192
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0x80) << 4);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 193 to 213
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xfc) << 9);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 214 to 234
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)input[28] << 14) |
			((uint32_t)(input[29] & 0xe0) << 6);
	output[10] = (double)(value >> 11);
}

static void unpack_11_21bit_unsigned_4off(const uint8_t * input, double * output) {
	// Unpack 11 values into output
	// Values are 21-bit unsigned
	// Skip 4 bits, read 231 bits of data.
	// Input must be at least 30 bytes long

	uint32_t value;

	// read output[0]: from bit 4 to 24
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0x80) << 4);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 25 to 45
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)(input[5] & 0xfc) << 9);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 46 to 66
	value = ((uint32_t)(input[5] & 0x03) << 30) |
			((uint32_t)input[6] << 22) |
			((uint32_t)input[7] << 14) |
			((uint32_t)(input[8] & 0xe0) << 6);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 67 to 87
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)input[10] << 11);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 88 to 108
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0xf8) << 8);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 109 to 129
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)input[15] << 13) |
			((uint32_t)(input[16] & 0xc0) << 5);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 130 to 150
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xfe) << 10);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 151 to 171
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xf0) << 7);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 172 to 192
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0x80) << 4);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 193 to 213
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xfc) << 9);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 214 to 234
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)input[28] << 14) |
			((uint32_t)(input[29] & 0xe0) << 6);
	output[10] = (double)(value >> 11);
}

static void unpack_11_21bit_signed_5off(const uint8_t * input, double * output) {
	// Unpack 11 values into output
	// Values are 21-bit signed
	// Skip 5 bits, read 231 bits of data.
	// Input must be at least 30 bytes long

	int32_t value;

	// read output[0]: from bit 5 to 25
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xc0) << 5);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 26 to 46
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)(input[5] & 0xfe) << 10);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 47 to 67
	value = ((uint32_t)(input[5] & 0x01) << 31) |
			((uint32_t)input[6] << 23) |
			((uint32_t)input[7] << 15) |
			((uint32_t)(input[8] & 0xf0) << 7);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 68 to 88
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)input[10] << 12) |
			((uint32_t)(input[11] & 0x80) << 4);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 89 to 109
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xfc) << 9);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 110 to 130
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)input[15] << 14) |
			((uint32_t)(input[16] & 0xe0) << 6);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 131 to 151
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)input[18] << 11);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 152 to 172
	value = ((uint32_t)input[19] << 24) |
			((uint32_t)input[20] << 16) |
			((uint32_t)(input[21] & 0xf8) << 8);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 173 to 193
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xc0) << 5);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 194 to 214
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xfe) << 10);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 215 to 235
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)input[28] << 15) |
			((uint32_t)(input[29] & 0xf0) << 7);
	output[10] = (double)(value >> 11);
}

static void unpack_11_21bit_unsigned_5off(const uint8_t * input, double * output) {
	// Unpack 11 values into output
	// Values are 21-bit unsigned
	// Skip 5 bits, read 231 bits of data.
	// Input must be at least 30 bytes long

	uint32_t value;

	// read output[0]: from bit 5 to 25
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xc0) << 5);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 26 to 46
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)(input[5] & 0xfe) << 10);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 47 to 67
	value = ((uint32_t)(input[5] & 0x01) << 31) |
			((uint32_t)input[6] << 23) |
			((uint32_t)input[7] << 15) |
			((uint32_t)(input[8] & 0xf0) << 7);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 68 to 88
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)input[10] << 12) |
			((uint32_t)(input[11] & 0x80) << 4);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 89 to 109
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xfc) << 9);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 110 to 130
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)input[15] << 14) |
			((uint32_t)(input[16] & 0xe0) << 6);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 131 to 151
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)input[18] << 11);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 152 to 172
	value = ((uint32_t)input[19] << 24) |
			((uint32_t)input[20] << 16) |
			((uint32_t)(input[21] & 0xf8) << 8);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 173 to 193
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xc0) << 5);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 194 to 214
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xfe) << 10);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 215 to 235
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)input[28] << 15) |
			((uint32_t)(input[29] & 0xf0) << 7);
	output[10] = (double)(value >> 11);
}

static void unpack_11_21bit_signed_6off(const uint8_t * input, double * output) {
	// Unpack 11 values into output
	// Values are 21-bit signed
	// Skip 6 bits, read 231 bits of data.
	// Input must be at least 30 bytes long

	int32_t value;

	// read output[0]: from bit 6 to 26
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xe0) << 6);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 27 to 47
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 48 to 68
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)(input[8] & 0xf8) << 8);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 69 to 89
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)input[10] << 13) |
			((uint32_t)(input[11] & 0xc0) << 5);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 90 to 110
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xfe) << 10);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 111 to 131
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)input[15] << 15) |
			((uint32_t)(input[16] & 0xf0) << 7);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 132 to 152
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)input[18] << 12) |
			((uint32_t)(input[19] & 0x80) << 4);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 153 to 173
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xfc) << 9);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 174 to 194
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xe0) << 6);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 195 to 215
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 216 to 236
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)(input[29] & 0xf8) << 8);
	output[10] = (double)(value >> 11);
}

static void unpack_11_21bit_unsigned_6off(const uint8_t * input, double * output) {
	// Unpack 11 values into output
	// Values are 21-bit unsigned
	// Skip 6 bits, read 231 bits of data.
	// Input must be at least 30 bytes long

	uint32_t value;

	// read output[0]: from bit 6 to 26
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xe0) << 6);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 27 to 47
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 48 to 68
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)(input[8] & 0xf8) << 8);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 69 to 89
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)input[10] << 13) |
			((uint32_t)(input[11] & 0xc0) << 5);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 90 to 110
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xfe) << 10);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 111 to 131
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)input[15] << 15) |
			((uint32_t)(input[16] & 0xf0) << 7);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 132 to 152
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)input[18] << 12) |
			((uint32_t)(input[19] & 0x80) << 4);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 153 to 173
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xfc) << 9);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 174 to 194
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xe0) << 6);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 195 to 215
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 216 to 236
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)(input[29] & 0xf8) << 8);
	output[10] = (double)(value >> 11);
}

static void unpack_11_21bit_signed_7off(const uint8_t * input, double * output) {
	// Unpack 11 values into output
	// Values are 21-bit signed
	// Skip 7 bits, read 231 bits of data.
	// Input must be at least 30 bytes long

	int32_t value;

	// read output[0]: from bit 7 to 27
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xf0) << 7);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 28 to 48
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0x80) << 4);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 49 to 69
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0xfc) << 9);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 70 to 90
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)input[10] << 14) |
			((uint32_t)(input[11] & 0xe0) << 6);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 91 to 111
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)input[13] << 11);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 112 to 132
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16) |
			((uint32_t)(input[16] & 0xf8) << 8);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 133 to 153
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)input[18] << 13) |
			((uint32_t)(input[19] & 0xc0) << 5);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 154 to 174
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xfe) << 10);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 175 to 195
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xf0) << 7);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 196 to 216
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0x80) << 4);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 217 to 237
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)(input[29] & 0xfc) << 9);
	output[10] = (double)(value >> 11);
}

static void unpack_11_21bit_unsigned_7off(const uint8_t * input, double * output) {
	// Unpack 11 values into output
	// Values are 21-bit unsigned
	// Skip 7 bits, read 231 bits of data.
	// Input must be at least 30 bytes long

	uint32_t value;

	// read output[0]: from bit 7 to 27
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xf0) << 7);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 28 to 48
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0x80) << 4);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 49 to 69
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0xfc) << 9);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 70 to 90
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)input[10] << 14) |
			((uint32_t)(input[11] & 0xe0) << 6);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 91 to 111
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)input[13] << 11);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 112 to 132
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16) |
			((uint32_t)(input[16] & 0xf8) << 8);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 133 to 153
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)input[18] << 13) |
			((uint32_t)(input[19] & 0xc0) << 5);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 154 to 174
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xfe) << 10);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 175 to 195
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xf0) << 7);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 196 to 216
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0x80) << 4);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 217 to 237
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)(input[29] & 0xfc) << 9);
	output[10] = (double)(value >> 11);
}

static void unpack_12_21bit_signed_0off(const uint8_t * input, double * output) {
	// Unpack 12 values into output
	// Values are 21-bit signed
	// Skip 0 bits, read 252 bits of data.
	// Input must be at least 32 bytes long

	int32_t value;

	// read output[0]: from bit 0 to 20
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0xf8) << 8);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 21 to 41
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)input[4] << 13) |
			((uint32_t)(input[5] & 0xc0) << 5);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 42 to 62
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)input[6] << 18) |
			((uint32_t)(input[7] & 0xfe) << 10);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 63 to 83
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)input[9] << 15) |
			((uint32_t)(input[10] & 0xf0) << 7);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 84 to 104
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)input[12] << 12) |
			((uint32_t)(input[13] & 0x80) << 4);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 105 to 125
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xfc) << 9);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 126 to 146
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xe0) << 6);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 147 to 167
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 168 to 188
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)(input[23] & 0xf8) << 8);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 189 to 209
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)input[25] << 13) |
			((uint32_t)(input[26] & 0xc0) << 5);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 210 to 230
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xfe) << 10);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 231 to 251
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)input[30] << 15) |
			((uint32_t)(input[31] & 0xf0) << 7);
	output[11] = (double)(value >> 11);
}

static void unpack_12_21bit_unsigned_0off(const uint8_t * input, double * output) {
	// Unpack 12 values into output
	// Values are 21-bit unsigned
	// Skip 0 bits, read 252 bits of data.
	// Input must be at least 32 bytes long

	uint32_t value;

	// read output[0]: from bit 0 to 20
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0xf8) << 8);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 21 to 41
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)input[4] << 13) |
			((uint32_t)(input[5] & 0xc0) << 5);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 42 to 62
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)input[6] << 18) |
			((uint32_t)(input[7] & 0xfe) << 10);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 63 to 83
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)input[9] << 15) |
			((uint32_t)(input[10] & 0xf0) << 7);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 84 to 104
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)input[12] << 12) |
			((uint32_t)(input[13] & 0x80) << 4);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 105 to 125
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xfc) << 9);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 126 to 146
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xe0) << 6);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 147 to 167
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 168 to 188
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)(input[23] & 0xf8) << 8);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 189 to 209
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)input[25] << 13) |
			((uint32_t)(input[26] & 0xc0) << 5);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 210 to 230
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xfe) << 10);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 231 to 251
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)input[30] << 15) |
			((uint32_t)(input[31] & 0xf0) << 7);
	output[11] = (double)(value >> 11);
}

static void unpack_12_21bit_signed_1off(const uint8_t * input, double * output) {
	// Unpack 12 values into output
	// Values are 21-bit signed
	// Skip 1 bits, read 252 bits of data.
	// Input must be at least 32 bytes long

	int32_t value;

	// read output[0]: from bit 1 to 21
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xfc) << 9);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 22 to 42
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)input[4] << 14) |
			((uint32_t)(input[5] & 0xe0) << 6);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 43 to 63
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)input[6] << 19) |
			((uint32_t)input[7] << 11);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 64 to 84
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16) |
			((uint32_t)(input[10] & 0xf8) << 8);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 85 to 105
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)input[12] << 13) |
			((uint32_t)(input[13] & 0xc0) << 5);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 106 to 126
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xfe) << 10);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 127 to 147
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xf0) << 7);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 148 to 168
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0x80) << 4);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 169 to 189
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)(input[23] & 0xfc) << 9);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 190 to 210
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)input[25] << 14) |
			((uint32_t)(input[26] & 0xe0) << 6);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 211 to 231
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)input[28] << 11);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 232 to 252
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)input[30] << 16) |
			((uint32_t)(input[31] & 0xf8) << 8);
	output[11] = (double)(value >> 11);
}

static void unpack_12_21bit_unsigned_1off(const uint8_t * input, double * output) {
	// Unpack 12 values into output
	// Values are 21-bit unsigned
	// Skip 1 bits, read 252 bits of data.
	// Input must be at least 32 bytes long

	uint32_t value;

	// read output[0]: from bit 1 to 21
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xfc) << 9);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 22 to 42
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)input[4] << 14) |
			((uint32_t)(input[5] & 0xe0) << 6);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 43 to 63
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)input[6] << 19) |
			((uint32_t)input[7] << 11);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 64 to 84
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16) |
			((uint32_t)(input[10] & 0xf8) << 8);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 85 to 105
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)input[12] << 13) |
			((uint32_t)(input[13] & 0xc0) << 5);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 106 to 126
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xfe) << 10);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 127 to 147
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xf0) << 7);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 148 to 168
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0x80) << 4);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 169 to 189
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)(input[23] & 0xfc) << 9);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 190 to 210
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)input[25] << 14) |
			((uint32_t)(input[26] & 0xe0) << 6);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 211 to 231
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)input[28] << 11);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 232 to 252
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)input[30] << 16) |
			((uint32_t)(input[31] & 0xf8) << 8);
	output[11] = (double)(value >> 11);
}

static void unpack_12_21bit_signed_2off(const uint8_t * input, double * output) {
	// Unpack 12 values into output
	// Values are 21-bit signed
	// Skip 2 bits, read 252 bits of data.
	// Input must be at least 32 bytes long

	int32_t value;

	// read output[0]: from bit 2 to 22
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xfe) << 10);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 23 to 43
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15) |
			((uint32_t)(input[5] & 0xf0) << 7);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 44 to 64
	value = ((uint32_t)(input[5] & 0x0f) << 28) |
			((uint32_t)input[6] << 20) |
			((uint32_t)input[7] << 12) |
			((uint32_t)(input[8] & 0x80) << 4);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 65 to 85
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0xfc) << 9);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 86 to 106
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)input[12] << 14) |
			((uint32_t)(input[13] & 0xe0) << 6);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 107 to 127
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)input[15] << 11);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 128 to 148
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16) |
			((uint32_t)(input[18] & 0xf8) << 8);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 149 to 169
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xc0) << 5);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 170 to 190
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xfe) << 10);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 191 to 211
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15) |
			((uint32_t)(input[26] & 0xf0) << 7);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 212 to 232
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)input[28] << 12) |
			((uint32_t)(input[29] & 0x80) << 4);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 233 to 253
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)input[30] << 17) |
			((uint32_t)(input[31] & 0xfc) << 9);
	output[11] = (double)(value >> 11);
}

static void unpack_12_21bit_unsigned_2off(const uint8_t * input, double * output) {
	// Unpack 12 values into output
	// Values are 21-bit unsigned
	// Skip 2 bits, read 252 bits of data.
	// Input must be at least 32 bytes long

	uint32_t value;

	// read output[0]: from bit 2 to 22
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xfe) << 10);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 23 to 43
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15) |
			((uint32_t)(input[5] & 0xf0) << 7);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 44 to 64
	value = ((uint32_t)(input[5] & 0x0f) << 28) |
			((uint32_t)input[6] << 20) |
			((uint32_t)input[7] << 12) |
			((uint32_t)(input[8] & 0x80) << 4);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 65 to 85
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0xfc) << 9);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 86 to 106
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)input[12] << 14) |
			((uint32_t)(input[13] & 0xe0) << 6);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 107 to 127
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)input[15] << 11);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 128 to 148
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16) |
			((uint32_t)(input[18] & 0xf8) << 8);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 149 to 169
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xc0) << 5);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 170 to 190
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xfe) << 10);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 191 to 211
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15) |
			((uint32_t)(input[26] & 0xf0) << 7);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 212 to 232
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)input[28] << 12) |
			((uint32_t)(input[29] & 0x80) << 4);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 233 to 253
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)input[30] << 17) |
			((uint32_t)(input[31] & 0xfc) << 9);
	output[11] = (double)(value >> 11);
}

static void unpack_12_21bit_signed_3off(const uint8_t * input, double * output) {
	// Unpack 12 values into output
	// Values are 21-bit signed
	// Skip 3 bits, read 252 bits of data.
	// Input must be at least 32 bytes long

	int32_t value;

	// read output[0]: from bit 3 to 23
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 24 to 44
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0xf8) << 8);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 45 to 65
	value = ((uint32_t)(input[5] & 0x07) << 29) |
			((uint32_t)input[6] << 21) |
			((uint32_t)input[7] << 13) |
			((uint32_t)(input[8] & 0xc0) << 5);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 66 to 86
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xfe) << 10);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 87 to 107
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15) |
			((uint32_t)(input[13] & 0xf0) << 7);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 108 to 128
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)input[15] << 12) |
			((uint32_t)(input[16] & 0x80) << 4);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 129 to 149
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0xfc) << 9);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 150 to 170
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xe0) << 6);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 171 to 191
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 192 to 212
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0xf8) << 8);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 213 to 233
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)input[28] << 13) |
			((uint32_t)(input[29] & 0xc0) << 5);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 234 to 254
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)input[30] << 18) |
			((uint32_t)(input[31] & 0xfe) << 10);
	output[11] = (double)(value >> 11);
}

static void unpack_12_21bit_unsigned_3off(const uint8_t * input, double * output) {
	// Unpack 12 values into output
	// Values are 21-bit unsigned
	// Skip 3 bits, read 252 bits of data.
	// Input must be at least 32 bytes long

	uint32_t value;

	// read output[0]: from bit 3 to 23
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 24 to 44
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0xf8) << 8);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 45 to 65
	value = ((uint32_t)(input[5] & 0x07) << 29) |
			((uint32_t)input[6] << 21) |
			((uint32_t)input[7] << 13) |
			((uint32_t)(input[8] & 0xc0) << 5);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 66 to 86
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xfe) << 10);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 87 to 107
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15) |
			((uint32_t)(input[13] & 0xf0) << 7);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 108 to 128
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)input[15] << 12) |
			((uint32_t)(input[16] & 0x80) << 4);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 129 to 149
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0xfc) << 9);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 150 to 170
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xe0) << 6);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 171 to 191
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 192 to 212
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0xf8) << 8);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 213 to 233
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)input[28] << 13) |
			((uint32_t)(input[29] & 0xc0) << 5);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 234 to 254
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)input[30] << 18) |
			((uint32_t)(input[31] & 0xfe) << 10);
	output[11] = (double)(value >> 11);
}

static void unpack_12_21bit_signed_4off(const uint8_t * input, double * output) {
	// Unpack 12 values into output
	// Values are 21-bit signed
	// Skip 4 bits, read 252 bits of data.
	// Input must be at least 32 bytes long

	int32_t value;

	// read output[0]: from bit 4 to 24
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0x80) << 4);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 25 to 45
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)(input[5] & 0xfc) << 9);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 46 to 66
	value = ((uint32_t)(input[5] & 0x03) << 30) |
			((uint32_t)input[6] << 22) |
			((uint32_t)input[7] << 14) |
			((uint32_t)(input[8] & 0xe0) << 6);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 67 to 87
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)input[10] << 11);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 88 to 108
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0xf8) << 8);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 109 to 129
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)input[15] << 13) |
			((uint32_t)(input[16] & 0xc0) << 5);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 130 to 150
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xfe) << 10);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 151 to 171
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xf0) << 7);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 172 to 192
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0x80) << 4);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 193 to 213
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xfc) << 9);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 214 to 234
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)input[28] << 14) |
			((uint32_t)(input[29] & 0xe0) << 6);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 235 to 255
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)input[30] << 19) |
			((uint32_t)input[31] << 11);
	output[11] = (double)(value >> 11);
}

static void unpack_12_21bit_unsigned_4off(const uint8_t * input, double * output) {
	// Unpack 12 values into output
	// Values are 21-bit unsigned
	// Skip 4 bits, read 252 bits of data.
	// Input must be at least 32 bytes long

	uint32_t value;

	// read output[0]: from bit 4 to 24
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0x80) << 4);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 25 to 45
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)(input[5] & 0xfc) << 9);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 46 to 66
	value = ((uint32_t)(input[5] & 0x03) << 30) |
			((uint32_t)input[6] << 22) |
			((uint32_t)input[7] << 14) |
			((uint32_t)(input[8] & 0xe0) << 6);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 67 to 87
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)input[10] << 11);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 88 to 108
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0xf8) << 8);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 109 to 129
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)input[15] << 13) |
			((uint32_t)(input[16] & 0xc0) << 5);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 130 to 150
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xfe) << 10);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 151 to 171
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xf0) << 7);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 172 to 192
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0x80) << 4);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 193 to 213
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xfc) << 9);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 214 to 234
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)input[28] << 14) |
			((uint32_t)(input[29] & 0xe0) << 6);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 235 to 255
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)input[30] << 19) |
			((uint32_t)input[31] << 11);
	output[11] = (double)(value >> 11);
}

static void unpack_12_21bit_signed_5off(const uint8_t * input, double * output) {
	// Unpack 12 values into output
	// Values are 21-bit signed
	// Skip 5 bits, read 252 bits of data.
	// Input must be at least 33 bytes long

	int32_t value;

	// read output[0]: from bit 5 to 25
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xc0) << 5);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 26 to 46
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)(input[5] & 0xfe) << 10);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 47 to 67
	value = ((uint32_t)(input[5] & 0x01) << 31) |
			((uint32_t)input[6] << 23) |
			((uint32_t)input[7] << 15) |
			((uint32_t)(input[8] & 0xf0) << 7);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 68 to 88
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)input[10] << 12) |
			((uint32_t)(input[11] & 0x80) << 4);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 89 to 109
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xfc) << 9);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 110 to 130
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)input[15] << 14) |
			((uint32_t)(input[16] & 0xe0) << 6);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 131 to 151
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)input[18] << 11);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 152 to 172
	value = ((uint32_t)input[19] << 24) |
			((uint32_t)input[20] << 16) |
			((uint32_t)(input[21] & 0xf8) << 8);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 173 to 193
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xc0) << 5);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 194 to 214
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xfe) << 10);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 215 to 235
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)input[28] << 15) |
			((uint32_t)(input[29] & 0xf0) << 7);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 236 to 256
	value = ((uint32_t)(input[29] & 0x0f) << 28) |
			((uint32_t)input[30] << 20) |
			((uint32_t)input[31] << 12) |
			((uint32_t)(input[32] & 0x80) << 4);
	output[11] = (double)(value >> 11);
}

static void unpack_12_21bit_unsigned_5off(const uint8_t * input, double * output) {
	// Unpack 12 values into output
	// Values are 21-bit unsigned
	// Skip 5 bits, read 252 bits of data.
	// Input must be at least 33 bytes long

	uint32_t value;

	// read output[0]: from bit 5 to 25
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xc0) << 5);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 26 to 46
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)(input[5] & 0xfe) << 10);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 47 to 67
	value = ((uint32_t)(input[5] & 0x01) << 31) |
			((uint32_t)input[6] << 23) |
			((uint32_t)input[7] << 15) |
			((uint32_t)(input[8] & 0xf0) << 7);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 68 to 88
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)input[10] << 12) |
			((uint32_t)(input[11] & 0x80) << 4);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 89 to 109
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xfc) << 9);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 110 to 130
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)input[15] << 14) |
			((uint32_t)(input[16] & 0xe0) << 6);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 131 to 151
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)input[18] << 11);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 152 to 172
	value = ((uint32_t)input[19] << 24) |
			((uint32_t)input[20] << 16) |
			((uint32_t)(input[21] & 0xf8) << 8);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 173 to 193
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xc0) << 5);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 194 to 214
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xfe) << 10);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 215 to 235
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)input[28] << 15) |
			((uint32_t)(input[29] & 0xf0) << 7);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 236 to 256
	value = ((uint32_t)(input[29] & 0x0f) << 28) |
			((uint32_t)input[30] << 20) |
			((uint32_t)input[31] << 12) |
			((uint32_t)(input[32] & 0x80) << 4);
	output[11] = (double)(value >> 11);
}

static void unpack_12_21bit_signed_6off(const uint8_t * input, double * output) {
	// Unpack 12 values into output
	// Values are 21-bit signed
	// Skip 6 bits, read 252 bits of data.
	// Input must be at least 33 bytes long

	int32_t value;

	// read output[0]: from bit 6 to 26
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xe0) << 6);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 27 to 47
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 48 to 68
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)(input[8] & 0xf8) << 8);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 69 to 89
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)input[10] << 13) |
			((uint32_t)(input[11] & 0xc0) << 5);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 90 to 110
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xfe) << 10);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 111 to 131
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)input[15] << 15) |
			((uint32_t)(input[16] & 0xf0) << 7);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 132 to 152
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)input[18] << 12) |
			((uint32_t)(input[19] & 0x80) << 4);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 153 to 173
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xfc) << 9);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 174 to 194
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xe0) << 6);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 195 to 215
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 216 to 236
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)(input[29] & 0xf8) << 8);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 237 to 257
	value = ((uint32_t)(input[29] & 0x07) << 29) |
			((uint32_t)input[30] << 21) |
			((uint32_t)input[31] << 13) |
			((uint32_t)(input[32] & 0xc0) << 5);
	output[11] = (double)(value >> 11);
}

static void unpack_12_21bit_unsigned_6off(const uint8_t * input, double * output) {
	// Unpack 12 values into output
	// Values are 21-bit unsigned
	// Skip 6 bits, read 252 bits of data.
	// Input must be at least 33 bytes long

	uint32_t value;

	// read output[0]: from bit 6 to 26
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xe0) << 6);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 27 to 47
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 48 to 68
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)(input[8] & 0xf8) << 8);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 69 to 89
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)input[10] << 13) |
			((uint32_t)(input[11] & 0xc0) << 5);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 90 to 110
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xfe) << 10);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 111 to 131
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)input[15] << 15) |
			((uint32_t)(input[16] & 0xf0) << 7);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 132 to 152
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)input[18] << 12) |
			((uint32_t)(input[19] & 0x80) << 4);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 153 to 173
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xfc) << 9);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 174 to 194
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xe0) << 6);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 195 to 215
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 216 to 236
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)(input[29] & 0xf8) << 8);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 237 to 257
	value = ((uint32_t)(input[29] & 0x07) << 29) |
			((uint32_t)input[30] << 21) |
			((uint32_t)input[31] << 13) |
			((uint32_t)(input[32] & 0xc0) << 5);
	output[11] = (double)(value >> 11);
}

static void unpack_12_21bit_signed_7off(const uint8_t * input, double * output) {
	// Unpack 12 values into output
	// Values are 21-bit signed
	// Skip 7 bits, read 252 bits of data.
	// Input must be at least 33 bytes long

	int32_t value;

	// read output[0]: from bit 7 to 27
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xf0) << 7);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 28 to 48
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0x80) << 4);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 49 to 69
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0xfc) << 9);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 70 to 90
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)input[10] << 14) |
			((uint32_t)(input[11] & 0xe0) << 6);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 91 to 111
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)input[13] << 11);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 112 to 132
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16) |
			((uint32_t)(input[16] & 0xf8) << 8);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 133 to 153
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)input[18] << 13) |
			((uint32_t)(input[19] & 0xc0) << 5);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 154 to 174
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xfe) << 10);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 175 to 195
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xf0) << 7);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 196 to 216
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0x80) << 4);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 217 to 237
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)(input[29] & 0xfc) << 9);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 238 to 258
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)input[31] << 14) |
			((uint32_t)(input[32] & 0xe0) << 6);
	output[11] = (double)(value >> 11);
}

static void unpack_12_21bit_unsigned_7off(const uint8_t * input, double * output) {
	// Unpack 12 values into output
	// Values are 21-bit unsigned
	// Skip 7 bits, read 252 bits of data.
	// Input must be at least 33 bytes long

	uint32_t value;

	// read output[0]: from bit 7 to 27
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xf0) << 7);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 28 to 48
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0x80) << 4);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 49 to 69
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0xfc) << 9);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 70 to 90
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)input[10] << 14) |
			((uint32_t)(input[11] & 0xe0) << 6);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 91 to 111
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)input[13] << 11);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 112 to 132
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16) |
			((uint32_t)(input[16] & 0xf8) << 8);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 133 to 153
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)input[18] << 13) |
			((uint32_t)(input[19] & 0xc0) << 5);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 154 to 174
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xfe) << 10);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 175 to 195
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xf0) << 7);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 196 to 216
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0x80) << 4);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 217 to 237
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)(input[29] & 0xfc) << 9);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 238 to 258
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)input[31] << 14) |
			((uint32_t)(input[32] & 0xe0) << 6);
	output[11] = (double)(value >> 11);
}

static void unpack_13_21bit_signed_0off(const uint8_t * input, double * output) {
	// Unpack 13 values into output
	// Values are 21-bit signed
	// Skip 0 bits, read 273 bits of data.
	// Input must be at least 35 bytes long

	int32_t value;

	// read output[0]: from bit 0 to 20
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0xf8) << 8);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 21 to 41
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)input[4] << 13) |
			((uint32_t)(input[5] & 0xc0) << 5);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 42 to 62
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)input[6] << 18) |
			((uint32_t)(input[7] & 0xfe) << 10);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 63 to 83
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)input[9] << 15) |
			((uint32_t)(input[10] & 0xf0) << 7);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 84 to 104
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)input[12] << 12) |
			((uint32_t)(input[13] & 0x80) << 4);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 105 to 125
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xfc) << 9);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 126 to 146
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xe0) << 6);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 147 to 167
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 168 to 188
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)(input[23] & 0xf8) << 8);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 189 to 209
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)input[25] << 13) |
			((uint32_t)(input[26] & 0xc0) << 5);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 210 to 230
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xfe) << 10);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 231 to 251
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)input[30] << 15) |
			((uint32_t)(input[31] & 0xf0) << 7);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 252 to 272
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20) |
			((uint32_t)input[33] << 12) |
			((uint32_t)(input[34] & 0x80) << 4);
	output[12] = (double)(value >> 11);
}

static void unpack_13_21bit_unsigned_0off(const uint8_t * input, double * output) {
	// Unpack 13 values into output
	// Values are 21-bit unsigned
	// Skip 0 bits, read 273 bits of data.
	// Input must be at least 35 bytes long

	uint32_t value;

	// read output[0]: from bit 0 to 20
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0xf8) << 8);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 21 to 41
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)input[4] << 13) |
			((uint32_t)(input[5] & 0xc0) << 5);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 42 to 62
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)input[6] << 18) |
			((uint32_t)(input[7] & 0xfe) << 10);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 63 to 83
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)input[9] << 15) |
			((uint32_t)(input[10] & 0xf0) << 7);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 84 to 104
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)input[12] << 12) |
			((uint32_t)(input[13] & 0x80) << 4);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 105 to 125
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xfc) << 9);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 126 to 146
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xe0) << 6);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 147 to 167
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 168 to 188
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)(input[23] & 0xf8) << 8);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 189 to 209
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)input[25] << 13) |
			((uint32_t)(input[26] & 0xc0) << 5);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 210 to 230
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xfe) << 10);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 231 to 251
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)input[30] << 15) |
			((uint32_t)(input[31] & 0xf0) << 7);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 252 to 272
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20) |
			((uint32_t)input[33] << 12) |
			((uint32_t)(input[34] & 0x80) << 4);
	output[12] = (double)(value >> 11);
}

static void unpack_13_21bit_signed_1off(const uint8_t * input, double * output) {
	// Unpack 13 values into output
	// Values are 21-bit signed
	// Skip 1 bits, read 273 bits of data.
	// Input must be at least 35 bytes long

	int32_t value;

	// read output[0]: from bit 1 to 21
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xfc) << 9);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 22 to 42
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)input[4] << 14) |
			((uint32_t)(input[5] & 0xe0) << 6);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 43 to 63
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)input[6] << 19) |
			((uint32_t)input[7] << 11);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 64 to 84
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16) |
			((uint32_t)(input[10] & 0xf8) << 8);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 85 to 105
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)input[12] << 13) |
			((uint32_t)(input[13] & 0xc0) << 5);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 106 to 126
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xfe) << 10);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 127 to 147
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xf0) << 7);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 148 to 168
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0x80) << 4);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 169 to 189
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)(input[23] & 0xfc) << 9);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 190 to 210
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)input[25] << 14) |
			((uint32_t)(input[26] & 0xe0) << 6);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 211 to 231
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)input[28] << 11);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 232 to 252
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)input[30] << 16) |
			((uint32_t)(input[31] & 0xf8) << 8);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 253 to 273
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)input[33] << 13) |
			((uint32_t)(input[34] & 0xc0) << 5);
	output[12] = (double)(value >> 11);
}

static void unpack_13_21bit_unsigned_1off(const uint8_t * input, double * output) {
	// Unpack 13 values into output
	// Values are 21-bit unsigned
	// Skip 1 bits, read 273 bits of data.
	// Input must be at least 35 bytes long

	uint32_t value;

	// read output[0]: from bit 1 to 21
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xfc) << 9);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 22 to 42
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)input[4] << 14) |
			((uint32_t)(input[5] & 0xe0) << 6);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 43 to 63
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)input[6] << 19) |
			((uint32_t)input[7] << 11);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 64 to 84
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16) |
			((uint32_t)(input[10] & 0xf8) << 8);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 85 to 105
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)input[12] << 13) |
			((uint32_t)(input[13] & 0xc0) << 5);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 106 to 126
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xfe) << 10);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 127 to 147
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xf0) << 7);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 148 to 168
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0x80) << 4);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 169 to 189
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)(input[23] & 0xfc) << 9);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 190 to 210
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)input[25] << 14) |
			((uint32_t)(input[26] & 0xe0) << 6);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 211 to 231
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)input[28] << 11);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 232 to 252
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)input[30] << 16) |
			((uint32_t)(input[31] & 0xf8) << 8);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 253 to 273
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)input[33] << 13) |
			((uint32_t)(input[34] & 0xc0) << 5);
	output[12] = (double)(value >> 11);
}

static void unpack_13_21bit_signed_2off(const uint8_t * input, double * output) {
	// Unpack 13 values into output
	// Values are 21-bit signed
	// Skip 2 bits, read 273 bits of data.
	// Input must be at least 35 bytes long

	int32_t value;

	// read output[0]: from bit 2 to 22
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xfe) << 10);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 23 to 43
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15) |
			((uint32_t)(input[5] & 0xf0) << 7);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 44 to 64
	value = ((uint32_t)(input[5] & 0x0f) << 28) |
			((uint32_t)input[6] << 20) |
			((uint32_t)input[7] << 12) |
			((uint32_t)(input[8] & 0x80) << 4);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 65 to 85
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0xfc) << 9);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 86 to 106
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)input[12] << 14) |
			((uint32_t)(input[13] & 0xe0) << 6);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 107 to 127
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)input[15] << 11);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 128 to 148
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16) |
			((uint32_t)(input[18] & 0xf8) << 8);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 149 to 169
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xc0) << 5);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 170 to 190
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xfe) << 10);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 191 to 211
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15) |
			((uint32_t)(input[26] & 0xf0) << 7);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 212 to 232
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)input[28] << 12) |
			((uint32_t)(input[29] & 0x80) << 4);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 233 to 253
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)input[30] << 17) |
			((uint32_t)(input[31] & 0xfc) << 9);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 254 to 274
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)input[33] << 14) |
			((uint32_t)(input[34] & 0xe0) << 6);
	output[12] = (double)(value >> 11);
}

static void unpack_13_21bit_unsigned_2off(const uint8_t * input, double * output) {
	// Unpack 13 values into output
	// Values are 21-bit unsigned
	// Skip 2 bits, read 273 bits of data.
	// Input must be at least 35 bytes long

	uint32_t value;

	// read output[0]: from bit 2 to 22
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xfe) << 10);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 23 to 43
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15) |
			((uint32_t)(input[5] & 0xf0) << 7);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 44 to 64
	value = ((uint32_t)(input[5] & 0x0f) << 28) |
			((uint32_t)input[6] << 20) |
			((uint32_t)input[7] << 12) |
			((uint32_t)(input[8] & 0x80) << 4);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 65 to 85
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0xfc) << 9);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 86 to 106
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)input[12] << 14) |
			((uint32_t)(input[13] & 0xe0) << 6);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 107 to 127
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)input[15] << 11);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 128 to 148
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16) |
			((uint32_t)(input[18] & 0xf8) << 8);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 149 to 169
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xc0) << 5);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 170 to 190
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xfe) << 10);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 191 to 211
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15) |
			((uint32_t)(input[26] & 0xf0) << 7);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 212 to 232
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)input[28] << 12) |
			((uint32_t)(input[29] & 0x80) << 4);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 233 to 253
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)input[30] << 17) |
			((uint32_t)(input[31] & 0xfc) << 9);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 254 to 274
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)input[33] << 14) |
			((uint32_t)(input[34] & 0xe0) << 6);
	output[12] = (double)(value >> 11);
}

static void unpack_13_21bit_signed_3off(const uint8_t * input, double * output) {
	// Unpack 13 values into output
	// Values are 21-bit signed
	// Skip 3 bits, read 273 bits of data.
	// Input must be at least 35 bytes long

	int32_t value;

	// read output[0]: from bit 3 to 23
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 24 to 44
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0xf8) << 8);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 45 to 65
	value = ((uint32_t)(input[5] & 0x07) << 29) |
			((uint32_t)input[6] << 21) |
			((uint32_t)input[7] << 13) |
			((uint32_t)(input[8] & 0xc0) << 5);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 66 to 86
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xfe) << 10);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 87 to 107
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15) |
			((uint32_t)(input[13] & 0xf0) << 7);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 108 to 128
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)input[15] << 12) |
			((uint32_t)(input[16] & 0x80) << 4);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 129 to 149
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0xfc) << 9);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 150 to 170
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xe0) << 6);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 171 to 191
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 192 to 212
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0xf8) << 8);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 213 to 233
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)input[28] << 13) |
			((uint32_t)(input[29] & 0xc0) << 5);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 234 to 254
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)input[30] << 18) |
			((uint32_t)(input[31] & 0xfe) << 10);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 255 to 275
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)input[33] << 15) |
			((uint32_t)(input[34] & 0xf0) << 7);
	output[12] = (double)(value >> 11);
}

static void unpack_13_21bit_unsigned_3off(const uint8_t * input, double * output) {
	// Unpack 13 values into output
	// Values are 21-bit unsigned
	// Skip 3 bits, read 273 bits of data.
	// Input must be at least 35 bytes long

	uint32_t value;

	// read output[0]: from bit 3 to 23
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 24 to 44
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0xf8) << 8);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 45 to 65
	value = ((uint32_t)(input[5] & 0x07) << 29) |
			((uint32_t)input[6] << 21) |
			((uint32_t)input[7] << 13) |
			((uint32_t)(input[8] & 0xc0) << 5);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 66 to 86
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xfe) << 10);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 87 to 107
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15) |
			((uint32_t)(input[13] & 0xf0) << 7);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 108 to 128
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)input[15] << 12) |
			((uint32_t)(input[16] & 0x80) << 4);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 129 to 149
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0xfc) << 9);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 150 to 170
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xe0) << 6);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 171 to 191
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 192 to 212
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0xf8) << 8);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 213 to 233
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)input[28] << 13) |
			((uint32_t)(input[29] & 0xc0) << 5);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 234 to 254
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)input[30] << 18) |
			((uint32_t)(input[31] & 0xfe) << 10);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 255 to 275
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)input[33] << 15) |
			((uint32_t)(input[34] & 0xf0) << 7);
	output[12] = (double)(value >> 11);
}

static void unpack_13_21bit_signed_4off(const uint8_t * input, double * output) {
	// Unpack 13 values into output
	// Values are 21-bit signed
	// Skip 4 bits, read 273 bits of data.
	// Input must be at least 35 bytes long

	int32_t value;

	// read output[0]: from bit 4 to 24
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0x80) << 4);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 25 to 45
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)(input[5] & 0xfc) << 9);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 46 to 66
	value = ((uint32_t)(input[5] & 0x03) << 30) |
			((uint32_t)input[6] << 22) |
			((uint32_t)input[7] << 14) |
			((uint32_t)(input[8] & 0xe0) << 6);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 67 to 87
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)input[10] << 11);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 88 to 108
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0xf8) << 8);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 109 to 129
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)input[15] << 13) |
			((uint32_t)(input[16] & 0xc0) << 5);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 130 to 150
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xfe) << 10);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 151 to 171
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xf0) << 7);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 172 to 192
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0x80) << 4);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 193 to 213
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xfc) << 9);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 214 to 234
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)input[28] << 14) |
			((uint32_t)(input[29] & 0xe0) << 6);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 235 to 255
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)input[30] << 19) |
			((uint32_t)input[31] << 11);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 256 to 276
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16) |
			((uint32_t)(input[34] & 0xf8) << 8);
	output[12] = (double)(value >> 11);
}

static void unpack_13_21bit_unsigned_4off(const uint8_t * input, double * output) {
	// Unpack 13 values into output
	// Values are 21-bit unsigned
	// Skip 4 bits, read 273 bits of data.
	// Input must be at least 35 bytes long

	uint32_t value;

	// read output[0]: from bit 4 to 24
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0x80) << 4);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 25 to 45
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)(input[5] & 0xfc) << 9);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 46 to 66
	value = ((uint32_t)(input[5] & 0x03) << 30) |
			((uint32_t)input[6] << 22) |
			((uint32_t)input[7] << 14) |
			((uint32_t)(input[8] & 0xe0) << 6);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 67 to 87
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)input[10] << 11);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 88 to 108
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0xf8) << 8);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 109 to 129
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)input[15] << 13) |
			((uint32_t)(input[16] & 0xc0) << 5);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 130 to 150
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xfe) << 10);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 151 to 171
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xf0) << 7);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 172 to 192
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0x80) << 4);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 193 to 213
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xfc) << 9);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 214 to 234
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)input[28] << 14) |
			((uint32_t)(input[29] & 0xe0) << 6);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 235 to 255
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)input[30] << 19) |
			((uint32_t)input[31] << 11);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 256 to 276
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16) |
			((uint32_t)(input[34] & 0xf8) << 8);
	output[12] = (double)(value >> 11);
}

static void unpack_13_21bit_signed_5off(const uint8_t * input, double * output) {
	// Unpack 13 values into output
	// Values are 21-bit signed
	// Skip 5 bits, read 273 bits of data.
	// Input must be at least 35 bytes long

	int32_t value;

	// read output[0]: from bit 5 to 25
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xc0) << 5);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 26 to 46
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)(input[5] & 0xfe) << 10);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 47 to 67
	value = ((uint32_t)(input[5] & 0x01) << 31) |
			((uint32_t)input[6] << 23) |
			((uint32_t)input[7] << 15) |
			((uint32_t)(input[8] & 0xf0) << 7);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 68 to 88
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)input[10] << 12) |
			((uint32_t)(input[11] & 0x80) << 4);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 89 to 109
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xfc) << 9);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 110 to 130
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)input[15] << 14) |
			((uint32_t)(input[16] & 0xe0) << 6);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 131 to 151
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)input[18] << 11);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 152 to 172
	value = ((uint32_t)input[19] << 24) |
			((uint32_t)input[20] << 16) |
			((uint32_t)(input[21] & 0xf8) << 8);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 173 to 193
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xc0) << 5);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 194 to 214
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xfe) << 10);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 215 to 235
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)input[28] << 15) |
			((uint32_t)(input[29] & 0xf0) << 7);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 236 to 256
	value = ((uint32_t)(input[29] & 0x0f) << 28) |
			((uint32_t)input[30] << 20) |
			((uint32_t)input[31] << 12) |
			((uint32_t)(input[32] & 0x80) << 4);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 257 to 277
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0xfc) << 9);
	output[12] = (double)(value >> 11);
}

static void unpack_13_21bit_unsigned_5off(const uint8_t * input, double * output) {
	// Unpack 13 values into output
	// Values are 21-bit unsigned
	// Skip 5 bits, read 273 bits of data.
	// Input must be at least 35 bytes long

	uint32_t value;

	// read output[0]: from bit 5 to 25
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xc0) << 5);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 26 to 46
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)(input[5] & 0xfe) << 10);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 47 to 67
	value = ((uint32_t)(input[5] & 0x01) << 31) |
			((uint32_t)input[6] << 23) |
			((uint32_t)input[7] << 15) |
			((uint32_t)(input[8] & 0xf0) << 7);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 68 to 88
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)input[10] << 12) |
			((uint32_t)(input[11] & 0x80) << 4);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 89 to 109
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xfc) << 9);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 110 to 130
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)input[15] << 14) |
			((uint32_t)(input[16] & 0xe0) << 6);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 131 to 151
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)input[18] << 11);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 152 to 172
	value = ((uint32_t)input[19] << 24) |
			((uint32_t)input[20] << 16) |
			((uint32_t)(input[21] & 0xf8) << 8);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 173 to 193
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xc0) << 5);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 194 to 214
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xfe) << 10);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 215 to 235
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)input[28] << 15) |
			((uint32_t)(input[29] & 0xf0) << 7);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 236 to 256
	value = ((uint32_t)(input[29] & 0x0f) << 28) |
			((uint32_t)input[30] << 20) |
			((uint32_t)input[31] << 12) |
			((uint32_t)(input[32] & 0x80) << 4);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 257 to 277
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0xfc) << 9);
	output[12] = (double)(value >> 11);
}

static void unpack_13_21bit_signed_6off(const uint8_t * input, double * output) {
	// Unpack 13 values into output
	// Values are 21-bit signed
	// Skip 6 bits, read 273 bits of data.
	// Input must be at least 35 bytes long

	int32_t value;

	// read output[0]: from bit 6 to 26
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xe0) << 6);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 27 to 47
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 48 to 68
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)(input[8] & 0xf8) << 8);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 69 to 89
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)input[10] << 13) |
			((uint32_t)(input[11] & 0xc0) << 5);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 90 to 110
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xfe) << 10);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 111 to 131
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)input[15] << 15) |
			((uint32_t)(input[16] & 0xf0) << 7);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 132 to 152
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)input[18] << 12) |
			((uint32_t)(input[19] & 0x80) << 4);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 153 to 173
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xfc) << 9);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 174 to 194
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xe0) << 6);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 195 to 215
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 216 to 236
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)(input[29] & 0xf8) << 8);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 237 to 257
	value = ((uint32_t)(input[29] & 0x07) << 29) |
			((uint32_t)input[30] << 21) |
			((uint32_t)input[31] << 13) |
			((uint32_t)(input[32] & 0xc0) << 5);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 258 to 278
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xfe) << 10);
	output[12] = (double)(value >> 11);
}

static void unpack_13_21bit_unsigned_6off(const uint8_t * input, double * output) {
	// Unpack 13 values into output
	// Values are 21-bit unsigned
	// Skip 6 bits, read 273 bits of data.
	// Input must be at least 35 bytes long

	uint32_t value;

	// read output[0]: from bit 6 to 26
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xe0) << 6);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 27 to 47
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 48 to 68
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)(input[8] & 0xf8) << 8);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 69 to 89
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)input[10] << 13) |
			((uint32_t)(input[11] & 0xc0) << 5);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 90 to 110
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xfe) << 10);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 111 to 131
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)input[15] << 15) |
			((uint32_t)(input[16] & 0xf0) << 7);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 132 to 152
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)input[18] << 12) |
			((uint32_t)(input[19] & 0x80) << 4);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 153 to 173
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xfc) << 9);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 174 to 194
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xe0) << 6);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 195 to 215
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 216 to 236
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)(input[29] & 0xf8) << 8);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 237 to 257
	value = ((uint32_t)(input[29] & 0x07) << 29) |
			((uint32_t)input[30] << 21) |
			((uint32_t)input[31] << 13) |
			((uint32_t)(input[32] & 0xc0) << 5);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 258 to 278
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xfe) << 10);
	output[12] = (double)(value >> 11);
}

static void unpack_13_21bit_signed_7off(const uint8_t * input, double * output) {
	// Unpack 13 values into output
	// Values are 21-bit signed
	// Skip 7 bits, read 273 bits of data.
	// Input must be at least 35 bytes long

	int32_t value;

	// read output[0]: from bit 7 to 27
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xf0) << 7);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 28 to 48
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0x80) << 4);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 49 to 69
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0xfc) << 9);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 70 to 90
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)input[10] << 14) |
			((uint32_t)(input[11] & 0xe0) << 6);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 91 to 111
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)input[13] << 11);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 112 to 132
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16) |
			((uint32_t)(input[16] & 0xf8) << 8);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 133 to 153
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)input[18] << 13) |
			((uint32_t)(input[19] & 0xc0) << 5);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 154 to 174
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xfe) << 10);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 175 to 195
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xf0) << 7);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 196 to 216
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0x80) << 4);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 217 to 237
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)(input[29] & 0xfc) << 9);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 238 to 258
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)input[31] << 14) |
			((uint32_t)(input[32] & 0xe0) << 6);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 259 to 279
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)input[34] << 11);
	output[12] = (double)(value >> 11);
}

static void unpack_13_21bit_unsigned_7off(const uint8_t * input, double * output) {
	// Unpack 13 values into output
	// Values are 21-bit unsigned
	// Skip 7 bits, read 273 bits of data.
	// Input must be at least 35 bytes long

	uint32_t value;

	// read output[0]: from bit 7 to 27
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xf0) << 7);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 28 to 48
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0x80) << 4);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 49 to 69
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0xfc) << 9);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 70 to 90
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)input[10] << 14) |
			((uint32_t)(input[11] & 0xe0) << 6);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 91 to 111
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)input[13] << 11);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 112 to 132
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16) |
			((uint32_t)(input[16] & 0xf8) << 8);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 133 to 153
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)input[18] << 13) |
			((uint32_t)(input[19] & 0xc0) << 5);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 154 to 174
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xfe) << 10);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 175 to 195
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xf0) << 7);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 196 to 216
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0x80) << 4);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 217 to 237
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)(input[29] & 0xfc) << 9);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 238 to 258
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)input[31] << 14) |
			((uint32_t)(input[32] & 0xe0) << 6);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 259 to 279
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)input[34] << 11);
	output[12] = (double)(value >> 11);
}

static void unpack_14_21bit_signed_0off(const uint8_t * input, double * output) {
	// Unpack 14 values into output
	// Values are 21-bit signed
	// Skip 0 bits, read 294 bits of data.
	// Input must be at least 37 bytes long

	int32_t value;

	// read output[0]: from bit 0 to 20
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0xf8) << 8);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 21 to 41
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)input[4] << 13) |
			((uint32_t)(input[5] & 0xc0) << 5);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 42 to 62
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)input[6] << 18) |
			((uint32_t)(input[7] & 0xfe) << 10);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 63 to 83
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)input[9] << 15) |
			((uint32_t)(input[10] & 0xf0) << 7);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 84 to 104
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)input[12] << 12) |
			((uint32_t)(input[13] & 0x80) << 4);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 105 to 125
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xfc) << 9);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 126 to 146
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xe0) << 6);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 147 to 167
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 168 to 188
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)(input[23] & 0xf8) << 8);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 189 to 209
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)input[25] << 13) |
			((uint32_t)(input[26] & 0xc0) << 5);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 210 to 230
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xfe) << 10);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 231 to 251
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)input[30] << 15) |
			((uint32_t)(input[31] & 0xf0) << 7);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 252 to 272
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20) |
			((uint32_t)input[33] << 12) |
			((uint32_t)(input[34] & 0x80) << 4);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 273 to 293
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0xfc) << 9);
	output[13] = (double)(value >> 11);
}

static void unpack_14_21bit_unsigned_0off(const uint8_t * input, double * output) {
	// Unpack 14 values into output
	// Values are 21-bit unsigned
	// Skip 0 bits, read 294 bits of data.
	// Input must be at least 37 bytes long

	uint32_t value;

	// read output[0]: from bit 0 to 20
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0xf8) << 8);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 21 to 41
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)input[4] << 13) |
			((uint32_t)(input[5] & 0xc0) << 5);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 42 to 62
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)input[6] << 18) |
			((uint32_t)(input[7] & 0xfe) << 10);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 63 to 83
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)input[9] << 15) |
			((uint32_t)(input[10] & 0xf0) << 7);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 84 to 104
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)input[12] << 12) |
			((uint32_t)(input[13] & 0x80) << 4);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 105 to 125
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xfc) << 9);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 126 to 146
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xe0) << 6);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 147 to 167
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 168 to 188
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)(input[23] & 0xf8) << 8);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 189 to 209
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)input[25] << 13) |
			((uint32_t)(input[26] & 0xc0) << 5);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 210 to 230
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xfe) << 10);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 231 to 251
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)input[30] << 15) |
			((uint32_t)(input[31] & 0xf0) << 7);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 252 to 272
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20) |
			((uint32_t)input[33] << 12) |
			((uint32_t)(input[34] & 0x80) << 4);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 273 to 293
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0xfc) << 9);
	output[13] = (double)(value >> 11);
}

static void unpack_14_21bit_signed_1off(const uint8_t * input, double * output) {
	// Unpack 14 values into output
	// Values are 21-bit signed
	// Skip 1 bits, read 294 bits of data.
	// Input must be at least 37 bytes long

	int32_t value;

	// read output[0]: from bit 1 to 21
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xfc) << 9);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 22 to 42
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)input[4] << 14) |
			((uint32_t)(input[5] & 0xe0) << 6);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 43 to 63
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)input[6] << 19) |
			((uint32_t)input[7] << 11);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 64 to 84
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16) |
			((uint32_t)(input[10] & 0xf8) << 8);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 85 to 105
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)input[12] << 13) |
			((uint32_t)(input[13] & 0xc0) << 5);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 106 to 126
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xfe) << 10);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 127 to 147
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xf0) << 7);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 148 to 168
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0x80) << 4);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 169 to 189
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)(input[23] & 0xfc) << 9);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 190 to 210
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)input[25] << 14) |
			((uint32_t)(input[26] & 0xe0) << 6);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 211 to 231
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)input[28] << 11);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 232 to 252
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)input[30] << 16) |
			((uint32_t)(input[31] & 0xf8) << 8);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 253 to 273
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)input[33] << 13) |
			((uint32_t)(input[34] & 0xc0) << 5);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 274 to 294
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xfe) << 10);
	output[13] = (double)(value >> 11);
}

static void unpack_14_21bit_unsigned_1off(const uint8_t * input, double * output) {
	// Unpack 14 values into output
	// Values are 21-bit unsigned
	// Skip 1 bits, read 294 bits of data.
	// Input must be at least 37 bytes long

	uint32_t value;

	// read output[0]: from bit 1 to 21
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xfc) << 9);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 22 to 42
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)input[4] << 14) |
			((uint32_t)(input[5] & 0xe0) << 6);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 43 to 63
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)input[6] << 19) |
			((uint32_t)input[7] << 11);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 64 to 84
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16) |
			((uint32_t)(input[10] & 0xf8) << 8);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 85 to 105
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)input[12] << 13) |
			((uint32_t)(input[13] & 0xc0) << 5);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 106 to 126
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xfe) << 10);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 127 to 147
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xf0) << 7);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 148 to 168
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0x80) << 4);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 169 to 189
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)(input[23] & 0xfc) << 9);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 190 to 210
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)input[25] << 14) |
			((uint32_t)(input[26] & 0xe0) << 6);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 211 to 231
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)input[28] << 11);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 232 to 252
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)input[30] << 16) |
			((uint32_t)(input[31] & 0xf8) << 8);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 253 to 273
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)input[33] << 13) |
			((uint32_t)(input[34] & 0xc0) << 5);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 274 to 294
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xfe) << 10);
	output[13] = (double)(value >> 11);
}

static void unpack_14_21bit_signed_2off(const uint8_t * input, double * output) {
	// Unpack 14 values into output
	// Values are 21-bit signed
	// Skip 2 bits, read 294 bits of data.
	// Input must be at least 37 bytes long

	int32_t value;

	// read output[0]: from bit 2 to 22
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xfe) << 10);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 23 to 43
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15) |
			((uint32_t)(input[5] & 0xf0) << 7);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 44 to 64
	value = ((uint32_t)(input[5] & 0x0f) << 28) |
			((uint32_t)input[6] << 20) |
			((uint32_t)input[7] << 12) |
			((uint32_t)(input[8] & 0x80) << 4);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 65 to 85
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0xfc) << 9);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 86 to 106
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)input[12] << 14) |
			((uint32_t)(input[13] & 0xe0) << 6);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 107 to 127
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)input[15] << 11);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 128 to 148
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16) |
			((uint32_t)(input[18] & 0xf8) << 8);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 149 to 169
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xc0) << 5);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 170 to 190
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xfe) << 10);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 191 to 211
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15) |
			((uint32_t)(input[26] & 0xf0) << 7);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 212 to 232
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)input[28] << 12) |
			((uint32_t)(input[29] & 0x80) << 4);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 233 to 253
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)input[30] << 17) |
			((uint32_t)(input[31] & 0xfc) << 9);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 254 to 274
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)input[33] << 14) |
			((uint32_t)(input[34] & 0xe0) << 6);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 275 to 295
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)input[36] << 11);
	output[13] = (double)(value >> 11);
}

static void unpack_14_21bit_unsigned_2off(const uint8_t * input, double * output) {
	// Unpack 14 values into output
	// Values are 21-bit unsigned
	// Skip 2 bits, read 294 bits of data.
	// Input must be at least 37 bytes long

	uint32_t value;

	// read output[0]: from bit 2 to 22
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xfe) << 10);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 23 to 43
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15) |
			((uint32_t)(input[5] & 0xf0) << 7);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 44 to 64
	value = ((uint32_t)(input[5] & 0x0f) << 28) |
			((uint32_t)input[6] << 20) |
			((uint32_t)input[7] << 12) |
			((uint32_t)(input[8] & 0x80) << 4);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 65 to 85
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0xfc) << 9);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 86 to 106
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)input[12] << 14) |
			((uint32_t)(input[13] & 0xe0) << 6);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 107 to 127
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)input[15] << 11);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 128 to 148
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16) |
			((uint32_t)(input[18] & 0xf8) << 8);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 149 to 169
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xc0) << 5);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 170 to 190
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xfe) << 10);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 191 to 211
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15) |
			((uint32_t)(input[26] & 0xf0) << 7);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 212 to 232
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)input[28] << 12) |
			((uint32_t)(input[29] & 0x80) << 4);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 233 to 253
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)input[30] << 17) |
			((uint32_t)(input[31] & 0xfc) << 9);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 254 to 274
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)input[33] << 14) |
			((uint32_t)(input[34] & 0xe0) << 6);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 275 to 295
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)input[36] << 11);
	output[13] = (double)(value >> 11);
}

static void unpack_14_21bit_signed_3off(const uint8_t * input, double * output) {
	// Unpack 14 values into output
	// Values are 21-bit signed
	// Skip 3 bits, read 294 bits of data.
	// Input must be at least 38 bytes long

	int32_t value;

	// read output[0]: from bit 3 to 23
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 24 to 44
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0xf8) << 8);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 45 to 65
	value = ((uint32_t)(input[5] & 0x07) << 29) |
			((uint32_t)input[6] << 21) |
			((uint32_t)input[7] << 13) |
			((uint32_t)(input[8] & 0xc0) << 5);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 66 to 86
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xfe) << 10);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 87 to 107
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15) |
			((uint32_t)(input[13] & 0xf0) << 7);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 108 to 128
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)input[15] << 12) |
			((uint32_t)(input[16] & 0x80) << 4);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 129 to 149
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0xfc) << 9);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 150 to 170
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xe0) << 6);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 171 to 191
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 192 to 212
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0xf8) << 8);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 213 to 233
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)input[28] << 13) |
			((uint32_t)(input[29] & 0xc0) << 5);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 234 to 254
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)input[30] << 18) |
			((uint32_t)(input[31] & 0xfe) << 10);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 255 to 275
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)input[33] << 15) |
			((uint32_t)(input[34] & 0xf0) << 7);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 276 to 296
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)input[36] << 12) |
			((uint32_t)(input[37] & 0x80) << 4);
	output[13] = (double)(value >> 11);
}

static void unpack_14_21bit_unsigned_3off(const uint8_t * input, double * output) {
	// Unpack 14 values into output
	// Values are 21-bit unsigned
	// Skip 3 bits, read 294 bits of data.
	// Input must be at least 38 bytes long

	uint32_t value;

	// read output[0]: from bit 3 to 23
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 24 to 44
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0xf8) << 8);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 45 to 65
	value = ((uint32_t)(input[5] & 0x07) << 29) |
			((uint32_t)input[6] << 21) |
			((uint32_t)input[7] << 13) |
			((uint32_t)(input[8] & 0xc0) << 5);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 66 to 86
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xfe) << 10);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 87 to 107
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15) |
			((uint32_t)(input[13] & 0xf0) << 7);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 108 to 128
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)input[15] << 12) |
			((uint32_t)(input[16] & 0x80) << 4);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 129 to 149
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0xfc) << 9);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 150 to 170
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xe0) << 6);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 171 to 191
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 192 to 212
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0xf8) << 8);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 213 to 233
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)input[28] << 13) |
			((uint32_t)(input[29] & 0xc0) << 5);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 234 to 254
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)input[30] << 18) |
			((uint32_t)(input[31] & 0xfe) << 10);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 255 to 275
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)input[33] << 15) |
			((uint32_t)(input[34] & 0xf0) << 7);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 276 to 296
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)input[36] << 12) |
			((uint32_t)(input[37] & 0x80) << 4);
	output[13] = (double)(value >> 11);
}

static void unpack_14_21bit_signed_4off(const uint8_t * input, double * output) {
	// Unpack 14 values into output
	// Values are 21-bit signed
	// Skip 4 bits, read 294 bits of data.
	// Input must be at least 38 bytes long

	int32_t value;

	// read output[0]: from bit 4 to 24
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0x80) << 4);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 25 to 45
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)(input[5] & 0xfc) << 9);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 46 to 66
	value = ((uint32_t)(input[5] & 0x03) << 30) |
			((uint32_t)input[6] << 22) |
			((uint32_t)input[7] << 14) |
			((uint32_t)(input[8] & 0xe0) << 6);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 67 to 87
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)input[10] << 11);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 88 to 108
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0xf8) << 8);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 109 to 129
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)input[15] << 13) |
			((uint32_t)(input[16] & 0xc0) << 5);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 130 to 150
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xfe) << 10);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 151 to 171
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xf0) << 7);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 172 to 192
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0x80) << 4);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 193 to 213
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xfc) << 9);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 214 to 234
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)input[28] << 14) |
			((uint32_t)(input[29] & 0xe0) << 6);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 235 to 255
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)input[30] << 19) |
			((uint32_t)input[31] << 11);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 256 to 276
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16) |
			((uint32_t)(input[34] & 0xf8) << 8);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 277 to 297
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)input[36] << 13) |
			((uint32_t)(input[37] & 0xc0) << 5);
	output[13] = (double)(value >> 11);
}

static void unpack_14_21bit_unsigned_4off(const uint8_t * input, double * output) {
	// Unpack 14 values into output
	// Values are 21-bit unsigned
	// Skip 4 bits, read 294 bits of data.
	// Input must be at least 38 bytes long

	uint32_t value;

	// read output[0]: from bit 4 to 24
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0x80) << 4);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 25 to 45
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)(input[5] & 0xfc) << 9);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 46 to 66
	value = ((uint32_t)(input[5] & 0x03) << 30) |
			((uint32_t)input[6] << 22) |
			((uint32_t)input[7] << 14) |
			((uint32_t)(input[8] & 0xe0) << 6);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 67 to 87
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)input[10] << 11);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 88 to 108
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0xf8) << 8);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 109 to 129
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)input[15] << 13) |
			((uint32_t)(input[16] & 0xc0) << 5);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 130 to 150
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xfe) << 10);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 151 to 171
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xf0) << 7);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 172 to 192
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0x80) << 4);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 193 to 213
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xfc) << 9);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 214 to 234
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)input[28] << 14) |
			((uint32_t)(input[29] & 0xe0) << 6);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 235 to 255
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)input[30] << 19) |
			((uint32_t)input[31] << 11);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 256 to 276
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16) |
			((uint32_t)(input[34] & 0xf8) << 8);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 277 to 297
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)input[36] << 13) |
			((uint32_t)(input[37] & 0xc0) << 5);
	output[13] = (double)(value >> 11);
}

static void unpack_14_21bit_signed_5off(const uint8_t * input, double * output) {
	// Unpack 14 values into output
	// Values are 21-bit signed
	// Skip 5 bits, read 294 bits of data.
	// Input must be at least 38 bytes long

	int32_t value;

	// read output[0]: from bit 5 to 25
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xc0) << 5);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 26 to 46
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)(input[5] & 0xfe) << 10);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 47 to 67
	value = ((uint32_t)(input[5] & 0x01) << 31) |
			((uint32_t)input[6] << 23) |
			((uint32_t)input[7] << 15) |
			((uint32_t)(input[8] & 0xf0) << 7);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 68 to 88
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)input[10] << 12) |
			((uint32_t)(input[11] & 0x80) << 4);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 89 to 109
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xfc) << 9);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 110 to 130
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)input[15] << 14) |
			((uint32_t)(input[16] & 0xe0) << 6);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 131 to 151
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)input[18] << 11);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 152 to 172
	value = ((uint32_t)input[19] << 24) |
			((uint32_t)input[20] << 16) |
			((uint32_t)(input[21] & 0xf8) << 8);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 173 to 193
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xc0) << 5);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 194 to 214
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xfe) << 10);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 215 to 235
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)input[28] << 15) |
			((uint32_t)(input[29] & 0xf0) << 7);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 236 to 256
	value = ((uint32_t)(input[29] & 0x0f) << 28) |
			((uint32_t)input[30] << 20) |
			((uint32_t)input[31] << 12) |
			((uint32_t)(input[32] & 0x80) << 4);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 257 to 277
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0xfc) << 9);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 278 to 298
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)input[36] << 14) |
			((uint32_t)(input[37] & 0xe0) << 6);
	output[13] = (double)(value >> 11);
}

static void unpack_14_21bit_unsigned_5off(const uint8_t * input, double * output) {
	// Unpack 14 values into output
	// Values are 21-bit unsigned
	// Skip 5 bits, read 294 bits of data.
	// Input must be at least 38 bytes long

	uint32_t value;

	// read output[0]: from bit 5 to 25
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xc0) << 5);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 26 to 46
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)(input[5] & 0xfe) << 10);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 47 to 67
	value = ((uint32_t)(input[5] & 0x01) << 31) |
			((uint32_t)input[6] << 23) |
			((uint32_t)input[7] << 15) |
			((uint32_t)(input[8] & 0xf0) << 7);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 68 to 88
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)input[10] << 12) |
			((uint32_t)(input[11] & 0x80) << 4);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 89 to 109
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xfc) << 9);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 110 to 130
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)input[15] << 14) |
			((uint32_t)(input[16] & 0xe0) << 6);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 131 to 151
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)input[18] << 11);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 152 to 172
	value = ((uint32_t)input[19] << 24) |
			((uint32_t)input[20] << 16) |
			((uint32_t)(input[21] & 0xf8) << 8);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 173 to 193
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xc0) << 5);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 194 to 214
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xfe) << 10);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 215 to 235
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)input[28] << 15) |
			((uint32_t)(input[29] & 0xf0) << 7);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 236 to 256
	value = ((uint32_t)(input[29] & 0x0f) << 28) |
			((uint32_t)input[30] << 20) |
			((uint32_t)input[31] << 12) |
			((uint32_t)(input[32] & 0x80) << 4);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 257 to 277
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0xfc) << 9);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 278 to 298
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)input[36] << 14) |
			((uint32_t)(input[37] & 0xe0) << 6);
	output[13] = (double)(value >> 11);
}

static void unpack_14_21bit_signed_6off(const uint8_t * input, double * output) {
	// Unpack 14 values into output
	// Values are 21-bit signed
	// Skip 6 bits, read 294 bits of data.
	// Input must be at least 38 bytes long

	int32_t value;

	// read output[0]: from bit 6 to 26
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xe0) << 6);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 27 to 47
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 48 to 68
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)(input[8] & 0xf8) << 8);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 69 to 89
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)input[10] << 13) |
			((uint32_t)(input[11] & 0xc0) << 5);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 90 to 110
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xfe) << 10);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 111 to 131
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)input[15] << 15) |
			((uint32_t)(input[16] & 0xf0) << 7);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 132 to 152
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)input[18] << 12) |
			((uint32_t)(input[19] & 0x80) << 4);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 153 to 173
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xfc) << 9);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 174 to 194
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xe0) << 6);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 195 to 215
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 216 to 236
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)(input[29] & 0xf8) << 8);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 237 to 257
	value = ((uint32_t)(input[29] & 0x07) << 29) |
			((uint32_t)input[30] << 21) |
			((uint32_t)input[31] << 13) |
			((uint32_t)(input[32] & 0xc0) << 5);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 258 to 278
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xfe) << 10);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 279 to 299
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)input[36] << 15) |
			((uint32_t)(input[37] & 0xf0) << 7);
	output[13] = (double)(value >> 11);
}

static void unpack_14_21bit_unsigned_6off(const uint8_t * input, double * output) {
	// Unpack 14 values into output
	// Values are 21-bit unsigned
	// Skip 6 bits, read 294 bits of data.
	// Input must be at least 38 bytes long

	uint32_t value;

	// read output[0]: from bit 6 to 26
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xe0) << 6);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 27 to 47
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 48 to 68
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)(input[8] & 0xf8) << 8);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 69 to 89
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)input[10] << 13) |
			((uint32_t)(input[11] & 0xc0) << 5);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 90 to 110
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xfe) << 10);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 111 to 131
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)input[15] << 15) |
			((uint32_t)(input[16] & 0xf0) << 7);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 132 to 152
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)input[18] << 12) |
			((uint32_t)(input[19] & 0x80) << 4);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 153 to 173
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xfc) << 9);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 174 to 194
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xe0) << 6);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 195 to 215
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 216 to 236
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)(input[29] & 0xf8) << 8);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 237 to 257
	value = ((uint32_t)(input[29] & 0x07) << 29) |
			((uint32_t)input[30] << 21) |
			((uint32_t)input[31] << 13) |
			((uint32_t)(input[32] & 0xc0) << 5);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 258 to 278
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xfe) << 10);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 279 to 299
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)input[36] << 15) |
			((uint32_t)(input[37] & 0xf0) << 7);
	output[13] = (double)(value >> 11);
}

static void unpack_14_21bit_signed_7off(const uint8_t * input, double * output) {
	// Unpack 14 values into output
	// Values are 21-bit signed
	// Skip 7 bits, read 294 bits of data.
	// Input must be at least 38 bytes long

	int32_t value;

	// read output[0]: from bit 7 to 27
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xf0) << 7);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 28 to 48
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0x80) << 4);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 49 to 69
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0xfc) << 9);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 70 to 90
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)input[10] << 14) |
			((uint32_t)(input[11] & 0xe0) << 6);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 91 to 111
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)input[13] << 11);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 112 to 132
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16) |
			((uint32_t)(input[16] & 0xf8) << 8);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 133 to 153
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)input[18] << 13) |
			((uint32_t)(input[19] & 0xc0) << 5);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 154 to 174
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xfe) << 10);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 175 to 195
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xf0) << 7);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 196 to 216
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0x80) << 4);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 217 to 237
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)(input[29] & 0xfc) << 9);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 238 to 258
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)input[31] << 14) |
			((uint32_t)(input[32] & 0xe0) << 6);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 259 to 279
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)input[34] << 11);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 280 to 300
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)input[36] << 16) |
			((uint32_t)(input[37] & 0xf8) << 8);
	output[13] = (double)(value >> 11);
}

static void unpack_14_21bit_unsigned_7off(const uint8_t * input, double * output) {
	// Unpack 14 values into output
	// Values are 21-bit unsigned
	// Skip 7 bits, read 294 bits of data.
	// Input must be at least 38 bytes long

	uint32_t value;

	// read output[0]: from bit 7 to 27
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xf0) << 7);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 28 to 48
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0x80) << 4);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 49 to 69
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0xfc) << 9);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 70 to 90
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)input[10] << 14) |
			((uint32_t)(input[11] & 0xe0) << 6);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 91 to 111
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)input[13] << 11);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 112 to 132
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16) |
			((uint32_t)(input[16] & 0xf8) << 8);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 133 to 153
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)input[18] << 13) |
			((uint32_t)(input[19] & 0xc0) << 5);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 154 to 174
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xfe) << 10);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 175 to 195
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xf0) << 7);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 196 to 216
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0x80) << 4);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 217 to 237
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)(input[29] & 0xfc) << 9);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 238 to 258
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)input[31] << 14) |
			((uint32_t)(input[32] & 0xe0) << 6);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 259 to 279
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)input[34] << 11);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 280 to 300
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)input[36] << 16) |
			((uint32_t)(input[37] & 0xf8) << 8);
	output[13] = (double)(value >> 11);
}

static void unpack_15_21bit_signed_0off(const uint8_t * input, double * output) {
	// Unpack 15 values into output
	// Values are 21-bit signed
	// Skip 0 bits, read 315 bits of data.
	// Input must be at least 40 bytes long

	int32_t value;

	// read output[0]: from bit 0 to 20
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0xf8) << 8);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 21 to 41
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)input[4] << 13) |
			((uint32_t)(input[5] & 0xc0) << 5);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 42 to 62
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)input[6] << 18) |
			((uint32_t)(input[7] & 0xfe) << 10);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 63 to 83
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)input[9] << 15) |
			((uint32_t)(input[10] & 0xf0) << 7);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 84 to 104
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)input[12] << 12) |
			((uint32_t)(input[13] & 0x80) << 4);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 105 to 125
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xfc) << 9);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 126 to 146
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xe0) << 6);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 147 to 167
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 168 to 188
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)(input[23] & 0xf8) << 8);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 189 to 209
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)input[25] << 13) |
			((uint32_t)(input[26] & 0xc0) << 5);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 210 to 230
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xfe) << 10);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 231 to 251
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)input[30] << 15) |
			((uint32_t)(input[31] & 0xf0) << 7);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 252 to 272
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20) |
			((uint32_t)input[33] << 12) |
			((uint32_t)(input[34] & 0x80) << 4);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 273 to 293
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0xfc) << 9);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 294 to 314
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xe0) << 6);
	output[14] = (double)(value >> 11);
}

static void unpack_15_21bit_unsigned_0off(const uint8_t * input, double * output) {
	// Unpack 15 values into output
	// Values are 21-bit unsigned
	// Skip 0 bits, read 315 bits of data.
	// Input must be at least 40 bytes long

	uint32_t value;

	// read output[0]: from bit 0 to 20
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0xf8) << 8);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 21 to 41
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)input[4] << 13) |
			((uint32_t)(input[5] & 0xc0) << 5);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 42 to 62
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)input[6] << 18) |
			((uint32_t)(input[7] & 0xfe) << 10);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 63 to 83
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)input[9] << 15) |
			((uint32_t)(input[10] & 0xf0) << 7);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 84 to 104
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)input[12] << 12) |
			((uint32_t)(input[13] & 0x80) << 4);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 105 to 125
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xfc) << 9);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 126 to 146
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xe0) << 6);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 147 to 167
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 168 to 188
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)(input[23] & 0xf8) << 8);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 189 to 209
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)input[25] << 13) |
			((uint32_t)(input[26] & 0xc0) << 5);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 210 to 230
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xfe) << 10);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 231 to 251
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)input[30] << 15) |
			((uint32_t)(input[31] & 0xf0) << 7);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 252 to 272
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20) |
			((uint32_t)input[33] << 12) |
			((uint32_t)(input[34] & 0x80) << 4);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 273 to 293
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0xfc) << 9);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 294 to 314
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xe0) << 6);
	output[14] = (double)(value >> 11);
}

static void unpack_15_21bit_signed_1off(const uint8_t * input, double * output) {
	// Unpack 15 values into output
	// Values are 21-bit signed
	// Skip 1 bits, read 315 bits of data.
	// Input must be at least 40 bytes long

	int32_t value;

	// read output[0]: from bit 1 to 21
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xfc) << 9);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 22 to 42
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)input[4] << 14) |
			((uint32_t)(input[5] & 0xe0) << 6);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 43 to 63
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)input[6] << 19) |
			((uint32_t)input[7] << 11);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 64 to 84
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16) |
			((uint32_t)(input[10] & 0xf8) << 8);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 85 to 105
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)input[12] << 13) |
			((uint32_t)(input[13] & 0xc0) << 5);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 106 to 126
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xfe) << 10);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 127 to 147
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xf0) << 7);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 148 to 168
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0x80) << 4);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 169 to 189
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)(input[23] & 0xfc) << 9);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 190 to 210
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)input[25] << 14) |
			((uint32_t)(input[26] & 0xe0) << 6);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 211 to 231
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)input[28] << 11);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 232 to 252
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)input[30] << 16) |
			((uint32_t)(input[31] & 0xf8) << 8);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 253 to 273
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)input[33] << 13) |
			((uint32_t)(input[34] & 0xc0) << 5);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 274 to 294
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xfe) << 10);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 295 to 315
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xf0) << 7);
	output[14] = (double)(value >> 11);
}

static void unpack_15_21bit_unsigned_1off(const uint8_t * input, double * output) {
	// Unpack 15 values into output
	// Values are 21-bit unsigned
	// Skip 1 bits, read 315 bits of data.
	// Input must be at least 40 bytes long

	uint32_t value;

	// read output[0]: from bit 1 to 21
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xfc) << 9);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 22 to 42
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)input[4] << 14) |
			((uint32_t)(input[5] & 0xe0) << 6);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 43 to 63
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)input[6] << 19) |
			((uint32_t)input[7] << 11);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 64 to 84
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16) |
			((uint32_t)(input[10] & 0xf8) << 8);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 85 to 105
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)input[12] << 13) |
			((uint32_t)(input[13] & 0xc0) << 5);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 106 to 126
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xfe) << 10);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 127 to 147
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xf0) << 7);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 148 to 168
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0x80) << 4);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 169 to 189
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)(input[23] & 0xfc) << 9);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 190 to 210
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)input[25] << 14) |
			((uint32_t)(input[26] & 0xe0) << 6);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 211 to 231
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)input[28] << 11);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 232 to 252
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)input[30] << 16) |
			((uint32_t)(input[31] & 0xf8) << 8);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 253 to 273
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)input[33] << 13) |
			((uint32_t)(input[34] & 0xc0) << 5);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 274 to 294
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xfe) << 10);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 295 to 315
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xf0) << 7);
	output[14] = (double)(value >> 11);
}

static void unpack_15_21bit_signed_2off(const uint8_t * input, double * output) {
	// Unpack 15 values into output
	// Values are 21-bit signed
	// Skip 2 bits, read 315 bits of data.
	// Input must be at least 40 bytes long

	int32_t value;

	// read output[0]: from bit 2 to 22
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xfe) << 10);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 23 to 43
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15) |
			((uint32_t)(input[5] & 0xf0) << 7);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 44 to 64
	value = ((uint32_t)(input[5] & 0x0f) << 28) |
			((uint32_t)input[6] << 20) |
			((uint32_t)input[7] << 12) |
			((uint32_t)(input[8] & 0x80) << 4);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 65 to 85
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0xfc) << 9);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 86 to 106
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)input[12] << 14) |
			((uint32_t)(input[13] & 0xe0) << 6);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 107 to 127
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)input[15] << 11);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 128 to 148
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16) |
			((uint32_t)(input[18] & 0xf8) << 8);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 149 to 169
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xc0) << 5);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 170 to 190
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xfe) << 10);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 191 to 211
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15) |
			((uint32_t)(input[26] & 0xf0) << 7);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 212 to 232
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)input[28] << 12) |
			((uint32_t)(input[29] & 0x80) << 4);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 233 to 253
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)input[30] << 17) |
			((uint32_t)(input[31] & 0xfc) << 9);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 254 to 274
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)input[33] << 14) |
			((uint32_t)(input[34] & 0xe0) << 6);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 275 to 295
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)input[36] << 11);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 296 to 316
	value = ((uint32_t)input[37] << 24) |
			((uint32_t)input[38] << 16) |
			((uint32_t)(input[39] & 0xf8) << 8);
	output[14] = (double)(value >> 11);
}

static void unpack_15_21bit_unsigned_2off(const uint8_t * input, double * output) {
	// Unpack 15 values into output
	// Values are 21-bit unsigned
	// Skip 2 bits, read 315 bits of data.
	// Input must be at least 40 bytes long

	uint32_t value;

	// read output[0]: from bit 2 to 22
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xfe) << 10);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 23 to 43
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15) |
			((uint32_t)(input[5] & 0xf0) << 7);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 44 to 64
	value = ((uint32_t)(input[5] & 0x0f) << 28) |
			((uint32_t)input[6] << 20) |
			((uint32_t)input[7] << 12) |
			((uint32_t)(input[8] & 0x80) << 4);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 65 to 85
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0xfc) << 9);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 86 to 106
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)input[12] << 14) |
			((uint32_t)(input[13] & 0xe0) << 6);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 107 to 127
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)input[15] << 11);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 128 to 148
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16) |
			((uint32_t)(input[18] & 0xf8) << 8);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 149 to 169
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xc0) << 5);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 170 to 190
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xfe) << 10);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 191 to 211
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15) |
			((uint32_t)(input[26] & 0xf0) << 7);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 212 to 232
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)input[28] << 12) |
			((uint32_t)(input[29] & 0x80) << 4);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 233 to 253
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)input[30] << 17) |
			((uint32_t)(input[31] & 0xfc) << 9);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 254 to 274
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)input[33] << 14) |
			((uint32_t)(input[34] & 0xe0) << 6);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 275 to 295
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)input[36] << 11);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 296 to 316
	value = ((uint32_t)input[37] << 24) |
			((uint32_t)input[38] << 16) |
			((uint32_t)(input[39] & 0xf8) << 8);
	output[14] = (double)(value >> 11);
}

static void unpack_15_21bit_signed_3off(const uint8_t * input, double * output) {
	// Unpack 15 values into output
	// Values are 21-bit signed
	// Skip 3 bits, read 315 bits of data.
	// Input must be at least 40 bytes long

	int32_t value;

	// read output[0]: from bit 3 to 23
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 24 to 44
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0xf8) << 8);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 45 to 65
	value = ((uint32_t)(input[5] & 0x07) << 29) |
			((uint32_t)input[6] << 21) |
			((uint32_t)input[7] << 13) |
			((uint32_t)(input[8] & 0xc0) << 5);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 66 to 86
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xfe) << 10);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 87 to 107
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15) |
			((uint32_t)(input[13] & 0xf0) << 7);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 108 to 128
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)input[15] << 12) |
			((uint32_t)(input[16] & 0x80) << 4);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 129 to 149
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0xfc) << 9);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 150 to 170
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xe0) << 6);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 171 to 191
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 192 to 212
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0xf8) << 8);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 213 to 233
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)input[28] << 13) |
			((uint32_t)(input[29] & 0xc0) << 5);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 234 to 254
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)input[30] << 18) |
			((uint32_t)(input[31] & 0xfe) << 10);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 255 to 275
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)input[33] << 15) |
			((uint32_t)(input[34] & 0xf0) << 7);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 276 to 296
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)input[36] << 12) |
			((uint32_t)(input[37] & 0x80) << 4);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 297 to 317
	value = ((uint32_t)(input[37] & 0x7f) << 25) |
			((uint32_t)input[38] << 17) |
			((uint32_t)(input[39] & 0xfc) << 9);
	output[14] = (double)(value >> 11);
}

static void unpack_15_21bit_unsigned_3off(const uint8_t * input, double * output) {
	// Unpack 15 values into output
	// Values are 21-bit unsigned
	// Skip 3 bits, read 315 bits of data.
	// Input must be at least 40 bytes long

	uint32_t value;

	// read output[0]: from bit 3 to 23
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 24 to 44
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0xf8) << 8);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 45 to 65
	value = ((uint32_t)(input[5] & 0x07) << 29) |
			((uint32_t)input[6] << 21) |
			((uint32_t)input[7] << 13) |
			((uint32_t)(input[8] & 0xc0) << 5);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 66 to 86
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xfe) << 10);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 87 to 107
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15) |
			((uint32_t)(input[13] & 0xf0) << 7);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 108 to 128
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)input[15] << 12) |
			((uint32_t)(input[16] & 0x80) << 4);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 129 to 149
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0xfc) << 9);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 150 to 170
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xe0) << 6);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 171 to 191
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 192 to 212
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0xf8) << 8);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 213 to 233
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)input[28] << 13) |
			((uint32_t)(input[29] & 0xc0) << 5);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 234 to 254
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)input[30] << 18) |
			((uint32_t)(input[31] & 0xfe) << 10);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 255 to 275
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)input[33] << 15) |
			((uint32_t)(input[34] & 0xf0) << 7);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 276 to 296
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)input[36] << 12) |
			((uint32_t)(input[37] & 0x80) << 4);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 297 to 317
	value = ((uint32_t)(input[37] & 0x7f) << 25) |
			((uint32_t)input[38] << 17) |
			((uint32_t)(input[39] & 0xfc) << 9);
	output[14] = (double)(value >> 11);
}

static void unpack_15_21bit_signed_4off(const uint8_t * input, double * output) {
	// Unpack 15 values into output
	// Values are 21-bit signed
	// Skip 4 bits, read 315 bits of data.
	// Input must be at least 40 bytes long

	int32_t value;

	// read output[0]: from bit 4 to 24
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0x80) << 4);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 25 to 45
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)(input[5] & 0xfc) << 9);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 46 to 66
	value = ((uint32_t)(input[5] & 0x03) << 30) |
			((uint32_t)input[6] << 22) |
			((uint32_t)input[7] << 14) |
			((uint32_t)(input[8] & 0xe0) << 6);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 67 to 87
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)input[10] << 11);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 88 to 108
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0xf8) << 8);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 109 to 129
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)input[15] << 13) |
			((uint32_t)(input[16] & 0xc0) << 5);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 130 to 150
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xfe) << 10);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 151 to 171
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xf0) << 7);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 172 to 192
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0x80) << 4);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 193 to 213
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xfc) << 9);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 214 to 234
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)input[28] << 14) |
			((uint32_t)(input[29] & 0xe0) << 6);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 235 to 255
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)input[30] << 19) |
			((uint32_t)input[31] << 11);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 256 to 276
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16) |
			((uint32_t)(input[34] & 0xf8) << 8);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 277 to 297
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)input[36] << 13) |
			((uint32_t)(input[37] & 0xc0) << 5);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 298 to 318
	value = ((uint32_t)(input[37] & 0x3f) << 26) |
			((uint32_t)input[38] << 18) |
			((uint32_t)(input[39] & 0xfe) << 10);
	output[14] = (double)(value >> 11);
}

static void unpack_15_21bit_unsigned_4off(const uint8_t * input, double * output) {
	// Unpack 15 values into output
	// Values are 21-bit unsigned
	// Skip 4 bits, read 315 bits of data.
	// Input must be at least 40 bytes long

	uint32_t value;

	// read output[0]: from bit 4 to 24
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0x80) << 4);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 25 to 45
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)(input[5] & 0xfc) << 9);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 46 to 66
	value = ((uint32_t)(input[5] & 0x03) << 30) |
			((uint32_t)input[6] << 22) |
			((uint32_t)input[7] << 14) |
			((uint32_t)(input[8] & 0xe0) << 6);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 67 to 87
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)input[10] << 11);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 88 to 108
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0xf8) << 8);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 109 to 129
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)input[15] << 13) |
			((uint32_t)(input[16] & 0xc0) << 5);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 130 to 150
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xfe) << 10);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 151 to 171
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xf0) << 7);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 172 to 192
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0x80) << 4);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 193 to 213
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xfc) << 9);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 214 to 234
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)input[28] << 14) |
			((uint32_t)(input[29] & 0xe0) << 6);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 235 to 255
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)input[30] << 19) |
			((uint32_t)input[31] << 11);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 256 to 276
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16) |
			((uint32_t)(input[34] & 0xf8) << 8);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 277 to 297
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)input[36] << 13) |
			((uint32_t)(input[37] & 0xc0) << 5);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 298 to 318
	value = ((uint32_t)(input[37] & 0x3f) << 26) |
			((uint32_t)input[38] << 18) |
			((uint32_t)(input[39] & 0xfe) << 10);
	output[14] = (double)(value >> 11);
}

static void unpack_15_21bit_signed_5off(const uint8_t * input, double * output) {
	// Unpack 15 values into output
	// Values are 21-bit signed
	// Skip 5 bits, read 315 bits of data.
	// Input must be at least 40 bytes long

	int32_t value;

	// read output[0]: from bit 5 to 25
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xc0) << 5);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 26 to 46
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)(input[5] & 0xfe) << 10);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 47 to 67
	value = ((uint32_t)(input[5] & 0x01) << 31) |
			((uint32_t)input[6] << 23) |
			((uint32_t)input[7] << 15) |
			((uint32_t)(input[8] & 0xf0) << 7);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 68 to 88
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)input[10] << 12) |
			((uint32_t)(input[11] & 0x80) << 4);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 89 to 109
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xfc) << 9);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 110 to 130
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)input[15] << 14) |
			((uint32_t)(input[16] & 0xe0) << 6);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 131 to 151
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)input[18] << 11);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 152 to 172
	value = ((uint32_t)input[19] << 24) |
			((uint32_t)input[20] << 16) |
			((uint32_t)(input[21] & 0xf8) << 8);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 173 to 193
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xc0) << 5);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 194 to 214
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xfe) << 10);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 215 to 235
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)input[28] << 15) |
			((uint32_t)(input[29] & 0xf0) << 7);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 236 to 256
	value = ((uint32_t)(input[29] & 0x0f) << 28) |
			((uint32_t)input[30] << 20) |
			((uint32_t)input[31] << 12) |
			((uint32_t)(input[32] & 0x80) << 4);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 257 to 277
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0xfc) << 9);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 278 to 298
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)input[36] << 14) |
			((uint32_t)(input[37] & 0xe0) << 6);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 299 to 319
	value = ((uint32_t)(input[37] & 0x1f) << 27) |
			((uint32_t)input[38] << 19) |
			((uint32_t)input[39] << 11);
	output[14] = (double)(value >> 11);
}

static void unpack_15_21bit_unsigned_5off(const uint8_t * input, double * output) {
	// Unpack 15 values into output
	// Values are 21-bit unsigned
	// Skip 5 bits, read 315 bits of data.
	// Input must be at least 40 bytes long

	uint32_t value;

	// read output[0]: from bit 5 to 25
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xc0) << 5);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 26 to 46
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)(input[5] & 0xfe) << 10);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 47 to 67
	value = ((uint32_t)(input[5] & 0x01) << 31) |
			((uint32_t)input[6] << 23) |
			((uint32_t)input[7] << 15) |
			((uint32_t)(input[8] & 0xf0) << 7);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 68 to 88
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)input[10] << 12) |
			((uint32_t)(input[11] & 0x80) << 4);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 89 to 109
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xfc) << 9);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 110 to 130
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)input[15] << 14) |
			((uint32_t)(input[16] & 0xe0) << 6);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 131 to 151
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)input[18] << 11);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 152 to 172
	value = ((uint32_t)input[19] << 24) |
			((uint32_t)input[20] << 16) |
			((uint32_t)(input[21] & 0xf8) << 8);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 173 to 193
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xc0) << 5);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 194 to 214
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xfe) << 10);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 215 to 235
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)input[28] << 15) |
			((uint32_t)(input[29] & 0xf0) << 7);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 236 to 256
	value = ((uint32_t)(input[29] & 0x0f) << 28) |
			((uint32_t)input[30] << 20) |
			((uint32_t)input[31] << 12) |
			((uint32_t)(input[32] & 0x80) << 4);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 257 to 277
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0xfc) << 9);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 278 to 298
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)input[36] << 14) |
			((uint32_t)(input[37] & 0xe0) << 6);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 299 to 319
	value = ((uint32_t)(input[37] & 0x1f) << 27) |
			((uint32_t)input[38] << 19) |
			((uint32_t)input[39] << 11);
	output[14] = (double)(value >> 11);
}

static void unpack_15_21bit_signed_6off(const uint8_t * input, double * output) {
	// Unpack 15 values into output
	// Values are 21-bit signed
	// Skip 6 bits, read 315 bits of data.
	// Input must be at least 41 bytes long

	int32_t value;

	// read output[0]: from bit 6 to 26
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xe0) << 6);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 27 to 47
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 48 to 68
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)(input[8] & 0xf8) << 8);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 69 to 89
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)input[10] << 13) |
			((uint32_t)(input[11] & 0xc0) << 5);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 90 to 110
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xfe) << 10);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 111 to 131
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)input[15] << 15) |
			((uint32_t)(input[16] & 0xf0) << 7);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 132 to 152
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)input[18] << 12) |
			((uint32_t)(input[19] & 0x80) << 4);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 153 to 173
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xfc) << 9);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 174 to 194
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xe0) << 6);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 195 to 215
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 216 to 236
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)(input[29] & 0xf8) << 8);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 237 to 257
	value = ((uint32_t)(input[29] & 0x07) << 29) |
			((uint32_t)input[30] << 21) |
			((uint32_t)input[31] << 13) |
			((uint32_t)(input[32] & 0xc0) << 5);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 258 to 278
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xfe) << 10);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 279 to 299
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)input[36] << 15) |
			((uint32_t)(input[37] & 0xf0) << 7);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 300 to 320
	value = ((uint32_t)(input[37] & 0x0f) << 28) |
			((uint32_t)input[38] << 20) |
			((uint32_t)input[39] << 12) |
			((uint32_t)(input[40] & 0x80) << 4);
	output[14] = (double)(value >> 11);
}

static void unpack_15_21bit_unsigned_6off(const uint8_t * input, double * output) {
	// Unpack 15 values into output
	// Values are 21-bit unsigned
	// Skip 6 bits, read 315 bits of data.
	// Input must be at least 41 bytes long

	uint32_t value;

	// read output[0]: from bit 6 to 26
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xe0) << 6);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 27 to 47
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 48 to 68
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)(input[8] & 0xf8) << 8);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 69 to 89
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)input[10] << 13) |
			((uint32_t)(input[11] & 0xc0) << 5);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 90 to 110
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xfe) << 10);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 111 to 131
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)input[15] << 15) |
			((uint32_t)(input[16] & 0xf0) << 7);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 132 to 152
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)input[18] << 12) |
			((uint32_t)(input[19] & 0x80) << 4);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 153 to 173
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xfc) << 9);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 174 to 194
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xe0) << 6);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 195 to 215
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 216 to 236
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)(input[29] & 0xf8) << 8);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 237 to 257
	value = ((uint32_t)(input[29] & 0x07) << 29) |
			((uint32_t)input[30] << 21) |
			((uint32_t)input[31] << 13) |
			((uint32_t)(input[32] & 0xc0) << 5);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 258 to 278
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xfe) << 10);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 279 to 299
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)input[36] << 15) |
			((uint32_t)(input[37] & 0xf0) << 7);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 300 to 320
	value = ((uint32_t)(input[37] & 0x0f) << 28) |
			((uint32_t)input[38] << 20) |
			((uint32_t)input[39] << 12) |
			((uint32_t)(input[40] & 0x80) << 4);
	output[14] = (double)(value >> 11);
}

static void unpack_15_21bit_signed_7off(const uint8_t * input, double * output) {
	// Unpack 15 values into output
	// Values are 21-bit signed
	// Skip 7 bits, read 315 bits of data.
	// Input must be at least 41 bytes long

	int32_t value;

	// read output[0]: from bit 7 to 27
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xf0) << 7);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 28 to 48
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0x80) << 4);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 49 to 69
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0xfc) << 9);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 70 to 90
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)input[10] << 14) |
			((uint32_t)(input[11] & 0xe0) << 6);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 91 to 111
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)input[13] << 11);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 112 to 132
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16) |
			((uint32_t)(input[16] & 0xf8) << 8);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 133 to 153
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)input[18] << 13) |
			((uint32_t)(input[19] & 0xc0) << 5);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 154 to 174
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xfe) << 10);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 175 to 195
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xf0) << 7);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 196 to 216
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0x80) << 4);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 217 to 237
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)(input[29] & 0xfc) << 9);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 238 to 258
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)input[31] << 14) |
			((uint32_t)(input[32] & 0xe0) << 6);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 259 to 279
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)input[34] << 11);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 280 to 300
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)input[36] << 16) |
			((uint32_t)(input[37] & 0xf8) << 8);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 301 to 321
	value = ((uint32_t)(input[37] & 0x07) << 29) |
			((uint32_t)input[38] << 21) |
			((uint32_t)input[39] << 13) |
			((uint32_t)(input[40] & 0xc0) << 5);
	output[14] = (double)(value >> 11);
}

static void unpack_15_21bit_unsigned_7off(const uint8_t * input, double * output) {
	// Unpack 15 values into output
	// Values are 21-bit unsigned
	// Skip 7 bits, read 315 bits of data.
	// Input must be at least 41 bytes long

	uint32_t value;

	// read output[0]: from bit 7 to 27
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xf0) << 7);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 28 to 48
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0x80) << 4);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 49 to 69
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0xfc) << 9);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 70 to 90
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)input[10] << 14) |
			((uint32_t)(input[11] & 0xe0) << 6);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 91 to 111
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)input[13] << 11);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 112 to 132
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16) |
			((uint32_t)(input[16] & 0xf8) << 8);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 133 to 153
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)input[18] << 13) |
			((uint32_t)(input[19] & 0xc0) << 5);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 154 to 174
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xfe) << 10);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 175 to 195
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xf0) << 7);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 196 to 216
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0x80) << 4);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 217 to 237
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)(input[29] & 0xfc) << 9);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 238 to 258
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)input[31] << 14) |
			((uint32_t)(input[32] & 0xe0) << 6);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 259 to 279
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)input[34] << 11);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 280 to 300
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)input[36] << 16) |
			((uint32_t)(input[37] & 0xf8) << 8);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 301 to 321
	value = ((uint32_t)(input[37] & 0x07) << 29) |
			((uint32_t)input[38] << 21) |
			((uint32_t)input[39] << 13) |
			((uint32_t)(input[40] & 0xc0) << 5);
	output[14] = (double)(value >> 11);
}

static void unpack_16_21bit_signed_0off(const uint8_t * input, double * output) {
	// Unpack 16 values into output
	// Values are 21-bit signed
	// Skip 0 bits, read 336 bits of data.
	// Input must be at least 42 bytes long

	int32_t value;

	// read output[0]: from bit 0 to 20
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0xf8) << 8);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 21 to 41
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)input[4] << 13) |
			((uint32_t)(input[5] & 0xc0) << 5);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 42 to 62
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)input[6] << 18) |
			((uint32_t)(input[7] & 0xfe) << 10);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 63 to 83
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)input[9] << 15) |
			((uint32_t)(input[10] & 0xf0) << 7);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 84 to 104
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)input[12] << 12) |
			((uint32_t)(input[13] & 0x80) << 4);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 105 to 125
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xfc) << 9);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 126 to 146
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xe0) << 6);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 147 to 167
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 168 to 188
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)(input[23] & 0xf8) << 8);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 189 to 209
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)input[25] << 13) |
			((uint32_t)(input[26] & 0xc0) << 5);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 210 to 230
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xfe) << 10);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 231 to 251
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)input[30] << 15) |
			((uint32_t)(input[31] & 0xf0) << 7);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 252 to 272
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20) |
			((uint32_t)input[33] << 12) |
			((uint32_t)(input[34] & 0x80) << 4);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 273 to 293
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0xfc) << 9);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 294 to 314
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xe0) << 6);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 315 to 335
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11);
	output[15] = (double)(value >> 11);
}

static void unpack_16_21bit_unsigned_0off(const uint8_t * input, double * output) {
	// Unpack 16 values into output
	// Values are 21-bit unsigned
	// Skip 0 bits, read 336 bits of data.
	// Input must be at least 42 bytes long

	uint32_t value;

	// read output[0]: from bit 0 to 20
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0xf8) << 8);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 21 to 41
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)input[4] << 13) |
			((uint32_t)(input[5] & 0xc0) << 5);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 42 to 62
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)input[6] << 18) |
			((uint32_t)(input[7] & 0xfe) << 10);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 63 to 83
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)input[9] << 15) |
			((uint32_t)(input[10] & 0xf0) << 7);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 84 to 104
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)input[12] << 12) |
			((uint32_t)(input[13] & 0x80) << 4);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 105 to 125
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xfc) << 9);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 126 to 146
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xe0) << 6);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 147 to 167
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 168 to 188
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)(input[23] & 0xf8) << 8);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 189 to 209
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)input[25] << 13) |
			((uint32_t)(input[26] & 0xc0) << 5);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 210 to 230
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xfe) << 10);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 231 to 251
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)input[30] << 15) |
			((uint32_t)(input[31] & 0xf0) << 7);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 252 to 272
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20) |
			((uint32_t)input[33] << 12) |
			((uint32_t)(input[34] & 0x80) << 4);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 273 to 293
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0xfc) << 9);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 294 to 314
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xe0) << 6);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 315 to 335
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11);
	output[15] = (double)(value >> 11);
}

static void unpack_16_21bit_signed_1off(const uint8_t * input, double * output) {
	// Unpack 16 values into output
	// Values are 21-bit signed
	// Skip 1 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	int32_t value;

	// read output[0]: from bit 1 to 21
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xfc) << 9);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 22 to 42
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)input[4] << 14) |
			((uint32_t)(input[5] & 0xe0) << 6);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 43 to 63
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)input[6] << 19) |
			((uint32_t)input[7] << 11);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 64 to 84
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16) |
			((uint32_t)(input[10] & 0xf8) << 8);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 85 to 105
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)input[12] << 13) |
			((uint32_t)(input[13] & 0xc0) << 5);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 106 to 126
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xfe) << 10);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 127 to 147
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xf0) << 7);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 148 to 168
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0x80) << 4);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 169 to 189
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)(input[23] & 0xfc) << 9);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 190 to 210
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)input[25] << 14) |
			((uint32_t)(input[26] & 0xe0) << 6);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 211 to 231
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)input[28] << 11);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 232 to 252
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)input[30] << 16) |
			((uint32_t)(input[31] & 0xf8) << 8);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 253 to 273
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)input[33] << 13) |
			((uint32_t)(input[34] & 0xc0) << 5);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 274 to 294
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xfe) << 10);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 295 to 315
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xf0) << 7);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 316 to 336
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0x80) << 4);
	output[15] = (double)(value >> 11);
}

static void unpack_16_21bit_unsigned_1off(const uint8_t * input, double * output) {
	// Unpack 16 values into output
	// Values are 21-bit unsigned
	// Skip 1 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	uint32_t value;

	// read output[0]: from bit 1 to 21
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xfc) << 9);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 22 to 42
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)input[4] << 14) |
			((uint32_t)(input[5] & 0xe0) << 6);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 43 to 63
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)input[6] << 19) |
			((uint32_t)input[7] << 11);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 64 to 84
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16) |
			((uint32_t)(input[10] & 0xf8) << 8);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 85 to 105
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)input[12] << 13) |
			((uint32_t)(input[13] & 0xc0) << 5);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 106 to 126
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xfe) << 10);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 127 to 147
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xf0) << 7);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 148 to 168
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0x80) << 4);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 169 to 189
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)(input[23] & 0xfc) << 9);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 190 to 210
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)input[25] << 14) |
			((uint32_t)(input[26] & 0xe0) << 6);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 211 to 231
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)input[28] << 11);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 232 to 252
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)input[30] << 16) |
			((uint32_t)(input[31] & 0xf8) << 8);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 253 to 273
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)input[33] << 13) |
			((uint32_t)(input[34] & 0xc0) << 5);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 274 to 294
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xfe) << 10);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 295 to 315
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xf0) << 7);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 316 to 336
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0x80) << 4);
	output[15] = (double)(value >> 11);
}

static void unpack_16_21bit_signed_2off(const uint8_t * input, double * output) {
	// Unpack 16 values into output
	// Values are 21-bit signed
	// Skip 2 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	int32_t value;

	// read output[0]: from bit 2 to 22
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xfe) << 10);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 23 to 43
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15) |
			((uint32_t)(input[5] & 0xf0) << 7);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 44 to 64
	value = ((uint32_t)(input[5] & 0x0f) << 28) |
			((uint32_t)input[6] << 20) |
			((uint32_t)input[7] << 12) |
			((uint32_t)(input[8] & 0x80) << 4);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 65 to 85
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0xfc) << 9);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 86 to 106
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)input[12] << 14) |
			((uint32_t)(input[13] & 0xe0) << 6);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 107 to 127
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)input[15] << 11);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 128 to 148
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16) |
			((uint32_t)(input[18] & 0xf8) << 8);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 149 to 169
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xc0) << 5);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 170 to 190
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xfe) << 10);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 191 to 211
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15) |
			((uint32_t)(input[26] & 0xf0) << 7);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 212 to 232
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)input[28] << 12) |
			((uint32_t)(input[29] & 0x80) << 4);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 233 to 253
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)input[30] << 17) |
			((uint32_t)(input[31] & 0xfc) << 9);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 254 to 274
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)input[33] << 14) |
			((uint32_t)(input[34] & 0xe0) << 6);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 275 to 295
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)input[36] << 11);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 296 to 316
	value = ((uint32_t)input[37] << 24) |
			((uint32_t)input[38] << 16) |
			((uint32_t)(input[39] & 0xf8) << 8);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 317 to 337
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xc0) << 5);
	output[15] = (double)(value >> 11);
}

static void unpack_16_21bit_unsigned_2off(const uint8_t * input, double * output) {
	// Unpack 16 values into output
	// Values are 21-bit unsigned
	// Skip 2 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	uint32_t value;

	// read output[0]: from bit 2 to 22
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xfe) << 10);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 23 to 43
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15) |
			((uint32_t)(input[5] & 0xf0) << 7);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 44 to 64
	value = ((uint32_t)(input[5] & 0x0f) << 28) |
			((uint32_t)input[6] << 20) |
			((uint32_t)input[7] << 12) |
			((uint32_t)(input[8] & 0x80) << 4);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 65 to 85
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0xfc) << 9);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 86 to 106
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)input[12] << 14) |
			((uint32_t)(input[13] & 0xe0) << 6);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 107 to 127
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)input[15] << 11);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 128 to 148
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16) |
			((uint32_t)(input[18] & 0xf8) << 8);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 149 to 169
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xc0) << 5);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 170 to 190
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xfe) << 10);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 191 to 211
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15) |
			((uint32_t)(input[26] & 0xf0) << 7);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 212 to 232
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)input[28] << 12) |
			((uint32_t)(input[29] & 0x80) << 4);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 233 to 253
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)input[30] << 17) |
			((uint32_t)(input[31] & 0xfc) << 9);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 254 to 274
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)input[33] << 14) |
			((uint32_t)(input[34] & 0xe0) << 6);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 275 to 295
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)input[36] << 11);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 296 to 316
	value = ((uint32_t)input[37] << 24) |
			((uint32_t)input[38] << 16) |
			((uint32_t)(input[39] & 0xf8) << 8);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 317 to 337
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xc0) << 5);
	output[15] = (double)(value >> 11);
}

static void unpack_16_21bit_signed_3off(const uint8_t * input, double * output) {
	// Unpack 16 values into output
	// Values are 21-bit signed
	// Skip 3 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	int32_t value;

	// read output[0]: from bit 3 to 23
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 24 to 44
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0xf8) << 8);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 45 to 65
	value = ((uint32_t)(input[5] & 0x07) << 29) |
			((uint32_t)input[6] << 21) |
			((uint32_t)input[7] << 13) |
			((uint32_t)(input[8] & 0xc0) << 5);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 66 to 86
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xfe) << 10);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 87 to 107
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15) |
			((uint32_t)(input[13] & 0xf0) << 7);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 108 to 128
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)input[15] << 12) |
			((uint32_t)(input[16] & 0x80) << 4);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 129 to 149
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0xfc) << 9);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 150 to 170
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xe0) << 6);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 171 to 191
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 192 to 212
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0xf8) << 8);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 213 to 233
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)input[28] << 13) |
			((uint32_t)(input[29] & 0xc0) << 5);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 234 to 254
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)input[30] << 18) |
			((uint32_t)(input[31] & 0xfe) << 10);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 255 to 275
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)input[33] << 15) |
			((uint32_t)(input[34] & 0xf0) << 7);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 276 to 296
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)input[36] << 12) |
			((uint32_t)(input[37] & 0x80) << 4);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 297 to 317
	value = ((uint32_t)(input[37] & 0x7f) << 25) |
			((uint32_t)input[38] << 17) |
			((uint32_t)(input[39] & 0xfc) << 9);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 318 to 338
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xe0) << 6);
	output[15] = (double)(value >> 11);
}

static void unpack_16_21bit_unsigned_3off(const uint8_t * input, double * output) {
	// Unpack 16 values into output
	// Values are 21-bit unsigned
	// Skip 3 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	uint32_t value;

	// read output[0]: from bit 3 to 23
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 24 to 44
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0xf8) << 8);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 45 to 65
	value = ((uint32_t)(input[5] & 0x07) << 29) |
			((uint32_t)input[6] << 21) |
			((uint32_t)input[7] << 13) |
			((uint32_t)(input[8] & 0xc0) << 5);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 66 to 86
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xfe) << 10);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 87 to 107
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15) |
			((uint32_t)(input[13] & 0xf0) << 7);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 108 to 128
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)input[15] << 12) |
			((uint32_t)(input[16] & 0x80) << 4);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 129 to 149
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0xfc) << 9);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 150 to 170
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xe0) << 6);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 171 to 191
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 192 to 212
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0xf8) << 8);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 213 to 233
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)input[28] << 13) |
			((uint32_t)(input[29] & 0xc0) << 5);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 234 to 254
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)input[30] << 18) |
			((uint32_t)(input[31] & 0xfe) << 10);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 255 to 275
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)input[33] << 15) |
			((uint32_t)(input[34] & 0xf0) << 7);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 276 to 296
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)input[36] << 12) |
			((uint32_t)(input[37] & 0x80) << 4);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 297 to 317
	value = ((uint32_t)(input[37] & 0x7f) << 25) |
			((uint32_t)input[38] << 17) |
			((uint32_t)(input[39] & 0xfc) << 9);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 318 to 338
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xe0) << 6);
	output[15] = (double)(value >> 11);
}

static void unpack_16_21bit_signed_4off(const uint8_t * input, double * output) {
	// Unpack 16 values into output
	// Values are 21-bit signed
	// Skip 4 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	int32_t value;

	// read output[0]: from bit 4 to 24
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0x80) << 4);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 25 to 45
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)(input[5] & 0xfc) << 9);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 46 to 66
	value = ((uint32_t)(input[5] & 0x03) << 30) |
			((uint32_t)input[6] << 22) |
			((uint32_t)input[7] << 14) |
			((uint32_t)(input[8] & 0xe0) << 6);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 67 to 87
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)input[10] << 11);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 88 to 108
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0xf8) << 8);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 109 to 129
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)input[15] << 13) |
			((uint32_t)(input[16] & 0xc0) << 5);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 130 to 150
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xfe) << 10);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 151 to 171
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xf0) << 7);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 172 to 192
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0x80) << 4);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 193 to 213
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xfc) << 9);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 214 to 234
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)input[28] << 14) |
			((uint32_t)(input[29] & 0xe0) << 6);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 235 to 255
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)input[30] << 19) |
			((uint32_t)input[31] << 11);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 256 to 276
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16) |
			((uint32_t)(input[34] & 0xf8) << 8);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 277 to 297
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)input[36] << 13) |
			((uint32_t)(input[37] & 0xc0) << 5);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 298 to 318
	value = ((uint32_t)(input[37] & 0x3f) << 26) |
			((uint32_t)input[38] << 18) |
			((uint32_t)(input[39] & 0xfe) << 10);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 319 to 339
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xf0) << 7);
	output[15] = (double)(value >> 11);
}

static void unpack_16_21bit_unsigned_4off(const uint8_t * input, double * output) {
	// Unpack 16 values into output
	// Values are 21-bit unsigned
	// Skip 4 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	uint32_t value;

	// read output[0]: from bit 4 to 24
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0x80) << 4);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 25 to 45
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)(input[5] & 0xfc) << 9);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 46 to 66
	value = ((uint32_t)(input[5] & 0x03) << 30) |
			((uint32_t)input[6] << 22) |
			((uint32_t)input[7] << 14) |
			((uint32_t)(input[8] & 0xe0) << 6);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 67 to 87
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)input[10] << 11);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 88 to 108
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0xf8) << 8);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 109 to 129
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)input[15] << 13) |
			((uint32_t)(input[16] & 0xc0) << 5);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 130 to 150
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xfe) << 10);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 151 to 171
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xf0) << 7);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 172 to 192
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0x80) << 4);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 193 to 213
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xfc) << 9);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 214 to 234
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)input[28] << 14) |
			((uint32_t)(input[29] & 0xe0) << 6);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 235 to 255
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)input[30] << 19) |
			((uint32_t)input[31] << 11);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 256 to 276
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16) |
			((uint32_t)(input[34] & 0xf8) << 8);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 277 to 297
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)input[36] << 13) |
			((uint32_t)(input[37] & 0xc0) << 5);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 298 to 318
	value = ((uint32_t)(input[37] & 0x3f) << 26) |
			((uint32_t)input[38] << 18) |
			((uint32_t)(input[39] & 0xfe) << 10);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 319 to 339
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xf0) << 7);
	output[15] = (double)(value >> 11);
}

static void unpack_16_21bit_signed_5off(const uint8_t * input, double * output) {
	// Unpack 16 values into output
	// Values are 21-bit signed
	// Skip 5 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	int32_t value;

	// read output[0]: from bit 5 to 25
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xc0) << 5);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 26 to 46
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)(input[5] & 0xfe) << 10);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 47 to 67
	value = ((uint32_t)(input[5] & 0x01) << 31) |
			((uint32_t)input[6] << 23) |
			((uint32_t)input[7] << 15) |
			((uint32_t)(input[8] & 0xf0) << 7);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 68 to 88
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)input[10] << 12) |
			((uint32_t)(input[11] & 0x80) << 4);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 89 to 109
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xfc) << 9);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 110 to 130
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)input[15] << 14) |
			((uint32_t)(input[16] & 0xe0) << 6);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 131 to 151
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)input[18] << 11);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 152 to 172
	value = ((uint32_t)input[19] << 24) |
			((uint32_t)input[20] << 16) |
			((uint32_t)(input[21] & 0xf8) << 8);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 173 to 193
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xc0) << 5);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 194 to 214
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xfe) << 10);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 215 to 235
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)input[28] << 15) |
			((uint32_t)(input[29] & 0xf0) << 7);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 236 to 256
	value = ((uint32_t)(input[29] & 0x0f) << 28) |
			((uint32_t)input[30] << 20) |
			((uint32_t)input[31] << 12) |
			((uint32_t)(input[32] & 0x80) << 4);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 257 to 277
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0xfc) << 9);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 278 to 298
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)input[36] << 14) |
			((uint32_t)(input[37] & 0xe0) << 6);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 299 to 319
	value = ((uint32_t)(input[37] & 0x1f) << 27) |
			((uint32_t)input[38] << 19) |
			((uint32_t)input[39] << 11);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 320 to 340
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16) |
			((uint32_t)(input[42] & 0xf8) << 8);
	output[15] = (double)(value >> 11);
}

static void unpack_16_21bit_unsigned_5off(const uint8_t * input, double * output) {
	// Unpack 16 values into output
	// Values are 21-bit unsigned
	// Skip 5 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	uint32_t value;

	// read output[0]: from bit 5 to 25
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xc0) << 5);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 26 to 46
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)(input[5] & 0xfe) << 10);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 47 to 67
	value = ((uint32_t)(input[5] & 0x01) << 31) |
			((uint32_t)input[6] << 23) |
			((uint32_t)input[7] << 15) |
			((uint32_t)(input[8] & 0xf0) << 7);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 68 to 88
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)input[10] << 12) |
			((uint32_t)(input[11] & 0x80) << 4);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 89 to 109
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xfc) << 9);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 110 to 130
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)input[15] << 14) |
			((uint32_t)(input[16] & 0xe0) << 6);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 131 to 151
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)input[18] << 11);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 152 to 172
	value = ((uint32_t)input[19] << 24) |
			((uint32_t)input[20] << 16) |
			((uint32_t)(input[21] & 0xf8) << 8);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 173 to 193
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xc0) << 5);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 194 to 214
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xfe) << 10);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 215 to 235
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)input[28] << 15) |
			((uint32_t)(input[29] & 0xf0) << 7);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 236 to 256
	value = ((uint32_t)(input[29] & 0x0f) << 28) |
			((uint32_t)input[30] << 20) |
			((uint32_t)input[31] << 12) |
			((uint32_t)(input[32] & 0x80) << 4);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 257 to 277
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0xfc) << 9);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 278 to 298
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)input[36] << 14) |
			((uint32_t)(input[37] & 0xe0) << 6);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 299 to 319
	value = ((uint32_t)(input[37] & 0x1f) << 27) |
			((uint32_t)input[38] << 19) |
			((uint32_t)input[39] << 11);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 320 to 340
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16) |
			((uint32_t)(input[42] & 0xf8) << 8);
	output[15] = (double)(value >> 11);
}

static void unpack_16_21bit_signed_6off(const uint8_t * input, double * output) {
	// Unpack 16 values into output
	// Values are 21-bit signed
	// Skip 6 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	int32_t value;

	// read output[0]: from bit 6 to 26
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xe0) << 6);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 27 to 47
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 48 to 68
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)(input[8] & 0xf8) << 8);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 69 to 89
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)input[10] << 13) |
			((uint32_t)(input[11] & 0xc0) << 5);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 90 to 110
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xfe) << 10);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 111 to 131
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)input[15] << 15) |
			((uint32_t)(input[16] & 0xf0) << 7);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 132 to 152
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)input[18] << 12) |
			((uint32_t)(input[19] & 0x80) << 4);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 153 to 173
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xfc) << 9);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 174 to 194
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xe0) << 6);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 195 to 215
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 216 to 236
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)(input[29] & 0xf8) << 8);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 237 to 257
	value = ((uint32_t)(input[29] & 0x07) << 29) |
			((uint32_t)input[30] << 21) |
			((uint32_t)input[31] << 13) |
			((uint32_t)(input[32] & 0xc0) << 5);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 258 to 278
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xfe) << 10);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 279 to 299
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)input[36] << 15) |
			((uint32_t)(input[37] & 0xf0) << 7);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 300 to 320
	value = ((uint32_t)(input[37] & 0x0f) << 28) |
			((uint32_t)input[38] << 20) |
			((uint32_t)input[39] << 12) |
			((uint32_t)(input[40] & 0x80) << 4);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 321 to 341
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0xfc) << 9);
	output[15] = (double)(value >> 11);
}

static void unpack_16_21bit_unsigned_6off(const uint8_t * input, double * output) {
	// Unpack 16 values into output
	// Values are 21-bit unsigned
	// Skip 6 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	uint32_t value;

	// read output[0]: from bit 6 to 26
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xe0) << 6);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 27 to 47
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 48 to 68
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)(input[8] & 0xf8) << 8);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 69 to 89
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)input[10] << 13) |
			((uint32_t)(input[11] & 0xc0) << 5);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 90 to 110
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xfe) << 10);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 111 to 131
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)input[15] << 15) |
			((uint32_t)(input[16] & 0xf0) << 7);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 132 to 152
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)input[18] << 12) |
			((uint32_t)(input[19] & 0x80) << 4);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 153 to 173
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xfc) << 9);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 174 to 194
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xe0) << 6);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 195 to 215
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 216 to 236
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)(input[29] & 0xf8) << 8);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 237 to 257
	value = ((uint32_t)(input[29] & 0x07) << 29) |
			((uint32_t)input[30] << 21) |
			((uint32_t)input[31] << 13) |
			((uint32_t)(input[32] & 0xc0) << 5);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 258 to 278
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xfe) << 10);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 279 to 299
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)input[36] << 15) |
			((uint32_t)(input[37] & 0xf0) << 7);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 300 to 320
	value = ((uint32_t)(input[37] & 0x0f) << 28) |
			((uint32_t)input[38] << 20) |
			((uint32_t)input[39] << 12) |
			((uint32_t)(input[40] & 0x80) << 4);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 321 to 341
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0xfc) << 9);
	output[15] = (double)(value >> 11);
}

static void unpack_16_21bit_signed_7off(const uint8_t * input, double * output) {
	// Unpack 16 values into output
	// Values are 21-bit signed
	// Skip 7 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	int32_t value;

	// read output[0]: from bit 7 to 27
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xf0) << 7);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 28 to 48
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0x80) << 4);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 49 to 69
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0xfc) << 9);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 70 to 90
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)input[10] << 14) |
			((uint32_t)(input[11] & 0xe0) << 6);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 91 to 111
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)input[13] << 11);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 112 to 132
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16) |
			((uint32_t)(input[16] & 0xf8) << 8);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 133 to 153
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)input[18] << 13) |
			((uint32_t)(input[19] & 0xc0) << 5);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 154 to 174
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xfe) << 10);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 175 to 195
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xf0) << 7);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 196 to 216
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0x80) << 4);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 217 to 237
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)(input[29] & 0xfc) << 9);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 238 to 258
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)input[31] << 14) |
			((uint32_t)(input[32] & 0xe0) << 6);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 259 to 279
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)input[34] << 11);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 280 to 300
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)input[36] << 16) |
			((uint32_t)(input[37] & 0xf8) << 8);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 301 to 321
	value = ((uint32_t)(input[37] & 0x07) << 29) |
			((uint32_t)input[38] << 21) |
			((uint32_t)input[39] << 13) |
			((uint32_t)(input[40] & 0xc0) << 5);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 322 to 342
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xfe) << 10);
	output[15] = (double)(value >> 11);
}

static void unpack_16_21bit_unsigned_7off(const uint8_t * input, double * output) {
	// Unpack 16 values into output
	// Values are 21-bit unsigned
	// Skip 7 bits, read 336 bits of data.
	// Input must be at least 43 bytes long

	uint32_t value;

	// read output[0]: from bit 7 to 27
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xf0) << 7);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 28 to 48
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0x80) << 4);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 49 to 69
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0xfc) << 9);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 70 to 90
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)input[10] << 14) |
			((uint32_t)(input[11] & 0xe0) << 6);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 91 to 111
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)input[13] << 11);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 112 to 132
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16) |
			((uint32_t)(input[16] & 0xf8) << 8);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 133 to 153
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)input[18] << 13) |
			((uint32_t)(input[19] & 0xc0) << 5);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 154 to 174
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xfe) << 10);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 175 to 195
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xf0) << 7);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 196 to 216
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0x80) << 4);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 217 to 237
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)(input[29] & 0xfc) << 9);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 238 to 258
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)input[31] << 14) |
			((uint32_t)(input[32] & 0xe0) << 6);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 259 to 279
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)input[34] << 11);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 280 to 300
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)input[36] << 16) |
			((uint32_t)(input[37] & 0xf8) << 8);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 301 to 321
	value = ((uint32_t)(input[37] & 0x07) << 29) |
			((uint32_t)input[38] << 21) |
			((uint32_t)input[39] << 13) |
			((uint32_t)(input[40] & 0xc0) << 5);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 322 to 342
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xfe) << 10);
	output[15] = (double)(value >> 11);
}

static void unpack_17_21bit_signed_0off(const uint8_t * input, double * output) {
	// Unpack 17 values into output
	// Values are 21-bit signed
	// Skip 0 bits, read 357 bits of data.
	// Input must be at least 45 bytes long

	int32_t value;

	// read output[0]: from bit 0 to 20
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0xf8) << 8);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 21 to 41
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)input[4] << 13) |
			((uint32_t)(input[5] & 0xc0) << 5);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 42 to 62
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)input[6] << 18) |
			((uint32_t)(input[7] & 0xfe) << 10);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 63 to 83
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)input[9] << 15) |
			((uint32_t)(input[10] & 0xf0) << 7);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 84 to 104
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)input[12] << 12) |
			((uint32_t)(input[13] & 0x80) << 4);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 105 to 125
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xfc) << 9);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 126 to 146
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xe0) << 6);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 147 to 167
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 168 to 188
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)(input[23] & 0xf8) << 8);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 189 to 209
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)input[25] << 13) |
			((uint32_t)(input[26] & 0xc0) << 5);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 210 to 230
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xfe) << 10);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 231 to 251
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)input[30] << 15) |
			((uint32_t)(input[31] & 0xf0) << 7);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 252 to 272
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20) |
			((uint32_t)input[33] << 12) |
			((uint32_t)(input[34] & 0x80) << 4);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 273 to 293
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0xfc) << 9);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 294 to 314
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xe0) << 6);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 315 to 335
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 336 to 356
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)(input[44] & 0xf8) << 8);
	output[16] = (double)(value >> 11);
}

static void unpack_17_21bit_unsigned_0off(const uint8_t * input, double * output) {
	// Unpack 17 values into output
	// Values are 21-bit unsigned
	// Skip 0 bits, read 357 bits of data.
	// Input must be at least 45 bytes long

	uint32_t value;

	// read output[0]: from bit 0 to 20
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0xf8) << 8);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 21 to 41
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)input[4] << 13) |
			((uint32_t)(input[5] & 0xc0) << 5);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 42 to 62
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)input[6] << 18) |
			((uint32_t)(input[7] & 0xfe) << 10);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 63 to 83
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)input[9] << 15) |
			((uint32_t)(input[10] & 0xf0) << 7);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 84 to 104
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)input[12] << 12) |
			((uint32_t)(input[13] & 0x80) << 4);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 105 to 125
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xfc) << 9);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 126 to 146
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xe0) << 6);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 147 to 167
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 168 to 188
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)(input[23] & 0xf8) << 8);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 189 to 209
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)input[25] << 13) |
			((uint32_t)(input[26] & 0xc0) << 5);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 210 to 230
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xfe) << 10);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 231 to 251
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)input[30] << 15) |
			((uint32_t)(input[31] & 0xf0) << 7);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 252 to 272
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20) |
			((uint32_t)input[33] << 12) |
			((uint32_t)(input[34] & 0x80) << 4);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 273 to 293
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0xfc) << 9);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 294 to 314
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xe0) << 6);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 315 to 335
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 336 to 356
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)(input[44] & 0xf8) << 8);
	output[16] = (double)(value >> 11);
}

static void unpack_17_21bit_signed_1off(const uint8_t * input, double * output) {
	// Unpack 17 values into output
	// Values are 21-bit signed
	// Skip 1 bits, read 357 bits of data.
	// Input must be at least 45 bytes long

	int32_t value;

	// read output[0]: from bit 1 to 21
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xfc) << 9);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 22 to 42
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)input[4] << 14) |
			((uint32_t)(input[5] & 0xe0) << 6);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 43 to 63
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)input[6] << 19) |
			((uint32_t)input[7] << 11);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 64 to 84
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16) |
			((uint32_t)(input[10] & 0xf8) << 8);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 85 to 105
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)input[12] << 13) |
			((uint32_t)(input[13] & 0xc0) << 5);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 106 to 126
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xfe) << 10);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 127 to 147
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xf0) << 7);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 148 to 168
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0x80) << 4);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 169 to 189
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)(input[23] & 0xfc) << 9);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 190 to 210
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)input[25] << 14) |
			((uint32_t)(input[26] & 0xe0) << 6);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 211 to 231
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)input[28] << 11);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 232 to 252
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)input[30] << 16) |
			((uint32_t)(input[31] & 0xf8) << 8);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 253 to 273
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)input[33] << 13) |
			((uint32_t)(input[34] & 0xc0) << 5);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 274 to 294
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xfe) << 10);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 295 to 315
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xf0) << 7);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 316 to 336
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0x80) << 4);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 337 to 357
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0xfc) << 9);
	output[16] = (double)(value >> 11);
}

static void unpack_17_21bit_unsigned_1off(const uint8_t * input, double * output) {
	// Unpack 17 values into output
	// Values are 21-bit unsigned
	// Skip 1 bits, read 357 bits of data.
	// Input must be at least 45 bytes long

	uint32_t value;

	// read output[0]: from bit 1 to 21
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xfc) << 9);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 22 to 42
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)input[4] << 14) |
			((uint32_t)(input[5] & 0xe0) << 6);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 43 to 63
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)input[6] << 19) |
			((uint32_t)input[7] << 11);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 64 to 84
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16) |
			((uint32_t)(input[10] & 0xf8) << 8);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 85 to 105
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)input[12] << 13) |
			((uint32_t)(input[13] & 0xc0) << 5);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 106 to 126
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xfe) << 10);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 127 to 147
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xf0) << 7);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 148 to 168
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0x80) << 4);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 169 to 189
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)(input[23] & 0xfc) << 9);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 190 to 210
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)input[25] << 14) |
			((uint32_t)(input[26] & 0xe0) << 6);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 211 to 231
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)input[28] << 11);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 232 to 252
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)input[30] << 16) |
			((uint32_t)(input[31] & 0xf8) << 8);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 253 to 273
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)input[33] << 13) |
			((uint32_t)(input[34] & 0xc0) << 5);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 274 to 294
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xfe) << 10);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 295 to 315
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xf0) << 7);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 316 to 336
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0x80) << 4);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 337 to 357
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0xfc) << 9);
	output[16] = (double)(value >> 11);
}

static void unpack_17_21bit_signed_2off(const uint8_t * input, double * output) {
	// Unpack 17 values into output
	// Values are 21-bit signed
	// Skip 2 bits, read 357 bits of data.
	// Input must be at least 45 bytes long

	int32_t value;

	// read output[0]: from bit 2 to 22
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xfe) << 10);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 23 to 43
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15) |
			((uint32_t)(input[5] & 0xf0) << 7);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 44 to 64
	value = ((uint32_t)(input[5] & 0x0f) << 28) |
			((uint32_t)input[6] << 20) |
			((uint32_t)input[7] << 12) |
			((uint32_t)(input[8] & 0x80) << 4);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 65 to 85
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0xfc) << 9);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 86 to 106
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)input[12] << 14) |
			((uint32_t)(input[13] & 0xe0) << 6);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 107 to 127
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)input[15] << 11);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 128 to 148
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16) |
			((uint32_t)(input[18] & 0xf8) << 8);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 149 to 169
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xc0) << 5);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 170 to 190
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xfe) << 10);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 191 to 211
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15) |
			((uint32_t)(input[26] & 0xf0) << 7);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 212 to 232
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)input[28] << 12) |
			((uint32_t)(input[29] & 0x80) << 4);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 233 to 253
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)input[30] << 17) |
			((uint32_t)(input[31] & 0xfc) << 9);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 254 to 274
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)input[33] << 14) |
			((uint32_t)(input[34] & 0xe0) << 6);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 275 to 295
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)input[36] << 11);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 296 to 316
	value = ((uint32_t)input[37] << 24) |
			((uint32_t)input[38] << 16) |
			((uint32_t)(input[39] & 0xf8) << 8);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 317 to 337
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xc0) << 5);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 338 to 358
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xfe) << 10);
	output[16] = (double)(value >> 11);
}

static void unpack_17_21bit_unsigned_2off(const uint8_t * input, double * output) {
	// Unpack 17 values into output
	// Values are 21-bit unsigned
	// Skip 2 bits, read 357 bits of data.
	// Input must be at least 45 bytes long

	uint32_t value;

	// read output[0]: from bit 2 to 22
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xfe) << 10);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 23 to 43
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15) |
			((uint32_t)(input[5] & 0xf0) << 7);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 44 to 64
	value = ((uint32_t)(input[5] & 0x0f) << 28) |
			((uint32_t)input[6] << 20) |
			((uint32_t)input[7] << 12) |
			((uint32_t)(input[8] & 0x80) << 4);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 65 to 85
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0xfc) << 9);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 86 to 106
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)input[12] << 14) |
			((uint32_t)(input[13] & 0xe0) << 6);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 107 to 127
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)input[15] << 11);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 128 to 148
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16) |
			((uint32_t)(input[18] & 0xf8) << 8);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 149 to 169
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xc0) << 5);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 170 to 190
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xfe) << 10);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 191 to 211
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15) |
			((uint32_t)(input[26] & 0xf0) << 7);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 212 to 232
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)input[28] << 12) |
			((uint32_t)(input[29] & 0x80) << 4);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 233 to 253
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)input[30] << 17) |
			((uint32_t)(input[31] & 0xfc) << 9);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 254 to 274
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)input[33] << 14) |
			((uint32_t)(input[34] & 0xe0) << 6);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 275 to 295
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)input[36] << 11);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 296 to 316
	value = ((uint32_t)input[37] << 24) |
			((uint32_t)input[38] << 16) |
			((uint32_t)(input[39] & 0xf8) << 8);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 317 to 337
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xc0) << 5);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 338 to 358
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xfe) << 10);
	output[16] = (double)(value >> 11);
}

static void unpack_17_21bit_signed_3off(const uint8_t * input, double * output) {
	// Unpack 17 values into output
	// Values are 21-bit signed
	// Skip 3 bits, read 357 bits of data.
	// Input must be at least 45 bytes long

	int32_t value;

	// read output[0]: from bit 3 to 23
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 24 to 44
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0xf8) << 8);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 45 to 65
	value = ((uint32_t)(input[5] & 0x07) << 29) |
			((uint32_t)input[6] << 21) |
			((uint32_t)input[7] << 13) |
			((uint32_t)(input[8] & 0xc0) << 5);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 66 to 86
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xfe) << 10);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 87 to 107
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15) |
			((uint32_t)(input[13] & 0xf0) << 7);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 108 to 128
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)input[15] << 12) |
			((uint32_t)(input[16] & 0x80) << 4);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 129 to 149
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0xfc) << 9);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 150 to 170
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xe0) << 6);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 171 to 191
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 192 to 212
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0xf8) << 8);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 213 to 233
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)input[28] << 13) |
			((uint32_t)(input[29] & 0xc0) << 5);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 234 to 254
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)input[30] << 18) |
			((uint32_t)(input[31] & 0xfe) << 10);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 255 to 275
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)input[33] << 15) |
			((uint32_t)(input[34] & 0xf0) << 7);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 276 to 296
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)input[36] << 12) |
			((uint32_t)(input[37] & 0x80) << 4);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 297 to 317
	value = ((uint32_t)(input[37] & 0x7f) << 25) |
			((uint32_t)input[38] << 17) |
			((uint32_t)(input[39] & 0xfc) << 9);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 318 to 338
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xe0) << 6);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 339 to 359
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11);
	output[16] = (double)(value >> 11);
}

static void unpack_17_21bit_unsigned_3off(const uint8_t * input, double * output) {
	// Unpack 17 values into output
	// Values are 21-bit unsigned
	// Skip 3 bits, read 357 bits of data.
	// Input must be at least 45 bytes long

	uint32_t value;

	// read output[0]: from bit 3 to 23
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 24 to 44
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0xf8) << 8);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 45 to 65
	value = ((uint32_t)(input[5] & 0x07) << 29) |
			((uint32_t)input[6] << 21) |
			((uint32_t)input[7] << 13) |
			((uint32_t)(input[8] & 0xc0) << 5);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 66 to 86
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xfe) << 10);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 87 to 107
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15) |
			((uint32_t)(input[13] & 0xf0) << 7);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 108 to 128
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)input[15] << 12) |
			((uint32_t)(input[16] & 0x80) << 4);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 129 to 149
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0xfc) << 9);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 150 to 170
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xe0) << 6);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 171 to 191
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 192 to 212
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0xf8) << 8);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 213 to 233
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)input[28] << 13) |
			((uint32_t)(input[29] & 0xc0) << 5);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 234 to 254
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)input[30] << 18) |
			((uint32_t)(input[31] & 0xfe) << 10);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 255 to 275
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)input[33] << 15) |
			((uint32_t)(input[34] & 0xf0) << 7);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 276 to 296
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)input[36] << 12) |
			((uint32_t)(input[37] & 0x80) << 4);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 297 to 317
	value = ((uint32_t)(input[37] & 0x7f) << 25) |
			((uint32_t)input[38] << 17) |
			((uint32_t)(input[39] & 0xfc) << 9);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 318 to 338
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xe0) << 6);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 339 to 359
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11);
	output[16] = (double)(value >> 11);
}

static void unpack_17_21bit_signed_4off(const uint8_t * input, double * output) {
	// Unpack 17 values into output
	// Values are 21-bit signed
	// Skip 4 bits, read 357 bits of data.
	// Input must be at least 46 bytes long

	int32_t value;

	// read output[0]: from bit 4 to 24
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0x80) << 4);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 25 to 45
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)(input[5] & 0xfc) << 9);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 46 to 66
	value = ((uint32_t)(input[5] & 0x03) << 30) |
			((uint32_t)input[6] << 22) |
			((uint32_t)input[7] << 14) |
			((uint32_t)(input[8] & 0xe0) << 6);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 67 to 87
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)input[10] << 11);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 88 to 108
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0xf8) << 8);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 109 to 129
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)input[15] << 13) |
			((uint32_t)(input[16] & 0xc0) << 5);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 130 to 150
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xfe) << 10);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 151 to 171
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xf0) << 7);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 172 to 192
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0x80) << 4);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 193 to 213
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xfc) << 9);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 214 to 234
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)input[28] << 14) |
			((uint32_t)(input[29] & 0xe0) << 6);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 235 to 255
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)input[30] << 19) |
			((uint32_t)input[31] << 11);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 256 to 276
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16) |
			((uint32_t)(input[34] & 0xf8) << 8);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 277 to 297
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)input[36] << 13) |
			((uint32_t)(input[37] & 0xc0) << 5);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 298 to 318
	value = ((uint32_t)(input[37] & 0x3f) << 26) |
			((uint32_t)input[38] << 18) |
			((uint32_t)(input[39] & 0xfe) << 10);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 319 to 339
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xf0) << 7);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 340 to 360
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0x80) << 4);
	output[16] = (double)(value >> 11);
}

static void unpack_17_21bit_unsigned_4off(const uint8_t * input, double * output) {
	// Unpack 17 values into output
	// Values are 21-bit unsigned
	// Skip 4 bits, read 357 bits of data.
	// Input must be at least 46 bytes long

	uint32_t value;

	// read output[0]: from bit 4 to 24
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0x80) << 4);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 25 to 45
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)(input[5] & 0xfc) << 9);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 46 to 66
	value = ((uint32_t)(input[5] & 0x03) << 30) |
			((uint32_t)input[6] << 22) |
			((uint32_t)input[7] << 14) |
			((uint32_t)(input[8] & 0xe0) << 6);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 67 to 87
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)input[10] << 11);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 88 to 108
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0xf8) << 8);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 109 to 129
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)input[15] << 13) |
			((uint32_t)(input[16] & 0xc0) << 5);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 130 to 150
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xfe) << 10);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 151 to 171
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xf0) << 7);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 172 to 192
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0x80) << 4);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 193 to 213
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xfc) << 9);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 214 to 234
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)input[28] << 14) |
			((uint32_t)(input[29] & 0xe0) << 6);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 235 to 255
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)input[30] << 19) |
			((uint32_t)input[31] << 11);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 256 to 276
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16) |
			((uint32_t)(input[34] & 0xf8) << 8);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 277 to 297
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)input[36] << 13) |
			((uint32_t)(input[37] & 0xc0) << 5);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 298 to 318
	value = ((uint32_t)(input[37] & 0x3f) << 26) |
			((uint32_t)input[38] << 18) |
			((uint32_t)(input[39] & 0xfe) << 10);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 319 to 339
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xf0) << 7);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 340 to 360
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0x80) << 4);
	output[16] = (double)(value >> 11);
}

static void unpack_17_21bit_signed_5off(const uint8_t * input, double * output) {
	// Unpack 17 values into output
	// Values are 21-bit signed
	// Skip 5 bits, read 357 bits of data.
	// Input must be at least 46 bytes long

	int32_t value;

	// read output[0]: from bit 5 to 25
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xc0) << 5);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 26 to 46
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)(input[5] & 0xfe) << 10);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 47 to 67
	value = ((uint32_t)(input[5] & 0x01) << 31) |
			((uint32_t)input[6] << 23) |
			((uint32_t)input[7] << 15) |
			((uint32_t)(input[8] & 0xf0) << 7);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 68 to 88
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)input[10] << 12) |
			((uint32_t)(input[11] & 0x80) << 4);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 89 to 109
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xfc) << 9);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 110 to 130
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)input[15] << 14) |
			((uint32_t)(input[16] & 0xe0) << 6);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 131 to 151
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)input[18] << 11);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 152 to 172
	value = ((uint32_t)input[19] << 24) |
			((uint32_t)input[20] << 16) |
			((uint32_t)(input[21] & 0xf8) << 8);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 173 to 193
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xc0) << 5);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 194 to 214
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xfe) << 10);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 215 to 235
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)input[28] << 15) |
			((uint32_t)(input[29] & 0xf0) << 7);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 236 to 256
	value = ((uint32_t)(input[29] & 0x0f) << 28) |
			((uint32_t)input[30] << 20) |
			((uint32_t)input[31] << 12) |
			((uint32_t)(input[32] & 0x80) << 4);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 257 to 277
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0xfc) << 9);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 278 to 298
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)input[36] << 14) |
			((uint32_t)(input[37] & 0xe0) << 6);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 299 to 319
	value = ((uint32_t)(input[37] & 0x1f) << 27) |
			((uint32_t)input[38] << 19) |
			((uint32_t)input[39] << 11);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 320 to 340
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16) |
			((uint32_t)(input[42] & 0xf8) << 8);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 341 to 361
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xc0) << 5);
	output[16] = (double)(value >> 11);
}

static void unpack_17_21bit_unsigned_5off(const uint8_t * input, double * output) {
	// Unpack 17 values into output
	// Values are 21-bit unsigned
	// Skip 5 bits, read 357 bits of data.
	// Input must be at least 46 bytes long

	uint32_t value;

	// read output[0]: from bit 5 to 25
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xc0) << 5);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 26 to 46
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)(input[5] & 0xfe) << 10);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 47 to 67
	value = ((uint32_t)(input[5] & 0x01) << 31) |
			((uint32_t)input[6] << 23) |
			((uint32_t)input[7] << 15) |
			((uint32_t)(input[8] & 0xf0) << 7);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 68 to 88
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)input[10] << 12) |
			((uint32_t)(input[11] & 0x80) << 4);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 89 to 109
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xfc) << 9);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 110 to 130
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)input[15] << 14) |
			((uint32_t)(input[16] & 0xe0) << 6);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 131 to 151
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)input[18] << 11);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 152 to 172
	value = ((uint32_t)input[19] << 24) |
			((uint32_t)input[20] << 16) |
			((uint32_t)(input[21] & 0xf8) << 8);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 173 to 193
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xc0) << 5);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 194 to 214
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xfe) << 10);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 215 to 235
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)input[28] << 15) |
			((uint32_t)(input[29] & 0xf0) << 7);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 236 to 256
	value = ((uint32_t)(input[29] & 0x0f) << 28) |
			((uint32_t)input[30] << 20) |
			((uint32_t)input[31] << 12) |
			((uint32_t)(input[32] & 0x80) << 4);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 257 to 277
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0xfc) << 9);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 278 to 298
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)input[36] << 14) |
			((uint32_t)(input[37] & 0xe0) << 6);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 299 to 319
	value = ((uint32_t)(input[37] & 0x1f) << 27) |
			((uint32_t)input[38] << 19) |
			((uint32_t)input[39] << 11);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 320 to 340
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16) |
			((uint32_t)(input[42] & 0xf8) << 8);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 341 to 361
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xc0) << 5);
	output[16] = (double)(value >> 11);
}

static void unpack_17_21bit_signed_6off(const uint8_t * input, double * output) {
	// Unpack 17 values into output
	// Values are 21-bit signed
	// Skip 6 bits, read 357 bits of data.
	// Input must be at least 46 bytes long

	int32_t value;

	// read output[0]: from bit 6 to 26
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xe0) << 6);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 27 to 47
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 48 to 68
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)(input[8] & 0xf8) << 8);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 69 to 89
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)input[10] << 13) |
			((uint32_t)(input[11] & 0xc0) << 5);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 90 to 110
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xfe) << 10);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 111 to 131
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)input[15] << 15) |
			((uint32_t)(input[16] & 0xf0) << 7);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 132 to 152
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)input[18] << 12) |
			((uint32_t)(input[19] & 0x80) << 4);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 153 to 173
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xfc) << 9);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 174 to 194
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xe0) << 6);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 195 to 215
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 216 to 236
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)(input[29] & 0xf8) << 8);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 237 to 257
	value = ((uint32_t)(input[29] & 0x07) << 29) |
			((uint32_t)input[30] << 21) |
			((uint32_t)input[31] << 13) |
			((uint32_t)(input[32] & 0xc0) << 5);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 258 to 278
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xfe) << 10);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 279 to 299
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)input[36] << 15) |
			((uint32_t)(input[37] & 0xf0) << 7);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 300 to 320
	value = ((uint32_t)(input[37] & 0x0f) << 28) |
			((uint32_t)input[38] << 20) |
			((uint32_t)input[39] << 12) |
			((uint32_t)(input[40] & 0x80) << 4);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 321 to 341
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0xfc) << 9);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 342 to 362
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xe0) << 6);
	output[16] = (double)(value >> 11);
}

static void unpack_17_21bit_unsigned_6off(const uint8_t * input, double * output) {
	// Unpack 17 values into output
	// Values are 21-bit unsigned
	// Skip 6 bits, read 357 bits of data.
	// Input must be at least 46 bytes long

	uint32_t value;

	// read output[0]: from bit 6 to 26
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xe0) << 6);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 27 to 47
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 48 to 68
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)(input[8] & 0xf8) << 8);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 69 to 89
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)input[10] << 13) |
			((uint32_t)(input[11] & 0xc0) << 5);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 90 to 110
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xfe) << 10);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 111 to 131
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)input[15] << 15) |
			((uint32_t)(input[16] & 0xf0) << 7);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 132 to 152
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)input[18] << 12) |
			((uint32_t)(input[19] & 0x80) << 4);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 153 to 173
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xfc) << 9);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 174 to 194
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xe0) << 6);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 195 to 215
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 216 to 236
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)(input[29] & 0xf8) << 8);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 237 to 257
	value = ((uint32_t)(input[29] & 0x07) << 29) |
			((uint32_t)input[30] << 21) |
			((uint32_t)input[31] << 13) |
			((uint32_t)(input[32] & 0xc0) << 5);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 258 to 278
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xfe) << 10);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 279 to 299
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)input[36] << 15) |
			((uint32_t)(input[37] & 0xf0) << 7);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 300 to 320
	value = ((uint32_t)(input[37] & 0x0f) << 28) |
			((uint32_t)input[38] << 20) |
			((uint32_t)input[39] << 12) |
			((uint32_t)(input[40] & 0x80) << 4);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 321 to 341
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0xfc) << 9);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 342 to 362
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xe0) << 6);
	output[16] = (double)(value >> 11);
}

static void unpack_17_21bit_signed_7off(const uint8_t * input, double * output) {
	// Unpack 17 values into output
	// Values are 21-bit signed
	// Skip 7 bits, read 357 bits of data.
	// Input must be at least 46 bytes long

	int32_t value;

	// read output[0]: from bit 7 to 27
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xf0) << 7);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 28 to 48
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0x80) << 4);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 49 to 69
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0xfc) << 9);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 70 to 90
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)input[10] << 14) |
			((uint32_t)(input[11] & 0xe0) << 6);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 91 to 111
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)input[13] << 11);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 112 to 132
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16) |
			((uint32_t)(input[16] & 0xf8) << 8);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 133 to 153
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)input[18] << 13) |
			((uint32_t)(input[19] & 0xc0) << 5);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 154 to 174
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xfe) << 10);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 175 to 195
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xf0) << 7);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 196 to 216
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0x80) << 4);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 217 to 237
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)(input[29] & 0xfc) << 9);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 238 to 258
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)input[31] << 14) |
			((uint32_t)(input[32] & 0xe0) << 6);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 259 to 279
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)input[34] << 11);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 280 to 300
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)input[36] << 16) |
			((uint32_t)(input[37] & 0xf8) << 8);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 301 to 321
	value = ((uint32_t)(input[37] & 0x07) << 29) |
			((uint32_t)input[38] << 21) |
			((uint32_t)input[39] << 13) |
			((uint32_t)(input[40] & 0xc0) << 5);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 322 to 342
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xfe) << 10);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 343 to 363
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xf0) << 7);
	output[16] = (double)(value >> 11);
}

static void unpack_17_21bit_unsigned_7off(const uint8_t * input, double * output) {
	// Unpack 17 values into output
	// Values are 21-bit unsigned
	// Skip 7 bits, read 357 bits of data.
	// Input must be at least 46 bytes long

	uint32_t value;

	// read output[0]: from bit 7 to 27
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xf0) << 7);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 28 to 48
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0x80) << 4);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 49 to 69
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0xfc) << 9);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 70 to 90
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)input[10] << 14) |
			((uint32_t)(input[11] & 0xe0) << 6);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 91 to 111
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)input[13] << 11);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 112 to 132
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16) |
			((uint32_t)(input[16] & 0xf8) << 8);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 133 to 153
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)input[18] << 13) |
			((uint32_t)(input[19] & 0xc0) << 5);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 154 to 174
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xfe) << 10);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 175 to 195
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xf0) << 7);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 196 to 216
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0x80) << 4);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 217 to 237
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)(input[29] & 0xfc) << 9);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 238 to 258
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)input[31] << 14) |
			((uint32_t)(input[32] & 0xe0) << 6);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 259 to 279
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)input[34] << 11);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 280 to 300
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)input[36] << 16) |
			((uint32_t)(input[37] & 0xf8) << 8);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 301 to 321
	value = ((uint32_t)(input[37] & 0x07) << 29) |
			((uint32_t)input[38] << 21) |
			((uint32_t)input[39] << 13) |
			((uint32_t)(input[40] & 0xc0) << 5);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 322 to 342
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xfe) << 10);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 343 to 363
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xf0) << 7);
	output[16] = (double)(value >> 11);
}

static void unpack_18_21bit_signed_0off(const uint8_t * input, double * output) {
	// Unpack 18 values into output
	// Values are 21-bit signed
	// Skip 0 bits, read 378 bits of data.
	// Input must be at least 48 bytes long

	int32_t value;

	// read output[0]: from bit 0 to 20
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0xf8) << 8);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 21 to 41
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)input[4] << 13) |
			((uint32_t)(input[5] & 0xc0) << 5);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 42 to 62
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)input[6] << 18) |
			((uint32_t)(input[7] & 0xfe) << 10);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 63 to 83
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)input[9] << 15) |
			((uint32_t)(input[10] & 0xf0) << 7);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 84 to 104
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)input[12] << 12) |
			((uint32_t)(input[13] & 0x80) << 4);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 105 to 125
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xfc) << 9);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 126 to 146
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xe0) << 6);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 147 to 167
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 168 to 188
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)(input[23] & 0xf8) << 8);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 189 to 209
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)input[25] << 13) |
			((uint32_t)(input[26] & 0xc0) << 5);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 210 to 230
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xfe) << 10);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 231 to 251
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)input[30] << 15) |
			((uint32_t)(input[31] & 0xf0) << 7);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 252 to 272
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20) |
			((uint32_t)input[33] << 12) |
			((uint32_t)(input[34] & 0x80) << 4);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 273 to 293
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0xfc) << 9);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 294 to 314
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xe0) << 6);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 315 to 335
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 336 to 356
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)(input[44] & 0xf8) << 8);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 357 to 377
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)input[46] << 13) |
			((uint32_t)(input[47] & 0xc0) << 5);
	output[17] = (double)(value >> 11);
}

static void unpack_18_21bit_unsigned_0off(const uint8_t * input, double * output) {
	// Unpack 18 values into output
	// Values are 21-bit unsigned
	// Skip 0 bits, read 378 bits of data.
	// Input must be at least 48 bytes long

	uint32_t value;

	// read output[0]: from bit 0 to 20
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0xf8) << 8);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 21 to 41
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)input[4] << 13) |
			((uint32_t)(input[5] & 0xc0) << 5);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 42 to 62
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)input[6] << 18) |
			((uint32_t)(input[7] & 0xfe) << 10);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 63 to 83
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)input[9] << 15) |
			((uint32_t)(input[10] & 0xf0) << 7);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 84 to 104
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)input[12] << 12) |
			((uint32_t)(input[13] & 0x80) << 4);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 105 to 125
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xfc) << 9);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 126 to 146
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xe0) << 6);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 147 to 167
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 168 to 188
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)(input[23] & 0xf8) << 8);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 189 to 209
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)input[25] << 13) |
			((uint32_t)(input[26] & 0xc0) << 5);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 210 to 230
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xfe) << 10);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 231 to 251
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)input[30] << 15) |
			((uint32_t)(input[31] & 0xf0) << 7);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 252 to 272
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20) |
			((uint32_t)input[33] << 12) |
			((uint32_t)(input[34] & 0x80) << 4);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 273 to 293
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0xfc) << 9);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 294 to 314
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xe0) << 6);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 315 to 335
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 336 to 356
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)(input[44] & 0xf8) << 8);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 357 to 377
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)input[46] << 13) |
			((uint32_t)(input[47] & 0xc0) << 5);
	output[17] = (double)(value >> 11);
}

static void unpack_18_21bit_signed_1off(const uint8_t * input, double * output) {
	// Unpack 18 values into output
	// Values are 21-bit signed
	// Skip 1 bits, read 378 bits of data.
	// Input must be at least 48 bytes long

	int32_t value;

	// read output[0]: from bit 1 to 21
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xfc) << 9);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 22 to 42
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)input[4] << 14) |
			((uint32_t)(input[5] & 0xe0) << 6);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 43 to 63
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)input[6] << 19) |
			((uint32_t)input[7] << 11);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 64 to 84
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16) |
			((uint32_t)(input[10] & 0xf8) << 8);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 85 to 105
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)input[12] << 13) |
			((uint32_t)(input[13] & 0xc0) << 5);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 106 to 126
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xfe) << 10);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 127 to 147
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xf0) << 7);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 148 to 168
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0x80) << 4);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 169 to 189
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)(input[23] & 0xfc) << 9);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 190 to 210
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)input[25] << 14) |
			((uint32_t)(input[26] & 0xe0) << 6);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 211 to 231
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)input[28] << 11);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 232 to 252
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)input[30] << 16) |
			((uint32_t)(input[31] & 0xf8) << 8);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 253 to 273
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)input[33] << 13) |
			((uint32_t)(input[34] & 0xc0) << 5);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 274 to 294
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xfe) << 10);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 295 to 315
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xf0) << 7);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 316 to 336
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0x80) << 4);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 337 to 357
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0xfc) << 9);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 358 to 378
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)input[46] << 14) |
			((uint32_t)(input[47] & 0xe0) << 6);
	output[17] = (double)(value >> 11);
}

static void unpack_18_21bit_unsigned_1off(const uint8_t * input, double * output) {
	// Unpack 18 values into output
	// Values are 21-bit unsigned
	// Skip 1 bits, read 378 bits of data.
	// Input must be at least 48 bytes long

	uint32_t value;

	// read output[0]: from bit 1 to 21
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xfc) << 9);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 22 to 42
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)input[4] << 14) |
			((uint32_t)(input[5] & 0xe0) << 6);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 43 to 63
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)input[6] << 19) |
			((uint32_t)input[7] << 11);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 64 to 84
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16) |
			((uint32_t)(input[10] & 0xf8) << 8);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 85 to 105
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)input[12] << 13) |
			((uint32_t)(input[13] & 0xc0) << 5);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 106 to 126
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xfe) << 10);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 127 to 147
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xf0) << 7);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 148 to 168
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0x80) << 4);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 169 to 189
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)(input[23] & 0xfc) << 9);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 190 to 210
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)input[25] << 14) |
			((uint32_t)(input[26] & 0xe0) << 6);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 211 to 231
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)input[28] << 11);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 232 to 252
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)input[30] << 16) |
			((uint32_t)(input[31] & 0xf8) << 8);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 253 to 273
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)input[33] << 13) |
			((uint32_t)(input[34] & 0xc0) << 5);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 274 to 294
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xfe) << 10);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 295 to 315
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xf0) << 7);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 316 to 336
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0x80) << 4);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 337 to 357
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0xfc) << 9);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 358 to 378
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)input[46] << 14) |
			((uint32_t)(input[47] & 0xe0) << 6);
	output[17] = (double)(value >> 11);
}

static void unpack_18_21bit_signed_2off(const uint8_t * input, double * output) {
	// Unpack 18 values into output
	// Values are 21-bit signed
	// Skip 2 bits, read 378 bits of data.
	// Input must be at least 48 bytes long

	int32_t value;

	// read output[0]: from bit 2 to 22
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xfe) << 10);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 23 to 43
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15) |
			((uint32_t)(input[5] & 0xf0) << 7);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 44 to 64
	value = ((uint32_t)(input[5] & 0x0f) << 28) |
			((uint32_t)input[6] << 20) |
			((uint32_t)input[7] << 12) |
			((uint32_t)(input[8] & 0x80) << 4);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 65 to 85
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0xfc) << 9);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 86 to 106
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)input[12] << 14) |
			((uint32_t)(input[13] & 0xe0) << 6);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 107 to 127
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)input[15] << 11);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 128 to 148
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16) |
			((uint32_t)(input[18] & 0xf8) << 8);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 149 to 169
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xc0) << 5);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 170 to 190
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xfe) << 10);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 191 to 211
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15) |
			((uint32_t)(input[26] & 0xf0) << 7);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 212 to 232
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)input[28] << 12) |
			((uint32_t)(input[29] & 0x80) << 4);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 233 to 253
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)input[30] << 17) |
			((uint32_t)(input[31] & 0xfc) << 9);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 254 to 274
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)input[33] << 14) |
			((uint32_t)(input[34] & 0xe0) << 6);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 275 to 295
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)input[36] << 11);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 296 to 316
	value = ((uint32_t)input[37] << 24) |
			((uint32_t)input[38] << 16) |
			((uint32_t)(input[39] & 0xf8) << 8);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 317 to 337
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xc0) << 5);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 338 to 358
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xfe) << 10);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 359 to 379
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)input[46] << 15) |
			((uint32_t)(input[47] & 0xf0) << 7);
	output[17] = (double)(value >> 11);
}

static void unpack_18_21bit_unsigned_2off(const uint8_t * input, double * output) {
	// Unpack 18 values into output
	// Values are 21-bit unsigned
	// Skip 2 bits, read 378 bits of data.
	// Input must be at least 48 bytes long

	uint32_t value;

	// read output[0]: from bit 2 to 22
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xfe) << 10);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 23 to 43
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15) |
			((uint32_t)(input[5] & 0xf0) << 7);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 44 to 64
	value = ((uint32_t)(input[5] & 0x0f) << 28) |
			((uint32_t)input[6] << 20) |
			((uint32_t)input[7] << 12) |
			((uint32_t)(input[8] & 0x80) << 4);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 65 to 85
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0xfc) << 9);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 86 to 106
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)input[12] << 14) |
			((uint32_t)(input[13] & 0xe0) << 6);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 107 to 127
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)input[15] << 11);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 128 to 148
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16) |
			((uint32_t)(input[18] & 0xf8) << 8);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 149 to 169
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xc0) << 5);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 170 to 190
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xfe) << 10);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 191 to 211
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15) |
			((uint32_t)(input[26] & 0xf0) << 7);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 212 to 232
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)input[28] << 12) |
			((uint32_t)(input[29] & 0x80) << 4);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 233 to 253
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)input[30] << 17) |
			((uint32_t)(input[31] & 0xfc) << 9);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 254 to 274
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)input[33] << 14) |
			((uint32_t)(input[34] & 0xe0) << 6);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 275 to 295
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)input[36] << 11);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 296 to 316
	value = ((uint32_t)input[37] << 24) |
			((uint32_t)input[38] << 16) |
			((uint32_t)(input[39] & 0xf8) << 8);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 317 to 337
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xc0) << 5);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 338 to 358
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xfe) << 10);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 359 to 379
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)input[46] << 15) |
			((uint32_t)(input[47] & 0xf0) << 7);
	output[17] = (double)(value >> 11);
}

static void unpack_18_21bit_signed_3off(const uint8_t * input, double * output) {
	// Unpack 18 values into output
	// Values are 21-bit signed
	// Skip 3 bits, read 378 bits of data.
	// Input must be at least 48 bytes long

	int32_t value;

	// read output[0]: from bit 3 to 23
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 24 to 44
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0xf8) << 8);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 45 to 65
	value = ((uint32_t)(input[5] & 0x07) << 29) |
			((uint32_t)input[6] << 21) |
			((uint32_t)input[7] << 13) |
			((uint32_t)(input[8] & 0xc0) << 5);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 66 to 86
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xfe) << 10);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 87 to 107
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15) |
			((uint32_t)(input[13] & 0xf0) << 7);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 108 to 128
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)input[15] << 12) |
			((uint32_t)(input[16] & 0x80) << 4);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 129 to 149
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0xfc) << 9);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 150 to 170
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xe0) << 6);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 171 to 191
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 192 to 212
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0xf8) << 8);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 213 to 233
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)input[28] << 13) |
			((uint32_t)(input[29] & 0xc0) << 5);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 234 to 254
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)input[30] << 18) |
			((uint32_t)(input[31] & 0xfe) << 10);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 255 to 275
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)input[33] << 15) |
			((uint32_t)(input[34] & 0xf0) << 7);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 276 to 296
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)input[36] << 12) |
			((uint32_t)(input[37] & 0x80) << 4);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 297 to 317
	value = ((uint32_t)(input[37] & 0x7f) << 25) |
			((uint32_t)input[38] << 17) |
			((uint32_t)(input[39] & 0xfc) << 9);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 318 to 338
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xe0) << 6);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 339 to 359
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 360 to 380
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)(input[47] & 0xf8) << 8);
	output[17] = (double)(value >> 11);
}

static void unpack_18_21bit_unsigned_3off(const uint8_t * input, double * output) {
	// Unpack 18 values into output
	// Values are 21-bit unsigned
	// Skip 3 bits, read 378 bits of data.
	// Input must be at least 48 bytes long

	uint32_t value;

	// read output[0]: from bit 3 to 23
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 24 to 44
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0xf8) << 8);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 45 to 65
	value = ((uint32_t)(input[5] & 0x07) << 29) |
			((uint32_t)input[6] << 21) |
			((uint32_t)input[7] << 13) |
			((uint32_t)(input[8] & 0xc0) << 5);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 66 to 86
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xfe) << 10);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 87 to 107
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15) |
			((uint32_t)(input[13] & 0xf0) << 7);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 108 to 128
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)input[15] << 12) |
			((uint32_t)(input[16] & 0x80) << 4);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 129 to 149
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0xfc) << 9);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 150 to 170
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xe0) << 6);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 171 to 191
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 192 to 212
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0xf8) << 8);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 213 to 233
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)input[28] << 13) |
			((uint32_t)(input[29] & 0xc0) << 5);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 234 to 254
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)input[30] << 18) |
			((uint32_t)(input[31] & 0xfe) << 10);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 255 to 275
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)input[33] << 15) |
			((uint32_t)(input[34] & 0xf0) << 7);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 276 to 296
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)input[36] << 12) |
			((uint32_t)(input[37] & 0x80) << 4);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 297 to 317
	value = ((uint32_t)(input[37] & 0x7f) << 25) |
			((uint32_t)input[38] << 17) |
			((uint32_t)(input[39] & 0xfc) << 9);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 318 to 338
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xe0) << 6);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 339 to 359
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 360 to 380
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)(input[47] & 0xf8) << 8);
	output[17] = (double)(value >> 11);
}

static void unpack_18_21bit_signed_4off(const uint8_t * input, double * output) {
	// Unpack 18 values into output
	// Values are 21-bit signed
	// Skip 4 bits, read 378 bits of data.
	// Input must be at least 48 bytes long

	int32_t value;

	// read output[0]: from bit 4 to 24
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0x80) << 4);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 25 to 45
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)(input[5] & 0xfc) << 9);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 46 to 66
	value = ((uint32_t)(input[5] & 0x03) << 30) |
			((uint32_t)input[6] << 22) |
			((uint32_t)input[7] << 14) |
			((uint32_t)(input[8] & 0xe0) << 6);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 67 to 87
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)input[10] << 11);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 88 to 108
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0xf8) << 8);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 109 to 129
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)input[15] << 13) |
			((uint32_t)(input[16] & 0xc0) << 5);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 130 to 150
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xfe) << 10);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 151 to 171
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xf0) << 7);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 172 to 192
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0x80) << 4);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 193 to 213
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xfc) << 9);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 214 to 234
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)input[28] << 14) |
			((uint32_t)(input[29] & 0xe0) << 6);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 235 to 255
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)input[30] << 19) |
			((uint32_t)input[31] << 11);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 256 to 276
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16) |
			((uint32_t)(input[34] & 0xf8) << 8);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 277 to 297
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)input[36] << 13) |
			((uint32_t)(input[37] & 0xc0) << 5);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 298 to 318
	value = ((uint32_t)(input[37] & 0x3f) << 26) |
			((uint32_t)input[38] << 18) |
			((uint32_t)(input[39] & 0xfe) << 10);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 319 to 339
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xf0) << 7);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 340 to 360
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0x80) << 4);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 361 to 381
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)(input[47] & 0xfc) << 9);
	output[17] = (double)(value >> 11);
}

static void unpack_18_21bit_unsigned_4off(const uint8_t * input, double * output) {
	// Unpack 18 values into output
	// Values are 21-bit unsigned
	// Skip 4 bits, read 378 bits of data.
	// Input must be at least 48 bytes long

	uint32_t value;

	// read output[0]: from bit 4 to 24
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0x80) << 4);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 25 to 45
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)(input[5] & 0xfc) << 9);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 46 to 66
	value = ((uint32_t)(input[5] & 0x03) << 30) |
			((uint32_t)input[6] << 22) |
			((uint32_t)input[7] << 14) |
			((uint32_t)(input[8] & 0xe0) << 6);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 67 to 87
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)input[10] << 11);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 88 to 108
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0xf8) << 8);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 109 to 129
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)input[15] << 13) |
			((uint32_t)(input[16] & 0xc0) << 5);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 130 to 150
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xfe) << 10);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 151 to 171
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xf0) << 7);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 172 to 192
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0x80) << 4);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 193 to 213
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xfc) << 9);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 214 to 234
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)input[28] << 14) |
			((uint32_t)(input[29] & 0xe0) << 6);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 235 to 255
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)input[30] << 19) |
			((uint32_t)input[31] << 11);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 256 to 276
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16) |
			((uint32_t)(input[34] & 0xf8) << 8);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 277 to 297
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)input[36] << 13) |
			((uint32_t)(input[37] & 0xc0) << 5);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 298 to 318
	value = ((uint32_t)(input[37] & 0x3f) << 26) |
			((uint32_t)input[38] << 18) |
			((uint32_t)(input[39] & 0xfe) << 10);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 319 to 339
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xf0) << 7);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 340 to 360
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0x80) << 4);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 361 to 381
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)(input[47] & 0xfc) << 9);
	output[17] = (double)(value >> 11);
}

static void unpack_18_21bit_signed_5off(const uint8_t * input, double * output) {
	// Unpack 18 values into output
	// Values are 21-bit signed
	// Skip 5 bits, read 378 bits of data.
	// Input must be at least 48 bytes long

	int32_t value;

	// read output[0]: from bit 5 to 25
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xc0) << 5);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 26 to 46
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)(input[5] & 0xfe) << 10);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 47 to 67
	value = ((uint32_t)(input[5] & 0x01) << 31) |
			((uint32_t)input[6] << 23) |
			((uint32_t)input[7] << 15) |
			((uint32_t)(input[8] & 0xf0) << 7);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 68 to 88
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)input[10] << 12) |
			((uint32_t)(input[11] & 0x80) << 4);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 89 to 109
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xfc) << 9);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 110 to 130
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)input[15] << 14) |
			((uint32_t)(input[16] & 0xe0) << 6);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 131 to 151
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)input[18] << 11);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 152 to 172
	value = ((uint32_t)input[19] << 24) |
			((uint32_t)input[20] << 16) |
			((uint32_t)(input[21] & 0xf8) << 8);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 173 to 193
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xc0) << 5);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 194 to 214
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xfe) << 10);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 215 to 235
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)input[28] << 15) |
			((uint32_t)(input[29] & 0xf0) << 7);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 236 to 256
	value = ((uint32_t)(input[29] & 0x0f) << 28) |
			((uint32_t)input[30] << 20) |
			((uint32_t)input[31] << 12) |
			((uint32_t)(input[32] & 0x80) << 4);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 257 to 277
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0xfc) << 9);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 278 to 298
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)input[36] << 14) |
			((uint32_t)(input[37] & 0xe0) << 6);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 299 to 319
	value = ((uint32_t)(input[37] & 0x1f) << 27) |
			((uint32_t)input[38] << 19) |
			((uint32_t)input[39] << 11);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 320 to 340
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16) |
			((uint32_t)(input[42] & 0xf8) << 8);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 341 to 361
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xc0) << 5);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 362 to 382
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)(input[47] & 0xfe) << 10);
	output[17] = (double)(value >> 11);
}

static void unpack_18_21bit_unsigned_5off(const uint8_t * input, double * output) {
	// Unpack 18 values into output
	// Values are 21-bit unsigned
	// Skip 5 bits, read 378 bits of data.
	// Input must be at least 48 bytes long

	uint32_t value;

	// read output[0]: from bit 5 to 25
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xc0) << 5);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 26 to 46
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)(input[5] & 0xfe) << 10);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 47 to 67
	value = ((uint32_t)(input[5] & 0x01) << 31) |
			((uint32_t)input[6] << 23) |
			((uint32_t)input[7] << 15) |
			((uint32_t)(input[8] & 0xf0) << 7);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 68 to 88
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)input[10] << 12) |
			((uint32_t)(input[11] & 0x80) << 4);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 89 to 109
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xfc) << 9);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 110 to 130
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)input[15] << 14) |
			((uint32_t)(input[16] & 0xe0) << 6);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 131 to 151
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)input[18] << 11);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 152 to 172
	value = ((uint32_t)input[19] << 24) |
			((uint32_t)input[20] << 16) |
			((uint32_t)(input[21] & 0xf8) << 8);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 173 to 193
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xc0) << 5);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 194 to 214
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xfe) << 10);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 215 to 235
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)input[28] << 15) |
			((uint32_t)(input[29] & 0xf0) << 7);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 236 to 256
	value = ((uint32_t)(input[29] & 0x0f) << 28) |
			((uint32_t)input[30] << 20) |
			((uint32_t)input[31] << 12) |
			((uint32_t)(input[32] & 0x80) << 4);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 257 to 277
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0xfc) << 9);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 278 to 298
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)input[36] << 14) |
			((uint32_t)(input[37] & 0xe0) << 6);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 299 to 319
	value = ((uint32_t)(input[37] & 0x1f) << 27) |
			((uint32_t)input[38] << 19) |
			((uint32_t)input[39] << 11);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 320 to 340
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16) |
			((uint32_t)(input[42] & 0xf8) << 8);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 341 to 361
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xc0) << 5);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 362 to 382
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)(input[47] & 0xfe) << 10);
	output[17] = (double)(value >> 11);
}

static void unpack_18_21bit_signed_6off(const uint8_t * input, double * output) {
	// Unpack 18 values into output
	// Values are 21-bit signed
	// Skip 6 bits, read 378 bits of data.
	// Input must be at least 48 bytes long

	int32_t value;

	// read output[0]: from bit 6 to 26
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xe0) << 6);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 27 to 47
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 48 to 68
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)(input[8] & 0xf8) << 8);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 69 to 89
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)input[10] << 13) |
			((uint32_t)(input[11] & 0xc0) << 5);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 90 to 110
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xfe) << 10);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 111 to 131
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)input[15] << 15) |
			((uint32_t)(input[16] & 0xf0) << 7);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 132 to 152
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)input[18] << 12) |
			((uint32_t)(input[19] & 0x80) << 4);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 153 to 173
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xfc) << 9);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 174 to 194
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xe0) << 6);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 195 to 215
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 216 to 236
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)(input[29] & 0xf8) << 8);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 237 to 257
	value = ((uint32_t)(input[29] & 0x07) << 29) |
			((uint32_t)input[30] << 21) |
			((uint32_t)input[31] << 13) |
			((uint32_t)(input[32] & 0xc0) << 5);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 258 to 278
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xfe) << 10);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 279 to 299
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)input[36] << 15) |
			((uint32_t)(input[37] & 0xf0) << 7);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 300 to 320
	value = ((uint32_t)(input[37] & 0x0f) << 28) |
			((uint32_t)input[38] << 20) |
			((uint32_t)input[39] << 12) |
			((uint32_t)(input[40] & 0x80) << 4);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 321 to 341
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0xfc) << 9);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 342 to 362
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xe0) << 6);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 363 to 383
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11);
	output[17] = (double)(value >> 11);
}

static void unpack_18_21bit_unsigned_6off(const uint8_t * input, double * output) {
	// Unpack 18 values into output
	// Values are 21-bit unsigned
	// Skip 6 bits, read 378 bits of data.
	// Input must be at least 48 bytes long

	uint32_t value;

	// read output[0]: from bit 6 to 26
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xe0) << 6);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 27 to 47
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 48 to 68
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)(input[8] & 0xf8) << 8);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 69 to 89
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)input[10] << 13) |
			((uint32_t)(input[11] & 0xc0) << 5);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 90 to 110
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xfe) << 10);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 111 to 131
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)input[15] << 15) |
			((uint32_t)(input[16] & 0xf0) << 7);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 132 to 152
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)input[18] << 12) |
			((uint32_t)(input[19] & 0x80) << 4);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 153 to 173
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xfc) << 9);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 174 to 194
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xe0) << 6);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 195 to 215
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 216 to 236
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)(input[29] & 0xf8) << 8);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 237 to 257
	value = ((uint32_t)(input[29] & 0x07) << 29) |
			((uint32_t)input[30] << 21) |
			((uint32_t)input[31] << 13) |
			((uint32_t)(input[32] & 0xc0) << 5);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 258 to 278
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xfe) << 10);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 279 to 299
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)input[36] << 15) |
			((uint32_t)(input[37] & 0xf0) << 7);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 300 to 320
	value = ((uint32_t)(input[37] & 0x0f) << 28) |
			((uint32_t)input[38] << 20) |
			((uint32_t)input[39] << 12) |
			((uint32_t)(input[40] & 0x80) << 4);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 321 to 341
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0xfc) << 9);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 342 to 362
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xe0) << 6);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 363 to 383
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11);
	output[17] = (double)(value >> 11);
}

static void unpack_18_21bit_signed_7off(const uint8_t * input, double * output) {
	// Unpack 18 values into output
	// Values are 21-bit signed
	// Skip 7 bits, read 378 bits of data.
	// Input must be at least 49 bytes long

	int32_t value;

	// read output[0]: from bit 7 to 27
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xf0) << 7);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 28 to 48
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0x80) << 4);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 49 to 69
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0xfc) << 9);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 70 to 90
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)input[10] << 14) |
			((uint32_t)(input[11] & 0xe0) << 6);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 91 to 111
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)input[13] << 11);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 112 to 132
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16) |
			((uint32_t)(input[16] & 0xf8) << 8);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 133 to 153
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)input[18] << 13) |
			((uint32_t)(input[19] & 0xc0) << 5);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 154 to 174
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xfe) << 10);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 175 to 195
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xf0) << 7);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 196 to 216
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0x80) << 4);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 217 to 237
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)(input[29] & 0xfc) << 9);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 238 to 258
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)input[31] << 14) |
			((uint32_t)(input[32] & 0xe0) << 6);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 259 to 279
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)input[34] << 11);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 280 to 300
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)input[36] << 16) |
			((uint32_t)(input[37] & 0xf8) << 8);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 301 to 321
	value = ((uint32_t)(input[37] & 0x07) << 29) |
			((uint32_t)input[38] << 21) |
			((uint32_t)input[39] << 13) |
			((uint32_t)(input[40] & 0xc0) << 5);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 322 to 342
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xfe) << 10);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 343 to 363
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xf0) << 7);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 364 to 384
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0x80) << 4);
	output[17] = (double)(value >> 11);
}

static void unpack_18_21bit_unsigned_7off(const uint8_t * input, double * output) {
	// Unpack 18 values into output
	// Values are 21-bit unsigned
	// Skip 7 bits, read 378 bits of data.
	// Input must be at least 49 bytes long

	uint32_t value;

	// read output[0]: from bit 7 to 27
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xf0) << 7);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 28 to 48
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0x80) << 4);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 49 to 69
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0xfc) << 9);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 70 to 90
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)input[10] << 14) |
			((uint32_t)(input[11] & 0xe0) << 6);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 91 to 111
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)input[13] << 11);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 112 to 132
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16) |
			((uint32_t)(input[16] & 0xf8) << 8);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 133 to 153
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)input[18] << 13) |
			((uint32_t)(input[19] & 0xc0) << 5);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 154 to 174
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xfe) << 10);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 175 to 195
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xf0) << 7);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 196 to 216
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0x80) << 4);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 217 to 237
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)(input[29] & 0xfc) << 9);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 238 to 258
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)input[31] << 14) |
			((uint32_t)(input[32] & 0xe0) << 6);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 259 to 279
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)input[34] << 11);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 280 to 300
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)input[36] << 16) |
			((uint32_t)(input[37] & 0xf8) << 8);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 301 to 321
	value = ((uint32_t)(input[37] & 0x07) << 29) |
			((uint32_t)input[38] << 21) |
			((uint32_t)input[39] << 13) |
			((uint32_t)(input[40] & 0xc0) << 5);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 322 to 342
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xfe) << 10);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 343 to 363
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xf0) << 7);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 364 to 384
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0x80) << 4);
	output[17] = (double)(value >> 11);
}

static void unpack_19_21bit_signed_0off(const uint8_t * input, double * output) {
	// Unpack 19 values into output
	// Values are 21-bit signed
	// Skip 0 bits, read 399 bits of data.
	// Input must be at least 50 bytes long

	int32_t value;

	// read output[0]: from bit 0 to 20
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0xf8) << 8);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 21 to 41
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)input[4] << 13) |
			((uint32_t)(input[5] & 0xc0) << 5);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 42 to 62
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)input[6] << 18) |
			((uint32_t)(input[7] & 0xfe) << 10);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 63 to 83
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)input[9] << 15) |
			((uint32_t)(input[10] & 0xf0) << 7);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 84 to 104
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)input[12] << 12) |
			((uint32_t)(input[13] & 0x80) << 4);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 105 to 125
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xfc) << 9);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 126 to 146
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xe0) << 6);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 147 to 167
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 168 to 188
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)(input[23] & 0xf8) << 8);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 189 to 209
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)input[25] << 13) |
			((uint32_t)(input[26] & 0xc0) << 5);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 210 to 230
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xfe) << 10);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 231 to 251
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)input[30] << 15) |
			((uint32_t)(input[31] & 0xf0) << 7);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 252 to 272
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20) |
			((uint32_t)input[33] << 12) |
			((uint32_t)(input[34] & 0x80) << 4);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 273 to 293
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0xfc) << 9);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 294 to 314
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xe0) << 6);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 315 to 335
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 336 to 356
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)(input[44] & 0xf8) << 8);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 357 to 377
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)input[46] << 13) |
			((uint32_t)(input[47] & 0xc0) << 5);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 378 to 398
	value = ((uint32_t)(input[47] & 0x3f) << 26) |
			((uint32_t)input[48] << 18) |
			((uint32_t)(input[49] & 0xfe) << 10);
	output[18] = (double)(value >> 11);
}

static void unpack_19_21bit_unsigned_0off(const uint8_t * input, double * output) {
	// Unpack 19 values into output
	// Values are 21-bit unsigned
	// Skip 0 bits, read 399 bits of data.
	// Input must be at least 50 bytes long

	uint32_t value;

	// read output[0]: from bit 0 to 20
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0xf8) << 8);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 21 to 41
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)input[4] << 13) |
			((uint32_t)(input[5] & 0xc0) << 5);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 42 to 62
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)input[6] << 18) |
			((uint32_t)(input[7] & 0xfe) << 10);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 63 to 83
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)input[9] << 15) |
			((uint32_t)(input[10] & 0xf0) << 7);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 84 to 104
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)input[12] << 12) |
			((uint32_t)(input[13] & 0x80) << 4);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 105 to 125
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xfc) << 9);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 126 to 146
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xe0) << 6);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 147 to 167
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 168 to 188
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)(input[23] & 0xf8) << 8);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 189 to 209
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)input[25] << 13) |
			((uint32_t)(input[26] & 0xc0) << 5);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 210 to 230
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xfe) << 10);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 231 to 251
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)input[30] << 15) |
			((uint32_t)(input[31] & 0xf0) << 7);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 252 to 272
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20) |
			((uint32_t)input[33] << 12) |
			((uint32_t)(input[34] & 0x80) << 4);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 273 to 293
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0xfc) << 9);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 294 to 314
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xe0) << 6);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 315 to 335
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 336 to 356
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)(input[44] & 0xf8) << 8);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 357 to 377
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)input[46] << 13) |
			((uint32_t)(input[47] & 0xc0) << 5);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 378 to 398
	value = ((uint32_t)(input[47] & 0x3f) << 26) |
			((uint32_t)input[48] << 18) |
			((uint32_t)(input[49] & 0xfe) << 10);
	output[18] = (double)(value >> 11);
}

static void unpack_19_21bit_signed_1off(const uint8_t * input, double * output) {
	// Unpack 19 values into output
	// Values are 21-bit signed
	// Skip 1 bits, read 399 bits of data.
	// Input must be at least 50 bytes long

	int32_t value;

	// read output[0]: from bit 1 to 21
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xfc) << 9);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 22 to 42
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)input[4] << 14) |
			((uint32_t)(input[5] & 0xe0) << 6);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 43 to 63
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)input[6] << 19) |
			((uint32_t)input[7] << 11);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 64 to 84
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16) |
			((uint32_t)(input[10] & 0xf8) << 8);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 85 to 105
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)input[12] << 13) |
			((uint32_t)(input[13] & 0xc0) << 5);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 106 to 126
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xfe) << 10);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 127 to 147
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xf0) << 7);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 148 to 168
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0x80) << 4);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 169 to 189
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)(input[23] & 0xfc) << 9);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 190 to 210
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)input[25] << 14) |
			((uint32_t)(input[26] & 0xe0) << 6);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 211 to 231
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)input[28] << 11);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 232 to 252
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)input[30] << 16) |
			((uint32_t)(input[31] & 0xf8) << 8);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 253 to 273
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)input[33] << 13) |
			((uint32_t)(input[34] & 0xc0) << 5);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 274 to 294
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xfe) << 10);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 295 to 315
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xf0) << 7);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 316 to 336
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0x80) << 4);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 337 to 357
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0xfc) << 9);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 358 to 378
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)input[46] << 14) |
			((uint32_t)(input[47] & 0xe0) << 6);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 379 to 399
	value = ((uint32_t)(input[47] & 0x1f) << 27) |
			((uint32_t)input[48] << 19) |
			((uint32_t)input[49] << 11);
	output[18] = (double)(value >> 11);
}

static void unpack_19_21bit_unsigned_1off(const uint8_t * input, double * output) {
	// Unpack 19 values into output
	// Values are 21-bit unsigned
	// Skip 1 bits, read 399 bits of data.
	// Input must be at least 50 bytes long

	uint32_t value;

	// read output[0]: from bit 1 to 21
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xfc) << 9);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 22 to 42
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)input[4] << 14) |
			((uint32_t)(input[5] & 0xe0) << 6);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 43 to 63
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)input[6] << 19) |
			((uint32_t)input[7] << 11);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 64 to 84
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16) |
			((uint32_t)(input[10] & 0xf8) << 8);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 85 to 105
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)input[12] << 13) |
			((uint32_t)(input[13] & 0xc0) << 5);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 106 to 126
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xfe) << 10);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 127 to 147
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xf0) << 7);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 148 to 168
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0x80) << 4);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 169 to 189
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)(input[23] & 0xfc) << 9);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 190 to 210
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)input[25] << 14) |
			((uint32_t)(input[26] & 0xe0) << 6);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 211 to 231
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)input[28] << 11);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 232 to 252
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)input[30] << 16) |
			((uint32_t)(input[31] & 0xf8) << 8);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 253 to 273
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)input[33] << 13) |
			((uint32_t)(input[34] & 0xc0) << 5);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 274 to 294
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xfe) << 10);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 295 to 315
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xf0) << 7);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 316 to 336
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0x80) << 4);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 337 to 357
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0xfc) << 9);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 358 to 378
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)input[46] << 14) |
			((uint32_t)(input[47] & 0xe0) << 6);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 379 to 399
	value = ((uint32_t)(input[47] & 0x1f) << 27) |
			((uint32_t)input[48] << 19) |
			((uint32_t)input[49] << 11);
	output[18] = (double)(value >> 11);
}

static void unpack_19_21bit_signed_2off(const uint8_t * input, double * output) {
	// Unpack 19 values into output
	// Values are 21-bit signed
	// Skip 2 bits, read 399 bits of data.
	// Input must be at least 51 bytes long

	int32_t value;

	// read output[0]: from bit 2 to 22
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xfe) << 10);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 23 to 43
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15) |
			((uint32_t)(input[5] & 0xf0) << 7);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 44 to 64
	value = ((uint32_t)(input[5] & 0x0f) << 28) |
			((uint32_t)input[6] << 20) |
			((uint32_t)input[7] << 12) |
			((uint32_t)(input[8] & 0x80) << 4);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 65 to 85
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0xfc) << 9);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 86 to 106
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)input[12] << 14) |
			((uint32_t)(input[13] & 0xe0) << 6);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 107 to 127
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)input[15] << 11);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 128 to 148
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16) |
			((uint32_t)(input[18] & 0xf8) << 8);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 149 to 169
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xc0) << 5);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 170 to 190
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xfe) << 10);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 191 to 211
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15) |
			((uint32_t)(input[26] & 0xf0) << 7);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 212 to 232
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)input[28] << 12) |
			((uint32_t)(input[29] & 0x80) << 4);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 233 to 253
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)input[30] << 17) |
			((uint32_t)(input[31] & 0xfc) << 9);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 254 to 274
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)input[33] << 14) |
			((uint32_t)(input[34] & 0xe0) << 6);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 275 to 295
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)input[36] << 11);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 296 to 316
	value = ((uint32_t)input[37] << 24) |
			((uint32_t)input[38] << 16) |
			((uint32_t)(input[39] & 0xf8) << 8);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 317 to 337
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xc0) << 5);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 338 to 358
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xfe) << 10);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 359 to 379
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)input[46] << 15) |
			((uint32_t)(input[47] & 0xf0) << 7);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 380 to 400
	value = ((uint32_t)(input[47] & 0x0f) << 28) |
			((uint32_t)input[48] << 20) |
			((uint32_t)input[49] << 12) |
			((uint32_t)(input[50] & 0x80) << 4);
	output[18] = (double)(value >> 11);
}

static void unpack_19_21bit_unsigned_2off(const uint8_t * input, double * output) {
	// Unpack 19 values into output
	// Values are 21-bit unsigned
	// Skip 2 bits, read 399 bits of data.
	// Input must be at least 51 bytes long

	uint32_t value;

	// read output[0]: from bit 2 to 22
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xfe) << 10);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 23 to 43
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15) |
			((uint32_t)(input[5] & 0xf0) << 7);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 44 to 64
	value = ((uint32_t)(input[5] & 0x0f) << 28) |
			((uint32_t)input[6] << 20) |
			((uint32_t)input[7] << 12) |
			((uint32_t)(input[8] & 0x80) << 4);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 65 to 85
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0xfc) << 9);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 86 to 106
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)input[12] << 14) |
			((uint32_t)(input[13] & 0xe0) << 6);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 107 to 127
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)input[15] << 11);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 128 to 148
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16) |
			((uint32_t)(input[18] & 0xf8) << 8);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 149 to 169
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xc0) << 5);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 170 to 190
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xfe) << 10);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 191 to 211
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15) |
			((uint32_t)(input[26] & 0xf0) << 7);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 212 to 232
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)input[28] << 12) |
			((uint32_t)(input[29] & 0x80) << 4);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 233 to 253
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)input[30] << 17) |
			((uint32_t)(input[31] & 0xfc) << 9);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 254 to 274
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)input[33] << 14) |
			((uint32_t)(input[34] & 0xe0) << 6);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 275 to 295
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)input[36] << 11);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 296 to 316
	value = ((uint32_t)input[37] << 24) |
			((uint32_t)input[38] << 16) |
			((uint32_t)(input[39] & 0xf8) << 8);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 317 to 337
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xc0) << 5);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 338 to 358
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xfe) << 10);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 359 to 379
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)input[46] << 15) |
			((uint32_t)(input[47] & 0xf0) << 7);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 380 to 400
	value = ((uint32_t)(input[47] & 0x0f) << 28) |
			((uint32_t)input[48] << 20) |
			((uint32_t)input[49] << 12) |
			((uint32_t)(input[50] & 0x80) << 4);
	output[18] = (double)(value >> 11);
}

static void unpack_19_21bit_signed_3off(const uint8_t * input, double * output) {
	// Unpack 19 values into output
	// Values are 21-bit signed
	// Skip 3 bits, read 399 bits of data.
	// Input must be at least 51 bytes long

	int32_t value;

	// read output[0]: from bit 3 to 23
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 24 to 44
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0xf8) << 8);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 45 to 65
	value = ((uint32_t)(input[5] & 0x07) << 29) |
			((uint32_t)input[6] << 21) |
			((uint32_t)input[7] << 13) |
			((uint32_t)(input[8] & 0xc0) << 5);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 66 to 86
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xfe) << 10);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 87 to 107
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15) |
			((uint32_t)(input[13] & 0xf0) << 7);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 108 to 128
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)input[15] << 12) |
			((uint32_t)(input[16] & 0x80) << 4);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 129 to 149
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0xfc) << 9);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 150 to 170
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xe0) << 6);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 171 to 191
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 192 to 212
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0xf8) << 8);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 213 to 233
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)input[28] << 13) |
			((uint32_t)(input[29] & 0xc0) << 5);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 234 to 254
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)input[30] << 18) |
			((uint32_t)(input[31] & 0xfe) << 10);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 255 to 275
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)input[33] << 15) |
			((uint32_t)(input[34] & 0xf0) << 7);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 276 to 296
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)input[36] << 12) |
			((uint32_t)(input[37] & 0x80) << 4);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 297 to 317
	value = ((uint32_t)(input[37] & 0x7f) << 25) |
			((uint32_t)input[38] << 17) |
			((uint32_t)(input[39] & 0xfc) << 9);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 318 to 338
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xe0) << 6);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 339 to 359
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 360 to 380
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)(input[47] & 0xf8) << 8);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 381 to 401
	value = ((uint32_t)(input[47] & 0x07) << 29) |
			((uint32_t)input[48] << 21) |
			((uint32_t)input[49] << 13) |
			((uint32_t)(input[50] & 0xc0) << 5);
	output[18] = (double)(value >> 11);
}

static void unpack_19_21bit_unsigned_3off(const uint8_t * input, double * output) {
	// Unpack 19 values into output
	// Values are 21-bit unsigned
	// Skip 3 bits, read 399 bits of data.
	// Input must be at least 51 bytes long

	uint32_t value;

	// read output[0]: from bit 3 to 23
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 24 to 44
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0xf8) << 8);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 45 to 65
	value = ((uint32_t)(input[5] & 0x07) << 29) |
			((uint32_t)input[6] << 21) |
			((uint32_t)input[7] << 13) |
			((uint32_t)(input[8] & 0xc0) << 5);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 66 to 86
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xfe) << 10);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 87 to 107
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15) |
			((uint32_t)(input[13] & 0xf0) << 7);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 108 to 128
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)input[15] << 12) |
			((uint32_t)(input[16] & 0x80) << 4);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 129 to 149
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0xfc) << 9);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 150 to 170
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xe0) << 6);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 171 to 191
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 192 to 212
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0xf8) << 8);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 213 to 233
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)input[28] << 13) |
			((uint32_t)(input[29] & 0xc0) << 5);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 234 to 254
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)input[30] << 18) |
			((uint32_t)(input[31] & 0xfe) << 10);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 255 to 275
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)input[33] << 15) |
			((uint32_t)(input[34] & 0xf0) << 7);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 276 to 296
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)input[36] << 12) |
			((uint32_t)(input[37] & 0x80) << 4);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 297 to 317
	value = ((uint32_t)(input[37] & 0x7f) << 25) |
			((uint32_t)input[38] << 17) |
			((uint32_t)(input[39] & 0xfc) << 9);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 318 to 338
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xe0) << 6);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 339 to 359
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 360 to 380
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)(input[47] & 0xf8) << 8);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 381 to 401
	value = ((uint32_t)(input[47] & 0x07) << 29) |
			((uint32_t)input[48] << 21) |
			((uint32_t)input[49] << 13) |
			((uint32_t)(input[50] & 0xc0) << 5);
	output[18] = (double)(value >> 11);
}

static void unpack_19_21bit_signed_4off(const uint8_t * input, double * output) {
	// Unpack 19 values into output
	// Values are 21-bit signed
	// Skip 4 bits, read 399 bits of data.
	// Input must be at least 51 bytes long

	int32_t value;

	// read output[0]: from bit 4 to 24
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0x80) << 4);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 25 to 45
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)(input[5] & 0xfc) << 9);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 46 to 66
	value = ((uint32_t)(input[5] & 0x03) << 30) |
			((uint32_t)input[6] << 22) |
			((uint32_t)input[7] << 14) |
			((uint32_t)(input[8] & 0xe0) << 6);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 67 to 87
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)input[10] << 11);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 88 to 108
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0xf8) << 8);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 109 to 129
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)input[15] << 13) |
			((uint32_t)(input[16] & 0xc0) << 5);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 130 to 150
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xfe) << 10);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 151 to 171
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xf0) << 7);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 172 to 192
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0x80) << 4);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 193 to 213
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xfc) << 9);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 214 to 234
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)input[28] << 14) |
			((uint32_t)(input[29] & 0xe0) << 6);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 235 to 255
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)input[30] << 19) |
			((uint32_t)input[31] << 11);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 256 to 276
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16) |
			((uint32_t)(input[34] & 0xf8) << 8);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 277 to 297
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)input[36] << 13) |
			((uint32_t)(input[37] & 0xc0) << 5);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 298 to 318
	value = ((uint32_t)(input[37] & 0x3f) << 26) |
			((uint32_t)input[38] << 18) |
			((uint32_t)(input[39] & 0xfe) << 10);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 319 to 339
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xf0) << 7);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 340 to 360
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0x80) << 4);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 361 to 381
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)(input[47] & 0xfc) << 9);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 382 to 402
	value = ((uint32_t)(input[47] & 0x03) << 30) |
			((uint32_t)input[48] << 22) |
			((uint32_t)input[49] << 14) |
			((uint32_t)(input[50] & 0xe0) << 6);
	output[18] = (double)(value >> 11);
}

static void unpack_19_21bit_unsigned_4off(const uint8_t * input, double * output) {
	// Unpack 19 values into output
	// Values are 21-bit unsigned
	// Skip 4 bits, read 399 bits of data.
	// Input must be at least 51 bytes long

	uint32_t value;

	// read output[0]: from bit 4 to 24
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0x80) << 4);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 25 to 45
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)(input[5] & 0xfc) << 9);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 46 to 66
	value = ((uint32_t)(input[5] & 0x03) << 30) |
			((uint32_t)input[6] << 22) |
			((uint32_t)input[7] << 14) |
			((uint32_t)(input[8] & 0xe0) << 6);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 67 to 87
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)input[10] << 11);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 88 to 108
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0xf8) << 8);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 109 to 129
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)input[15] << 13) |
			((uint32_t)(input[16] & 0xc0) << 5);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 130 to 150
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xfe) << 10);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 151 to 171
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xf0) << 7);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 172 to 192
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0x80) << 4);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 193 to 213
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xfc) << 9);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 214 to 234
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)input[28] << 14) |
			((uint32_t)(input[29] & 0xe0) << 6);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 235 to 255
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)input[30] << 19) |
			((uint32_t)input[31] << 11);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 256 to 276
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16) |
			((uint32_t)(input[34] & 0xf8) << 8);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 277 to 297
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)input[36] << 13) |
			((uint32_t)(input[37] & 0xc0) << 5);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 298 to 318
	value = ((uint32_t)(input[37] & 0x3f) << 26) |
			((uint32_t)input[38] << 18) |
			((uint32_t)(input[39] & 0xfe) << 10);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 319 to 339
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xf0) << 7);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 340 to 360
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0x80) << 4);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 361 to 381
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)(input[47] & 0xfc) << 9);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 382 to 402
	value = ((uint32_t)(input[47] & 0x03) << 30) |
			((uint32_t)input[48] << 22) |
			((uint32_t)input[49] << 14) |
			((uint32_t)(input[50] & 0xe0) << 6);
	output[18] = (double)(value >> 11);
}

static void unpack_19_21bit_signed_5off(const uint8_t * input, double * output) {
	// Unpack 19 values into output
	// Values are 21-bit signed
	// Skip 5 bits, read 399 bits of data.
	// Input must be at least 51 bytes long

	int32_t value;

	// read output[0]: from bit 5 to 25
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xc0) << 5);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 26 to 46
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)(input[5] & 0xfe) << 10);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 47 to 67
	value = ((uint32_t)(input[5] & 0x01) << 31) |
			((uint32_t)input[6] << 23) |
			((uint32_t)input[7] << 15) |
			((uint32_t)(input[8] & 0xf0) << 7);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 68 to 88
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)input[10] << 12) |
			((uint32_t)(input[11] & 0x80) << 4);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 89 to 109
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xfc) << 9);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 110 to 130
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)input[15] << 14) |
			((uint32_t)(input[16] & 0xe0) << 6);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 131 to 151
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)input[18] << 11);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 152 to 172
	value = ((uint32_t)input[19] << 24) |
			((uint32_t)input[20] << 16) |
			((uint32_t)(input[21] & 0xf8) << 8);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 173 to 193
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xc0) << 5);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 194 to 214
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xfe) << 10);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 215 to 235
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)input[28] << 15) |
			((uint32_t)(input[29] & 0xf0) << 7);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 236 to 256
	value = ((uint32_t)(input[29] & 0x0f) << 28) |
			((uint32_t)input[30] << 20) |
			((uint32_t)input[31] << 12) |
			((uint32_t)(input[32] & 0x80) << 4);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 257 to 277
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0xfc) << 9);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 278 to 298
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)input[36] << 14) |
			((uint32_t)(input[37] & 0xe0) << 6);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 299 to 319
	value = ((uint32_t)(input[37] & 0x1f) << 27) |
			((uint32_t)input[38] << 19) |
			((uint32_t)input[39] << 11);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 320 to 340
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16) |
			((uint32_t)(input[42] & 0xf8) << 8);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 341 to 361
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xc0) << 5);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 362 to 382
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)(input[47] & 0xfe) << 10);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 383 to 403
	value = ((uint32_t)(input[47] & 0x01) << 31) |
			((uint32_t)input[48] << 23) |
			((uint32_t)input[49] << 15) |
			((uint32_t)(input[50] & 0xf0) << 7);
	output[18] = (double)(value >> 11);
}

static void unpack_19_21bit_unsigned_5off(const uint8_t * input, double * output) {
	// Unpack 19 values into output
	// Values are 21-bit unsigned
	// Skip 5 bits, read 399 bits of data.
	// Input must be at least 51 bytes long

	uint32_t value;

	// read output[0]: from bit 5 to 25
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xc0) << 5);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 26 to 46
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)(input[5] & 0xfe) << 10);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 47 to 67
	value = ((uint32_t)(input[5] & 0x01) << 31) |
			((uint32_t)input[6] << 23) |
			((uint32_t)input[7] << 15) |
			((uint32_t)(input[8] & 0xf0) << 7);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 68 to 88
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)input[10] << 12) |
			((uint32_t)(input[11] & 0x80) << 4);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 89 to 109
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xfc) << 9);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 110 to 130
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)input[15] << 14) |
			((uint32_t)(input[16] & 0xe0) << 6);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 131 to 151
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)input[18] << 11);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 152 to 172
	value = ((uint32_t)input[19] << 24) |
			((uint32_t)input[20] << 16) |
			((uint32_t)(input[21] & 0xf8) << 8);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 173 to 193
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xc0) << 5);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 194 to 214
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xfe) << 10);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 215 to 235
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)input[28] << 15) |
			((uint32_t)(input[29] & 0xf0) << 7);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 236 to 256
	value = ((uint32_t)(input[29] & 0x0f) << 28) |
			((uint32_t)input[30] << 20) |
			((uint32_t)input[31] << 12) |
			((uint32_t)(input[32] & 0x80) << 4);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 257 to 277
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0xfc) << 9);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 278 to 298
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)input[36] << 14) |
			((uint32_t)(input[37] & 0xe0) << 6);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 299 to 319
	value = ((uint32_t)(input[37] & 0x1f) << 27) |
			((uint32_t)input[38] << 19) |
			((uint32_t)input[39] << 11);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 320 to 340
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16) |
			((uint32_t)(input[42] & 0xf8) << 8);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 341 to 361
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xc0) << 5);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 362 to 382
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)(input[47] & 0xfe) << 10);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 383 to 403
	value = ((uint32_t)(input[47] & 0x01) << 31) |
			((uint32_t)input[48] << 23) |
			((uint32_t)input[49] << 15) |
			((uint32_t)(input[50] & 0xf0) << 7);
	output[18] = (double)(value >> 11);
}

static void unpack_19_21bit_signed_6off(const uint8_t * input, double * output) {
	// Unpack 19 values into output
	// Values are 21-bit signed
	// Skip 6 bits, read 399 bits of data.
	// Input must be at least 51 bytes long

	int32_t value;

	// read output[0]: from bit 6 to 26
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xe0) << 6);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 27 to 47
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 48 to 68
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)(input[8] & 0xf8) << 8);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 69 to 89
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)input[10] << 13) |
			((uint32_t)(input[11] & 0xc0) << 5);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 90 to 110
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xfe) << 10);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 111 to 131
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)input[15] << 15) |
			((uint32_t)(input[16] & 0xf0) << 7);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 132 to 152
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)input[18] << 12) |
			((uint32_t)(input[19] & 0x80) << 4);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 153 to 173
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xfc) << 9);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 174 to 194
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xe0) << 6);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 195 to 215
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 216 to 236
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)(input[29] & 0xf8) << 8);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 237 to 257
	value = ((uint32_t)(input[29] & 0x07) << 29) |
			((uint32_t)input[30] << 21) |
			((uint32_t)input[31] << 13) |
			((uint32_t)(input[32] & 0xc0) << 5);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 258 to 278
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xfe) << 10);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 279 to 299
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)input[36] << 15) |
			((uint32_t)(input[37] & 0xf0) << 7);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 300 to 320
	value = ((uint32_t)(input[37] & 0x0f) << 28) |
			((uint32_t)input[38] << 20) |
			((uint32_t)input[39] << 12) |
			((uint32_t)(input[40] & 0x80) << 4);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 321 to 341
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0xfc) << 9);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 342 to 362
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xe0) << 6);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 363 to 383
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 384 to 404
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)(input[50] & 0xf8) << 8);
	output[18] = (double)(value >> 11);
}

static void unpack_19_21bit_unsigned_6off(const uint8_t * input, double * output) {
	// Unpack 19 values into output
	// Values are 21-bit unsigned
	// Skip 6 bits, read 399 bits of data.
	// Input must be at least 51 bytes long

	uint32_t value;

	// read output[0]: from bit 6 to 26
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xe0) << 6);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 27 to 47
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 48 to 68
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)(input[8] & 0xf8) << 8);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 69 to 89
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)input[10] << 13) |
			((uint32_t)(input[11] & 0xc0) << 5);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 90 to 110
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xfe) << 10);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 111 to 131
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)input[15] << 15) |
			((uint32_t)(input[16] & 0xf0) << 7);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 132 to 152
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)input[18] << 12) |
			((uint32_t)(input[19] & 0x80) << 4);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 153 to 173
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xfc) << 9);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 174 to 194
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xe0) << 6);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 195 to 215
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 216 to 236
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)(input[29] & 0xf8) << 8);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 237 to 257
	value = ((uint32_t)(input[29] & 0x07) << 29) |
			((uint32_t)input[30] << 21) |
			((uint32_t)input[31] << 13) |
			((uint32_t)(input[32] & 0xc0) << 5);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 258 to 278
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xfe) << 10);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 279 to 299
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)input[36] << 15) |
			((uint32_t)(input[37] & 0xf0) << 7);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 300 to 320
	value = ((uint32_t)(input[37] & 0x0f) << 28) |
			((uint32_t)input[38] << 20) |
			((uint32_t)input[39] << 12) |
			((uint32_t)(input[40] & 0x80) << 4);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 321 to 341
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0xfc) << 9);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 342 to 362
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xe0) << 6);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 363 to 383
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 384 to 404
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)(input[50] & 0xf8) << 8);
	output[18] = (double)(value >> 11);
}

static void unpack_19_21bit_signed_7off(const uint8_t * input, double * output) {
	// Unpack 19 values into output
	// Values are 21-bit signed
	// Skip 7 bits, read 399 bits of data.
	// Input must be at least 51 bytes long

	int32_t value;

	// read output[0]: from bit 7 to 27
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xf0) << 7);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 28 to 48
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0x80) << 4);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 49 to 69
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0xfc) << 9);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 70 to 90
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)input[10] << 14) |
			((uint32_t)(input[11] & 0xe0) << 6);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 91 to 111
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)input[13] << 11);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 112 to 132
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16) |
			((uint32_t)(input[16] & 0xf8) << 8);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 133 to 153
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)input[18] << 13) |
			((uint32_t)(input[19] & 0xc0) << 5);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 154 to 174
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xfe) << 10);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 175 to 195
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xf0) << 7);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 196 to 216
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0x80) << 4);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 217 to 237
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)(input[29] & 0xfc) << 9);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 238 to 258
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)input[31] << 14) |
			((uint32_t)(input[32] & 0xe0) << 6);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 259 to 279
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)input[34] << 11);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 280 to 300
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)input[36] << 16) |
			((uint32_t)(input[37] & 0xf8) << 8);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 301 to 321
	value = ((uint32_t)(input[37] & 0x07) << 29) |
			((uint32_t)input[38] << 21) |
			((uint32_t)input[39] << 13) |
			((uint32_t)(input[40] & 0xc0) << 5);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 322 to 342
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xfe) << 10);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 343 to 363
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xf0) << 7);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 364 to 384
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0x80) << 4);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 385 to 405
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0xfc) << 9);
	output[18] = (double)(value >> 11);
}

static void unpack_19_21bit_unsigned_7off(const uint8_t * input, double * output) {
	// Unpack 19 values into output
	// Values are 21-bit unsigned
	// Skip 7 bits, read 399 bits of data.
	// Input must be at least 51 bytes long

	uint32_t value;

	// read output[0]: from bit 7 to 27
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xf0) << 7);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 28 to 48
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0x80) << 4);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 49 to 69
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0xfc) << 9);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 70 to 90
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)input[10] << 14) |
			((uint32_t)(input[11] & 0xe0) << 6);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 91 to 111
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)input[13] << 11);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 112 to 132
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16) |
			((uint32_t)(input[16] & 0xf8) << 8);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 133 to 153
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)input[18] << 13) |
			((uint32_t)(input[19] & 0xc0) << 5);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 154 to 174
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xfe) << 10);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 175 to 195
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xf0) << 7);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 196 to 216
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0x80) << 4);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 217 to 237
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)(input[29] & 0xfc) << 9);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 238 to 258
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)input[31] << 14) |
			((uint32_t)(input[32] & 0xe0) << 6);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 259 to 279
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)input[34] << 11);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 280 to 300
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)input[36] << 16) |
			((uint32_t)(input[37] & 0xf8) << 8);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 301 to 321
	value = ((uint32_t)(input[37] & 0x07) << 29) |
			((uint32_t)input[38] << 21) |
			((uint32_t)input[39] << 13) |
			((uint32_t)(input[40] & 0xc0) << 5);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 322 to 342
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xfe) << 10);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 343 to 363
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xf0) << 7);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 364 to 384
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0x80) << 4);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 385 to 405
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0xfc) << 9);
	output[18] = (double)(value >> 11);
}

static void unpack_20_21bit_signed_0off(const uint8_t * input, double * output) {
	// Unpack 20 values into output
	// Values are 21-bit signed
	// Skip 0 bits, read 420 bits of data.
	// Input must be at least 53 bytes long

	int32_t value;

	// read output[0]: from bit 0 to 20
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0xf8) << 8);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 21 to 41
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)input[4] << 13) |
			((uint32_t)(input[5] & 0xc0) << 5);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 42 to 62
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)input[6] << 18) |
			((uint32_t)(input[7] & 0xfe) << 10);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 63 to 83
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)input[9] << 15) |
			((uint32_t)(input[10] & 0xf0) << 7);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 84 to 104
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)input[12] << 12) |
			((uint32_t)(input[13] & 0x80) << 4);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 105 to 125
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xfc) << 9);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 126 to 146
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xe0) << 6);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 147 to 167
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 168 to 188
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)(input[23] & 0xf8) << 8);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 189 to 209
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)input[25] << 13) |
			((uint32_t)(input[26] & 0xc0) << 5);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 210 to 230
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xfe) << 10);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 231 to 251
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)input[30] << 15) |
			((uint32_t)(input[31] & 0xf0) << 7);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 252 to 272
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20) |
			((uint32_t)input[33] << 12) |
			((uint32_t)(input[34] & 0x80) << 4);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 273 to 293
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0xfc) << 9);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 294 to 314
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xe0) << 6);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 315 to 335
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 336 to 356
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)(input[44] & 0xf8) << 8);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 357 to 377
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)input[46] << 13) |
			((uint32_t)(input[47] & 0xc0) << 5);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 378 to 398
	value = ((uint32_t)(input[47] & 0x3f) << 26) |
			((uint32_t)input[48] << 18) |
			((uint32_t)(input[49] & 0xfe) << 10);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 399 to 419
	value = ((uint32_t)(input[49] & 0x01) << 31) |
			((uint32_t)input[50] << 23) |
			((uint32_t)input[51] << 15) |
			((uint32_t)(input[52] & 0xf0) << 7);
	output[19] = (double)(value >> 11);
}

static void unpack_20_21bit_unsigned_0off(const uint8_t * input, double * output) {
	// Unpack 20 values into output
	// Values are 21-bit unsigned
	// Skip 0 bits, read 420 bits of data.
	// Input must be at least 53 bytes long

	uint32_t value;

	// read output[0]: from bit 0 to 20
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0xf8) << 8);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 21 to 41
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)input[4] << 13) |
			((uint32_t)(input[5] & 0xc0) << 5);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 42 to 62
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)input[6] << 18) |
			((uint32_t)(input[7] & 0xfe) << 10);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 63 to 83
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)input[9] << 15) |
			((uint32_t)(input[10] & 0xf0) << 7);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 84 to 104
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)input[12] << 12) |
			((uint32_t)(input[13] & 0x80) << 4);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 105 to 125
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xfc) << 9);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 126 to 146
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xe0) << 6);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 147 to 167
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 168 to 188
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)(input[23] & 0xf8) << 8);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 189 to 209
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)input[25] << 13) |
			((uint32_t)(input[26] & 0xc0) << 5);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 210 to 230
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xfe) << 10);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 231 to 251
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)input[30] << 15) |
			((uint32_t)(input[31] & 0xf0) << 7);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 252 to 272
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20) |
			((uint32_t)input[33] << 12) |
			((uint32_t)(input[34] & 0x80) << 4);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 273 to 293
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0xfc) << 9);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 294 to 314
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xe0) << 6);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 315 to 335
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 336 to 356
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)(input[44] & 0xf8) << 8);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 357 to 377
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)input[46] << 13) |
			((uint32_t)(input[47] & 0xc0) << 5);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 378 to 398
	value = ((uint32_t)(input[47] & 0x3f) << 26) |
			((uint32_t)input[48] << 18) |
			((uint32_t)(input[49] & 0xfe) << 10);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 399 to 419
	value = ((uint32_t)(input[49] & 0x01) << 31) |
			((uint32_t)input[50] << 23) |
			((uint32_t)input[51] << 15) |
			((uint32_t)(input[52] & 0xf0) << 7);
	output[19] = (double)(value >> 11);
}

static void unpack_20_21bit_signed_1off(const uint8_t * input, double * output) {
	// Unpack 20 values into output
	// Values are 21-bit signed
	// Skip 1 bits, read 420 bits of data.
	// Input must be at least 53 bytes long

	int32_t value;

	// read output[0]: from bit 1 to 21
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xfc) << 9);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 22 to 42
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)input[4] << 14) |
			((uint32_t)(input[5] & 0xe0) << 6);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 43 to 63
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)input[6] << 19) |
			((uint32_t)input[7] << 11);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 64 to 84
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16) |
			((uint32_t)(input[10] & 0xf8) << 8);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 85 to 105
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)input[12] << 13) |
			((uint32_t)(input[13] & 0xc0) << 5);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 106 to 126
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xfe) << 10);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 127 to 147
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xf0) << 7);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 148 to 168
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0x80) << 4);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 169 to 189
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)(input[23] & 0xfc) << 9);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 190 to 210
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)input[25] << 14) |
			((uint32_t)(input[26] & 0xe0) << 6);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 211 to 231
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)input[28] << 11);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 232 to 252
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)input[30] << 16) |
			((uint32_t)(input[31] & 0xf8) << 8);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 253 to 273
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)input[33] << 13) |
			((uint32_t)(input[34] & 0xc0) << 5);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 274 to 294
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xfe) << 10);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 295 to 315
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xf0) << 7);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 316 to 336
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0x80) << 4);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 337 to 357
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0xfc) << 9);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 358 to 378
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)input[46] << 14) |
			((uint32_t)(input[47] & 0xe0) << 6);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 379 to 399
	value = ((uint32_t)(input[47] & 0x1f) << 27) |
			((uint32_t)input[48] << 19) |
			((uint32_t)input[49] << 11);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 400 to 420
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16) |
			((uint32_t)(input[52] & 0xf8) << 8);
	output[19] = (double)(value >> 11);
}

static void unpack_20_21bit_unsigned_1off(const uint8_t * input, double * output) {
	// Unpack 20 values into output
	// Values are 21-bit unsigned
	// Skip 1 bits, read 420 bits of data.
	// Input must be at least 53 bytes long

	uint32_t value;

	// read output[0]: from bit 1 to 21
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xfc) << 9);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 22 to 42
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)input[4] << 14) |
			((uint32_t)(input[5] & 0xe0) << 6);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 43 to 63
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)input[6] << 19) |
			((uint32_t)input[7] << 11);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 64 to 84
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16) |
			((uint32_t)(input[10] & 0xf8) << 8);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 85 to 105
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)input[12] << 13) |
			((uint32_t)(input[13] & 0xc0) << 5);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 106 to 126
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xfe) << 10);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 127 to 147
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xf0) << 7);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 148 to 168
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0x80) << 4);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 169 to 189
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)(input[23] & 0xfc) << 9);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 190 to 210
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)input[25] << 14) |
			((uint32_t)(input[26] & 0xe0) << 6);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 211 to 231
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)input[28] << 11);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 232 to 252
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)input[30] << 16) |
			((uint32_t)(input[31] & 0xf8) << 8);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 253 to 273
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)input[33] << 13) |
			((uint32_t)(input[34] & 0xc0) << 5);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 274 to 294
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xfe) << 10);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 295 to 315
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xf0) << 7);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 316 to 336
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0x80) << 4);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 337 to 357
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0xfc) << 9);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 358 to 378
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)input[46] << 14) |
			((uint32_t)(input[47] & 0xe0) << 6);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 379 to 399
	value = ((uint32_t)(input[47] & 0x1f) << 27) |
			((uint32_t)input[48] << 19) |
			((uint32_t)input[49] << 11);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 400 to 420
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16) |
			((uint32_t)(input[52] & 0xf8) << 8);
	output[19] = (double)(value >> 11);
}

static void unpack_20_21bit_signed_2off(const uint8_t * input, double * output) {
	// Unpack 20 values into output
	// Values are 21-bit signed
	// Skip 2 bits, read 420 bits of data.
	// Input must be at least 53 bytes long

	int32_t value;

	// read output[0]: from bit 2 to 22
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xfe) << 10);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 23 to 43
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15) |
			((uint32_t)(input[5] & 0xf0) << 7);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 44 to 64
	value = ((uint32_t)(input[5] & 0x0f) << 28) |
			((uint32_t)input[6] << 20) |
			((uint32_t)input[7] << 12) |
			((uint32_t)(input[8] & 0x80) << 4);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 65 to 85
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0xfc) << 9);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 86 to 106
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)input[12] << 14) |
			((uint32_t)(input[13] & 0xe0) << 6);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 107 to 127
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)input[15] << 11);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 128 to 148
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16) |
			((uint32_t)(input[18] & 0xf8) << 8);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 149 to 169
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xc0) << 5);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 170 to 190
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xfe) << 10);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 191 to 211
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15) |
			((uint32_t)(input[26] & 0xf0) << 7);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 212 to 232
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)input[28] << 12) |
			((uint32_t)(input[29] & 0x80) << 4);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 233 to 253
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)input[30] << 17) |
			((uint32_t)(input[31] & 0xfc) << 9);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 254 to 274
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)input[33] << 14) |
			((uint32_t)(input[34] & 0xe0) << 6);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 275 to 295
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)input[36] << 11);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 296 to 316
	value = ((uint32_t)input[37] << 24) |
			((uint32_t)input[38] << 16) |
			((uint32_t)(input[39] & 0xf8) << 8);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 317 to 337
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xc0) << 5);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 338 to 358
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xfe) << 10);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 359 to 379
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)input[46] << 15) |
			((uint32_t)(input[47] & 0xf0) << 7);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 380 to 400
	value = ((uint32_t)(input[47] & 0x0f) << 28) |
			((uint32_t)input[48] << 20) |
			((uint32_t)input[49] << 12) |
			((uint32_t)(input[50] & 0x80) << 4);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 401 to 421
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0xfc) << 9);
	output[19] = (double)(value >> 11);
}

static void unpack_20_21bit_unsigned_2off(const uint8_t * input, double * output) {
	// Unpack 20 values into output
	// Values are 21-bit unsigned
	// Skip 2 bits, read 420 bits of data.
	// Input must be at least 53 bytes long

	uint32_t value;

	// read output[0]: from bit 2 to 22
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xfe) << 10);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 23 to 43
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15) |
			((uint32_t)(input[5] & 0xf0) << 7);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 44 to 64
	value = ((uint32_t)(input[5] & 0x0f) << 28) |
			((uint32_t)input[6] << 20) |
			((uint32_t)input[7] << 12) |
			((uint32_t)(input[8] & 0x80) << 4);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 65 to 85
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0xfc) << 9);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 86 to 106
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)input[12] << 14) |
			((uint32_t)(input[13] & 0xe0) << 6);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 107 to 127
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)input[15] << 11);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 128 to 148
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16) |
			((uint32_t)(input[18] & 0xf8) << 8);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 149 to 169
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xc0) << 5);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 170 to 190
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xfe) << 10);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 191 to 211
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15) |
			((uint32_t)(input[26] & 0xf0) << 7);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 212 to 232
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)input[28] << 12) |
			((uint32_t)(input[29] & 0x80) << 4);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 233 to 253
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)input[30] << 17) |
			((uint32_t)(input[31] & 0xfc) << 9);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 254 to 274
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)input[33] << 14) |
			((uint32_t)(input[34] & 0xe0) << 6);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 275 to 295
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)input[36] << 11);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 296 to 316
	value = ((uint32_t)input[37] << 24) |
			((uint32_t)input[38] << 16) |
			((uint32_t)(input[39] & 0xf8) << 8);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 317 to 337
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xc0) << 5);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 338 to 358
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xfe) << 10);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 359 to 379
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)input[46] << 15) |
			((uint32_t)(input[47] & 0xf0) << 7);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 380 to 400
	value = ((uint32_t)(input[47] & 0x0f) << 28) |
			((uint32_t)input[48] << 20) |
			((uint32_t)input[49] << 12) |
			((uint32_t)(input[50] & 0x80) << 4);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 401 to 421
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0xfc) << 9);
	output[19] = (double)(value >> 11);
}

static void unpack_20_21bit_signed_3off(const uint8_t * input, double * output) {
	// Unpack 20 values into output
	// Values are 21-bit signed
	// Skip 3 bits, read 420 bits of data.
	// Input must be at least 53 bytes long

	int32_t value;

	// read output[0]: from bit 3 to 23
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 24 to 44
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0xf8) << 8);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 45 to 65
	value = ((uint32_t)(input[5] & 0x07) << 29) |
			((uint32_t)input[6] << 21) |
			((uint32_t)input[7] << 13) |
			((uint32_t)(input[8] & 0xc0) << 5);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 66 to 86
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xfe) << 10);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 87 to 107
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15) |
			((uint32_t)(input[13] & 0xf0) << 7);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 108 to 128
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)input[15] << 12) |
			((uint32_t)(input[16] & 0x80) << 4);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 129 to 149
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0xfc) << 9);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 150 to 170
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xe0) << 6);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 171 to 191
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 192 to 212
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0xf8) << 8);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 213 to 233
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)input[28] << 13) |
			((uint32_t)(input[29] & 0xc0) << 5);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 234 to 254
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)input[30] << 18) |
			((uint32_t)(input[31] & 0xfe) << 10);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 255 to 275
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)input[33] << 15) |
			((uint32_t)(input[34] & 0xf0) << 7);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 276 to 296
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)input[36] << 12) |
			((uint32_t)(input[37] & 0x80) << 4);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 297 to 317
	value = ((uint32_t)(input[37] & 0x7f) << 25) |
			((uint32_t)input[38] << 17) |
			((uint32_t)(input[39] & 0xfc) << 9);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 318 to 338
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xe0) << 6);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 339 to 359
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 360 to 380
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)(input[47] & 0xf8) << 8);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 381 to 401
	value = ((uint32_t)(input[47] & 0x07) << 29) |
			((uint32_t)input[48] << 21) |
			((uint32_t)input[49] << 13) |
			((uint32_t)(input[50] & 0xc0) << 5);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 402 to 422
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xfe) << 10);
	output[19] = (double)(value >> 11);
}

static void unpack_20_21bit_unsigned_3off(const uint8_t * input, double * output) {
	// Unpack 20 values into output
	// Values are 21-bit unsigned
	// Skip 3 bits, read 420 bits of data.
	// Input must be at least 53 bytes long

	uint32_t value;

	// read output[0]: from bit 3 to 23
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 24 to 44
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0xf8) << 8);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 45 to 65
	value = ((uint32_t)(input[5] & 0x07) << 29) |
			((uint32_t)input[6] << 21) |
			((uint32_t)input[7] << 13) |
			((uint32_t)(input[8] & 0xc0) << 5);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 66 to 86
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xfe) << 10);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 87 to 107
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15) |
			((uint32_t)(input[13] & 0xf0) << 7);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 108 to 128
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)input[15] << 12) |
			((uint32_t)(input[16] & 0x80) << 4);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 129 to 149
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0xfc) << 9);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 150 to 170
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xe0) << 6);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 171 to 191
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 192 to 212
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0xf8) << 8);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 213 to 233
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)input[28] << 13) |
			((uint32_t)(input[29] & 0xc0) << 5);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 234 to 254
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)input[30] << 18) |
			((uint32_t)(input[31] & 0xfe) << 10);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 255 to 275
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)input[33] << 15) |
			((uint32_t)(input[34] & 0xf0) << 7);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 276 to 296
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)input[36] << 12) |
			((uint32_t)(input[37] & 0x80) << 4);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 297 to 317
	value = ((uint32_t)(input[37] & 0x7f) << 25) |
			((uint32_t)input[38] << 17) |
			((uint32_t)(input[39] & 0xfc) << 9);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 318 to 338
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xe0) << 6);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 339 to 359
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 360 to 380
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)(input[47] & 0xf8) << 8);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 381 to 401
	value = ((uint32_t)(input[47] & 0x07) << 29) |
			((uint32_t)input[48] << 21) |
			((uint32_t)input[49] << 13) |
			((uint32_t)(input[50] & 0xc0) << 5);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 402 to 422
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xfe) << 10);
	output[19] = (double)(value >> 11);
}

static void unpack_20_21bit_signed_4off(const uint8_t * input, double * output) {
	// Unpack 20 values into output
	// Values are 21-bit signed
	// Skip 4 bits, read 420 bits of data.
	// Input must be at least 53 bytes long

	int32_t value;

	// read output[0]: from bit 4 to 24
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0x80) << 4);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 25 to 45
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)(input[5] & 0xfc) << 9);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 46 to 66
	value = ((uint32_t)(input[5] & 0x03) << 30) |
			((uint32_t)input[6] << 22) |
			((uint32_t)input[7] << 14) |
			((uint32_t)(input[8] & 0xe0) << 6);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 67 to 87
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)input[10] << 11);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 88 to 108
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0xf8) << 8);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 109 to 129
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)input[15] << 13) |
			((uint32_t)(input[16] & 0xc0) << 5);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 130 to 150
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xfe) << 10);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 151 to 171
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xf0) << 7);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 172 to 192
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0x80) << 4);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 193 to 213
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xfc) << 9);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 214 to 234
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)input[28] << 14) |
			((uint32_t)(input[29] & 0xe0) << 6);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 235 to 255
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)input[30] << 19) |
			((uint32_t)input[31] << 11);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 256 to 276
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16) |
			((uint32_t)(input[34] & 0xf8) << 8);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 277 to 297
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)input[36] << 13) |
			((uint32_t)(input[37] & 0xc0) << 5);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 298 to 318
	value = ((uint32_t)(input[37] & 0x3f) << 26) |
			((uint32_t)input[38] << 18) |
			((uint32_t)(input[39] & 0xfe) << 10);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 319 to 339
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xf0) << 7);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 340 to 360
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0x80) << 4);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 361 to 381
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)(input[47] & 0xfc) << 9);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 382 to 402
	value = ((uint32_t)(input[47] & 0x03) << 30) |
			((uint32_t)input[48] << 22) |
			((uint32_t)input[49] << 14) |
			((uint32_t)(input[50] & 0xe0) << 6);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 403 to 423
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)input[52] << 11);
	output[19] = (double)(value >> 11);
}

static void unpack_20_21bit_unsigned_4off(const uint8_t * input, double * output) {
	// Unpack 20 values into output
	// Values are 21-bit unsigned
	// Skip 4 bits, read 420 bits of data.
	// Input must be at least 53 bytes long

	uint32_t value;

	// read output[0]: from bit 4 to 24
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0x80) << 4);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 25 to 45
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)(input[5] & 0xfc) << 9);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 46 to 66
	value = ((uint32_t)(input[5] & 0x03) << 30) |
			((uint32_t)input[6] << 22) |
			((uint32_t)input[7] << 14) |
			((uint32_t)(input[8] & 0xe0) << 6);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 67 to 87
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)input[10] << 11);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 88 to 108
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0xf8) << 8);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 109 to 129
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)input[15] << 13) |
			((uint32_t)(input[16] & 0xc0) << 5);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 130 to 150
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xfe) << 10);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 151 to 171
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xf0) << 7);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 172 to 192
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0x80) << 4);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 193 to 213
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xfc) << 9);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 214 to 234
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)input[28] << 14) |
			((uint32_t)(input[29] & 0xe0) << 6);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 235 to 255
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)input[30] << 19) |
			((uint32_t)input[31] << 11);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 256 to 276
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16) |
			((uint32_t)(input[34] & 0xf8) << 8);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 277 to 297
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)input[36] << 13) |
			((uint32_t)(input[37] & 0xc0) << 5);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 298 to 318
	value = ((uint32_t)(input[37] & 0x3f) << 26) |
			((uint32_t)input[38] << 18) |
			((uint32_t)(input[39] & 0xfe) << 10);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 319 to 339
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xf0) << 7);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 340 to 360
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0x80) << 4);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 361 to 381
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)(input[47] & 0xfc) << 9);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 382 to 402
	value = ((uint32_t)(input[47] & 0x03) << 30) |
			((uint32_t)input[48] << 22) |
			((uint32_t)input[49] << 14) |
			((uint32_t)(input[50] & 0xe0) << 6);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 403 to 423
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)input[52] << 11);
	output[19] = (double)(value >> 11);
}

static void unpack_20_21bit_signed_5off(const uint8_t * input, double * output) {
	// Unpack 20 values into output
	// Values are 21-bit signed
	// Skip 5 bits, read 420 bits of data.
	// Input must be at least 54 bytes long

	int32_t value;

	// read output[0]: from bit 5 to 25
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xc0) << 5);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 26 to 46
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)(input[5] & 0xfe) << 10);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 47 to 67
	value = ((uint32_t)(input[5] & 0x01) << 31) |
			((uint32_t)input[6] << 23) |
			((uint32_t)input[7] << 15) |
			((uint32_t)(input[8] & 0xf0) << 7);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 68 to 88
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)input[10] << 12) |
			((uint32_t)(input[11] & 0x80) << 4);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 89 to 109
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xfc) << 9);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 110 to 130
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)input[15] << 14) |
			((uint32_t)(input[16] & 0xe0) << 6);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 131 to 151
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)input[18] << 11);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 152 to 172
	value = ((uint32_t)input[19] << 24) |
			((uint32_t)input[20] << 16) |
			((uint32_t)(input[21] & 0xf8) << 8);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 173 to 193
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xc0) << 5);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 194 to 214
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xfe) << 10);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 215 to 235
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)input[28] << 15) |
			((uint32_t)(input[29] & 0xf0) << 7);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 236 to 256
	value = ((uint32_t)(input[29] & 0x0f) << 28) |
			((uint32_t)input[30] << 20) |
			((uint32_t)input[31] << 12) |
			((uint32_t)(input[32] & 0x80) << 4);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 257 to 277
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0xfc) << 9);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 278 to 298
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)input[36] << 14) |
			((uint32_t)(input[37] & 0xe0) << 6);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 299 to 319
	value = ((uint32_t)(input[37] & 0x1f) << 27) |
			((uint32_t)input[38] << 19) |
			((uint32_t)input[39] << 11);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 320 to 340
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16) |
			((uint32_t)(input[42] & 0xf8) << 8);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 341 to 361
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xc0) << 5);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 362 to 382
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)(input[47] & 0xfe) << 10);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 383 to 403
	value = ((uint32_t)(input[47] & 0x01) << 31) |
			((uint32_t)input[48] << 23) |
			((uint32_t)input[49] << 15) |
			((uint32_t)(input[50] & 0xf0) << 7);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 404 to 424
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)input[52] << 12) |
			((uint32_t)(input[53] & 0x80) << 4);
	output[19] = (double)(value >> 11);
}

static void unpack_20_21bit_unsigned_5off(const uint8_t * input, double * output) {
	// Unpack 20 values into output
	// Values are 21-bit unsigned
	// Skip 5 bits, read 420 bits of data.
	// Input must be at least 54 bytes long

	uint32_t value;

	// read output[0]: from bit 5 to 25
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xc0) << 5);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 26 to 46
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)(input[5] & 0xfe) << 10);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 47 to 67
	value = ((uint32_t)(input[5] & 0x01) << 31) |
			((uint32_t)input[6] << 23) |
			((uint32_t)input[7] << 15) |
			((uint32_t)(input[8] & 0xf0) << 7);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 68 to 88
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)input[10] << 12) |
			((uint32_t)(input[11] & 0x80) << 4);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 89 to 109
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xfc) << 9);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 110 to 130
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)input[15] << 14) |
			((uint32_t)(input[16] & 0xe0) << 6);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 131 to 151
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)input[18] << 11);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 152 to 172
	value = ((uint32_t)input[19] << 24) |
			((uint32_t)input[20] << 16) |
			((uint32_t)(input[21] & 0xf8) << 8);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 173 to 193
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xc0) << 5);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 194 to 214
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xfe) << 10);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 215 to 235
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)input[28] << 15) |
			((uint32_t)(input[29] & 0xf0) << 7);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 236 to 256
	value = ((uint32_t)(input[29] & 0x0f) << 28) |
			((uint32_t)input[30] << 20) |
			((uint32_t)input[31] << 12) |
			((uint32_t)(input[32] & 0x80) << 4);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 257 to 277
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0xfc) << 9);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 278 to 298
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)input[36] << 14) |
			((uint32_t)(input[37] & 0xe0) << 6);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 299 to 319
	value = ((uint32_t)(input[37] & 0x1f) << 27) |
			((uint32_t)input[38] << 19) |
			((uint32_t)input[39] << 11);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 320 to 340
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16) |
			((uint32_t)(input[42] & 0xf8) << 8);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 341 to 361
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xc0) << 5);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 362 to 382
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)(input[47] & 0xfe) << 10);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 383 to 403
	value = ((uint32_t)(input[47] & 0x01) << 31) |
			((uint32_t)input[48] << 23) |
			((uint32_t)input[49] << 15) |
			((uint32_t)(input[50] & 0xf0) << 7);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 404 to 424
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)input[52] << 12) |
			((uint32_t)(input[53] & 0x80) << 4);
	output[19] = (double)(value >> 11);
}

static void unpack_20_21bit_signed_6off(const uint8_t * input, double * output) {
	// Unpack 20 values into output
	// Values are 21-bit signed
	// Skip 6 bits, read 420 bits of data.
	// Input must be at least 54 bytes long

	int32_t value;

	// read output[0]: from bit 6 to 26
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xe0) << 6);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 27 to 47
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 48 to 68
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)(input[8] & 0xf8) << 8);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 69 to 89
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)input[10] << 13) |
			((uint32_t)(input[11] & 0xc0) << 5);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 90 to 110
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xfe) << 10);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 111 to 131
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)input[15] << 15) |
			((uint32_t)(input[16] & 0xf0) << 7);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 132 to 152
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)input[18] << 12) |
			((uint32_t)(input[19] & 0x80) << 4);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 153 to 173
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xfc) << 9);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 174 to 194
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xe0) << 6);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 195 to 215
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 216 to 236
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)(input[29] & 0xf8) << 8);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 237 to 257
	value = ((uint32_t)(input[29] & 0x07) << 29) |
			((uint32_t)input[30] << 21) |
			((uint32_t)input[31] << 13) |
			((uint32_t)(input[32] & 0xc0) << 5);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 258 to 278
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xfe) << 10);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 279 to 299
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)input[36] << 15) |
			((uint32_t)(input[37] & 0xf0) << 7);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 300 to 320
	value = ((uint32_t)(input[37] & 0x0f) << 28) |
			((uint32_t)input[38] << 20) |
			((uint32_t)input[39] << 12) |
			((uint32_t)(input[40] & 0x80) << 4);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 321 to 341
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0xfc) << 9);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 342 to 362
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xe0) << 6);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 363 to 383
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 384 to 404
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)(input[50] & 0xf8) << 8);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 405 to 425
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)input[52] << 13) |
			((uint32_t)(input[53] & 0xc0) << 5);
	output[19] = (double)(value >> 11);
}

static void unpack_20_21bit_unsigned_6off(const uint8_t * input, double * output) {
	// Unpack 20 values into output
	// Values are 21-bit unsigned
	// Skip 6 bits, read 420 bits of data.
	// Input must be at least 54 bytes long

	uint32_t value;

	// read output[0]: from bit 6 to 26
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xe0) << 6);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 27 to 47
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 48 to 68
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)(input[8] & 0xf8) << 8);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 69 to 89
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)input[10] << 13) |
			((uint32_t)(input[11] & 0xc0) << 5);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 90 to 110
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xfe) << 10);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 111 to 131
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)input[15] << 15) |
			((uint32_t)(input[16] & 0xf0) << 7);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 132 to 152
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)input[18] << 12) |
			((uint32_t)(input[19] & 0x80) << 4);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 153 to 173
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xfc) << 9);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 174 to 194
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xe0) << 6);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 195 to 215
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 216 to 236
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)(input[29] & 0xf8) << 8);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 237 to 257
	value = ((uint32_t)(input[29] & 0x07) << 29) |
			((uint32_t)input[30] << 21) |
			((uint32_t)input[31] << 13) |
			((uint32_t)(input[32] & 0xc0) << 5);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 258 to 278
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xfe) << 10);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 279 to 299
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)input[36] << 15) |
			((uint32_t)(input[37] & 0xf0) << 7);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 300 to 320
	value = ((uint32_t)(input[37] & 0x0f) << 28) |
			((uint32_t)input[38] << 20) |
			((uint32_t)input[39] << 12) |
			((uint32_t)(input[40] & 0x80) << 4);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 321 to 341
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0xfc) << 9);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 342 to 362
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xe0) << 6);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 363 to 383
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 384 to 404
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)(input[50] & 0xf8) << 8);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 405 to 425
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)input[52] << 13) |
			((uint32_t)(input[53] & 0xc0) << 5);
	output[19] = (double)(value >> 11);
}

static void unpack_20_21bit_signed_7off(const uint8_t * input, double * output) {
	// Unpack 20 values into output
	// Values are 21-bit signed
	// Skip 7 bits, read 420 bits of data.
	// Input must be at least 54 bytes long

	int32_t value;

	// read output[0]: from bit 7 to 27
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xf0) << 7);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 28 to 48
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0x80) << 4);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 49 to 69
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0xfc) << 9);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 70 to 90
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)input[10] << 14) |
			((uint32_t)(input[11] & 0xe0) << 6);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 91 to 111
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)input[13] << 11);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 112 to 132
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16) |
			((uint32_t)(input[16] & 0xf8) << 8);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 133 to 153
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)input[18] << 13) |
			((uint32_t)(input[19] & 0xc0) << 5);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 154 to 174
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xfe) << 10);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 175 to 195
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xf0) << 7);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 196 to 216
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0x80) << 4);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 217 to 237
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)(input[29] & 0xfc) << 9);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 238 to 258
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)input[31] << 14) |
			((uint32_t)(input[32] & 0xe0) << 6);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 259 to 279
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)input[34] << 11);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 280 to 300
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)input[36] << 16) |
			((uint32_t)(input[37] & 0xf8) << 8);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 301 to 321
	value = ((uint32_t)(input[37] & 0x07) << 29) |
			((uint32_t)input[38] << 21) |
			((uint32_t)input[39] << 13) |
			((uint32_t)(input[40] & 0xc0) << 5);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 322 to 342
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xfe) << 10);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 343 to 363
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xf0) << 7);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 364 to 384
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0x80) << 4);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 385 to 405
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0xfc) << 9);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 406 to 426
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)input[52] << 14) |
			((uint32_t)(input[53] & 0xe0) << 6);
	output[19] = (double)(value >> 11);
}

static void unpack_20_21bit_unsigned_7off(const uint8_t * input, double * output) {
	// Unpack 20 values into output
	// Values are 21-bit unsigned
	// Skip 7 bits, read 420 bits of data.
	// Input must be at least 54 bytes long

	uint32_t value;

	// read output[0]: from bit 7 to 27
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xf0) << 7);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 28 to 48
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0x80) << 4);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 49 to 69
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0xfc) << 9);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 70 to 90
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)input[10] << 14) |
			((uint32_t)(input[11] & 0xe0) << 6);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 91 to 111
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)input[13] << 11);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 112 to 132
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16) |
			((uint32_t)(input[16] & 0xf8) << 8);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 133 to 153
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)input[18] << 13) |
			((uint32_t)(input[19] & 0xc0) << 5);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 154 to 174
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xfe) << 10);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 175 to 195
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xf0) << 7);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 196 to 216
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0x80) << 4);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 217 to 237
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)(input[29] & 0xfc) << 9);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 238 to 258
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)input[31] << 14) |
			((uint32_t)(input[32] & 0xe0) << 6);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 259 to 279
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)input[34] << 11);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 280 to 300
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)input[36] << 16) |
			((uint32_t)(input[37] & 0xf8) << 8);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 301 to 321
	value = ((uint32_t)(input[37] & 0x07) << 29) |
			((uint32_t)input[38] << 21) |
			((uint32_t)input[39] << 13) |
			((uint32_t)(input[40] & 0xc0) << 5);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 322 to 342
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xfe) << 10);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 343 to 363
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xf0) << 7);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 364 to 384
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0x80) << 4);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 385 to 405
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0xfc) << 9);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 406 to 426
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)input[52] << 14) |
			((uint32_t)(input[53] & 0xe0) << 6);
	output[19] = (double)(value >> 11);
}

static void unpack_21_21bit_signed_0off(const uint8_t * input, double * output) {
	// Unpack 21 values into output
	// Values are 21-bit signed
	// Skip 0 bits, read 441 bits of data.
	// Input must be at least 56 bytes long

	int32_t value;

	// read output[0]: from bit 0 to 20
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0xf8) << 8);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 21 to 41
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)input[4] << 13) |
			((uint32_t)(input[5] & 0xc0) << 5);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 42 to 62
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)input[6] << 18) |
			((uint32_t)(input[7] & 0xfe) << 10);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 63 to 83
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)input[9] << 15) |
			((uint32_t)(input[10] & 0xf0) << 7);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 84 to 104
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)input[12] << 12) |
			((uint32_t)(input[13] & 0x80) << 4);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 105 to 125
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xfc) << 9);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 126 to 146
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xe0) << 6);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 147 to 167
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 168 to 188
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)(input[23] & 0xf8) << 8);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 189 to 209
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)input[25] << 13) |
			((uint32_t)(input[26] & 0xc0) << 5);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 210 to 230
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xfe) << 10);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 231 to 251
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)input[30] << 15) |
			((uint32_t)(input[31] & 0xf0) << 7);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 252 to 272
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20) |
			((uint32_t)input[33] << 12) |
			((uint32_t)(input[34] & 0x80) << 4);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 273 to 293
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0xfc) << 9);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 294 to 314
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xe0) << 6);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 315 to 335
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 336 to 356
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)(input[44] & 0xf8) << 8);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 357 to 377
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)input[46] << 13) |
			((uint32_t)(input[47] & 0xc0) << 5);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 378 to 398
	value = ((uint32_t)(input[47] & 0x3f) << 26) |
			((uint32_t)input[48] << 18) |
			((uint32_t)(input[49] & 0xfe) << 10);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 399 to 419
	value = ((uint32_t)(input[49] & 0x01) << 31) |
			((uint32_t)input[50] << 23) |
			((uint32_t)input[51] << 15) |
			((uint32_t)(input[52] & 0xf0) << 7);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 420 to 440
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)input[54] << 12) |
			((uint32_t)(input[55] & 0x80) << 4);
	output[20] = (double)(value >> 11);
}

static void unpack_21_21bit_unsigned_0off(const uint8_t * input, double * output) {
	// Unpack 21 values into output
	// Values are 21-bit unsigned
	// Skip 0 bits, read 441 bits of data.
	// Input must be at least 56 bytes long

	uint32_t value;

	// read output[0]: from bit 0 to 20
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0xf8) << 8);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 21 to 41
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)input[4] << 13) |
			((uint32_t)(input[5] & 0xc0) << 5);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 42 to 62
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)input[6] << 18) |
			((uint32_t)(input[7] & 0xfe) << 10);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 63 to 83
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)input[9] << 15) |
			((uint32_t)(input[10] & 0xf0) << 7);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 84 to 104
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)input[12] << 12) |
			((uint32_t)(input[13] & 0x80) << 4);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 105 to 125
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xfc) << 9);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 126 to 146
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xe0) << 6);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 147 to 167
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 168 to 188
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)(input[23] & 0xf8) << 8);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 189 to 209
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)input[25] << 13) |
			((uint32_t)(input[26] & 0xc0) << 5);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 210 to 230
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xfe) << 10);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 231 to 251
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)input[30] << 15) |
			((uint32_t)(input[31] & 0xf0) << 7);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 252 to 272
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20) |
			((uint32_t)input[33] << 12) |
			((uint32_t)(input[34] & 0x80) << 4);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 273 to 293
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0xfc) << 9);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 294 to 314
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xe0) << 6);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 315 to 335
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 336 to 356
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)(input[44] & 0xf8) << 8);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 357 to 377
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)input[46] << 13) |
			((uint32_t)(input[47] & 0xc0) << 5);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 378 to 398
	value = ((uint32_t)(input[47] & 0x3f) << 26) |
			((uint32_t)input[48] << 18) |
			((uint32_t)(input[49] & 0xfe) << 10);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 399 to 419
	value = ((uint32_t)(input[49] & 0x01) << 31) |
			((uint32_t)input[50] << 23) |
			((uint32_t)input[51] << 15) |
			((uint32_t)(input[52] & 0xf0) << 7);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 420 to 440
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)input[54] << 12) |
			((uint32_t)(input[55] & 0x80) << 4);
	output[20] = (double)(value >> 11);
}

static void unpack_21_21bit_signed_1off(const uint8_t * input, double * output) {
	// Unpack 21 values into output
	// Values are 21-bit signed
	// Skip 1 bits, read 441 bits of data.
	// Input must be at least 56 bytes long

	int32_t value;

	// read output[0]: from bit 1 to 21
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xfc) << 9);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 22 to 42
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)input[4] << 14) |
			((uint32_t)(input[5] & 0xe0) << 6);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 43 to 63
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)input[6] << 19) |
			((uint32_t)input[7] << 11);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 64 to 84
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16) |
			((uint32_t)(input[10] & 0xf8) << 8);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 85 to 105
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)input[12] << 13) |
			((uint32_t)(input[13] & 0xc0) << 5);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 106 to 126
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xfe) << 10);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 127 to 147
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xf0) << 7);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 148 to 168
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0x80) << 4);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 169 to 189
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)(input[23] & 0xfc) << 9);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 190 to 210
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)input[25] << 14) |
			((uint32_t)(input[26] & 0xe0) << 6);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 211 to 231
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)input[28] << 11);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 232 to 252
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)input[30] << 16) |
			((uint32_t)(input[31] & 0xf8) << 8);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 253 to 273
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)input[33] << 13) |
			((uint32_t)(input[34] & 0xc0) << 5);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 274 to 294
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xfe) << 10);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 295 to 315
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xf0) << 7);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 316 to 336
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0x80) << 4);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 337 to 357
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0xfc) << 9);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 358 to 378
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)input[46] << 14) |
			((uint32_t)(input[47] & 0xe0) << 6);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 379 to 399
	value = ((uint32_t)(input[47] & 0x1f) << 27) |
			((uint32_t)input[48] << 19) |
			((uint32_t)input[49] << 11);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 400 to 420
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16) |
			((uint32_t)(input[52] & 0xf8) << 8);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 421 to 441
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)input[54] << 13) |
			((uint32_t)(input[55] & 0xc0) << 5);
	output[20] = (double)(value >> 11);
}

static void unpack_21_21bit_unsigned_1off(const uint8_t * input, double * output) {
	// Unpack 21 values into output
	// Values are 21-bit unsigned
	// Skip 1 bits, read 441 bits of data.
	// Input must be at least 56 bytes long

	uint32_t value;

	// read output[0]: from bit 1 to 21
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xfc) << 9);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 22 to 42
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)input[4] << 14) |
			((uint32_t)(input[5] & 0xe0) << 6);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 43 to 63
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)input[6] << 19) |
			((uint32_t)input[7] << 11);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 64 to 84
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16) |
			((uint32_t)(input[10] & 0xf8) << 8);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 85 to 105
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)input[12] << 13) |
			((uint32_t)(input[13] & 0xc0) << 5);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 106 to 126
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xfe) << 10);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 127 to 147
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xf0) << 7);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 148 to 168
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0x80) << 4);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 169 to 189
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)(input[23] & 0xfc) << 9);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 190 to 210
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)input[25] << 14) |
			((uint32_t)(input[26] & 0xe0) << 6);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 211 to 231
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)input[28] << 11);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 232 to 252
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)input[30] << 16) |
			((uint32_t)(input[31] & 0xf8) << 8);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 253 to 273
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)input[33] << 13) |
			((uint32_t)(input[34] & 0xc0) << 5);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 274 to 294
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xfe) << 10);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 295 to 315
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xf0) << 7);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 316 to 336
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0x80) << 4);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 337 to 357
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0xfc) << 9);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 358 to 378
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)input[46] << 14) |
			((uint32_t)(input[47] & 0xe0) << 6);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 379 to 399
	value = ((uint32_t)(input[47] & 0x1f) << 27) |
			((uint32_t)input[48] << 19) |
			((uint32_t)input[49] << 11);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 400 to 420
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16) |
			((uint32_t)(input[52] & 0xf8) << 8);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 421 to 441
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)input[54] << 13) |
			((uint32_t)(input[55] & 0xc0) << 5);
	output[20] = (double)(value >> 11);
}

static void unpack_21_21bit_signed_2off(const uint8_t * input, double * output) {
	// Unpack 21 values into output
	// Values are 21-bit signed
	// Skip 2 bits, read 441 bits of data.
	// Input must be at least 56 bytes long

	int32_t value;

	// read output[0]: from bit 2 to 22
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xfe) << 10);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 23 to 43
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15) |
			((uint32_t)(input[5] & 0xf0) << 7);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 44 to 64
	value = ((uint32_t)(input[5] & 0x0f) << 28) |
			((uint32_t)input[6] << 20) |
			((uint32_t)input[7] << 12) |
			((uint32_t)(input[8] & 0x80) << 4);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 65 to 85
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0xfc) << 9);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 86 to 106
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)input[12] << 14) |
			((uint32_t)(input[13] & 0xe0) << 6);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 107 to 127
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)input[15] << 11);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 128 to 148
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16) |
			((uint32_t)(input[18] & 0xf8) << 8);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 149 to 169
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xc0) << 5);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 170 to 190
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xfe) << 10);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 191 to 211
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15) |
			((uint32_t)(input[26] & 0xf0) << 7);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 212 to 232
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)input[28] << 12) |
			((uint32_t)(input[29] & 0x80) << 4);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 233 to 253
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)input[30] << 17) |
			((uint32_t)(input[31] & 0xfc) << 9);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 254 to 274
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)input[33] << 14) |
			((uint32_t)(input[34] & 0xe0) << 6);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 275 to 295
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)input[36] << 11);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 296 to 316
	value = ((uint32_t)input[37] << 24) |
			((uint32_t)input[38] << 16) |
			((uint32_t)(input[39] & 0xf8) << 8);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 317 to 337
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xc0) << 5);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 338 to 358
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xfe) << 10);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 359 to 379
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)input[46] << 15) |
			((uint32_t)(input[47] & 0xf0) << 7);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 380 to 400
	value = ((uint32_t)(input[47] & 0x0f) << 28) |
			((uint32_t)input[48] << 20) |
			((uint32_t)input[49] << 12) |
			((uint32_t)(input[50] & 0x80) << 4);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 401 to 421
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0xfc) << 9);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 422 to 442
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)input[54] << 14) |
			((uint32_t)(input[55] & 0xe0) << 6);
	output[20] = (double)(value >> 11);
}

static void unpack_21_21bit_unsigned_2off(const uint8_t * input, double * output) {
	// Unpack 21 values into output
	// Values are 21-bit unsigned
	// Skip 2 bits, read 441 bits of data.
	// Input must be at least 56 bytes long

	uint32_t value;

	// read output[0]: from bit 2 to 22
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xfe) << 10);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 23 to 43
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15) |
			((uint32_t)(input[5] & 0xf0) << 7);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 44 to 64
	value = ((uint32_t)(input[5] & 0x0f) << 28) |
			((uint32_t)input[6] << 20) |
			((uint32_t)input[7] << 12) |
			((uint32_t)(input[8] & 0x80) << 4);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 65 to 85
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0xfc) << 9);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 86 to 106
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)input[12] << 14) |
			((uint32_t)(input[13] & 0xe0) << 6);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 107 to 127
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)input[15] << 11);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 128 to 148
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16) |
			((uint32_t)(input[18] & 0xf8) << 8);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 149 to 169
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xc0) << 5);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 170 to 190
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xfe) << 10);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 191 to 211
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15) |
			((uint32_t)(input[26] & 0xf0) << 7);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 212 to 232
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)input[28] << 12) |
			((uint32_t)(input[29] & 0x80) << 4);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 233 to 253
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)input[30] << 17) |
			((uint32_t)(input[31] & 0xfc) << 9);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 254 to 274
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)input[33] << 14) |
			((uint32_t)(input[34] & 0xe0) << 6);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 275 to 295
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)input[36] << 11);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 296 to 316
	value = ((uint32_t)input[37] << 24) |
			((uint32_t)input[38] << 16) |
			((uint32_t)(input[39] & 0xf8) << 8);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 317 to 337
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xc0) << 5);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 338 to 358
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xfe) << 10);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 359 to 379
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)input[46] << 15) |
			((uint32_t)(input[47] & 0xf0) << 7);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 380 to 400
	value = ((uint32_t)(input[47] & 0x0f) << 28) |
			((uint32_t)input[48] << 20) |
			((uint32_t)input[49] << 12) |
			((uint32_t)(input[50] & 0x80) << 4);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 401 to 421
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0xfc) << 9);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 422 to 442
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)input[54] << 14) |
			((uint32_t)(input[55] & 0xe0) << 6);
	output[20] = (double)(value >> 11);
}

static void unpack_21_21bit_signed_3off(const uint8_t * input, double * output) {
	// Unpack 21 values into output
	// Values are 21-bit signed
	// Skip 3 bits, read 441 bits of data.
	// Input must be at least 56 bytes long

	int32_t value;

	// read output[0]: from bit 3 to 23
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 24 to 44
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0xf8) << 8);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 45 to 65
	value = ((uint32_t)(input[5] & 0x07) << 29) |
			((uint32_t)input[6] << 21) |
			((uint32_t)input[7] << 13) |
			((uint32_t)(input[8] & 0xc0) << 5);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 66 to 86
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xfe) << 10);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 87 to 107
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15) |
			((uint32_t)(input[13] & 0xf0) << 7);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 108 to 128
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)input[15] << 12) |
			((uint32_t)(input[16] & 0x80) << 4);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 129 to 149
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0xfc) << 9);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 150 to 170
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xe0) << 6);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 171 to 191
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 192 to 212
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0xf8) << 8);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 213 to 233
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)input[28] << 13) |
			((uint32_t)(input[29] & 0xc0) << 5);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 234 to 254
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)input[30] << 18) |
			((uint32_t)(input[31] & 0xfe) << 10);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 255 to 275
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)input[33] << 15) |
			((uint32_t)(input[34] & 0xf0) << 7);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 276 to 296
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)input[36] << 12) |
			((uint32_t)(input[37] & 0x80) << 4);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 297 to 317
	value = ((uint32_t)(input[37] & 0x7f) << 25) |
			((uint32_t)input[38] << 17) |
			((uint32_t)(input[39] & 0xfc) << 9);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 318 to 338
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xe0) << 6);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 339 to 359
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 360 to 380
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)(input[47] & 0xf8) << 8);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 381 to 401
	value = ((uint32_t)(input[47] & 0x07) << 29) |
			((uint32_t)input[48] << 21) |
			((uint32_t)input[49] << 13) |
			((uint32_t)(input[50] & 0xc0) << 5);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 402 to 422
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xfe) << 10);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 423 to 443
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)input[54] << 15) |
			((uint32_t)(input[55] & 0xf0) << 7);
	output[20] = (double)(value >> 11);
}

static void unpack_21_21bit_unsigned_3off(const uint8_t * input, double * output) {
	// Unpack 21 values into output
	// Values are 21-bit unsigned
	// Skip 3 bits, read 441 bits of data.
	// Input must be at least 56 bytes long

	uint32_t value;

	// read output[0]: from bit 3 to 23
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 24 to 44
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0xf8) << 8);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 45 to 65
	value = ((uint32_t)(input[5] & 0x07) << 29) |
			((uint32_t)input[6] << 21) |
			((uint32_t)input[7] << 13) |
			((uint32_t)(input[8] & 0xc0) << 5);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 66 to 86
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xfe) << 10);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 87 to 107
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15) |
			((uint32_t)(input[13] & 0xf0) << 7);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 108 to 128
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)input[15] << 12) |
			((uint32_t)(input[16] & 0x80) << 4);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 129 to 149
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0xfc) << 9);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 150 to 170
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xe0) << 6);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 171 to 191
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 192 to 212
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0xf8) << 8);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 213 to 233
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)input[28] << 13) |
			((uint32_t)(input[29] & 0xc0) << 5);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 234 to 254
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)input[30] << 18) |
			((uint32_t)(input[31] & 0xfe) << 10);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 255 to 275
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)input[33] << 15) |
			((uint32_t)(input[34] & 0xf0) << 7);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 276 to 296
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)input[36] << 12) |
			((uint32_t)(input[37] & 0x80) << 4);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 297 to 317
	value = ((uint32_t)(input[37] & 0x7f) << 25) |
			((uint32_t)input[38] << 17) |
			((uint32_t)(input[39] & 0xfc) << 9);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 318 to 338
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xe0) << 6);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 339 to 359
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 360 to 380
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)(input[47] & 0xf8) << 8);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 381 to 401
	value = ((uint32_t)(input[47] & 0x07) << 29) |
			((uint32_t)input[48] << 21) |
			((uint32_t)input[49] << 13) |
			((uint32_t)(input[50] & 0xc0) << 5);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 402 to 422
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xfe) << 10);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 423 to 443
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)input[54] << 15) |
			((uint32_t)(input[55] & 0xf0) << 7);
	output[20] = (double)(value >> 11);
}

static void unpack_21_21bit_signed_4off(const uint8_t * input, double * output) {
	// Unpack 21 values into output
	// Values are 21-bit signed
	// Skip 4 bits, read 441 bits of data.
	// Input must be at least 56 bytes long

	int32_t value;

	// read output[0]: from bit 4 to 24
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0x80) << 4);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 25 to 45
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)(input[5] & 0xfc) << 9);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 46 to 66
	value = ((uint32_t)(input[5] & 0x03) << 30) |
			((uint32_t)input[6] << 22) |
			((uint32_t)input[7] << 14) |
			((uint32_t)(input[8] & 0xe0) << 6);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 67 to 87
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)input[10] << 11);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 88 to 108
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0xf8) << 8);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 109 to 129
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)input[15] << 13) |
			((uint32_t)(input[16] & 0xc0) << 5);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 130 to 150
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xfe) << 10);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 151 to 171
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xf0) << 7);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 172 to 192
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0x80) << 4);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 193 to 213
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xfc) << 9);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 214 to 234
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)input[28] << 14) |
			((uint32_t)(input[29] & 0xe0) << 6);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 235 to 255
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)input[30] << 19) |
			((uint32_t)input[31] << 11);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 256 to 276
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16) |
			((uint32_t)(input[34] & 0xf8) << 8);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 277 to 297
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)input[36] << 13) |
			((uint32_t)(input[37] & 0xc0) << 5);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 298 to 318
	value = ((uint32_t)(input[37] & 0x3f) << 26) |
			((uint32_t)input[38] << 18) |
			((uint32_t)(input[39] & 0xfe) << 10);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 319 to 339
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xf0) << 7);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 340 to 360
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0x80) << 4);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 361 to 381
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)(input[47] & 0xfc) << 9);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 382 to 402
	value = ((uint32_t)(input[47] & 0x03) << 30) |
			((uint32_t)input[48] << 22) |
			((uint32_t)input[49] << 14) |
			((uint32_t)(input[50] & 0xe0) << 6);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 403 to 423
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)input[52] << 11);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 424 to 444
	value = ((uint32_t)input[53] << 24) |
			((uint32_t)input[54] << 16) |
			((uint32_t)(input[55] & 0xf8) << 8);
	output[20] = (double)(value >> 11);
}

static void unpack_21_21bit_unsigned_4off(const uint8_t * input, double * output) {
	// Unpack 21 values into output
	// Values are 21-bit unsigned
	// Skip 4 bits, read 441 bits of data.
	// Input must be at least 56 bytes long

	uint32_t value;

	// read output[0]: from bit 4 to 24
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0x80) << 4);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 25 to 45
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)(input[5] & 0xfc) << 9);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 46 to 66
	value = ((uint32_t)(input[5] & 0x03) << 30) |
			((uint32_t)input[6] << 22) |
			((uint32_t)input[7] << 14) |
			((uint32_t)(input[8] & 0xe0) << 6);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 67 to 87
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)input[10] << 11);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 88 to 108
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0xf8) << 8);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 109 to 129
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)input[15] << 13) |
			((uint32_t)(input[16] & 0xc0) << 5);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 130 to 150
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xfe) << 10);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 151 to 171
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xf0) << 7);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 172 to 192
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0x80) << 4);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 193 to 213
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xfc) << 9);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 214 to 234
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)input[28] << 14) |
			((uint32_t)(input[29] & 0xe0) << 6);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 235 to 255
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)input[30] << 19) |
			((uint32_t)input[31] << 11);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 256 to 276
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16) |
			((uint32_t)(input[34] & 0xf8) << 8);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 277 to 297
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)input[36] << 13) |
			((uint32_t)(input[37] & 0xc0) << 5);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 298 to 318
	value = ((uint32_t)(input[37] & 0x3f) << 26) |
			((uint32_t)input[38] << 18) |
			((uint32_t)(input[39] & 0xfe) << 10);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 319 to 339
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xf0) << 7);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 340 to 360
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0x80) << 4);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 361 to 381
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)(input[47] & 0xfc) << 9);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 382 to 402
	value = ((uint32_t)(input[47] & 0x03) << 30) |
			((uint32_t)input[48] << 22) |
			((uint32_t)input[49] << 14) |
			((uint32_t)(input[50] & 0xe0) << 6);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 403 to 423
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)input[52] << 11);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 424 to 444
	value = ((uint32_t)input[53] << 24) |
			((uint32_t)input[54] << 16) |
			((uint32_t)(input[55] & 0xf8) << 8);
	output[20] = (double)(value >> 11);
}

static void unpack_21_21bit_signed_5off(const uint8_t * input, double * output) {
	// Unpack 21 values into output
	// Values are 21-bit signed
	// Skip 5 bits, read 441 bits of data.
	// Input must be at least 56 bytes long

	int32_t value;

	// read output[0]: from bit 5 to 25
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xc0) << 5);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 26 to 46
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)(input[5] & 0xfe) << 10);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 47 to 67
	value = ((uint32_t)(input[5] & 0x01) << 31) |
			((uint32_t)input[6] << 23) |
			((uint32_t)input[7] << 15) |
			((uint32_t)(input[8] & 0xf0) << 7);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 68 to 88
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)input[10] << 12) |
			((uint32_t)(input[11] & 0x80) << 4);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 89 to 109
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xfc) << 9);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 110 to 130
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)input[15] << 14) |
			((uint32_t)(input[16] & 0xe0) << 6);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 131 to 151
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)input[18] << 11);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 152 to 172
	value = ((uint32_t)input[19] << 24) |
			((uint32_t)input[20] << 16) |
			((uint32_t)(input[21] & 0xf8) << 8);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 173 to 193
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xc0) << 5);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 194 to 214
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xfe) << 10);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 215 to 235
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)input[28] << 15) |
			((uint32_t)(input[29] & 0xf0) << 7);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 236 to 256
	value = ((uint32_t)(input[29] & 0x0f) << 28) |
			((uint32_t)input[30] << 20) |
			((uint32_t)input[31] << 12) |
			((uint32_t)(input[32] & 0x80) << 4);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 257 to 277
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0xfc) << 9);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 278 to 298
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)input[36] << 14) |
			((uint32_t)(input[37] & 0xe0) << 6);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 299 to 319
	value = ((uint32_t)(input[37] & 0x1f) << 27) |
			((uint32_t)input[38] << 19) |
			((uint32_t)input[39] << 11);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 320 to 340
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16) |
			((uint32_t)(input[42] & 0xf8) << 8);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 341 to 361
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xc0) << 5);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 362 to 382
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)(input[47] & 0xfe) << 10);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 383 to 403
	value = ((uint32_t)(input[47] & 0x01) << 31) |
			((uint32_t)input[48] << 23) |
			((uint32_t)input[49] << 15) |
			((uint32_t)(input[50] & 0xf0) << 7);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 404 to 424
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)input[52] << 12) |
			((uint32_t)(input[53] & 0x80) << 4);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 425 to 445
	value = ((uint32_t)(input[53] & 0x7f) << 25) |
			((uint32_t)input[54] << 17) |
			((uint32_t)(input[55] & 0xfc) << 9);
	output[20] = (double)(value >> 11);
}

static void unpack_21_21bit_unsigned_5off(const uint8_t * input, double * output) {
	// Unpack 21 values into output
	// Values are 21-bit unsigned
	// Skip 5 bits, read 441 bits of data.
	// Input must be at least 56 bytes long

	uint32_t value;

	// read output[0]: from bit 5 to 25
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xc0) << 5);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 26 to 46
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)(input[5] & 0xfe) << 10);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 47 to 67
	value = ((uint32_t)(input[5] & 0x01) << 31) |
			((uint32_t)input[6] << 23) |
			((uint32_t)input[7] << 15) |
			((uint32_t)(input[8] & 0xf0) << 7);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 68 to 88
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)input[10] << 12) |
			((uint32_t)(input[11] & 0x80) << 4);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 89 to 109
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xfc) << 9);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 110 to 130
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)input[15] << 14) |
			((uint32_t)(input[16] & 0xe0) << 6);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 131 to 151
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)input[18] << 11);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 152 to 172
	value = ((uint32_t)input[19] << 24) |
			((uint32_t)input[20] << 16) |
			((uint32_t)(input[21] & 0xf8) << 8);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 173 to 193
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xc0) << 5);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 194 to 214
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xfe) << 10);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 215 to 235
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)input[28] << 15) |
			((uint32_t)(input[29] & 0xf0) << 7);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 236 to 256
	value = ((uint32_t)(input[29] & 0x0f) << 28) |
			((uint32_t)input[30] << 20) |
			((uint32_t)input[31] << 12) |
			((uint32_t)(input[32] & 0x80) << 4);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 257 to 277
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0xfc) << 9);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 278 to 298
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)input[36] << 14) |
			((uint32_t)(input[37] & 0xe0) << 6);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 299 to 319
	value = ((uint32_t)(input[37] & 0x1f) << 27) |
			((uint32_t)input[38] << 19) |
			((uint32_t)input[39] << 11);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 320 to 340
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16) |
			((uint32_t)(input[42] & 0xf8) << 8);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 341 to 361
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xc0) << 5);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 362 to 382
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)(input[47] & 0xfe) << 10);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 383 to 403
	value = ((uint32_t)(input[47] & 0x01) << 31) |
			((uint32_t)input[48] << 23) |
			((uint32_t)input[49] << 15) |
			((uint32_t)(input[50] & 0xf0) << 7);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 404 to 424
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)input[52] << 12) |
			((uint32_t)(input[53] & 0x80) << 4);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 425 to 445
	value = ((uint32_t)(input[53] & 0x7f) << 25) |
			((uint32_t)input[54] << 17) |
			((uint32_t)(input[55] & 0xfc) << 9);
	output[20] = (double)(value >> 11);
}

static void unpack_21_21bit_signed_6off(const uint8_t * input, double * output) {
	// Unpack 21 values into output
	// Values are 21-bit signed
	// Skip 6 bits, read 441 bits of data.
	// Input must be at least 56 bytes long

	int32_t value;

	// read output[0]: from bit 6 to 26
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xe0) << 6);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 27 to 47
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 48 to 68
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)(input[8] & 0xf8) << 8);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 69 to 89
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)input[10] << 13) |
			((uint32_t)(input[11] & 0xc0) << 5);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 90 to 110
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xfe) << 10);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 111 to 131
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)input[15] << 15) |
			((uint32_t)(input[16] & 0xf0) << 7);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 132 to 152
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)input[18] << 12) |
			((uint32_t)(input[19] & 0x80) << 4);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 153 to 173
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xfc) << 9);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 174 to 194
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xe0) << 6);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 195 to 215
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 216 to 236
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)(input[29] & 0xf8) << 8);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 237 to 257
	value = ((uint32_t)(input[29] & 0x07) << 29) |
			((uint32_t)input[30] << 21) |
			((uint32_t)input[31] << 13) |
			((uint32_t)(input[32] & 0xc0) << 5);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 258 to 278
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xfe) << 10);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 279 to 299
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)input[36] << 15) |
			((uint32_t)(input[37] & 0xf0) << 7);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 300 to 320
	value = ((uint32_t)(input[37] & 0x0f) << 28) |
			((uint32_t)input[38] << 20) |
			((uint32_t)input[39] << 12) |
			((uint32_t)(input[40] & 0x80) << 4);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 321 to 341
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0xfc) << 9);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 342 to 362
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xe0) << 6);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 363 to 383
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 384 to 404
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)(input[50] & 0xf8) << 8);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 405 to 425
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)input[52] << 13) |
			((uint32_t)(input[53] & 0xc0) << 5);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 426 to 446
	value = ((uint32_t)(input[53] & 0x3f) << 26) |
			((uint32_t)input[54] << 18) |
			((uint32_t)(input[55] & 0xfe) << 10);
	output[20] = (double)(value >> 11);
}

static void unpack_21_21bit_unsigned_6off(const uint8_t * input, double * output) {
	// Unpack 21 values into output
	// Values are 21-bit unsigned
	// Skip 6 bits, read 441 bits of data.
	// Input must be at least 56 bytes long

	uint32_t value;

	// read output[0]: from bit 6 to 26
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xe0) << 6);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 27 to 47
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 48 to 68
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)(input[8] & 0xf8) << 8);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 69 to 89
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)input[10] << 13) |
			((uint32_t)(input[11] & 0xc0) << 5);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 90 to 110
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xfe) << 10);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 111 to 131
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)input[15] << 15) |
			((uint32_t)(input[16] & 0xf0) << 7);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 132 to 152
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)input[18] << 12) |
			((uint32_t)(input[19] & 0x80) << 4);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 153 to 173
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xfc) << 9);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 174 to 194
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xe0) << 6);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 195 to 215
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 216 to 236
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)(input[29] & 0xf8) << 8);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 237 to 257
	value = ((uint32_t)(input[29] & 0x07) << 29) |
			((uint32_t)input[30] << 21) |
			((uint32_t)input[31] << 13) |
			((uint32_t)(input[32] & 0xc0) << 5);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 258 to 278
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xfe) << 10);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 279 to 299
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)input[36] << 15) |
			((uint32_t)(input[37] & 0xf0) << 7);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 300 to 320
	value = ((uint32_t)(input[37] & 0x0f) << 28) |
			((uint32_t)input[38] << 20) |
			((uint32_t)input[39] << 12) |
			((uint32_t)(input[40] & 0x80) << 4);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 321 to 341
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0xfc) << 9);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 342 to 362
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xe0) << 6);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 363 to 383
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 384 to 404
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)(input[50] & 0xf8) << 8);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 405 to 425
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)input[52] << 13) |
			((uint32_t)(input[53] & 0xc0) << 5);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 426 to 446
	value = ((uint32_t)(input[53] & 0x3f) << 26) |
			((uint32_t)input[54] << 18) |
			((uint32_t)(input[55] & 0xfe) << 10);
	output[20] = (double)(value >> 11);
}

static void unpack_21_21bit_signed_7off(const uint8_t * input, double * output) {
	// Unpack 21 values into output
	// Values are 21-bit signed
	// Skip 7 bits, read 441 bits of data.
	// Input must be at least 56 bytes long

	int32_t value;

	// read output[0]: from bit 7 to 27
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xf0) << 7);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 28 to 48
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0x80) << 4);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 49 to 69
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0xfc) << 9);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 70 to 90
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)input[10] << 14) |
			((uint32_t)(input[11] & 0xe0) << 6);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 91 to 111
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)input[13] << 11);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 112 to 132
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16) |
			((uint32_t)(input[16] & 0xf8) << 8);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 133 to 153
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)input[18] << 13) |
			((uint32_t)(input[19] & 0xc0) << 5);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 154 to 174
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xfe) << 10);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 175 to 195
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xf0) << 7);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 196 to 216
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0x80) << 4);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 217 to 237
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)(input[29] & 0xfc) << 9);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 238 to 258
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)input[31] << 14) |
			((uint32_t)(input[32] & 0xe0) << 6);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 259 to 279
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)input[34] << 11);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 280 to 300
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)input[36] << 16) |
			((uint32_t)(input[37] & 0xf8) << 8);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 301 to 321
	value = ((uint32_t)(input[37] & 0x07) << 29) |
			((uint32_t)input[38] << 21) |
			((uint32_t)input[39] << 13) |
			((uint32_t)(input[40] & 0xc0) << 5);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 322 to 342
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xfe) << 10);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 343 to 363
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xf0) << 7);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 364 to 384
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0x80) << 4);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 385 to 405
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0xfc) << 9);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 406 to 426
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)input[52] << 14) |
			((uint32_t)(input[53] & 0xe0) << 6);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 427 to 447
	value = ((uint32_t)(input[53] & 0x1f) << 27) |
			((uint32_t)input[54] << 19) |
			((uint32_t)input[55] << 11);
	output[20] = (double)(value >> 11);
}

static void unpack_21_21bit_unsigned_7off(const uint8_t * input, double * output) {
	// Unpack 21 values into output
	// Values are 21-bit unsigned
	// Skip 7 bits, read 441 bits of data.
	// Input must be at least 56 bytes long

	uint32_t value;

	// read output[0]: from bit 7 to 27
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xf0) << 7);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 28 to 48
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0x80) << 4);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 49 to 69
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0xfc) << 9);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 70 to 90
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)input[10] << 14) |
			((uint32_t)(input[11] & 0xe0) << 6);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 91 to 111
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)input[13] << 11);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 112 to 132
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16) |
			((uint32_t)(input[16] & 0xf8) << 8);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 133 to 153
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)input[18] << 13) |
			((uint32_t)(input[19] & 0xc0) << 5);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 154 to 174
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xfe) << 10);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 175 to 195
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xf0) << 7);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 196 to 216
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0x80) << 4);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 217 to 237
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)(input[29] & 0xfc) << 9);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 238 to 258
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)input[31] << 14) |
			((uint32_t)(input[32] & 0xe0) << 6);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 259 to 279
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)input[34] << 11);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 280 to 300
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)input[36] << 16) |
			((uint32_t)(input[37] & 0xf8) << 8);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 301 to 321
	value = ((uint32_t)(input[37] & 0x07) << 29) |
			((uint32_t)input[38] << 21) |
			((uint32_t)input[39] << 13) |
			((uint32_t)(input[40] & 0xc0) << 5);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 322 to 342
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xfe) << 10);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 343 to 363
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xf0) << 7);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 364 to 384
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0x80) << 4);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 385 to 405
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0xfc) << 9);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 406 to 426
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)input[52] << 14) |
			((uint32_t)(input[53] & 0xe0) << 6);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 427 to 447
	value = ((uint32_t)(input[53] & 0x1f) << 27) |
			((uint32_t)input[54] << 19) |
			((uint32_t)input[55] << 11);
	output[20] = (double)(value >> 11);
}

static void unpack_22_21bit_signed_0off(const uint8_t * input, double * output) {
	// Unpack 22 values into output
	// Values are 21-bit signed
	// Skip 0 bits, read 462 bits of data.
	// Input must be at least 58 bytes long

	int32_t value;

	// read output[0]: from bit 0 to 20
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0xf8) << 8);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 21 to 41
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)input[4] << 13) |
			((uint32_t)(input[5] & 0xc0) << 5);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 42 to 62
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)input[6] << 18) |
			((uint32_t)(input[7] & 0xfe) << 10);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 63 to 83
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)input[9] << 15) |
			((uint32_t)(input[10] & 0xf0) << 7);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 84 to 104
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)input[12] << 12) |
			((uint32_t)(input[13] & 0x80) << 4);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 105 to 125
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xfc) << 9);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 126 to 146
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xe0) << 6);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 147 to 167
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 168 to 188
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)(input[23] & 0xf8) << 8);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 189 to 209
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)input[25] << 13) |
			((uint32_t)(input[26] & 0xc0) << 5);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 210 to 230
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xfe) << 10);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 231 to 251
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)input[30] << 15) |
			((uint32_t)(input[31] & 0xf0) << 7);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 252 to 272
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20) |
			((uint32_t)input[33] << 12) |
			((uint32_t)(input[34] & 0x80) << 4);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 273 to 293
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0xfc) << 9);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 294 to 314
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xe0) << 6);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 315 to 335
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 336 to 356
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)(input[44] & 0xf8) << 8);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 357 to 377
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)input[46] << 13) |
			((uint32_t)(input[47] & 0xc0) << 5);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 378 to 398
	value = ((uint32_t)(input[47] & 0x3f) << 26) |
			((uint32_t)input[48] << 18) |
			((uint32_t)(input[49] & 0xfe) << 10);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 399 to 419
	value = ((uint32_t)(input[49] & 0x01) << 31) |
			((uint32_t)input[50] << 23) |
			((uint32_t)input[51] << 15) |
			((uint32_t)(input[52] & 0xf0) << 7);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 420 to 440
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)input[54] << 12) |
			((uint32_t)(input[55] & 0x80) << 4);
	output[20] = (double)(value >> 11);

	// read output[21]: from bit 441 to 461
	value = ((uint32_t)(input[55] & 0x7f) << 25) |
			((uint32_t)input[56] << 17) |
			((uint32_t)(input[57] & 0xfc) << 9);
	output[21] = (double)(value >> 11);
}

static void unpack_22_21bit_unsigned_0off(const uint8_t * input, double * output) {
	// Unpack 22 values into output
	// Values are 21-bit unsigned
	// Skip 0 bits, read 462 bits of data.
	// Input must be at least 58 bytes long

	uint32_t value;

	// read output[0]: from bit 0 to 20
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0xf8) << 8);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 21 to 41
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)input[4] << 13) |
			((uint32_t)(input[5] & 0xc0) << 5);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 42 to 62
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)input[6] << 18) |
			((uint32_t)(input[7] & 0xfe) << 10);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 63 to 83
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)input[9] << 15) |
			((uint32_t)(input[10] & 0xf0) << 7);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 84 to 104
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)input[12] << 12) |
			((uint32_t)(input[13] & 0x80) << 4);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 105 to 125
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xfc) << 9);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 126 to 146
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xe0) << 6);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 147 to 167
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 168 to 188
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)(input[23] & 0xf8) << 8);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 189 to 209
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)input[25] << 13) |
			((uint32_t)(input[26] & 0xc0) << 5);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 210 to 230
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xfe) << 10);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 231 to 251
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)input[30] << 15) |
			((uint32_t)(input[31] & 0xf0) << 7);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 252 to 272
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20) |
			((uint32_t)input[33] << 12) |
			((uint32_t)(input[34] & 0x80) << 4);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 273 to 293
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0xfc) << 9);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 294 to 314
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xe0) << 6);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 315 to 335
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 336 to 356
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)(input[44] & 0xf8) << 8);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 357 to 377
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)input[46] << 13) |
			((uint32_t)(input[47] & 0xc0) << 5);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 378 to 398
	value = ((uint32_t)(input[47] & 0x3f) << 26) |
			((uint32_t)input[48] << 18) |
			((uint32_t)(input[49] & 0xfe) << 10);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 399 to 419
	value = ((uint32_t)(input[49] & 0x01) << 31) |
			((uint32_t)input[50] << 23) |
			((uint32_t)input[51] << 15) |
			((uint32_t)(input[52] & 0xf0) << 7);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 420 to 440
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)input[54] << 12) |
			((uint32_t)(input[55] & 0x80) << 4);
	output[20] = (double)(value >> 11);

	// read output[21]: from bit 441 to 461
	value = ((uint32_t)(input[55] & 0x7f) << 25) |
			((uint32_t)input[56] << 17) |
			((uint32_t)(input[57] & 0xfc) << 9);
	output[21] = (double)(value >> 11);
}

static void unpack_22_21bit_signed_1off(const uint8_t * input, double * output) {
	// Unpack 22 values into output
	// Values are 21-bit signed
	// Skip 1 bits, read 462 bits of data.
	// Input must be at least 58 bytes long

	int32_t value;

	// read output[0]: from bit 1 to 21
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xfc) << 9);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 22 to 42
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)input[4] << 14) |
			((uint32_t)(input[5] & 0xe0) << 6);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 43 to 63
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)input[6] << 19) |
			((uint32_t)input[7] << 11);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 64 to 84
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16) |
			((uint32_t)(input[10] & 0xf8) << 8);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 85 to 105
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)input[12] << 13) |
			((uint32_t)(input[13] & 0xc0) << 5);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 106 to 126
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xfe) << 10);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 127 to 147
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xf0) << 7);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 148 to 168
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0x80) << 4);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 169 to 189
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)(input[23] & 0xfc) << 9);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 190 to 210
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)input[25] << 14) |
			((uint32_t)(input[26] & 0xe0) << 6);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 211 to 231
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)input[28] << 11);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 232 to 252
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)input[30] << 16) |
			((uint32_t)(input[31] & 0xf8) << 8);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 253 to 273
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)input[33] << 13) |
			((uint32_t)(input[34] & 0xc0) << 5);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 274 to 294
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xfe) << 10);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 295 to 315
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xf0) << 7);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 316 to 336
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0x80) << 4);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 337 to 357
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0xfc) << 9);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 358 to 378
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)input[46] << 14) |
			((uint32_t)(input[47] & 0xe0) << 6);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 379 to 399
	value = ((uint32_t)(input[47] & 0x1f) << 27) |
			((uint32_t)input[48] << 19) |
			((uint32_t)input[49] << 11);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 400 to 420
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16) |
			((uint32_t)(input[52] & 0xf8) << 8);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 421 to 441
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)input[54] << 13) |
			((uint32_t)(input[55] & 0xc0) << 5);
	output[20] = (double)(value >> 11);

	// read output[21]: from bit 442 to 462
	value = ((uint32_t)(input[55] & 0x3f) << 26) |
			((uint32_t)input[56] << 18) |
			((uint32_t)(input[57] & 0xfe) << 10);
	output[21] = (double)(value >> 11);
}

static void unpack_22_21bit_unsigned_1off(const uint8_t * input, double * output) {
	// Unpack 22 values into output
	// Values are 21-bit unsigned
	// Skip 1 bits, read 462 bits of data.
	// Input must be at least 58 bytes long

	uint32_t value;

	// read output[0]: from bit 1 to 21
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xfc) << 9);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 22 to 42
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)input[4] << 14) |
			((uint32_t)(input[5] & 0xe0) << 6);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 43 to 63
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)input[6] << 19) |
			((uint32_t)input[7] << 11);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 64 to 84
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16) |
			((uint32_t)(input[10] & 0xf8) << 8);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 85 to 105
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)input[12] << 13) |
			((uint32_t)(input[13] & 0xc0) << 5);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 106 to 126
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xfe) << 10);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 127 to 147
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xf0) << 7);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 148 to 168
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0x80) << 4);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 169 to 189
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)(input[23] & 0xfc) << 9);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 190 to 210
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)input[25] << 14) |
			((uint32_t)(input[26] & 0xe0) << 6);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 211 to 231
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)input[28] << 11);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 232 to 252
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)input[30] << 16) |
			((uint32_t)(input[31] & 0xf8) << 8);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 253 to 273
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)input[33] << 13) |
			((uint32_t)(input[34] & 0xc0) << 5);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 274 to 294
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xfe) << 10);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 295 to 315
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xf0) << 7);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 316 to 336
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0x80) << 4);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 337 to 357
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0xfc) << 9);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 358 to 378
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)input[46] << 14) |
			((uint32_t)(input[47] & 0xe0) << 6);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 379 to 399
	value = ((uint32_t)(input[47] & 0x1f) << 27) |
			((uint32_t)input[48] << 19) |
			((uint32_t)input[49] << 11);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 400 to 420
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16) |
			((uint32_t)(input[52] & 0xf8) << 8);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 421 to 441
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)input[54] << 13) |
			((uint32_t)(input[55] & 0xc0) << 5);
	output[20] = (double)(value >> 11);

	// read output[21]: from bit 442 to 462
	value = ((uint32_t)(input[55] & 0x3f) << 26) |
			((uint32_t)input[56] << 18) |
			((uint32_t)(input[57] & 0xfe) << 10);
	output[21] = (double)(value >> 11);
}

static void unpack_22_21bit_signed_2off(const uint8_t * input, double * output) {
	// Unpack 22 values into output
	// Values are 21-bit signed
	// Skip 2 bits, read 462 bits of data.
	// Input must be at least 58 bytes long

	int32_t value;

	// read output[0]: from bit 2 to 22
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xfe) << 10);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 23 to 43
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15) |
			((uint32_t)(input[5] & 0xf0) << 7);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 44 to 64
	value = ((uint32_t)(input[5] & 0x0f) << 28) |
			((uint32_t)input[6] << 20) |
			((uint32_t)input[7] << 12) |
			((uint32_t)(input[8] & 0x80) << 4);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 65 to 85
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0xfc) << 9);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 86 to 106
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)input[12] << 14) |
			((uint32_t)(input[13] & 0xe0) << 6);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 107 to 127
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)input[15] << 11);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 128 to 148
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16) |
			((uint32_t)(input[18] & 0xf8) << 8);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 149 to 169
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xc0) << 5);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 170 to 190
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xfe) << 10);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 191 to 211
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15) |
			((uint32_t)(input[26] & 0xf0) << 7);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 212 to 232
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)input[28] << 12) |
			((uint32_t)(input[29] & 0x80) << 4);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 233 to 253
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)input[30] << 17) |
			((uint32_t)(input[31] & 0xfc) << 9);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 254 to 274
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)input[33] << 14) |
			((uint32_t)(input[34] & 0xe0) << 6);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 275 to 295
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)input[36] << 11);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 296 to 316
	value = ((uint32_t)input[37] << 24) |
			((uint32_t)input[38] << 16) |
			((uint32_t)(input[39] & 0xf8) << 8);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 317 to 337
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xc0) << 5);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 338 to 358
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xfe) << 10);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 359 to 379
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)input[46] << 15) |
			((uint32_t)(input[47] & 0xf0) << 7);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 380 to 400
	value = ((uint32_t)(input[47] & 0x0f) << 28) |
			((uint32_t)input[48] << 20) |
			((uint32_t)input[49] << 12) |
			((uint32_t)(input[50] & 0x80) << 4);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 401 to 421
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0xfc) << 9);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 422 to 442
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)input[54] << 14) |
			((uint32_t)(input[55] & 0xe0) << 6);
	output[20] = (double)(value >> 11);

	// read output[21]: from bit 443 to 463
	value = ((uint32_t)(input[55] & 0x1f) << 27) |
			((uint32_t)input[56] << 19) |
			((uint32_t)input[57] << 11);
	output[21] = (double)(value >> 11);
}

static void unpack_22_21bit_unsigned_2off(const uint8_t * input, double * output) {
	// Unpack 22 values into output
	// Values are 21-bit unsigned
	// Skip 2 bits, read 462 bits of data.
	// Input must be at least 58 bytes long

	uint32_t value;

	// read output[0]: from bit 2 to 22
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xfe) << 10);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 23 to 43
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15) |
			((uint32_t)(input[5] & 0xf0) << 7);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 44 to 64
	value = ((uint32_t)(input[5] & 0x0f) << 28) |
			((uint32_t)input[6] << 20) |
			((uint32_t)input[7] << 12) |
			((uint32_t)(input[8] & 0x80) << 4);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 65 to 85
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0xfc) << 9);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 86 to 106
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)input[12] << 14) |
			((uint32_t)(input[13] & 0xe0) << 6);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 107 to 127
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)input[15] << 11);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 128 to 148
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16) |
			((uint32_t)(input[18] & 0xf8) << 8);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 149 to 169
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xc0) << 5);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 170 to 190
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xfe) << 10);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 191 to 211
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15) |
			((uint32_t)(input[26] & 0xf0) << 7);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 212 to 232
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)input[28] << 12) |
			((uint32_t)(input[29] & 0x80) << 4);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 233 to 253
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)input[30] << 17) |
			((uint32_t)(input[31] & 0xfc) << 9);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 254 to 274
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)input[33] << 14) |
			((uint32_t)(input[34] & 0xe0) << 6);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 275 to 295
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)input[36] << 11);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 296 to 316
	value = ((uint32_t)input[37] << 24) |
			((uint32_t)input[38] << 16) |
			((uint32_t)(input[39] & 0xf8) << 8);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 317 to 337
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xc0) << 5);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 338 to 358
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xfe) << 10);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 359 to 379
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)input[46] << 15) |
			((uint32_t)(input[47] & 0xf0) << 7);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 380 to 400
	value = ((uint32_t)(input[47] & 0x0f) << 28) |
			((uint32_t)input[48] << 20) |
			((uint32_t)input[49] << 12) |
			((uint32_t)(input[50] & 0x80) << 4);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 401 to 421
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0xfc) << 9);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 422 to 442
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)input[54] << 14) |
			((uint32_t)(input[55] & 0xe0) << 6);
	output[20] = (double)(value >> 11);

	// read output[21]: from bit 443 to 463
	value = ((uint32_t)(input[55] & 0x1f) << 27) |
			((uint32_t)input[56] << 19) |
			((uint32_t)input[57] << 11);
	output[21] = (double)(value >> 11);
}

static void unpack_22_21bit_signed_3off(const uint8_t * input, double * output) {
	// Unpack 22 values into output
	// Values are 21-bit signed
	// Skip 3 bits, read 462 bits of data.
	// Input must be at least 59 bytes long

	int32_t value;

	// read output[0]: from bit 3 to 23
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 24 to 44
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0xf8) << 8);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 45 to 65
	value = ((uint32_t)(input[5] & 0x07) << 29) |
			((uint32_t)input[6] << 21) |
			((uint32_t)input[7] << 13) |
			((uint32_t)(input[8] & 0xc0) << 5);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 66 to 86
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xfe) << 10);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 87 to 107
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15) |
			((uint32_t)(input[13] & 0xf0) << 7);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 108 to 128
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)input[15] << 12) |
			((uint32_t)(input[16] & 0x80) << 4);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 129 to 149
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0xfc) << 9);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 150 to 170
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xe0) << 6);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 171 to 191
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 192 to 212
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0xf8) << 8);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 213 to 233
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)input[28] << 13) |
			((uint32_t)(input[29] & 0xc0) << 5);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 234 to 254
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)input[30] << 18) |
			((uint32_t)(input[31] & 0xfe) << 10);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 255 to 275
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)input[33] << 15) |
			((uint32_t)(input[34] & 0xf0) << 7);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 276 to 296
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)input[36] << 12) |
			((uint32_t)(input[37] & 0x80) << 4);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 297 to 317
	value = ((uint32_t)(input[37] & 0x7f) << 25) |
			((uint32_t)input[38] << 17) |
			((uint32_t)(input[39] & 0xfc) << 9);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 318 to 338
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xe0) << 6);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 339 to 359
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 360 to 380
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)(input[47] & 0xf8) << 8);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 381 to 401
	value = ((uint32_t)(input[47] & 0x07) << 29) |
			((uint32_t)input[48] << 21) |
			((uint32_t)input[49] << 13) |
			((uint32_t)(input[50] & 0xc0) << 5);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 402 to 422
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xfe) << 10);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 423 to 443
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)input[54] << 15) |
			((uint32_t)(input[55] & 0xf0) << 7);
	output[20] = (double)(value >> 11);

	// read output[21]: from bit 444 to 464
	value = ((uint32_t)(input[55] & 0x0f) << 28) |
			((uint32_t)input[56] << 20) |
			((uint32_t)input[57] << 12) |
			((uint32_t)(input[58] & 0x80) << 4);
	output[21] = (double)(value >> 11);
}

static void unpack_22_21bit_unsigned_3off(const uint8_t * input, double * output) {
	// Unpack 22 values into output
	// Values are 21-bit unsigned
	// Skip 3 bits, read 462 bits of data.
	// Input must be at least 59 bytes long

	uint32_t value;

	// read output[0]: from bit 3 to 23
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 24 to 44
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0xf8) << 8);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 45 to 65
	value = ((uint32_t)(input[5] & 0x07) << 29) |
			((uint32_t)input[6] << 21) |
			((uint32_t)input[7] << 13) |
			((uint32_t)(input[8] & 0xc0) << 5);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 66 to 86
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xfe) << 10);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 87 to 107
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15) |
			((uint32_t)(input[13] & 0xf0) << 7);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 108 to 128
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)input[15] << 12) |
			((uint32_t)(input[16] & 0x80) << 4);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 129 to 149
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0xfc) << 9);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 150 to 170
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xe0) << 6);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 171 to 191
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 192 to 212
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0xf8) << 8);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 213 to 233
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)input[28] << 13) |
			((uint32_t)(input[29] & 0xc0) << 5);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 234 to 254
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)input[30] << 18) |
			((uint32_t)(input[31] & 0xfe) << 10);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 255 to 275
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)input[33] << 15) |
			((uint32_t)(input[34] & 0xf0) << 7);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 276 to 296
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)input[36] << 12) |
			((uint32_t)(input[37] & 0x80) << 4);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 297 to 317
	value = ((uint32_t)(input[37] & 0x7f) << 25) |
			((uint32_t)input[38] << 17) |
			((uint32_t)(input[39] & 0xfc) << 9);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 318 to 338
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xe0) << 6);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 339 to 359
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 360 to 380
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)(input[47] & 0xf8) << 8);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 381 to 401
	value = ((uint32_t)(input[47] & 0x07) << 29) |
			((uint32_t)input[48] << 21) |
			((uint32_t)input[49] << 13) |
			((uint32_t)(input[50] & 0xc0) << 5);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 402 to 422
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xfe) << 10);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 423 to 443
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)input[54] << 15) |
			((uint32_t)(input[55] & 0xf0) << 7);
	output[20] = (double)(value >> 11);

	// read output[21]: from bit 444 to 464
	value = ((uint32_t)(input[55] & 0x0f) << 28) |
			((uint32_t)input[56] << 20) |
			((uint32_t)input[57] << 12) |
			((uint32_t)(input[58] & 0x80) << 4);
	output[21] = (double)(value >> 11);
}

static void unpack_22_21bit_signed_4off(const uint8_t * input, double * output) {
	// Unpack 22 values into output
	// Values are 21-bit signed
	// Skip 4 bits, read 462 bits of data.
	// Input must be at least 59 bytes long

	int32_t value;

	// read output[0]: from bit 4 to 24
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0x80) << 4);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 25 to 45
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)(input[5] & 0xfc) << 9);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 46 to 66
	value = ((uint32_t)(input[5] & 0x03) << 30) |
			((uint32_t)input[6] << 22) |
			((uint32_t)input[7] << 14) |
			((uint32_t)(input[8] & 0xe0) << 6);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 67 to 87
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)input[10] << 11);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 88 to 108
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0xf8) << 8);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 109 to 129
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)input[15] << 13) |
			((uint32_t)(input[16] & 0xc0) << 5);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 130 to 150
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xfe) << 10);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 151 to 171
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xf0) << 7);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 172 to 192
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0x80) << 4);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 193 to 213
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xfc) << 9);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 214 to 234
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)input[28] << 14) |
			((uint32_t)(input[29] & 0xe0) << 6);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 235 to 255
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)input[30] << 19) |
			((uint32_t)input[31] << 11);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 256 to 276
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16) |
			((uint32_t)(input[34] & 0xf8) << 8);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 277 to 297
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)input[36] << 13) |
			((uint32_t)(input[37] & 0xc0) << 5);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 298 to 318
	value = ((uint32_t)(input[37] & 0x3f) << 26) |
			((uint32_t)input[38] << 18) |
			((uint32_t)(input[39] & 0xfe) << 10);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 319 to 339
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xf0) << 7);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 340 to 360
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0x80) << 4);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 361 to 381
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)(input[47] & 0xfc) << 9);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 382 to 402
	value = ((uint32_t)(input[47] & 0x03) << 30) |
			((uint32_t)input[48] << 22) |
			((uint32_t)input[49] << 14) |
			((uint32_t)(input[50] & 0xe0) << 6);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 403 to 423
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)input[52] << 11);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 424 to 444
	value = ((uint32_t)input[53] << 24) |
			((uint32_t)input[54] << 16) |
			((uint32_t)(input[55] & 0xf8) << 8);
	output[20] = (double)(value >> 11);

	// read output[21]: from bit 445 to 465
	value = ((uint32_t)(input[55] & 0x07) << 29) |
			((uint32_t)input[56] << 21) |
			((uint32_t)input[57] << 13) |
			((uint32_t)(input[58] & 0xc0) << 5);
	output[21] = (double)(value >> 11);
}

static void unpack_22_21bit_unsigned_4off(const uint8_t * input, double * output) {
	// Unpack 22 values into output
	// Values are 21-bit unsigned
	// Skip 4 bits, read 462 bits of data.
	// Input must be at least 59 bytes long

	uint32_t value;

	// read output[0]: from bit 4 to 24
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0x80) << 4);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 25 to 45
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)(input[5] & 0xfc) << 9);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 46 to 66
	value = ((uint32_t)(input[5] & 0x03) << 30) |
			((uint32_t)input[6] << 22) |
			((uint32_t)input[7] << 14) |
			((uint32_t)(input[8] & 0xe0) << 6);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 67 to 87
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)input[10] << 11);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 88 to 108
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0xf8) << 8);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 109 to 129
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)input[15] << 13) |
			((uint32_t)(input[16] & 0xc0) << 5);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 130 to 150
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xfe) << 10);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 151 to 171
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xf0) << 7);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 172 to 192
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0x80) << 4);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 193 to 213
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xfc) << 9);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 214 to 234
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)input[28] << 14) |
			((uint32_t)(input[29] & 0xe0) << 6);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 235 to 255
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)input[30] << 19) |
			((uint32_t)input[31] << 11);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 256 to 276
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16) |
			((uint32_t)(input[34] & 0xf8) << 8);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 277 to 297
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)input[36] << 13) |
			((uint32_t)(input[37] & 0xc0) << 5);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 298 to 318
	value = ((uint32_t)(input[37] & 0x3f) << 26) |
			((uint32_t)input[38] << 18) |
			((uint32_t)(input[39] & 0xfe) << 10);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 319 to 339
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xf0) << 7);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 340 to 360
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0x80) << 4);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 361 to 381
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)(input[47] & 0xfc) << 9);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 382 to 402
	value = ((uint32_t)(input[47] & 0x03) << 30) |
			((uint32_t)input[48] << 22) |
			((uint32_t)input[49] << 14) |
			((uint32_t)(input[50] & 0xe0) << 6);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 403 to 423
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)input[52] << 11);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 424 to 444
	value = ((uint32_t)input[53] << 24) |
			((uint32_t)input[54] << 16) |
			((uint32_t)(input[55] & 0xf8) << 8);
	output[20] = (double)(value >> 11);

	// read output[21]: from bit 445 to 465
	value = ((uint32_t)(input[55] & 0x07) << 29) |
			((uint32_t)input[56] << 21) |
			((uint32_t)input[57] << 13) |
			((uint32_t)(input[58] & 0xc0) << 5);
	output[21] = (double)(value >> 11);
}

static void unpack_22_21bit_signed_5off(const uint8_t * input, double * output) {
	// Unpack 22 values into output
	// Values are 21-bit signed
	// Skip 5 bits, read 462 bits of data.
	// Input must be at least 59 bytes long

	int32_t value;

	// read output[0]: from bit 5 to 25
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xc0) << 5);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 26 to 46
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)(input[5] & 0xfe) << 10);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 47 to 67
	value = ((uint32_t)(input[5] & 0x01) << 31) |
			((uint32_t)input[6] << 23) |
			((uint32_t)input[7] << 15) |
			((uint32_t)(input[8] & 0xf0) << 7);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 68 to 88
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)input[10] << 12) |
			((uint32_t)(input[11] & 0x80) << 4);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 89 to 109
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xfc) << 9);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 110 to 130
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)input[15] << 14) |
			((uint32_t)(input[16] & 0xe0) << 6);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 131 to 151
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)input[18] << 11);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 152 to 172
	value = ((uint32_t)input[19] << 24) |
			((uint32_t)input[20] << 16) |
			((uint32_t)(input[21] & 0xf8) << 8);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 173 to 193
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xc0) << 5);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 194 to 214
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xfe) << 10);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 215 to 235
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)input[28] << 15) |
			((uint32_t)(input[29] & 0xf0) << 7);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 236 to 256
	value = ((uint32_t)(input[29] & 0x0f) << 28) |
			((uint32_t)input[30] << 20) |
			((uint32_t)input[31] << 12) |
			((uint32_t)(input[32] & 0x80) << 4);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 257 to 277
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0xfc) << 9);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 278 to 298
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)input[36] << 14) |
			((uint32_t)(input[37] & 0xe0) << 6);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 299 to 319
	value = ((uint32_t)(input[37] & 0x1f) << 27) |
			((uint32_t)input[38] << 19) |
			((uint32_t)input[39] << 11);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 320 to 340
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16) |
			((uint32_t)(input[42] & 0xf8) << 8);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 341 to 361
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xc0) << 5);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 362 to 382
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)(input[47] & 0xfe) << 10);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 383 to 403
	value = ((uint32_t)(input[47] & 0x01) << 31) |
			((uint32_t)input[48] << 23) |
			((uint32_t)input[49] << 15) |
			((uint32_t)(input[50] & 0xf0) << 7);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 404 to 424
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)input[52] << 12) |
			((uint32_t)(input[53] & 0x80) << 4);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 425 to 445
	value = ((uint32_t)(input[53] & 0x7f) << 25) |
			((uint32_t)input[54] << 17) |
			((uint32_t)(input[55] & 0xfc) << 9);
	output[20] = (double)(value >> 11);

	// read output[21]: from bit 446 to 466
	value = ((uint32_t)(input[55] & 0x03) << 30) |
			((uint32_t)input[56] << 22) |
			((uint32_t)input[57] << 14) |
			((uint32_t)(input[58] & 0xe0) << 6);
	output[21] = (double)(value >> 11);
}

static void unpack_22_21bit_unsigned_5off(const uint8_t * input, double * output) {
	// Unpack 22 values into output
	// Values are 21-bit unsigned
	// Skip 5 bits, read 462 bits of data.
	// Input must be at least 59 bytes long

	uint32_t value;

	// read output[0]: from bit 5 to 25
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xc0) << 5);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 26 to 46
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)(input[5] & 0xfe) << 10);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 47 to 67
	value = ((uint32_t)(input[5] & 0x01) << 31) |
			((uint32_t)input[6] << 23) |
			((uint32_t)input[7] << 15) |
			((uint32_t)(input[8] & 0xf0) << 7);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 68 to 88
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)input[10] << 12) |
			((uint32_t)(input[11] & 0x80) << 4);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 89 to 109
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xfc) << 9);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 110 to 130
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)input[15] << 14) |
			((uint32_t)(input[16] & 0xe0) << 6);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 131 to 151
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)input[18] << 11);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 152 to 172
	value = ((uint32_t)input[19] << 24) |
			((uint32_t)input[20] << 16) |
			((uint32_t)(input[21] & 0xf8) << 8);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 173 to 193
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xc0) << 5);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 194 to 214
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xfe) << 10);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 215 to 235
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)input[28] << 15) |
			((uint32_t)(input[29] & 0xf0) << 7);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 236 to 256
	value = ((uint32_t)(input[29] & 0x0f) << 28) |
			((uint32_t)input[30] << 20) |
			((uint32_t)input[31] << 12) |
			((uint32_t)(input[32] & 0x80) << 4);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 257 to 277
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0xfc) << 9);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 278 to 298
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)input[36] << 14) |
			((uint32_t)(input[37] & 0xe0) << 6);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 299 to 319
	value = ((uint32_t)(input[37] & 0x1f) << 27) |
			((uint32_t)input[38] << 19) |
			((uint32_t)input[39] << 11);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 320 to 340
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16) |
			((uint32_t)(input[42] & 0xf8) << 8);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 341 to 361
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xc0) << 5);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 362 to 382
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)(input[47] & 0xfe) << 10);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 383 to 403
	value = ((uint32_t)(input[47] & 0x01) << 31) |
			((uint32_t)input[48] << 23) |
			((uint32_t)input[49] << 15) |
			((uint32_t)(input[50] & 0xf0) << 7);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 404 to 424
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)input[52] << 12) |
			((uint32_t)(input[53] & 0x80) << 4);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 425 to 445
	value = ((uint32_t)(input[53] & 0x7f) << 25) |
			((uint32_t)input[54] << 17) |
			((uint32_t)(input[55] & 0xfc) << 9);
	output[20] = (double)(value >> 11);

	// read output[21]: from bit 446 to 466
	value = ((uint32_t)(input[55] & 0x03) << 30) |
			((uint32_t)input[56] << 22) |
			((uint32_t)input[57] << 14) |
			((uint32_t)(input[58] & 0xe0) << 6);
	output[21] = (double)(value >> 11);
}

static void unpack_22_21bit_signed_6off(const uint8_t * input, double * output) {
	// Unpack 22 values into output
	// Values are 21-bit signed
	// Skip 6 bits, read 462 bits of data.
	// Input must be at least 59 bytes long

	int32_t value;

	// read output[0]: from bit 6 to 26
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xe0) << 6);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 27 to 47
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 48 to 68
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)(input[8] & 0xf8) << 8);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 69 to 89
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)input[10] << 13) |
			((uint32_t)(input[11] & 0xc0) << 5);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 90 to 110
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xfe) << 10);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 111 to 131
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)input[15] << 15) |
			((uint32_t)(input[16] & 0xf0) << 7);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 132 to 152
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)input[18] << 12) |
			((uint32_t)(input[19] & 0x80) << 4);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 153 to 173
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xfc) << 9);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 174 to 194
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xe0) << 6);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 195 to 215
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 216 to 236
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)(input[29] & 0xf8) << 8);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 237 to 257
	value = ((uint32_t)(input[29] & 0x07) << 29) |
			((uint32_t)input[30] << 21) |
			((uint32_t)input[31] << 13) |
			((uint32_t)(input[32] & 0xc0) << 5);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 258 to 278
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xfe) << 10);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 279 to 299
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)input[36] << 15) |
			((uint32_t)(input[37] & 0xf0) << 7);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 300 to 320
	value = ((uint32_t)(input[37] & 0x0f) << 28) |
			((uint32_t)input[38] << 20) |
			((uint32_t)input[39] << 12) |
			((uint32_t)(input[40] & 0x80) << 4);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 321 to 341
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0xfc) << 9);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 342 to 362
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xe0) << 6);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 363 to 383
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 384 to 404
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)(input[50] & 0xf8) << 8);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 405 to 425
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)input[52] << 13) |
			((uint32_t)(input[53] & 0xc0) << 5);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 426 to 446
	value = ((uint32_t)(input[53] & 0x3f) << 26) |
			((uint32_t)input[54] << 18) |
			((uint32_t)(input[55] & 0xfe) << 10);
	output[20] = (double)(value >> 11);

	// read output[21]: from bit 447 to 467
	value = ((uint32_t)(input[55] & 0x01) << 31) |
			((uint32_t)input[56] << 23) |
			((uint32_t)input[57] << 15) |
			((uint32_t)(input[58] & 0xf0) << 7);
	output[21] = (double)(value >> 11);
}

static void unpack_22_21bit_unsigned_6off(const uint8_t * input, double * output) {
	// Unpack 22 values into output
	// Values are 21-bit unsigned
	// Skip 6 bits, read 462 bits of data.
	// Input must be at least 59 bytes long

	uint32_t value;

	// read output[0]: from bit 6 to 26
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xe0) << 6);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 27 to 47
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 48 to 68
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)(input[8] & 0xf8) << 8);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 69 to 89
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)input[10] << 13) |
			((uint32_t)(input[11] & 0xc0) << 5);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 90 to 110
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xfe) << 10);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 111 to 131
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)input[15] << 15) |
			((uint32_t)(input[16] & 0xf0) << 7);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 132 to 152
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)input[18] << 12) |
			((uint32_t)(input[19] & 0x80) << 4);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 153 to 173
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xfc) << 9);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 174 to 194
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xe0) << 6);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 195 to 215
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 216 to 236
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)(input[29] & 0xf8) << 8);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 237 to 257
	value = ((uint32_t)(input[29] & 0x07) << 29) |
			((uint32_t)input[30] << 21) |
			((uint32_t)input[31] << 13) |
			((uint32_t)(input[32] & 0xc0) << 5);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 258 to 278
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xfe) << 10);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 279 to 299
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)input[36] << 15) |
			((uint32_t)(input[37] & 0xf0) << 7);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 300 to 320
	value = ((uint32_t)(input[37] & 0x0f) << 28) |
			((uint32_t)input[38] << 20) |
			((uint32_t)input[39] << 12) |
			((uint32_t)(input[40] & 0x80) << 4);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 321 to 341
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0xfc) << 9);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 342 to 362
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xe0) << 6);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 363 to 383
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 384 to 404
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)(input[50] & 0xf8) << 8);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 405 to 425
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)input[52] << 13) |
			((uint32_t)(input[53] & 0xc0) << 5);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 426 to 446
	value = ((uint32_t)(input[53] & 0x3f) << 26) |
			((uint32_t)input[54] << 18) |
			((uint32_t)(input[55] & 0xfe) << 10);
	output[20] = (double)(value >> 11);

	// read output[21]: from bit 447 to 467
	value = ((uint32_t)(input[55] & 0x01) << 31) |
			((uint32_t)input[56] << 23) |
			((uint32_t)input[57] << 15) |
			((uint32_t)(input[58] & 0xf0) << 7);
	output[21] = (double)(value >> 11);
}

static void unpack_22_21bit_signed_7off(const uint8_t * input, double * output) {
	// Unpack 22 values into output
	// Values are 21-bit signed
	// Skip 7 bits, read 462 bits of data.
	// Input must be at least 59 bytes long

	int32_t value;

	// read output[0]: from bit 7 to 27
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xf0) << 7);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 28 to 48
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0x80) << 4);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 49 to 69
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0xfc) << 9);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 70 to 90
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)input[10] << 14) |
			((uint32_t)(input[11] & 0xe0) << 6);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 91 to 111
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)input[13] << 11);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 112 to 132
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16) |
			((uint32_t)(input[16] & 0xf8) << 8);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 133 to 153
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)input[18] << 13) |
			((uint32_t)(input[19] & 0xc0) << 5);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 154 to 174
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xfe) << 10);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 175 to 195
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xf0) << 7);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 196 to 216
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0x80) << 4);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 217 to 237
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)(input[29] & 0xfc) << 9);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 238 to 258
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)input[31] << 14) |
			((uint32_t)(input[32] & 0xe0) << 6);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 259 to 279
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)input[34] << 11);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 280 to 300
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)input[36] << 16) |
			((uint32_t)(input[37] & 0xf8) << 8);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 301 to 321
	value = ((uint32_t)(input[37] & 0x07) << 29) |
			((uint32_t)input[38] << 21) |
			((uint32_t)input[39] << 13) |
			((uint32_t)(input[40] & 0xc0) << 5);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 322 to 342
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xfe) << 10);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 343 to 363
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xf0) << 7);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 364 to 384
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0x80) << 4);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 385 to 405
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0xfc) << 9);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 406 to 426
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)input[52] << 14) |
			((uint32_t)(input[53] & 0xe0) << 6);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 427 to 447
	value = ((uint32_t)(input[53] & 0x1f) << 27) |
			((uint32_t)input[54] << 19) |
			((uint32_t)input[55] << 11);
	output[20] = (double)(value >> 11);

	// read output[21]: from bit 448 to 468
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16) |
			((uint32_t)(input[58] & 0xf8) << 8);
	output[21] = (double)(value >> 11);
}

static void unpack_22_21bit_unsigned_7off(const uint8_t * input, double * output) {
	// Unpack 22 values into output
	// Values are 21-bit unsigned
	// Skip 7 bits, read 462 bits of data.
	// Input must be at least 59 bytes long

	uint32_t value;

	// read output[0]: from bit 7 to 27
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xf0) << 7);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 28 to 48
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0x80) << 4);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 49 to 69
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0xfc) << 9);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 70 to 90
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)input[10] << 14) |
			((uint32_t)(input[11] & 0xe0) << 6);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 91 to 111
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)input[13] << 11);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 112 to 132
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16) |
			((uint32_t)(input[16] & 0xf8) << 8);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 133 to 153
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)input[18] << 13) |
			((uint32_t)(input[19] & 0xc0) << 5);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 154 to 174
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xfe) << 10);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 175 to 195
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xf0) << 7);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 196 to 216
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0x80) << 4);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 217 to 237
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)(input[29] & 0xfc) << 9);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 238 to 258
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)input[31] << 14) |
			((uint32_t)(input[32] & 0xe0) << 6);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 259 to 279
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)input[34] << 11);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 280 to 300
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)input[36] << 16) |
			((uint32_t)(input[37] & 0xf8) << 8);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 301 to 321
	value = ((uint32_t)(input[37] & 0x07) << 29) |
			((uint32_t)input[38] << 21) |
			((uint32_t)input[39] << 13) |
			((uint32_t)(input[40] & 0xc0) << 5);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 322 to 342
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xfe) << 10);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 343 to 363
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xf0) << 7);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 364 to 384
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0x80) << 4);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 385 to 405
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0xfc) << 9);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 406 to 426
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)input[52] << 14) |
			((uint32_t)(input[53] & 0xe0) << 6);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 427 to 447
	value = ((uint32_t)(input[53] & 0x1f) << 27) |
			((uint32_t)input[54] << 19) |
			((uint32_t)input[55] << 11);
	output[20] = (double)(value >> 11);

	// read output[21]: from bit 448 to 468
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16) |
			((uint32_t)(input[58] & 0xf8) << 8);
	output[21] = (double)(value >> 11);
}

static void unpack_23_21bit_signed_0off(const uint8_t * input, double * output) {
	// Unpack 23 values into output
	// Values are 21-bit signed
	// Skip 0 bits, read 483 bits of data.
	// Input must be at least 61 bytes long

	int32_t value;

	// read output[0]: from bit 0 to 20
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0xf8) << 8);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 21 to 41
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)input[4] << 13) |
			((uint32_t)(input[5] & 0xc0) << 5);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 42 to 62
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)input[6] << 18) |
			((uint32_t)(input[7] & 0xfe) << 10);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 63 to 83
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)input[9] << 15) |
			((uint32_t)(input[10] & 0xf0) << 7);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 84 to 104
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)input[12] << 12) |
			((uint32_t)(input[13] & 0x80) << 4);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 105 to 125
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xfc) << 9);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 126 to 146
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xe0) << 6);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 147 to 167
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 168 to 188
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)(input[23] & 0xf8) << 8);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 189 to 209
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)input[25] << 13) |
			((uint32_t)(input[26] & 0xc0) << 5);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 210 to 230
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xfe) << 10);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 231 to 251
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)input[30] << 15) |
			((uint32_t)(input[31] & 0xf0) << 7);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 252 to 272
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20) |
			((uint32_t)input[33] << 12) |
			((uint32_t)(input[34] & 0x80) << 4);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 273 to 293
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0xfc) << 9);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 294 to 314
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xe0) << 6);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 315 to 335
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 336 to 356
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)(input[44] & 0xf8) << 8);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 357 to 377
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)input[46] << 13) |
			((uint32_t)(input[47] & 0xc0) << 5);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 378 to 398
	value = ((uint32_t)(input[47] & 0x3f) << 26) |
			((uint32_t)input[48] << 18) |
			((uint32_t)(input[49] & 0xfe) << 10);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 399 to 419
	value = ((uint32_t)(input[49] & 0x01) << 31) |
			((uint32_t)input[50] << 23) |
			((uint32_t)input[51] << 15) |
			((uint32_t)(input[52] & 0xf0) << 7);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 420 to 440
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)input[54] << 12) |
			((uint32_t)(input[55] & 0x80) << 4);
	output[20] = (double)(value >> 11);

	// read output[21]: from bit 441 to 461
	value = ((uint32_t)(input[55] & 0x7f) << 25) |
			((uint32_t)input[56] << 17) |
			((uint32_t)(input[57] & 0xfc) << 9);
	output[21] = (double)(value >> 11);

	// read output[22]: from bit 462 to 482
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)input[59] << 14) |
			((uint32_t)(input[60] & 0xe0) << 6);
	output[22] = (double)(value >> 11);
}

static void unpack_23_21bit_unsigned_0off(const uint8_t * input, double * output) {
	// Unpack 23 values into output
	// Values are 21-bit unsigned
	// Skip 0 bits, read 483 bits of data.
	// Input must be at least 61 bytes long

	uint32_t value;

	// read output[0]: from bit 0 to 20
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0xf8) << 8);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 21 to 41
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)input[4] << 13) |
			((uint32_t)(input[5] & 0xc0) << 5);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 42 to 62
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)input[6] << 18) |
			((uint32_t)(input[7] & 0xfe) << 10);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 63 to 83
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)input[9] << 15) |
			((uint32_t)(input[10] & 0xf0) << 7);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 84 to 104
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)input[12] << 12) |
			((uint32_t)(input[13] & 0x80) << 4);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 105 to 125
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xfc) << 9);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 126 to 146
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xe0) << 6);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 147 to 167
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 168 to 188
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)(input[23] & 0xf8) << 8);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 189 to 209
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)input[25] << 13) |
			((uint32_t)(input[26] & 0xc0) << 5);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 210 to 230
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xfe) << 10);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 231 to 251
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)input[30] << 15) |
			((uint32_t)(input[31] & 0xf0) << 7);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 252 to 272
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20) |
			((uint32_t)input[33] << 12) |
			((uint32_t)(input[34] & 0x80) << 4);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 273 to 293
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0xfc) << 9);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 294 to 314
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xe0) << 6);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 315 to 335
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 336 to 356
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)(input[44] & 0xf8) << 8);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 357 to 377
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)input[46] << 13) |
			((uint32_t)(input[47] & 0xc0) << 5);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 378 to 398
	value = ((uint32_t)(input[47] & 0x3f) << 26) |
			((uint32_t)input[48] << 18) |
			((uint32_t)(input[49] & 0xfe) << 10);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 399 to 419
	value = ((uint32_t)(input[49] & 0x01) << 31) |
			((uint32_t)input[50] << 23) |
			((uint32_t)input[51] << 15) |
			((uint32_t)(input[52] & 0xf0) << 7);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 420 to 440
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)input[54] << 12) |
			((uint32_t)(input[55] & 0x80) << 4);
	output[20] = (double)(value >> 11);

	// read output[21]: from bit 441 to 461
	value = ((uint32_t)(input[55] & 0x7f) << 25) |
			((uint32_t)input[56] << 17) |
			((uint32_t)(input[57] & 0xfc) << 9);
	output[21] = (double)(value >> 11);

	// read output[22]: from bit 462 to 482
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)input[59] << 14) |
			((uint32_t)(input[60] & 0xe0) << 6);
	output[22] = (double)(value >> 11);
}

static void unpack_23_21bit_signed_1off(const uint8_t * input, double * output) {
	// Unpack 23 values into output
	// Values are 21-bit signed
	// Skip 1 bits, read 483 bits of data.
	// Input must be at least 61 bytes long

	int32_t value;

	// read output[0]: from bit 1 to 21
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xfc) << 9);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 22 to 42
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)input[4] << 14) |
			((uint32_t)(input[5] & 0xe0) << 6);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 43 to 63
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)input[6] << 19) |
			((uint32_t)input[7] << 11);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 64 to 84
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16) |
			((uint32_t)(input[10] & 0xf8) << 8);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 85 to 105
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)input[12] << 13) |
			((uint32_t)(input[13] & 0xc0) << 5);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 106 to 126
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xfe) << 10);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 127 to 147
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xf0) << 7);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 148 to 168
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0x80) << 4);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 169 to 189
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)(input[23] & 0xfc) << 9);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 190 to 210
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)input[25] << 14) |
			((uint32_t)(input[26] & 0xe0) << 6);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 211 to 231
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)input[28] << 11);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 232 to 252
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)input[30] << 16) |
			((uint32_t)(input[31] & 0xf8) << 8);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 253 to 273
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)input[33] << 13) |
			((uint32_t)(input[34] & 0xc0) << 5);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 274 to 294
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xfe) << 10);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 295 to 315
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xf0) << 7);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 316 to 336
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0x80) << 4);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 337 to 357
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0xfc) << 9);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 358 to 378
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)input[46] << 14) |
			((uint32_t)(input[47] & 0xe0) << 6);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 379 to 399
	value = ((uint32_t)(input[47] & 0x1f) << 27) |
			((uint32_t)input[48] << 19) |
			((uint32_t)input[49] << 11);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 400 to 420
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16) |
			((uint32_t)(input[52] & 0xf8) << 8);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 421 to 441
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)input[54] << 13) |
			((uint32_t)(input[55] & 0xc0) << 5);
	output[20] = (double)(value >> 11);

	// read output[21]: from bit 442 to 462
	value = ((uint32_t)(input[55] & 0x3f) << 26) |
			((uint32_t)input[56] << 18) |
			((uint32_t)(input[57] & 0xfe) << 10);
	output[21] = (double)(value >> 11);

	// read output[22]: from bit 463 to 483
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15) |
			((uint32_t)(input[60] & 0xf0) << 7);
	output[22] = (double)(value >> 11);
}

static void unpack_23_21bit_unsigned_1off(const uint8_t * input, double * output) {
	// Unpack 23 values into output
	// Values are 21-bit unsigned
	// Skip 1 bits, read 483 bits of data.
	// Input must be at least 61 bytes long

	uint32_t value;

	// read output[0]: from bit 1 to 21
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xfc) << 9);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 22 to 42
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)input[4] << 14) |
			((uint32_t)(input[5] & 0xe0) << 6);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 43 to 63
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)input[6] << 19) |
			((uint32_t)input[7] << 11);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 64 to 84
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16) |
			((uint32_t)(input[10] & 0xf8) << 8);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 85 to 105
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)input[12] << 13) |
			((uint32_t)(input[13] & 0xc0) << 5);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 106 to 126
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xfe) << 10);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 127 to 147
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xf0) << 7);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 148 to 168
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0x80) << 4);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 169 to 189
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)(input[23] & 0xfc) << 9);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 190 to 210
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)input[25] << 14) |
			((uint32_t)(input[26] & 0xe0) << 6);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 211 to 231
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)input[28] << 11);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 232 to 252
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)input[30] << 16) |
			((uint32_t)(input[31] & 0xf8) << 8);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 253 to 273
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)input[33] << 13) |
			((uint32_t)(input[34] & 0xc0) << 5);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 274 to 294
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xfe) << 10);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 295 to 315
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xf0) << 7);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 316 to 336
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0x80) << 4);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 337 to 357
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0xfc) << 9);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 358 to 378
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)input[46] << 14) |
			((uint32_t)(input[47] & 0xe0) << 6);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 379 to 399
	value = ((uint32_t)(input[47] & 0x1f) << 27) |
			((uint32_t)input[48] << 19) |
			((uint32_t)input[49] << 11);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 400 to 420
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16) |
			((uint32_t)(input[52] & 0xf8) << 8);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 421 to 441
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)input[54] << 13) |
			((uint32_t)(input[55] & 0xc0) << 5);
	output[20] = (double)(value >> 11);

	// read output[21]: from bit 442 to 462
	value = ((uint32_t)(input[55] & 0x3f) << 26) |
			((uint32_t)input[56] << 18) |
			((uint32_t)(input[57] & 0xfe) << 10);
	output[21] = (double)(value >> 11);

	// read output[22]: from bit 463 to 483
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15) |
			((uint32_t)(input[60] & 0xf0) << 7);
	output[22] = (double)(value >> 11);
}

static void unpack_23_21bit_signed_2off(const uint8_t * input, double * output) {
	// Unpack 23 values into output
	// Values are 21-bit signed
	// Skip 2 bits, read 483 bits of data.
	// Input must be at least 61 bytes long

	int32_t value;

	// read output[0]: from bit 2 to 22
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xfe) << 10);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 23 to 43
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15) |
			((uint32_t)(input[5] & 0xf0) << 7);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 44 to 64
	value = ((uint32_t)(input[5] & 0x0f) << 28) |
			((uint32_t)input[6] << 20) |
			((uint32_t)input[7] << 12) |
			((uint32_t)(input[8] & 0x80) << 4);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 65 to 85
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0xfc) << 9);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 86 to 106
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)input[12] << 14) |
			((uint32_t)(input[13] & 0xe0) << 6);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 107 to 127
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)input[15] << 11);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 128 to 148
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16) |
			((uint32_t)(input[18] & 0xf8) << 8);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 149 to 169
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xc0) << 5);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 170 to 190
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xfe) << 10);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 191 to 211
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15) |
			((uint32_t)(input[26] & 0xf0) << 7);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 212 to 232
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)input[28] << 12) |
			((uint32_t)(input[29] & 0x80) << 4);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 233 to 253
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)input[30] << 17) |
			((uint32_t)(input[31] & 0xfc) << 9);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 254 to 274
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)input[33] << 14) |
			((uint32_t)(input[34] & 0xe0) << 6);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 275 to 295
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)input[36] << 11);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 296 to 316
	value = ((uint32_t)input[37] << 24) |
			((uint32_t)input[38] << 16) |
			((uint32_t)(input[39] & 0xf8) << 8);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 317 to 337
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xc0) << 5);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 338 to 358
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xfe) << 10);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 359 to 379
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)input[46] << 15) |
			((uint32_t)(input[47] & 0xf0) << 7);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 380 to 400
	value = ((uint32_t)(input[47] & 0x0f) << 28) |
			((uint32_t)input[48] << 20) |
			((uint32_t)input[49] << 12) |
			((uint32_t)(input[50] & 0x80) << 4);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 401 to 421
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0xfc) << 9);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 422 to 442
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)input[54] << 14) |
			((uint32_t)(input[55] & 0xe0) << 6);
	output[20] = (double)(value >> 11);

	// read output[21]: from bit 443 to 463
	value = ((uint32_t)(input[55] & 0x1f) << 27) |
			((uint32_t)input[56] << 19) |
			((uint32_t)input[57] << 11);
	output[21] = (double)(value >> 11);

	// read output[22]: from bit 464 to 484
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16) |
			((uint32_t)(input[60] & 0xf8) << 8);
	output[22] = (double)(value >> 11);
}

static void unpack_23_21bit_unsigned_2off(const uint8_t * input, double * output) {
	// Unpack 23 values into output
	// Values are 21-bit unsigned
	// Skip 2 bits, read 483 bits of data.
	// Input must be at least 61 bytes long

	uint32_t value;

	// read output[0]: from bit 2 to 22
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xfe) << 10);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 23 to 43
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15) |
			((uint32_t)(input[5] & 0xf0) << 7);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 44 to 64
	value = ((uint32_t)(input[5] & 0x0f) << 28) |
			((uint32_t)input[6] << 20) |
			((uint32_t)input[7] << 12) |
			((uint32_t)(input[8] & 0x80) << 4);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 65 to 85
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0xfc) << 9);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 86 to 106
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)input[12] << 14) |
			((uint32_t)(input[13] & 0xe0) << 6);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 107 to 127
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)input[15] << 11);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 128 to 148
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16) |
			((uint32_t)(input[18] & 0xf8) << 8);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 149 to 169
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xc0) << 5);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 170 to 190
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xfe) << 10);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 191 to 211
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15) |
			((uint32_t)(input[26] & 0xf0) << 7);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 212 to 232
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)input[28] << 12) |
			((uint32_t)(input[29] & 0x80) << 4);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 233 to 253
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)input[30] << 17) |
			((uint32_t)(input[31] & 0xfc) << 9);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 254 to 274
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)input[33] << 14) |
			((uint32_t)(input[34] & 0xe0) << 6);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 275 to 295
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)input[36] << 11);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 296 to 316
	value = ((uint32_t)input[37] << 24) |
			((uint32_t)input[38] << 16) |
			((uint32_t)(input[39] & 0xf8) << 8);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 317 to 337
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xc0) << 5);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 338 to 358
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xfe) << 10);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 359 to 379
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)input[46] << 15) |
			((uint32_t)(input[47] & 0xf0) << 7);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 380 to 400
	value = ((uint32_t)(input[47] & 0x0f) << 28) |
			((uint32_t)input[48] << 20) |
			((uint32_t)input[49] << 12) |
			((uint32_t)(input[50] & 0x80) << 4);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 401 to 421
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0xfc) << 9);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 422 to 442
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)input[54] << 14) |
			((uint32_t)(input[55] & 0xe0) << 6);
	output[20] = (double)(value >> 11);

	// read output[21]: from bit 443 to 463
	value = ((uint32_t)(input[55] & 0x1f) << 27) |
			((uint32_t)input[56] << 19) |
			((uint32_t)input[57] << 11);
	output[21] = (double)(value >> 11);

	// read output[22]: from bit 464 to 484
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16) |
			((uint32_t)(input[60] & 0xf8) << 8);
	output[22] = (double)(value >> 11);
}

static void unpack_23_21bit_signed_3off(const uint8_t * input, double * output) {
	// Unpack 23 values into output
	// Values are 21-bit signed
	// Skip 3 bits, read 483 bits of data.
	// Input must be at least 61 bytes long

	int32_t value;

	// read output[0]: from bit 3 to 23
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 24 to 44
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0xf8) << 8);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 45 to 65
	value = ((uint32_t)(input[5] & 0x07) << 29) |
			((uint32_t)input[6] << 21) |
			((uint32_t)input[7] << 13) |
			((uint32_t)(input[8] & 0xc0) << 5);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 66 to 86
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xfe) << 10);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 87 to 107
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15) |
			((uint32_t)(input[13] & 0xf0) << 7);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 108 to 128
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)input[15] << 12) |
			((uint32_t)(input[16] & 0x80) << 4);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 129 to 149
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0xfc) << 9);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 150 to 170
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xe0) << 6);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 171 to 191
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 192 to 212
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0xf8) << 8);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 213 to 233
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)input[28] << 13) |
			((uint32_t)(input[29] & 0xc0) << 5);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 234 to 254
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)input[30] << 18) |
			((uint32_t)(input[31] & 0xfe) << 10);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 255 to 275
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)input[33] << 15) |
			((uint32_t)(input[34] & 0xf0) << 7);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 276 to 296
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)input[36] << 12) |
			((uint32_t)(input[37] & 0x80) << 4);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 297 to 317
	value = ((uint32_t)(input[37] & 0x7f) << 25) |
			((uint32_t)input[38] << 17) |
			((uint32_t)(input[39] & 0xfc) << 9);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 318 to 338
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xe0) << 6);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 339 to 359
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 360 to 380
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)(input[47] & 0xf8) << 8);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 381 to 401
	value = ((uint32_t)(input[47] & 0x07) << 29) |
			((uint32_t)input[48] << 21) |
			((uint32_t)input[49] << 13) |
			((uint32_t)(input[50] & 0xc0) << 5);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 402 to 422
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xfe) << 10);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 423 to 443
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)input[54] << 15) |
			((uint32_t)(input[55] & 0xf0) << 7);
	output[20] = (double)(value >> 11);

	// read output[21]: from bit 444 to 464
	value = ((uint32_t)(input[55] & 0x0f) << 28) |
			((uint32_t)input[56] << 20) |
			((uint32_t)input[57] << 12) |
			((uint32_t)(input[58] & 0x80) << 4);
	output[21] = (double)(value >> 11);

	// read output[22]: from bit 465 to 485
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0xfc) << 9);
	output[22] = (double)(value >> 11);
}

static void unpack_23_21bit_unsigned_3off(const uint8_t * input, double * output) {
	// Unpack 23 values into output
	// Values are 21-bit unsigned
	// Skip 3 bits, read 483 bits of data.
	// Input must be at least 61 bytes long

	uint32_t value;

	// read output[0]: from bit 3 to 23
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 24 to 44
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0xf8) << 8);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 45 to 65
	value = ((uint32_t)(input[5] & 0x07) << 29) |
			((uint32_t)input[6] << 21) |
			((uint32_t)input[7] << 13) |
			((uint32_t)(input[8] & 0xc0) << 5);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 66 to 86
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xfe) << 10);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 87 to 107
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15) |
			((uint32_t)(input[13] & 0xf0) << 7);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 108 to 128
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)input[15] << 12) |
			((uint32_t)(input[16] & 0x80) << 4);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 129 to 149
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0xfc) << 9);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 150 to 170
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xe0) << 6);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 171 to 191
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 192 to 212
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0xf8) << 8);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 213 to 233
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)input[28] << 13) |
			((uint32_t)(input[29] & 0xc0) << 5);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 234 to 254
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)input[30] << 18) |
			((uint32_t)(input[31] & 0xfe) << 10);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 255 to 275
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)input[33] << 15) |
			((uint32_t)(input[34] & 0xf0) << 7);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 276 to 296
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)input[36] << 12) |
			((uint32_t)(input[37] & 0x80) << 4);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 297 to 317
	value = ((uint32_t)(input[37] & 0x7f) << 25) |
			((uint32_t)input[38] << 17) |
			((uint32_t)(input[39] & 0xfc) << 9);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 318 to 338
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xe0) << 6);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 339 to 359
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 360 to 380
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)(input[47] & 0xf8) << 8);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 381 to 401
	value = ((uint32_t)(input[47] & 0x07) << 29) |
			((uint32_t)input[48] << 21) |
			((uint32_t)input[49] << 13) |
			((uint32_t)(input[50] & 0xc0) << 5);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 402 to 422
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xfe) << 10);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 423 to 443
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)input[54] << 15) |
			((uint32_t)(input[55] & 0xf0) << 7);
	output[20] = (double)(value >> 11);

	// read output[21]: from bit 444 to 464
	value = ((uint32_t)(input[55] & 0x0f) << 28) |
			((uint32_t)input[56] << 20) |
			((uint32_t)input[57] << 12) |
			((uint32_t)(input[58] & 0x80) << 4);
	output[21] = (double)(value >> 11);

	// read output[22]: from bit 465 to 485
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0xfc) << 9);
	output[22] = (double)(value >> 11);
}

static void unpack_23_21bit_signed_4off(const uint8_t * input, double * output) {
	// Unpack 23 values into output
	// Values are 21-bit signed
	// Skip 4 bits, read 483 bits of data.
	// Input must be at least 61 bytes long

	int32_t value;

	// read output[0]: from bit 4 to 24
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0x80) << 4);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 25 to 45
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)(input[5] & 0xfc) << 9);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 46 to 66
	value = ((uint32_t)(input[5] & 0x03) << 30) |
			((uint32_t)input[6] << 22) |
			((uint32_t)input[7] << 14) |
			((uint32_t)(input[8] & 0xe0) << 6);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 67 to 87
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)input[10] << 11);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 88 to 108
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0xf8) << 8);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 109 to 129
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)input[15] << 13) |
			((uint32_t)(input[16] & 0xc0) << 5);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 130 to 150
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xfe) << 10);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 151 to 171
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xf0) << 7);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 172 to 192
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0x80) << 4);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 193 to 213
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xfc) << 9);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 214 to 234
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)input[28] << 14) |
			((uint32_t)(input[29] & 0xe0) << 6);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 235 to 255
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)input[30] << 19) |
			((uint32_t)input[31] << 11);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 256 to 276
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16) |
			((uint32_t)(input[34] & 0xf8) << 8);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 277 to 297
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)input[36] << 13) |
			((uint32_t)(input[37] & 0xc0) << 5);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 298 to 318
	value = ((uint32_t)(input[37] & 0x3f) << 26) |
			((uint32_t)input[38] << 18) |
			((uint32_t)(input[39] & 0xfe) << 10);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 319 to 339
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xf0) << 7);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 340 to 360
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0x80) << 4);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 361 to 381
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)(input[47] & 0xfc) << 9);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 382 to 402
	value = ((uint32_t)(input[47] & 0x03) << 30) |
			((uint32_t)input[48] << 22) |
			((uint32_t)input[49] << 14) |
			((uint32_t)(input[50] & 0xe0) << 6);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 403 to 423
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)input[52] << 11);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 424 to 444
	value = ((uint32_t)input[53] << 24) |
			((uint32_t)input[54] << 16) |
			((uint32_t)(input[55] & 0xf8) << 8);
	output[20] = (double)(value >> 11);

	// read output[21]: from bit 445 to 465
	value = ((uint32_t)(input[55] & 0x07) << 29) |
			((uint32_t)input[56] << 21) |
			((uint32_t)input[57] << 13) |
			((uint32_t)(input[58] & 0xc0) << 5);
	output[21] = (double)(value >> 11);

	// read output[22]: from bit 466 to 486
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xfe) << 10);
	output[22] = (double)(value >> 11);
}

static void unpack_23_21bit_unsigned_4off(const uint8_t * input, double * output) {
	// Unpack 23 values into output
	// Values are 21-bit unsigned
	// Skip 4 bits, read 483 bits of data.
	// Input must be at least 61 bytes long

	uint32_t value;

	// read output[0]: from bit 4 to 24
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0x80) << 4);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 25 to 45
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)(input[5] & 0xfc) << 9);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 46 to 66
	value = ((uint32_t)(input[5] & 0x03) << 30) |
			((uint32_t)input[6] << 22) |
			((uint32_t)input[7] << 14) |
			((uint32_t)(input[8] & 0xe0) << 6);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 67 to 87
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)input[10] << 11);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 88 to 108
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0xf8) << 8);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 109 to 129
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)input[15] << 13) |
			((uint32_t)(input[16] & 0xc0) << 5);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 130 to 150
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xfe) << 10);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 151 to 171
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xf0) << 7);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 172 to 192
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0x80) << 4);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 193 to 213
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xfc) << 9);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 214 to 234
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)input[28] << 14) |
			((uint32_t)(input[29] & 0xe0) << 6);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 235 to 255
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)input[30] << 19) |
			((uint32_t)input[31] << 11);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 256 to 276
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16) |
			((uint32_t)(input[34] & 0xf8) << 8);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 277 to 297
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)input[36] << 13) |
			((uint32_t)(input[37] & 0xc0) << 5);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 298 to 318
	value = ((uint32_t)(input[37] & 0x3f) << 26) |
			((uint32_t)input[38] << 18) |
			((uint32_t)(input[39] & 0xfe) << 10);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 319 to 339
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xf0) << 7);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 340 to 360
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0x80) << 4);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 361 to 381
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)(input[47] & 0xfc) << 9);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 382 to 402
	value = ((uint32_t)(input[47] & 0x03) << 30) |
			((uint32_t)input[48] << 22) |
			((uint32_t)input[49] << 14) |
			((uint32_t)(input[50] & 0xe0) << 6);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 403 to 423
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)input[52] << 11);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 424 to 444
	value = ((uint32_t)input[53] << 24) |
			((uint32_t)input[54] << 16) |
			((uint32_t)(input[55] & 0xf8) << 8);
	output[20] = (double)(value >> 11);

	// read output[21]: from bit 445 to 465
	value = ((uint32_t)(input[55] & 0x07) << 29) |
			((uint32_t)input[56] << 21) |
			((uint32_t)input[57] << 13) |
			((uint32_t)(input[58] & 0xc0) << 5);
	output[21] = (double)(value >> 11);

	// read output[22]: from bit 466 to 486
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xfe) << 10);
	output[22] = (double)(value >> 11);
}

static void unpack_23_21bit_signed_5off(const uint8_t * input, double * output) {
	// Unpack 23 values into output
	// Values are 21-bit signed
	// Skip 5 bits, read 483 bits of data.
	// Input must be at least 61 bytes long

	int32_t value;

	// read output[0]: from bit 5 to 25
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xc0) << 5);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 26 to 46
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)(input[5] & 0xfe) << 10);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 47 to 67
	value = ((uint32_t)(input[5] & 0x01) << 31) |
			((uint32_t)input[6] << 23) |
			((uint32_t)input[7] << 15) |
			((uint32_t)(input[8] & 0xf0) << 7);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 68 to 88
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)input[10] << 12) |
			((uint32_t)(input[11] & 0x80) << 4);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 89 to 109
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xfc) << 9);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 110 to 130
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)input[15] << 14) |
			((uint32_t)(input[16] & 0xe0) << 6);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 131 to 151
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)input[18] << 11);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 152 to 172
	value = ((uint32_t)input[19] << 24) |
			((uint32_t)input[20] << 16) |
			((uint32_t)(input[21] & 0xf8) << 8);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 173 to 193
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xc0) << 5);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 194 to 214
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xfe) << 10);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 215 to 235
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)input[28] << 15) |
			((uint32_t)(input[29] & 0xf0) << 7);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 236 to 256
	value = ((uint32_t)(input[29] & 0x0f) << 28) |
			((uint32_t)input[30] << 20) |
			((uint32_t)input[31] << 12) |
			((uint32_t)(input[32] & 0x80) << 4);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 257 to 277
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0xfc) << 9);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 278 to 298
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)input[36] << 14) |
			((uint32_t)(input[37] & 0xe0) << 6);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 299 to 319
	value = ((uint32_t)(input[37] & 0x1f) << 27) |
			((uint32_t)input[38] << 19) |
			((uint32_t)input[39] << 11);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 320 to 340
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16) |
			((uint32_t)(input[42] & 0xf8) << 8);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 341 to 361
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xc0) << 5);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 362 to 382
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)(input[47] & 0xfe) << 10);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 383 to 403
	value = ((uint32_t)(input[47] & 0x01) << 31) |
			((uint32_t)input[48] << 23) |
			((uint32_t)input[49] << 15) |
			((uint32_t)(input[50] & 0xf0) << 7);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 404 to 424
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)input[52] << 12) |
			((uint32_t)(input[53] & 0x80) << 4);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 425 to 445
	value = ((uint32_t)(input[53] & 0x7f) << 25) |
			((uint32_t)input[54] << 17) |
			((uint32_t)(input[55] & 0xfc) << 9);
	output[20] = (double)(value >> 11);

	// read output[21]: from bit 446 to 466
	value = ((uint32_t)(input[55] & 0x03) << 30) |
			((uint32_t)input[56] << 22) |
			((uint32_t)input[57] << 14) |
			((uint32_t)(input[58] & 0xe0) << 6);
	output[21] = (double)(value >> 11);

	// read output[22]: from bit 467 to 487
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)input[60] << 11);
	output[22] = (double)(value >> 11);
}

static void unpack_23_21bit_unsigned_5off(const uint8_t * input, double * output) {
	// Unpack 23 values into output
	// Values are 21-bit unsigned
	// Skip 5 bits, read 483 bits of data.
	// Input must be at least 61 bytes long

	uint32_t value;

	// read output[0]: from bit 5 to 25
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xc0) << 5);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 26 to 46
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)(input[5] & 0xfe) << 10);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 47 to 67
	value = ((uint32_t)(input[5] & 0x01) << 31) |
			((uint32_t)input[6] << 23) |
			((uint32_t)input[7] << 15) |
			((uint32_t)(input[8] & 0xf0) << 7);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 68 to 88
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)input[10] << 12) |
			((uint32_t)(input[11] & 0x80) << 4);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 89 to 109
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xfc) << 9);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 110 to 130
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)input[15] << 14) |
			((uint32_t)(input[16] & 0xe0) << 6);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 131 to 151
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)input[18] << 11);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 152 to 172
	value = ((uint32_t)input[19] << 24) |
			((uint32_t)input[20] << 16) |
			((uint32_t)(input[21] & 0xf8) << 8);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 173 to 193
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xc0) << 5);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 194 to 214
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xfe) << 10);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 215 to 235
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)input[28] << 15) |
			((uint32_t)(input[29] & 0xf0) << 7);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 236 to 256
	value = ((uint32_t)(input[29] & 0x0f) << 28) |
			((uint32_t)input[30] << 20) |
			((uint32_t)input[31] << 12) |
			((uint32_t)(input[32] & 0x80) << 4);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 257 to 277
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0xfc) << 9);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 278 to 298
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)input[36] << 14) |
			((uint32_t)(input[37] & 0xe0) << 6);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 299 to 319
	value = ((uint32_t)(input[37] & 0x1f) << 27) |
			((uint32_t)input[38] << 19) |
			((uint32_t)input[39] << 11);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 320 to 340
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16) |
			((uint32_t)(input[42] & 0xf8) << 8);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 341 to 361
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xc0) << 5);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 362 to 382
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)(input[47] & 0xfe) << 10);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 383 to 403
	value = ((uint32_t)(input[47] & 0x01) << 31) |
			((uint32_t)input[48] << 23) |
			((uint32_t)input[49] << 15) |
			((uint32_t)(input[50] & 0xf0) << 7);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 404 to 424
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)input[52] << 12) |
			((uint32_t)(input[53] & 0x80) << 4);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 425 to 445
	value = ((uint32_t)(input[53] & 0x7f) << 25) |
			((uint32_t)input[54] << 17) |
			((uint32_t)(input[55] & 0xfc) << 9);
	output[20] = (double)(value >> 11);

	// read output[21]: from bit 446 to 466
	value = ((uint32_t)(input[55] & 0x03) << 30) |
			((uint32_t)input[56] << 22) |
			((uint32_t)input[57] << 14) |
			((uint32_t)(input[58] & 0xe0) << 6);
	output[21] = (double)(value >> 11);

	// read output[22]: from bit 467 to 487
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)input[60] << 11);
	output[22] = (double)(value >> 11);
}

static void unpack_23_21bit_signed_6off(const uint8_t * input, double * output) {
	// Unpack 23 values into output
	// Values are 21-bit signed
	// Skip 6 bits, read 483 bits of data.
	// Input must be at least 62 bytes long

	int32_t value;

	// read output[0]: from bit 6 to 26
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xe0) << 6);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 27 to 47
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 48 to 68
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)(input[8] & 0xf8) << 8);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 69 to 89
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)input[10] << 13) |
			((uint32_t)(input[11] & 0xc0) << 5);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 90 to 110
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xfe) << 10);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 111 to 131
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)input[15] << 15) |
			((uint32_t)(input[16] & 0xf0) << 7);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 132 to 152
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)input[18] << 12) |
			((uint32_t)(input[19] & 0x80) << 4);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 153 to 173
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xfc) << 9);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 174 to 194
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xe0) << 6);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 195 to 215
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 216 to 236
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)(input[29] & 0xf8) << 8);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 237 to 257
	value = ((uint32_t)(input[29] & 0x07) << 29) |
			((uint32_t)input[30] << 21) |
			((uint32_t)input[31] << 13) |
			((uint32_t)(input[32] & 0xc0) << 5);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 258 to 278
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xfe) << 10);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 279 to 299
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)input[36] << 15) |
			((uint32_t)(input[37] & 0xf0) << 7);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 300 to 320
	value = ((uint32_t)(input[37] & 0x0f) << 28) |
			((uint32_t)input[38] << 20) |
			((uint32_t)input[39] << 12) |
			((uint32_t)(input[40] & 0x80) << 4);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 321 to 341
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0xfc) << 9);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 342 to 362
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xe0) << 6);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 363 to 383
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 384 to 404
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)(input[50] & 0xf8) << 8);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 405 to 425
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)input[52] << 13) |
			((uint32_t)(input[53] & 0xc0) << 5);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 426 to 446
	value = ((uint32_t)(input[53] & 0x3f) << 26) |
			((uint32_t)input[54] << 18) |
			((uint32_t)(input[55] & 0xfe) << 10);
	output[20] = (double)(value >> 11);

	// read output[21]: from bit 447 to 467
	value = ((uint32_t)(input[55] & 0x01) << 31) |
			((uint32_t)input[56] << 23) |
			((uint32_t)input[57] << 15) |
			((uint32_t)(input[58] & 0xf0) << 7);
	output[21] = (double)(value >> 11);

	// read output[22]: from bit 468 to 488
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)input[60] << 12) |
			((uint32_t)(input[61] & 0x80) << 4);
	output[22] = (double)(value >> 11);
}

static void unpack_23_21bit_unsigned_6off(const uint8_t * input, double * output) {
	// Unpack 23 values into output
	// Values are 21-bit unsigned
	// Skip 6 bits, read 483 bits of data.
	// Input must be at least 62 bytes long

	uint32_t value;

	// read output[0]: from bit 6 to 26
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xe0) << 6);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 27 to 47
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 48 to 68
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)(input[8] & 0xf8) << 8);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 69 to 89
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)input[10] << 13) |
			((uint32_t)(input[11] & 0xc0) << 5);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 90 to 110
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xfe) << 10);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 111 to 131
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)input[15] << 15) |
			((uint32_t)(input[16] & 0xf0) << 7);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 132 to 152
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)input[18] << 12) |
			((uint32_t)(input[19] & 0x80) << 4);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 153 to 173
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xfc) << 9);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 174 to 194
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xe0) << 6);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 195 to 215
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 216 to 236
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)(input[29] & 0xf8) << 8);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 237 to 257
	value = ((uint32_t)(input[29] & 0x07) << 29) |
			((uint32_t)input[30] << 21) |
			((uint32_t)input[31] << 13) |
			((uint32_t)(input[32] & 0xc0) << 5);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 258 to 278
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xfe) << 10);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 279 to 299
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)input[36] << 15) |
			((uint32_t)(input[37] & 0xf0) << 7);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 300 to 320
	value = ((uint32_t)(input[37] & 0x0f) << 28) |
			((uint32_t)input[38] << 20) |
			((uint32_t)input[39] << 12) |
			((uint32_t)(input[40] & 0x80) << 4);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 321 to 341
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0xfc) << 9);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 342 to 362
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xe0) << 6);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 363 to 383
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 384 to 404
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)(input[50] & 0xf8) << 8);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 405 to 425
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)input[52] << 13) |
			((uint32_t)(input[53] & 0xc0) << 5);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 426 to 446
	value = ((uint32_t)(input[53] & 0x3f) << 26) |
			((uint32_t)input[54] << 18) |
			((uint32_t)(input[55] & 0xfe) << 10);
	output[20] = (double)(value >> 11);

	// read output[21]: from bit 447 to 467
	value = ((uint32_t)(input[55] & 0x01) << 31) |
			((uint32_t)input[56] << 23) |
			((uint32_t)input[57] << 15) |
			((uint32_t)(input[58] & 0xf0) << 7);
	output[21] = (double)(value >> 11);

	// read output[22]: from bit 468 to 488
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)input[60] << 12) |
			((uint32_t)(input[61] & 0x80) << 4);
	output[22] = (double)(value >> 11);
}

static void unpack_23_21bit_signed_7off(const uint8_t * input, double * output) {
	// Unpack 23 values into output
	// Values are 21-bit signed
	// Skip 7 bits, read 483 bits of data.
	// Input must be at least 62 bytes long

	int32_t value;

	// read output[0]: from bit 7 to 27
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xf0) << 7);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 28 to 48
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0x80) << 4);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 49 to 69
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0xfc) << 9);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 70 to 90
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)input[10] << 14) |
			((uint32_t)(input[11] & 0xe0) << 6);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 91 to 111
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)input[13] << 11);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 112 to 132
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16) |
			((uint32_t)(input[16] & 0xf8) << 8);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 133 to 153
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)input[18] << 13) |
			((uint32_t)(input[19] & 0xc0) << 5);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 154 to 174
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xfe) << 10);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 175 to 195
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xf0) << 7);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 196 to 216
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0x80) << 4);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 217 to 237
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)(input[29] & 0xfc) << 9);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 238 to 258
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)input[31] << 14) |
			((uint32_t)(input[32] & 0xe0) << 6);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 259 to 279
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)input[34] << 11);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 280 to 300
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)input[36] << 16) |
			((uint32_t)(input[37] & 0xf8) << 8);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 301 to 321
	value = ((uint32_t)(input[37] & 0x07) << 29) |
			((uint32_t)input[38] << 21) |
			((uint32_t)input[39] << 13) |
			((uint32_t)(input[40] & 0xc0) << 5);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 322 to 342
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xfe) << 10);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 343 to 363
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xf0) << 7);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 364 to 384
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0x80) << 4);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 385 to 405
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0xfc) << 9);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 406 to 426
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)input[52] << 14) |
			((uint32_t)(input[53] & 0xe0) << 6);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 427 to 447
	value = ((uint32_t)(input[53] & 0x1f) << 27) |
			((uint32_t)input[54] << 19) |
			((uint32_t)input[55] << 11);
	output[20] = (double)(value >> 11);

	// read output[21]: from bit 448 to 468
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16) |
			((uint32_t)(input[58] & 0xf8) << 8);
	output[21] = (double)(value >> 11);

	// read output[22]: from bit 469 to 489
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)input[60] << 13) |
			((uint32_t)(input[61] & 0xc0) << 5);
	output[22] = (double)(value >> 11);
}

static void unpack_23_21bit_unsigned_7off(const uint8_t * input, double * output) {
	// Unpack 23 values into output
	// Values are 21-bit unsigned
	// Skip 7 bits, read 483 bits of data.
	// Input must be at least 62 bytes long

	uint32_t value;

	// read output[0]: from bit 7 to 27
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xf0) << 7);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 28 to 48
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0x80) << 4);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 49 to 69
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0xfc) << 9);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 70 to 90
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)input[10] << 14) |
			((uint32_t)(input[11] & 0xe0) << 6);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 91 to 111
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)input[13] << 11);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 112 to 132
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16) |
			((uint32_t)(input[16] & 0xf8) << 8);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 133 to 153
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)input[18] << 13) |
			((uint32_t)(input[19] & 0xc0) << 5);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 154 to 174
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xfe) << 10);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 175 to 195
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xf0) << 7);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 196 to 216
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0x80) << 4);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 217 to 237
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)(input[29] & 0xfc) << 9);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 238 to 258
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)input[31] << 14) |
			((uint32_t)(input[32] & 0xe0) << 6);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 259 to 279
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)input[34] << 11);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 280 to 300
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)input[36] << 16) |
			((uint32_t)(input[37] & 0xf8) << 8);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 301 to 321
	value = ((uint32_t)(input[37] & 0x07) << 29) |
			((uint32_t)input[38] << 21) |
			((uint32_t)input[39] << 13) |
			((uint32_t)(input[40] & 0xc0) << 5);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 322 to 342
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xfe) << 10);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 343 to 363
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xf0) << 7);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 364 to 384
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0x80) << 4);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 385 to 405
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0xfc) << 9);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 406 to 426
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)input[52] << 14) |
			((uint32_t)(input[53] & 0xe0) << 6);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 427 to 447
	value = ((uint32_t)(input[53] & 0x1f) << 27) |
			((uint32_t)input[54] << 19) |
			((uint32_t)input[55] << 11);
	output[20] = (double)(value >> 11);

	// read output[21]: from bit 448 to 468
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16) |
			((uint32_t)(input[58] & 0xf8) << 8);
	output[21] = (double)(value >> 11);

	// read output[22]: from bit 469 to 489
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)input[60] << 13) |
			((uint32_t)(input[61] & 0xc0) << 5);
	output[22] = (double)(value >> 11);
}

static void unpack_24_21bit_signed_0off(const uint8_t * input, double * output) {
	// Unpack 24 values into output
	// Values are 21-bit signed
	// Skip 0 bits, read 504 bits of data.
	// Input must be at least 63 bytes long

	int32_t value;

	// read output[0]: from bit 0 to 20
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0xf8) << 8);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 21 to 41
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)input[4] << 13) |
			((uint32_t)(input[5] & 0xc0) << 5);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 42 to 62
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)input[6] << 18) |
			((uint32_t)(input[7] & 0xfe) << 10);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 63 to 83
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)input[9] << 15) |
			((uint32_t)(input[10] & 0xf0) << 7);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 84 to 104
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)input[12] << 12) |
			((uint32_t)(input[13] & 0x80) << 4);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 105 to 125
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xfc) << 9);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 126 to 146
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xe0) << 6);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 147 to 167
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 168 to 188
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)(input[23] & 0xf8) << 8);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 189 to 209
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)input[25] << 13) |
			((uint32_t)(input[26] & 0xc0) << 5);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 210 to 230
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xfe) << 10);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 231 to 251
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)input[30] << 15) |
			((uint32_t)(input[31] & 0xf0) << 7);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 252 to 272
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20) |
			((uint32_t)input[33] << 12) |
			((uint32_t)(input[34] & 0x80) << 4);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 273 to 293
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0xfc) << 9);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 294 to 314
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xe0) << 6);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 315 to 335
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 336 to 356
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)(input[44] & 0xf8) << 8);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 357 to 377
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)input[46] << 13) |
			((uint32_t)(input[47] & 0xc0) << 5);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 378 to 398
	value = ((uint32_t)(input[47] & 0x3f) << 26) |
			((uint32_t)input[48] << 18) |
			((uint32_t)(input[49] & 0xfe) << 10);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 399 to 419
	value = ((uint32_t)(input[49] & 0x01) << 31) |
			((uint32_t)input[50] << 23) |
			((uint32_t)input[51] << 15) |
			((uint32_t)(input[52] & 0xf0) << 7);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 420 to 440
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)input[54] << 12) |
			((uint32_t)(input[55] & 0x80) << 4);
	output[20] = (double)(value >> 11);

	// read output[21]: from bit 441 to 461
	value = ((uint32_t)(input[55] & 0x7f) << 25) |
			((uint32_t)input[56] << 17) |
			((uint32_t)(input[57] & 0xfc) << 9);
	output[21] = (double)(value >> 11);

	// read output[22]: from bit 462 to 482
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)input[59] << 14) |
			((uint32_t)(input[60] & 0xe0) << 6);
	output[22] = (double)(value >> 11);

	// read output[23]: from bit 483 to 503
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)input[62] << 11);
	output[23] = (double)(value >> 11);
}

static void unpack_24_21bit_unsigned_0off(const uint8_t * input, double * output) {
	// Unpack 24 values into output
	// Values are 21-bit unsigned
	// Skip 0 bits, read 504 bits of data.
	// Input must be at least 63 bytes long

	uint32_t value;

	// read output[0]: from bit 0 to 20
	value = ((uint32_t)input[0] << 24) |
			((uint32_t)input[1] << 16) |
			((uint32_t)(input[2] & 0xf8) << 8);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 21 to 41
	value = ((uint32_t)(input[2] & 0x07) << 29) |
			((uint32_t)input[3] << 21) |
			((uint32_t)input[4] << 13) |
			((uint32_t)(input[5] & 0xc0) << 5);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 42 to 62
	value = ((uint32_t)(input[5] & 0x3f) << 26) |
			((uint32_t)input[6] << 18) |
			((uint32_t)(input[7] & 0xfe) << 10);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 63 to 83
	value = ((uint32_t)(input[7] & 0x01) << 31) |
			((uint32_t)input[8] << 23) |
			((uint32_t)input[9] << 15) |
			((uint32_t)(input[10] & 0xf0) << 7);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 84 to 104
	value = ((uint32_t)(input[10] & 0x0f) << 28) |
			((uint32_t)input[11] << 20) |
			((uint32_t)input[12] << 12) |
			((uint32_t)(input[13] & 0x80) << 4);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 105 to 125
	value = ((uint32_t)(input[13] & 0x7f) << 25) |
			((uint32_t)input[14] << 17) |
			((uint32_t)(input[15] & 0xfc) << 9);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 126 to 146
	value = ((uint32_t)(input[15] & 0x03) << 30) |
			((uint32_t)input[16] << 22) |
			((uint32_t)input[17] << 14) |
			((uint32_t)(input[18] & 0xe0) << 6);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 147 to 167
	value = ((uint32_t)(input[18] & 0x1f) << 27) |
			((uint32_t)input[19] << 19) |
			((uint32_t)input[20] << 11);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 168 to 188
	value = ((uint32_t)input[21] << 24) |
			((uint32_t)input[22] << 16) |
			((uint32_t)(input[23] & 0xf8) << 8);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 189 to 209
	value = ((uint32_t)(input[23] & 0x07) << 29) |
			((uint32_t)input[24] << 21) |
			((uint32_t)input[25] << 13) |
			((uint32_t)(input[26] & 0xc0) << 5);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 210 to 230
	value = ((uint32_t)(input[26] & 0x3f) << 26) |
			((uint32_t)input[27] << 18) |
			((uint32_t)(input[28] & 0xfe) << 10);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 231 to 251
	value = ((uint32_t)(input[28] & 0x01) << 31) |
			((uint32_t)input[29] << 23) |
			((uint32_t)input[30] << 15) |
			((uint32_t)(input[31] & 0xf0) << 7);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 252 to 272
	value = ((uint32_t)(input[31] & 0x0f) << 28) |
			((uint32_t)input[32] << 20) |
			((uint32_t)input[33] << 12) |
			((uint32_t)(input[34] & 0x80) << 4);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 273 to 293
	value = ((uint32_t)(input[34] & 0x7f) << 25) |
			((uint32_t)input[35] << 17) |
			((uint32_t)(input[36] & 0xfc) << 9);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 294 to 314
	value = ((uint32_t)(input[36] & 0x03) << 30) |
			((uint32_t)input[37] << 22) |
			((uint32_t)input[38] << 14) |
			((uint32_t)(input[39] & 0xe0) << 6);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 315 to 335
	value = ((uint32_t)(input[39] & 0x1f) << 27) |
			((uint32_t)input[40] << 19) |
			((uint32_t)input[41] << 11);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 336 to 356
	value = ((uint32_t)input[42] << 24) |
			((uint32_t)input[43] << 16) |
			((uint32_t)(input[44] & 0xf8) << 8);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 357 to 377
	value = ((uint32_t)(input[44] & 0x07) << 29) |
			((uint32_t)input[45] << 21) |
			((uint32_t)input[46] << 13) |
			((uint32_t)(input[47] & 0xc0) << 5);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 378 to 398
	value = ((uint32_t)(input[47] & 0x3f) << 26) |
			((uint32_t)input[48] << 18) |
			((uint32_t)(input[49] & 0xfe) << 10);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 399 to 419
	value = ((uint32_t)(input[49] & 0x01) << 31) |
			((uint32_t)input[50] << 23) |
			((uint32_t)input[51] << 15) |
			((uint32_t)(input[52] & 0xf0) << 7);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 420 to 440
	value = ((uint32_t)(input[52] & 0x0f) << 28) |
			((uint32_t)input[53] << 20) |
			((uint32_t)input[54] << 12) |
			((uint32_t)(input[55] & 0x80) << 4);
	output[20] = (double)(value >> 11);

	// read output[21]: from bit 441 to 461
	value = ((uint32_t)(input[55] & 0x7f) << 25) |
			((uint32_t)input[56] << 17) |
			((uint32_t)(input[57] & 0xfc) << 9);
	output[21] = (double)(value >> 11);

	// read output[22]: from bit 462 to 482
	value = ((uint32_t)(input[57] & 0x03) << 30) |
			((uint32_t)input[58] << 22) |
			((uint32_t)input[59] << 14) |
			((uint32_t)(input[60] & 0xe0) << 6);
	output[22] = (double)(value >> 11);

	// read output[23]: from bit 483 to 503
	value = ((uint32_t)(input[60] & 0x1f) << 27) |
			((uint32_t)input[61] << 19) |
			((uint32_t)input[62] << 11);
	output[23] = (double)(value >> 11);
}

static void unpack_24_21bit_signed_1off(const uint8_t * input, double * output) {
	// Unpack 24 values into output
	// Values are 21-bit signed
	// Skip 1 bits, read 504 bits of data.
	// Input must be at least 64 bytes long

	int32_t value;

	// read output[0]: from bit 1 to 21
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xfc) << 9);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 22 to 42
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)input[4] << 14) |
			((uint32_t)(input[5] & 0xe0) << 6);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 43 to 63
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)input[6] << 19) |
			((uint32_t)input[7] << 11);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 64 to 84
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16) |
			((uint32_t)(input[10] & 0xf8) << 8);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 85 to 105
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)input[12] << 13) |
			((uint32_t)(input[13] & 0xc0) << 5);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 106 to 126
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xfe) << 10);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 127 to 147
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xf0) << 7);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 148 to 168
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0x80) << 4);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 169 to 189
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)(input[23] & 0xfc) << 9);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 190 to 210
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)input[25] << 14) |
			((uint32_t)(input[26] & 0xe0) << 6);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 211 to 231
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)input[28] << 11);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 232 to 252
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)input[30] << 16) |
			((uint32_t)(input[31] & 0xf8) << 8);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 253 to 273
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)input[33] << 13) |
			((uint32_t)(input[34] & 0xc0) << 5);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 274 to 294
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xfe) << 10);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 295 to 315
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xf0) << 7);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 316 to 336
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0x80) << 4);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 337 to 357
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0xfc) << 9);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 358 to 378
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)input[46] << 14) |
			((uint32_t)(input[47] & 0xe0) << 6);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 379 to 399
	value = ((uint32_t)(input[47] & 0x1f) << 27) |
			((uint32_t)input[48] << 19) |
			((uint32_t)input[49] << 11);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 400 to 420
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16) |
			((uint32_t)(input[52] & 0xf8) << 8);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 421 to 441
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)input[54] << 13) |
			((uint32_t)(input[55] & 0xc0) << 5);
	output[20] = (double)(value >> 11);

	// read output[21]: from bit 442 to 462
	value = ((uint32_t)(input[55] & 0x3f) << 26) |
			((uint32_t)input[56] << 18) |
			((uint32_t)(input[57] & 0xfe) << 10);
	output[21] = (double)(value >> 11);

	// read output[22]: from bit 463 to 483
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15) |
			((uint32_t)(input[60] & 0xf0) << 7);
	output[22] = (double)(value >> 11);

	// read output[23]: from bit 484 to 504
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)input[62] << 12) |
			((uint32_t)(input[63] & 0x80) << 4);
	output[23] = (double)(value >> 11);
}

static void unpack_24_21bit_unsigned_1off(const uint8_t * input, double * output) {
	// Unpack 24 values into output
	// Values are 21-bit unsigned
	// Skip 1 bits, read 504 bits of data.
	// Input must be at least 64 bytes long

	uint32_t value;

	// read output[0]: from bit 1 to 21
	value = ((uint32_t)(input[0] & 0x7f) << 25) |
			((uint32_t)input[1] << 17) |
			((uint32_t)(input[2] & 0xfc) << 9);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 22 to 42
	value = ((uint32_t)(input[2] & 0x03) << 30) |
			((uint32_t)input[3] << 22) |
			((uint32_t)input[4] << 14) |
			((uint32_t)(input[5] & 0xe0) << 6);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 43 to 63
	value = ((uint32_t)(input[5] & 0x1f) << 27) |
			((uint32_t)input[6] << 19) |
			((uint32_t)input[7] << 11);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 64 to 84
	value = ((uint32_t)input[8] << 24) |
			((uint32_t)input[9] << 16) |
			((uint32_t)(input[10] & 0xf8) << 8);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 85 to 105
	value = ((uint32_t)(input[10] & 0x07) << 29) |
			((uint32_t)input[11] << 21) |
			((uint32_t)input[12] << 13) |
			((uint32_t)(input[13] & 0xc0) << 5);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 106 to 126
	value = ((uint32_t)(input[13] & 0x3f) << 26) |
			((uint32_t)input[14] << 18) |
			((uint32_t)(input[15] & 0xfe) << 10);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 127 to 147
	value = ((uint32_t)(input[15] & 0x01) << 31) |
			((uint32_t)input[16] << 23) |
			((uint32_t)input[17] << 15) |
			((uint32_t)(input[18] & 0xf0) << 7);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 148 to 168
	value = ((uint32_t)(input[18] & 0x0f) << 28) |
			((uint32_t)input[19] << 20) |
			((uint32_t)input[20] << 12) |
			((uint32_t)(input[21] & 0x80) << 4);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 169 to 189
	value = ((uint32_t)(input[21] & 0x7f) << 25) |
			((uint32_t)input[22] << 17) |
			((uint32_t)(input[23] & 0xfc) << 9);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 190 to 210
	value = ((uint32_t)(input[23] & 0x03) << 30) |
			((uint32_t)input[24] << 22) |
			((uint32_t)input[25] << 14) |
			((uint32_t)(input[26] & 0xe0) << 6);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 211 to 231
	value = ((uint32_t)(input[26] & 0x1f) << 27) |
			((uint32_t)input[27] << 19) |
			((uint32_t)input[28] << 11);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 232 to 252
	value = ((uint32_t)input[29] << 24) |
			((uint32_t)input[30] << 16) |
			((uint32_t)(input[31] & 0xf8) << 8);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 253 to 273
	value = ((uint32_t)(input[31] & 0x07) << 29) |
			((uint32_t)input[32] << 21) |
			((uint32_t)input[33] << 13) |
			((uint32_t)(input[34] & 0xc0) << 5);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 274 to 294
	value = ((uint32_t)(input[34] & 0x3f) << 26) |
			((uint32_t)input[35] << 18) |
			((uint32_t)(input[36] & 0xfe) << 10);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 295 to 315
	value = ((uint32_t)(input[36] & 0x01) << 31) |
			((uint32_t)input[37] << 23) |
			((uint32_t)input[38] << 15) |
			((uint32_t)(input[39] & 0xf0) << 7);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 316 to 336
	value = ((uint32_t)(input[39] & 0x0f) << 28) |
			((uint32_t)input[40] << 20) |
			((uint32_t)input[41] << 12) |
			((uint32_t)(input[42] & 0x80) << 4);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 337 to 357
	value = ((uint32_t)(input[42] & 0x7f) << 25) |
			((uint32_t)input[43] << 17) |
			((uint32_t)(input[44] & 0xfc) << 9);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 358 to 378
	value = ((uint32_t)(input[44] & 0x03) << 30) |
			((uint32_t)input[45] << 22) |
			((uint32_t)input[46] << 14) |
			((uint32_t)(input[47] & 0xe0) << 6);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 379 to 399
	value = ((uint32_t)(input[47] & 0x1f) << 27) |
			((uint32_t)input[48] << 19) |
			((uint32_t)input[49] << 11);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 400 to 420
	value = ((uint32_t)input[50] << 24) |
			((uint32_t)input[51] << 16) |
			((uint32_t)(input[52] & 0xf8) << 8);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 421 to 441
	value = ((uint32_t)(input[52] & 0x07) << 29) |
			((uint32_t)input[53] << 21) |
			((uint32_t)input[54] << 13) |
			((uint32_t)(input[55] & 0xc0) << 5);
	output[20] = (double)(value >> 11);

	// read output[21]: from bit 442 to 462
	value = ((uint32_t)(input[55] & 0x3f) << 26) |
			((uint32_t)input[56] << 18) |
			((uint32_t)(input[57] & 0xfe) << 10);
	output[21] = (double)(value >> 11);

	// read output[22]: from bit 463 to 483
	value = ((uint32_t)(input[57] & 0x01) << 31) |
			((uint32_t)input[58] << 23) |
			((uint32_t)input[59] << 15) |
			((uint32_t)(input[60] & 0xf0) << 7);
	output[22] = (double)(value >> 11);

	// read output[23]: from bit 484 to 504
	value = ((uint32_t)(input[60] & 0x0f) << 28) |
			((uint32_t)input[61] << 20) |
			((uint32_t)input[62] << 12) |
			((uint32_t)(input[63] & 0x80) << 4);
	output[23] = (double)(value >> 11);
}

static void unpack_24_21bit_signed_2off(const uint8_t * input, double * output) {
	// Unpack 24 values into output
	// Values are 21-bit signed
	// Skip 2 bits, read 504 bits of data.
	// Input must be at least 64 bytes long

	int32_t value;

	// read output[0]: from bit 2 to 22
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xfe) << 10);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 23 to 43
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15) |
			((uint32_t)(input[5] & 0xf0) << 7);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 44 to 64
	value = ((uint32_t)(input[5] & 0x0f) << 28) |
			((uint32_t)input[6] << 20) |
			((uint32_t)input[7] << 12) |
			((uint32_t)(input[8] & 0x80) << 4);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 65 to 85
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0xfc) << 9);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 86 to 106
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)input[12] << 14) |
			((uint32_t)(input[13] & 0xe0) << 6);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 107 to 127
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)input[15] << 11);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 128 to 148
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16) |
			((uint32_t)(input[18] & 0xf8) << 8);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 149 to 169
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xc0) << 5);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 170 to 190
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xfe) << 10);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 191 to 211
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15) |
			((uint32_t)(input[26] & 0xf0) << 7);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 212 to 232
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)input[28] << 12) |
			((uint32_t)(input[29] & 0x80) << 4);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 233 to 253
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)input[30] << 17) |
			((uint32_t)(input[31] & 0xfc) << 9);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 254 to 274
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)input[33] << 14) |
			((uint32_t)(input[34] & 0xe0) << 6);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 275 to 295
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)input[36] << 11);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 296 to 316
	value = ((uint32_t)input[37] << 24) |
			((uint32_t)input[38] << 16) |
			((uint32_t)(input[39] & 0xf8) << 8);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 317 to 337
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xc0) << 5);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 338 to 358
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xfe) << 10);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 359 to 379
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)input[46] << 15) |
			((uint32_t)(input[47] & 0xf0) << 7);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 380 to 400
	value = ((uint32_t)(input[47] & 0x0f) << 28) |
			((uint32_t)input[48] << 20) |
			((uint32_t)input[49] << 12) |
			((uint32_t)(input[50] & 0x80) << 4);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 401 to 421
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0xfc) << 9);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 422 to 442
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)input[54] << 14) |
			((uint32_t)(input[55] & 0xe0) << 6);
	output[20] = (double)(value >> 11);

	// read output[21]: from bit 443 to 463
	value = ((uint32_t)(input[55] & 0x1f) << 27) |
			((uint32_t)input[56] << 19) |
			((uint32_t)input[57] << 11);
	output[21] = (double)(value >> 11);

	// read output[22]: from bit 464 to 484
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16) |
			((uint32_t)(input[60] & 0xf8) << 8);
	output[22] = (double)(value >> 11);

	// read output[23]: from bit 485 to 505
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)input[62] << 13) |
			((uint32_t)(input[63] & 0xc0) << 5);
	output[23] = (double)(value >> 11);
}

static void unpack_24_21bit_unsigned_2off(const uint8_t * input, double * output) {
	// Unpack 24 values into output
	// Values are 21-bit unsigned
	// Skip 2 bits, read 504 bits of data.
	// Input must be at least 64 bytes long

	uint32_t value;

	// read output[0]: from bit 2 to 22
	value = ((uint32_t)(input[0] & 0x3f) << 26) |
			((uint32_t)input[1] << 18) |
			((uint32_t)(input[2] & 0xfe) << 10);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 23 to 43
	value = ((uint32_t)(input[2] & 0x01) << 31) |
			((uint32_t)input[3] << 23) |
			((uint32_t)input[4] << 15) |
			((uint32_t)(input[5] & 0xf0) << 7);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 44 to 64
	value = ((uint32_t)(input[5] & 0x0f) << 28) |
			((uint32_t)input[6] << 20) |
			((uint32_t)input[7] << 12) |
			((uint32_t)(input[8] & 0x80) << 4);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 65 to 85
	value = ((uint32_t)(input[8] & 0x7f) << 25) |
			((uint32_t)input[9] << 17) |
			((uint32_t)(input[10] & 0xfc) << 9);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 86 to 106
	value = ((uint32_t)(input[10] & 0x03) << 30) |
			((uint32_t)input[11] << 22) |
			((uint32_t)input[12] << 14) |
			((uint32_t)(input[13] & 0xe0) << 6);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 107 to 127
	value = ((uint32_t)(input[13] & 0x1f) << 27) |
			((uint32_t)input[14] << 19) |
			((uint32_t)input[15] << 11);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 128 to 148
	value = ((uint32_t)input[16] << 24) |
			((uint32_t)input[17] << 16) |
			((uint32_t)(input[18] & 0xf8) << 8);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 149 to 169
	value = ((uint32_t)(input[18] & 0x07) << 29) |
			((uint32_t)input[19] << 21) |
			((uint32_t)input[20] << 13) |
			((uint32_t)(input[21] & 0xc0) << 5);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 170 to 190
	value = ((uint32_t)(input[21] & 0x3f) << 26) |
			((uint32_t)input[22] << 18) |
			((uint32_t)(input[23] & 0xfe) << 10);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 191 to 211
	value = ((uint32_t)(input[23] & 0x01) << 31) |
			((uint32_t)input[24] << 23) |
			((uint32_t)input[25] << 15) |
			((uint32_t)(input[26] & 0xf0) << 7);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 212 to 232
	value = ((uint32_t)(input[26] & 0x0f) << 28) |
			((uint32_t)input[27] << 20) |
			((uint32_t)input[28] << 12) |
			((uint32_t)(input[29] & 0x80) << 4);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 233 to 253
	value = ((uint32_t)(input[29] & 0x7f) << 25) |
			((uint32_t)input[30] << 17) |
			((uint32_t)(input[31] & 0xfc) << 9);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 254 to 274
	value = ((uint32_t)(input[31] & 0x03) << 30) |
			((uint32_t)input[32] << 22) |
			((uint32_t)input[33] << 14) |
			((uint32_t)(input[34] & 0xe0) << 6);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 275 to 295
	value = ((uint32_t)(input[34] & 0x1f) << 27) |
			((uint32_t)input[35] << 19) |
			((uint32_t)input[36] << 11);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 296 to 316
	value = ((uint32_t)input[37] << 24) |
			((uint32_t)input[38] << 16) |
			((uint32_t)(input[39] & 0xf8) << 8);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 317 to 337
	value = ((uint32_t)(input[39] & 0x07) << 29) |
			((uint32_t)input[40] << 21) |
			((uint32_t)input[41] << 13) |
			((uint32_t)(input[42] & 0xc0) << 5);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 338 to 358
	value = ((uint32_t)(input[42] & 0x3f) << 26) |
			((uint32_t)input[43] << 18) |
			((uint32_t)(input[44] & 0xfe) << 10);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 359 to 379
	value = ((uint32_t)(input[44] & 0x01) << 31) |
			((uint32_t)input[45] << 23) |
			((uint32_t)input[46] << 15) |
			((uint32_t)(input[47] & 0xf0) << 7);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 380 to 400
	value = ((uint32_t)(input[47] & 0x0f) << 28) |
			((uint32_t)input[48] << 20) |
			((uint32_t)input[49] << 12) |
			((uint32_t)(input[50] & 0x80) << 4);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 401 to 421
	value = ((uint32_t)(input[50] & 0x7f) << 25) |
			((uint32_t)input[51] << 17) |
			((uint32_t)(input[52] & 0xfc) << 9);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 422 to 442
	value = ((uint32_t)(input[52] & 0x03) << 30) |
			((uint32_t)input[53] << 22) |
			((uint32_t)input[54] << 14) |
			((uint32_t)(input[55] & 0xe0) << 6);
	output[20] = (double)(value >> 11);

	// read output[21]: from bit 443 to 463
	value = ((uint32_t)(input[55] & 0x1f) << 27) |
			((uint32_t)input[56] << 19) |
			((uint32_t)input[57] << 11);
	output[21] = (double)(value >> 11);

	// read output[22]: from bit 464 to 484
	value = ((uint32_t)input[58] << 24) |
			((uint32_t)input[59] << 16) |
			((uint32_t)(input[60] & 0xf8) << 8);
	output[22] = (double)(value >> 11);

	// read output[23]: from bit 485 to 505
	value = ((uint32_t)(input[60] & 0x07) << 29) |
			((uint32_t)input[61] << 21) |
			((uint32_t)input[62] << 13) |
			((uint32_t)(input[63] & 0xc0) << 5);
	output[23] = (double)(value >> 11);
}

static void unpack_24_21bit_signed_3off(const uint8_t * input, double * output) {
	// Unpack 24 values into output
	// Values are 21-bit signed
	// Skip 3 bits, read 504 bits of data.
	// Input must be at least 64 bytes long

	int32_t value;

	// read output[0]: from bit 3 to 23
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 24 to 44
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0xf8) << 8);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 45 to 65
	value = ((uint32_t)(input[5] & 0x07) << 29) |
			((uint32_t)input[6] << 21) |
			((uint32_t)input[7] << 13) |
			((uint32_t)(input[8] & 0xc0) << 5);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 66 to 86
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xfe) << 10);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 87 to 107
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15) |
			((uint32_t)(input[13] & 0xf0) << 7);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 108 to 128
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)input[15] << 12) |
			((uint32_t)(input[16] & 0x80) << 4);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 129 to 149
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0xfc) << 9);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 150 to 170
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xe0) << 6);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 171 to 191
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 192 to 212
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0xf8) << 8);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 213 to 233
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)input[28] << 13) |
			((uint32_t)(input[29] & 0xc0) << 5);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 234 to 254
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)input[30] << 18) |
			((uint32_t)(input[31] & 0xfe) << 10);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 255 to 275
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)input[33] << 15) |
			((uint32_t)(input[34] & 0xf0) << 7);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 276 to 296
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)input[36] << 12) |
			((uint32_t)(input[37] & 0x80) << 4);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 297 to 317
	value = ((uint32_t)(input[37] & 0x7f) << 25) |
			((uint32_t)input[38] << 17) |
			((uint32_t)(input[39] & 0xfc) << 9);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 318 to 338
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xe0) << 6);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 339 to 359
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 360 to 380
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)(input[47] & 0xf8) << 8);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 381 to 401
	value = ((uint32_t)(input[47] & 0x07) << 29) |
			((uint32_t)input[48] << 21) |
			((uint32_t)input[49] << 13) |
			((uint32_t)(input[50] & 0xc0) << 5);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 402 to 422
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xfe) << 10);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 423 to 443
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)input[54] << 15) |
			((uint32_t)(input[55] & 0xf0) << 7);
	output[20] = (double)(value >> 11);

	// read output[21]: from bit 444 to 464
	value = ((uint32_t)(input[55] & 0x0f) << 28) |
			((uint32_t)input[56] << 20) |
			((uint32_t)input[57] << 12) |
			((uint32_t)(input[58] & 0x80) << 4);
	output[21] = (double)(value >> 11);

	// read output[22]: from bit 465 to 485
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0xfc) << 9);
	output[22] = (double)(value >> 11);

	// read output[23]: from bit 486 to 506
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)input[62] << 14) |
			((uint32_t)(input[63] & 0xe0) << 6);
	output[23] = (double)(value >> 11);
}

static void unpack_24_21bit_unsigned_3off(const uint8_t * input, double * output) {
	// Unpack 24 values into output
	// Values are 21-bit unsigned
	// Skip 3 bits, read 504 bits of data.
	// Input must be at least 64 bytes long

	uint32_t value;

	// read output[0]: from bit 3 to 23
	value = ((uint32_t)(input[0] & 0x1f) << 27) |
			((uint32_t)input[1] << 19) |
			((uint32_t)input[2] << 11);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 24 to 44
	value = ((uint32_t)input[3] << 24) |
			((uint32_t)input[4] << 16) |
			((uint32_t)(input[5] & 0xf8) << 8);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 45 to 65
	value = ((uint32_t)(input[5] & 0x07) << 29) |
			((uint32_t)input[6] << 21) |
			((uint32_t)input[7] << 13) |
			((uint32_t)(input[8] & 0xc0) << 5);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 66 to 86
	value = ((uint32_t)(input[8] & 0x3f) << 26) |
			((uint32_t)input[9] << 18) |
			((uint32_t)(input[10] & 0xfe) << 10);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 87 to 107
	value = ((uint32_t)(input[10] & 0x01) << 31) |
			((uint32_t)input[11] << 23) |
			((uint32_t)input[12] << 15) |
			((uint32_t)(input[13] & 0xf0) << 7);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 108 to 128
	value = ((uint32_t)(input[13] & 0x0f) << 28) |
			((uint32_t)input[14] << 20) |
			((uint32_t)input[15] << 12) |
			((uint32_t)(input[16] & 0x80) << 4);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 129 to 149
	value = ((uint32_t)(input[16] & 0x7f) << 25) |
			((uint32_t)input[17] << 17) |
			((uint32_t)(input[18] & 0xfc) << 9);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 150 to 170
	value = ((uint32_t)(input[18] & 0x03) << 30) |
			((uint32_t)input[19] << 22) |
			((uint32_t)input[20] << 14) |
			((uint32_t)(input[21] & 0xe0) << 6);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 171 to 191
	value = ((uint32_t)(input[21] & 0x1f) << 27) |
			((uint32_t)input[22] << 19) |
			((uint32_t)input[23] << 11);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 192 to 212
	value = ((uint32_t)input[24] << 24) |
			((uint32_t)input[25] << 16) |
			((uint32_t)(input[26] & 0xf8) << 8);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 213 to 233
	value = ((uint32_t)(input[26] & 0x07) << 29) |
			((uint32_t)input[27] << 21) |
			((uint32_t)input[28] << 13) |
			((uint32_t)(input[29] & 0xc0) << 5);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 234 to 254
	value = ((uint32_t)(input[29] & 0x3f) << 26) |
			((uint32_t)input[30] << 18) |
			((uint32_t)(input[31] & 0xfe) << 10);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 255 to 275
	value = ((uint32_t)(input[31] & 0x01) << 31) |
			((uint32_t)input[32] << 23) |
			((uint32_t)input[33] << 15) |
			((uint32_t)(input[34] & 0xf0) << 7);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 276 to 296
	value = ((uint32_t)(input[34] & 0x0f) << 28) |
			((uint32_t)input[35] << 20) |
			((uint32_t)input[36] << 12) |
			((uint32_t)(input[37] & 0x80) << 4);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 297 to 317
	value = ((uint32_t)(input[37] & 0x7f) << 25) |
			((uint32_t)input[38] << 17) |
			((uint32_t)(input[39] & 0xfc) << 9);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 318 to 338
	value = ((uint32_t)(input[39] & 0x03) << 30) |
			((uint32_t)input[40] << 22) |
			((uint32_t)input[41] << 14) |
			((uint32_t)(input[42] & 0xe0) << 6);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 339 to 359
	value = ((uint32_t)(input[42] & 0x1f) << 27) |
			((uint32_t)input[43] << 19) |
			((uint32_t)input[44] << 11);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 360 to 380
	value = ((uint32_t)input[45] << 24) |
			((uint32_t)input[46] << 16) |
			((uint32_t)(input[47] & 0xf8) << 8);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 381 to 401
	value = ((uint32_t)(input[47] & 0x07) << 29) |
			((uint32_t)input[48] << 21) |
			((uint32_t)input[49] << 13) |
			((uint32_t)(input[50] & 0xc0) << 5);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 402 to 422
	value = ((uint32_t)(input[50] & 0x3f) << 26) |
			((uint32_t)input[51] << 18) |
			((uint32_t)(input[52] & 0xfe) << 10);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 423 to 443
	value = ((uint32_t)(input[52] & 0x01) << 31) |
			((uint32_t)input[53] << 23) |
			((uint32_t)input[54] << 15) |
			((uint32_t)(input[55] & 0xf0) << 7);
	output[20] = (double)(value >> 11);

	// read output[21]: from bit 444 to 464
	value = ((uint32_t)(input[55] & 0x0f) << 28) |
			((uint32_t)input[56] << 20) |
			((uint32_t)input[57] << 12) |
			((uint32_t)(input[58] & 0x80) << 4);
	output[21] = (double)(value >> 11);

	// read output[22]: from bit 465 to 485
	value = ((uint32_t)(input[58] & 0x7f) << 25) |
			((uint32_t)input[59] << 17) |
			((uint32_t)(input[60] & 0xfc) << 9);
	output[22] = (double)(value >> 11);

	// read output[23]: from bit 486 to 506
	value = ((uint32_t)(input[60] & 0x03) << 30) |
			((uint32_t)input[61] << 22) |
			((uint32_t)input[62] << 14) |
			((uint32_t)(input[63] & 0xe0) << 6);
	output[23] = (double)(value >> 11);
}

static void unpack_24_21bit_signed_4off(const uint8_t * input, double * output) {
	// Unpack 24 values into output
	// Values are 21-bit signed
	// Skip 4 bits, read 504 bits of data.
	// Input must be at least 64 bytes long

	int32_t value;

	// read output[0]: from bit 4 to 24
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0x80) << 4);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 25 to 45
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)(input[5] & 0xfc) << 9);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 46 to 66
	value = ((uint32_t)(input[5] & 0x03) << 30) |
			((uint32_t)input[6] << 22) |
			((uint32_t)input[7] << 14) |
			((uint32_t)(input[8] & 0xe0) << 6);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 67 to 87
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)input[10] << 11);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 88 to 108
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0xf8) << 8);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 109 to 129
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)input[15] << 13) |
			((uint32_t)(input[16] & 0xc0) << 5);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 130 to 150
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xfe) << 10);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 151 to 171
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xf0) << 7);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 172 to 192
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0x80) << 4);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 193 to 213
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xfc) << 9);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 214 to 234
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)input[28] << 14) |
			((uint32_t)(input[29] & 0xe0) << 6);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 235 to 255
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)input[30] << 19) |
			((uint32_t)input[31] << 11);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 256 to 276
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16) |
			((uint32_t)(input[34] & 0xf8) << 8);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 277 to 297
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)input[36] << 13) |
			((uint32_t)(input[37] & 0xc0) << 5);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 298 to 318
	value = ((uint32_t)(input[37] & 0x3f) << 26) |
			((uint32_t)input[38] << 18) |
			((uint32_t)(input[39] & 0xfe) << 10);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 319 to 339
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xf0) << 7);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 340 to 360
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0x80) << 4);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 361 to 381
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)(input[47] & 0xfc) << 9);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 382 to 402
	value = ((uint32_t)(input[47] & 0x03) << 30) |
			((uint32_t)input[48] << 22) |
			((uint32_t)input[49] << 14) |
			((uint32_t)(input[50] & 0xe0) << 6);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 403 to 423
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)input[52] << 11);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 424 to 444
	value = ((uint32_t)input[53] << 24) |
			((uint32_t)input[54] << 16) |
			((uint32_t)(input[55] & 0xf8) << 8);
	output[20] = (double)(value >> 11);

	// read output[21]: from bit 445 to 465
	value = ((uint32_t)(input[55] & 0x07) << 29) |
			((uint32_t)input[56] << 21) |
			((uint32_t)input[57] << 13) |
			((uint32_t)(input[58] & 0xc0) << 5);
	output[21] = (double)(value >> 11);

	// read output[22]: from bit 466 to 486
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xfe) << 10);
	output[22] = (double)(value >> 11);

	// read output[23]: from bit 487 to 507
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)input[62] << 15) |
			((uint32_t)(input[63] & 0xf0) << 7);
	output[23] = (double)(value >> 11);
}

static void unpack_24_21bit_unsigned_4off(const uint8_t * input, double * output) {
	// Unpack 24 values into output
	// Values are 21-bit unsigned
	// Skip 4 bits, read 504 bits of data.
	// Input must be at least 64 bytes long

	uint32_t value;

	// read output[0]: from bit 4 to 24
	value = ((uint32_t)(input[0] & 0x0f) << 28) |
			((uint32_t)input[1] << 20) |
			((uint32_t)input[2] << 12) |
			((uint32_t)(input[3] & 0x80) << 4);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 25 to 45
	value = ((uint32_t)(input[3] & 0x7f) << 25) |
			((uint32_t)input[4] << 17) |
			((uint32_t)(input[5] & 0xfc) << 9);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 46 to 66
	value = ((uint32_t)(input[5] & 0x03) << 30) |
			((uint32_t)input[6] << 22) |
			((uint32_t)input[7] << 14) |
			((uint32_t)(input[8] & 0xe0) << 6);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 67 to 87
	value = ((uint32_t)(input[8] & 0x1f) << 27) |
			((uint32_t)input[9] << 19) |
			((uint32_t)input[10] << 11);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 88 to 108
	value = ((uint32_t)input[11] << 24) |
			((uint32_t)input[12] << 16) |
			((uint32_t)(input[13] & 0xf8) << 8);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 109 to 129
	value = ((uint32_t)(input[13] & 0x07) << 29) |
			((uint32_t)input[14] << 21) |
			((uint32_t)input[15] << 13) |
			((uint32_t)(input[16] & 0xc0) << 5);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 130 to 150
	value = ((uint32_t)(input[16] & 0x3f) << 26) |
			((uint32_t)input[17] << 18) |
			((uint32_t)(input[18] & 0xfe) << 10);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 151 to 171
	value = ((uint32_t)(input[18] & 0x01) << 31) |
			((uint32_t)input[19] << 23) |
			((uint32_t)input[20] << 15) |
			((uint32_t)(input[21] & 0xf0) << 7);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 172 to 192
	value = ((uint32_t)(input[21] & 0x0f) << 28) |
			((uint32_t)input[22] << 20) |
			((uint32_t)input[23] << 12) |
			((uint32_t)(input[24] & 0x80) << 4);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 193 to 213
	value = ((uint32_t)(input[24] & 0x7f) << 25) |
			((uint32_t)input[25] << 17) |
			((uint32_t)(input[26] & 0xfc) << 9);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 214 to 234
	value = ((uint32_t)(input[26] & 0x03) << 30) |
			((uint32_t)input[27] << 22) |
			((uint32_t)input[28] << 14) |
			((uint32_t)(input[29] & 0xe0) << 6);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 235 to 255
	value = ((uint32_t)(input[29] & 0x1f) << 27) |
			((uint32_t)input[30] << 19) |
			((uint32_t)input[31] << 11);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 256 to 276
	value = ((uint32_t)input[32] << 24) |
			((uint32_t)input[33] << 16) |
			((uint32_t)(input[34] & 0xf8) << 8);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 277 to 297
	value = ((uint32_t)(input[34] & 0x07) << 29) |
			((uint32_t)input[35] << 21) |
			((uint32_t)input[36] << 13) |
			((uint32_t)(input[37] & 0xc0) << 5);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 298 to 318
	value = ((uint32_t)(input[37] & 0x3f) << 26) |
			((uint32_t)input[38] << 18) |
			((uint32_t)(input[39] & 0xfe) << 10);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 319 to 339
	value = ((uint32_t)(input[39] & 0x01) << 31) |
			((uint32_t)input[40] << 23) |
			((uint32_t)input[41] << 15) |
			((uint32_t)(input[42] & 0xf0) << 7);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 340 to 360
	value = ((uint32_t)(input[42] & 0x0f) << 28) |
			((uint32_t)input[43] << 20) |
			((uint32_t)input[44] << 12) |
			((uint32_t)(input[45] & 0x80) << 4);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 361 to 381
	value = ((uint32_t)(input[45] & 0x7f) << 25) |
			((uint32_t)input[46] << 17) |
			((uint32_t)(input[47] & 0xfc) << 9);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 382 to 402
	value = ((uint32_t)(input[47] & 0x03) << 30) |
			((uint32_t)input[48] << 22) |
			((uint32_t)input[49] << 14) |
			((uint32_t)(input[50] & 0xe0) << 6);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 403 to 423
	value = ((uint32_t)(input[50] & 0x1f) << 27) |
			((uint32_t)input[51] << 19) |
			((uint32_t)input[52] << 11);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 424 to 444
	value = ((uint32_t)input[53] << 24) |
			((uint32_t)input[54] << 16) |
			((uint32_t)(input[55] & 0xf8) << 8);
	output[20] = (double)(value >> 11);

	// read output[21]: from bit 445 to 465
	value = ((uint32_t)(input[55] & 0x07) << 29) |
			((uint32_t)input[56] << 21) |
			((uint32_t)input[57] << 13) |
			((uint32_t)(input[58] & 0xc0) << 5);
	output[21] = (double)(value >> 11);

	// read output[22]: from bit 466 to 486
	value = ((uint32_t)(input[58] & 0x3f) << 26) |
			((uint32_t)input[59] << 18) |
			((uint32_t)(input[60] & 0xfe) << 10);
	output[22] = (double)(value >> 11);

	// read output[23]: from bit 487 to 507
	value = ((uint32_t)(input[60] & 0x01) << 31) |
			((uint32_t)input[61] << 23) |
			((uint32_t)input[62] << 15) |
			((uint32_t)(input[63] & 0xf0) << 7);
	output[23] = (double)(value >> 11);
}

static void unpack_24_21bit_signed_5off(const uint8_t * input, double * output) {
	// Unpack 24 values into output
	// Values are 21-bit signed
	// Skip 5 bits, read 504 bits of data.
	// Input must be at least 64 bytes long

	int32_t value;

	// read output[0]: from bit 5 to 25
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xc0) << 5);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 26 to 46
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)(input[5] & 0xfe) << 10);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 47 to 67
	value = ((uint32_t)(input[5] & 0x01) << 31) |
			((uint32_t)input[6] << 23) |
			((uint32_t)input[7] << 15) |
			((uint32_t)(input[8] & 0xf0) << 7);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 68 to 88
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)input[10] << 12) |
			((uint32_t)(input[11] & 0x80) << 4);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 89 to 109
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xfc) << 9);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 110 to 130
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)input[15] << 14) |
			((uint32_t)(input[16] & 0xe0) << 6);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 131 to 151
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)input[18] << 11);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 152 to 172
	value = ((uint32_t)input[19] << 24) |
			((uint32_t)input[20] << 16) |
			((uint32_t)(input[21] & 0xf8) << 8);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 173 to 193
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xc0) << 5);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 194 to 214
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xfe) << 10);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 215 to 235
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)input[28] << 15) |
			((uint32_t)(input[29] & 0xf0) << 7);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 236 to 256
	value = ((uint32_t)(input[29] & 0x0f) << 28) |
			((uint32_t)input[30] << 20) |
			((uint32_t)input[31] << 12) |
			((uint32_t)(input[32] & 0x80) << 4);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 257 to 277
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0xfc) << 9);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 278 to 298
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)input[36] << 14) |
			((uint32_t)(input[37] & 0xe0) << 6);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 299 to 319
	value = ((uint32_t)(input[37] & 0x1f) << 27) |
			((uint32_t)input[38] << 19) |
			((uint32_t)input[39] << 11);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 320 to 340
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16) |
			((uint32_t)(input[42] & 0xf8) << 8);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 341 to 361
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xc0) << 5);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 362 to 382
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)(input[47] & 0xfe) << 10);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 383 to 403
	value = ((uint32_t)(input[47] & 0x01) << 31) |
			((uint32_t)input[48] << 23) |
			((uint32_t)input[49] << 15) |
			((uint32_t)(input[50] & 0xf0) << 7);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 404 to 424
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)input[52] << 12) |
			((uint32_t)(input[53] & 0x80) << 4);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 425 to 445
	value = ((uint32_t)(input[53] & 0x7f) << 25) |
			((uint32_t)input[54] << 17) |
			((uint32_t)(input[55] & 0xfc) << 9);
	output[20] = (double)(value >> 11);

	// read output[21]: from bit 446 to 466
	value = ((uint32_t)(input[55] & 0x03) << 30) |
			((uint32_t)input[56] << 22) |
			((uint32_t)input[57] << 14) |
			((uint32_t)(input[58] & 0xe0) << 6);
	output[21] = (double)(value >> 11);

	// read output[22]: from bit 467 to 487
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)input[60] << 11);
	output[22] = (double)(value >> 11);

	// read output[23]: from bit 488 to 508
	value = ((uint32_t)input[61] << 24) |
			((uint32_t)input[62] << 16) |
			((uint32_t)(input[63] & 0xf8) << 8);
	output[23] = (double)(value >> 11);
}

static void unpack_24_21bit_unsigned_5off(const uint8_t * input, double * output) {
	// Unpack 24 values into output
	// Values are 21-bit unsigned
	// Skip 5 bits, read 504 bits of data.
	// Input must be at least 64 bytes long

	uint32_t value;

	// read output[0]: from bit 5 to 25
	value = ((uint32_t)(input[0] & 0x07) << 29) |
			((uint32_t)input[1] << 21) |
			((uint32_t)input[2] << 13) |
			((uint32_t)(input[3] & 0xc0) << 5);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 26 to 46
	value = ((uint32_t)(input[3] & 0x3f) << 26) |
			((uint32_t)input[4] << 18) |
			((uint32_t)(input[5] & 0xfe) << 10);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 47 to 67
	value = ((uint32_t)(input[5] & 0x01) << 31) |
			((uint32_t)input[6] << 23) |
			((uint32_t)input[7] << 15) |
			((uint32_t)(input[8] & 0xf0) << 7);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 68 to 88
	value = ((uint32_t)(input[8] & 0x0f) << 28) |
			((uint32_t)input[9] << 20) |
			((uint32_t)input[10] << 12) |
			((uint32_t)(input[11] & 0x80) << 4);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 89 to 109
	value = ((uint32_t)(input[11] & 0x7f) << 25) |
			((uint32_t)input[12] << 17) |
			((uint32_t)(input[13] & 0xfc) << 9);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 110 to 130
	value = ((uint32_t)(input[13] & 0x03) << 30) |
			((uint32_t)input[14] << 22) |
			((uint32_t)input[15] << 14) |
			((uint32_t)(input[16] & 0xe0) << 6);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 131 to 151
	value = ((uint32_t)(input[16] & 0x1f) << 27) |
			((uint32_t)input[17] << 19) |
			((uint32_t)input[18] << 11);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 152 to 172
	value = ((uint32_t)input[19] << 24) |
			((uint32_t)input[20] << 16) |
			((uint32_t)(input[21] & 0xf8) << 8);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 173 to 193
	value = ((uint32_t)(input[21] & 0x07) << 29) |
			((uint32_t)input[22] << 21) |
			((uint32_t)input[23] << 13) |
			((uint32_t)(input[24] & 0xc0) << 5);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 194 to 214
	value = ((uint32_t)(input[24] & 0x3f) << 26) |
			((uint32_t)input[25] << 18) |
			((uint32_t)(input[26] & 0xfe) << 10);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 215 to 235
	value = ((uint32_t)(input[26] & 0x01) << 31) |
			((uint32_t)input[27] << 23) |
			((uint32_t)input[28] << 15) |
			((uint32_t)(input[29] & 0xf0) << 7);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 236 to 256
	value = ((uint32_t)(input[29] & 0x0f) << 28) |
			((uint32_t)input[30] << 20) |
			((uint32_t)input[31] << 12) |
			((uint32_t)(input[32] & 0x80) << 4);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 257 to 277
	value = ((uint32_t)(input[32] & 0x7f) << 25) |
			((uint32_t)input[33] << 17) |
			((uint32_t)(input[34] & 0xfc) << 9);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 278 to 298
	value = ((uint32_t)(input[34] & 0x03) << 30) |
			((uint32_t)input[35] << 22) |
			((uint32_t)input[36] << 14) |
			((uint32_t)(input[37] & 0xe0) << 6);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 299 to 319
	value = ((uint32_t)(input[37] & 0x1f) << 27) |
			((uint32_t)input[38] << 19) |
			((uint32_t)input[39] << 11);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 320 to 340
	value = ((uint32_t)input[40] << 24) |
			((uint32_t)input[41] << 16) |
			((uint32_t)(input[42] & 0xf8) << 8);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 341 to 361
	value = ((uint32_t)(input[42] & 0x07) << 29) |
			((uint32_t)input[43] << 21) |
			((uint32_t)input[44] << 13) |
			((uint32_t)(input[45] & 0xc0) << 5);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 362 to 382
	value = ((uint32_t)(input[45] & 0x3f) << 26) |
			((uint32_t)input[46] << 18) |
			((uint32_t)(input[47] & 0xfe) << 10);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 383 to 403
	value = ((uint32_t)(input[47] & 0x01) << 31) |
			((uint32_t)input[48] << 23) |
			((uint32_t)input[49] << 15) |
			((uint32_t)(input[50] & 0xf0) << 7);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 404 to 424
	value = ((uint32_t)(input[50] & 0x0f) << 28) |
			((uint32_t)input[51] << 20) |
			((uint32_t)input[52] << 12) |
			((uint32_t)(input[53] & 0x80) << 4);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 425 to 445
	value = ((uint32_t)(input[53] & 0x7f) << 25) |
			((uint32_t)input[54] << 17) |
			((uint32_t)(input[55] & 0xfc) << 9);
	output[20] = (double)(value >> 11);

	// read output[21]: from bit 446 to 466
	value = ((uint32_t)(input[55] & 0x03) << 30) |
			((uint32_t)input[56] << 22) |
			((uint32_t)input[57] << 14) |
			((uint32_t)(input[58] & 0xe0) << 6);
	output[21] = (double)(value >> 11);

	// read output[22]: from bit 467 to 487
	value = ((uint32_t)(input[58] & 0x1f) << 27) |
			((uint32_t)input[59] << 19) |
			((uint32_t)input[60] << 11);
	output[22] = (double)(value >> 11);

	// read output[23]: from bit 488 to 508
	value = ((uint32_t)input[61] << 24) |
			((uint32_t)input[62] << 16) |
			((uint32_t)(input[63] & 0xf8) << 8);
	output[23] = (double)(value >> 11);
}

static void unpack_24_21bit_signed_6off(const uint8_t * input, double * output) {
	// Unpack 24 values into output
	// Values are 21-bit signed
	// Skip 6 bits, read 504 bits of data.
	// Input must be at least 64 bytes long

	int32_t value;

	// read output[0]: from bit 6 to 26
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xe0) << 6);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 27 to 47
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 48 to 68
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)(input[8] & 0xf8) << 8);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 69 to 89
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)input[10] << 13) |
			((uint32_t)(input[11] & 0xc0) << 5);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 90 to 110
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xfe) << 10);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 111 to 131
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)input[15] << 15) |
			((uint32_t)(input[16] & 0xf0) << 7);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 132 to 152
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)input[18] << 12) |
			((uint32_t)(input[19] & 0x80) << 4);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 153 to 173
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xfc) << 9);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 174 to 194
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xe0) << 6);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 195 to 215
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 216 to 236
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)(input[29] & 0xf8) << 8);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 237 to 257
	value = ((uint32_t)(input[29] & 0x07) << 29) |
			((uint32_t)input[30] << 21) |
			((uint32_t)input[31] << 13) |
			((uint32_t)(input[32] & 0xc0) << 5);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 258 to 278
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xfe) << 10);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 279 to 299
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)input[36] << 15) |
			((uint32_t)(input[37] & 0xf0) << 7);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 300 to 320
	value = ((uint32_t)(input[37] & 0x0f) << 28) |
			((uint32_t)input[38] << 20) |
			((uint32_t)input[39] << 12) |
			((uint32_t)(input[40] & 0x80) << 4);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 321 to 341
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0xfc) << 9);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 342 to 362
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xe0) << 6);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 363 to 383
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 384 to 404
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)(input[50] & 0xf8) << 8);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 405 to 425
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)input[52] << 13) |
			((uint32_t)(input[53] & 0xc0) << 5);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 426 to 446
	value = ((uint32_t)(input[53] & 0x3f) << 26) |
			((uint32_t)input[54] << 18) |
			((uint32_t)(input[55] & 0xfe) << 10);
	output[20] = (double)(value >> 11);

	// read output[21]: from bit 447 to 467
	value = ((uint32_t)(input[55] & 0x01) << 31) |
			((uint32_t)input[56] << 23) |
			((uint32_t)input[57] << 15) |
			((uint32_t)(input[58] & 0xf0) << 7);
	output[21] = (double)(value >> 11);

	// read output[22]: from bit 468 to 488
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)input[60] << 12) |
			((uint32_t)(input[61] & 0x80) << 4);
	output[22] = (double)(value >> 11);

	// read output[23]: from bit 489 to 509
	value = ((uint32_t)(input[61] & 0x7f) << 25) |
			((uint32_t)input[62] << 17) |
			((uint32_t)(input[63] & 0xfc) << 9);
	output[23] = (double)(value >> 11);
}

static void unpack_24_21bit_unsigned_6off(const uint8_t * input, double * output) {
	// Unpack 24 values into output
	// Values are 21-bit unsigned
	// Skip 6 bits, read 504 bits of data.
	// Input must be at least 64 bytes long

	uint32_t value;

	// read output[0]: from bit 6 to 26
	value = ((uint32_t)(input[0] & 0x03) << 30) |
			((uint32_t)input[1] << 22) |
			((uint32_t)input[2] << 14) |
			((uint32_t)(input[3] & 0xe0) << 6);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 27 to 47
	value = ((uint32_t)(input[3] & 0x1f) << 27) |
			((uint32_t)input[4] << 19) |
			((uint32_t)input[5] << 11);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 48 to 68
	value = ((uint32_t)input[6] << 24) |
			((uint32_t)input[7] << 16) |
			((uint32_t)(input[8] & 0xf8) << 8);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 69 to 89
	value = ((uint32_t)(input[8] & 0x07) << 29) |
			((uint32_t)input[9] << 21) |
			((uint32_t)input[10] << 13) |
			((uint32_t)(input[11] & 0xc0) << 5);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 90 to 110
	value = ((uint32_t)(input[11] & 0x3f) << 26) |
			((uint32_t)input[12] << 18) |
			((uint32_t)(input[13] & 0xfe) << 10);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 111 to 131
	value = ((uint32_t)(input[13] & 0x01) << 31) |
			((uint32_t)input[14] << 23) |
			((uint32_t)input[15] << 15) |
			((uint32_t)(input[16] & 0xf0) << 7);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 132 to 152
	value = ((uint32_t)(input[16] & 0x0f) << 28) |
			((uint32_t)input[17] << 20) |
			((uint32_t)input[18] << 12) |
			((uint32_t)(input[19] & 0x80) << 4);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 153 to 173
	value = ((uint32_t)(input[19] & 0x7f) << 25) |
			((uint32_t)input[20] << 17) |
			((uint32_t)(input[21] & 0xfc) << 9);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 174 to 194
	value = ((uint32_t)(input[21] & 0x03) << 30) |
			((uint32_t)input[22] << 22) |
			((uint32_t)input[23] << 14) |
			((uint32_t)(input[24] & 0xe0) << 6);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 195 to 215
	value = ((uint32_t)(input[24] & 0x1f) << 27) |
			((uint32_t)input[25] << 19) |
			((uint32_t)input[26] << 11);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 216 to 236
	value = ((uint32_t)input[27] << 24) |
			((uint32_t)input[28] << 16) |
			((uint32_t)(input[29] & 0xf8) << 8);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 237 to 257
	value = ((uint32_t)(input[29] & 0x07) << 29) |
			((uint32_t)input[30] << 21) |
			((uint32_t)input[31] << 13) |
			((uint32_t)(input[32] & 0xc0) << 5);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 258 to 278
	value = ((uint32_t)(input[32] & 0x3f) << 26) |
			((uint32_t)input[33] << 18) |
			((uint32_t)(input[34] & 0xfe) << 10);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 279 to 299
	value = ((uint32_t)(input[34] & 0x01) << 31) |
			((uint32_t)input[35] << 23) |
			((uint32_t)input[36] << 15) |
			((uint32_t)(input[37] & 0xf0) << 7);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 300 to 320
	value = ((uint32_t)(input[37] & 0x0f) << 28) |
			((uint32_t)input[38] << 20) |
			((uint32_t)input[39] << 12) |
			((uint32_t)(input[40] & 0x80) << 4);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 321 to 341
	value = ((uint32_t)(input[40] & 0x7f) << 25) |
			((uint32_t)input[41] << 17) |
			((uint32_t)(input[42] & 0xfc) << 9);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 342 to 362
	value = ((uint32_t)(input[42] & 0x03) << 30) |
			((uint32_t)input[43] << 22) |
			((uint32_t)input[44] << 14) |
			((uint32_t)(input[45] & 0xe0) << 6);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 363 to 383
	value = ((uint32_t)(input[45] & 0x1f) << 27) |
			((uint32_t)input[46] << 19) |
			((uint32_t)input[47] << 11);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 384 to 404
	value = ((uint32_t)input[48] << 24) |
			((uint32_t)input[49] << 16) |
			((uint32_t)(input[50] & 0xf8) << 8);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 405 to 425
	value = ((uint32_t)(input[50] & 0x07) << 29) |
			((uint32_t)input[51] << 21) |
			((uint32_t)input[52] << 13) |
			((uint32_t)(input[53] & 0xc0) << 5);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 426 to 446
	value = ((uint32_t)(input[53] & 0x3f) << 26) |
			((uint32_t)input[54] << 18) |
			((uint32_t)(input[55] & 0xfe) << 10);
	output[20] = (double)(value >> 11);

	// read output[21]: from bit 447 to 467
	value = ((uint32_t)(input[55] & 0x01) << 31) |
			((uint32_t)input[56] << 23) |
			((uint32_t)input[57] << 15) |
			((uint32_t)(input[58] & 0xf0) << 7);
	output[21] = (double)(value >> 11);

	// read output[22]: from bit 468 to 488
	value = ((uint32_t)(input[58] & 0x0f) << 28) |
			((uint32_t)input[59] << 20) |
			((uint32_t)input[60] << 12) |
			((uint32_t)(input[61] & 0x80) << 4);
	output[22] = (double)(value >> 11);

	// read output[23]: from bit 489 to 509
	value = ((uint32_t)(input[61] & 0x7f) << 25) |
			((uint32_t)input[62] << 17) |
			((uint32_t)(input[63] & 0xfc) << 9);
	output[23] = (double)(value >> 11);
}

static void unpack_24_21bit_signed_7off(const uint8_t * input, double * output) {
	// Unpack 24 values into output
	// Values are 21-bit signed
	// Skip 7 bits, read 504 bits of data.
	// Input must be at least 64 bytes long

	int32_t value;

	// read output[0]: from bit 7 to 27
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xf0) << 7);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 28 to 48
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0x80) << 4);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 49 to 69
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0xfc) << 9);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 70 to 90
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)input[10] << 14) |
			((uint32_t)(input[11] & 0xe0) << 6);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 91 to 111
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)input[13] << 11);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 112 to 132
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16) |
			((uint32_t)(input[16] & 0xf8) << 8);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 133 to 153
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)input[18] << 13) |
			((uint32_t)(input[19] & 0xc0) << 5);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 154 to 174
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xfe) << 10);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 175 to 195
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xf0) << 7);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 196 to 216
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0x80) << 4);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 217 to 237
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)(input[29] & 0xfc) << 9);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 238 to 258
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)input[31] << 14) |
			((uint32_t)(input[32] & 0xe0) << 6);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 259 to 279
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)input[34] << 11);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 280 to 300
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)input[36] << 16) |
			((uint32_t)(input[37] & 0xf8) << 8);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 301 to 321
	value = ((uint32_t)(input[37] & 0x07) << 29) |
			((uint32_t)input[38] << 21) |
			((uint32_t)input[39] << 13) |
			((uint32_t)(input[40] & 0xc0) << 5);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 322 to 342
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xfe) << 10);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 343 to 363
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xf0) << 7);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 364 to 384
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0x80) << 4);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 385 to 405
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0xfc) << 9);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 406 to 426
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)input[52] << 14) |
			((uint32_t)(input[53] & 0xe0) << 6);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 427 to 447
	value = ((uint32_t)(input[53] & 0x1f) << 27) |
			((uint32_t)input[54] << 19) |
			((uint32_t)input[55] << 11);
	output[20] = (double)(value >> 11);

	// read output[21]: from bit 448 to 468
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16) |
			((uint32_t)(input[58] & 0xf8) << 8);
	output[21] = (double)(value >> 11);

	// read output[22]: from bit 469 to 489
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)input[60] << 13) |
			((uint32_t)(input[61] & 0xc0) << 5);
	output[22] = (double)(value >> 11);

	// read output[23]: from bit 490 to 510
	value = ((uint32_t)(input[61] & 0x3f) << 26) |
			((uint32_t)input[62] << 18) |
			((uint32_t)(input[63] & 0xfe) << 10);
	output[23] = (double)(value >> 11);
}

static void unpack_24_21bit_unsigned_7off(const uint8_t * input, double * output) {
	// Unpack 24 values into output
	// Values are 21-bit unsigned
	// Skip 7 bits, read 504 bits of data.
	// Input must be at least 64 bytes long

	uint32_t value;

	// read output[0]: from bit 7 to 27
	value = ((uint32_t)(input[0] & 0x01) << 31) |
			((uint32_t)input[1] << 23) |
			((uint32_t)input[2] << 15) |
			((uint32_t)(input[3] & 0xf0) << 7);
	output[0] = (double)(value >> 11);

	// read output[1]: from bit 28 to 48
	value = ((uint32_t)(input[3] & 0x0f) << 28) |
			((uint32_t)input[4] << 20) |
			((uint32_t)input[5] << 12) |
			((uint32_t)(input[6] & 0x80) << 4);
	output[1] = (double)(value >> 11);

	// read output[2]: from bit 49 to 69
	value = ((uint32_t)(input[6] & 0x7f) << 25) |
			((uint32_t)input[7] << 17) |
			((uint32_t)(input[8] & 0xfc) << 9);
	output[2] = (double)(value >> 11);

	// read output[3]: from bit 70 to 90
	value = ((uint32_t)(input[8] & 0x03) << 30) |
			((uint32_t)input[9] << 22) |
			((uint32_t)input[10] << 14) |
			((uint32_t)(input[11] & 0xe0) << 6);
	output[3] = (double)(value >> 11);

	// read output[4]: from bit 91 to 111
	value = ((uint32_t)(input[11] & 0x1f) << 27) |
			((uint32_t)input[12] << 19) |
			((uint32_t)input[13] << 11);
	output[4] = (double)(value >> 11);

	// read output[5]: from bit 112 to 132
	value = ((uint32_t)input[14] << 24) |
			((uint32_t)input[15] << 16) |
			((uint32_t)(input[16] & 0xf8) << 8);
	output[5] = (double)(value >> 11);

	// read output[6]: from bit 133 to 153
	value = ((uint32_t)(input[16] & 0x07) << 29) |
			((uint32_t)input[17] << 21) |
			((uint32_t)input[18] << 13) |
			((uint32_t)(input[19] & 0xc0) << 5);
	output[6] = (double)(value >> 11);

	// read output[7]: from bit 154 to 174
	value = ((uint32_t)(input[19] & 0x3f) << 26) |
			((uint32_t)input[20] << 18) |
			((uint32_t)(input[21] & 0xfe) << 10);
	output[7] = (double)(value >> 11);

	// read output[8]: from bit 175 to 195
	value = ((uint32_t)(input[21] & 0x01) << 31) |
			((uint32_t)input[22] << 23) |
			((uint32_t)input[23] << 15) |
			((uint32_t)(input[24] & 0xf0) << 7);
	output[8] = (double)(value >> 11);

	// read output[9]: from bit 196 to 216
	value = ((uint32_t)(input[24] & 0x0f) << 28) |
			((uint32_t)input[25] << 20) |
			((uint32_t)input[26] << 12) |
			((uint32_t)(input[27] & 0x80) << 4);
	output[9] = (double)(value >> 11);

	// read output[10]: from bit 217 to 237
	value = ((uint32_t)(input[27] & 0x7f) << 25) |
			((uint32_t)input[28] << 17) |
			((uint32_t)(input[29] & 0xfc) << 9);
	output[10] = (double)(value >> 11);

	// read output[11]: from bit 238 to 258
	value = ((uint32_t)(input[29] & 0x03) << 30) |
			((uint32_t)input[30] << 22) |
			((uint32_t)input[31] << 14) |
			((uint32_t)(input[32] & 0xe0) << 6);
	output[11] = (double)(value >> 11);

	// read output[12]: from bit 259 to 279
	value = ((uint32_t)(input[32] & 0x1f) << 27) |
			((uint32_t)input[33] << 19) |
			((uint32_t)input[34] << 11);
	output[12] = (double)(value >> 11);

	// read output[13]: from bit 280 to 300
	value = ((uint32_t)input[35] << 24) |
			((uint32_t)input[36] << 16) |
			((uint32_t)(input[37] & 0xf8) << 8);
	output[13] = (double)(value >> 11);

	// read output[14]: from bit 301 to 321
	value = ((uint32_t)(input[37] & 0x07) << 29) |
			((uint32_t)input[38] << 21) |
			((uint32_t)input[39] << 13) |
			((uint32_t)(input[40] & 0xc0) << 5);
	output[14] = (double)(value >> 11);

	// read output[15]: from bit 322 to 342
	value = ((uint32_t)(input[40] & 0x3f) << 26) |
			((uint32_t)input[41] << 18) |
			((uint32_t)(input[42] & 0xfe) << 10);
	output[15] = (double)(value >> 11);

	// read output[16]: from bit 343 to 363
	value = ((uint32_t)(input[42] & 0x01) << 31) |
			((uint32_t)input[43] << 23) |
			((uint32_t)input[44] << 15) |
			((uint32_t)(input[45] & 0xf0) << 7);
	output[16] = (double)(value >> 11);

	// read output[17]: from bit 364 to 384
	value = ((uint32_t)(input[45] & 0x0f) << 28) |
			((uint32_t)input[46] << 20) |
			((uint32_t)input[47] << 12) |
			((uint32_t)(input[48] & 0x80) << 4);
	output[17] = (double)(value >> 11);

	// read output[18]: from bit 385 to 405
	value = ((uint32_t)(input[48] & 0x7f) << 25) |
			((uint32_t)input[49] << 17) |
			((uint32_t)(input[50] & 0xfc) << 9);
	output[18] = (double)(value >> 11);

	// read output[19]: from bit 406 to 426
	value = ((uint32_t)(input[50] & 0x03) << 30) |
			((uint32_t)input[51] << 22) |
			((uint32_t)input[52] << 14) |
			((uint32_t)(input[53] & 0xe0) << 6);
	output[19] = (double)(value >> 11);

	// read output[20]: from bit 427 to 447
	value = ((uint32_t)(input[53] & 0x1f) << 27) |
			((uint32_t)input[54] << 19) |
			((uint32_t)input[55] << 11);
	output[20] = (double)(value >> 11);

	// read output[21]: from bit 448 to 468
	value = ((uint32_t)input[56] << 24) |
			((uint32_t)input[57] << 16) |
			((uint32_t)(input[58] & 0xf8) << 8);
	output[21] = (double)(value >> 11);

	// read output[22]: from bit 469 to 489
	value = ((uint32_t)(input[58] & 0x07) << 29) |
			((uint32_t)input[59] << 21) |
			((uint32_t)input[60] << 13) |
			((uint32_t)(input[61] & 0xc0) << 5);
	output[22] = (double)(value >> 11);

	// read output[23]: from bit 490 to 510
	value = ((uint32_t)(input[61] & 0x3f) << 26) |
			((uint32_t)input[62] << 18) |
			((uint32_t)(input[63] & 0xfe) << 10);
	output[23] = (double)(value >> 11);
}


unpack_func_t unpack_21bit[UNPACK_21BIT_MAX_COUNT][8][2] = {
	{
		{
			unpack_1_21bit_unsigned_0off,
			unpack_1_21bit_signed_0off,
		},
		{
			unpack_1_21bit_unsigned_1off,
			unpack_1_21bit_signed_1off,
		},
		{
			unpack_1_21bit_unsigned_2off,
			unpack_1_21bit_signed_2off,
		},
		{
			unpack_1_21bit_unsigned_3off,
			unpack_1_21bit_signed_3off,
		},
		{
			unpack_1_21bit_unsigned_4off,
			unpack_1_21bit_signed_4off,
		},
		{
			unpack_1_21bit_unsigned_5off,
			unpack_1_21bit_signed_5off,
		},
		{
			unpack_1_21bit_unsigned_6off,
			unpack_1_21bit_signed_6off,
		},
		{
			unpack_1_21bit_unsigned_7off,
			unpack_1_21bit_signed_7off,
		},
	},
	{
		{
			unpack_2_21bit_unsigned_0off,
			unpack_2_21bit_signed_0off,
		},
		{
			unpack_2_21bit_unsigned_1off,
			unpack_2_21bit_signed_1off,
		},
		{
			unpack_2_21bit_unsigned_2off,
			unpack_2_21bit_signed_2off,
		},
		{
			unpack_2_21bit_unsigned_3off,
			unpack_2_21bit_signed_3off,
		},
		{
			unpack_2_21bit_unsigned_4off,
			unpack_2_21bit_signed_4off,
		},
		{
			unpack_2_21bit_unsigned_5off,
			unpack_2_21bit_signed_5off,
		},
		{
			unpack_2_21bit_unsigned_6off,
			unpack_2_21bit_signed_6off,
		},
		{
			unpack_2_21bit_unsigned_7off,
			unpack_2_21bit_signed_7off,
		},
	},
	{
		{
			unpack_3_21bit_unsigned_0off,
			unpack_3_21bit_signed_0off,
		},
		{
			unpack_3_21bit_unsigned_1off,
			unpack_3_21bit_signed_1off,
		},
		{
			unpack_3_21bit_unsigned_2off,
			unpack_3_21bit_signed_2off,
		},
		{
			unpack_3_21bit_unsigned_3off,
			unpack_3_21bit_signed_3off,
		},
		{
			unpack_3_21bit_unsigned_4off,
			unpack_3_21bit_signed_4off,
		},
		{
			unpack_3_21bit_unsigned_5off,
			unpack_3_21bit_signed_5off,
		},
		{
			unpack_3_21bit_unsigned_6off,
			unpack_3_21bit_signed_6off,
		},
		{
			unpack_3_21bit_unsigned_7off,
			unpack_3_21bit_signed_7off,
		},
	},
	{
		{
			unpack_4_21bit_unsigned_0off,
			unpack_4_21bit_signed_0off,
		},
		{
			unpack_4_21bit_unsigned_1off,
			unpack_4_21bit_signed_1off,
		},
		{
			unpack_4_21bit_unsigned_2off,
			unpack_4_21bit_signed_2off,
		},
		{
			unpack_4_21bit_unsigned_3off,
			unpack_4_21bit_signed_3off,
		},
		{
			unpack_4_21bit_unsigned_4off,
			unpack_4_21bit_signed_4off,
		},
		{
			unpack_4_21bit_unsigned_5off,
			unpack_4_21bit_signed_5off,
		},
		{
			unpack_4_21bit_unsigned_6off,
			unpack_4_21bit_signed_6off,
		},
		{
			unpack_4_21bit_unsigned_7off,
			unpack_4_21bit_signed_7off,
		},
	},
	{
		{
			unpack_5_21bit_unsigned_0off,
			unpack_5_21bit_signed_0off,
		},
		{
			unpack_5_21bit_unsigned_1off,
			unpack_5_21bit_signed_1off,
		},
		{
			unpack_5_21bit_unsigned_2off,
			unpack_5_21bit_signed_2off,
		},
		{
			unpack_5_21bit_unsigned_3off,
			unpack_5_21bit_signed_3off,
		},
		{
			unpack_5_21bit_unsigned_4off,
			unpack_5_21bit_signed_4off,
		},
		{
			unpack_5_21bit_unsigned_5off,
			unpack_5_21bit_signed_5off,
		},
		{
			unpack_5_21bit_unsigned_6off,
			unpack_5_21bit_signed_6off,
		},
		{
			unpack_5_21bit_unsigned_7off,
			unpack_5_21bit_signed_7off,
		},
	},
	{
		{
			unpack_6_21bit_unsigned_0off,
			unpack_6_21bit_signed_0off,
		},
		{
			unpack_6_21bit_unsigned_1off,
			unpack_6_21bit_signed_1off,
		},
		{
			unpack_6_21bit_unsigned_2off,
			unpack_6_21bit_signed_2off,
		},
		{
			unpack_6_21bit_unsigned_3off,
			unpack_6_21bit_signed_3off,
		},
		{
			unpack_6_21bit_unsigned_4off,
			unpack_6_21bit_signed_4off,
		},
		{
			unpack_6_21bit_unsigned_5off,
			unpack_6_21bit_signed_5off,
		},
		{
			unpack_6_21bit_unsigned_6off,
			unpack_6_21bit_signed_6off,
		},
		{
			unpack_6_21bit_unsigned_7off,
			unpack_6_21bit_signed_7off,
		},
	},
	{
		{
			unpack_7_21bit_unsigned_0off,
			unpack_7_21bit_signed_0off,
		},
		{
			unpack_7_21bit_unsigned_1off,
			unpack_7_21bit_signed_1off,
		},
		{
			unpack_7_21bit_unsigned_2off,
			unpack_7_21bit_signed_2off,
		},
		{
			unpack_7_21bit_unsigned_3off,
			unpack_7_21bit_signed_3off,
		},
		{
			unpack_7_21bit_unsigned_4off,
			unpack_7_21bit_signed_4off,
		},
		{
			unpack_7_21bit_unsigned_5off,
			unpack_7_21bit_signed_5off,
		},
		{
			unpack_7_21bit_unsigned_6off,
			unpack_7_21bit_signed_6off,
		},
		{
			unpack_7_21bit_unsigned_7off,
			unpack_7_21bit_signed_7off,
		},
	},
	{
		{
			unpack_8_21bit_unsigned_0off,
			unpack_8_21bit_signed_0off,
		},
		{
			unpack_8_21bit_unsigned_1off,
			unpack_8_21bit_signed_1off,
		},
		{
			unpack_8_21bit_unsigned_2off,
			unpack_8_21bit_signed_2off,
		},
		{
			unpack_8_21bit_unsigned_3off,
			unpack_8_21bit_signed_3off,
		},
		{
			unpack_8_21bit_unsigned_4off,
			unpack_8_21bit_signed_4off,
		},
		{
			unpack_8_21bit_unsigned_5off,
			unpack_8_21bit_signed_5off,
		},
		{
			unpack_8_21bit_unsigned_6off,
			unpack_8_21bit_signed_6off,
		},
		{
			unpack_8_21bit_unsigned_7off,
			unpack_8_21bit_signed_7off,
		},
	},
	{
		{
			unpack_9_21bit_unsigned_0off,
			unpack_9_21bit_signed_0off,
		},
		{
			unpack_9_21bit_unsigned_1off,
			unpack_9_21bit_signed_1off,
		},
		{
			unpack_9_21bit_unsigned_2off,
			unpack_9_21bit_signed_2off,
		},
		{
			unpack_9_21bit_unsigned_3off,
			unpack_9_21bit_signed_3off,
		},
		{
			unpack_9_21bit_unsigned_4off,
			unpack_9_21bit_signed_4off,
		},
		{
			unpack_9_21bit_unsigned_5off,
			unpack_9_21bit_signed_5off,
		},
		{
			unpack_9_21bit_unsigned_6off,
			unpack_9_21bit_signed_6off,
		},
		{
			unpack_9_21bit_unsigned_7off,
			unpack_9_21bit_signed_7off,
		},
	},
	{
		{
			unpack_10_21bit_unsigned_0off,
			unpack_10_21bit_signed_0off,
		},
		{
			unpack_10_21bit_unsigned_1off,
			unpack_10_21bit_signed_1off,
		},
		{
			unpack_10_21bit_unsigned_2off,
			unpack_10_21bit_signed_2off,
		},
		{
			unpack_10_21bit_unsigned_3off,
			unpack_10_21bit_signed_3off,
		},
		{
			unpack_10_21bit_unsigned_4off,
			unpack_10_21bit_signed_4off,
		},
		{
			unpack_10_21bit_unsigned_5off,
			unpack_10_21bit_signed_5off,
		},
		{
			unpack_10_21bit_unsigned_6off,
			unpack_10_21bit_signed_6off,
		},
		{
			unpack_10_21bit_unsigned_7off,
			unpack_10_21bit_signed_7off,
		},
	},
	{
		{
			unpack_11_21bit_unsigned_0off,
			unpack_11_21bit_signed_0off,
		},
		{
			unpack_11_21bit_unsigned_1off,
			unpack_11_21bit_signed_1off,
		},
		{
			unpack_11_21bit_unsigned_2off,
			unpack_11_21bit_signed_2off,
		},
		{
			unpack_11_21bit_unsigned_3off,
			unpack_11_21bit_signed_3off,
		},
		{
			unpack_11_21bit_unsigned_4off,
			unpack_11_21bit_signed_4off,
		},
		{
			unpack_11_21bit_unsigned_5off,
			unpack_11_21bit_signed_5off,
		},
		{
			unpack_11_21bit_unsigned_6off,
			unpack_11_21bit_signed_6off,
		},
		{
			unpack_11_21bit_unsigned_7off,
			unpack_11_21bit_signed_7off,
		},
	},
	{
		{
			unpack_12_21bit_unsigned_0off,
			unpack_12_21bit_signed_0off,
		},
		{
			unpack_12_21bit_unsigned_1off,
			unpack_12_21bit_signed_1off,
		},
		{
			unpack_12_21bit_unsigned_2off,
			unpack_12_21bit_signed_2off,
		},
		{
			unpack_12_21bit_unsigned_3off,
			unpack_12_21bit_signed_3off,
		},
		{
			unpack_12_21bit_unsigned_4off,
			unpack_12_21bit_signed_4off,
		},
		{
			unpack_12_21bit_unsigned_5off,
			unpack_12_21bit_signed_5off,
		},
		{
			unpack_12_21bit_unsigned_6off,
			unpack_12_21bit_signed_6off,
		},
		{
			unpack_12_21bit_unsigned_7off,
			unpack_12_21bit_signed_7off,
		},
	},
	{
		{
			unpack_13_21bit_unsigned_0off,
			unpack_13_21bit_signed_0off,
		},
		{
			unpack_13_21bit_unsigned_1off,
			unpack_13_21bit_signed_1off,
		},
		{
			unpack_13_21bit_unsigned_2off,
			unpack_13_21bit_signed_2off,
		},
		{
			unpack_13_21bit_unsigned_3off,
			unpack_13_21bit_signed_3off,
		},
		{
			unpack_13_21bit_unsigned_4off,
			unpack_13_21bit_signed_4off,
		},
		{
			unpack_13_21bit_unsigned_5off,
			unpack_13_21bit_signed_5off,
		},
		{
			unpack_13_21bit_unsigned_6off,
			unpack_13_21bit_signed_6off,
		},
		{
			unpack_13_21bit_unsigned_7off,
			unpack_13_21bit_signed_7off,
		},
	},
	{
		{
			unpack_14_21bit_unsigned_0off,
			unpack_14_21bit_signed_0off,
		},
		{
			unpack_14_21bit_unsigned_1off,
			unpack_14_21bit_signed_1off,
		},
		{
			unpack_14_21bit_unsigned_2off,
			unpack_14_21bit_signed_2off,
		},
		{
			unpack_14_21bit_unsigned_3off,
			unpack_14_21bit_signed_3off,
		},
		{
			unpack_14_21bit_unsigned_4off,
			unpack_14_21bit_signed_4off,
		},
		{
			unpack_14_21bit_unsigned_5off,
			unpack_14_21bit_signed_5off,
		},
		{
			unpack_14_21bit_unsigned_6off,
			unpack_14_21bit_signed_6off,
		},
		{
			unpack_14_21bit_unsigned_7off,
			unpack_14_21bit_signed_7off,
		},
	},
	{
		{
			unpack_15_21bit_unsigned_0off,
			unpack_15_21bit_signed_0off,
		},
		{
			unpack_15_21bit_unsigned_1off,
			unpack_15_21bit_signed_1off,
		},
		{
			unpack_15_21bit_unsigned_2off,
			unpack_15_21bit_signed_2off,
		},
		{
			unpack_15_21bit_unsigned_3off,
			unpack_15_21bit_signed_3off,
		},
		{
			unpack_15_21bit_unsigned_4off,
			unpack_15_21bit_signed_4off,
		},
		{
			unpack_15_21bit_unsigned_5off,
			unpack_15_21bit_signed_5off,
		},
		{
			unpack_15_21bit_unsigned_6off,
			unpack_15_21bit_signed_6off,
		},
		{
			unpack_15_21bit_unsigned_7off,
			unpack_15_21bit_signed_7off,
		},
	},
	{
		{
			unpack_16_21bit_unsigned_0off,
			unpack_16_21bit_signed_0off,
		},
		{
			unpack_16_21bit_unsigned_1off,
			unpack_16_21bit_signed_1off,
		},
		{
			unpack_16_21bit_unsigned_2off,
			unpack_16_21bit_signed_2off,
		},
		{
			unpack_16_21bit_unsigned_3off,
			unpack_16_21bit_signed_3off,
		},
		{
			unpack_16_21bit_unsigned_4off,
			unpack_16_21bit_signed_4off,
		},
		{
			unpack_16_21bit_unsigned_5off,
			unpack_16_21bit_signed_5off,
		},
		{
			unpack_16_21bit_unsigned_6off,
			unpack_16_21bit_signed_6off,
		},
		{
			unpack_16_21bit_unsigned_7off,
			unpack_16_21bit_signed_7off,
		},
	},
	{
		{
			unpack_17_21bit_unsigned_0off,
			unpack_17_21bit_signed_0off,
		},
		{
			unpack_17_21bit_unsigned_1off,
			unpack_17_21bit_signed_1off,
		},
		{
			unpack_17_21bit_unsigned_2off,
			unpack_17_21bit_signed_2off,
		},
		{
			unpack_17_21bit_unsigned_3off,
			unpack_17_21bit_signed_3off,
		},
		{
			unpack_17_21bit_unsigned_4off,
			unpack_17_21bit_signed_4off,
		},
		{
			unpack_17_21bit_unsigned_5off,
			unpack_17_21bit_signed_5off,
		},
		{
			unpack_17_21bit_unsigned_6off,
			unpack_17_21bit_signed_6off,
		},
		{
			unpack_17_21bit_unsigned_7off,
			unpack_17_21bit_signed_7off,
		},
	},
	{
		{
			unpack_18_21bit_unsigned_0off,
			unpack_18_21bit_signed_0off,
		},
		{
			unpack_18_21bit_unsigned_1off,
			unpack_18_21bit_signed_1off,
		},
		{
			unpack_18_21bit_unsigned_2off,
			unpack_18_21bit_signed_2off,
		},
		{
			unpack_18_21bit_unsigned_3off,
			unpack_18_21bit_signed_3off,
		},
		{
			unpack_18_21bit_unsigned_4off,
			unpack_18_21bit_signed_4off,
		},
		{
			unpack_18_21bit_unsigned_5off,
			unpack_18_21bit_signed_5off,
		},
		{
			unpack_18_21bit_unsigned_6off,
			unpack_18_21bit_signed_6off,
		},
		{
			unpack_18_21bit_unsigned_7off,
			unpack_18_21bit_signed_7off,
		},
	},
	{
		{
			unpack_19_21bit_unsigned_0off,
			unpack_19_21bit_signed_0off,
		},
		{
			unpack_19_21bit_unsigned_1off,
			unpack_19_21bit_signed_1off,
		},
		{
			unpack_19_21bit_unsigned_2off,
			unpack_19_21bit_signed_2off,
		},
		{
			unpack_19_21bit_unsigned_3off,
			unpack_19_21bit_signed_3off,
		},
		{
			unpack_19_21bit_unsigned_4off,
			unpack_19_21bit_signed_4off,
		},
		{
			unpack_19_21bit_unsigned_5off,
			unpack_19_21bit_signed_5off,
		},
		{
			unpack_19_21bit_unsigned_6off,
			unpack_19_21bit_signed_6off,
		},
		{
			unpack_19_21bit_unsigned_7off,
			unpack_19_21bit_signed_7off,
		},
	},
	{
		{
			unpack_20_21bit_unsigned_0off,
			unpack_20_21bit_signed_0off,
		},
		{
			unpack_20_21bit_unsigned_1off,
			unpack_20_21bit_signed_1off,
		},
		{
			unpack_20_21bit_unsigned_2off,
			unpack_20_21bit_signed_2off,
		},
		{
			unpack_20_21bit_unsigned_3off,
			unpack_20_21bit_signed_3off,
		},
		{
			unpack_20_21bit_unsigned_4off,
			unpack_20_21bit_signed_4off,
		},
		{
			unpack_20_21bit_unsigned_5off,
			unpack_20_21bit_signed_5off,
		},
		{
			unpack_20_21bit_unsigned_6off,
			unpack_20_21bit_signed_6off,
		},
		{
			unpack_20_21bit_unsigned_7off,
			unpack_20_21bit_signed_7off,
		},
	},
	{
		{
			unpack_21_21bit_unsigned_0off,
			unpack_21_21bit_signed_0off,
		},
		{
			unpack_21_21bit_unsigned_1off,
			unpack_21_21bit_signed_1off,
		},
		{
			unpack_21_21bit_unsigned_2off,
			unpack_21_21bit_signed_2off,
		},
		{
			unpack_21_21bit_unsigned_3off,
			unpack_21_21bit_signed_3off,
		},
		{
			unpack_21_21bit_unsigned_4off,
			unpack_21_21bit_signed_4off,
		},
		{
			unpack_21_21bit_unsigned_5off,
			unpack_21_21bit_signed_5off,
		},
		{
			unpack_21_21bit_unsigned_6off,
			unpack_21_21bit_signed_6off,
		},
		{
			unpack_21_21bit_unsigned_7off,
			unpack_21_21bit_signed_7off,
		},
	},
	{
		{
			unpack_22_21bit_unsigned_0off,
			unpack_22_21bit_signed_0off,
		},
		{
			unpack_22_21bit_unsigned_1off,
			unpack_22_21bit_signed_1off,
		},
		{
			unpack_22_21bit_unsigned_2off,
			unpack_22_21bit_signed_2off,
		},
		{
			unpack_22_21bit_unsigned_3off,
			unpack_22_21bit_signed_3off,
		},
		{
			unpack_22_21bit_unsigned_4off,
			unpack_22_21bit_signed_4off,
		},
		{
			unpack_22_21bit_unsigned_5off,
			unpack_22_21bit_signed_5off,
		},
		{
			unpack_22_21bit_unsigned_6off,
			unpack_22_21bit_signed_6off,
		},
		{
			unpack_22_21bit_unsigned_7off,
			unpack_22_21bit_signed_7off,
		},
	},
	{
		{
			unpack_23_21bit_unsigned_0off,
			unpack_23_21bit_signed_0off,
		},
		{
			unpack_23_21bit_unsigned_1off,
			unpack_23_21bit_signed_1off,
		},
		{
			unpack_23_21bit_unsigned_2off,
			unpack_23_21bit_signed_2off,
		},
		{
			unpack_23_21bit_unsigned_3off,
			unpack_23_21bit_signed_3off,
		},
		{
			unpack_23_21bit_unsigned_4off,
			unpack_23_21bit_signed_4off,
		},
		{
			unpack_23_21bit_unsigned_5off,
			unpack_23_21bit_signed_5off,
		},
		{
			unpack_23_21bit_unsigned_6off,
			unpack_23_21bit_signed_6off,
		},
		{
			unpack_23_21bit_unsigned_7off,
			unpack_23_21bit_signed_7off,
		},
	},
	{
		{
			unpack_24_21bit_unsigned_0off,
			unpack_24_21bit_signed_0off,
		},
		{
			unpack_24_21bit_unsigned_1off,
			unpack_24_21bit_signed_1off,
		},
		{
			unpack_24_21bit_unsigned_2off,
			unpack_24_21bit_signed_2off,
		},
		{
			unpack_24_21bit_unsigned_3off,
			unpack_24_21bit_signed_3off,
		},
		{
			unpack_24_21bit_unsigned_4off,
			unpack_24_21bit_signed_4off,
		},
		{
			unpack_24_21bit_unsigned_5off,
			unpack_24_21bit_signed_5off,
		},
		{
			unpack_24_21bit_unsigned_6off,
			unpack_24_21bit_signed_6off,
		},
		{
			unpack_24_21bit_unsigned_7off,
			unpack_24_21bit_signed_7off,
		},
	},
};
